/*/////////////////////////////////////////////////////////////////////////////
//
//     spiral_fft_double.c
//
//     This library was generated by Spiral 6.0, developed at Carnegie Mellon
//     University, http://www.spiral.net. This code is distributed under the
//     GNU general purpose software license version 2.0.
//
//     Commercial licenses and support are available through SpiralGen, Inc.
//     fft@spiralgen.com
//
*/

#include "spiral_fft.h"
#include "spiral_private.h"

/*************************************************
 * Main dispatch  
 *************************************************/

SPIRAL_API(spiral_status_t, spiral_fft_double)(int n, int sign, const double *pSrc, double *pDst ) {
    if (sign<0) {
        switch(n) {
            case 2: return spiral_fftfwd_double_2(pSrc, pDst );
            case 4: return spiral_fftfwd_double_4(pSrc, pDst );
            case 8: return spiral_fftfwd_double_8(pSrc, pDst );
            case 16: return spiral_fftfwd_double_16(pSrc, pDst );
            case 32: return spiral_fftfwd_double_32(pSrc, pDst );
            case 64: return spiral_fftfwd_double_64(pSrc, pDst );
            case 128: return spiral_fftfwd_double_128(pSrc, pDst );
            case 256: return spiral_fftfwd_double_256(pSrc, pDst );
            case 512: return spiral_fftfwd_double_512(pSrc, pDst );
            case 1024: return spiral_fftfwd_double_1024(pSrc, pDst );
            case 2048: return spiral_fftfwd_double_2048(pSrc, pDst );
            case 4096: return spiral_fftfwd_double_4096(pSrc, pDst );
            case 8192: return spiral_fftfwd_double_8192(pSrc, pDst );
            default: return SPIRAL_SIZE_NOT_SUPPORTED;
        }
    } 
    else {
        switch(n) {
            case 2: return spiral_fftinv_double_2(pSrc, pDst );
            case 4: return spiral_fftinv_double_4(pSrc, pDst );
            case 8: return spiral_fftinv_double_8(pSrc, pDst );
            case 16: return spiral_fftinv_double_16(pSrc, pDst );
            case 32: return spiral_fftinv_double_32(pSrc, pDst );
            case 64: return spiral_fftinv_double_64(pSrc, pDst );
            case 128: return spiral_fftinv_double_128(pSrc, pDst );
            case 256: return spiral_fftinv_double_256(pSrc, pDst );
            case 512: return spiral_fftinv_double_512(pSrc, pDst );
            case 1024: return spiral_fftinv_double_1024(pSrc, pDst );
            case 2048: return spiral_fftinv_double_2048(pSrc, pDst );
            case 4096: return spiral_fftinv_double_4096(pSrc, pDst );
            case 8192: return spiral_fftinv_double_8192(pSrc, pDst );
            default: return SPIRAL_SIZE_NOT_SUPPORTED;
        }
    }
}

/*************************************************
 * Individual transform sizes  
 *************************************************/

SPIRAL_API(spiral_status_t, spiral_fftinv_double_2)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    {const double  *a, *a2, *a3;
    a = (src + 2);
    a2 = (src + 1);
    a3 = (src + 3);
    *(dst) = (*(src) + *(a));
    *((dst + 1)) = (*(a2) + *(a3));
    *((dst + 2)) = (*(src) - *(a));
    *((dst + 3)) = (*(a2) - *(a3));
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_double_4)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    {const double  *a, *a2, *a3, *a4, *a5, *a6, *a7;
    double t, t2, t3, t4, t5, t6, t7, t8;
    a = (src + 4);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 5);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 2);
    a5 = (src + 6);
    t5 = (*(a4) + *(a5));
    a6 = (src + 3);
    a7 = (src + 7);
    t6 = (*(a6) + *(a7));
    t7 = (*(a4) - *(a5));
    t8 = (*(a6) - *(a7));
    *(dst) = (t + t5);
    *((dst + 1)) = (t2 + t6);
    *((dst + 4)) = (t - t5);
    *((dst + 5)) = (t2 - t6);
    *((dst + 2)) = (t3 - t8);
    *((dst + 3)) = (t4 + t7);
    *((dst + 6)) = (t3 + t8);
    *((dst + 7)) = (t4 - t7);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_double_8)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    {const double  *a, *a01, *a11, *a2, *a21, *a3, *a31, *a4, *a41, *a5, *a51, *a6, *a7, *a8, *a9;
    double a61, a71, a81, a91, s, s2, s3, s4, t, t01, t02, t11, t12, t2, t21, t22, t3, t31, t32, t4, t41, t42
            , t5, t51, t52, t6, t61, t62, t7, t71, t72, t8, t81, t82, t9, t91;
    a = (src + 8);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 9);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 4);
    a5 = (src + 12);
    t5 = (*(a4) + *(a5));
    a6 = (src + 5);
    a7 = (src + 13);
    t6 = (*(a6) + *(a7));
    t7 = (*(a4) - *(a5));
    t8 = (*(a6) - *(a7));
    t9 = (t + t5);
    t01 = (t2 + t6);
    t11 = (t - t5);
    t21 = (t2 - t6);
    t31 = (t3 - t8);
    t41 = (t4 + t7);
    t51 = (t3 + t8);
    t61 = (t4 - t7);
    a8 = (src + 2);
    a9 = (src + 10);
    t71 = (*(a8) + *(a9));
    a01 = (src + 3);
    a11 = (src + 11);
    t81 = (*(a01) + *(a11));
    t91 = (*(a8) - *(a9));
    t02 = (*(a01) - *(a11));
    a21 = (src + 6);
    a31 = (src + 14);
    t12 = (*(a21) + *(a31));
    a41 = (src + 7);
    a51 = (src + 15);
    t22 = (*(a41) + *(a51));
    t32 = (*(a21) - *(a31));
    t42 = (*(a41) - *(a51));
    t52 = (t71 + t12);
    t62 = (t81 + t22);
    t72 = (t71 - t12);
    t82 = (t81 - t22);
    a61 = (0.70710678118654757*(t91 - t42));
    a71 = (0.70710678118654757*(t02 + t32));
    s = (a61 - a71);
    s2 = (a61 + a71);
    a81 = (0.70710678118654757*(t91 + t42));
    a91 = (0.70710678118654757*(t02 - t32));
    s3 = (a81 + a91);
    s4 = (a81 - a91);
    *(dst) = (t9 + t52);
    *((dst + 1)) = (t01 + t62);
    *((dst + 8)) = (t9 - t52);
    *((dst + 9)) = (t01 - t62);
    *((dst + 2)) = (t31 + s);
    *((dst + 3)) = (t41 + s2);
    *((dst + 10)) = (t31 - s);
    *((dst + 11)) = (t41 - s2);
    *((dst + 4)) = (t11 - t82);
    *((dst + 5)) = (t21 + t72);
    *((dst + 12)) = (t11 + t82);
    *((dst + 13)) = (t21 - t72);
    *((dst + 6)) = (t51 - s3);
    *((dst + 7)) = (t61 + s4);
    *((dst + 14)) = (t51 + s3);
    *((dst + 15)) = (t61 - s4);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_double_16)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    {const double  *a, *a01, *a02, *a03, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52
            , *a53, *a6, *a63, *a7, *a73, *a8, *a81, *a9, *a91;
    double a61, a62, a71, a72, a82, a83, a92, a93, s, s01, s11, s2, s21, s3, s31, s4, s41, s5, s51, s6, s61, s7
            , s8, s9, t, t01, t02, t03, t04, t05, t06, t07, t08, t11, t12, t13, t14, t15, t16, t17, t18, t2, t21, t22
            , t23, t24, t25, t26, t27, t28, t3, t31, t32, t33, t34, t35, t36, t37, t38, t4, t41, t42, t43, t44, t45, t46
            , t47, t48, t5, t51, t52, t53, t54, t55, t56, t57, t58, t6, t61, t62, t63, t64, t65, t66, t67, t68, t7, t71
            , t72, t73, t74, t75, t76, t77, t78, t8, t81, t82, t83, t84, t85, t86, t87, t88, t9, t91, t92, t93, t94, t95
            , t96, t97;
    a = (src + 16);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 17);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 8);
    a5 = (src + 24);
    t5 = (*(a4) + *(a5));
    a6 = (src + 9);
    a7 = (src + 25);
    t6 = (*(a6) + *(a7));
    t7 = (*(a4) - *(a5));
    t8 = (*(a6) - *(a7));
    t9 = (t + t5);
    t01 = (t2 + t6);
    t11 = (t - t5);
    t21 = (t2 - t6);
    t31 = (t3 - t8);
    t41 = (t4 + t7);
    t51 = (t3 + t8);
    t61 = (t4 - t7);
    a8 = (src + 2);
    a9 = (src + 18);
    t71 = (*(a8) + *(a9));
    a01 = (src + 3);
    a11 = (src + 19);
    t81 = (*(a01) + *(a11));
    t91 = (*(a8) - *(a9));
    t02 = (*(a01) - *(a11));
    a21 = (src + 10);
    a31 = (src + 26);
    t12 = (*(a21) + *(a31));
    a41 = (src + 11);
    a51 = (src + 27);
    t22 = (*(a41) + *(a51));
    t32 = (*(a21) - *(a31));
    t42 = (*(a41) - *(a51));
    t52 = (t71 + t12);
    t62 = (t81 + t22);
    a61 = (0.70710678118654757*(t71 - t12));
    a71 = (0.70710678118654757*(t81 - t22));
    s = (a61 - a71);
    s2 = (a61 + a71);
    t72 = (t91 - t42);
    t82 = (t02 + t32);
    t92 = (t91 + t42);
    t03 = (t02 - t32);
    s3 = ((0.92387953251128674*t72) - (0.38268343236508978*t82));
    s4 = ((0.38268343236508978*t72) + (0.92387953251128674*t82));
    s5 = ((0.38268343236508978*t92) - (0.92387953251128674*t03));
    s6 = ((0.92387953251128674*t92) + (0.38268343236508978*t03));
    a81 = (src + 4);
    a91 = (src + 20);
    t13 = (*(a81) + *(a91));
    a02 = (src + 5);
    a12 = (src + 21);
    t23 = (*(a02) + *(a12));
    t33 = (*(a81) - *(a91));
    t43 = (*(a02) - *(a12));
    a22 = (src + 12);
    a32 = (src + 28);
    t53 = (*(a22) + *(a32));
    a42 = (src + 13);
    a52 = (src + 29);
    t63 = (*(a42) + *(a52));
    t73 = (*(a22) - *(a32));
    t83 = (*(a42) - *(a52));
    t93 = (t13 + t53);
    t04 = (t23 + t63);
    t14 = (t13 - t53);
    t24 = (t23 - t63);
    a62 = (0.70710678118654757*(t33 - t83));
    a72 = (0.70710678118654757*(t43 + t73));
    s7 = (a62 - a72);
    s8 = (a62 + a72);
    a82 = (0.70710678118654757*(t33 + t83));
    a92 = (0.70710678118654757*(t43 - t73));
    s9 = (a82 + a92);
    s01 = (a82 - a92);
    a03 = (src + 6);
    a13 = (src + 22);
    t34 = (*(a03) + *(a13));
    a23 = (src + 7);
    a33 = (src + 23);
    t44 = (*(a23) + *(a33));
    t54 = (*(a03) - *(a13));
    t64 = (*(a23) - *(a33));
    a43 = (src + 14);
    a53 = (src + 30);
    t74 = (*(a43) + *(a53));
    a63 = (src + 15);
    a73 = (src + 31);
    t84 = (*(a63) + *(a73));
    t94 = (*(a43) - *(a53));
    t05 = (*(a63) - *(a73));
    t15 = (t34 + t74);
    t25 = (t44 + t84);
    a83 = (0.70710678118654757*(t34 - t74));
    a93 = (0.70710678118654757*(t44 - t84));
    s11 = (a83 + a93);
    s21 = (a83 - a93);
    t35 = (t54 - t05);
    t45 = (t64 + t94);
    t55 = (t54 + t05);
    t65 = (t64 - t94);
    s31 = ((0.38268343236508978*t35) - (0.92387953251128674*t45));
    s41 = ((0.92387953251128674*t35) + (0.38268343236508978*t45));
    s51 = ((0.38268343236508978*t65) - (0.92387953251128674*t55));
    s61 = ((0.38268343236508978*t55) + (0.92387953251128674*t65));
    t75 = (t9 + t93);
    t85 = (t01 + t04);
    t95 = (t9 - t93);
    t06 = (t01 - t04);
    t16 = (t52 + t15);
    t26 = (t62 + t25);
    t36 = (t52 - t15);
    t46 = (t62 - t25);
    *(dst) = (t75 + t16);
    *((dst + 1)) = (t85 + t26);
    *((dst + 16)) = (t75 - t16);
    *((dst + 17)) = (t85 - t26);
    *((dst + 8)) = (t95 - t46);
    *((dst + 9)) = (t06 + t36);
    *((dst + 24)) = (t95 + t46);
    *((dst + 25)) = (t06 - t36);
    t56 = (t31 + s7);
    t66 = (t41 + s8);
    t76 = (t31 - s7);
    t86 = (t41 - s8);
    t96 = (s3 + s31);
    t07 = (s4 + s41);
    t17 = (s3 - s31);
    t27 = (s4 - s41);
    *((dst + 2)) = (t56 + t96);
    *((dst + 3)) = (t66 + t07);
    *((dst + 18)) = (t56 - t96);
    *((dst + 19)) = (t66 - t07);
    *((dst + 10)) = (t76 - t27);
    *((dst + 11)) = (t86 + t17);
    *((dst + 26)) = (t76 + t27);
    *((dst + 27)) = (t86 - t17);
    t37 = (t11 - t24);
    t47 = (t21 + t14);
    t57 = (t11 + t24);
    t67 = (t21 - t14);
    t77 = (s - s11);
    t87 = (s2 + s21);
    t97 = (s + s11);
    t08 = (s2 - s21);
    *((dst + 4)) = (t37 + t77);
    *((dst + 5)) = (t47 + t87);
    *((dst + 20)) = (t37 - t77);
    *((dst + 21)) = (t47 - t87);
    *((dst + 12)) = (t57 - t08);
    *((dst + 13)) = (t67 + t97);
    *((dst + 28)) = (t57 + t08);
    *((dst + 29)) = (t67 - t97);
    t18 = (t51 - s9);
    t28 = (t61 + s01);
    t38 = (t51 + s9);
    t48 = (t61 - s01);
    t58 = (s5 + s51);
    t68 = (s6 - s61);
    t78 = (s5 - s51);
    t88 = (s6 + s61);
    *((dst + 6)) = (t18 + t58);
    *((dst + 7)) = (t28 + t68);
    *((dst + 22)) = (t18 - t58);
    *((dst + 23)) = (t28 - t68);
    *((dst + 14)) = (t38 - t88);
    *((dst + 15)) = (t48 + t78);
    *((dst + 30)) = (t38 + t88);
    *((dst + 31)) = (t48 - t78);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_double_32)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    {const double  *a, *a01, *a02, *a03, *a05, *a07, *a08, *a11, *a12, *a13, *a15, *a17, *a18, *a2, *a21, *a22, *a23, *a24, *a25, *a27, *a3, *a31
            , *a32, *a33, *a34, *a35, *a37, *a4, *a41, *a42, *a43, *a44, *a45, *a47, *a5, *a51, *a52, *a53, *a54, *a55, *a57, *a6, *a62, *a64
            , *a65, *a66, *a67, *a7, *a72, *a74, *a75, *a76, *a77, *a8, *a82, *a84, *a86, *a87, *a9, *a92, *a94, *a96, *a97;
    double a04, a06, a14, a16, a26, a28, a36, a38, a46, a48, a56, a58, a61, a63, a68, a71, a73, a78, a81, a83, a85, a91
            , a93, a95, s, s01, s02, s03, s04, s05, s11, s12, s13, s14, s15, s2, s21, s22, s23, s24, s25, s3, s31, s32
            , s33, s34, s35, s4, s41, s42, s43, s44, s45, s5, s51, s52, s53, s54, s55, s6, s61, s62, s63, s64, s65, s7
            , s71, s72, s73, s74, s8, s81, s82, s83, s84, s9, s91, s92, s93, s94, t, t01, t02, t03, t04, t05, t06, t07
            , t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t11, t12, t13, t14, t15, t16
            , t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t2, t21, t22, t23, t24
            , t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t3, t31, t32
            , t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l, t3m, t4, t41
            , t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t5
            , t51, t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m
            , t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l
            , t6m, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k
            , t7l, t7m, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j
            , t8k, t8l, t8m, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i
            , t9j, t9k, t9l, t9m;
    a = (src + 32);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 33);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 16);
    a5 = (src + 48);
    t5 = (*(a4) + *(a5));
    a6 = (src + 17);
    a7 = (src + 49);
    t6 = (*(a6) + *(a7));
    t7 = (*(a4) - *(a5));
    t8 = (*(a6) - *(a7));
    t9 = (t + t5);
    t01 = (t2 + t6);
    t11 = (t - t5);
    t21 = (t2 - t6);
    t31 = (t3 - t8);
    t41 = (t4 + t7);
    t51 = (t3 + t8);
    t61 = (t4 - t7);
    a8 = (src + 8);
    a9 = (src + 40);
    t71 = (*(a8) + *(a9));
    a01 = (src + 9);
    a11 = (src + 41);
    t81 = (*(a01) + *(a11));
    t91 = (*(a8) - *(a9));
    t02 = (*(a01) - *(a11));
    a21 = (src + 24);
    a31 = (src + 56);
    t12 = (*(a21) + *(a31));
    a41 = (src + 25);
    a51 = (src + 57);
    t22 = (*(a41) + *(a51));
    t32 = (*(a21) - *(a31));
    t42 = (*(a41) - *(a51));
    t52 = (t71 + t12);
    t62 = (t81 + t22);
    t72 = (t71 - t12);
    t82 = (t81 - t22);
    a61 = (0.70710678118654757*(t91 - t42));
    a71 = (0.70710678118654757*(t02 + t32));
    s = (a61 - a71);
    s2 = (a61 + a71);
    a81 = (0.70710678118654757*(t91 + t42));
    a91 = (0.70710678118654757*(t02 - t32));
    s3 = (a81 + a91);
    s4 = (a81 - a91);
    t92 = (t9 + t52);
    t03 = (t01 + t62);
    t13 = (t9 - t52);
    t23 = (t01 - t62);
    t33 = (t31 + s);
    t43 = (t41 + s2);
    t53 = (t31 - s);
    t63 = (t41 - s2);
    t73 = (t11 - t82);
    t83 = (t21 + t72);
    t93 = (t11 + t82);
    t04 = (t21 - t72);
    t14 = (t51 - s3);
    t24 = (t61 + s4);
    t34 = (t51 + s3);
    t44 = (t61 - s4);
    a02 = (src + 2);
    a12 = (src + 34);
    t54 = (*(a02) + *(a12));
    a22 = (src + 3);
    a32 = (src + 35);
    t64 = (*(a22) + *(a32));
    t74 = (*(a02) - *(a12));
    t84 = (*(a22) - *(a32));
    a42 = (src + 18);
    a52 = (src + 50);
    t94 = (*(a42) + *(a52));
    a62 = (src + 19);
    a72 = (src + 51);
    t05 = (*(a62) + *(a72));
    t15 = (*(a42) - *(a52));
    t25 = (*(a62) - *(a72));
    t35 = (t54 + t94);
    t45 = (t64 + t05);
    t55 = (t54 - t94);
    t65 = (t64 - t05);
    t75 = (t74 - t25);
    t85 = (t84 + t15);
    t95 = (t74 + t25);
    t06 = (t84 - t15);
    a82 = (src + 10);
    a92 = (src + 42);
    t16 = (*(a82) + *(a92));
    a03 = (src + 11);
    a13 = (src + 43);
    t26 = (*(a03) + *(a13));
    t36 = (*(a82) - *(a92));
    t46 = (*(a03) - *(a13));
    a23 = (src + 26);
    a33 = (src + 58);
    t56 = (*(a23) + *(a33));
    a43 = (src + 27);
    a53 = (src + 59);
    t66 = (*(a43) + *(a53));
    t76 = (*(a23) - *(a33));
    t86 = (*(a43) - *(a53));
    t96 = (t16 + t56);
    t07 = (t26 + t66);
    t17 = (t16 - t56);
    t27 = (t26 - t66);
    a63 = (0.70710678118654757*(t36 - t86));
    a73 = (0.70710678118654757*(t46 + t76));
    s5 = (a63 - a73);
    s6 = (a63 + a73);
    a83 = (0.70710678118654757*(t36 + t86));
    a93 = (0.70710678118654757*(t46 - t76));
    s7 = (a83 + a93);
    s8 = (a83 - a93);
    t37 = (t35 + t96);
    t47 = (t45 + t07);
    a04 = (0.70710678118654757*(t35 - t96));
    a14 = (0.70710678118654757*(t45 - t07));
    s9 = (a04 - a14);
    s01 = (a04 + a14);
    t57 = (t75 + s5);
    t67 = (t85 + s6);
    t77 = (t75 - s5);
    t87 = (t85 - s6);
    s11 = ((0.98078528040323043*t57) - (0.19509032201612828*t67));
    s21 = ((0.19509032201612828*t57) + (0.98078528040323043*t67));
    s31 = ((0.55557023301960218*t77) - (0.83146961230254524*t87));
    s41 = ((0.83146961230254524*t77) + (0.55557023301960218*t87));
    t97 = (t55 - t27);
    t08 = (t65 + t17);
    t18 = (t55 + t27);
    t28 = (t65 - t17);
    s51 = ((0.92387953251128674*t97) - (0.38268343236508978*t08));
    s61 = ((0.38268343236508978*t97) + (0.92387953251128674*t08));
    s71 = ((0.38268343236508978*t18) - (0.92387953251128674*t28));
    s81 = ((0.92387953251128674*t18) + (0.38268343236508978*t28));
    t38 = (t95 - s7);
    t48 = (t06 + s8);
    t58 = (t95 + s7);
    t68 = (t06 - s8);
    s91 = ((0.83146961230254524*t38) - (0.55557023301960218*t48));
    s02 = ((0.55557023301960218*t38) + (0.83146961230254524*t48));
    s12 = ((0.19509032201612828*t58) - (0.98078528040323043*t68));
    s22 = ((0.98078528040323043*t58) + (0.19509032201612828*t68));
    a24 = (src + 4);
    a34 = (src + 36);
    t78 = (*(a24) + *(a34));
    a44 = (src + 5);
    a54 = (src + 37);
    t88 = (*(a44) + *(a54));
    t98 = (*(a24) - *(a34));
    t09 = (*(a44) - *(a54));
    a64 = (src + 20);
    a74 = (src + 52);
    t19 = (*(a64) + *(a74));
    a84 = (src + 21);
    a94 = (src + 53);
    t29 = (*(a84) + *(a94));
    t39 = (*(a64) - *(a74));
    t49 = (*(a84) - *(a94));
    t59 = (t78 + t19);
    t69 = (t88 + t29);
    t79 = (t78 - t19);
    t89 = (t88 - t29);
    t99 = (t98 - t49);
    t0a = (t09 + t39);
    t1a = (t98 + t49);
    t2a = (t09 - t39);
    a05 = (src + 12);
    a15 = (src + 44);
    t3a = (*(a05) + *(a15));
    a25 = (src + 13);
    a35 = (src + 45);
    t4a = (*(a25) + *(a35));
    t5a = (*(a05) - *(a15));
    t6a = (*(a25) - *(a35));
    a45 = (src + 28);
    a55 = (src + 60);
    t7a = (*(a45) + *(a55));
    a65 = (src + 29);
    a75 = (src + 61);
    t8a = (*(a65) + *(a75));
    t9a = (*(a45) - *(a55));
    t0b = (*(a65) - *(a75));
    t1b = (t3a + t7a);
    t2b = (t4a + t8a);
    t3b = (t3a - t7a);
    t4b = (t4a - t8a);
    a85 = (0.70710678118654757*(t5a - t0b));
    a95 = (0.70710678118654757*(t6a + t9a));
    s32 = (a85 - a95);
    s42 = (a85 + a95);
    a06 = (0.70710678118654757*(t5a + t0b));
    a16 = (0.70710678118654757*(t6a - t9a));
    s52 = (a06 + a16);
    s62 = (a06 - a16);
    t5b = (t59 + t1b);
    t6b = (t69 + t2b);
    t7b = (t59 - t1b);
    t8b = (t69 - t2b);
    t9b = (t99 + s32);
    t0c = (t0a + s42);
    t1c = (t99 - s32);
    t2c = (t0a - s42);
    s72 = ((0.92387953251128674*t9b) - (0.38268343236508978*t0c));
    s82 = ((0.38268343236508978*t9b) + (0.92387953251128674*t0c));
    s92 = ((0.38268343236508978*t1c) + (0.92387953251128674*t2c));
    s03 = ((0.92387953251128674*t1c) - (0.38268343236508978*t2c));
    a26 = (0.70710678118654757*(t79 - t4b));
    a36 = (0.70710678118654757*(t89 + t3b));
    s13 = (a26 - a36);
    s23 = (a26 + a36);
    a46 = (0.70710678118654757*(t79 + t4b));
    a56 = (0.70710678118654757*(t89 - t3b));
    s33 = (a46 + a56);
    s43 = (a46 - a56);
    t3c = (t1a - s52);
    t4c = (t2a + s62);
    t5c = (t1a + s52);
    t6c = (t2a - s62);
    s53 = ((0.38268343236508978*t3c) - (0.92387953251128674*t4c));
    s63 = ((0.92387953251128674*t3c) + (0.38268343236508978*t4c));
    s73 = ((0.92387953251128674*t5c) + (0.38268343236508978*t6c));
    s83 = ((0.38268343236508978*t5c) - (0.92387953251128674*t6c));
    a66 = (src + 6);
    a76 = (src + 38);
    t7c = (*(a66) + *(a76));
    a86 = (src + 7);
    a96 = (src + 39);
    t8c = (*(a86) + *(a96));
    t9c = (*(a66) - *(a76));
    t0d = (*(a86) - *(a96));
    a07 = (src + 22);
    a17 = (src + 54);
    t1d = (*(a07) + *(a17));
    a27 = (src + 23);
    a37 = (src + 55);
    t2d = (*(a27) + *(a37));
    t3d = (*(a07) - *(a17));
    t4d = (*(a27) - *(a37));
    t5d = (t7c + t1d);
    t6d = (t8c + t2d);
    t7d = (t7c - t1d);
    t8d = (t8c - t2d);
    t9d = (t9c - t4d);
    t0e = (t0d + t3d);
    t1e = (t9c + t4d);
    t2e = (t0d - t3d);
    a47 = (src + 14);
    a57 = (src + 46);
    t3e = (*(a47) + *(a57));
    a67 = (src + 15);
    a77 = (src + 47);
    t4e = (*(a67) + *(a77));
    t5e = (*(a47) - *(a57));
    t6e = (*(a67) - *(a77));
    a87 = (src + 30);
    a97 = (src + 62);
    t7e = (*(a87) + *(a97));
    a08 = (src + 31);
    a18 = (src + 63);
    t8e = (*(a08) + *(a18));
    t9e = (*(a87) - *(a97));
    t0f = (*(a08) - *(a18));
    t1f = (t3e + t7e);
    t2f = (t4e + t8e);
    t3f = (t3e - t7e);
    t4f = (t4e - t8e);
    a28 = (0.70710678118654757*(t5e - t0f));
    a38 = (0.70710678118654757*(t6e + t9e));
    s93 = (a28 - a38);
    s04 = (a28 + a38);
    a48 = (0.70710678118654757*(t5e + t0f));
    a58 = (0.70710678118654757*(t6e - t9e));
    s14 = (a48 + a58);
    s24 = (a48 - a58);
    t5f = (t5d + t1f);
    t6f = (t6d + t2f);
    a68 = (0.70710678118654757*(t5d - t1f));
    a78 = (0.70710678118654757*(t6d - t2f));
    s34 = (a68 + a78);
    s44 = (a68 - a78);
    t7f = (t9d + s93);
    t8f = (t0e + s04);
    t9f = (t9d - s93);
    t0g = (t0e - s04);
    s54 = ((0.83146961230254524*t7f) - (0.55557023301960218*t8f));
    s64 = ((0.55557023301960218*t7f) + (0.83146961230254524*t8f));
    s74 = ((0.98078528040323043*t9f) + (0.19509032201612828*t0g));
    s84 = ((0.19509032201612828*t9f) - (0.98078528040323043*t0g));
    t1g = (t7d - t4f);
    t2g = (t8d + t3f);
    t3g = (t7d + t4f);
    t4g = (t8d - t3f);
    s94 = ((0.38268343236508978*t1g) - (0.92387953251128674*t2g));
    s05 = ((0.92387953251128674*t1g) + (0.38268343236508978*t2g));
    s15 = ((0.38268343236508978*t4g) - (0.92387953251128674*t3g));
    s25 = ((0.38268343236508978*t3g) + (0.92387953251128674*t4g));
    t5g = (t1e - s14);
    t6g = (t2e + s24);
    t7g = (t1e + s14);
    t8g = (t2e - s24);
    s35 = ((0.19509032201612828*t5g) + (0.98078528040323043*t6g));
    s45 = ((0.98078528040323043*t5g) - (0.19509032201612828*t6g));
    s55 = ((0.83146961230254524*t8g) - (0.55557023301960218*t7g));
    s65 = ((0.83146961230254524*t7g) + (0.55557023301960218*t8g));
    t9g = (t92 + t5b);
    t0h = (t03 + t6b);
    t1h = (t92 - t5b);
    t2h = (t03 - t6b);
    t3h = (t37 + t5f);
    t4h = (t47 + t6f);
    t5h = (t37 - t5f);
    t6h = (t47 - t6f);
    *(dst) = (t9g + t3h);
    *((dst + 1)) = (t0h + t4h);
    *((dst + 32)) = (t9g - t3h);
    *((dst + 33)) = (t0h - t4h);
    *((dst + 16)) = (t1h - t6h);
    *((dst + 17)) = (t2h + t5h);
    *((dst + 48)) = (t1h + t6h);
    *((dst + 49)) = (t2h - t5h);
    t7h = (t33 + s72);
    t8h = (t43 + s82);
    t9h = (t33 - s72);
    t0i = (t43 - s82);
    t1i = (s11 + s54);
    t2i = (s21 + s64);
    t3i = (s11 - s54);
    t4i = (s21 - s64);
    *((dst + 2)) = (t7h + t1i);
    *((dst + 3)) = (t8h + t2i);
    *((dst + 34)) = (t7h - t1i);
    *((dst + 35)) = (t8h - t2i);
    *((dst + 18)) = (t9h - t4i);
    *((dst + 19)) = (t0i + t3i);
    *((dst + 50)) = (t9h + t4i);
    *((dst + 51)) = (t0i - t3i);
    t5i = (t73 + s13);
    t6i = (t83 + s23);
    t7i = (t73 - s13);
    t8i = (t83 - s23);
    t9i = (s51 + s94);
    t0j = (s61 + s05);
    t1j = (s51 - s94);
    t2j = (s61 - s05);
    *((dst + 4)) = (t5i + t9i);
    *((dst + 5)) = (t6i + t0j);
    *((dst + 36)) = (t5i - t9i);
    *((dst + 37)) = (t6i - t0j);
    *((dst + 20)) = (t7i - t2j);
    *((dst + 21)) = (t8i + t1j);
    *((dst + 52)) = (t7i + t2j);
    *((dst + 53)) = (t8i - t1j);
    t3j = (t14 + s53);
    t4j = (t24 + s63);
    t5j = (t14 - s53);
    t6j = (t24 - s63);
    t7j = (s91 - s35);
    t8j = (s02 + s45);
    t9j = (s91 + s35);
    t0k = (s02 - s45);
    *((dst + 6)) = (t3j + t7j);
    *((dst + 7)) = (t4j + t8j);
    *((dst + 38)) = (t3j - t7j);
    *((dst + 39)) = (t4j - t8j);
    *((dst + 22)) = (t5j - t0k);
    *((dst + 23)) = (t6j + t9j);
    *((dst + 54)) = (t5j + t0k);
    *((dst + 55)) = (t6j - t9j);
    t1k = (t13 - t8b);
    t2k = (t23 + t7b);
    t3k = (t13 + t8b);
    t4k = (t23 - t7b);
    t5k = (s9 - s34);
    t6k = (s01 + s44);
    t7k = (s9 + s34);
    t8k = (s01 - s44);
    *((dst + 8)) = (t1k + t5k);
    *((dst + 9)) = (t2k + t6k);
    *((dst + 40)) = (t1k - t5k);
    *((dst + 41)) = (t2k - t6k);
    *((dst + 24)) = (t3k - t8k);
    *((dst + 25)) = (t4k + t7k);
    *((dst + 56)) = (t3k + t8k);
    *((dst + 57)) = (t4k - t7k);
    t9k = (t53 - s92);
    t0l = (t63 + s03);
    t1l = (t53 + s92);
    t2l = (t63 - s03);
    t3l = (s31 - s74);
    t4l = (s41 + s84);
    t5l = (s31 + s74);
    t6l = (s41 - s84);
    *((dst + 10)) = (t9k + t3l);
    *((dst + 11)) = (t0l + t4l);
    *((dst + 42)) = (t9k - t3l);
    *((dst + 43)) = (t0l - t4l);
    *((dst + 26)) = (t1l - t6l);
    *((dst + 27)) = (t2l + t5l);
    *((dst + 58)) = (t1l + t6l);
    *((dst + 59)) = (t2l - t5l);
    t7l = (t93 - s33);
    t8l = (t04 + s43);
    t9l = (t93 + s33);
    t0m = (t04 - s43);
    t1m = (s71 + s15);
    t2m = (s81 - s25);
    t3m = (s71 - s15);
    t4m = (s81 + s25);
    *((dst + 12)) = (t7l + t1m);
    *((dst + 13)) = (t8l + t2m);
    *((dst + 44)) = (t7l - t1m);
    *((dst + 45)) = (t8l - t2m);
    *((dst + 28)) = (t9l - t4m);
    *((dst + 29)) = (t0m + t3m);
    *((dst + 60)) = (t9l + t4m);
    *((dst + 61)) = (t0m - t3m);
    t5m = (t34 - s73);
    t6m = (t44 + s83);
    t7m = (t34 + s73);
    t8m = (t44 - s83);
    t9m = (s12 + s55);
    t0n = (s22 - s65);
    t1n = (s12 - s55);
    t2n = (s22 + s65);
    *((dst + 14)) = (t5m + t9m);
    *((dst + 15)) = (t6m + t0n);
    *((dst + 46)) = (t5m - t9m);
    *((dst + 47)) = (t6m - t0n);
    *((dst + 30)) = (t7m - t2n);
    *((dst + 31)) = (t8m + t1n);
    *((dst + 62)) = (t7m + t2n);
    *((dst + 63)) = (t8m - t1n);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_double_64)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[128];
    double  *a03, *a04, *a05, *a06, *a13, *a14, *a15, *a22, *a23, *a24, *a25, *a32, *a33, *a34, *a35, *a42, *a43, *a44, *a45, *a52, *a53, *a54
            , *a55, *a62, *a63, *a64, *a72, *a73, *a74, *a82, *a83, *a84, *a92, *a94;
    const double  *a, *a01, *a11, *a2, *a21, *a3, *a31, *a4, *a41, *a5, *a51, *a6, *a61, *a7, *a8, *a9;
    int a12, a93;
    double a02, a65, a71, a75, a81, a85, a91, a95, s, s2, s3, s4, s5, s6, s7, s8, t, t01, t02, t03, t04, t05
            , t06, t07, t11, t12, t13, t14, t15, t16, t17, t2, t21, t22, t23, t24, t25, t26, t27, t3, t31, t32, t33, t34
            , t35, t36, t4, t41, t42, t43, t44, t45, t46, t5, t51, t52, t53, t54, t55, t56, t6, t61, t62, t63, t64, t65
            , t66, t7, t71, t72, t73, t74, t75, t76, t8, t81, t82, t83, t84, t85, t86, t9, t91, t92, t93, t94, t95, t96;
    {long i; for(i = 0; i <= 7; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 64);
        a4 = (a + 65);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 32);
        a6 = (a + 33);
        a7 = (a + 96);
        a8 = (a + 97);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 - t8);
        t41 = (t4 + t7);
        t51 = (t3 + t8);
        t61 = (t4 - t7);
        a9 = (a + 16);
        a01 = (a + 17);
        a11 = (a + 80);
        a21 = (a + 81);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 48);
        a41 = (a + 49);
        a51 = (a + 112);
        a61 = (a + 113);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        t72 = (t71 - t12);
        t82 = (t81 - t22);
        a71 = (0.70710678118654757*(t91 - t42));
        a81 = (0.70710678118654757*(t02 + t32));
        s = (a71 - a81);
        s2 = (a71 + a81);
        a91 = (0.70710678118654757*(t91 + t42));
        a02 = (0.70710678118654757*(t02 - t32));
        s3 = (a91 + a02);
        s4 = (a91 - a02);
        t92 = (t9 + t52);
        t03 = (t01 + t62);
        t13 = (t9 - t52);
        t23 = (t01 - t62);
        a12 = (16*i);
        a22 = (D283 + a12);
        a32 = (a22 + 1);
        a42 = (a22 + 2);
        a52 = (a22 + 3);
        a62 = (T + a12);
        *(a62) = ((*(a22)*t92) - (*(a32)*t03));
        *((a62 + 1)) = ((*(a32)*t92) + (*(a22)*t03));
        *((a62 + 8)) = ((*(a42)*t13) - (*(a52)*t23));
        *((a62 + 9)) = ((*(a52)*t13) + (*(a42)*t23));
        t33 = (t31 + s);
        t43 = (t41 + s2);
        t53 = (t31 - s);
        t63 = (t41 - s2);
        a72 = (a22 + 4);
        a82 = (a22 + 5);
        a92 = (a22 + 6);
        a03 = (a22 + 7);
        *((a62 + 2)) = ((*(a72)*t33) - (*(a82)*t43));
        *((a62 + 3)) = ((*(a82)*t33) + (*(a72)*t43));
        *((a62 + 10)) = ((*(a92)*t53) - (*(a03)*t63));
        *((a62 + 11)) = ((*(a03)*t53) + (*(a92)*t63));
        t73 = (t11 - t82);
        t83 = (t21 + t72);
        t93 = (t11 + t82);
        t04 = (t21 - t72);
        a13 = (a22 + 8);
        a23 = (a22 + 9);
        a33 = (a22 + 10);
        a43 = (a22 + 11);
        *((a62 + 4)) = ((*(a13)*t73) - (*(a23)*t83));
        *((a62 + 5)) = ((*(a23)*t73) + (*(a13)*t83));
        *((a62 + 12)) = ((*(a33)*t93) - (*(a43)*t04));
        *((a62 + 13)) = ((*(a43)*t93) + (*(a33)*t04));
        t14 = (t51 - s3);
        t24 = (t61 + s4);
        t34 = (t51 + s3);
        t44 = (t61 - s4);
        a53 = (a22 + 12);
        a63 = (a22 + 13);
        a73 = (a22 + 14);
        a83 = (a22 + 15);
        *((a62 + 6)) = ((*(a53)*t14) - (*(a63)*t24));
        *((a62 + 7)) = ((*(a63)*t14) + (*(a53)*t24));
        *((a62 + 14)) = ((*(a73)*t34) - (*(a83)*t44));
        *((a62 + 15)) = ((*(a83)*t34) + (*(a73)*t44));
    }}
    {long i2; for(i2 = 0; i2 <= 7; i2++) {
        a93 = (2*i2);
        a04 = (T + a93);
        a14 = (a04 + 1);
        a24 = (a04 + 64);
        a34 = (a04 + 65);
        t54 = (*(a04) + *(a24));
        t64 = (*(a14) + *(a34));
        t74 = (*(a04) - *(a24));
        t84 = (*(a14) - *(a34));
        a44 = (a04 + 32);
        a54 = (a04 + 33);
        a64 = (a04 + 96);
        a74 = (a04 + 97);
        t94 = (*(a44) + *(a64));
        t05 = (*(a54) + *(a74));
        t15 = (*(a44) - *(a64));
        t25 = (*(a54) - *(a74));
        t35 = (t54 + t94);
        t45 = (t64 + t05);
        t55 = (t54 - t94);
        t65 = (t64 - t05);
        t75 = (t74 - t25);
        t85 = (t84 + t15);
        t95 = (t74 + t25);
        t06 = (t84 - t15);
        a84 = (a04 + 16);
        a94 = (a04 + 17);
        a05 = (a04 + 80);
        a15 = (a04 + 81);
        t16 = (*(a84) + *(a05));
        t26 = (*(a94) + *(a15));
        t36 = (*(a84) - *(a05));
        t46 = (*(a94) - *(a15));
        a25 = (a04 + 48);
        a35 = (a04 + 49);
        a45 = (a04 + 112);
        a55 = (a04 + 113);
        t56 = (*(a25) + *(a45));
        t66 = (*(a35) + *(a55));
        t76 = (*(a25) - *(a45));
        t86 = (*(a35) - *(a55));
        t96 = (t16 + t56);
        t07 = (t26 + t66);
        t17 = (t16 - t56);
        t27 = (t26 - t66);
        a65 = (0.70710678118654757*(t36 - t86));
        a75 = (0.70710678118654757*(t46 + t76));
        s5 = (a65 - a75);
        s6 = (a65 + a75);
        a85 = (0.70710678118654757*(t36 + t86));
        a95 = (0.70710678118654757*(t46 - t76));
        s7 = (a85 + a95);
        s8 = (a85 - a95);
        a06 = (dst + a93);
        *(a06) = (t35 + t96);
        *((a06 + 1)) = (t45 + t07);
        *((a06 + 64)) = (t35 - t96);
        *((a06 + 65)) = (t45 - t07);
        *((a06 + 16)) = (t75 + s5);
        *((a06 + 17)) = (t85 + s6);
        *((a06 + 80)) = (t75 - s5);
        *((a06 + 81)) = (t85 - s6);
        *((a06 + 32)) = (t55 - t27);
        *((a06 + 33)) = (t65 + t17);
        *((a06 + 96)) = (t55 + t27);
        *((a06 + 97)) = (t65 - t17);
        *((a06 + 48)) = (t95 - s7);
        *((a06 + 49)) = (t06 + s8);
        *((a06 + 112)) = (t95 + s7);
        *((a06 + 113)) = (t06 - s8);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_double_128)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[256];
    double  *a05, *a06, *a07, *a08, *a09, *a15, *a16, *a17, *a18, *a19, *a24, *a25, *a26, *a27, *a28, *a34, *a35, *a36, *a37, *a38, *a44, *a45
            , *a46, *a47, *a48, *a54, *a55, *a56, *a58, *a64, *a65, *a66, *a67, *a68, *a69, *a74, *a75, *a76, *a77, *a78, *a84, *a85, *a86, *a87
            , *a88, *a94, *a95, *a96, *a97, *a98;
    const double  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a57;
    double a03, a04, a29, a39, a49, a59, a71, a72, a81, a82, a92, a93, s, s01, s02, s11, s2, s21, s3, s31, s4, s41
            , s5, s51, s6, s61, s7, s71, s8, s81, s9, s91, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b
            , t0c, t0d, t0e, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t2, t21, t22, t23, t24
            , t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b
            , t3c, t3d, t3e, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t5, t51, t52, t53
            , t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a
            , t6b, t6c, t6d, t6e, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t8, t81, t82
            , t83, t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99
            , t9a, t9b, t9c, t9d;
    {long i; for(i = 0; i <= 7; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 128);
        a4 = (a + 129);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 64);
        a6 = (a + 65);
        a7 = (a + 192);
        a8 = (a + 193);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 - t8);
        t41 = (t4 + t7);
        t51 = (t3 + t8);
        t61 = (t4 - t7);
        a9 = (a + 16);
        a01 = (a + 17);
        a11 = (a + 144);
        a21 = (a + 145);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 80);
        a41 = (a + 81);
        a51 = (a + 208);
        a61 = (a + 209);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        a71 = (0.70710678118654757*(t71 - t12));
        a81 = (0.70710678118654757*(t81 - t22));
        s = (a71 - a81);
        s2 = (a71 + a81);
        t72 = (t91 - t42);
        t82 = (t02 + t32);
        t92 = (t91 + t42);
        t03 = (t02 - t32);
        s3 = ((0.92387953251128674*t72) - (0.38268343236508978*t82));
        s4 = ((0.38268343236508978*t72) + (0.92387953251128674*t82));
        s5 = ((0.38268343236508978*t92) - (0.92387953251128674*t03));
        s6 = ((0.92387953251128674*t92) + (0.38268343236508978*t03));
        a91 = (a + 32);
        a02 = (a + 33);
        a12 = (a + 160);
        a22 = (a + 161);
        t13 = (*(a91) + *(a12));
        t23 = (*(a02) + *(a22));
        t33 = (*(a91) - *(a12));
        t43 = (*(a02) - *(a22));
        a32 = (a + 96);
        a42 = (a + 97);
        a52 = (a + 224);
        a62 = (a + 225);
        t53 = (*(a32) + *(a52));
        t63 = (*(a42) + *(a62));
        t73 = (*(a32) - *(a52));
        t83 = (*(a42) - *(a62));
        t93 = (t13 + t53);
        t04 = (t23 + t63);
        t14 = (t13 - t53);
        t24 = (t23 - t63);
        a72 = (0.70710678118654757*(t33 - t83));
        a82 = (0.70710678118654757*(t43 + t73));
        s7 = (a72 - a82);
        s8 = (a72 + a82);
        a92 = (0.70710678118654757*(t33 + t83));
        a03 = (0.70710678118654757*(t43 - t73));
        s9 = (a92 + a03);
        s01 = (a92 - a03);
        a13 = (a + 48);
        a23 = (a + 49);
        a33 = (a + 176);
        a43 = (a + 177);
        t34 = (*(a13) + *(a33));
        t44 = (*(a23) + *(a43));
        t54 = (*(a13) - *(a33));
        t64 = (*(a23) - *(a43));
        a53 = (a + 112);
        a63 = (a + 113);
        a73 = (a + 240);
        a83 = (a + 241);
        t74 = (*(a53) + *(a73));
        t84 = (*(a63) + *(a83));
        t94 = (*(a53) - *(a73));
        t05 = (*(a63) - *(a83));
        t15 = (t34 + t74);
        t25 = (t44 + t84);
        a93 = (0.70710678118654757*(t34 - t74));
        a04 = (0.70710678118654757*(t44 - t84));
        s11 = (a93 + a04);
        s21 = (a93 - a04);
        t35 = (t54 - t05);
        t45 = (t64 + t94);
        t55 = (t54 + t05);
        t65 = (t64 - t94);
        s31 = ((0.38268343236508978*t35) - (0.92387953251128674*t45));
        s41 = ((0.92387953251128674*t35) + (0.38268343236508978*t45));
        s51 = ((0.38268343236508978*t65) - (0.92387953251128674*t55));
        s61 = ((0.38268343236508978*t55) + (0.92387953251128674*t65));
        t75 = (t9 + t93);
        t85 = (t01 + t04);
        t95 = (t9 - t93);
        t06 = (t01 - t04);
        t16 = (t52 + t15);
        t26 = (t62 + t25);
        t36 = (t52 - t15);
        t46 = (t62 - t25);
        t56 = (t75 + t16);
        t66 = (t85 + t26);
        t76 = (t75 - t16);
        t86 = (t85 - t26);
        a14 = (32*i);
        a24 = (D284 + a14);
        a34 = (a24 + 1);
        a44 = (a24 + 2);
        a54 = (a24 + 3);
        a64 = (T + a14);
        *(a64) = ((*(a24)*t56) - (*(a34)*t66));
        *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
        *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
        *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
        t96 = (t95 - t46);
        t07 = (t06 + t36);
        t17 = (t95 + t46);
        t27 = (t06 - t36);
        a74 = (a24 + 4);
        a84 = (a24 + 5);
        a94 = (a24 + 6);
        a05 = (a24 + 7);
        *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
        *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
        *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
        *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
        t37 = (t31 + s7);
        t47 = (t41 + s8);
        t57 = (t31 - s7);
        t67 = (t41 - s8);
        t77 = (s3 + s31);
        t87 = (s4 + s41);
        t97 = (s3 - s31);
        t08 = (s4 - s41);
        t18 = (t37 + t77);
        t28 = (t47 + t87);
        t38 = (t37 - t77);
        t48 = (t47 - t87);
        a15 = (a24 + 8);
        a25 = (a24 + 9);
        a35 = (a24 + 10);
        a45 = (a24 + 11);
        *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
        *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
        *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
        *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
        t58 = (t57 - t08);
        t68 = (t67 + t97);
        t78 = (t57 + t08);
        t88 = (t67 - t97);
        a55 = (a24 + 12);
        a65 = (a24 + 13);
        a75 = (a24 + 14);
        a85 = (a24 + 15);
        *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
        *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
        *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
        *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
        t98 = (t11 - t24);
        t09 = (t21 + t14);
        t19 = (t11 + t24);
        t29 = (t21 - t14);
        t39 = (s - s11);
        t49 = (s2 + s21);
        t59 = (s + s11);
        t69 = (s2 - s21);
        t79 = (t98 + t39);
        t89 = (t09 + t49);
        t99 = (t98 - t39);
        t0a = (t09 - t49);
        a95 = (a24 + 16);
        a06 = (a24 + 17);
        a16 = (a24 + 18);
        a26 = (a24 + 19);
        *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
        *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
        *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
        *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
        t1a = (t19 - t69);
        t2a = (t29 + t59);
        t3a = (t19 + t69);
        t4a = (t29 - t59);
        a36 = (a24 + 20);
        a46 = (a24 + 21);
        a56 = (a24 + 22);
        a66 = (a24 + 23);
        *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
        *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
        *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
        *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
        t5a = (t51 - s9);
        t6a = (t61 + s01);
        t7a = (t51 + s9);
        t8a = (t61 - s01);
        t9a = (s5 + s51);
        t0b = (s6 - s61);
        t1b = (s5 - s51);
        t2b = (s6 + s61);
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        a76 = (a24 + 24);
        a86 = (a24 + 25);
        a96 = (a24 + 26);
        a07 = (a24 + 27);
        *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
        *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
        *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
        *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
        t7b = (t7a - t2b);
        t8b = (t8a + t1b);
        t9b = (t7a + t2b);
        t0c = (t8a - t1b);
        a17 = (a24 + 28);
        a27 = (a24 + 29);
        a37 = (a24 + 30);
        a47 = (a24 + 31);
        *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
        *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
        *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
        *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        a57 = (2*i2);
        a67 = (T + a57);
        a77 = (a67 + 1);
        a87 = (a67 + 128);
        a97 = (a67 + 129);
        t1c = (*(a67) + *(a87));
        t2c = (*(a77) + *(a97));
        t3c = (*(a67) - *(a87));
        t4c = (*(a77) - *(a97));
        a08 = (a67 + 64);
        a18 = (a67 + 65);
        a28 = (a67 + 192);
        a38 = (a67 + 193);
        t5c = (*(a08) + *(a28));
        t6c = (*(a18) + *(a38));
        t7c = (*(a08) - *(a28));
        t8c = (*(a18) - *(a38));
        t9c = (t1c + t5c);
        t0d = (t2c + t6c);
        t1d = (t1c - t5c);
        t2d = (t2c - t6c);
        t3d = (t3c - t8c);
        t4d = (t4c + t7c);
        t5d = (t3c + t8c);
        t6d = (t4c - t7c);
        a48 = (a67 + 32);
        a58 = (a67 + 33);
        a68 = (a67 + 160);
        a78 = (a67 + 161);
        t7d = (*(a48) + *(a68));
        t8d = (*(a58) + *(a78));
        t9d = (*(a48) - *(a68));
        t0e = (*(a58) - *(a78));
        a88 = (a67 + 96);
        a98 = (a67 + 97);
        a09 = (a67 + 224);
        a19 = (a67 + 225);
        t1e = (*(a88) + *(a09));
        t2e = (*(a98) + *(a19));
        t3e = (*(a88) - *(a09));
        t4e = (*(a98) - *(a19));
        t5e = (t7d + t1e);
        t6e = (t8d + t2e);
        t7e = (t7d - t1e);
        t8e = (t8d - t2e);
        a29 = (0.70710678118654757*(t9d - t4e));
        a39 = (0.70710678118654757*(t0e + t3e));
        s71 = (a29 - a39);
        s81 = (a29 + a39);
        a49 = (0.70710678118654757*(t9d + t4e));
        a59 = (0.70710678118654757*(t0e - t3e));
        s91 = (a49 + a59);
        s02 = (a49 - a59);
        a69 = (dst + a57);
        *(a69) = (t9c + t5e);
        *((a69 + 1)) = (t0d + t6e);
        *((a69 + 128)) = (t9c - t5e);
        *((a69 + 129)) = (t0d - t6e);
        *((a69 + 32)) = (t3d + s71);
        *((a69 + 33)) = (t4d + s81);
        *((a69 + 160)) = (t3d - s71);
        *((a69 + 161)) = (t4d - s81);
        *((a69 + 64)) = (t1d - t8e);
        *((a69 + 65)) = (t2d + t7e);
        *((a69 + 192)) = (t1d + t8e);
        *((a69 + 193)) = (t2d - t7e);
        *((a69 + 96)) = (t5d - s91);
        *((a69 + 97)) = (t6d + s02);
        *((a69 + 224)) = (t5d + s91);
        *((a69 + 225)) = (t6d - s02);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_double_256)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[512];
    double  *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a15, *a16, *a17, *a18, *a19, *a1a, *a1b, *a24, *a25, *a26, *a27, *a28, *a2b, *a34, *a35
            , *a36, *a37, *a38, *a3b, *a44, *a45, *a46, *a47, *a48, *a49, *a54, *a55, *a56, *a58, *a59, *a64, *a65, *a66, *a67, *a68, *a69, *a6a
            , *a6b, *a74, *a75, *a76, *a77, *a78, *a79, *a7a, *a84, *a85, *a86, *a87, *a88, *a89, *a8a, *a94, *a95, *a96, *a97, *a98, *a99, *a9a;
    const double  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a57;
    double a03, a04, a29, a2a, a39, a3a, a4a, a4b, a5a, a5b, a71, a72, a81, a82, a92, a93, s, s01, s02, s03, s11, s12
            , s13, s2, s21, s22, s23, s3, s31, s32, s4, s41, s42, s5, s51, s52, s6, s61, s62, s7, s71, s72, s8, s81
            , s82, s9, s91, s92, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h
            , t0i, t0j, t0k, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j
            , t1k, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k
            , t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t4
            , t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t5, t51
            , t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t6, t61, t62
            , t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t7, t71, t72, t73
            , t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t8, t81, t82, t83, t84
            , t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t9, t91, t92, t93, t94, t95
            , t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j;
    {long i; for(i = 0; i <= 15; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 256);
        a4 = (a + 257);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 128);
        a6 = (a + 129);
        a7 = (a + 384);
        a8 = (a + 385);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 - t8);
        t41 = (t4 + t7);
        t51 = (t3 + t8);
        t61 = (t4 - t7);
        a9 = (a + 32);
        a01 = (a + 33);
        a11 = (a + 288);
        a21 = (a + 289);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 160);
        a41 = (a + 161);
        a51 = (a + 416);
        a61 = (a + 417);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        a71 = (0.70710678118654757*(t71 - t12));
        a81 = (0.70710678118654757*(t81 - t22));
        s = (a71 - a81);
        s2 = (a71 + a81);
        t72 = (t91 - t42);
        t82 = (t02 + t32);
        t92 = (t91 + t42);
        t03 = (t02 - t32);
        s3 = ((0.92387953251128674*t72) - (0.38268343236508978*t82));
        s4 = ((0.38268343236508978*t72) + (0.92387953251128674*t82));
        s5 = ((0.38268343236508978*t92) - (0.92387953251128674*t03));
        s6 = ((0.92387953251128674*t92) + (0.38268343236508978*t03));
        a91 = (a + 64);
        a02 = (a + 65);
        a12 = (a + 320);
        a22 = (a + 321);
        t13 = (*(a91) + *(a12));
        t23 = (*(a02) + *(a22));
        t33 = (*(a91) - *(a12));
        t43 = (*(a02) - *(a22));
        a32 = (a + 192);
        a42 = (a + 193);
        a52 = (a + 448);
        a62 = (a + 449);
        t53 = (*(a32) + *(a52));
        t63 = (*(a42) + *(a62));
        t73 = (*(a32) - *(a52));
        t83 = (*(a42) - *(a62));
        t93 = (t13 + t53);
        t04 = (t23 + t63);
        t14 = (t13 - t53);
        t24 = (t23 - t63);
        a72 = (0.70710678118654757*(t33 - t83));
        a82 = (0.70710678118654757*(t43 + t73));
        s7 = (a72 - a82);
        s8 = (a72 + a82);
        a92 = (0.70710678118654757*(t33 + t83));
        a03 = (0.70710678118654757*(t43 - t73));
        s9 = (a92 + a03);
        s01 = (a92 - a03);
        a13 = (a + 96);
        a23 = (a + 97);
        a33 = (a + 352);
        a43 = (a + 353);
        t34 = (*(a13) + *(a33));
        t44 = (*(a23) + *(a43));
        t54 = (*(a13) - *(a33));
        t64 = (*(a23) - *(a43));
        a53 = (a + 224);
        a63 = (a + 225);
        a73 = (a + 480);
        a83 = (a + 481);
        t74 = (*(a53) + *(a73));
        t84 = (*(a63) + *(a83));
        t94 = (*(a53) - *(a73));
        t05 = (*(a63) - *(a83));
        t15 = (t34 + t74);
        t25 = (t44 + t84);
        a93 = (0.70710678118654757*(t34 - t74));
        a04 = (0.70710678118654757*(t44 - t84));
        s11 = (a93 + a04);
        s21 = (a93 - a04);
        t35 = (t54 - t05);
        t45 = (t64 + t94);
        t55 = (t54 + t05);
        t65 = (t64 - t94);
        s31 = ((0.38268343236508978*t35) - (0.92387953251128674*t45));
        s41 = ((0.92387953251128674*t35) + (0.38268343236508978*t45));
        s51 = ((0.38268343236508978*t65) - (0.92387953251128674*t55));
        s61 = ((0.38268343236508978*t55) + (0.92387953251128674*t65));
        t75 = (t9 + t93);
        t85 = (t01 + t04);
        t95 = (t9 - t93);
        t06 = (t01 - t04);
        t16 = (t52 + t15);
        t26 = (t62 + t25);
        t36 = (t52 - t15);
        t46 = (t62 - t25);
        t56 = (t75 + t16);
        t66 = (t85 + t26);
        t76 = (t75 - t16);
        t86 = (t85 - t26);
        a14 = (32*i);
        a24 = (D285 + a14);
        a34 = (a24 + 1);
        a44 = (a24 + 2);
        a54 = (a24 + 3);
        a64 = (T + a14);
        *(a64) = ((*(a24)*t56) - (*(a34)*t66));
        *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
        *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
        *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
        t96 = (t95 - t46);
        t07 = (t06 + t36);
        t17 = (t95 + t46);
        t27 = (t06 - t36);
        a74 = (a24 + 4);
        a84 = (a24 + 5);
        a94 = (a24 + 6);
        a05 = (a24 + 7);
        *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
        *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
        *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
        *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
        t37 = (t31 + s7);
        t47 = (t41 + s8);
        t57 = (t31 - s7);
        t67 = (t41 - s8);
        t77 = (s3 + s31);
        t87 = (s4 + s41);
        t97 = (s3 - s31);
        t08 = (s4 - s41);
        t18 = (t37 + t77);
        t28 = (t47 + t87);
        t38 = (t37 - t77);
        t48 = (t47 - t87);
        a15 = (a24 + 8);
        a25 = (a24 + 9);
        a35 = (a24 + 10);
        a45 = (a24 + 11);
        *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
        *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
        *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
        *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
        t58 = (t57 - t08);
        t68 = (t67 + t97);
        t78 = (t57 + t08);
        t88 = (t67 - t97);
        a55 = (a24 + 12);
        a65 = (a24 + 13);
        a75 = (a24 + 14);
        a85 = (a24 + 15);
        *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
        *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
        *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
        *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
        t98 = (t11 - t24);
        t09 = (t21 + t14);
        t19 = (t11 + t24);
        t29 = (t21 - t14);
        t39 = (s - s11);
        t49 = (s2 + s21);
        t59 = (s + s11);
        t69 = (s2 - s21);
        t79 = (t98 + t39);
        t89 = (t09 + t49);
        t99 = (t98 - t39);
        t0a = (t09 - t49);
        a95 = (a24 + 16);
        a06 = (a24 + 17);
        a16 = (a24 + 18);
        a26 = (a24 + 19);
        *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
        *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
        *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
        *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
        t1a = (t19 - t69);
        t2a = (t29 + t59);
        t3a = (t19 + t69);
        t4a = (t29 - t59);
        a36 = (a24 + 20);
        a46 = (a24 + 21);
        a56 = (a24 + 22);
        a66 = (a24 + 23);
        *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
        *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
        *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
        *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
        t5a = (t51 - s9);
        t6a = (t61 + s01);
        t7a = (t51 + s9);
        t8a = (t61 - s01);
        t9a = (s5 + s51);
        t0b = (s6 - s61);
        t1b = (s5 - s51);
        t2b = (s6 + s61);
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        a76 = (a24 + 24);
        a86 = (a24 + 25);
        a96 = (a24 + 26);
        a07 = (a24 + 27);
        *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
        *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
        *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
        *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
        t7b = (t7a - t2b);
        t8b = (t8a + t1b);
        t9b = (t7a + t2b);
        t0c = (t8a - t1b);
        a17 = (a24 + 28);
        a27 = (a24 + 29);
        a37 = (a24 + 30);
        a47 = (a24 + 31);
        *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
        *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
        *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
        *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        a57 = (2*i2);
        a67 = (T + a57);
        a77 = (a67 + 1);
        a87 = (a67 + 256);
        a97 = (a67 + 257);
        t1c = (*(a67) + *(a87));
        t2c = (*(a77) + *(a97));
        t3c = (*(a67) - *(a87));
        t4c = (*(a77) - *(a97));
        a08 = (a67 + 128);
        a18 = (a67 + 129);
        a28 = (a67 + 384);
        a38 = (a67 + 385);
        t5c = (*(a08) + *(a28));
        t6c = (*(a18) + *(a38));
        t7c = (*(a08) - *(a28));
        t8c = (*(a18) - *(a38));
        t9c = (t1c + t5c);
        t0d = (t2c + t6c);
        t1d = (t1c - t5c);
        t2d = (t2c - t6c);
        t3d = (t3c - t8c);
        t4d = (t4c + t7c);
        t5d = (t3c + t8c);
        t6d = (t4c - t7c);
        a48 = (a67 + 32);
        a58 = (a67 + 33);
        a68 = (a67 + 288);
        a78 = (a67 + 289);
        t7d = (*(a48) + *(a68));
        t8d = (*(a58) + *(a78));
        t9d = (*(a48) - *(a68));
        t0e = (*(a58) - *(a78));
        a88 = (a67 + 160);
        a98 = (a67 + 161);
        a09 = (a67 + 416);
        a19 = (a67 + 417);
        t1e = (*(a88) + *(a09));
        t2e = (*(a98) + *(a19));
        t3e = (*(a88) - *(a09));
        t4e = (*(a98) - *(a19));
        t5e = (t7d + t1e);
        t6e = (t8d + t2e);
        a29 = (0.70710678118654757*(t7d - t1e));
        a39 = (0.70710678118654757*(t8d - t2e));
        s71 = (a29 - a39);
        s81 = (a29 + a39);
        t7e = (t9d - t4e);
        t8e = (t0e + t3e);
        t9e = (t9d + t4e);
        t0f = (t0e - t3e);
        s91 = ((0.92387953251128674*t7e) - (0.38268343236508978*t8e));
        s02 = ((0.38268343236508978*t7e) + (0.92387953251128674*t8e));
        s12 = ((0.38268343236508978*t9e) - (0.92387953251128674*t0f));
        s22 = ((0.92387953251128674*t9e) + (0.38268343236508978*t0f));
        a49 = (a67 + 64);
        a59 = (a67 + 65);
        a69 = (a67 + 320);
        a79 = (a67 + 321);
        t1f = (*(a49) + *(a69));
        t2f = (*(a59) + *(a79));
        t3f = (*(a49) - *(a69));
        t4f = (*(a59) - *(a79));
        a89 = (a67 + 192);
        a99 = (a67 + 193);
        a0a = (a67 + 448);
        a1a = (a67 + 449);
        t5f = (*(a89) + *(a0a));
        t6f = (*(a99) + *(a1a));
        t7f = (*(a89) - *(a0a));
        t8f = (*(a99) - *(a1a));
        t9f = (t1f + t5f);
        t0g = (t2f + t6f);
        t1g = (t1f - t5f);
        t2g = (t2f - t6f);
        a2a = (0.70710678118654757*(t3f - t8f));
        a3a = (0.70710678118654757*(t4f + t7f));
        s32 = (a2a - a3a);
        s42 = (a2a + a3a);
        a4a = (0.70710678118654757*(t3f + t8f));
        a5a = (0.70710678118654757*(t4f - t7f));
        s52 = (a4a + a5a);
        s62 = (a4a - a5a);
        a6a = (a67 + 96);
        a7a = (a67 + 97);
        a8a = (a67 + 352);
        a9a = (a67 + 353);
        t3g = (*(a6a) + *(a8a));
        t4g = (*(a7a) + *(a9a));
        t5g = (*(a6a) - *(a8a));
        t6g = (*(a7a) - *(a9a));
        a0b = (a67 + 224);
        a1b = (a67 + 225);
        a2b = (a67 + 480);
        a3b = (a67 + 481);
        t7g = (*(a0b) + *(a2b));
        t8g = (*(a1b) + *(a3b));
        t9g = (*(a0b) - *(a2b));
        t0h = (*(a1b) - *(a3b));
        t1h = (t3g + t7g);
        t2h = (t4g + t8g);
        a4b = (0.70710678118654757*(t3g - t7g));
        a5b = (0.70710678118654757*(t4g - t8g));
        s72 = (a4b + a5b);
        s82 = (a4b - a5b);
        t3h = (t5g - t0h);
        t4h = (t6g + t9g);
        t5h = (t5g + t0h);
        t6h = (t6g - t9g);
        s92 = ((0.38268343236508978*t3h) - (0.92387953251128674*t4h));
        s03 = ((0.92387953251128674*t3h) + (0.38268343236508978*t4h));
        s13 = ((0.38268343236508978*t6h) - (0.92387953251128674*t5h));
        s23 = ((0.38268343236508978*t5h) + (0.92387953251128674*t6h));
        t7h = (t9c + t9f);
        t8h = (t0d + t0g);
        t9h = (t9c - t9f);
        t0i = (t0d - t0g);
        t1i = (t5e + t1h);
        t2i = (t6e + t2h);
        t3i = (t5e - t1h);
        t4i = (t6e - t2h);
        a6b = (dst + a57);
        *(a6b) = (t7h + t1i);
        *((a6b + 1)) = (t8h + t2i);
        *((a6b + 256)) = (t7h - t1i);
        *((a6b + 257)) = (t8h - t2i);
        *((a6b + 128)) = (t9h - t4i);
        *((a6b + 129)) = (t0i + t3i);
        *((a6b + 384)) = (t9h + t4i);
        *((a6b + 385)) = (t0i - t3i);
        t5i = (t3d + s32);
        t6i = (t4d + s42);
        t7i = (t3d - s32);
        t8i = (t4d - s42);
        t9i = (s91 + s92);
        t0j = (s02 + s03);
        t1j = (s91 - s92);
        t2j = (s02 - s03);
        *((a6b + 32)) = (t5i + t9i);
        *((a6b + 33)) = (t6i + t0j);
        *((a6b + 288)) = (t5i - t9i);
        *((a6b + 289)) = (t6i - t0j);
        *((a6b + 160)) = (t7i - t2j);
        *((a6b + 161)) = (t8i + t1j);
        *((a6b + 416)) = (t7i + t2j);
        *((a6b + 417)) = (t8i - t1j);
        t3j = (t1d - t2g);
        t4j = (t2d + t1g);
        t5j = (t1d + t2g);
        t6j = (t2d - t1g);
        t7j = (s71 - s72);
        t8j = (s81 + s82);
        t9j = (s71 + s72);
        t0k = (s81 - s82);
        *((a6b + 64)) = (t3j + t7j);
        *((a6b + 65)) = (t4j + t8j);
        *((a6b + 320)) = (t3j - t7j);
        *((a6b + 321)) = (t4j - t8j);
        *((a6b + 192)) = (t5j - t0k);
        *((a6b + 193)) = (t6j + t9j);
        *((a6b + 448)) = (t5j + t0k);
        *((a6b + 449)) = (t6j - t9j);
        t1k = (t5d - s52);
        t2k = (t6d + s62);
        t3k = (t5d + s52);
        t4k = (t6d - s62);
        t5k = (s12 + s13);
        t6k = (s22 - s23);
        t7k = (s12 - s13);
        t8k = (s22 + s23);
        *((a6b + 96)) = (t1k + t5k);
        *((a6b + 97)) = (t2k + t6k);
        *((a6b + 352)) = (t1k - t5k);
        *((a6b + 353)) = (t2k - t6k);
        *((a6b + 224)) = (t3k - t8k);
        *((a6b + 225)) = (t4k + t7k);
        *((a6b + 480)) = (t3k + t8k);
        *((a6b + 481)) = (t4k - t7k);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_double_512)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[1024];
    double  *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0g, *a0h, *a0i, *a0j, *a19, *a1a, *a1b, *a1c, *a1d, *a1e, *a1f, *a1g, *a1h, *a1i, *a1j
            , *a29, *a2a, *a2b, *a2c, *a2d, *a2e, *a2f, *a2g, *a2j, *a39, *a3a, *a3b, *a3c, *a3d, *a3e, *a3f, *a3g, *a3j, *a49, *a4a, *a4b, *a4c
            , *a4d, *a4e, *a4f, *a4g, *a4h, *a59, *a5a, *a5b, *a5c, *a5d, *a5e, *a5g, *a5h, *a69, *a6a, *a6b, *a6c, *a6d, *a6e, *a6f, *a6g, *a6h
            , *a6i, *a6j, *a79, *a7a, *a7b, *a7c, *a7d, *a7e, *a7f, *a7g, *a7h, *a7i, *a89, *a8a, *a8b, *a8c, *a8d, *a8e, *a8f, *a8g, *a8h, *a8i
            , *a99, *a9a, *a9b, *a9c, *a9d, *a9e, *a9f, *a9g, *a9h, *a9i;
    const double  *a, *a01, *a03, *a05, *a07, *a08, *a11, *a12, *a13, *a15, *a17, *a18, *a2, *a21, *a22, *a23, *a25, *a27, *a28, *a3, *a31, *a32
            , *a33, *a34, *a35, *a37, *a4, *a41, *a42, *a43, *a44, *a45, *a47, *a5, *a51, *a52, *a53, *a54, *a55, *a57, *a6, *a61, *a62, *a63
            , *a64, *a65, *a67, *a7, *a72, *a74, *a75, *a76, *a77, *a8, *a82, *a84, *a85, *a86, *a87, *a9, *a92, *a94, *a96, *a97;
    int a5f, a98;
    double a02, a04, a06, a14, a16, a24, a26, a2h, a2i, a36, a38, a3h, a3i, a46, a48, a4i, a4j, a56, a58, a5i, a5j, a66
            , a68, a71, a73, a78, a81, a83, a88, a91, a93, a95, s, s01, s02, s03, s04, s05, s06, s07, s11, s12, s13, s14
            , s15, s16, s17, s2, s21, s22, s23, s24, s25, s26, s27, s3, s31, s32, s33, s34, s35, s36, s4, s41, s42, s43
            , s44, s45, s46, s5, s51, s52, s53, s54, s55, s56, s6, s61, s62, s63, s64, s65, s66, s7, s71, s72, s73, s74
            , s75, s76, s8, s81, s82, s83, s84, s85, s86, s9, s91, s92, s93, s94, s95, s96, t, t01, t02, t03, t04, t05
            , t06, t07, t08, t09, t0A, t0B, t0C, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o
            , t0p, t0q, t0r, t0s, t0t, t0u, t0v, t0w, t0x, t0y, t0z, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1A, t1B
            , t1C, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t, t1u
            , t1v, t1w, t1x, t1y, t1z, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2A, t2B, t2C, t2a, t2b, t2c, t2d
            , t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p, t2q, t2r, t2s, t2t, t2u, t2v, t2w, t2x, t2y, t2z
            , t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3A, t3B, t3C, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i
            , t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s, t3t, t3u, t3v, t3w, t3x, t3y, t3z, t4, t41, t42, t43, t44
            , t45, t46, t47, t48, t49, t4A, t4B, t4C, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n
            , t4o, t4p, t4q, t4r, t4s, t4t, t4u, t4v, t4w, t4x, t4y, t4z, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59
            , t5A, t5B, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t5r, t5s, t5t
            , t5u, t5v, t5w, t5x, t5y, t5z, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6A, t6B, t6a, t6b, t6c, t6d
            , t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r, t6s, t6t, t6u, t6v, t6w, t6x, t6y, t6z
            , t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7A, t7B, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j
            , t7k, t7l, t7m, t7n, t7o, t7p, t7q, t7r, t7s, t7t, t7u, t7v, t7w, t7x, t7y, t7z, t8, t81, t82, t83, t84, t85
            , t86, t87, t88, t89, t8A, t8B, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p
            , t8q, t8r, t8s, t8t, t8u, t8v, t8w, t8x, t8y, t8z, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9A, t9B
            , t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p, t9q, t9r, t9s, t9t, t9u, t9v
            , t9w, t9x, t9y, t9z;
    {long i; for(i = 0; i <= 15; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 512);
        a4 = (a + 513);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 256);
        a6 = (a + 257);
        a7 = (a + 768);
        a8 = (a + 769);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 - t8);
        t41 = (t4 + t7);
        t51 = (t3 + t8);
        t61 = (t4 - t7);
        a9 = (a + 128);
        a01 = (a + 129);
        a11 = (a + 640);
        a21 = (a + 641);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 384);
        a41 = (a + 385);
        a51 = (a + 896);
        a61 = (a + 897);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        t72 = (t71 - t12);
        t82 = (t81 - t22);
        a71 = (0.70710678118654757*(t91 - t42));
        a81 = (0.70710678118654757*(t02 + t32));
        s = (a71 - a81);
        s2 = (a71 + a81);
        a91 = (0.70710678118654757*(t91 + t42));
        a02 = (0.70710678118654757*(t02 - t32));
        s3 = (a91 + a02);
        s4 = (a91 - a02);
        t92 = (t9 + t52);
        t03 = (t01 + t62);
        t13 = (t9 - t52);
        t23 = (t01 - t62);
        t33 = (t31 + s);
        t43 = (t41 + s2);
        t53 = (t31 - s);
        t63 = (t41 - s2);
        t73 = (t11 - t82);
        t83 = (t21 + t72);
        t93 = (t11 + t82);
        t04 = (t21 - t72);
        t14 = (t51 - s3);
        t24 = (t61 + s4);
        t34 = (t51 + s3);
        t44 = (t61 - s4);
        a12 = (a + 32);
        a22 = (a + 33);
        a32 = (a + 544);
        a42 = (a + 545);
        t54 = (*(a12) + *(a32));
        t64 = (*(a22) + *(a42));
        t74 = (*(a12) - *(a32));
        t84 = (*(a22) - *(a42));
        a52 = (a + 288);
        a62 = (a + 289);
        a72 = (a + 800);
        a82 = (a + 801);
        t94 = (*(a52) + *(a72));
        t05 = (*(a62) + *(a82));
        t15 = (*(a52) - *(a72));
        t25 = (*(a62) - *(a82));
        t35 = (t54 + t94);
        t45 = (t64 + t05);
        t55 = (t54 - t94);
        t65 = (t64 - t05);
        t75 = (t74 - t25);
        t85 = (t84 + t15);
        t95 = (t74 + t25);
        t06 = (t84 - t15);
        a92 = (a + 160);
        a03 = (a + 161);
        a13 = (a + 672);
        a23 = (a + 673);
        t16 = (*(a92) + *(a13));
        t26 = (*(a03) + *(a23));
        t36 = (*(a92) - *(a13));
        t46 = (*(a03) - *(a23));
        a33 = (a + 416);
        a43 = (a + 417);
        a53 = (a + 928);
        a63 = (a + 929);
        t56 = (*(a33) + *(a53));
        t66 = (*(a43) + *(a63));
        t76 = (*(a33) - *(a53));
        t86 = (*(a43) - *(a63));
        t96 = (t16 + t56);
        t07 = (t26 + t66);
        t17 = (t16 - t56);
        t27 = (t26 - t66);
        a73 = (0.70710678118654757*(t36 - t86));
        a83 = (0.70710678118654757*(t46 + t76));
        s5 = (a73 - a83);
        s6 = (a73 + a83);
        a93 = (0.70710678118654757*(t36 + t86));
        a04 = (0.70710678118654757*(t46 - t76));
        s7 = (a93 + a04);
        s8 = (a93 - a04);
        t37 = (t35 + t96);
        t47 = (t45 + t07);
        a14 = (0.70710678118654757*(t35 - t96));
        a24 = (0.70710678118654757*(t45 - t07));
        s9 = (a14 - a24);
        s01 = (a14 + a24);
        t57 = (t75 + s5);
        t67 = (t85 + s6);
        t77 = (t75 - s5);
        t87 = (t85 - s6);
        s11 = ((0.98078528040323043*t57) - (0.19509032201612828*t67));
        s21 = ((0.19509032201612828*t57) + (0.98078528040323043*t67));
        s31 = ((0.55557023301960218*t77) - (0.83146961230254524*t87));
        s41 = ((0.83146961230254524*t77) + (0.55557023301960218*t87));
        t97 = (t55 - t27);
        t08 = (t65 + t17);
        t18 = (t55 + t27);
        t28 = (t65 - t17);
        s51 = ((0.92387953251128674*t97) - (0.38268343236508978*t08));
        s61 = ((0.38268343236508978*t97) + (0.92387953251128674*t08));
        s71 = ((0.38268343236508978*t18) - (0.92387953251128674*t28));
        s81 = ((0.92387953251128674*t18) + (0.38268343236508978*t28));
        t38 = (t95 - s7);
        t48 = (t06 + s8);
        t58 = (t95 + s7);
        t68 = (t06 - s8);
        s91 = ((0.83146961230254524*t38) - (0.55557023301960218*t48));
        s02 = ((0.55557023301960218*t38) + (0.83146961230254524*t48));
        s12 = ((0.19509032201612828*t58) - (0.98078528040323043*t68));
        s22 = ((0.98078528040323043*t58) + (0.19509032201612828*t68));
        a34 = (a + 64);
        a44 = (a + 65);
        a54 = (a + 576);
        a64 = (a + 577);
        t78 = (*(a34) + *(a54));
        t88 = (*(a44) + *(a64));
        t98 = (*(a34) - *(a54));
        t09 = (*(a44) - *(a64));
        a74 = (a + 320);
        a84 = (a + 321);
        a94 = (a + 832);
        a05 = (a + 833);
        t19 = (*(a74) + *(a94));
        t29 = (*(a84) + *(a05));
        t39 = (*(a74) - *(a94));
        t49 = (*(a84) - *(a05));
        t59 = (t78 + t19);
        t69 = (t88 + t29);
        t79 = (t78 - t19);
        t89 = (t88 - t29);
        t99 = (t98 - t49);
        t0a = (t09 + t39);
        t1a = (t98 + t49);
        t2a = (t09 - t39);
        a15 = (a + 192);
        a25 = (a + 193);
        a35 = (a + 704);
        a45 = (a + 705);
        t3a = (*(a15) + *(a35));
        t4a = (*(a25) + *(a45));
        t5a = (*(a15) - *(a35));
        t6a = (*(a25) - *(a45));
        a55 = (a + 448);
        a65 = (a + 449);
        a75 = (a + 960);
        a85 = (a + 961);
        t7a = (*(a55) + *(a75));
        t8a = (*(a65) + *(a85));
        t9a = (*(a55) - *(a75));
        t0b = (*(a65) - *(a85));
        t1b = (t3a + t7a);
        t2b = (t4a + t8a);
        t3b = (t3a - t7a);
        t4b = (t4a - t8a);
        a95 = (0.70710678118654757*(t5a - t0b));
        a06 = (0.70710678118654757*(t6a + t9a));
        s32 = (a95 - a06);
        s42 = (a95 + a06);
        a16 = (0.70710678118654757*(t5a + t0b));
        a26 = (0.70710678118654757*(t6a - t9a));
        s52 = (a16 + a26);
        s62 = (a16 - a26);
        t5b = (t59 + t1b);
        t6b = (t69 + t2b);
        t7b = (t59 - t1b);
        t8b = (t69 - t2b);
        t9b = (t99 + s32);
        t0c = (t0a + s42);
        t1c = (t99 - s32);
        t2c = (t0a - s42);
        s72 = ((0.92387953251128674*t9b) - (0.38268343236508978*t0c));
        s82 = ((0.38268343236508978*t9b) + (0.92387953251128674*t0c));
        s92 = ((0.38268343236508978*t1c) + (0.92387953251128674*t2c));
        s03 = ((0.92387953251128674*t1c) - (0.38268343236508978*t2c));
        a36 = (0.70710678118654757*(t79 - t4b));
        a46 = (0.70710678118654757*(t89 + t3b));
        s13 = (a36 - a46);
        s23 = (a36 + a46);
        a56 = (0.70710678118654757*(t79 + t4b));
        a66 = (0.70710678118654757*(t89 - t3b));
        s33 = (a56 + a66);
        s43 = (a56 - a66);
        t3c = (t1a - s52);
        t4c = (t2a + s62);
        t5c = (t1a + s52);
        t6c = (t2a - s62);
        s53 = ((0.38268343236508978*t3c) - (0.92387953251128674*t4c));
        s63 = ((0.92387953251128674*t3c) + (0.38268343236508978*t4c));
        s73 = ((0.92387953251128674*t5c) + (0.38268343236508978*t6c));
        s83 = ((0.38268343236508978*t5c) - (0.92387953251128674*t6c));
        a76 = (a + 96);
        a86 = (a + 97);
        a96 = (a + 608);
        a07 = (a + 609);
        t7c = (*(a76) + *(a96));
        t8c = (*(a86) + *(a07));
        t9c = (*(a76) - *(a96));
        t0d = (*(a86) - *(a07));
        a17 = (a + 352);
        a27 = (a + 353);
        a37 = (a + 864);
        a47 = (a + 865);
        t1d = (*(a17) + *(a37));
        t2d = (*(a27) + *(a47));
        t3d = (*(a17) - *(a37));
        t4d = (*(a27) - *(a47));
        t5d = (t7c + t1d);
        t6d = (t8c + t2d);
        t7d = (t7c - t1d);
        t8d = (t8c - t2d);
        t9d = (t9c - t4d);
        t0e = (t0d + t3d);
        t1e = (t9c + t4d);
        t2e = (t0d - t3d);
        a57 = (a + 224);
        a67 = (a + 225);
        a77 = (a + 736);
        a87 = (a + 737);
        t3e = (*(a57) + *(a77));
        t4e = (*(a67) + *(a87));
        t5e = (*(a57) - *(a77));
        t6e = (*(a67) - *(a87));
        a97 = (a + 480);
        a08 = (a + 481);
        a18 = (a + 992);
        a28 = (a + 993);
        t7e = (*(a97) + *(a18));
        t8e = (*(a08) + *(a28));
        t9e = (*(a97) - *(a18));
        t0f = (*(a08) - *(a28));
        t1f = (t3e + t7e);
        t2f = (t4e + t8e);
        t3f = (t3e - t7e);
        t4f = (t4e - t8e);
        a38 = (0.70710678118654757*(t5e - t0f));
        a48 = (0.70710678118654757*(t6e + t9e));
        s93 = (a38 - a48);
        s04 = (a38 + a48);
        a58 = (0.70710678118654757*(t5e + t0f));
        a68 = (0.70710678118654757*(t6e - t9e));
        s14 = (a58 + a68);
        s24 = (a58 - a68);
        t5f = (t5d + t1f);
        t6f = (t6d + t2f);
        a78 = (0.70710678118654757*(t5d - t1f));
        a88 = (0.70710678118654757*(t6d - t2f));
        s34 = (a78 + a88);
        s44 = (a78 - a88);
        t7f = (t9d + s93);
        t8f = (t0e + s04);
        t9f = (t9d - s93);
        t0g = (t0e - s04);
        s54 = ((0.83146961230254524*t7f) - (0.55557023301960218*t8f));
        s64 = ((0.55557023301960218*t7f) + (0.83146961230254524*t8f));
        s74 = ((0.98078528040323043*t9f) + (0.19509032201612828*t0g));
        s84 = ((0.19509032201612828*t9f) - (0.98078528040323043*t0g));
        t1g = (t7d - t4f);
        t2g = (t8d + t3f);
        t3g = (t7d + t4f);
        t4g = (t8d - t3f);
        s94 = ((0.38268343236508978*t1g) - (0.92387953251128674*t2g));
        s05 = ((0.92387953251128674*t1g) + (0.38268343236508978*t2g));
        s15 = ((0.38268343236508978*t4g) - (0.92387953251128674*t3g));
        s25 = ((0.38268343236508978*t3g) + (0.92387953251128674*t4g));
        t5g = (t1e - s14);
        t6g = (t2e + s24);
        t7g = (t1e + s14);
        t8g = (t2e - s24);
        s35 = ((0.19509032201612828*t5g) + (0.98078528040323043*t6g));
        s45 = ((0.98078528040323043*t5g) - (0.19509032201612828*t6g));
        s55 = ((0.83146961230254524*t8g) - (0.55557023301960218*t7g));
        s65 = ((0.83146961230254524*t7g) + (0.55557023301960218*t8g));
        t9g = (t92 + t5b);
        t0h = (t03 + t6b);
        t1h = (t92 - t5b);
        t2h = (t03 - t6b);
        t3h = (t37 + t5f);
        t4h = (t47 + t6f);
        t5h = (t37 - t5f);
        t6h = (t47 - t6f);
        t7h = (t9g + t3h);
        t8h = (t0h + t4h);
        t9h = (t9g - t3h);
        t0i = (t0h - t4h);
        a98 = (64*i);
        a09 = (D286 + a98);
        a19 = (a09 + 1);
        a29 = (a09 + 2);
        a39 = (a09 + 3);
        a49 = (T + a98);
        *(a49) = ((*(a09)*t7h) - (*(a19)*t8h));
        *((a49 + 1)) = ((*(a19)*t7h) + (*(a09)*t8h));
        *((a49 + 32)) = ((*(a29)*t9h) - (*(a39)*t0i));
        *((a49 + 33)) = ((*(a39)*t9h) + (*(a29)*t0i));
        t1i = (t1h - t6h);
        t2i = (t2h + t5h);
        t3i = (t1h + t6h);
        t4i = (t2h - t5h);
        a59 = (a09 + 4);
        a69 = (a09 + 5);
        a79 = (a09 + 6);
        a89 = (a09 + 7);
        *((a49 + 16)) = ((*(a59)*t1i) - (*(a69)*t2i));
        *((a49 + 17)) = ((*(a69)*t1i) + (*(a59)*t2i));
        *((a49 + 48)) = ((*(a79)*t3i) - (*(a89)*t4i));
        *((a49 + 49)) = ((*(a89)*t3i) + (*(a79)*t4i));
        t5i = (t33 + s72);
        t6i = (t43 + s82);
        t7i = (t33 - s72);
        t8i = (t43 - s82);
        t9i = (s11 + s54);
        t0j = (s21 + s64);
        t1j = (s11 - s54);
        t2j = (s21 - s64);
        t3j = (t5i + t9i);
        t4j = (t6i + t0j);
        t5j = (t5i - t9i);
        t6j = (t6i - t0j);
        a99 = (a09 + 8);
        a0a = (a09 + 9);
        a1a = (a09 + 10);
        a2a = (a09 + 11);
        *((a49 + 2)) = ((*(a99)*t3j) - (*(a0a)*t4j));
        *((a49 + 3)) = ((*(a0a)*t3j) + (*(a99)*t4j));
        *((a49 + 34)) = ((*(a1a)*t5j) - (*(a2a)*t6j));
        *((a49 + 35)) = ((*(a2a)*t5j) + (*(a1a)*t6j));
        t7j = (t7i - t2j);
        t8j = (t8i + t1j);
        t9j = (t7i + t2j);
        t0k = (t8i - t1j);
        a3a = (a09 + 12);
        a4a = (a09 + 13);
        a5a = (a09 + 14);
        a6a = (a09 + 15);
        *((a49 + 18)) = ((*(a3a)*t7j) - (*(a4a)*t8j));
        *((a49 + 19)) = ((*(a4a)*t7j) + (*(a3a)*t8j));
        *((a49 + 50)) = ((*(a5a)*t9j) - (*(a6a)*t0k));
        *((a49 + 51)) = ((*(a6a)*t9j) + (*(a5a)*t0k));
        t1k = (t73 + s13);
        t2k = (t83 + s23);
        t3k = (t73 - s13);
        t4k = (t83 - s23);
        t5k = (s51 + s94);
        t6k = (s61 + s05);
        t7k = (s51 - s94);
        t8k = (s61 - s05);
        t9k = (t1k + t5k);
        t0l = (t2k + t6k);
        t1l = (t1k - t5k);
        t2l = (t2k - t6k);
        a7a = (a09 + 16);
        a8a = (a09 + 17);
        a9a = (a09 + 18);
        a0b = (a09 + 19);
        *((a49 + 4)) = ((*(a7a)*t9k) - (*(a8a)*t0l));
        *((a49 + 5)) = ((*(a8a)*t9k) + (*(a7a)*t0l));
        *((a49 + 36)) = ((*(a9a)*t1l) - (*(a0b)*t2l));
        *((a49 + 37)) = ((*(a0b)*t1l) + (*(a9a)*t2l));
        t3l = (t3k - t8k);
        t4l = (t4k + t7k);
        t5l = (t3k + t8k);
        t6l = (t4k - t7k);
        a1b = (a09 + 20);
        a2b = (a09 + 21);
        a3b = (a09 + 22);
        a4b = (a09 + 23);
        *((a49 + 20)) = ((*(a1b)*t3l) - (*(a2b)*t4l));
        *((a49 + 21)) = ((*(a2b)*t3l) + (*(a1b)*t4l));
        *((a49 + 52)) = ((*(a3b)*t5l) - (*(a4b)*t6l));
        *((a49 + 53)) = ((*(a4b)*t5l) + (*(a3b)*t6l));
        t7l = (t14 + s53);
        t8l = (t24 + s63);
        t9l = (t14 - s53);
        t0m = (t24 - s63);
        t1m = (s91 - s35);
        t2m = (s02 + s45);
        t3m = (s91 + s35);
        t4m = (s02 - s45);
        t5m = (t7l + t1m);
        t6m = (t8l + t2m);
        t7m = (t7l - t1m);
        t8m = (t8l - t2m);
        a5b = (a09 + 24);
        a6b = (a09 + 25);
        a7b = (a09 + 26);
        a8b = (a09 + 27);
        *((a49 + 6)) = ((*(a5b)*t5m) - (*(a6b)*t6m));
        *((a49 + 7)) = ((*(a6b)*t5m) + (*(a5b)*t6m));
        *((a49 + 38)) = ((*(a7b)*t7m) - (*(a8b)*t8m));
        *((a49 + 39)) = ((*(a8b)*t7m) + (*(a7b)*t8m));
        t9m = (t9l - t4m);
        t0n = (t0m + t3m);
        t1n = (t9l + t4m);
        t2n = (t0m - t3m);
        a9b = (a09 + 28);
        a0c = (a09 + 29);
        a1c = (a09 + 30);
        a2c = (a09 + 31);
        *((a49 + 22)) = ((*(a9b)*t9m) - (*(a0c)*t0n));
        *((a49 + 23)) = ((*(a0c)*t9m) + (*(a9b)*t0n));
        *((a49 + 54)) = ((*(a1c)*t1n) - (*(a2c)*t2n));
        *((a49 + 55)) = ((*(a2c)*t1n) + (*(a1c)*t2n));
        t3n = (t13 - t8b);
        t4n = (t23 + t7b);
        t5n = (t13 + t8b);
        t6n = (t23 - t7b);
        t7n = (s9 - s34);
        t8n = (s01 + s44);
        t9n = (s9 + s34);
        t0o = (s01 - s44);
        t1o = (t3n + t7n);
        t2o = (t4n + t8n);
        t3o = (t3n - t7n);
        t4o = (t4n - t8n);
        a3c = (a09 + 32);
        a4c = (a09 + 33);
        a5c = (a09 + 34);
        a6c = (a09 + 35);
        *((a49 + 8)) = ((*(a3c)*t1o) - (*(a4c)*t2o));
        *((a49 + 9)) = ((*(a4c)*t1o) + (*(a3c)*t2o));
        *((a49 + 40)) = ((*(a5c)*t3o) - (*(a6c)*t4o));
        *((a49 + 41)) = ((*(a6c)*t3o) + (*(a5c)*t4o));
        t5o = (t5n - t0o);
        t6o = (t6n + t9n);
        t7o = (t5n + t0o);
        t8o = (t6n - t9n);
        a7c = (a09 + 36);
        a8c = (a09 + 37);
        a9c = (a09 + 38);
        a0d = (a09 + 39);
        *((a49 + 24)) = ((*(a7c)*t5o) - (*(a8c)*t6o));
        *((a49 + 25)) = ((*(a8c)*t5o) + (*(a7c)*t6o));
        *((a49 + 56)) = ((*(a9c)*t7o) - (*(a0d)*t8o));
        *((a49 + 57)) = ((*(a0d)*t7o) + (*(a9c)*t8o));
        t9o = (t53 - s92);
        t0p = (t63 + s03);
        t1p = (t53 + s92);
        t2p = (t63 - s03);
        t3p = (s31 - s74);
        t4p = (s41 + s84);
        t5p = (s31 + s74);
        t6p = (s41 - s84);
        t7p = (t9o + t3p);
        t8p = (t0p + t4p);
        t9p = (t9o - t3p);
        t0q = (t0p - t4p);
        a1d = (a09 + 40);
        a2d = (a09 + 41);
        a3d = (a09 + 42);
        a4d = (a09 + 43);
        *((a49 + 10)) = ((*(a1d)*t7p) - (*(a2d)*t8p));
        *((a49 + 11)) = ((*(a2d)*t7p) + (*(a1d)*t8p));
        *((a49 + 42)) = ((*(a3d)*t9p) - (*(a4d)*t0q));
        *((a49 + 43)) = ((*(a4d)*t9p) + (*(a3d)*t0q));
        t1q = (t1p - t6p);
        t2q = (t2p + t5p);
        t3q = (t1p + t6p);
        t4q = (t2p - t5p);
        a5d = (a09 + 44);
        a6d = (a09 + 45);
        a7d = (a09 + 46);
        a8d = (a09 + 47);
        *((a49 + 26)) = ((*(a5d)*t1q) - (*(a6d)*t2q));
        *((a49 + 27)) = ((*(a6d)*t1q) + (*(a5d)*t2q));
        *((a49 + 58)) = ((*(a7d)*t3q) - (*(a8d)*t4q));
        *((a49 + 59)) = ((*(a8d)*t3q) + (*(a7d)*t4q));
        t5q = (t93 - s33);
        t6q = (t04 + s43);
        t7q = (t93 + s33);
        t8q = (t04 - s43);
        t9q = (s71 + s15);
        t0r = (s81 - s25);
        t1r = (s71 - s15);
        t2r = (s81 + s25);
        t3r = (t5q + t9q);
        t4r = (t6q + t0r);
        t5r = (t5q - t9q);
        t6r = (t6q - t0r);
        a9d = (a09 + 48);
        a0e = (a09 + 49);
        a1e = (a09 + 50);
        a2e = (a09 + 51);
        *((a49 + 12)) = ((*(a9d)*t3r) - (*(a0e)*t4r));
        *((a49 + 13)) = ((*(a0e)*t3r) + (*(a9d)*t4r));
        *((a49 + 44)) = ((*(a1e)*t5r) - (*(a2e)*t6r));
        *((a49 + 45)) = ((*(a2e)*t5r) + (*(a1e)*t6r));
        t7r = (t7q - t2r);
        t8r = (t8q + t1r);
        t9r = (t7q + t2r);
        t0s = (t8q - t1r);
        a3e = (a09 + 52);
        a4e = (a09 + 53);
        a5e = (a09 + 54);
        a6e = (a09 + 55);
        *((a49 + 28)) = ((*(a3e)*t7r) - (*(a4e)*t8r));
        *((a49 + 29)) = ((*(a4e)*t7r) + (*(a3e)*t8r));
        *((a49 + 60)) = ((*(a5e)*t9r) - (*(a6e)*t0s));
        *((a49 + 61)) = ((*(a6e)*t9r) + (*(a5e)*t0s));
        t1s = (t34 - s73);
        t2s = (t44 + s83);
        t3s = (t34 + s73);
        t4s = (t44 - s83);
        t5s = (s12 + s55);
        t6s = (s22 - s65);
        t7s = (s12 - s55);
        t8s = (s22 + s65);
        t9s = (t1s + t5s);
        t0t = (t2s + t6s);
        t1t = (t1s - t5s);
        t2t = (t2s - t6s);
        a7e = (a09 + 56);
        a8e = (a09 + 57);
        a9e = (a09 + 58);
        a0f = (a09 + 59);
        *((a49 + 14)) = ((*(a7e)*t9s) - (*(a8e)*t0t));
        *((a49 + 15)) = ((*(a8e)*t9s) + (*(a7e)*t0t));
        *((a49 + 46)) = ((*(a9e)*t1t) - (*(a0f)*t2t));
        *((a49 + 47)) = ((*(a0f)*t1t) + (*(a9e)*t2t));
        t3t = (t3s - t8s);
        t4t = (t4s + t7s);
        t5t = (t3s + t8s);
        t6t = (t4s - t7s);
        a1f = (a09 + 60);
        a2f = (a09 + 61);
        a3f = (a09 + 62);
        a4f = (a09 + 63);
        *((a49 + 30)) = ((*(a1f)*t3t) - (*(a2f)*t4t));
        *((a49 + 31)) = ((*(a2f)*t3t) + (*(a1f)*t4t));
        *((a49 + 62)) = ((*(a3f)*t5t) - (*(a4f)*t6t));
        *((a49 + 63)) = ((*(a4f)*t5t) + (*(a3f)*t6t));
    }}
    {long i2; for(i2 = 0; i2 <= 31; i2++) {
        a5f = (2*i2);
        a6f = (T + a5f);
        a7f = (a6f + 1);
        a8f = (a6f + 512);
        a9f = (a6f + 513);
        t7t = (*(a6f) + *(a8f));
        t8t = (*(a7f) + *(a9f));
        t9t = (*(a6f) - *(a8f));
        t0u = (*(a7f) - *(a9f));
        a0g = (a6f + 256);
        a1g = (a6f + 257);
        a2g = (a6f + 768);
        a3g = (a6f + 769);
        t1u = (*(a0g) + *(a2g));
        t2u = (*(a1g) + *(a3g));
        t3u = (*(a0g) - *(a2g));
        t4u = (*(a1g) - *(a3g));
        t5u = (t7t + t1u);
        t6u = (t8t + t2u);
        t7u = (t7t - t1u);
        t8u = (t8t - t2u);
        t9u = (t9t - t4u);
        t0v = (t0u + t3u);
        t1v = (t9t + t4u);
        t2v = (t0u - t3u);
        a4g = (a6f + 64);
        a5g = (a6f + 65);
        a6g = (a6f + 576);
        a7g = (a6f + 577);
        t3v = (*(a4g) + *(a6g));
        t4v = (*(a5g) + *(a7g));
        t5v = (*(a4g) - *(a6g));
        t6v = (*(a5g) - *(a7g));
        a8g = (a6f + 320);
        a9g = (a6f + 321);
        a0h = (a6f + 832);
        a1h = (a6f + 833);
        t7v = (*(a8g) + *(a0h));
        t8v = (*(a9g) + *(a1h));
        t9v = (*(a8g) - *(a0h));
        t0w = (*(a9g) - *(a1h));
        t1w = (t3v + t7v);
        t2w = (t4v + t8v);
        a2h = (0.70710678118654757*(t3v - t7v));
        a3h = (0.70710678118654757*(t4v - t8v));
        s75 = (a2h - a3h);
        s85 = (a2h + a3h);
        t3w = (t5v - t0w);
        t4w = (t6v + t9v);
        t5w = (t5v + t0w);
        t6w = (t6v - t9v);
        s95 = ((0.92387953251128674*t3w) - (0.38268343236508978*t4w));
        s06 = ((0.38268343236508978*t3w) + (0.92387953251128674*t4w));
        s16 = ((0.38268343236508978*t5w) - (0.92387953251128674*t6w));
        s26 = ((0.92387953251128674*t5w) + (0.38268343236508978*t6w));
        a4h = (a6f + 128);
        a5h = (a6f + 129);
        a6h = (a6f + 640);
        a7h = (a6f + 641);
        t7w = (*(a4h) + *(a6h));
        t8w = (*(a5h) + *(a7h));
        t9w = (*(a4h) - *(a6h));
        t0x = (*(a5h) - *(a7h));
        a8h = (a6f + 384);
        a9h = (a6f + 385);
        a0i = (a6f + 896);
        a1i = (a6f + 897);
        t1x = (*(a8h) + *(a0i));
        t2x = (*(a9h) + *(a1i));
        t3x = (*(a8h) - *(a0i));
        t4x = (*(a9h) - *(a1i));
        t5x = (t7w + t1x);
        t6x = (t8w + t2x);
        t7x = (t7w - t1x);
        t8x = (t8w - t2x);
        a2i = (0.70710678118654757*(t9w - t4x));
        a3i = (0.70710678118654757*(t0x + t3x));
        s36 = (a2i - a3i);
        s46 = (a2i + a3i);
        a4i = (0.70710678118654757*(t9w + t4x));
        a5i = (0.70710678118654757*(t0x - t3x));
        s56 = (a4i + a5i);
        s66 = (a4i - a5i);
        a6i = (a6f + 192);
        a7i = (a6f + 193);
        a8i = (a6f + 704);
        a9i = (a6f + 705);
        t9x = (*(a6i) + *(a8i));
        t0y = (*(a7i) + *(a9i));
        t1y = (*(a6i) - *(a8i));
        t2y = (*(a7i) - *(a9i));
        a0j = (a6f + 448);
        a1j = (a6f + 449);
        a2j = (a6f + 960);
        a3j = (a6f + 961);
        t3y = (*(a0j) + *(a2j));
        t4y = (*(a1j) + *(a3j));
        t5y = (*(a0j) - *(a2j));
        t6y = (*(a1j) - *(a3j));
        t7y = (t9x + t3y);
        t8y = (t0y + t4y);
        a4j = (0.70710678118654757*(t9x - t3y));
        a5j = (0.70710678118654757*(t0y - t4y));
        s76 = (a4j + a5j);
        s86 = (a4j - a5j);
        t9y = (t1y - t6y);
        t0z = (t2y + t5y);
        t1z = (t1y + t6y);
        t2z = (t2y - t5y);
        s96 = ((0.38268343236508978*t9y) - (0.92387953251128674*t0z));
        s07 = ((0.92387953251128674*t9y) + (0.38268343236508978*t0z));
        s17 = ((0.38268343236508978*t2z) - (0.92387953251128674*t1z));
        s27 = ((0.38268343236508978*t1z) + (0.92387953251128674*t2z));
        t3z = (t5u + t5x);
        t4z = (t6u + t6x);
        t5z = (t5u - t5x);
        t6z = (t6u - t6x);
        t7z = (t1w + t7y);
        t8z = (t2w + t8y);
        t9z = (t1w - t7y);
        t0A = (t2w - t8y);
        a6j = (dst + a5f);
        *(a6j) = (t3z + t7z);
        *((a6j + 1)) = (t4z + t8z);
        *((a6j + 512)) = (t3z - t7z);
        *((a6j + 513)) = (t4z - t8z);
        *((a6j + 256)) = (t5z - t0A);
        *((a6j + 257)) = (t6z + t9z);
        *((a6j + 768)) = (t5z + t0A);
        *((a6j + 769)) = (t6z - t9z);
        t1A = (t9u + s36);
        t2A = (t0v + s46);
        t3A = (t9u - s36);
        t4A = (t0v - s46);
        t5A = (s95 + s96);
        t6A = (s06 + s07);
        t7A = (s95 - s96);
        t8A = (s06 - s07);
        *((a6j + 64)) = (t1A + t5A);
        *((a6j + 65)) = (t2A + t6A);
        *((a6j + 576)) = (t1A - t5A);
        *((a6j + 577)) = (t2A - t6A);
        *((a6j + 320)) = (t3A - t8A);
        *((a6j + 321)) = (t4A + t7A);
        *((a6j + 832)) = (t3A + t8A);
        *((a6j + 833)) = (t4A - t7A);
        t9A = (t7u - t8x);
        t0B = (t8u + t7x);
        t1B = (t7u + t8x);
        t2B = (t8u - t7x);
        t3B = (s75 - s76);
        t4B = (s85 + s86);
        t5B = (s75 + s76);
        t6B = (s85 - s86);
        *((a6j + 128)) = (t9A + t3B);
        *((a6j + 129)) = (t0B + t4B);
        *((a6j + 640)) = (t9A - t3B);
        *((a6j + 641)) = (t0B - t4B);
        *((a6j + 384)) = (t1B - t6B);
        *((a6j + 385)) = (t2B + t5B);
        *((a6j + 896)) = (t1B + t6B);
        *((a6j + 897)) = (t2B - t5B);
        t7B = (t1v - s56);
        t8B = (t2v + s66);
        t9B = (t1v + s56);
        t0C = (t2v - s66);
        t1C = (s16 + s17);
        t2C = (s26 - s27);
        t3C = (s16 - s17);
        t4C = (s26 + s27);
        *((a6j + 192)) = (t7B + t1C);
        *((a6j + 193)) = (t8B + t2C);
        *((a6j + 704)) = (t7B - t1C);
        *((a6j + 705)) = (t8B - t2C);
        *((a6j + 448)) = (t9B - t4C);
        *((a6j + 449)) = (t0C + t3C);
        *((a6j + 960)) = (t9B + t4C);
        *((a6j + 961)) = (t0C - t3C);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_double_1024)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[2048];
     double T2[128];
    double  *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a0c, *a15, *a16, *a17, *a18, *a1a, *a1b, *a1c, *a24, *a25, *a26, *a27, *a28, *a2a, *a2b
            , *a2c, *a34, *a35, *a36, *a37, *a38, *a3a, *a3b, *a3c, *a3d, *a44, *a45, *a46, *a47, *a48, *a4a, *a4b, *a4c, *a54, *a55, *a56, *a57
            , *a58, *a5a, *a5b, *a5c, *a64, *a65, *a66, *a67, *a68, *a69, *a6a, *a6b, *a6c, *a74, *a75, *a76, *a77, *a78, *a79, *a7a, *a7b, *a7c
            , *a84, *a85, *a86, *a87, *a88, *a89, *a8a, *a8b, *a8c, *a94, *a95, *a96, *a97, *a98, *a99, *a9a, *a9b;
    const double  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a59;
    double a03, a04, a0d, a19, a1d, a29, a2d, a39, a49, a71, a72, a81, a82, a92, a93, a9c, s, s01, s02, s11, s12, s2
            , s21, s22, s3, s31, s32, s4, s41, s42, s5, s51, s6, s61, s7, s71, s8, s81, s9, s91, t, t01, t02, t03
            , t04, t05, t06, t07, t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t11, t12, t13, t14, t15, t16
            , t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t2, t21, t22, t23, t24, t25, t26, t27, t28
            , t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a
            , t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d
            , t4e, t4f, t4g, t4h, t4i, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g
            , t5h, t5i, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t7
            , t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t8, t81, t82, t83
            , t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t9, t91, t92, t93, t94, t95, t96
            , t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i;
    {long i; for(i = 0; i <= 63; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 1024);
        a4 = (a + 1025);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 512);
        a6 = (a + 513);
        a7 = (a + 1536);
        a8 = (a + 1537);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 - t8);
        t41 = (t4 + t7);
        t51 = (t3 + t8);
        t61 = (t4 - t7);
        a9 = (a + 128);
        a01 = (a + 129);
        a11 = (a + 1152);
        a21 = (a + 1153);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 640);
        a41 = (a + 641);
        a51 = (a + 1664);
        a61 = (a + 1665);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        a71 = (0.70710678118654757*(t71 - t12));
        a81 = (0.70710678118654757*(t81 - t22));
        s = (a71 - a81);
        s2 = (a71 + a81);
        t72 = (t91 - t42);
        t82 = (t02 + t32);
        t92 = (t91 + t42);
        t03 = (t02 - t32);
        s3 = ((0.92387953251128674*t72) - (0.38268343236508978*t82));
        s4 = ((0.38268343236508978*t72) + (0.92387953251128674*t82));
        s5 = ((0.38268343236508978*t92) - (0.92387953251128674*t03));
        s6 = ((0.92387953251128674*t92) + (0.38268343236508978*t03));
        a91 = (a + 256);
        a02 = (a + 257);
        a12 = (a + 1280);
        a22 = (a + 1281);
        t13 = (*(a91) + *(a12));
        t23 = (*(a02) + *(a22));
        t33 = (*(a91) - *(a12));
        t43 = (*(a02) - *(a22));
        a32 = (a + 768);
        a42 = (a + 769);
        a52 = (a + 1792);
        a62 = (a + 1793);
        t53 = (*(a32) + *(a52));
        t63 = (*(a42) + *(a62));
        t73 = (*(a32) - *(a52));
        t83 = (*(a42) - *(a62));
        t93 = (t13 + t53);
        t04 = (t23 + t63);
        t14 = (t13 - t53);
        t24 = (t23 - t63);
        a72 = (0.70710678118654757*(t33 - t83));
        a82 = (0.70710678118654757*(t43 + t73));
        s7 = (a72 - a82);
        s8 = (a72 + a82);
        a92 = (0.70710678118654757*(t33 + t83));
        a03 = (0.70710678118654757*(t43 - t73));
        s9 = (a92 + a03);
        s01 = (a92 - a03);
        a13 = (a + 384);
        a23 = (a + 385);
        a33 = (a + 1408);
        a43 = (a + 1409);
        t34 = (*(a13) + *(a33));
        t44 = (*(a23) + *(a43));
        t54 = (*(a13) - *(a33));
        t64 = (*(a23) - *(a43));
        a53 = (a + 896);
        a63 = (a + 897);
        a73 = (a + 1920);
        a83 = (a + 1921);
        t74 = (*(a53) + *(a73));
        t84 = (*(a63) + *(a83));
        t94 = (*(a53) - *(a73));
        t05 = (*(a63) - *(a83));
        t15 = (t34 + t74);
        t25 = (t44 + t84);
        a93 = (0.70710678118654757*(t34 - t74));
        a04 = (0.70710678118654757*(t44 - t84));
        s11 = (a93 + a04);
        s21 = (a93 - a04);
        t35 = (t54 - t05);
        t45 = (t64 + t94);
        t55 = (t54 + t05);
        t65 = (t64 - t94);
        s31 = ((0.38268343236508978*t35) - (0.92387953251128674*t45));
        s41 = ((0.92387953251128674*t35) + (0.38268343236508978*t45));
        s51 = ((0.38268343236508978*t65) - (0.92387953251128674*t55));
        s61 = ((0.38268343236508978*t55) + (0.92387953251128674*t65));
        t75 = (t9 + t93);
        t85 = (t01 + t04);
        t95 = (t9 - t93);
        t06 = (t01 - t04);
        t16 = (t52 + t15);
        t26 = (t62 + t25);
        t36 = (t52 - t15);
        t46 = (t62 - t25);
        t56 = (t75 + t16);
        t66 = (t85 + t26);
        t76 = (t75 - t16);
        t86 = (t85 - t26);
        a14 = (32*i);
        a24 = (D287 + a14);
        a34 = (a24 + 1);
        a44 = (a24 + 2);
        a54 = (a24 + 3);
        a64 = (T + a14);
        *(a64) = ((*(a24)*t56) - (*(a34)*t66));
        *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
        *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
        *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
        t96 = (t95 - t46);
        t07 = (t06 + t36);
        t17 = (t95 + t46);
        t27 = (t06 - t36);
        a74 = (a24 + 4);
        a84 = (a24 + 5);
        a94 = (a24 + 6);
        a05 = (a24 + 7);
        *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
        *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
        *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
        *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
        t37 = (t31 + s7);
        t47 = (t41 + s8);
        t57 = (t31 - s7);
        t67 = (t41 - s8);
        t77 = (s3 + s31);
        t87 = (s4 + s41);
        t97 = (s3 - s31);
        t08 = (s4 - s41);
        t18 = (t37 + t77);
        t28 = (t47 + t87);
        t38 = (t37 - t77);
        t48 = (t47 - t87);
        a15 = (a24 + 8);
        a25 = (a24 + 9);
        a35 = (a24 + 10);
        a45 = (a24 + 11);
        *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
        *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
        *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
        *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
        t58 = (t57 - t08);
        t68 = (t67 + t97);
        t78 = (t57 + t08);
        t88 = (t67 - t97);
        a55 = (a24 + 12);
        a65 = (a24 + 13);
        a75 = (a24 + 14);
        a85 = (a24 + 15);
        *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
        *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
        *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
        *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
        t98 = (t11 - t24);
        t09 = (t21 + t14);
        t19 = (t11 + t24);
        t29 = (t21 - t14);
        t39 = (s - s11);
        t49 = (s2 + s21);
        t59 = (s + s11);
        t69 = (s2 - s21);
        t79 = (t98 + t39);
        t89 = (t09 + t49);
        t99 = (t98 - t39);
        t0a = (t09 - t49);
        a95 = (a24 + 16);
        a06 = (a24 + 17);
        a16 = (a24 + 18);
        a26 = (a24 + 19);
        *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
        *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
        *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
        *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
        t1a = (t19 - t69);
        t2a = (t29 + t59);
        t3a = (t19 + t69);
        t4a = (t29 - t59);
        a36 = (a24 + 20);
        a46 = (a24 + 21);
        a56 = (a24 + 22);
        a66 = (a24 + 23);
        *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
        *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
        *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
        *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
        t5a = (t51 - s9);
        t6a = (t61 + s01);
        t7a = (t51 + s9);
        t8a = (t61 - s01);
        t9a = (s5 + s51);
        t0b = (s6 - s61);
        t1b = (s5 - s51);
        t2b = (s6 + s61);
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        a76 = (a24 + 24);
        a86 = (a24 + 25);
        a96 = (a24 + 26);
        a07 = (a24 + 27);
        *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
        *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
        *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
        *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
        t7b = (t7a - t2b);
        t8b = (t8a + t1b);
        t9b = (t7a + t2b);
        t0c = (t8a - t1b);
        a17 = (a24 + 28);
        a27 = (a24 + 29);
        a37 = (a24 + 30);
        a47 = (a24 + 31);
        *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
        *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
        *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
        *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        {long i3; for(i3 = 0; i3 <= 7; i3++) {
            a57 = (T + (2*i2) + (32*i3));
            a67 = (a57 + 1);
            a77 = (a57 + 1024);
            a87 = (a57 + 1025);
            t1c = (*(a57) + *(a77));
            t2c = (*(a67) + *(a87));
            t3c = (*(a57) - *(a77));
            t4c = (*(a67) - *(a87));
            a97 = (a57 + 512);
            a08 = (a57 + 513);
            a18 = (a57 + 1536);
            a28 = (a57 + 1537);
            t5c = (*(a97) + *(a18));
            t6c = (*(a08) + *(a28));
            t7c = (*(a97) - *(a18));
            t8c = (*(a08) - *(a28));
            t9c = (t1c + t5c);
            t0d = (t2c + t6c);
            t1d = (t1c - t5c);
            t2d = (t2c - t6c);
            t3d = (t3c - t8c);
            t4d = (t4c + t7c);
            t5d = (t3c + t8c);
            t6d = (t4c - t7c);
            a38 = (a57 + 256);
            a48 = (a57 + 257);
            a58 = (a57 + 1280);
            a68 = (a57 + 1281);
            t7d = (*(a38) + *(a58));
            t8d = (*(a48) + *(a68));
            t9d = (*(a38) - *(a58));
            t0e = (*(a48) - *(a68));
            a78 = (a57 + 768);
            a88 = (a57 + 769);
            a98 = (a57 + 1792);
            a09 = (a57 + 1793);
            t1e = (*(a78) + *(a98));
            t2e = (*(a88) + *(a09));
            t3e = (*(a78) - *(a98));
            t4e = (*(a88) - *(a09));
            t5e = (t7d + t1e);
            t6e = (t8d + t2e);
            t7e = (t7d - t1e);
            t8e = (t8d - t2e);
            a19 = (0.70710678118654757*(t9d - t4e));
            a29 = (0.70710678118654757*(t0e + t3e));
            s71 = (a19 - a29);
            s81 = (a19 + a29);
            a39 = (0.70710678118654757*(t9d + t4e));
            a49 = (0.70710678118654757*(t0e - t3e));
            s91 = (a39 + a49);
            s02 = (a39 - a49);
            t9e = (t9c + t5e);
            t0f = (t0d + t6e);
            t1f = (t9c - t5e);
            t2f = (t0d - t6e);
            a59 = (16*i3);
            a69 = (D283 + a59);
            a79 = (a69 + 1);
            a89 = (a69 + 2);
            a99 = (a69 + 3);
            a0a = (T2 + a59);
            *(a0a) = ((*(a69)*t9e) - (*(a79)*t0f));
            *((a0a + 1)) = ((*(a79)*t9e) + (*(a69)*t0f));
            *((a0a + 8)) = ((*(a89)*t1f) - (*(a99)*t2f));
            *((a0a + 9)) = ((*(a99)*t1f) + (*(a89)*t2f));
            t3f = (t3d + s71);
            t4f = (t4d + s81);
            t5f = (t3d - s71);
            t6f = (t4d - s81);
            a1a = (a69 + 4);
            a2a = (a69 + 5);
            a3a = (a69 + 6);
            a4a = (a69 + 7);
            *((a0a + 2)) = ((*(a1a)*t3f) - (*(a2a)*t4f));
            *((a0a + 3)) = ((*(a2a)*t3f) + (*(a1a)*t4f));
            *((a0a + 10)) = ((*(a3a)*t5f) - (*(a4a)*t6f));
            *((a0a + 11)) = ((*(a4a)*t5f) + (*(a3a)*t6f));
            t7f = (t1d - t8e);
            t8f = (t2d + t7e);
            t9f = (t1d + t8e);
            t0g = (t2d - t7e);
            a5a = (a69 + 8);
            a6a = (a69 + 9);
            a7a = (a69 + 10);
            a8a = (a69 + 11);
            *((a0a + 4)) = ((*(a5a)*t7f) - (*(a6a)*t8f));
            *((a0a + 5)) = ((*(a6a)*t7f) + (*(a5a)*t8f));
            *((a0a + 12)) = ((*(a7a)*t9f) - (*(a8a)*t0g));
            *((a0a + 13)) = ((*(a8a)*t9f) + (*(a7a)*t0g));
            t1g = (t5d - s91);
            t2g = (t6d + s02);
            t3g = (t5d + s91);
            t4g = (t6d - s02);
            a9a = (a69 + 12);
            a0b = (a69 + 13);
            a1b = (a69 + 14);
            a2b = (a69 + 15);
            *((a0a + 6)) = ((*(a9a)*t1g) - (*(a0b)*t2g));
            *((a0a + 7)) = ((*(a0b)*t1g) + (*(a9a)*t2g));
            *((a0a + 14)) = ((*(a1b)*t3g) - (*(a2b)*t4g));
            *((a0a + 15)) = ((*(a2b)*t3g) + (*(a1b)*t4g));
        }}
        {long i4; for(i4 = 0; i4 <= 7; i4++) {
            a3b = (T2 + (2*i4));
            a4b = (a3b + 1);
            a5b = (a3b + 64);
            a6b = (a3b + 65);
            t5g = (*(a3b) + *(a5b));
            t6g = (*(a4b) + *(a6b));
            t7g = (*(a3b) - *(a5b));
            t8g = (*(a4b) - *(a6b));
            a7b = (a3b + 32);
            a8b = (a3b + 33);
            a9b = (a3b + 96);
            a0c = (a3b + 97);
            t9g = (*(a7b) + *(a9b));
            t0h = (*(a8b) + *(a0c));
            t1h = (*(a7b) - *(a9b));
            t2h = (*(a8b) - *(a0c));
            t3h = (t5g + t9g);
            t4h = (t6g + t0h);
            t5h = (t5g - t9g);
            t6h = (t6g - t0h);
            t7h = (t7g - t2h);
            t8h = (t8g + t1h);
            t9h = (t7g + t2h);
            t0i = (t8g - t1h);
            a1c = (a3b + 16);
            a2c = (a3b + 17);
            a3c = (a3b + 80);
            a4c = (a3b + 81);
            t1i = (*(a1c) + *(a3c));
            t2i = (*(a2c) + *(a4c));
            t3i = (*(a1c) - *(a3c));
            t4i = (*(a2c) - *(a4c));
            a5c = (a3b + 48);
            a6c = (a3b + 49);
            a7c = (a3b + 112);
            a8c = (a3b + 113);
            t5i = (*(a5c) + *(a7c));
            t6i = (*(a6c) + *(a8c));
            t7i = (*(a5c) - *(a7c));
            t8i = (*(a6c) - *(a8c));
            t9i = (t1i + t5i);
            t0j = (t2i + t6i);
            t1j = (t1i - t5i);
            t2j = (t2i - t6i);
            a9c = (0.70710678118654757*(t3i - t8i));
            a0d = (0.70710678118654757*(t4i + t7i));
            s12 = (a9c - a0d);
            s22 = (a9c + a0d);
            a1d = (0.70710678118654757*(t3i + t8i));
            a2d = (0.70710678118654757*(t4i - t7i));
            s32 = (a1d + a2d);
            s42 = (a1d - a2d);
            a3d = (dst + (2*i2) + (32*i4));
            *(a3d) = (t3h + t9i);
            *((a3d + 1)) = (t4h + t0j);
            *((a3d + 1024)) = (t3h - t9i);
            *((a3d + 1025)) = (t4h - t0j);
            *((a3d + 256)) = (t7h + s12);
            *((a3d + 257)) = (t8h + s22);
            *((a3d + 1280)) = (t7h - s12);
            *((a3d + 1281)) = (t8h - s22);
            *((a3d + 512)) = (t5h - t2j);
            *((a3d + 513)) = (t6h + t1j);
            *((a3d + 1536)) = (t5h + t2j);
            *((a3d + 1537)) = (t6h - t1j);
            *((a3d + 768)) = (t9h - s32);
            *((a3d + 769)) = (t0i + s42);
            *((a3d + 1792)) = (t9h + s32);
            *((a3d + 1793)) = (t0i - s42);
        }}
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_double_2048)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[4096];
     double T2[256];
    double  *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0g, *a15, *a16, *a17, *a18, *a19, *a1a, *a1b, *a1c, *a1d, *a1e
            , *a1f, *a1g, *a24, *a25, *a26, *a27, *a28, *a2b, *a2c, *a2d, *a2e, *a2f, *a2g, *a34, *a35, *a36, *a37, *a38, *a3b, *a3c, *a3d, *a3e
            , *a3f, *a3g, *a44, *a45, *a46, *a47, *a48, *a49, *a4c, *a4d, *a4e, *a4f, *a4g, *a54, *a55, *a56, *a58, *a59, *a5c, *a5d, *a5e, *a5f
            , *a64, *a65, *a66, *a67, *a68, *a69, *a6a, *a6b, *a6c, *a6d, *a6e, *a6f, *a74, *a75, *a76, *a77, *a78, *a79, *a7a, *a7b, *a7c, *a7d
            , *a7e, *a7f, *a84, *a85, *a86, *a87, *a88, *a89, *a8a, *a8b, *a8c, *a8d, *a8e, *a8f, *a94, *a95, *a96, *a97, *a98, *a99, *a9a, *a9b
            , *a9c, *a9d, *a9e, *a9f, *a9g;
    const double  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a57;
    double a03, a04, a29, a2a, a39, a3a, a4a, a4b, a5a, a5b, a5g, a6g, a71, a72, a7g, a81, a82, a8g, a92, a93, s, s01
            , s02, s03, s11, s12, s13, s2, s21, s22, s23, s3, s31, s32, s33, s4, s41, s42, s43, s5, s51, s52, s53, s6
            , s61, s62, s63, s7, s71, s72, s8, s81, s82, s9, s91, s92, t, t01, t02, t03, t04, t05, t06, t07, t08, t09
            , t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o, t0p, t0q, t11, t12, t13, t14, t15
            , t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t2
            , t21, t22, t23, t24, t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m
            , t2n, t2o, t2p, t2q, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h
            , t3i, t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c
            , t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t4o, t4p, t4q, t5, t51, t52, t53, t54, t55, t56, t57
            , t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t6, t61, t62
            , t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o
            , t6p, t6q, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j
            , t7k, t7l, t7m, t7n, t7o, t7p, t7q, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e
            , t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p, t8q, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99
            , t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p;
    {long i; for(i = 0; i <= 127; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 2048);
        a4 = (a + 2049);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 1024);
        a6 = (a + 1025);
        a7 = (a + 3072);
        a8 = (a + 3073);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 - t8);
        t41 = (t4 + t7);
        t51 = (t3 + t8);
        t61 = (t4 - t7);
        a9 = (a + 256);
        a01 = (a + 257);
        a11 = (a + 2304);
        a21 = (a + 2305);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 1280);
        a41 = (a + 1281);
        a51 = (a + 3328);
        a61 = (a + 3329);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        a71 = (0.70710678118654757*(t71 - t12));
        a81 = (0.70710678118654757*(t81 - t22));
        s = (a71 - a81);
        s2 = (a71 + a81);
        t72 = (t91 - t42);
        t82 = (t02 + t32);
        t92 = (t91 + t42);
        t03 = (t02 - t32);
        s3 = ((0.92387953251128674*t72) - (0.38268343236508978*t82));
        s4 = ((0.38268343236508978*t72) + (0.92387953251128674*t82));
        s5 = ((0.38268343236508978*t92) - (0.92387953251128674*t03));
        s6 = ((0.92387953251128674*t92) + (0.38268343236508978*t03));
        a91 = (a + 512);
        a02 = (a + 513);
        a12 = (a + 2560);
        a22 = (a + 2561);
        t13 = (*(a91) + *(a12));
        t23 = (*(a02) + *(a22));
        t33 = (*(a91) - *(a12));
        t43 = (*(a02) - *(a22));
        a32 = (a + 1536);
        a42 = (a + 1537);
        a52 = (a + 3584);
        a62 = (a + 3585);
        t53 = (*(a32) + *(a52));
        t63 = (*(a42) + *(a62));
        t73 = (*(a32) - *(a52));
        t83 = (*(a42) - *(a62));
        t93 = (t13 + t53);
        t04 = (t23 + t63);
        t14 = (t13 - t53);
        t24 = (t23 - t63);
        a72 = (0.70710678118654757*(t33 - t83));
        a82 = (0.70710678118654757*(t43 + t73));
        s7 = (a72 - a82);
        s8 = (a72 + a82);
        a92 = (0.70710678118654757*(t33 + t83));
        a03 = (0.70710678118654757*(t43 - t73));
        s9 = (a92 + a03);
        s01 = (a92 - a03);
        a13 = (a + 768);
        a23 = (a + 769);
        a33 = (a + 2816);
        a43 = (a + 2817);
        t34 = (*(a13) + *(a33));
        t44 = (*(a23) + *(a43));
        t54 = (*(a13) - *(a33));
        t64 = (*(a23) - *(a43));
        a53 = (a + 1792);
        a63 = (a + 1793);
        a73 = (a + 3840);
        a83 = (a + 3841);
        t74 = (*(a53) + *(a73));
        t84 = (*(a63) + *(a83));
        t94 = (*(a53) - *(a73));
        t05 = (*(a63) - *(a83));
        t15 = (t34 + t74);
        t25 = (t44 + t84);
        a93 = (0.70710678118654757*(t34 - t74));
        a04 = (0.70710678118654757*(t44 - t84));
        s11 = (a93 + a04);
        s21 = (a93 - a04);
        t35 = (t54 - t05);
        t45 = (t64 + t94);
        t55 = (t54 + t05);
        t65 = (t64 - t94);
        s31 = ((0.38268343236508978*t35) - (0.92387953251128674*t45));
        s41 = ((0.92387953251128674*t35) + (0.38268343236508978*t45));
        s51 = ((0.38268343236508978*t65) - (0.92387953251128674*t55));
        s61 = ((0.38268343236508978*t55) + (0.92387953251128674*t65));
        t75 = (t9 + t93);
        t85 = (t01 + t04);
        t95 = (t9 - t93);
        t06 = (t01 - t04);
        t16 = (t52 + t15);
        t26 = (t62 + t25);
        t36 = (t52 - t15);
        t46 = (t62 - t25);
        t56 = (t75 + t16);
        t66 = (t85 + t26);
        t76 = (t75 - t16);
        t86 = (t85 - t26);
        a14 = (32*i);
        a24 = (D288 + a14);
        a34 = (a24 + 1);
        a44 = (a24 + 2);
        a54 = (a24 + 3);
        a64 = (T + a14);
        *(a64) = ((*(a24)*t56) - (*(a34)*t66));
        *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
        *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
        *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
        t96 = (t95 - t46);
        t07 = (t06 + t36);
        t17 = (t95 + t46);
        t27 = (t06 - t36);
        a74 = (a24 + 4);
        a84 = (a24 + 5);
        a94 = (a24 + 6);
        a05 = (a24 + 7);
        *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
        *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
        *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
        *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
        t37 = (t31 + s7);
        t47 = (t41 + s8);
        t57 = (t31 - s7);
        t67 = (t41 - s8);
        t77 = (s3 + s31);
        t87 = (s4 + s41);
        t97 = (s3 - s31);
        t08 = (s4 - s41);
        t18 = (t37 + t77);
        t28 = (t47 + t87);
        t38 = (t37 - t77);
        t48 = (t47 - t87);
        a15 = (a24 + 8);
        a25 = (a24 + 9);
        a35 = (a24 + 10);
        a45 = (a24 + 11);
        *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
        *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
        *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
        *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
        t58 = (t57 - t08);
        t68 = (t67 + t97);
        t78 = (t57 + t08);
        t88 = (t67 - t97);
        a55 = (a24 + 12);
        a65 = (a24 + 13);
        a75 = (a24 + 14);
        a85 = (a24 + 15);
        *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
        *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
        *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
        *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
        t98 = (t11 - t24);
        t09 = (t21 + t14);
        t19 = (t11 + t24);
        t29 = (t21 - t14);
        t39 = (s - s11);
        t49 = (s2 + s21);
        t59 = (s + s11);
        t69 = (s2 - s21);
        t79 = (t98 + t39);
        t89 = (t09 + t49);
        t99 = (t98 - t39);
        t0a = (t09 - t49);
        a95 = (a24 + 16);
        a06 = (a24 + 17);
        a16 = (a24 + 18);
        a26 = (a24 + 19);
        *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
        *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
        *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
        *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
        t1a = (t19 - t69);
        t2a = (t29 + t59);
        t3a = (t19 + t69);
        t4a = (t29 - t59);
        a36 = (a24 + 20);
        a46 = (a24 + 21);
        a56 = (a24 + 22);
        a66 = (a24 + 23);
        *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
        *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
        *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
        *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
        t5a = (t51 - s9);
        t6a = (t61 + s01);
        t7a = (t51 + s9);
        t8a = (t61 - s01);
        t9a = (s5 + s51);
        t0b = (s6 - s61);
        t1b = (s5 - s51);
        t2b = (s6 + s61);
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        a76 = (a24 + 24);
        a86 = (a24 + 25);
        a96 = (a24 + 26);
        a07 = (a24 + 27);
        *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
        *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
        *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
        *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
        t7b = (t7a - t2b);
        t8b = (t8a + t1b);
        t9b = (t7a + t2b);
        t0c = (t8a - t1b);
        a17 = (a24 + 28);
        a27 = (a24 + 29);
        a37 = (a24 + 30);
        a47 = (a24 + 31);
        *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
        *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
        *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
        *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        {long i3; for(i3 = 0; i3 <= 7; i3++) {
            a57 = (32*i3);
            a67 = (T + (2*i2) + a57);
            a77 = (a67 + 1);
            a87 = (a67 + 2048);
            a97 = (a67 + 2049);
            t1c = (*(a67) + *(a87));
            t2c = (*(a77) + *(a97));
            t3c = (*(a67) - *(a87));
            t4c = (*(a77) - *(a97));
            a08 = (a67 + 1024);
            a18 = (a67 + 1025);
            a28 = (a67 + 3072);
            a38 = (a67 + 3073);
            t5c = (*(a08) + *(a28));
            t6c = (*(a18) + *(a38));
            t7c = (*(a08) - *(a28));
            t8c = (*(a18) - *(a38));
            t9c = (t1c + t5c);
            t0d = (t2c + t6c);
            t1d = (t1c - t5c);
            t2d = (t2c - t6c);
            t3d = (t3c - t8c);
            t4d = (t4c + t7c);
            t5d = (t3c + t8c);
            t6d = (t4c - t7c);
            a48 = (a67 + 256);
            a58 = (a67 + 257);
            a68 = (a67 + 2304);
            a78 = (a67 + 2305);
            t7d = (*(a48) + *(a68));
            t8d = (*(a58) + *(a78));
            t9d = (*(a48) - *(a68));
            t0e = (*(a58) - *(a78));
            a88 = (a67 + 1280);
            a98 = (a67 + 1281);
            a09 = (a67 + 3328);
            a19 = (a67 + 3329);
            t1e = (*(a88) + *(a09));
            t2e = (*(a98) + *(a19));
            t3e = (*(a88) - *(a09));
            t4e = (*(a98) - *(a19));
            t5e = (t7d + t1e);
            t6e = (t8d + t2e);
            a29 = (0.70710678118654757*(t7d - t1e));
            a39 = (0.70710678118654757*(t8d - t2e));
            s71 = (a29 - a39);
            s81 = (a29 + a39);
            t7e = (t9d - t4e);
            t8e = (t0e + t3e);
            t9e = (t9d + t4e);
            t0f = (t0e - t3e);
            s91 = ((0.92387953251128674*t7e) - (0.38268343236508978*t8e));
            s02 = ((0.38268343236508978*t7e) + (0.92387953251128674*t8e));
            s12 = ((0.38268343236508978*t9e) - (0.92387953251128674*t0f));
            s22 = ((0.92387953251128674*t9e) + (0.38268343236508978*t0f));
            a49 = (a67 + 512);
            a59 = (a67 + 513);
            a69 = (a67 + 2560);
            a79 = (a67 + 2561);
            t1f = (*(a49) + *(a69));
            t2f = (*(a59) + *(a79));
            t3f = (*(a49) - *(a69));
            t4f = (*(a59) - *(a79));
            a89 = (a67 + 1536);
            a99 = (a67 + 1537);
            a0a = (a67 + 3584);
            a1a = (a67 + 3585);
            t5f = (*(a89) + *(a0a));
            t6f = (*(a99) + *(a1a));
            t7f = (*(a89) - *(a0a));
            t8f = (*(a99) - *(a1a));
            t9f = (t1f + t5f);
            t0g = (t2f + t6f);
            t1g = (t1f - t5f);
            t2g = (t2f - t6f);
            a2a = (0.70710678118654757*(t3f - t8f));
            a3a = (0.70710678118654757*(t4f + t7f));
            s32 = (a2a - a3a);
            s42 = (a2a + a3a);
            a4a = (0.70710678118654757*(t3f + t8f));
            a5a = (0.70710678118654757*(t4f - t7f));
            s52 = (a4a + a5a);
            s62 = (a4a - a5a);
            a6a = (a67 + 768);
            a7a = (a67 + 769);
            a8a = (a67 + 2816);
            a9a = (a67 + 2817);
            t3g = (*(a6a) + *(a8a));
            t4g = (*(a7a) + *(a9a));
            t5g = (*(a6a) - *(a8a));
            t6g = (*(a7a) - *(a9a));
            a0b = (a67 + 1792);
            a1b = (a67 + 1793);
            a2b = (a67 + 3840);
            a3b = (a67 + 3841);
            t7g = (*(a0b) + *(a2b));
            t8g = (*(a1b) + *(a3b));
            t9g = (*(a0b) - *(a2b));
            t0h = (*(a1b) - *(a3b));
            t1h = (t3g + t7g);
            t2h = (t4g + t8g);
            a4b = (0.70710678118654757*(t3g - t7g));
            a5b = (0.70710678118654757*(t4g - t8g));
            s72 = (a4b + a5b);
            s82 = (a4b - a5b);
            t3h = (t5g - t0h);
            t4h = (t6g + t9g);
            t5h = (t5g + t0h);
            t6h = (t6g - t9g);
            s92 = ((0.38268343236508978*t3h) - (0.92387953251128674*t4h));
            s03 = ((0.92387953251128674*t3h) + (0.38268343236508978*t4h));
            s13 = ((0.38268343236508978*t6h) - (0.92387953251128674*t5h));
            s23 = ((0.38268343236508978*t5h) + (0.92387953251128674*t6h));
            t7h = (t9c + t9f);
            t8h = (t0d + t0g);
            t9h = (t9c - t9f);
            t0i = (t0d - t0g);
            t1i = (t5e + t1h);
            t2i = (t6e + t2h);
            t3i = (t5e - t1h);
            t4i = (t6e - t2h);
            t5i = (t7h + t1i);
            t6i = (t8h + t2i);
            t7i = (t7h - t1i);
            t8i = (t8h - t2i);
            a6b = (D284 + a57);
            a7b = (a6b + 1);
            a8b = (a6b + 2);
            a9b = (a6b + 3);
            a0c = (T2 + a57);
            *(a0c) = ((*(a6b)*t5i) - (*(a7b)*t6i));
            *((a0c + 1)) = ((*(a7b)*t5i) + (*(a6b)*t6i));
            *((a0c + 16)) = ((*(a8b)*t7i) - (*(a9b)*t8i));
            *((a0c + 17)) = ((*(a9b)*t7i) + (*(a8b)*t8i));
            t9i = (t9h - t4i);
            t0j = (t0i + t3i);
            t1j = (t9h + t4i);
            t2j = (t0i - t3i);
            a1c = (a6b + 4);
            a2c = (a6b + 5);
            a3c = (a6b + 6);
            a4c = (a6b + 7);
            *((a0c + 8)) = ((*(a1c)*t9i) - (*(a2c)*t0j));
            *((a0c + 9)) = ((*(a2c)*t9i) + (*(a1c)*t0j));
            *((a0c + 24)) = ((*(a3c)*t1j) - (*(a4c)*t2j));
            *((a0c + 25)) = ((*(a4c)*t1j) + (*(a3c)*t2j));
            t3j = (t3d + s32);
            t4j = (t4d + s42);
            t5j = (t3d - s32);
            t6j = (t4d - s42);
            t7j = (s91 + s92);
            t8j = (s02 + s03);
            t9j = (s91 - s92);
            t0k = (s02 - s03);
            t1k = (t3j + t7j);
            t2k = (t4j + t8j);
            t3k = (t3j - t7j);
            t4k = (t4j - t8j);
            a5c = (a6b + 8);
            a6c = (a6b + 9);
            a7c = (a6b + 10);
            a8c = (a6b + 11);
            *((a0c + 2)) = ((*(a5c)*t1k) - (*(a6c)*t2k));
            *((a0c + 3)) = ((*(a6c)*t1k) + (*(a5c)*t2k));
            *((a0c + 18)) = ((*(a7c)*t3k) - (*(a8c)*t4k));
            *((a0c + 19)) = ((*(a8c)*t3k) + (*(a7c)*t4k));
            t5k = (t5j - t0k);
            t6k = (t6j + t9j);
            t7k = (t5j + t0k);
            t8k = (t6j - t9j);
            a9c = (a6b + 12);
            a0d = (a6b + 13);
            a1d = (a6b + 14);
            a2d = (a6b + 15);
            *((a0c + 10)) = ((*(a9c)*t5k) - (*(a0d)*t6k));
            *((a0c + 11)) = ((*(a0d)*t5k) + (*(a9c)*t6k));
            *((a0c + 26)) = ((*(a1d)*t7k) - (*(a2d)*t8k));
            *((a0c + 27)) = ((*(a2d)*t7k) + (*(a1d)*t8k));
            t9k = (t1d - t2g);
            t0l = (t2d + t1g);
            t1l = (t1d + t2g);
            t2l = (t2d - t1g);
            t3l = (s71 - s72);
            t4l = (s81 + s82);
            t5l = (s71 + s72);
            t6l = (s81 - s82);
            t7l = (t9k + t3l);
            t8l = (t0l + t4l);
            t9l = (t9k - t3l);
            t0m = (t0l - t4l);
            a3d = (a6b + 16);
            a4d = (a6b + 17);
            a5d = (a6b + 18);
            a6d = (a6b + 19);
            *((a0c + 4)) = ((*(a3d)*t7l) - (*(a4d)*t8l));
            *((a0c + 5)) = ((*(a4d)*t7l) + (*(a3d)*t8l));
            *((a0c + 20)) = ((*(a5d)*t9l) - (*(a6d)*t0m));
            *((a0c + 21)) = ((*(a6d)*t9l) + (*(a5d)*t0m));
            t1m = (t1l - t6l);
            t2m = (t2l + t5l);
            t3m = (t1l + t6l);
            t4m = (t2l - t5l);
            a7d = (a6b + 20);
            a8d = (a6b + 21);
            a9d = (a6b + 22);
            a0e = (a6b + 23);
            *((a0c + 12)) = ((*(a7d)*t1m) - (*(a8d)*t2m));
            *((a0c + 13)) = ((*(a8d)*t1m) + (*(a7d)*t2m));
            *((a0c + 28)) = ((*(a9d)*t3m) - (*(a0e)*t4m));
            *((a0c + 29)) = ((*(a0e)*t3m) + (*(a9d)*t4m));
            t5m = (t5d - s52);
            t6m = (t6d + s62);
            t7m = (t5d + s52);
            t8m = (t6d - s62);
            t9m = (s12 + s13);
            t0n = (s22 - s23);
            t1n = (s12 - s13);
            t2n = (s22 + s23);
            t3n = (t5m + t9m);
            t4n = (t6m + t0n);
            t5n = (t5m - t9m);
            t6n = (t6m - t0n);
            a1e = (a6b + 24);
            a2e = (a6b + 25);
            a3e = (a6b + 26);
            a4e = (a6b + 27);
            *((a0c + 6)) = ((*(a1e)*t3n) - (*(a2e)*t4n));
            *((a0c + 7)) = ((*(a2e)*t3n) + (*(a1e)*t4n));
            *((a0c + 22)) = ((*(a3e)*t5n) - (*(a4e)*t6n));
            *((a0c + 23)) = ((*(a4e)*t5n) + (*(a3e)*t6n));
            t7n = (t7m - t2n);
            t8n = (t8m + t1n);
            t9n = (t7m + t2n);
            t0o = (t8m - t1n);
            a5e = (a6b + 28);
            a6e = (a6b + 29);
            a7e = (a6b + 30);
            a8e = (a6b + 31);
            *((a0c + 14)) = ((*(a5e)*t7n) - (*(a6e)*t8n));
            *((a0c + 15)) = ((*(a6e)*t7n) + (*(a5e)*t8n));
            *((a0c + 30)) = ((*(a7e)*t9n) - (*(a8e)*t0o));
            *((a0c + 31)) = ((*(a8e)*t9n) + (*(a7e)*t0o));
        }}
        {long i4; for(i4 = 0; i4 <= 15; i4++) {
            a9e = (T2 + (2*i4));
            a0f = (a9e + 1);
            a1f = (a9e + 128);
            a2f = (a9e + 129);
            t1o = (*(a9e) + *(a1f));
            t2o = (*(a0f) + *(a2f));
            t3o = (*(a9e) - *(a1f));
            t4o = (*(a0f) - *(a2f));
            a3f = (a9e + 64);
            a4f = (a9e + 65);
            a5f = (a9e + 192);
            a6f = (a9e + 193);
            t5o = (*(a3f) + *(a5f));
            t6o = (*(a4f) + *(a6f));
            t7o = (*(a3f) - *(a5f));
            t8o = (*(a4f) - *(a6f));
            t9o = (t1o + t5o);
            t0p = (t2o + t6o);
            t1p = (t1o - t5o);
            t2p = (t2o - t6o);
            t3p = (t3o - t8o);
            t4p = (t4o + t7o);
            t5p = (t3o + t8o);
            t6p = (t4o - t7o);
            a7f = (a9e + 32);
            a8f = (a9e + 33);
            a9f = (a9e + 160);
            a0g = (a9e + 161);
            t7p = (*(a7f) + *(a9f));
            t8p = (*(a8f) + *(a0g));
            t9p = (*(a7f) - *(a9f));
            t0q = (*(a8f) - *(a0g));
            a1g = (a9e + 96);
            a2g = (a9e + 97);
            a3g = (a9e + 224);
            a4g = (a9e + 225);
            t1q = (*(a1g) + *(a3g));
            t2q = (*(a2g) + *(a4g));
            t3q = (*(a1g) - *(a3g));
            t4q = (*(a2g) - *(a4g));
            t5q = (t7p + t1q);
            t6q = (t8p + t2q);
            t7q = (t7p - t1q);
            t8q = (t8p - t2q);
            a5g = (0.70710678118654757*(t9p - t4q));
            a6g = (0.70710678118654757*(t0q + t3q));
            s33 = (a5g - a6g);
            s43 = (a5g + a6g);
            a7g = (0.70710678118654757*(t9p + t4q));
            a8g = (0.70710678118654757*(t0q - t3q));
            s53 = (a7g + a8g);
            s63 = (a7g - a8g);
            a9g = (dst + (2*i2) + (32*i4));
            *(a9g) = (t9o + t5q);
            *((a9g + 1)) = (t0p + t6q);
            *((a9g + 2048)) = (t9o - t5q);
            *((a9g + 2049)) = (t0p - t6q);
            *((a9g + 512)) = (t3p + s33);
            *((a9g + 513)) = (t4p + s43);
            *((a9g + 2560)) = (t3p - s33);
            *((a9g + 2561)) = (t4p - s43);
            *((a9g + 1024)) = (t1p - t8q);
            *((a9g + 1025)) = (t2p + t7q);
            *((a9g + 3072)) = (t1p + t8q);
            *((a9g + 3073)) = (t2p - t7q);
            *((a9g + 1536)) = (t5p - s53);
            *((a9g + 1537)) = (t6p + s63);
            *((a9g + 3584)) = (t5p + s53);
            *((a9g + 3585)) = (t6p - s63);
        }}
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_double_4096)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[8192];
     double T2[1024];
    double  *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0g, *a0h, *a0i, *a0j, *a0k, *a0l, *a0m, *a0o, *a19, *a1a, *a1b, *a1c, *a1d, *a1e, *a1f
            , *a1g, *a1h, *a1i, *a1j, *a1k, *a1l, *a1m, *a1n, *a1o, *a1p, *a29, *a2a, *a2b, *a2c, *a2d, *a2e, *a2f, *a2g, *a2j, *a2k, *a2l, *a2m
            , *a2n, *a2o, *a39, *a3a, *a3b, *a3c, *a3d, *a3e, *a3f, *a3g, *a3j, *a3k, *a3l, *a3m, *a3n, *a3o, *a49, *a4a, *a4b, *a4c, *a4d, *a4e
            , *a4f, *a4g, *a4h, *a4k, *a4l, *a4m, *a4n, *a4o, *a59, *a5a, *a5b, *a5c, *a5d, *a5e, *a5g, *a5h, *a5k, *a5l, *a5m, *a5n, *a5o, *a69
            , *a6a, *a6b, *a6c, *a6d, *a6e, *a6f, *a6g, *a6h, *a6i, *a6k, *a6l, *a6m, *a6n, *a6o, *a79, *a7a, *a7b, *a7c, *a7d, *a7e, *a7f, *a7g
            , *a7h, *a7i, *a7j, *a7k, *a7l, *a7m, *a7n, *a89, *a8a, *a8b, *a8c, *a8d, *a8e, *a8f, *a8g, *a8h, *a8i, *a8j, *a8k, *a8l, *a8m, *a8n
            , *a99, *a9a, *a9b, *a9c, *a9d, *a9e, *a9f, *a9g, *a9h, *a9i, *a9j, *a9k, *a9l, *a9m, *a9n;
    const double  *a, *a01, *a03, *a05, *a07, *a08, *a11, *a12, *a13, *a15, *a17, *a18, *a2, *a21, *a22, *a23, *a25, *a27, *a28, *a3, *a31, *a32
            , *a33, *a34, *a35, *a37, *a4, *a41, *a42, *a43, *a44, *a45, *a47, *a5, *a51, *a52, *a53, *a54, *a55, *a57, *a6, *a61, *a62, *a63
            , *a64, *a65, *a67, *a7, *a72, *a74, *a75, *a76, *a77, *a8, *a82, *a84, *a85, *a86, *a87, *a9, *a92, *a94, *a96, *a97;
    int a0n, a5f, a6j, a98;
    double a02, a04, a06, a0p, a14, a16, a24, a26, a2h, a2i, a36, a38, a3h, a3i, a46, a48, a4i, a4j, a56, a58, a5i, a5j
            , a66, a68, a71, a73, a78, a7o, a81, a83, a88, a8o, a91, a93, a95, a9o, s, s01, s02, s03, s04, s05, s06, s07
            , s11, s12, s13, s14, s15, s16, s17, s2, s21, s22, s23, s24, s25, s26, s27, s3, s31, s32, s33, s34, s35, s36
            , s37, s4, s41, s42, s43, s44, s45, s46, s47, s5, s51, s52, s53, s54, s55, s56, s57, s6, s61, s62, s63, s64
            , s65, s66, s67, s7, s71, s72, s73, s74, s75, s76, s8, s81, s82, s83, s84, s85, s86, s9, s91, s92, s93, s94
            , s95, s96, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0A, t0B, t0C, t0D, t0E, t0F, t0G, t0H, t0I, t0a
            , t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o, t0p, t0q, t0r, t0s, t0t, t0u, t0v, t0w
            , t0x, t0y, t0z, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1A, t1B, t1C, t1D, t1E, t1F, t1G, t1H, t1I, t1a
            , t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t, t1u, t1v, t1w
            , t1x, t1y, t1z, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2A, t2B, t2C, t2D, t2E, t2F, t2G, t2H, t2I
            , t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p, t2q, t2r, t2s, t2t, t2u, t2v
            , t2w, t2x, t2y, t2z, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3A, t3B, t3C, t3D, t3E, t3F, t3G, t3H
            , t3I, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s, t3t, t3u
            , t3v, t3w, t3x, t3y, t3z, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4A, t4B, t4C, t4D, t4E, t4F, t4G
            , t4H, t4I, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t4o, t4p, t4q, t4r, t4s, t4t
            , t4u, t4v, t4w, t4x, t4y, t4z, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5A, t5B, t5C, t5D, t5E, t5F
            , t5G, t5H, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t5r, t5s, t5t
            , t5u, t5v, t5w, t5x, t5y, t5z, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6A, t6B, t6C, t6D, t6E, t6F
            , t6G, t6H, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r, t6s, t6t
            , t6u, t6v, t6w, t6x, t6y, t6z, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7A, t7B, t7C, t7D, t7E, t7F
            , t7G, t7H, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m, t7n, t7o, t7p, t7q, t7r, t7s, t7t
            , t7u, t7v, t7w, t7x, t7y, t7z, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8A, t8B, t8C, t8D, t8E, t8F
            , t8G, t8H, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p, t8q, t8r, t8s, t8t
            , t8u, t8v, t8w, t8x, t8y, t8z, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9A, t9B, t9C, t9D, t9E, t9F
            , t9G, t9H, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p, t9q, t9r, t9s, t9t
            , t9u, t9v, t9w, t9x, t9y, t9z;
    {long i; for(i = 0; i <= 7; i++) {
        {long i2; for(i2 = 0; i2 <= 15; i2++) {
            a = (src + (2*i) + (16*i2));
            a2 = (a + 1);
            a3 = (a + 4096);
            a4 = (a + 4097);
            t = (*(a) + *(a3));
            t2 = (*(a2) + *(a4));
            t3 = (*(a) - *(a3));
            t4 = (*(a2) - *(a4));
            a5 = (a + 2048);
            a6 = (a + 2049);
            a7 = (a + 6144);
            a8 = (a + 6145);
            t5 = (*(a5) + *(a7));
            t6 = (*(a6) + *(a8));
            t7 = (*(a5) - *(a7));
            t8 = (*(a6) - *(a8));
            t9 = (t + t5);
            t01 = (t2 + t6);
            t11 = (t - t5);
            t21 = (t2 - t6);
            t31 = (t3 - t8);
            t41 = (t4 + t7);
            t51 = (t3 + t8);
            t61 = (t4 - t7);
            a9 = (a + 1024);
            a01 = (a + 1025);
            a11 = (a + 5120);
            a21 = (a + 5121);
            t71 = (*(a9) + *(a11));
            t81 = (*(a01) + *(a21));
            t91 = (*(a9) - *(a11));
            t02 = (*(a01) - *(a21));
            a31 = (a + 3072);
            a41 = (a + 3073);
            a51 = (a + 7168);
            a61 = (a + 7169);
            t12 = (*(a31) + *(a51));
            t22 = (*(a41) + *(a61));
            t32 = (*(a31) - *(a51));
            t42 = (*(a41) - *(a61));
            t52 = (t71 + t12);
            t62 = (t81 + t22);
            t72 = (t71 - t12);
            t82 = (t81 - t22);
            a71 = (0.70710678118654757*(t91 - t42));
            a81 = (0.70710678118654757*(t02 + t32));
            s = (a71 - a81);
            s2 = (a71 + a81);
            a91 = (0.70710678118654757*(t91 + t42));
            a02 = (0.70710678118654757*(t02 - t32));
            s3 = (a91 + a02);
            s4 = (a91 - a02);
            t92 = (t9 + t52);
            t03 = (t01 + t62);
            t13 = (t9 - t52);
            t23 = (t01 - t62);
            t33 = (t31 + s);
            t43 = (t41 + s2);
            t53 = (t31 - s);
            t63 = (t41 - s2);
            t73 = (t11 - t82);
            t83 = (t21 + t72);
            t93 = (t11 + t82);
            t04 = (t21 - t72);
            t14 = (t51 - s3);
            t24 = (t61 + s4);
            t34 = (t51 + s3);
            t44 = (t61 - s4);
            a12 = (a + 256);
            a22 = (a + 257);
            a32 = (a + 4352);
            a42 = (a + 4353);
            t54 = (*(a12) + *(a32));
            t64 = (*(a22) + *(a42));
            t74 = (*(a12) - *(a32));
            t84 = (*(a22) - *(a42));
            a52 = (a + 2304);
            a62 = (a + 2305);
            a72 = (a + 6400);
            a82 = (a + 6401);
            t94 = (*(a52) + *(a72));
            t05 = (*(a62) + *(a82));
            t15 = (*(a52) - *(a72));
            t25 = (*(a62) - *(a82));
            t35 = (t54 + t94);
            t45 = (t64 + t05);
            t55 = (t54 - t94);
            t65 = (t64 - t05);
            t75 = (t74 - t25);
            t85 = (t84 + t15);
            t95 = (t74 + t25);
            t06 = (t84 - t15);
            a92 = (a + 1280);
            a03 = (a + 1281);
            a13 = (a + 5376);
            a23 = (a + 5377);
            t16 = (*(a92) + *(a13));
            t26 = (*(a03) + *(a23));
            t36 = (*(a92) - *(a13));
            t46 = (*(a03) - *(a23));
            a33 = (a + 3328);
            a43 = (a + 3329);
            a53 = (a + 7424);
            a63 = (a + 7425);
            t56 = (*(a33) + *(a53));
            t66 = (*(a43) + *(a63));
            t76 = (*(a33) - *(a53));
            t86 = (*(a43) - *(a63));
            t96 = (t16 + t56);
            t07 = (t26 + t66);
            t17 = (t16 - t56);
            t27 = (t26 - t66);
            a73 = (0.70710678118654757*(t36 - t86));
            a83 = (0.70710678118654757*(t46 + t76));
            s5 = (a73 - a83);
            s6 = (a73 + a83);
            a93 = (0.70710678118654757*(t36 + t86));
            a04 = (0.70710678118654757*(t46 - t76));
            s7 = (a93 + a04);
            s8 = (a93 - a04);
            t37 = (t35 + t96);
            t47 = (t45 + t07);
            a14 = (0.70710678118654757*(t35 - t96));
            a24 = (0.70710678118654757*(t45 - t07));
            s9 = (a14 - a24);
            s01 = (a14 + a24);
            t57 = (t75 + s5);
            t67 = (t85 + s6);
            t77 = (t75 - s5);
            t87 = (t85 - s6);
            s11 = ((0.98078528040323043*t57) - (0.19509032201612828*t67));
            s21 = ((0.19509032201612828*t57) + (0.98078528040323043*t67));
            s31 = ((0.55557023301960218*t77) - (0.83146961230254524*t87));
            s41 = ((0.83146961230254524*t77) + (0.55557023301960218*t87));
            t97 = (t55 - t27);
            t08 = (t65 + t17);
            t18 = (t55 + t27);
            t28 = (t65 - t17);
            s51 = ((0.92387953251128674*t97) - (0.38268343236508978*t08));
            s61 = ((0.38268343236508978*t97) + (0.92387953251128674*t08));
            s71 = ((0.38268343236508978*t18) - (0.92387953251128674*t28));
            s81 = ((0.92387953251128674*t18) + (0.38268343236508978*t28));
            t38 = (t95 - s7);
            t48 = (t06 + s8);
            t58 = (t95 + s7);
            t68 = (t06 - s8);
            s91 = ((0.83146961230254524*t38) - (0.55557023301960218*t48));
            s02 = ((0.55557023301960218*t38) + (0.83146961230254524*t48));
            s12 = ((0.19509032201612828*t58) - (0.98078528040323043*t68));
            s22 = ((0.98078528040323043*t58) + (0.19509032201612828*t68));
            a34 = (a + 512);
            a44 = (a + 513);
            a54 = (a + 4608);
            a64 = (a + 4609);
            t78 = (*(a34) + *(a54));
            t88 = (*(a44) + *(a64));
            t98 = (*(a34) - *(a54));
            t09 = (*(a44) - *(a64));
            a74 = (a + 2560);
            a84 = (a + 2561);
            a94 = (a + 6656);
            a05 = (a + 6657);
            t19 = (*(a74) + *(a94));
            t29 = (*(a84) + *(a05));
            t39 = (*(a74) - *(a94));
            t49 = (*(a84) - *(a05));
            t59 = (t78 + t19);
            t69 = (t88 + t29);
            t79 = (t78 - t19);
            t89 = (t88 - t29);
            t99 = (t98 - t49);
            t0a = (t09 + t39);
            t1a = (t98 + t49);
            t2a = (t09 - t39);
            a15 = (a + 1536);
            a25 = (a + 1537);
            a35 = (a + 5632);
            a45 = (a + 5633);
            t3a = (*(a15) + *(a35));
            t4a = (*(a25) + *(a45));
            t5a = (*(a15) - *(a35));
            t6a = (*(a25) - *(a45));
            a55 = (a + 3584);
            a65 = (a + 3585);
            a75 = (a + 7680);
            a85 = (a + 7681);
            t7a = (*(a55) + *(a75));
            t8a = (*(a65) + *(a85));
            t9a = (*(a55) - *(a75));
            t0b = (*(a65) - *(a85));
            t1b = (t3a + t7a);
            t2b = (t4a + t8a);
            t3b = (t3a - t7a);
            t4b = (t4a - t8a);
            a95 = (0.70710678118654757*(t5a - t0b));
            a06 = (0.70710678118654757*(t6a + t9a));
            s32 = (a95 - a06);
            s42 = (a95 + a06);
            a16 = (0.70710678118654757*(t5a + t0b));
            a26 = (0.70710678118654757*(t6a - t9a));
            s52 = (a16 + a26);
            s62 = (a16 - a26);
            t5b = (t59 + t1b);
            t6b = (t69 + t2b);
            t7b = (t59 - t1b);
            t8b = (t69 - t2b);
            t9b = (t99 + s32);
            t0c = (t0a + s42);
            t1c = (t99 - s32);
            t2c = (t0a - s42);
            s72 = ((0.92387953251128674*t9b) - (0.38268343236508978*t0c));
            s82 = ((0.38268343236508978*t9b) + (0.92387953251128674*t0c));
            s92 = ((0.38268343236508978*t1c) + (0.92387953251128674*t2c));
            s03 = ((0.92387953251128674*t1c) - (0.38268343236508978*t2c));
            a36 = (0.70710678118654757*(t79 - t4b));
            a46 = (0.70710678118654757*(t89 + t3b));
            s13 = (a36 - a46);
            s23 = (a36 + a46);
            a56 = (0.70710678118654757*(t79 + t4b));
            a66 = (0.70710678118654757*(t89 - t3b));
            s33 = (a56 + a66);
            s43 = (a56 - a66);
            t3c = (t1a - s52);
            t4c = (t2a + s62);
            t5c = (t1a + s52);
            t6c = (t2a - s62);
            s53 = ((0.38268343236508978*t3c) - (0.92387953251128674*t4c));
            s63 = ((0.92387953251128674*t3c) + (0.38268343236508978*t4c));
            s73 = ((0.92387953251128674*t5c) + (0.38268343236508978*t6c));
            s83 = ((0.38268343236508978*t5c) - (0.92387953251128674*t6c));
            a76 = (a + 768);
            a86 = (a + 769);
            a96 = (a + 4864);
            a07 = (a + 4865);
            t7c = (*(a76) + *(a96));
            t8c = (*(a86) + *(a07));
            t9c = (*(a76) - *(a96));
            t0d = (*(a86) - *(a07));
            a17 = (a + 2816);
            a27 = (a + 2817);
            a37 = (a + 6912);
            a47 = (a + 6913);
            t1d = (*(a17) + *(a37));
            t2d = (*(a27) + *(a47));
            t3d = (*(a17) - *(a37));
            t4d = (*(a27) - *(a47));
            t5d = (t7c + t1d);
            t6d = (t8c + t2d);
            t7d = (t7c - t1d);
            t8d = (t8c - t2d);
            t9d = (t9c - t4d);
            t0e = (t0d + t3d);
            t1e = (t9c + t4d);
            t2e = (t0d - t3d);
            a57 = (a + 1792);
            a67 = (a + 1793);
            a77 = (a + 5888);
            a87 = (a + 5889);
            t3e = (*(a57) + *(a77));
            t4e = (*(a67) + *(a87));
            t5e = (*(a57) - *(a77));
            t6e = (*(a67) - *(a87));
            a97 = (a + 3840);
            a08 = (a + 3841);
            a18 = (a + 7936);
            a28 = (a + 7937);
            t7e = (*(a97) + *(a18));
            t8e = (*(a08) + *(a28));
            t9e = (*(a97) - *(a18));
            t0f = (*(a08) - *(a28));
            t1f = (t3e + t7e);
            t2f = (t4e + t8e);
            t3f = (t3e - t7e);
            t4f = (t4e - t8e);
            a38 = (0.70710678118654757*(t5e - t0f));
            a48 = (0.70710678118654757*(t6e + t9e));
            s93 = (a38 - a48);
            s04 = (a38 + a48);
            a58 = (0.70710678118654757*(t5e + t0f));
            a68 = (0.70710678118654757*(t6e - t9e));
            s14 = (a58 + a68);
            s24 = (a58 - a68);
            t5f = (t5d + t1f);
            t6f = (t6d + t2f);
            a78 = (0.70710678118654757*(t5d - t1f));
            a88 = (0.70710678118654757*(t6d - t2f));
            s34 = (a78 + a88);
            s44 = (a78 - a88);
            t7f = (t9d + s93);
            t8f = (t0e + s04);
            t9f = (t9d - s93);
            t0g = (t0e - s04);
            s54 = ((0.83146961230254524*t7f) - (0.55557023301960218*t8f));
            s64 = ((0.55557023301960218*t7f) + (0.83146961230254524*t8f));
            s74 = ((0.98078528040323043*t9f) + (0.19509032201612828*t0g));
            s84 = ((0.19509032201612828*t9f) - (0.98078528040323043*t0g));
            t1g = (t7d - t4f);
            t2g = (t8d + t3f);
            t3g = (t7d + t4f);
            t4g = (t8d - t3f);
            s94 = ((0.38268343236508978*t1g) - (0.92387953251128674*t2g));
            s05 = ((0.92387953251128674*t1g) + (0.38268343236508978*t2g));
            s15 = ((0.38268343236508978*t4g) - (0.92387953251128674*t3g));
            s25 = ((0.38268343236508978*t3g) + (0.92387953251128674*t4g));
            t5g = (t1e - s14);
            t6g = (t2e + s24);
            t7g = (t1e + s14);
            t8g = (t2e - s24);
            s35 = ((0.19509032201612828*t5g) + (0.98078528040323043*t6g));
            s45 = ((0.98078528040323043*t5g) - (0.19509032201612828*t6g));
            s55 = ((0.83146961230254524*t8g) - (0.55557023301960218*t7g));
            s65 = ((0.83146961230254524*t7g) + (0.55557023301960218*t8g));
            t9g = (t92 + t5b);
            t0h = (t03 + t6b);
            t1h = (t92 - t5b);
            t2h = (t03 - t6b);
            t3h = (t37 + t5f);
            t4h = (t47 + t6f);
            t5h = (t37 - t5f);
            t6h = (t47 - t6f);
            t7h = (t9g + t3h);
            t8h = (t0h + t4h);
            t9h = (t9g - t3h);
            t0i = (t0h - t4h);
            a98 = (64*i2);
            a09 = (D286 + a98);
            a19 = (a09 + 1);
            a29 = (a09 + 2);
            a39 = (a09 + 3);
            a49 = (T2 + a98);
            *(a49) = ((*(a09)*t7h) - (*(a19)*t8h));
            *((a49 + 1)) = ((*(a19)*t7h) + (*(a09)*t8h));
            *((a49 + 32)) = ((*(a29)*t9h) - (*(a39)*t0i));
            *((a49 + 33)) = ((*(a39)*t9h) + (*(a29)*t0i));
            t1i = (t1h - t6h);
            t2i = (t2h + t5h);
            t3i = (t1h + t6h);
            t4i = (t2h - t5h);
            a59 = (a09 + 4);
            a69 = (a09 + 5);
            a79 = (a09 + 6);
            a89 = (a09 + 7);
            *((a49 + 16)) = ((*(a59)*t1i) - (*(a69)*t2i));
            *((a49 + 17)) = ((*(a69)*t1i) + (*(a59)*t2i));
            *((a49 + 48)) = ((*(a79)*t3i) - (*(a89)*t4i));
            *((a49 + 49)) = ((*(a89)*t3i) + (*(a79)*t4i));
            t5i = (t33 + s72);
            t6i = (t43 + s82);
            t7i = (t33 - s72);
            t8i = (t43 - s82);
            t9i = (s11 + s54);
            t0j = (s21 + s64);
            t1j = (s11 - s54);
            t2j = (s21 - s64);
            t3j = (t5i + t9i);
            t4j = (t6i + t0j);
            t5j = (t5i - t9i);
            t6j = (t6i - t0j);
            a99 = (a09 + 8);
            a0a = (a09 + 9);
            a1a = (a09 + 10);
            a2a = (a09 + 11);
            *((a49 + 2)) = ((*(a99)*t3j) - (*(a0a)*t4j));
            *((a49 + 3)) = ((*(a0a)*t3j) + (*(a99)*t4j));
            *((a49 + 34)) = ((*(a1a)*t5j) - (*(a2a)*t6j));
            *((a49 + 35)) = ((*(a2a)*t5j) + (*(a1a)*t6j));
            t7j = (t7i - t2j);
            t8j = (t8i + t1j);
            t9j = (t7i + t2j);
            t0k = (t8i - t1j);
            a3a = (a09 + 12);
            a4a = (a09 + 13);
            a5a = (a09 + 14);
            a6a = (a09 + 15);
            *((a49 + 18)) = ((*(a3a)*t7j) - (*(a4a)*t8j));
            *((a49 + 19)) = ((*(a4a)*t7j) + (*(a3a)*t8j));
            *((a49 + 50)) = ((*(a5a)*t9j) - (*(a6a)*t0k));
            *((a49 + 51)) = ((*(a6a)*t9j) + (*(a5a)*t0k));
            t1k = (t73 + s13);
            t2k = (t83 + s23);
            t3k = (t73 - s13);
            t4k = (t83 - s23);
            t5k = (s51 + s94);
            t6k = (s61 + s05);
            t7k = (s51 - s94);
            t8k = (s61 - s05);
            t9k = (t1k + t5k);
            t0l = (t2k + t6k);
            t1l = (t1k - t5k);
            t2l = (t2k - t6k);
            a7a = (a09 + 16);
            a8a = (a09 + 17);
            a9a = (a09 + 18);
            a0b = (a09 + 19);
            *((a49 + 4)) = ((*(a7a)*t9k) - (*(a8a)*t0l));
            *((a49 + 5)) = ((*(a8a)*t9k) + (*(a7a)*t0l));
            *((a49 + 36)) = ((*(a9a)*t1l) - (*(a0b)*t2l));
            *((a49 + 37)) = ((*(a0b)*t1l) + (*(a9a)*t2l));
            t3l = (t3k - t8k);
            t4l = (t4k + t7k);
            t5l = (t3k + t8k);
            t6l = (t4k - t7k);
            a1b = (a09 + 20);
            a2b = (a09 + 21);
            a3b = (a09 + 22);
            a4b = (a09 + 23);
            *((a49 + 20)) = ((*(a1b)*t3l) - (*(a2b)*t4l));
            *((a49 + 21)) = ((*(a2b)*t3l) + (*(a1b)*t4l));
            *((a49 + 52)) = ((*(a3b)*t5l) - (*(a4b)*t6l));
            *((a49 + 53)) = ((*(a4b)*t5l) + (*(a3b)*t6l));
            t7l = (t14 + s53);
            t8l = (t24 + s63);
            t9l = (t14 - s53);
            t0m = (t24 - s63);
            t1m = (s91 - s35);
            t2m = (s02 + s45);
            t3m = (s91 + s35);
            t4m = (s02 - s45);
            t5m = (t7l + t1m);
            t6m = (t8l + t2m);
            t7m = (t7l - t1m);
            t8m = (t8l - t2m);
            a5b = (a09 + 24);
            a6b = (a09 + 25);
            a7b = (a09 + 26);
            a8b = (a09 + 27);
            *((a49 + 6)) = ((*(a5b)*t5m) - (*(a6b)*t6m));
            *((a49 + 7)) = ((*(a6b)*t5m) + (*(a5b)*t6m));
            *((a49 + 38)) = ((*(a7b)*t7m) - (*(a8b)*t8m));
            *((a49 + 39)) = ((*(a8b)*t7m) + (*(a7b)*t8m));
            t9m = (t9l - t4m);
            t0n = (t0m + t3m);
            t1n = (t9l + t4m);
            t2n = (t0m - t3m);
            a9b = (a09 + 28);
            a0c = (a09 + 29);
            a1c = (a09 + 30);
            a2c = (a09 + 31);
            *((a49 + 22)) = ((*(a9b)*t9m) - (*(a0c)*t0n));
            *((a49 + 23)) = ((*(a0c)*t9m) + (*(a9b)*t0n));
            *((a49 + 54)) = ((*(a1c)*t1n) - (*(a2c)*t2n));
            *((a49 + 55)) = ((*(a2c)*t1n) + (*(a1c)*t2n));
            t3n = (t13 - t8b);
            t4n = (t23 + t7b);
            t5n = (t13 + t8b);
            t6n = (t23 - t7b);
            t7n = (s9 - s34);
            t8n = (s01 + s44);
            t9n = (s9 + s34);
            t0o = (s01 - s44);
            t1o = (t3n + t7n);
            t2o = (t4n + t8n);
            t3o = (t3n - t7n);
            t4o = (t4n - t8n);
            a3c = (a09 + 32);
            a4c = (a09 + 33);
            a5c = (a09 + 34);
            a6c = (a09 + 35);
            *((a49 + 8)) = ((*(a3c)*t1o) - (*(a4c)*t2o));
            *((a49 + 9)) = ((*(a4c)*t1o) + (*(a3c)*t2o));
            *((a49 + 40)) = ((*(a5c)*t3o) - (*(a6c)*t4o));
            *((a49 + 41)) = ((*(a6c)*t3o) + (*(a5c)*t4o));
            t5o = (t5n - t0o);
            t6o = (t6n + t9n);
            t7o = (t5n + t0o);
            t8o = (t6n - t9n);
            a7c = (a09 + 36);
            a8c = (a09 + 37);
            a9c = (a09 + 38);
            a0d = (a09 + 39);
            *((a49 + 24)) = ((*(a7c)*t5o) - (*(a8c)*t6o));
            *((a49 + 25)) = ((*(a8c)*t5o) + (*(a7c)*t6o));
            *((a49 + 56)) = ((*(a9c)*t7o) - (*(a0d)*t8o));
            *((a49 + 57)) = ((*(a0d)*t7o) + (*(a9c)*t8o));
            t9o = (t53 - s92);
            t0p = (t63 + s03);
            t1p = (t53 + s92);
            t2p = (t63 - s03);
            t3p = (s31 - s74);
            t4p = (s41 + s84);
            t5p = (s31 + s74);
            t6p = (s41 - s84);
            t7p = (t9o + t3p);
            t8p = (t0p + t4p);
            t9p = (t9o - t3p);
            t0q = (t0p - t4p);
            a1d = (a09 + 40);
            a2d = (a09 + 41);
            a3d = (a09 + 42);
            a4d = (a09 + 43);
            *((a49 + 10)) = ((*(a1d)*t7p) - (*(a2d)*t8p));
            *((a49 + 11)) = ((*(a2d)*t7p) + (*(a1d)*t8p));
            *((a49 + 42)) = ((*(a3d)*t9p) - (*(a4d)*t0q));
            *((a49 + 43)) = ((*(a4d)*t9p) + (*(a3d)*t0q));
            t1q = (t1p - t6p);
            t2q = (t2p + t5p);
            t3q = (t1p + t6p);
            t4q = (t2p - t5p);
            a5d = (a09 + 44);
            a6d = (a09 + 45);
            a7d = (a09 + 46);
            a8d = (a09 + 47);
            *((a49 + 26)) = ((*(a5d)*t1q) - (*(a6d)*t2q));
            *((a49 + 27)) = ((*(a6d)*t1q) + (*(a5d)*t2q));
            *((a49 + 58)) = ((*(a7d)*t3q) - (*(a8d)*t4q));
            *((a49 + 59)) = ((*(a8d)*t3q) + (*(a7d)*t4q));
            t5q = (t93 - s33);
            t6q = (t04 + s43);
            t7q = (t93 + s33);
            t8q = (t04 - s43);
            t9q = (s71 + s15);
            t0r = (s81 - s25);
            t1r = (s71 - s15);
            t2r = (s81 + s25);
            t3r = (t5q + t9q);
            t4r = (t6q + t0r);
            t5r = (t5q - t9q);
            t6r = (t6q - t0r);
            a9d = (a09 + 48);
            a0e = (a09 + 49);
            a1e = (a09 + 50);
            a2e = (a09 + 51);
            *((a49 + 12)) = ((*(a9d)*t3r) - (*(a0e)*t4r));
            *((a49 + 13)) = ((*(a0e)*t3r) + (*(a9d)*t4r));
            *((a49 + 44)) = ((*(a1e)*t5r) - (*(a2e)*t6r));
            *((a49 + 45)) = ((*(a2e)*t5r) + (*(a1e)*t6r));
            t7r = (t7q - t2r);
            t8r = (t8q + t1r);
            t9r = (t7q + t2r);
            t0s = (t8q - t1r);
            a3e = (a09 + 52);
            a4e = (a09 + 53);
            a5e = (a09 + 54);
            a6e = (a09 + 55);
            *((a49 + 28)) = ((*(a3e)*t7r) - (*(a4e)*t8r));
            *((a49 + 29)) = ((*(a4e)*t7r) + (*(a3e)*t8r));
            *((a49 + 60)) = ((*(a5e)*t9r) - (*(a6e)*t0s));
            *((a49 + 61)) = ((*(a6e)*t9r) + (*(a5e)*t0s));
            t1s = (t34 - s73);
            t2s = (t44 + s83);
            t3s = (t34 + s73);
            t4s = (t44 - s83);
            t5s = (s12 + s55);
            t6s = (s22 - s65);
            t7s = (s12 - s55);
            t8s = (s22 + s65);
            t9s = (t1s + t5s);
            t0t = (t2s + t6s);
            t1t = (t1s - t5s);
            t2t = (t2s - t6s);
            a7e = (a09 + 56);
            a8e = (a09 + 57);
            a9e = (a09 + 58);
            a0f = (a09 + 59);
            *((a49 + 14)) = ((*(a7e)*t9s) - (*(a8e)*t0t));
            *((a49 + 15)) = ((*(a8e)*t9s) + (*(a7e)*t0t));
            *((a49 + 46)) = ((*(a9e)*t1t) - (*(a0f)*t2t));
            *((a49 + 47)) = ((*(a0f)*t1t) + (*(a9e)*t2t));
            t3t = (t3s - t8s);
            t4t = (t4s + t7s);
            t5t = (t3s + t8s);
            t6t = (t4s - t7s);
            a1f = (a09 + 60);
            a2f = (a09 + 61);
            a3f = (a09 + 62);
            a4f = (a09 + 63);
            *((a49 + 30)) = ((*(a1f)*t3t) - (*(a2f)*t4t));
            *((a49 + 31)) = ((*(a2f)*t3t) + (*(a1f)*t4t));
            *((a49 + 62)) = ((*(a3f)*t5t) - (*(a4f)*t6t));
            *((a49 + 63)) = ((*(a4f)*t5t) + (*(a3f)*t6t));
        }}
        {long i3; for(i3 = 0; i3 <= 31; i3++) {
            a5f = (2*i3);
            a6f = (T2 + a5f);
            a7f = (a6f + 1);
            a8f = (a6f + 512);
            a9f = (a6f + 513);
            t7t = (*(a6f) + *(a8f));
            t8t = (*(a7f) + *(a9f));
            t9t = (*(a6f) - *(a8f));
            t0u = (*(a7f) - *(a9f));
            a0g = (a6f + 256);
            a1g = (a6f + 257);
            a2g = (a6f + 768);
            a3g = (a6f + 769);
            t1u = (*(a0g) + *(a2g));
            t2u = (*(a1g) + *(a3g));
            t3u = (*(a0g) - *(a2g));
            t4u = (*(a1g) - *(a3g));
            t5u = (t7t + t1u);
            t6u = (t8t + t2u);
            t7u = (t7t - t1u);
            t8u = (t8t - t2u);
            t9u = (t9t - t4u);
            t0v = (t0u + t3u);
            t1v = (t9t + t4u);
            t2v = (t0u - t3u);
            a4g = (a6f + 64);
            a5g = (a6f + 65);
            a6g = (a6f + 576);
            a7g = (a6f + 577);
            t3v = (*(a4g) + *(a6g));
            t4v = (*(a5g) + *(a7g));
            t5v = (*(a4g) - *(a6g));
            t6v = (*(a5g) - *(a7g));
            a8g = (a6f + 320);
            a9g = (a6f + 321);
            a0h = (a6f + 832);
            a1h = (a6f + 833);
            t7v = (*(a8g) + *(a0h));
            t8v = (*(a9g) + *(a1h));
            t9v = (*(a8g) - *(a0h));
            t0w = (*(a9g) - *(a1h));
            t1w = (t3v + t7v);
            t2w = (t4v + t8v);
            a2h = (0.70710678118654757*(t3v - t7v));
            a3h = (0.70710678118654757*(t4v - t8v));
            s75 = (a2h - a3h);
            s85 = (a2h + a3h);
            t3w = (t5v - t0w);
            t4w = (t6v + t9v);
            t5w = (t5v + t0w);
            t6w = (t6v - t9v);
            s95 = ((0.92387953251128674*t3w) - (0.38268343236508978*t4w));
            s06 = ((0.38268343236508978*t3w) + (0.92387953251128674*t4w));
            s16 = ((0.38268343236508978*t5w) - (0.92387953251128674*t6w));
            s26 = ((0.92387953251128674*t5w) + (0.38268343236508978*t6w));
            a4h = (a6f + 128);
            a5h = (a6f + 129);
            a6h = (a6f + 640);
            a7h = (a6f + 641);
            t7w = (*(a4h) + *(a6h));
            t8w = (*(a5h) + *(a7h));
            t9w = (*(a4h) - *(a6h));
            t0x = (*(a5h) - *(a7h));
            a8h = (a6f + 384);
            a9h = (a6f + 385);
            a0i = (a6f + 896);
            a1i = (a6f + 897);
            t1x = (*(a8h) + *(a0i));
            t2x = (*(a9h) + *(a1i));
            t3x = (*(a8h) - *(a0i));
            t4x = (*(a9h) - *(a1i));
            t5x = (t7w + t1x);
            t6x = (t8w + t2x);
            t7x = (t7w - t1x);
            t8x = (t8w - t2x);
            a2i = (0.70710678118654757*(t9w - t4x));
            a3i = (0.70710678118654757*(t0x + t3x));
            s36 = (a2i - a3i);
            s46 = (a2i + a3i);
            a4i = (0.70710678118654757*(t9w + t4x));
            a5i = (0.70710678118654757*(t0x - t3x));
            s56 = (a4i + a5i);
            s66 = (a4i - a5i);
            a6i = (a6f + 192);
            a7i = (a6f + 193);
            a8i = (a6f + 704);
            a9i = (a6f + 705);
            t9x = (*(a6i) + *(a8i));
            t0y = (*(a7i) + *(a9i));
            t1y = (*(a6i) - *(a8i));
            t2y = (*(a7i) - *(a9i));
            a0j = (a6f + 448);
            a1j = (a6f + 449);
            a2j = (a6f + 960);
            a3j = (a6f + 961);
            t3y = (*(a0j) + *(a2j));
            t4y = (*(a1j) + *(a3j));
            t5y = (*(a0j) - *(a2j));
            t6y = (*(a1j) - *(a3j));
            t7y = (t9x + t3y);
            t8y = (t0y + t4y);
            a4j = (0.70710678118654757*(t9x - t3y));
            a5j = (0.70710678118654757*(t0y - t4y));
            s76 = (a4j + a5j);
            s86 = (a4j - a5j);
            t9y = (t1y - t6y);
            t0z = (t2y + t5y);
            t1z = (t1y + t6y);
            t2z = (t2y - t5y);
            s96 = ((0.38268343236508978*t9y) - (0.92387953251128674*t0z));
            s07 = ((0.92387953251128674*t9y) + (0.38268343236508978*t0z));
            s17 = ((0.38268343236508978*t2z) - (0.92387953251128674*t1z));
            s27 = ((0.38268343236508978*t1z) + (0.92387953251128674*t2z));
            t3z = (t5u + t5x);
            t4z = (t6u + t6x);
            t5z = (t5u - t5x);
            t6z = (t6u - t6x);
            t7z = (t1w + t7y);
            t8z = (t2w + t8y);
            t9z = (t1w - t7y);
            t0A = (t2w - t8y);
            t1A = (t3z + t7z);
            t2A = (t4z + t8z);
            t3A = (t3z - t7z);
            t4A = (t4z - t8z);
            a6j = (1024*i);
            a7j = (D289 + a6j + (32*i3));
            a8j = (a7j + 1);
            a9j = (a7j + 2);
            a0k = (a7j + 3);
            a1k = (T + a6j + a5f);
            *(a1k) = ((*(a7j)*t1A) - (*(a8j)*t2A));
            *((a1k + 1)) = ((*(a8j)*t1A) + (*(a7j)*t2A));
            *((a1k + 512)) = ((*(a9j)*t3A) - (*(a0k)*t4A));
            *((a1k + 513)) = ((*(a0k)*t3A) + (*(a9j)*t4A));
            t5A = (t5z - t0A);
            t6A = (t6z + t9z);
            t7A = (t5z + t0A);
            t8A = (t6z - t9z);
            a2k = (a7j + 4);
            a3k = (a7j + 5);
            a4k = (a7j + 6);
            a5k = (a7j + 7);
            *((a1k + 256)) = ((*(a2k)*t5A) - (*(a3k)*t6A));
            *((a1k + 257)) = ((*(a3k)*t5A) + (*(a2k)*t6A));
            *((a1k + 768)) = ((*(a4k)*t7A) - (*(a5k)*t8A));
            *((a1k + 769)) = ((*(a5k)*t7A) + (*(a4k)*t8A));
            t9A = (t9u + s36);
            t0B = (t0v + s46);
            t1B = (t9u - s36);
            t2B = (t0v - s46);
            t3B = (s95 + s96);
            t4B = (s06 + s07);
            t5B = (s95 - s96);
            t6B = (s06 - s07);
            t7B = (t9A + t3B);
            t8B = (t0B + t4B);
            t9B = (t9A - t3B);
            t0C = (t0B - t4B);
            a6k = (a7j + 8);
            a7k = (a7j + 9);
            a8k = (a7j + 10);
            a9k = (a7j + 11);
            *((a1k + 64)) = ((*(a6k)*t7B) - (*(a7k)*t8B));
            *((a1k + 65)) = ((*(a7k)*t7B) + (*(a6k)*t8B));
            *((a1k + 576)) = ((*(a8k)*t9B) - (*(a9k)*t0C));
            *((a1k + 577)) = ((*(a9k)*t9B) + (*(a8k)*t0C));
            t1C = (t1B - t6B);
            t2C = (t2B + t5B);
            t3C = (t1B + t6B);
            t4C = (t2B - t5B);
            a0l = (a7j + 12);
            a1l = (a7j + 13);
            a2l = (a7j + 14);
            a3l = (a7j + 15);
            *((a1k + 320)) = ((*(a0l)*t1C) - (*(a1l)*t2C));
            *((a1k + 321)) = ((*(a1l)*t1C) + (*(a0l)*t2C));
            *((a1k + 832)) = ((*(a2l)*t3C) - (*(a3l)*t4C));
            *((a1k + 833)) = ((*(a3l)*t3C) + (*(a2l)*t4C));
            t5C = (t7u - t8x);
            t6C = (t8u + t7x);
            t7C = (t7u + t8x);
            t8C = (t8u - t7x);
            t9C = (s75 - s76);
            t0D = (s85 + s86);
            t1D = (s75 + s76);
            t2D = (s85 - s86);
            t3D = (t5C + t9C);
            t4D = (t6C + t0D);
            t5D = (t5C - t9C);
            t6D = (t6C - t0D);
            a4l = (a7j + 16);
            a5l = (a7j + 17);
            a6l = (a7j + 18);
            a7l = (a7j + 19);
            *((a1k + 128)) = ((*(a4l)*t3D) - (*(a5l)*t4D));
            *((a1k + 129)) = ((*(a5l)*t3D) + (*(a4l)*t4D));
            *((a1k + 640)) = ((*(a6l)*t5D) - (*(a7l)*t6D));
            *((a1k + 641)) = ((*(a7l)*t5D) + (*(a6l)*t6D));
            t7D = (t7C - t2D);
            t8D = (t8C + t1D);
            t9D = (t7C + t2D);
            t0E = (t8C - t1D);
            a8l = (a7j + 20);
            a9l = (a7j + 21);
            a0m = (a7j + 22);
            a1m = (a7j + 23);
            *((a1k + 384)) = ((*(a8l)*t7D) - (*(a9l)*t8D));
            *((a1k + 385)) = ((*(a9l)*t7D) + (*(a8l)*t8D));
            *((a1k + 896)) = ((*(a0m)*t9D) - (*(a1m)*t0E));
            *((a1k + 897)) = ((*(a1m)*t9D) + (*(a0m)*t0E));
            t1E = (t1v - s56);
            t2E = (t2v + s66);
            t3E = (t1v + s56);
            t4E = (t2v - s66);
            t5E = (s16 + s17);
            t6E = (s26 - s27);
            t7E = (s16 - s17);
            t8E = (s26 + s27);
            t9E = (t1E + t5E);
            t0F = (t2E + t6E);
            t1F = (t1E - t5E);
            t2F = (t2E - t6E);
            a2m = (a7j + 24);
            a3m = (a7j + 25);
            a4m = (a7j + 26);
            a5m = (a7j + 27);
            *((a1k + 192)) = ((*(a2m)*t9E) - (*(a3m)*t0F));
            *((a1k + 193)) = ((*(a3m)*t9E) + (*(a2m)*t0F));
            *((a1k + 704)) = ((*(a4m)*t1F) - (*(a5m)*t2F));
            *((a1k + 705)) = ((*(a5m)*t1F) + (*(a4m)*t2F));
            t3F = (t3E - t8E);
            t4F = (t4E + t7E);
            t5F = (t3E + t8E);
            t6F = (t4E - t7E);
            a6m = (a7j + 28);
            a7m = (a7j + 29);
            a8m = (a7j + 30);
            a9m = (a7j + 31);
            *((a1k + 448)) = ((*(a6m)*t3F) - (*(a7m)*t4F));
            *((a1k + 449)) = ((*(a7m)*t3F) + (*(a6m)*t4F));
            *((a1k + 960)) = ((*(a8m)*t5F) - (*(a9m)*t6F));
            *((a1k + 961)) = ((*(a9m)*t5F) + (*(a8m)*t6F));
        }}
    }}
    {long i4; for(i4 = 0; i4 <= 511; i4++) {
        a0n = (2*i4);
        a1n = (T + a0n);
        a2n = (a1n + 1);
        a3n = (a1n + 4096);
        a4n = (a1n + 4097);
        t7F = (*(a1n) + *(a3n));
        t8F = (*(a2n) + *(a4n));
        t9F = (*(a1n) - *(a3n));
        t0G = (*(a2n) - *(a4n));
        a5n = (a1n + 2048);
        a6n = (a1n + 2049);
        a7n = (a1n + 6144);
        a8n = (a1n + 6145);
        t1G = (*(a5n) + *(a7n));
        t2G = (*(a6n) + *(a8n));
        t3G = (*(a5n) - *(a7n));
        t4G = (*(a6n) - *(a8n));
        t5G = (t7F + t1G);
        t6G = (t8F + t2G);
        t7G = (t7F - t1G);
        t8G = (t8F - t2G);
        t9G = (t9F - t4G);
        t0H = (t0G + t3G);
        t1H = (t9F + t4G);
        t2H = (t0G - t3G);
        a9n = (a1n + 1024);
        a0o = (a1n + 1025);
        a1o = (a1n + 5120);
        a2o = (a1n + 5121);
        t3H = (*(a9n) + *(a1o));
        t4H = (*(a0o) + *(a2o));
        t5H = (*(a9n) - *(a1o));
        t6H = (*(a0o) - *(a2o));
        a3o = (a1n + 3072);
        a4o = (a1n + 3073);
        a5o = (a1n + 7168);
        a6o = (a1n + 7169);
        t7H = (*(a3o) + *(a5o));
        t8H = (*(a4o) + *(a6o));
        t9H = (*(a3o) - *(a5o));
        t0I = (*(a4o) - *(a6o));
        t1I = (t3H + t7H);
        t2I = (t4H + t8H);
        t3I = (t3H - t7H);
        t4I = (t4H - t8H);
        a7o = (0.70710678118654757*(t5H - t0I));
        a8o = (0.70710678118654757*(t6H + t9H));
        s37 = (a7o - a8o);
        s47 = (a7o + a8o);
        a9o = (0.70710678118654757*(t5H + t0I));
        a0p = (0.70710678118654757*(t6H - t9H));
        s57 = (a9o + a0p);
        s67 = (a9o - a0p);
        a1p = (dst + a0n);
        *(a1p) = (t5G + t1I);
        *((a1p + 1)) = (t6G + t2I);
        *((a1p + 4096)) = (t5G - t1I);
        *((a1p + 4097)) = (t6G - t2I);
        *((a1p + 1024)) = (t9G + s37);
        *((a1p + 1025)) = (t0H + s47);
        *((a1p + 5120)) = (t9G - s37);
        *((a1p + 5121)) = (t0H - s47);
        *((a1p + 2048)) = (t7G - t4I);
        *((a1p + 2049)) = (t8G + t3I);
        *((a1p + 6144)) = (t7G + t4I);
        *((a1p + 6145)) = (t8G - t3I);
        *((a1p + 3072)) = (t1H - s57);
        *((a1p + 3073)) = (t2H + s67);
        *((a1p + 7168)) = (t1H + s57);
        *((a1p + 7169)) = (t2H - s67);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_double_8192)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[16384];
     double T2[2048];
     double T3[128];
    double  *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a0c, *a0e, *a0f, *a0g, *a15, *a16, *a17, *a18, *a1a, *a1b, *a1c, *a1e, *a1g, *a24, *a25
            , *a26, *a27, *a28, *a2a, *a2b, *a2c, *a2e, *a2f, *a2g, *a2h, *a34, *a35, *a36, *a37, *a38, *a3a, *a3b, *a3c, *a3e, *a3f, *a3g, *a44
            , *a45, *a46, *a47, *a48, *a4a, *a4b, *a4c, *a4d, *a4e, *a4f, *a4g, *a54, *a55, *a56, *a57, *a58, *a5a, *a5b, *a5c, *a5d, *a5e, *a5f
            , *a5g, *a64, *a65, *a66, *a67, *a68, *a69, *a6a, *a6b, *a6c, *a6d, *a6e, *a6f, *a6g, *a74, *a75, *a76, *a77, *a78, *a79, *a7a, *a7b
            , *a7c, *a7d, *a7e, *a7f, *a7g, *a84, *a85, *a86, *a87, *a88, *a89, *a8a, *a8b, *a8c, *a8d, *a8e, *a8f, *a94, *a95, *a96, *a97, *a98
            , *a99, *a9a, *a9b, *a9d, *a9e, *a9f;
    const double  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a1f, a3d, a59;
    double a03, a04, a0d, a0h, a19, a1d, a1h, a29, a2d, a39, a49, a71, a72, a81, a82, a8g, a92, a93, a9c, a9g, s, s01
            , s02, s11, s12, s2, s21, s22, s3, s31, s32, s4, s41, s42, s5, s51, s52, s6, s61, s62, s7, s71, s72, s8
            , s81, s82, s9, s91, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h
            , t0i, t0j, t0k, t0l, t0m, t0n, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g
            , t1h, t1i, t1j, t1k, t1l, t1m, t1n, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e
            , t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c
            , t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l, t3m, t3n, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a
            , t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t5, t51, t52, t53, t54, t55, t56, t57, t58
            , t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t6, t61, t62, t63, t64, t65, t66
            , t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t7, t71, t72, t73, t74
            , t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m, t8, t81, t82, t83
            , t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t9, t91, t92
            , t93, t94, t95, t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m;
    {long i; for(i = 0; i <= 7; i++) {
        {long i2; for(i2 = 0; i2 <= 63; i2++) {
            a = (src + (2*i) + (16*i2));
            a2 = (a + 1);
            a3 = (a + 8192);
            a4 = (a + 8193);
            t = (*(a) + *(a3));
            t2 = (*(a2) + *(a4));
            t3 = (*(a) - *(a3));
            t4 = (*(a2) - *(a4));
            a5 = (a + 4096);
            a6 = (a + 4097);
            a7 = (a + 12288);
            a8 = (a + 12289);
            t5 = (*(a5) + *(a7));
            t6 = (*(a6) + *(a8));
            t7 = (*(a5) - *(a7));
            t8 = (*(a6) - *(a8));
            t9 = (t + t5);
            t01 = (t2 + t6);
            t11 = (t - t5);
            t21 = (t2 - t6);
            t31 = (t3 - t8);
            t41 = (t4 + t7);
            t51 = (t3 + t8);
            t61 = (t4 - t7);
            a9 = (a + 1024);
            a01 = (a + 1025);
            a11 = (a + 9216);
            a21 = (a + 9217);
            t71 = (*(a9) + *(a11));
            t81 = (*(a01) + *(a21));
            t91 = (*(a9) - *(a11));
            t02 = (*(a01) - *(a21));
            a31 = (a + 5120);
            a41 = (a + 5121);
            a51 = (a + 13312);
            a61 = (a + 13313);
            t12 = (*(a31) + *(a51));
            t22 = (*(a41) + *(a61));
            t32 = (*(a31) - *(a51));
            t42 = (*(a41) - *(a61));
            t52 = (t71 + t12);
            t62 = (t81 + t22);
            a71 = (0.70710678118654757*(t71 - t12));
            a81 = (0.70710678118654757*(t81 - t22));
            s = (a71 - a81);
            s2 = (a71 + a81);
            t72 = (t91 - t42);
            t82 = (t02 + t32);
            t92 = (t91 + t42);
            t03 = (t02 - t32);
            s3 = ((0.92387953251128674*t72) - (0.38268343236508978*t82));
            s4 = ((0.38268343236508978*t72) + (0.92387953251128674*t82));
            s5 = ((0.38268343236508978*t92) - (0.92387953251128674*t03));
            s6 = ((0.92387953251128674*t92) + (0.38268343236508978*t03));
            a91 = (a + 2048);
            a02 = (a + 2049);
            a12 = (a + 10240);
            a22 = (a + 10241);
            t13 = (*(a91) + *(a12));
            t23 = (*(a02) + *(a22));
            t33 = (*(a91) - *(a12));
            t43 = (*(a02) - *(a22));
            a32 = (a + 6144);
            a42 = (a + 6145);
            a52 = (a + 14336);
            a62 = (a + 14337);
            t53 = (*(a32) + *(a52));
            t63 = (*(a42) + *(a62));
            t73 = (*(a32) - *(a52));
            t83 = (*(a42) - *(a62));
            t93 = (t13 + t53);
            t04 = (t23 + t63);
            t14 = (t13 - t53);
            t24 = (t23 - t63);
            a72 = (0.70710678118654757*(t33 - t83));
            a82 = (0.70710678118654757*(t43 + t73));
            s7 = (a72 - a82);
            s8 = (a72 + a82);
            a92 = (0.70710678118654757*(t33 + t83));
            a03 = (0.70710678118654757*(t43 - t73));
            s9 = (a92 + a03);
            s01 = (a92 - a03);
            a13 = (a + 3072);
            a23 = (a + 3073);
            a33 = (a + 11264);
            a43 = (a + 11265);
            t34 = (*(a13) + *(a33));
            t44 = (*(a23) + *(a43));
            t54 = (*(a13) - *(a33));
            t64 = (*(a23) - *(a43));
            a53 = (a + 7168);
            a63 = (a + 7169);
            a73 = (a + 15360);
            a83 = (a + 15361);
            t74 = (*(a53) + *(a73));
            t84 = (*(a63) + *(a83));
            t94 = (*(a53) - *(a73));
            t05 = (*(a63) - *(a83));
            t15 = (t34 + t74);
            t25 = (t44 + t84);
            a93 = (0.70710678118654757*(t34 - t74));
            a04 = (0.70710678118654757*(t44 - t84));
            s11 = (a93 + a04);
            s21 = (a93 - a04);
            t35 = (t54 - t05);
            t45 = (t64 + t94);
            t55 = (t54 + t05);
            t65 = (t64 - t94);
            s31 = ((0.38268343236508978*t35) - (0.92387953251128674*t45));
            s41 = ((0.92387953251128674*t35) + (0.38268343236508978*t45));
            s51 = ((0.38268343236508978*t65) - (0.92387953251128674*t55));
            s61 = ((0.38268343236508978*t55) + (0.92387953251128674*t65));
            t75 = (t9 + t93);
            t85 = (t01 + t04);
            t95 = (t9 - t93);
            t06 = (t01 - t04);
            t16 = (t52 + t15);
            t26 = (t62 + t25);
            t36 = (t52 - t15);
            t46 = (t62 - t25);
            t56 = (t75 + t16);
            t66 = (t85 + t26);
            t76 = (t75 - t16);
            t86 = (t85 - t26);
            a14 = (32*i2);
            a24 = (D287 + a14);
            a34 = (a24 + 1);
            a44 = (a24 + 2);
            a54 = (a24 + 3);
            a64 = (T2 + a14);
            *(a64) = ((*(a24)*t56) - (*(a34)*t66));
            *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
            *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
            *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
            t96 = (t95 - t46);
            t07 = (t06 + t36);
            t17 = (t95 + t46);
            t27 = (t06 - t36);
            a74 = (a24 + 4);
            a84 = (a24 + 5);
            a94 = (a24 + 6);
            a05 = (a24 + 7);
            *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
            *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
            *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
            *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
            t37 = (t31 + s7);
            t47 = (t41 + s8);
            t57 = (t31 - s7);
            t67 = (t41 - s8);
            t77 = (s3 + s31);
            t87 = (s4 + s41);
            t97 = (s3 - s31);
            t08 = (s4 - s41);
            t18 = (t37 + t77);
            t28 = (t47 + t87);
            t38 = (t37 - t77);
            t48 = (t47 - t87);
            a15 = (a24 + 8);
            a25 = (a24 + 9);
            a35 = (a24 + 10);
            a45 = (a24 + 11);
            *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
            *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
            *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
            *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
            t58 = (t57 - t08);
            t68 = (t67 + t97);
            t78 = (t57 + t08);
            t88 = (t67 - t97);
            a55 = (a24 + 12);
            a65 = (a24 + 13);
            a75 = (a24 + 14);
            a85 = (a24 + 15);
            *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
            *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
            *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
            *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
            t98 = (t11 - t24);
            t09 = (t21 + t14);
            t19 = (t11 + t24);
            t29 = (t21 - t14);
            t39 = (s - s11);
            t49 = (s2 + s21);
            t59 = (s + s11);
            t69 = (s2 - s21);
            t79 = (t98 + t39);
            t89 = (t09 + t49);
            t99 = (t98 - t39);
            t0a = (t09 - t49);
            a95 = (a24 + 16);
            a06 = (a24 + 17);
            a16 = (a24 + 18);
            a26 = (a24 + 19);
            *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
            *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
            *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
            *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
            t1a = (t19 - t69);
            t2a = (t29 + t59);
            t3a = (t19 + t69);
            t4a = (t29 - t59);
            a36 = (a24 + 20);
            a46 = (a24 + 21);
            a56 = (a24 + 22);
            a66 = (a24 + 23);
            *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
            *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
            *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
            *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
            t5a = (t51 - s9);
            t6a = (t61 + s01);
            t7a = (t51 + s9);
            t8a = (t61 - s01);
            t9a = (s5 + s51);
            t0b = (s6 - s61);
            t1b = (s5 - s51);
            t2b = (s6 + s61);
            t3b = (t5a + t9a);
            t4b = (t6a + t0b);
            t5b = (t5a - t9a);
            t6b = (t6a - t0b);
            a76 = (a24 + 24);
            a86 = (a24 + 25);
            a96 = (a24 + 26);
            a07 = (a24 + 27);
            *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
            *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
            *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
            *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
            t7b = (t7a - t2b);
            t8b = (t8a + t1b);
            t9b = (t7a + t2b);
            t0c = (t8a - t1b);
            a17 = (a24 + 28);
            a27 = (a24 + 29);
            a37 = (a24 + 30);
            a47 = (a24 + 31);
            *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
            *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
            *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
            *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
        }}
        {long i3; for(i3 = 0; i3 <= 15; i3++) {
            {long i4; for(i4 = 0; i4 <= 7; i4++) {
                a57 = (T2 + (2*i3) + (32*i4));
                a67 = (a57 + 1);
                a77 = (a57 + 1024);
                a87 = (a57 + 1025);
                t1c = (*(a57) + *(a77));
                t2c = (*(a67) + *(a87));
                t3c = (*(a57) - *(a77));
                t4c = (*(a67) - *(a87));
                a97 = (a57 + 512);
                a08 = (a57 + 513);
                a18 = (a57 + 1536);
                a28 = (a57 + 1537);
                t5c = (*(a97) + *(a18));
                t6c = (*(a08) + *(a28));
                t7c = (*(a97) - *(a18));
                t8c = (*(a08) - *(a28));
                t9c = (t1c + t5c);
                t0d = (t2c + t6c);
                t1d = (t1c - t5c);
                t2d = (t2c - t6c);
                t3d = (t3c - t8c);
                t4d = (t4c + t7c);
                t5d = (t3c + t8c);
                t6d = (t4c - t7c);
                a38 = (a57 + 256);
                a48 = (a57 + 257);
                a58 = (a57 + 1280);
                a68 = (a57 + 1281);
                t7d = (*(a38) + *(a58));
                t8d = (*(a48) + *(a68));
                t9d = (*(a38) - *(a58));
                t0e = (*(a48) - *(a68));
                a78 = (a57 + 768);
                a88 = (a57 + 769);
                a98 = (a57 + 1792);
                a09 = (a57 + 1793);
                t1e = (*(a78) + *(a98));
                t2e = (*(a88) + *(a09));
                t3e = (*(a78) - *(a98));
                t4e = (*(a88) - *(a09));
                t5e = (t7d + t1e);
                t6e = (t8d + t2e);
                t7e = (t7d - t1e);
                t8e = (t8d - t2e);
                a19 = (0.70710678118654757*(t9d - t4e));
                a29 = (0.70710678118654757*(t0e + t3e));
                s71 = (a19 - a29);
                s81 = (a19 + a29);
                a39 = (0.70710678118654757*(t9d + t4e));
                a49 = (0.70710678118654757*(t0e - t3e));
                s91 = (a39 + a49);
                s02 = (a39 - a49);
                t9e = (t9c + t5e);
                t0f = (t0d + t6e);
                t1f = (t9c - t5e);
                t2f = (t0d - t6e);
                a59 = (16*i4);
                a69 = (D283 + a59);
                a79 = (a69 + 1);
                a89 = (a69 + 2);
                a99 = (a69 + 3);
                a0a = (T3 + a59);
                *(a0a) = ((*(a69)*t9e) - (*(a79)*t0f));
                *((a0a + 1)) = ((*(a79)*t9e) + (*(a69)*t0f));
                *((a0a + 8)) = ((*(a89)*t1f) - (*(a99)*t2f));
                *((a0a + 9)) = ((*(a99)*t1f) + (*(a89)*t2f));
                t3f = (t3d + s71);
                t4f = (t4d + s81);
                t5f = (t3d - s71);
                t6f = (t4d - s81);
                a1a = (a69 + 4);
                a2a = (a69 + 5);
                a3a = (a69 + 6);
                a4a = (a69 + 7);
                *((a0a + 2)) = ((*(a1a)*t3f) - (*(a2a)*t4f));
                *((a0a + 3)) = ((*(a2a)*t3f) + (*(a1a)*t4f));
                *((a0a + 10)) = ((*(a3a)*t5f) - (*(a4a)*t6f));
                *((a0a + 11)) = ((*(a4a)*t5f) + (*(a3a)*t6f));
                t7f = (t1d - t8e);
                t8f = (t2d + t7e);
                t9f = (t1d + t8e);
                t0g = (t2d - t7e);
                a5a = (a69 + 8);
                a6a = (a69 + 9);
                a7a = (a69 + 10);
                a8a = (a69 + 11);
                *((a0a + 4)) = ((*(a5a)*t7f) - (*(a6a)*t8f));
                *((a0a + 5)) = ((*(a6a)*t7f) + (*(a5a)*t8f));
                *((a0a + 12)) = ((*(a7a)*t9f) - (*(a8a)*t0g));
                *((a0a + 13)) = ((*(a8a)*t9f) + (*(a7a)*t0g));
                t1g = (t5d - s91);
                t2g = (t6d + s02);
                t3g = (t5d + s91);
                t4g = (t6d - s02);
                a9a = (a69 + 12);
                a0b = (a69 + 13);
                a1b = (a69 + 14);
                a2b = (a69 + 15);
                *((a0a + 6)) = ((*(a9a)*t1g) - (*(a0b)*t2g));
                *((a0a + 7)) = ((*(a0b)*t1g) + (*(a9a)*t2g));
                *((a0a + 14)) = ((*(a1b)*t3g) - (*(a2b)*t4g));
                *((a0a + 15)) = ((*(a2b)*t3g) + (*(a1b)*t4g));
            }}
            {long i5; for(i5 = 0; i5 <= 7; i5++) {
                a3b = (T3 + (2*i5));
                a4b = (a3b + 1);
                a5b = (a3b + 64);
                a6b = (a3b + 65);
                t5g = (*(a3b) + *(a5b));
                t6g = (*(a4b) + *(a6b));
                t7g = (*(a3b) - *(a5b));
                t8g = (*(a4b) - *(a6b));
                a7b = (a3b + 32);
                a8b = (a3b + 33);
                a9b = (a3b + 96);
                a0c = (a3b + 97);
                t9g = (*(a7b) + *(a9b));
                t0h = (*(a8b) + *(a0c));
                t1h = (*(a7b) - *(a9b));
                t2h = (*(a8b) - *(a0c));
                t3h = (t5g + t9g);
                t4h = (t6g + t0h);
                t5h = (t5g - t9g);
                t6h = (t6g - t0h);
                t7h = (t7g - t2h);
                t8h = (t8g + t1h);
                t9h = (t7g + t2h);
                t0i = (t8g - t1h);
                a1c = (a3b + 16);
                a2c = (a3b + 17);
                a3c = (a3b + 80);
                a4c = (a3b + 81);
                t1i = (*(a1c) + *(a3c));
                t2i = (*(a2c) + *(a4c));
                t3i = (*(a1c) - *(a3c));
                t4i = (*(a2c) - *(a4c));
                a5c = (a3b + 48);
                a6c = (a3b + 49);
                a7c = (a3b + 112);
                a8c = (a3b + 113);
                t5i = (*(a5c) + *(a7c));
                t6i = (*(a6c) + *(a8c));
                t7i = (*(a5c) - *(a7c));
                t8i = (*(a6c) - *(a8c));
                t9i = (t1i + t5i);
                t0j = (t2i + t6i);
                t1j = (t1i - t5i);
                t2j = (t2i - t6i);
                a9c = (0.70710678118654757*(t3i - t8i));
                a0d = (0.70710678118654757*(t4i + t7i));
                s12 = (a9c - a0d);
                s22 = (a9c + a0d);
                a1d = (0.70710678118654757*(t3i + t8i));
                a2d = (0.70710678118654757*(t4i - t7i));
                s32 = (a1d + a2d);
                s42 = (a1d - a2d);
                t3j = (t3h + t9i);
                t4j = (t4h + t0j);
                t5j = (t3h - t9i);
                t6j = (t4h - t0j);
                a3d = (2048*i);
                a4d = (D290 + a3d + (128*i3) + (16*i5));
                a5d = (a4d + 1);
                a6d = (a4d + 2);
                a7d = (a4d + 3);
                a8d = (T + a3d + (2*i3) + (32*i5));
                *(a8d) = ((*(a4d)*t3j) - (*(a5d)*t4j));
                *((a8d + 1)) = ((*(a5d)*t3j) + (*(a4d)*t4j));
                *((a8d + 1024)) = ((*(a6d)*t5j) - (*(a7d)*t6j));
                *((a8d + 1025)) = ((*(a7d)*t5j) + (*(a6d)*t6j));
                t7j = (t7h + s12);
                t8j = (t8h + s22);
                t9j = (t7h - s12);
                t0k = (t8h - s22);
                a9d = (a4d + 4);
                a0e = (a4d + 5);
                a1e = (a4d + 6);
                a2e = (a4d + 7);
                *((a8d + 256)) = ((*(a9d)*t7j) - (*(a0e)*t8j));
                *((a8d + 257)) = ((*(a0e)*t7j) + (*(a9d)*t8j));
                *((a8d + 1280)) = ((*(a1e)*t9j) - (*(a2e)*t0k));
                *((a8d + 1281)) = ((*(a2e)*t9j) + (*(a1e)*t0k));
                t1k = (t5h - t2j);
                t2k = (t6h + t1j);
                t3k = (t5h + t2j);
                t4k = (t6h - t1j);
                a3e = (a4d + 8);
                a4e = (a4d + 9);
                a5e = (a4d + 10);
                a6e = (a4d + 11);
                *((a8d + 512)) = ((*(a3e)*t1k) - (*(a4e)*t2k));
                *((a8d + 513)) = ((*(a4e)*t1k) + (*(a3e)*t2k));
                *((a8d + 1536)) = ((*(a5e)*t3k) - (*(a6e)*t4k));
                *((a8d + 1537)) = ((*(a6e)*t3k) + (*(a5e)*t4k));
                t5k = (t9h - s32);
                t6k = (t0i + s42);
                t7k = (t9h + s32);
                t8k = (t0i - s42);
                a7e = (a4d + 12);
                a8e = (a4d + 13);
                a9e = (a4d + 14);
                a0f = (a4d + 15);
                *((a8d + 768)) = ((*(a7e)*t5k) - (*(a8e)*t6k));
                *((a8d + 769)) = ((*(a8e)*t5k) + (*(a7e)*t6k));
                *((a8d + 1792)) = ((*(a9e)*t7k) - (*(a0f)*t8k));
                *((a8d + 1793)) = ((*(a0f)*t7k) + (*(a9e)*t8k));
            }}
        }}
    }}
    {long i6; for(i6 = 0; i6 <= 1023; i6++) {
        a1f = (2*i6);
        a2f = (T + a1f);
        a3f = (a2f + 1);
        a4f = (a2f + 8192);
        a5f = (a2f + 8193);
        t9k = (*(a2f) + *(a4f));
        t0l = (*(a3f) + *(a5f));
        t1l = (*(a2f) - *(a4f));
        t2l = (*(a3f) - *(a5f));
        a6f = (a2f + 4096);
        a7f = (a2f + 4097);
        a8f = (a2f + 12288);
        a9f = (a2f + 12289);
        t3l = (*(a6f) + *(a8f));
        t4l = (*(a7f) + *(a9f));
        t5l = (*(a6f) - *(a8f));
        t6l = (*(a7f) - *(a9f));
        t7l = (t9k + t3l);
        t8l = (t0l + t4l);
        t9l = (t9k - t3l);
        t0m = (t0l - t4l);
        t1m = (t1l - t6l);
        t2m = (t2l + t5l);
        t3m = (t1l + t6l);
        t4m = (t2l - t5l);
        a0g = (a2f + 2048);
        a1g = (a2f + 2049);
        a2g = (a2f + 10240);
        a3g = (a2f + 10241);
        t5m = (*(a0g) + *(a2g));
        t6m = (*(a1g) + *(a3g));
        t7m = (*(a0g) - *(a2g));
        t8m = (*(a1g) - *(a3g));
        a4g = (a2f + 6144);
        a5g = (a2f + 6145);
        a6g = (a2f + 14336);
        a7g = (a2f + 14337);
        t9m = (*(a4g) + *(a6g));
        t0n = (*(a5g) + *(a7g));
        t1n = (*(a4g) - *(a6g));
        t2n = (*(a5g) - *(a7g));
        t3n = (t5m + t9m);
        t4n = (t6m + t0n);
        t5n = (t5m - t9m);
        t6n = (t6m - t0n);
        a8g = (0.70710678118654757*(t7m - t2n));
        a9g = (0.70710678118654757*(t8m + t1n));
        s52 = (a8g - a9g);
        s62 = (a8g + a9g);
        a0h = (0.70710678118654757*(t7m + t2n));
        a1h = (0.70710678118654757*(t8m - t1n));
        s72 = (a0h + a1h);
        s82 = (a0h - a1h);
        a2h = (dst + a1f);
        *(a2h) = (t7l + t3n);
        *((a2h + 1)) = (t8l + t4n);
        *((a2h + 8192)) = (t7l - t3n);
        *((a2h + 8193)) = (t8l - t4n);
        *((a2h + 2048)) = (t1m + s52);
        *((a2h + 2049)) = (t2m + s62);
        *((a2h + 10240)) = (t1m - s52);
        *((a2h + 10241)) = (t2m - s62);
        *((a2h + 4096)) = (t9l - t6n);
        *((a2h + 4097)) = (t0m + t5n);
        *((a2h + 12288)) = (t9l + t6n);
        *((a2h + 12289)) = (t0m - t5n);
        *((a2h + 6144)) = (t3m - s72);
        *((a2h + 6145)) = (t4m + s82);
        *((a2h + 14336)) = (t3m + s72);
        *((a2h + 14337)) = (t4m - s82);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_double_2)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    {const double  *a, *a2, *a3;
    a = (src + 2);
    a2 = (src + 1);
    a3 = (src + 3);
    *(dst) = (*(src) + *(a));
    *((dst + 1)) = (*(a2) + *(a3));
    *((dst + 2)) = (*(src) - *(a));
    *((dst + 3)) = (*(a2) - *(a3));
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_double_4)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    {const double  *a, *a2, *a3, *a4, *a5, *a6, *a7;
    double t, t2, t3, t4, t5, t6, t7, t8;
    a = (src + 4);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 5);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 2);
    a5 = (src + 6);
    t5 = (*(a4) + *(a5));
    a6 = (src + 3);
    a7 = (src + 7);
    t6 = (*(a6) + *(a7));
    t7 = (*(a4) - *(a5));
    t8 = (*(a6) - *(a7));
    *(dst) = (t + t5);
    *((dst + 1)) = (t2 + t6);
    *((dst + 4)) = (t - t5);
    *((dst + 5)) = (t2 - t6);
    *((dst + 2)) = (t3 + t8);
    *((dst + 3)) = (t4 - t7);
    *((dst + 6)) = (t3 - t8);
    *((dst + 7)) = (t4 + t7);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_double_8)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    {const double  *a, *a01, *a11, *a2, *a21, *a3, *a31, *a4, *a41, *a5, *a51, *a6, *a7, *a8, *a9;
    double a61, a71, a81, a91, s, s2, s3, s4, t, t01, t02, t11, t12, t2, t21, t22, t3, t31, t32, t4, t41, t42
            , t5, t51, t52, t6, t61, t62, t7, t71, t72, t8, t81, t82, t9, t91;
    a = (src + 8);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 9);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 4);
    a5 = (src + 12);
    t5 = (*(a4) + *(a5));
    a6 = (src + 5);
    a7 = (src + 13);
    t6 = (*(a6) + *(a7));
    t7 = (*(a4) - *(a5));
    t8 = (*(a6) - *(a7));
    t9 = (t + t5);
    t01 = (t2 + t6);
    t11 = (t - t5);
    t21 = (t2 - t6);
    t31 = (t3 + t8);
    t41 = (t4 - t7);
    t51 = (t3 - t8);
    t61 = (t4 + t7);
    a8 = (src + 2);
    a9 = (src + 10);
    t71 = (*(a8) + *(a9));
    a01 = (src + 3);
    a11 = (src + 11);
    t81 = (*(a01) + *(a11));
    t91 = (*(a8) - *(a9));
    t02 = (*(a01) - *(a11));
    a21 = (src + 6);
    a31 = (src + 14);
    t12 = (*(a21) + *(a31));
    a41 = (src + 7);
    a51 = (src + 15);
    t22 = (*(a41) + *(a51));
    t32 = (*(a21) - *(a31));
    t42 = (*(a41) - *(a51));
    t52 = (t71 + t12);
    t62 = (t81 + t22);
    t72 = (t71 - t12);
    t82 = (t81 - t22);
    a61 = (0.70710678118654757*(t91 + t42));
    a71 = (0.70710678118654757*(t02 - t32));
    s = (a61 + a71);
    s2 = (a71 - a61);
    a81 = (0.70710678118654757*(t02 + t32));
    a91 = (0.70710678118654757*(t91 - t42));
    s3 = (a81 - a91);
    s4 = (a91 + a81);
    *(dst) = (t9 + t52);
    *((dst + 1)) = (t01 + t62);
    *((dst + 8)) = (t9 - t52);
    *((dst + 9)) = (t01 - t62);
    *((dst + 2)) = (t31 + s);
    *((dst + 3)) = (t41 + s2);
    *((dst + 10)) = (t31 - s);
    *((dst + 11)) = (t41 - s2);
    *((dst + 4)) = (t11 + t82);
    *((dst + 5)) = (t21 - t72);
    *((dst + 12)) = (t11 - t82);
    *((dst + 13)) = (t21 + t72);
    *((dst + 6)) = (t51 + s3);
    *((dst + 7)) = (t61 - s4);
    *((dst + 14)) = (t51 - s3);
    *((dst + 15)) = (t61 + s4);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_double_16)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    {const double  *a, *a01, *a02, *a03, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52
            , *a53, *a6, *a63, *a7, *a73, *a8, *a81, *a9, *a91;
    double a61, a62, a71, a72, a82, a83, a92, a93, s, s01, s11, s2, s21, s3, s31, s4, s41, s5, s51, s6, s61, s7
            , s8, s9, t, t01, t02, t03, t04, t05, t06, t07, t08, t11, t12, t13, t14, t15, t16, t17, t18, t2, t21, t22
            , t23, t24, t25, t26, t27, t28, t3, t31, t32, t33, t34, t35, t36, t37, t38, t4, t41, t42, t43, t44, t45, t46
            , t47, t48, t5, t51, t52, t53, t54, t55, t56, t57, t58, t6, t61, t62, t63, t64, t65, t66, t67, t68, t7, t71
            , t72, t73, t74, t75, t76, t77, t78, t8, t81, t82, t83, t84, t85, t86, t87, t88, t9, t91, t92, t93, t94, t95
            , t96, t97;
    a = (src + 16);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 17);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 8);
    a5 = (src + 24);
    t5 = (*(a4) + *(a5));
    a6 = (src + 9);
    a7 = (src + 25);
    t6 = (*(a6) + *(a7));
    t7 = (*(a4) - *(a5));
    t8 = (*(a6) - *(a7));
    t9 = (t + t5);
    t01 = (t2 + t6);
    t11 = (t - t5);
    t21 = (t2 - t6);
    t31 = (t3 + t8);
    t41 = (t4 - t7);
    t51 = (t3 - t8);
    t61 = (t4 + t7);
    a8 = (src + 2);
    a9 = (src + 18);
    t71 = (*(a8) + *(a9));
    a01 = (src + 3);
    a11 = (src + 19);
    t81 = (*(a01) + *(a11));
    t91 = (*(a8) - *(a9));
    t02 = (*(a01) - *(a11));
    a21 = (src + 10);
    a31 = (src + 26);
    t12 = (*(a21) + *(a31));
    a41 = (src + 11);
    a51 = (src + 27);
    t22 = (*(a41) + *(a51));
    t32 = (*(a21) - *(a31));
    t42 = (*(a41) - *(a51));
    t52 = (t71 + t12);
    t62 = (t81 + t22);
    a61 = (0.70710678118654757*(t71 - t12));
    a71 = (0.70710678118654757*(t81 - t22));
    s = (a61 + a71);
    s2 = (a71 - a61);
    t72 = (t91 + t42);
    t82 = (t02 - t32);
    t92 = (t91 - t42);
    t03 = (t02 + t32);
    s3 = ((0.92387953251128674*t72) + (0.38268343236508978*t82));
    s4 = ((0.92387953251128674*t82) - (0.38268343236508978*t72));
    s5 = ((0.38268343236508978*t92) + (0.92387953251128674*t03));
    s6 = ((0.38268343236508978*t03) - (0.92387953251128674*t92));
    a81 = (src + 4);
    a91 = (src + 20);
    t13 = (*(a81) + *(a91));
    a02 = (src + 5);
    a12 = (src + 21);
    t23 = (*(a02) + *(a12));
    t33 = (*(a81) - *(a91));
    t43 = (*(a02) - *(a12));
    a22 = (src + 12);
    a32 = (src + 28);
    t53 = (*(a22) + *(a32));
    a42 = (src + 13);
    a52 = (src + 29);
    t63 = (*(a42) + *(a52));
    t73 = (*(a22) - *(a32));
    t83 = (*(a42) - *(a52));
    t93 = (t13 + t53);
    t04 = (t23 + t63);
    t14 = (t13 - t53);
    t24 = (t23 - t63);
    a62 = (0.70710678118654757*(t33 + t83));
    a72 = (0.70710678118654757*(t43 - t73));
    s7 = (a62 + a72);
    s8 = (a72 - a62);
    a82 = (0.70710678118654757*(t43 + t73));
    a92 = (0.70710678118654757*(t33 - t83));
    s9 = (a82 - a92);
    s01 = (a92 + a82);
    a03 = (src + 6);
    a13 = (src + 22);
    t34 = (*(a03) + *(a13));
    a23 = (src + 7);
    a33 = (src + 23);
    t44 = (*(a23) + *(a33));
    t54 = (*(a03) - *(a13));
    t64 = (*(a23) - *(a33));
    a43 = (src + 14);
    a53 = (src + 30);
    t74 = (*(a43) + *(a53));
    a63 = (src + 15);
    a73 = (src + 31);
    t84 = (*(a63) + *(a73));
    t94 = (*(a43) - *(a53));
    t05 = (*(a63) - *(a73));
    t15 = (t34 + t74);
    t25 = (t44 + t84);
    a83 = (0.70710678118654757*(t44 - t84));
    a93 = (0.70710678118654757*(t34 - t74));
    s11 = (a83 - a93);
    s21 = (a93 + a83);
    t35 = (t54 + t05);
    t45 = (t64 - t94);
    t55 = (t54 - t05);
    t65 = (t64 + t94);
    s31 = ((0.38268343236508978*t35) + (0.92387953251128674*t45));
    s41 = ((0.38268343236508978*t45) - (0.92387953251128674*t35));
    s51 = ((0.92387953251128674*t55) + (0.38268343236508978*t65));
    s61 = ((0.38268343236508978*t55) - (0.92387953251128674*t65));
    t75 = (t9 + t93);
    t85 = (t01 + t04);
    t95 = (t9 - t93);
    t06 = (t01 - t04);
    t16 = (t52 + t15);
    t26 = (t62 + t25);
    t36 = (t52 - t15);
    t46 = (t62 - t25);
    *(dst) = (t75 + t16);
    *((dst + 1)) = (t85 + t26);
    *((dst + 16)) = (t75 - t16);
    *((dst + 17)) = (t85 - t26);
    *((dst + 8)) = (t95 + t46);
    *((dst + 9)) = (t06 - t36);
    *((dst + 24)) = (t95 - t46);
    *((dst + 25)) = (t06 + t36);
    t56 = (t31 + s7);
    t66 = (t41 + s8);
    t76 = (t31 - s7);
    t86 = (t41 - s8);
    t96 = (s3 + s31);
    t07 = (s4 + s41);
    t17 = (s3 - s31);
    t27 = (s4 - s41);
    *((dst + 2)) = (t56 + t96);
    *((dst + 3)) = (t66 + t07);
    *((dst + 18)) = (t56 - t96);
    *((dst + 19)) = (t66 - t07);
    *((dst + 10)) = (t76 + t27);
    *((dst + 11)) = (t86 - t17);
    *((dst + 26)) = (t76 - t27);
    *((dst + 27)) = (t86 + t17);
    t37 = (t11 + t24);
    t47 = (t21 - t14);
    t57 = (t11 - t24);
    t67 = (t21 + t14);
    t77 = (s + s11);
    t87 = (s2 - s21);
    t97 = (s - s11);
    t08 = (s2 + s21);
    *((dst + 4)) = (t37 + t77);
    *((dst + 5)) = (t47 + t87);
    *((dst + 20)) = (t37 - t77);
    *((dst + 21)) = (t47 - t87);
    *((dst + 12)) = (t57 + t08);
    *((dst + 13)) = (t67 - t97);
    *((dst + 28)) = (t57 - t08);
    *((dst + 29)) = (t67 + t97);
    t18 = (t51 + s9);
    t28 = (t61 - s01);
    t38 = (t51 - s9);
    t48 = (t61 + s01);
    t58 = (s5 - s51);
    t68 = (s6 + s61);
    t78 = (s5 + s51);
    t88 = (s6 - s61);
    *((dst + 6)) = (t18 + t58);
    *((dst + 7)) = (t28 + t68);
    *((dst + 22)) = (t18 - t58);
    *((dst + 23)) = (t28 - t68);
    *((dst + 14)) = (t38 + t88);
    *((dst + 15)) = (t48 - t78);
    *((dst + 30)) = (t38 - t88);
    *((dst + 31)) = (t48 + t78);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_double_32)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    {const double  *a, *a01, *a02, *a03, *a05, *a07, *a08, *a11, *a12, *a13, *a15, *a17, *a18, *a2, *a21, *a22, *a23, *a24, *a25, *a27, *a3, *a31
            , *a32, *a33, *a34, *a35, *a37, *a4, *a41, *a42, *a43, *a44, *a45, *a47, *a5, *a51, *a52, *a53, *a54, *a55, *a57, *a6, *a62, *a64
            , *a65, *a66, *a67, *a7, *a72, *a74, *a75, *a76, *a77, *a8, *a82, *a84, *a86, *a87, *a9, *a92, *a94, *a96, *a97;
    double a04, a06, a14, a16, a26, a28, a36, a38, a46, a48, a56, a58, a61, a63, a68, a71, a73, a78, a81, a83, a85, a91
            , a93, a95, s, s01, s02, s03, s04, s05, s11, s12, s13, s14, s15, s2, s21, s22, s23, s24, s25, s3, s31, s32
            , s33, s34, s35, s4, s41, s42, s43, s44, s45, s5, s51, s52, s53, s54, s55, s6, s61, s62, s63, s64, s65, s7
            , s71, s72, s73, s74, s8, s81, s82, s83, s84, s9, s91, s92, s93, s94, t, t01, t02, t03, t04, t05, t06, t07
            , t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t11, t12, t13, t14, t15, t16
            , t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t2, t21, t22, t23, t24
            , t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t3, t31, t32
            , t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l, t3m, t4, t41
            , t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t5
            , t51, t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m
            , t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l
            , t6m, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k
            , t7l, t7m, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j
            , t8k, t8l, t8m, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i
            , t9j, t9k, t9l, t9m;
    a = (src + 32);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 33);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 16);
    a5 = (src + 48);
    t5 = (*(a4) + *(a5));
    a6 = (src + 17);
    a7 = (src + 49);
    t6 = (*(a6) + *(a7));
    t7 = (*(a4) - *(a5));
    t8 = (*(a6) - *(a7));
    t9 = (t + t5);
    t01 = (t2 + t6);
    t11 = (t - t5);
    t21 = (t2 - t6);
    t31 = (t3 + t8);
    t41 = (t4 - t7);
    t51 = (t3 - t8);
    t61 = (t4 + t7);
    a8 = (src + 8);
    a9 = (src + 40);
    t71 = (*(a8) + *(a9));
    a01 = (src + 9);
    a11 = (src + 41);
    t81 = (*(a01) + *(a11));
    t91 = (*(a8) - *(a9));
    t02 = (*(a01) - *(a11));
    a21 = (src + 24);
    a31 = (src + 56);
    t12 = (*(a21) + *(a31));
    a41 = (src + 25);
    a51 = (src + 57);
    t22 = (*(a41) + *(a51));
    t32 = (*(a21) - *(a31));
    t42 = (*(a41) - *(a51));
    t52 = (t71 + t12);
    t62 = (t81 + t22);
    t72 = (t71 - t12);
    t82 = (t81 - t22);
    a61 = (0.70710678118654757*(t91 + t42));
    a71 = (0.70710678118654757*(t02 - t32));
    s = (a61 + a71);
    s2 = (a71 - a61);
    a81 = (0.70710678118654757*(t02 + t32));
    a91 = (0.70710678118654757*(t91 - t42));
    s3 = (a81 - a91);
    s4 = (a91 + a81);
    t92 = (t9 + t52);
    t03 = (t01 + t62);
    t13 = (t9 - t52);
    t23 = (t01 - t62);
    t33 = (t31 + s);
    t43 = (t41 + s2);
    t53 = (t31 - s);
    t63 = (t41 - s2);
    t73 = (t11 + t82);
    t83 = (t21 - t72);
    t93 = (t11 - t82);
    t04 = (t21 + t72);
    t14 = (t51 + s3);
    t24 = (t61 - s4);
    t34 = (t51 - s3);
    t44 = (t61 + s4);
    a02 = (src + 2);
    a12 = (src + 34);
    t54 = (*(a02) + *(a12));
    a22 = (src + 3);
    a32 = (src + 35);
    t64 = (*(a22) + *(a32));
    t74 = (*(a02) - *(a12));
    t84 = (*(a22) - *(a32));
    a42 = (src + 18);
    a52 = (src + 50);
    t94 = (*(a42) + *(a52));
    a62 = (src + 19);
    a72 = (src + 51);
    t05 = (*(a62) + *(a72));
    t15 = (*(a42) - *(a52));
    t25 = (*(a62) - *(a72));
    t35 = (t54 + t94);
    t45 = (t64 + t05);
    t55 = (t54 - t94);
    t65 = (t64 - t05);
    t75 = (t74 + t25);
    t85 = (t84 - t15);
    t95 = (t74 - t25);
    t06 = (t84 + t15);
    a82 = (src + 10);
    a92 = (src + 42);
    t16 = (*(a82) + *(a92));
    a03 = (src + 11);
    a13 = (src + 43);
    t26 = (*(a03) + *(a13));
    t36 = (*(a82) - *(a92));
    t46 = (*(a03) - *(a13));
    a23 = (src + 26);
    a33 = (src + 58);
    t56 = (*(a23) + *(a33));
    a43 = (src + 27);
    a53 = (src + 59);
    t66 = (*(a43) + *(a53));
    t76 = (*(a23) - *(a33));
    t86 = (*(a43) - *(a53));
    t96 = (t16 + t56);
    t07 = (t26 + t66);
    t17 = (t16 - t56);
    t27 = (t26 - t66);
    a63 = (0.70710678118654757*(t36 + t86));
    a73 = (0.70710678118654757*(t46 - t76));
    s5 = (a63 + a73);
    s6 = (a73 - a63);
    a83 = (0.70710678118654757*(t46 + t76));
    a93 = (0.70710678118654757*(t36 - t86));
    s7 = (a83 - a93);
    s8 = (a93 + a83);
    t37 = (t35 + t96);
    t47 = (t45 + t07);
    a04 = (0.70710678118654757*(t35 - t96));
    a14 = (0.70710678118654757*(t45 - t07));
    s9 = (a04 + a14);
    s01 = (a14 - a04);
    t57 = (t75 + s5);
    t67 = (t85 + s6);
    t77 = (t75 - s5);
    t87 = (t85 - s6);
    s11 = ((0.98078528040323043*t57) + (0.19509032201612828*t67));
    s21 = ((0.98078528040323043*t67) - (0.19509032201612828*t57));
    s31 = ((0.55557023301960218*t77) + (0.83146961230254524*t87));
    s41 = ((0.55557023301960218*t87) - (0.83146961230254524*t77));
    t97 = (t55 + t27);
    t08 = (t65 - t17);
    t18 = (t55 - t27);
    t28 = (t65 + t17);
    s51 = ((0.92387953251128674*t97) + (0.38268343236508978*t08));
    s61 = ((0.92387953251128674*t08) - (0.38268343236508978*t97));
    s71 = ((0.38268343236508978*t18) + (0.92387953251128674*t28));
    s81 = ((0.38268343236508978*t28) - (0.92387953251128674*t18));
    t38 = (t95 + s7);
    t48 = (t06 - s8);
    t58 = (t95 - s7);
    t68 = (t06 + s8);
    s91 = ((0.83146961230254524*t38) + (0.55557023301960218*t48));
    s02 = ((0.83146961230254524*t48) - (0.55557023301960218*t38));
    s12 = ((0.19509032201612828*t58) + (0.98078528040323043*t68));
    s22 = ((0.19509032201612828*t68) - (0.98078528040323043*t58));
    a24 = (src + 4);
    a34 = (src + 36);
    t78 = (*(a24) + *(a34));
    a44 = (src + 5);
    a54 = (src + 37);
    t88 = (*(a44) + *(a54));
    t98 = (*(a24) - *(a34));
    t09 = (*(a44) - *(a54));
    a64 = (src + 20);
    a74 = (src + 52);
    t19 = (*(a64) + *(a74));
    a84 = (src + 21);
    a94 = (src + 53);
    t29 = (*(a84) + *(a94));
    t39 = (*(a64) - *(a74));
    t49 = (*(a84) - *(a94));
    t59 = (t78 + t19);
    t69 = (t88 + t29);
    t79 = (t78 - t19);
    t89 = (t88 - t29);
    t99 = (t98 + t49);
    t0a = (t09 - t39);
    t1a = (t98 - t49);
    t2a = (t09 + t39);
    a05 = (src + 12);
    a15 = (src + 44);
    t3a = (*(a05) + *(a15));
    a25 = (src + 13);
    a35 = (src + 45);
    t4a = (*(a25) + *(a35));
    t5a = (*(a05) - *(a15));
    t6a = (*(a25) - *(a35));
    a45 = (src + 28);
    a55 = (src + 60);
    t7a = (*(a45) + *(a55));
    a65 = (src + 29);
    a75 = (src + 61);
    t8a = (*(a65) + *(a75));
    t9a = (*(a45) - *(a55));
    t0b = (*(a65) - *(a75));
    t1b = (t3a + t7a);
    t2b = (t4a + t8a);
    t3b = (t3a - t7a);
    t4b = (t4a - t8a);
    a85 = (0.70710678118654757*(t5a + t0b));
    a95 = (0.70710678118654757*(t6a - t9a));
    s32 = (a85 + a95);
    s42 = (a95 - a85);
    a06 = (0.70710678118654757*(t6a + t9a));
    a16 = (0.70710678118654757*(t5a - t0b));
    s52 = (a06 - a16);
    s62 = (a16 + a06);
    t5b = (t59 + t1b);
    t6b = (t69 + t2b);
    t7b = (t59 - t1b);
    t8b = (t69 - t2b);
    t9b = (t99 + s32);
    t0c = (t0a + s42);
    t1c = (t99 - s32);
    t2c = (t0a - s42);
    s72 = ((0.92387953251128674*t9b) + (0.38268343236508978*t0c));
    s82 = ((0.92387953251128674*t0c) - (0.38268343236508978*t9b));
    s92 = ((0.92387953251128674*t2c) - (0.38268343236508978*t1c));
    s03 = ((0.92387953251128674*t1c) + (0.38268343236508978*t2c));
    a26 = (0.70710678118654757*(t79 + t4b));
    a36 = (0.70710678118654757*(t89 - t3b));
    s13 = (a26 + a36);
    s23 = (a36 - a26);
    a46 = (0.70710678118654757*(t89 + t3b));
    a56 = (0.70710678118654757*(t79 - t4b));
    s33 = (a46 - a56);
    s43 = (a56 + a46);
    t3c = (t1a + s52);
    t4c = (t2a - s62);
    t5c = (t1a - s52);
    t6c = (t2a + s62);
    s53 = ((0.38268343236508978*t3c) + (0.92387953251128674*t4c));
    s63 = ((0.38268343236508978*t4c) - (0.92387953251128674*t3c));
    s73 = ((0.38268343236508978*t6c) - (0.92387953251128674*t5c));
    s83 = ((0.38268343236508978*t5c) + (0.92387953251128674*t6c));
    a66 = (src + 6);
    a76 = (src + 38);
    t7c = (*(a66) + *(a76));
    a86 = (src + 7);
    a96 = (src + 39);
    t8c = (*(a86) + *(a96));
    t9c = (*(a66) - *(a76));
    t0d = (*(a86) - *(a96));
    a07 = (src + 22);
    a17 = (src + 54);
    t1d = (*(a07) + *(a17));
    a27 = (src + 23);
    a37 = (src + 55);
    t2d = (*(a27) + *(a37));
    t3d = (*(a07) - *(a17));
    t4d = (*(a27) - *(a37));
    t5d = (t7c + t1d);
    t6d = (t8c + t2d);
    t7d = (t7c - t1d);
    t8d = (t8c - t2d);
    t9d = (t9c + t4d);
    t0e = (t0d - t3d);
    t1e = (t9c - t4d);
    t2e = (t0d + t3d);
    a47 = (src + 14);
    a57 = (src + 46);
    t3e = (*(a47) + *(a57));
    a67 = (src + 15);
    a77 = (src + 47);
    t4e = (*(a67) + *(a77));
    t5e = (*(a47) - *(a57));
    t6e = (*(a67) - *(a77));
    a87 = (src + 30);
    a97 = (src + 62);
    t7e = (*(a87) + *(a97));
    a08 = (src + 31);
    a18 = (src + 63);
    t8e = (*(a08) + *(a18));
    t9e = (*(a87) - *(a97));
    t0f = (*(a08) - *(a18));
    t1f = (t3e + t7e);
    t2f = (t4e + t8e);
    t3f = (t3e - t7e);
    t4f = (t4e - t8e);
    a28 = (0.70710678118654757*(t5e + t0f));
    a38 = (0.70710678118654757*(t6e - t9e));
    s93 = (a28 + a38);
    s04 = (a38 - a28);
    a48 = (0.70710678118654757*(t6e + t9e));
    a58 = (0.70710678118654757*(t5e - t0f));
    s14 = (a48 - a58);
    s24 = (a58 + a48);
    t5f = (t5d + t1f);
    t6f = (t6d + t2f);
    a68 = (0.70710678118654757*(t6d - t2f));
    a78 = (0.70710678118654757*(t5d - t1f));
    s34 = (a68 - a78);
    s44 = (a78 + a68);
    t7f = (t9d + s93);
    t8f = (t0e + s04);
    t9f = (t9d - s93);
    t0g = (t0e - s04);
    s54 = ((0.83146961230254524*t7f) + (0.55557023301960218*t8f));
    s64 = ((0.83146961230254524*t8f) - (0.55557023301960218*t7f));
    s74 = ((0.19509032201612828*t0g) - (0.98078528040323043*t9f));
    s84 = ((0.19509032201612828*t9f) + (0.98078528040323043*t0g));
    t1g = (t7d + t4f);
    t2g = (t8d - t3f);
    t3g = (t7d - t4f);
    t4g = (t8d + t3f);
    s94 = ((0.38268343236508978*t1g) + (0.92387953251128674*t2g));
    s05 = ((0.38268343236508978*t2g) - (0.92387953251128674*t1g));
    s15 = ((0.92387953251128674*t3g) + (0.38268343236508978*t4g));
    s25 = ((0.38268343236508978*t3g) - (0.92387953251128674*t4g));
    t5g = (t1e + s14);
    t6g = (t2e - s24);
    t7g = (t1e - s14);
    t8g = (t2e + s24);
    s35 = ((0.98078528040323043*t6g) - (0.19509032201612828*t5g));
    s45 = ((0.98078528040323043*t5g) + (0.19509032201612828*t6g));
    s55 = ((0.55557023301960218*t7g) + (0.83146961230254524*t8g));
    s65 = ((0.83146961230254524*t7g) - (0.55557023301960218*t8g));
    t9g = (t92 + t5b);
    t0h = (t03 + t6b);
    t1h = (t92 - t5b);
    t2h = (t03 - t6b);
    t3h = (t37 + t5f);
    t4h = (t47 + t6f);
    t5h = (t37 - t5f);
    t6h = (t47 - t6f);
    *(dst) = (t9g + t3h);
    *((dst + 1)) = (t0h + t4h);
    *((dst + 32)) = (t9g - t3h);
    *((dst + 33)) = (t0h - t4h);
    *((dst + 16)) = (t1h + t6h);
    *((dst + 17)) = (t2h - t5h);
    *((dst + 48)) = (t1h - t6h);
    *((dst + 49)) = (t2h + t5h);
    t7h = (t33 + s72);
    t8h = (t43 + s82);
    t9h = (t33 - s72);
    t0i = (t43 - s82);
    t1i = (s11 + s54);
    t2i = (s21 + s64);
    t3i = (s11 - s54);
    t4i = (s21 - s64);
    *((dst + 2)) = (t7h + t1i);
    *((dst + 3)) = (t8h + t2i);
    *((dst + 34)) = (t7h - t1i);
    *((dst + 35)) = (t8h - t2i);
    *((dst + 18)) = (t9h + t4i);
    *((dst + 19)) = (t0i - t3i);
    *((dst + 50)) = (t9h - t4i);
    *((dst + 51)) = (t0i + t3i);
    t5i = (t73 + s13);
    t6i = (t83 + s23);
    t7i = (t73 - s13);
    t8i = (t83 - s23);
    t9i = (s51 + s94);
    t0j = (s61 + s05);
    t1j = (s51 - s94);
    t2j = (s61 - s05);
    *((dst + 4)) = (t5i + t9i);
    *((dst + 5)) = (t6i + t0j);
    *((dst + 36)) = (t5i - t9i);
    *((dst + 37)) = (t6i - t0j);
    *((dst + 20)) = (t7i + t2j);
    *((dst + 21)) = (t8i - t1j);
    *((dst + 52)) = (t7i - t2j);
    *((dst + 53)) = (t8i + t1j);
    t3j = (t14 + s53);
    t4j = (t24 + s63);
    t5j = (t14 - s53);
    t6j = (t24 - s63);
    t7j = (s91 + s35);
    t8j = (s02 - s45);
    t9j = (s91 - s35);
    t0k = (s02 + s45);
    *((dst + 6)) = (t3j + t7j);
    *((dst + 7)) = (t4j + t8j);
    *((dst + 38)) = (t3j - t7j);
    *((dst + 39)) = (t4j - t8j);
    *((dst + 22)) = (t5j + t0k);
    *((dst + 23)) = (t6j - t9j);
    *((dst + 54)) = (t5j - t0k);
    *((dst + 55)) = (t6j + t9j);
    t1k = (t13 + t8b);
    t2k = (t23 - t7b);
    t3k = (t13 - t8b);
    t4k = (t23 + t7b);
    t5k = (s9 + s34);
    t6k = (s01 - s44);
    t7k = (s9 - s34);
    t8k = (s01 + s44);
    *((dst + 8)) = (t1k + t5k);
    *((dst + 9)) = (t2k + t6k);
    *((dst + 40)) = (t1k - t5k);
    *((dst + 41)) = (t2k - t6k);
    *((dst + 24)) = (t3k + t8k);
    *((dst + 25)) = (t4k - t7k);
    *((dst + 56)) = (t3k - t8k);
    *((dst + 57)) = (t4k + t7k);
    t9k = (t53 + s92);
    t0l = (t63 - s03);
    t1l = (t53 - s92);
    t2l = (t63 + s03);
    t3l = (s31 + s74);
    t4l = (s41 - s84);
    t5l = (s31 - s74);
    t6l = (s41 + s84);
    *((dst + 10)) = (t9k + t3l);
    *((dst + 11)) = (t0l + t4l);
    *((dst + 42)) = (t9k - t3l);
    *((dst + 43)) = (t0l - t4l);
    *((dst + 26)) = (t1l + t6l);
    *((dst + 27)) = (t2l - t5l);
    *((dst + 58)) = (t1l - t6l);
    *((dst + 59)) = (t2l + t5l);
    t7l = (t93 + s33);
    t8l = (t04 - s43);
    t9l = (t93 - s33);
    t0m = (t04 + s43);
    t1m = (s71 - s15);
    t2m = (s81 + s25);
    t3m = (s71 + s15);
    t4m = (s81 - s25);
    *((dst + 12)) = (t7l + t1m);
    *((dst + 13)) = (t8l + t2m);
    *((dst + 44)) = (t7l - t1m);
    *((dst + 45)) = (t8l - t2m);
    *((dst + 28)) = (t9l + t4m);
    *((dst + 29)) = (t0m - t3m);
    *((dst + 60)) = (t9l - t4m);
    *((dst + 61)) = (t0m + t3m);
    t5m = (t34 + s73);
    t6m = (t44 - s83);
    t7m = (t34 - s73);
    t8m = (t44 + s83);
    t9m = (s12 - s55);
    t0n = (s22 + s65);
    t1n = (s12 + s55);
    t2n = (s22 - s65);
    *((dst + 14)) = (t5m + t9m);
    *((dst + 15)) = (t6m + t0n);
    *((dst + 46)) = (t5m - t9m);
    *((dst + 47)) = (t6m - t0n);
    *((dst + 30)) = (t7m + t2n);
    *((dst + 31)) = (t8m - t1n);
    *((dst + 62)) = (t7m - t2n);
    *((dst + 63)) = (t8m + t1n);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_double_64)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[128];
    double  *a03, *a04, *a05, *a06, *a13, *a14, *a15, *a22, *a23, *a24, *a25, *a32, *a33, *a34, *a35, *a42, *a43, *a44, *a45, *a52, *a53, *a54
            , *a55, *a62, *a63, *a64, *a72, *a73, *a74, *a82, *a83, *a84, *a92, *a94;
    const double  *a, *a01, *a11, *a2, *a21, *a3, *a31, *a4, *a41, *a5, *a51, *a6, *a61, *a7, *a8, *a9;
    int a12, a93;
    double a02, a65, a71, a75, a81, a85, a91, a95, s, s2, s3, s4, s5, s6, s7, s8, t, t01, t02, t03, t04, t05
            , t06, t07, t11, t12, t13, t14, t15, t16, t17, t2, t21, t22, t23, t24, t25, t26, t27, t3, t31, t32, t33, t34
            , t35, t36, t4, t41, t42, t43, t44, t45, t46, t5, t51, t52, t53, t54, t55, t56, t6, t61, t62, t63, t64, t65
            , t66, t7, t71, t72, t73, t74, t75, t76, t8, t81, t82, t83, t84, t85, t86, t9, t91, t92, t93, t94, t95, t96;
    {long i; for(i = 0; i <= 7; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 64);
        a4 = (a + 65);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 32);
        a6 = (a + 33);
        a7 = (a + 96);
        a8 = (a + 97);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 + t8);
        t41 = (t4 - t7);
        t51 = (t3 - t8);
        t61 = (t4 + t7);
        a9 = (a + 16);
        a01 = (a + 17);
        a11 = (a + 80);
        a21 = (a + 81);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 48);
        a41 = (a + 49);
        a51 = (a + 112);
        a61 = (a + 113);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        t72 = (t71 - t12);
        t82 = (t81 - t22);
        a71 = (0.70710678118654757*(t91 + t42));
        a81 = (0.70710678118654757*(t02 - t32));
        s = (a71 + a81);
        s2 = (a81 - a71);
        a91 = (0.70710678118654757*(t02 + t32));
        a02 = (0.70710678118654757*(t91 - t42));
        s3 = (a91 - a02);
        s4 = (a02 + a91);
        t92 = (t9 + t52);
        t03 = (t01 + t62);
        t13 = (t9 - t52);
        t23 = (t01 - t62);
        a12 = (16*i);
        a22 = (D291 + a12);
        a32 = (a22 + 1);
        a42 = (a22 + 2);
        a52 = (a22 + 3);
        a62 = (T + a12);
        *(a62) = ((*(a22)*t92) - (*(a32)*t03));
        *((a62 + 1)) = ((*(a32)*t92) + (*(a22)*t03));
        *((a62 + 8)) = ((*(a42)*t13) - (*(a52)*t23));
        *((a62 + 9)) = ((*(a52)*t13) + (*(a42)*t23));
        t33 = (t31 + s);
        t43 = (t41 + s2);
        t53 = (t31 - s);
        t63 = (t41 - s2);
        a72 = (a22 + 4);
        a82 = (a22 + 5);
        a92 = (a22 + 6);
        a03 = (a22 + 7);
        *((a62 + 2)) = ((*(a72)*t33) - (*(a82)*t43));
        *((a62 + 3)) = ((*(a82)*t33) + (*(a72)*t43));
        *((a62 + 10)) = ((*(a92)*t53) - (*(a03)*t63));
        *((a62 + 11)) = ((*(a03)*t53) + (*(a92)*t63));
        t73 = (t11 + t82);
        t83 = (t21 - t72);
        t93 = (t11 - t82);
        t04 = (t21 + t72);
        a13 = (a22 + 8);
        a23 = (a22 + 9);
        a33 = (a22 + 10);
        a43 = (a22 + 11);
        *((a62 + 4)) = ((*(a13)*t73) - (*(a23)*t83));
        *((a62 + 5)) = ((*(a23)*t73) + (*(a13)*t83));
        *((a62 + 12)) = ((*(a33)*t93) - (*(a43)*t04));
        *((a62 + 13)) = ((*(a43)*t93) + (*(a33)*t04));
        t14 = (t51 + s3);
        t24 = (t61 - s4);
        t34 = (t51 - s3);
        t44 = (t61 + s4);
        a53 = (a22 + 12);
        a63 = (a22 + 13);
        a73 = (a22 + 14);
        a83 = (a22 + 15);
        *((a62 + 6)) = ((*(a53)*t14) - (*(a63)*t24));
        *((a62 + 7)) = ((*(a63)*t14) + (*(a53)*t24));
        *((a62 + 14)) = ((*(a73)*t34) - (*(a83)*t44));
        *((a62 + 15)) = ((*(a83)*t34) + (*(a73)*t44));
    }}
    {long i2; for(i2 = 0; i2 <= 7; i2++) {
        a93 = (2*i2);
        a04 = (T + a93);
        a14 = (a04 + 1);
        a24 = (a04 + 64);
        a34 = (a04 + 65);
        t54 = (*(a04) + *(a24));
        t64 = (*(a14) + *(a34));
        t74 = (*(a04) - *(a24));
        t84 = (*(a14) - *(a34));
        a44 = (a04 + 32);
        a54 = (a04 + 33);
        a64 = (a04 + 96);
        a74 = (a04 + 97);
        t94 = (*(a44) + *(a64));
        t05 = (*(a54) + *(a74));
        t15 = (*(a44) - *(a64));
        t25 = (*(a54) - *(a74));
        t35 = (t54 + t94);
        t45 = (t64 + t05);
        t55 = (t54 - t94);
        t65 = (t64 - t05);
        t75 = (t74 + t25);
        t85 = (t84 - t15);
        t95 = (t74 - t25);
        t06 = (t84 + t15);
        a84 = (a04 + 16);
        a94 = (a04 + 17);
        a05 = (a04 + 80);
        a15 = (a04 + 81);
        t16 = (*(a84) + *(a05));
        t26 = (*(a94) + *(a15));
        t36 = (*(a84) - *(a05));
        t46 = (*(a94) - *(a15));
        a25 = (a04 + 48);
        a35 = (a04 + 49);
        a45 = (a04 + 112);
        a55 = (a04 + 113);
        t56 = (*(a25) + *(a45));
        t66 = (*(a35) + *(a55));
        t76 = (*(a25) - *(a45));
        t86 = (*(a35) - *(a55));
        t96 = (t16 + t56);
        t07 = (t26 + t66);
        t17 = (t16 - t56);
        t27 = (t26 - t66);
        a65 = (0.70710678118654757*(t36 + t86));
        a75 = (0.70710678118654757*(t46 - t76));
        s5 = (a65 + a75);
        s6 = (a75 - a65);
        a85 = (0.70710678118654757*(t46 + t76));
        a95 = (0.70710678118654757*(t36 - t86));
        s7 = (a85 - a95);
        s8 = (a95 + a85);
        a06 = (dst + a93);
        *(a06) = (t35 + t96);
        *((a06 + 1)) = (t45 + t07);
        *((a06 + 64)) = (t35 - t96);
        *((a06 + 65)) = (t45 - t07);
        *((a06 + 16)) = (t75 + s5);
        *((a06 + 17)) = (t85 + s6);
        *((a06 + 80)) = (t75 - s5);
        *((a06 + 81)) = (t85 - s6);
        *((a06 + 32)) = (t55 + t27);
        *((a06 + 33)) = (t65 - t17);
        *((a06 + 96)) = (t55 - t27);
        *((a06 + 97)) = (t65 + t17);
        *((a06 + 48)) = (t95 + s7);
        *((a06 + 49)) = (t06 - s8);
        *((a06 + 112)) = (t95 - s7);
        *((a06 + 113)) = (t06 + s8);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_double_128)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[256];
    double  *a05, *a06, *a07, *a08, *a09, *a15, *a16, *a17, *a18, *a19, *a24, *a25, *a26, *a27, *a28, *a34, *a35, *a36, *a37, *a38, *a44, *a45
            , *a46, *a47, *a48, *a54, *a55, *a56, *a58, *a64, *a65, *a66, *a67, *a68, *a69, *a74, *a75, *a76, *a77, *a78, *a84, *a85, *a86, *a87
            , *a88, *a94, *a95, *a96, *a97, *a98;
    const double  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a57;
    double a03, a04, a29, a39, a49, a59, a71, a72, a81, a82, a92, a93, s, s01, s02, s11, s2, s21, s3, s31, s4, s41
            , s5, s51, s6, s61, s7, s71, s8, s81, s9, s91, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b
            , t0c, t0d, t0e, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t2, t21, t22, t23, t24
            , t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b
            , t3c, t3d, t3e, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t5, t51, t52, t53
            , t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a
            , t6b, t6c, t6d, t6e, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t8, t81, t82
            , t83, t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99
            , t9a, t9b, t9c, t9d;
    {long i; for(i = 0; i <= 7; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 128);
        a4 = (a + 129);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 64);
        a6 = (a + 65);
        a7 = (a + 192);
        a8 = (a + 193);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 + t8);
        t41 = (t4 - t7);
        t51 = (t3 - t8);
        t61 = (t4 + t7);
        a9 = (a + 16);
        a01 = (a + 17);
        a11 = (a + 144);
        a21 = (a + 145);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 80);
        a41 = (a + 81);
        a51 = (a + 208);
        a61 = (a + 209);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        a71 = (0.70710678118654757*(t71 - t12));
        a81 = (0.70710678118654757*(t81 - t22));
        s = (a71 + a81);
        s2 = (a81 - a71);
        t72 = (t91 + t42);
        t82 = (t02 - t32);
        t92 = (t91 - t42);
        t03 = (t02 + t32);
        s3 = ((0.92387953251128674*t72) + (0.38268343236508978*t82));
        s4 = ((0.92387953251128674*t82) - (0.38268343236508978*t72));
        s5 = ((0.38268343236508978*t92) + (0.92387953251128674*t03));
        s6 = ((0.38268343236508978*t03) - (0.92387953251128674*t92));
        a91 = (a + 32);
        a02 = (a + 33);
        a12 = (a + 160);
        a22 = (a + 161);
        t13 = (*(a91) + *(a12));
        t23 = (*(a02) + *(a22));
        t33 = (*(a91) - *(a12));
        t43 = (*(a02) - *(a22));
        a32 = (a + 96);
        a42 = (a + 97);
        a52 = (a + 224);
        a62 = (a + 225);
        t53 = (*(a32) + *(a52));
        t63 = (*(a42) + *(a62));
        t73 = (*(a32) - *(a52));
        t83 = (*(a42) - *(a62));
        t93 = (t13 + t53);
        t04 = (t23 + t63);
        t14 = (t13 - t53);
        t24 = (t23 - t63);
        a72 = (0.70710678118654757*(t33 + t83));
        a82 = (0.70710678118654757*(t43 - t73));
        s7 = (a72 + a82);
        s8 = (a82 - a72);
        a92 = (0.70710678118654757*(t43 + t73));
        a03 = (0.70710678118654757*(t33 - t83));
        s9 = (a92 - a03);
        s01 = (a03 + a92);
        a13 = (a + 48);
        a23 = (a + 49);
        a33 = (a + 176);
        a43 = (a + 177);
        t34 = (*(a13) + *(a33));
        t44 = (*(a23) + *(a43));
        t54 = (*(a13) - *(a33));
        t64 = (*(a23) - *(a43));
        a53 = (a + 112);
        a63 = (a + 113);
        a73 = (a + 240);
        a83 = (a + 241);
        t74 = (*(a53) + *(a73));
        t84 = (*(a63) + *(a83));
        t94 = (*(a53) - *(a73));
        t05 = (*(a63) - *(a83));
        t15 = (t34 + t74);
        t25 = (t44 + t84);
        a93 = (0.70710678118654757*(t44 - t84));
        a04 = (0.70710678118654757*(t34 - t74));
        s11 = (a93 - a04);
        s21 = (a04 + a93);
        t35 = (t54 + t05);
        t45 = (t64 - t94);
        t55 = (t54 - t05);
        t65 = (t64 + t94);
        s31 = ((0.38268343236508978*t35) + (0.92387953251128674*t45));
        s41 = ((0.38268343236508978*t45) - (0.92387953251128674*t35));
        s51 = ((0.92387953251128674*t55) + (0.38268343236508978*t65));
        s61 = ((0.38268343236508978*t55) - (0.92387953251128674*t65));
        t75 = (t9 + t93);
        t85 = (t01 + t04);
        t95 = (t9 - t93);
        t06 = (t01 - t04);
        t16 = (t52 + t15);
        t26 = (t62 + t25);
        t36 = (t52 - t15);
        t46 = (t62 - t25);
        t56 = (t75 + t16);
        t66 = (t85 + t26);
        t76 = (t75 - t16);
        t86 = (t85 - t26);
        a14 = (32*i);
        a24 = (D292 + a14);
        a34 = (a24 + 1);
        a44 = (a24 + 2);
        a54 = (a24 + 3);
        a64 = (T + a14);
        *(a64) = ((*(a24)*t56) - (*(a34)*t66));
        *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
        *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
        *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
        t96 = (t95 + t46);
        t07 = (t06 - t36);
        t17 = (t95 - t46);
        t27 = (t06 + t36);
        a74 = (a24 + 4);
        a84 = (a24 + 5);
        a94 = (a24 + 6);
        a05 = (a24 + 7);
        *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
        *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
        *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
        *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
        t37 = (t31 + s7);
        t47 = (t41 + s8);
        t57 = (t31 - s7);
        t67 = (t41 - s8);
        t77 = (s3 + s31);
        t87 = (s4 + s41);
        t97 = (s3 - s31);
        t08 = (s4 - s41);
        t18 = (t37 + t77);
        t28 = (t47 + t87);
        t38 = (t37 - t77);
        t48 = (t47 - t87);
        a15 = (a24 + 8);
        a25 = (a24 + 9);
        a35 = (a24 + 10);
        a45 = (a24 + 11);
        *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
        *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
        *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
        *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
        t58 = (t57 + t08);
        t68 = (t67 - t97);
        t78 = (t57 - t08);
        t88 = (t67 + t97);
        a55 = (a24 + 12);
        a65 = (a24 + 13);
        a75 = (a24 + 14);
        a85 = (a24 + 15);
        *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
        *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
        *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
        *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
        t98 = (t11 + t24);
        t09 = (t21 - t14);
        t19 = (t11 - t24);
        t29 = (t21 + t14);
        t39 = (s + s11);
        t49 = (s2 - s21);
        t59 = (s - s11);
        t69 = (s2 + s21);
        t79 = (t98 + t39);
        t89 = (t09 + t49);
        t99 = (t98 - t39);
        t0a = (t09 - t49);
        a95 = (a24 + 16);
        a06 = (a24 + 17);
        a16 = (a24 + 18);
        a26 = (a24 + 19);
        *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
        *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
        *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
        *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
        t1a = (t19 + t69);
        t2a = (t29 - t59);
        t3a = (t19 - t69);
        t4a = (t29 + t59);
        a36 = (a24 + 20);
        a46 = (a24 + 21);
        a56 = (a24 + 22);
        a66 = (a24 + 23);
        *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
        *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
        *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
        *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
        t5a = (t51 + s9);
        t6a = (t61 - s01);
        t7a = (t51 - s9);
        t8a = (t61 + s01);
        t9a = (s5 - s51);
        t0b = (s6 + s61);
        t1b = (s5 + s51);
        t2b = (s6 - s61);
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        a76 = (a24 + 24);
        a86 = (a24 + 25);
        a96 = (a24 + 26);
        a07 = (a24 + 27);
        *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
        *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
        *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
        *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
        t7b = (t7a + t2b);
        t8b = (t8a - t1b);
        t9b = (t7a - t2b);
        t0c = (t8a + t1b);
        a17 = (a24 + 28);
        a27 = (a24 + 29);
        a37 = (a24 + 30);
        a47 = (a24 + 31);
        *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
        *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
        *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
        *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        a57 = (2*i2);
        a67 = (T + a57);
        a77 = (a67 + 1);
        a87 = (a67 + 128);
        a97 = (a67 + 129);
        t1c = (*(a67) + *(a87));
        t2c = (*(a77) + *(a97));
        t3c = (*(a67) - *(a87));
        t4c = (*(a77) - *(a97));
        a08 = (a67 + 64);
        a18 = (a67 + 65);
        a28 = (a67 + 192);
        a38 = (a67 + 193);
        t5c = (*(a08) + *(a28));
        t6c = (*(a18) + *(a38));
        t7c = (*(a08) - *(a28));
        t8c = (*(a18) - *(a38));
        t9c = (t1c + t5c);
        t0d = (t2c + t6c);
        t1d = (t1c - t5c);
        t2d = (t2c - t6c);
        t3d = (t3c + t8c);
        t4d = (t4c - t7c);
        t5d = (t3c - t8c);
        t6d = (t4c + t7c);
        a48 = (a67 + 32);
        a58 = (a67 + 33);
        a68 = (a67 + 160);
        a78 = (a67 + 161);
        t7d = (*(a48) + *(a68));
        t8d = (*(a58) + *(a78));
        t9d = (*(a48) - *(a68));
        t0e = (*(a58) - *(a78));
        a88 = (a67 + 96);
        a98 = (a67 + 97);
        a09 = (a67 + 224);
        a19 = (a67 + 225);
        t1e = (*(a88) + *(a09));
        t2e = (*(a98) + *(a19));
        t3e = (*(a88) - *(a09));
        t4e = (*(a98) - *(a19));
        t5e = (t7d + t1e);
        t6e = (t8d + t2e);
        t7e = (t7d - t1e);
        t8e = (t8d - t2e);
        a29 = (0.70710678118654757*(t9d + t4e));
        a39 = (0.70710678118654757*(t0e - t3e));
        s71 = (a29 + a39);
        s81 = (a39 - a29);
        a49 = (0.70710678118654757*(t0e + t3e));
        a59 = (0.70710678118654757*(t9d - t4e));
        s91 = (a49 - a59);
        s02 = (a59 + a49);
        a69 = (dst + a57);
        *(a69) = (t9c + t5e);
        *((a69 + 1)) = (t0d + t6e);
        *((a69 + 128)) = (t9c - t5e);
        *((a69 + 129)) = (t0d - t6e);
        *((a69 + 32)) = (t3d + s71);
        *((a69 + 33)) = (t4d + s81);
        *((a69 + 160)) = (t3d - s71);
        *((a69 + 161)) = (t4d - s81);
        *((a69 + 64)) = (t1d + t8e);
        *((a69 + 65)) = (t2d - t7e);
        *((a69 + 192)) = (t1d - t8e);
        *((a69 + 193)) = (t2d + t7e);
        *((a69 + 96)) = (t5d + s91);
        *((a69 + 97)) = (t6d - s02);
        *((a69 + 224)) = (t5d - s91);
        *((a69 + 225)) = (t6d + s02);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_double_256)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[512];
    double  *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a15, *a16, *a17, *a18, *a19, *a1a, *a1b, *a24, *a25, *a26, *a27, *a28, *a2b, *a34, *a35
            , *a36, *a37, *a38, *a3b, *a44, *a45, *a46, *a47, *a48, *a49, *a54, *a55, *a56, *a58, *a59, *a64, *a65, *a66, *a67, *a68, *a69, *a6a
            , *a6b, *a74, *a75, *a76, *a77, *a78, *a79, *a7a, *a84, *a85, *a86, *a87, *a88, *a89, *a8a, *a94, *a95, *a96, *a97, *a98, *a99, *a9a;
    const double  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a57;
    double a03, a04, a29, a2a, a39, a3a, a4a, a4b, a5a, a5b, a71, a72, a81, a82, a92, a93, s, s01, s02, s03, s11, s12
            , s13, s2, s21, s22, s23, s3, s31, s32, s4, s41, s42, s5, s51, s52, s6, s61, s62, s7, s71, s72, s8, s81
            , s82, s9, s91, s92, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h
            , t0i, t0j, t0k, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j
            , t1k, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k
            , t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t4
            , t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t5, t51
            , t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t6, t61, t62
            , t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t7, t71, t72, t73
            , t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t8, t81, t82, t83, t84
            , t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t9, t91, t92, t93, t94, t95
            , t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j;
    {long i; for(i = 0; i <= 15; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 256);
        a4 = (a + 257);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 128);
        a6 = (a + 129);
        a7 = (a + 384);
        a8 = (a + 385);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 + t8);
        t41 = (t4 - t7);
        t51 = (t3 - t8);
        t61 = (t4 + t7);
        a9 = (a + 32);
        a01 = (a + 33);
        a11 = (a + 288);
        a21 = (a + 289);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 160);
        a41 = (a + 161);
        a51 = (a + 416);
        a61 = (a + 417);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        a71 = (0.70710678118654757*(t71 - t12));
        a81 = (0.70710678118654757*(t81 - t22));
        s = (a71 + a81);
        s2 = (a81 - a71);
        t72 = (t91 + t42);
        t82 = (t02 - t32);
        t92 = (t91 - t42);
        t03 = (t02 + t32);
        s3 = ((0.92387953251128674*t72) + (0.38268343236508978*t82));
        s4 = ((0.92387953251128674*t82) - (0.38268343236508978*t72));
        s5 = ((0.38268343236508978*t92) + (0.92387953251128674*t03));
        s6 = ((0.38268343236508978*t03) - (0.92387953251128674*t92));
        a91 = (a + 64);
        a02 = (a + 65);
        a12 = (a + 320);
        a22 = (a + 321);
        t13 = (*(a91) + *(a12));
        t23 = (*(a02) + *(a22));
        t33 = (*(a91) - *(a12));
        t43 = (*(a02) - *(a22));
        a32 = (a + 192);
        a42 = (a + 193);
        a52 = (a + 448);
        a62 = (a + 449);
        t53 = (*(a32) + *(a52));
        t63 = (*(a42) + *(a62));
        t73 = (*(a32) - *(a52));
        t83 = (*(a42) - *(a62));
        t93 = (t13 + t53);
        t04 = (t23 + t63);
        t14 = (t13 - t53);
        t24 = (t23 - t63);
        a72 = (0.70710678118654757*(t33 + t83));
        a82 = (0.70710678118654757*(t43 - t73));
        s7 = (a72 + a82);
        s8 = (a82 - a72);
        a92 = (0.70710678118654757*(t43 + t73));
        a03 = (0.70710678118654757*(t33 - t83));
        s9 = (a92 - a03);
        s01 = (a03 + a92);
        a13 = (a + 96);
        a23 = (a + 97);
        a33 = (a + 352);
        a43 = (a + 353);
        t34 = (*(a13) + *(a33));
        t44 = (*(a23) + *(a43));
        t54 = (*(a13) - *(a33));
        t64 = (*(a23) - *(a43));
        a53 = (a + 224);
        a63 = (a + 225);
        a73 = (a + 480);
        a83 = (a + 481);
        t74 = (*(a53) + *(a73));
        t84 = (*(a63) + *(a83));
        t94 = (*(a53) - *(a73));
        t05 = (*(a63) - *(a83));
        t15 = (t34 + t74);
        t25 = (t44 + t84);
        a93 = (0.70710678118654757*(t44 - t84));
        a04 = (0.70710678118654757*(t34 - t74));
        s11 = (a93 - a04);
        s21 = (a04 + a93);
        t35 = (t54 + t05);
        t45 = (t64 - t94);
        t55 = (t54 - t05);
        t65 = (t64 + t94);
        s31 = ((0.38268343236508978*t35) + (0.92387953251128674*t45));
        s41 = ((0.38268343236508978*t45) - (0.92387953251128674*t35));
        s51 = ((0.92387953251128674*t55) + (0.38268343236508978*t65));
        s61 = ((0.38268343236508978*t55) - (0.92387953251128674*t65));
        t75 = (t9 + t93);
        t85 = (t01 + t04);
        t95 = (t9 - t93);
        t06 = (t01 - t04);
        t16 = (t52 + t15);
        t26 = (t62 + t25);
        t36 = (t52 - t15);
        t46 = (t62 - t25);
        t56 = (t75 + t16);
        t66 = (t85 + t26);
        t76 = (t75 - t16);
        t86 = (t85 - t26);
        a14 = (32*i);
        a24 = (D293 + a14);
        a34 = (a24 + 1);
        a44 = (a24 + 2);
        a54 = (a24 + 3);
        a64 = (T + a14);
        *(a64) = ((*(a24)*t56) - (*(a34)*t66));
        *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
        *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
        *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
        t96 = (t95 + t46);
        t07 = (t06 - t36);
        t17 = (t95 - t46);
        t27 = (t06 + t36);
        a74 = (a24 + 4);
        a84 = (a24 + 5);
        a94 = (a24 + 6);
        a05 = (a24 + 7);
        *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
        *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
        *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
        *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
        t37 = (t31 + s7);
        t47 = (t41 + s8);
        t57 = (t31 - s7);
        t67 = (t41 - s8);
        t77 = (s3 + s31);
        t87 = (s4 + s41);
        t97 = (s3 - s31);
        t08 = (s4 - s41);
        t18 = (t37 + t77);
        t28 = (t47 + t87);
        t38 = (t37 - t77);
        t48 = (t47 - t87);
        a15 = (a24 + 8);
        a25 = (a24 + 9);
        a35 = (a24 + 10);
        a45 = (a24 + 11);
        *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
        *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
        *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
        *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
        t58 = (t57 + t08);
        t68 = (t67 - t97);
        t78 = (t57 - t08);
        t88 = (t67 + t97);
        a55 = (a24 + 12);
        a65 = (a24 + 13);
        a75 = (a24 + 14);
        a85 = (a24 + 15);
        *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
        *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
        *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
        *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
        t98 = (t11 + t24);
        t09 = (t21 - t14);
        t19 = (t11 - t24);
        t29 = (t21 + t14);
        t39 = (s + s11);
        t49 = (s2 - s21);
        t59 = (s - s11);
        t69 = (s2 + s21);
        t79 = (t98 + t39);
        t89 = (t09 + t49);
        t99 = (t98 - t39);
        t0a = (t09 - t49);
        a95 = (a24 + 16);
        a06 = (a24 + 17);
        a16 = (a24 + 18);
        a26 = (a24 + 19);
        *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
        *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
        *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
        *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
        t1a = (t19 + t69);
        t2a = (t29 - t59);
        t3a = (t19 - t69);
        t4a = (t29 + t59);
        a36 = (a24 + 20);
        a46 = (a24 + 21);
        a56 = (a24 + 22);
        a66 = (a24 + 23);
        *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
        *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
        *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
        *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
        t5a = (t51 + s9);
        t6a = (t61 - s01);
        t7a = (t51 - s9);
        t8a = (t61 + s01);
        t9a = (s5 - s51);
        t0b = (s6 + s61);
        t1b = (s5 + s51);
        t2b = (s6 - s61);
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        a76 = (a24 + 24);
        a86 = (a24 + 25);
        a96 = (a24 + 26);
        a07 = (a24 + 27);
        *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
        *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
        *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
        *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
        t7b = (t7a + t2b);
        t8b = (t8a - t1b);
        t9b = (t7a - t2b);
        t0c = (t8a + t1b);
        a17 = (a24 + 28);
        a27 = (a24 + 29);
        a37 = (a24 + 30);
        a47 = (a24 + 31);
        *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
        *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
        *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
        *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        a57 = (2*i2);
        a67 = (T + a57);
        a77 = (a67 + 1);
        a87 = (a67 + 256);
        a97 = (a67 + 257);
        t1c = (*(a67) + *(a87));
        t2c = (*(a77) + *(a97));
        t3c = (*(a67) - *(a87));
        t4c = (*(a77) - *(a97));
        a08 = (a67 + 128);
        a18 = (a67 + 129);
        a28 = (a67 + 384);
        a38 = (a67 + 385);
        t5c = (*(a08) + *(a28));
        t6c = (*(a18) + *(a38));
        t7c = (*(a08) - *(a28));
        t8c = (*(a18) - *(a38));
        t9c = (t1c + t5c);
        t0d = (t2c + t6c);
        t1d = (t1c - t5c);
        t2d = (t2c - t6c);
        t3d = (t3c + t8c);
        t4d = (t4c - t7c);
        t5d = (t3c - t8c);
        t6d = (t4c + t7c);
        a48 = (a67 + 32);
        a58 = (a67 + 33);
        a68 = (a67 + 288);
        a78 = (a67 + 289);
        t7d = (*(a48) + *(a68));
        t8d = (*(a58) + *(a78));
        t9d = (*(a48) - *(a68));
        t0e = (*(a58) - *(a78));
        a88 = (a67 + 160);
        a98 = (a67 + 161);
        a09 = (a67 + 416);
        a19 = (a67 + 417);
        t1e = (*(a88) + *(a09));
        t2e = (*(a98) + *(a19));
        t3e = (*(a88) - *(a09));
        t4e = (*(a98) - *(a19));
        t5e = (t7d + t1e);
        t6e = (t8d + t2e);
        a29 = (0.70710678118654757*(t7d - t1e));
        a39 = (0.70710678118654757*(t8d - t2e));
        s71 = (a29 + a39);
        s81 = (a39 - a29);
        t7e = (t9d + t4e);
        t8e = (t0e - t3e);
        t9e = (t9d - t4e);
        t0f = (t0e + t3e);
        s91 = ((0.92387953251128674*t7e) + (0.38268343236508978*t8e));
        s02 = ((0.92387953251128674*t8e) - (0.38268343236508978*t7e));
        s12 = ((0.38268343236508978*t9e) + (0.92387953251128674*t0f));
        s22 = ((0.38268343236508978*t0f) - (0.92387953251128674*t9e));
        a49 = (a67 + 64);
        a59 = (a67 + 65);
        a69 = (a67 + 320);
        a79 = (a67 + 321);
        t1f = (*(a49) + *(a69));
        t2f = (*(a59) + *(a79));
        t3f = (*(a49) - *(a69));
        t4f = (*(a59) - *(a79));
        a89 = (a67 + 192);
        a99 = (a67 + 193);
        a0a = (a67 + 448);
        a1a = (a67 + 449);
        t5f = (*(a89) + *(a0a));
        t6f = (*(a99) + *(a1a));
        t7f = (*(a89) - *(a0a));
        t8f = (*(a99) - *(a1a));
        t9f = (t1f + t5f);
        t0g = (t2f + t6f);
        t1g = (t1f - t5f);
        t2g = (t2f - t6f);
        a2a = (0.70710678118654757*(t3f + t8f));
        a3a = (0.70710678118654757*(t4f - t7f));
        s32 = (a2a + a3a);
        s42 = (a3a - a2a);
        a4a = (0.70710678118654757*(t4f + t7f));
        a5a = (0.70710678118654757*(t3f - t8f));
        s52 = (a4a - a5a);
        s62 = (a5a + a4a);
        a6a = (a67 + 96);
        a7a = (a67 + 97);
        a8a = (a67 + 352);
        a9a = (a67 + 353);
        t3g = (*(a6a) + *(a8a));
        t4g = (*(a7a) + *(a9a));
        t5g = (*(a6a) - *(a8a));
        t6g = (*(a7a) - *(a9a));
        a0b = (a67 + 224);
        a1b = (a67 + 225);
        a2b = (a67 + 480);
        a3b = (a67 + 481);
        t7g = (*(a0b) + *(a2b));
        t8g = (*(a1b) + *(a3b));
        t9g = (*(a0b) - *(a2b));
        t0h = (*(a1b) - *(a3b));
        t1h = (t3g + t7g);
        t2h = (t4g + t8g);
        a4b = (0.70710678118654757*(t4g - t8g));
        a5b = (0.70710678118654757*(t3g - t7g));
        s72 = (a4b - a5b);
        s82 = (a5b + a4b);
        t3h = (t5g + t0h);
        t4h = (t6g - t9g);
        t5h = (t5g - t0h);
        t6h = (t6g + t9g);
        s92 = ((0.38268343236508978*t3h) + (0.92387953251128674*t4h));
        s03 = ((0.38268343236508978*t4h) - (0.92387953251128674*t3h));
        s13 = ((0.92387953251128674*t5h) + (0.38268343236508978*t6h));
        s23 = ((0.38268343236508978*t5h) - (0.92387953251128674*t6h));
        t7h = (t9c + t9f);
        t8h = (t0d + t0g);
        t9h = (t9c - t9f);
        t0i = (t0d - t0g);
        t1i = (t5e + t1h);
        t2i = (t6e + t2h);
        t3i = (t5e - t1h);
        t4i = (t6e - t2h);
        a6b = (dst + a57);
        *(a6b) = (t7h + t1i);
        *((a6b + 1)) = (t8h + t2i);
        *((a6b + 256)) = (t7h - t1i);
        *((a6b + 257)) = (t8h - t2i);
        *((a6b + 128)) = (t9h + t4i);
        *((a6b + 129)) = (t0i - t3i);
        *((a6b + 384)) = (t9h - t4i);
        *((a6b + 385)) = (t0i + t3i);
        t5i = (t3d + s32);
        t6i = (t4d + s42);
        t7i = (t3d - s32);
        t8i = (t4d - s42);
        t9i = (s91 + s92);
        t0j = (s02 + s03);
        t1j = (s91 - s92);
        t2j = (s02 - s03);
        *((a6b + 32)) = (t5i + t9i);
        *((a6b + 33)) = (t6i + t0j);
        *((a6b + 288)) = (t5i - t9i);
        *((a6b + 289)) = (t6i - t0j);
        *((a6b + 160)) = (t7i + t2j);
        *((a6b + 161)) = (t8i - t1j);
        *((a6b + 416)) = (t7i - t2j);
        *((a6b + 417)) = (t8i + t1j);
        t3j = (t1d + t2g);
        t4j = (t2d - t1g);
        t5j = (t1d - t2g);
        t6j = (t2d + t1g);
        t7j = (s71 + s72);
        t8j = (s81 - s82);
        t9j = (s71 - s72);
        t0k = (s81 + s82);
        *((a6b + 64)) = (t3j + t7j);
        *((a6b + 65)) = (t4j + t8j);
        *((a6b + 320)) = (t3j - t7j);
        *((a6b + 321)) = (t4j - t8j);
        *((a6b + 192)) = (t5j + t0k);
        *((a6b + 193)) = (t6j - t9j);
        *((a6b + 448)) = (t5j - t0k);
        *((a6b + 449)) = (t6j + t9j);
        t1k = (t5d + s52);
        t2k = (t6d - s62);
        t3k = (t5d - s52);
        t4k = (t6d + s62);
        t5k = (s12 - s13);
        t6k = (s22 + s23);
        t7k = (s12 + s13);
        t8k = (s22 - s23);
        *((a6b + 96)) = (t1k + t5k);
        *((a6b + 97)) = (t2k + t6k);
        *((a6b + 352)) = (t1k - t5k);
        *((a6b + 353)) = (t2k - t6k);
        *((a6b + 224)) = (t3k + t8k);
        *((a6b + 225)) = (t4k - t7k);
        *((a6b + 480)) = (t3k - t8k);
        *((a6b + 481)) = (t4k + t7k);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_double_512)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[1024];
    double  *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0g, *a0h, *a0i, *a0j, *a19, *a1a, *a1b, *a1c, *a1d, *a1e, *a1f, *a1g, *a1h, *a1i, *a1j
            , *a29, *a2a, *a2b, *a2c, *a2d, *a2e, *a2f, *a2g, *a2j, *a39, *a3a, *a3b, *a3c, *a3d, *a3e, *a3f, *a3g, *a3j, *a49, *a4a, *a4b, *a4c
            , *a4d, *a4e, *a4f, *a4g, *a4h, *a59, *a5a, *a5b, *a5c, *a5d, *a5e, *a5g, *a5h, *a69, *a6a, *a6b, *a6c, *a6d, *a6e, *a6f, *a6g, *a6h
            , *a6i, *a6j, *a79, *a7a, *a7b, *a7c, *a7d, *a7e, *a7f, *a7g, *a7h, *a7i, *a89, *a8a, *a8b, *a8c, *a8d, *a8e, *a8f, *a8g, *a8h, *a8i
            , *a99, *a9a, *a9b, *a9c, *a9d, *a9e, *a9f, *a9g, *a9h, *a9i;
    const double  *a, *a01, *a03, *a05, *a07, *a08, *a11, *a12, *a13, *a15, *a17, *a18, *a2, *a21, *a22, *a23, *a25, *a27, *a28, *a3, *a31, *a32
            , *a33, *a34, *a35, *a37, *a4, *a41, *a42, *a43, *a44, *a45, *a47, *a5, *a51, *a52, *a53, *a54, *a55, *a57, *a6, *a61, *a62, *a63
            , *a64, *a65, *a67, *a7, *a72, *a74, *a75, *a76, *a77, *a8, *a82, *a84, *a85, *a86, *a87, *a9, *a92, *a94, *a96, *a97;
    int a5f, a98;
    double a02, a04, a06, a14, a16, a24, a26, a2h, a2i, a36, a38, a3h, a3i, a46, a48, a4i, a4j, a56, a58, a5i, a5j, a66
            , a68, a71, a73, a78, a81, a83, a88, a91, a93, a95, s, s01, s02, s03, s04, s05, s06, s07, s11, s12, s13, s14
            , s15, s16, s17, s2, s21, s22, s23, s24, s25, s26, s27, s3, s31, s32, s33, s34, s35, s36, s4, s41, s42, s43
            , s44, s45, s46, s5, s51, s52, s53, s54, s55, s56, s6, s61, s62, s63, s64, s65, s66, s7, s71, s72, s73, s74
            , s75, s76, s8, s81, s82, s83, s84, s85, s86, s9, s91, s92, s93, s94, s95, s96, t, t01, t02, t03, t04, t05
            , t06, t07, t08, t09, t0A, t0B, t0C, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o
            , t0p, t0q, t0r, t0s, t0t, t0u, t0v, t0w, t0x, t0y, t0z, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1A, t1B
            , t1C, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t, t1u
            , t1v, t1w, t1x, t1y, t1z, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2A, t2B, t2C, t2a, t2b, t2c, t2d
            , t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p, t2q, t2r, t2s, t2t, t2u, t2v, t2w, t2x, t2y, t2z
            , t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3A, t3B, t3C, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i
            , t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s, t3t, t3u, t3v, t3w, t3x, t3y, t3z, t4, t41, t42, t43, t44
            , t45, t46, t47, t48, t49, t4A, t4B, t4C, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n
            , t4o, t4p, t4q, t4r, t4s, t4t, t4u, t4v, t4w, t4x, t4y, t4z, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59
            , t5A, t5B, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t5r, t5s, t5t
            , t5u, t5v, t5w, t5x, t5y, t5z, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6A, t6B, t6a, t6b, t6c, t6d
            , t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r, t6s, t6t, t6u, t6v, t6w, t6x, t6y, t6z
            , t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7A, t7B, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j
            , t7k, t7l, t7m, t7n, t7o, t7p, t7q, t7r, t7s, t7t, t7u, t7v, t7w, t7x, t7y, t7z, t8, t81, t82, t83, t84, t85
            , t86, t87, t88, t89, t8A, t8B, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p
            , t8q, t8r, t8s, t8t, t8u, t8v, t8w, t8x, t8y, t8z, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9A, t9B
            , t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p, t9q, t9r, t9s, t9t, t9u, t9v
            , t9w, t9x, t9y, t9z;
    {long i; for(i = 0; i <= 15; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 512);
        a4 = (a + 513);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 256);
        a6 = (a + 257);
        a7 = (a + 768);
        a8 = (a + 769);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 + t8);
        t41 = (t4 - t7);
        t51 = (t3 - t8);
        t61 = (t4 + t7);
        a9 = (a + 128);
        a01 = (a + 129);
        a11 = (a + 640);
        a21 = (a + 641);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 384);
        a41 = (a + 385);
        a51 = (a + 896);
        a61 = (a + 897);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        t72 = (t71 - t12);
        t82 = (t81 - t22);
        a71 = (0.70710678118654757*(t91 + t42));
        a81 = (0.70710678118654757*(t02 - t32));
        s = (a71 + a81);
        s2 = (a81 - a71);
        a91 = (0.70710678118654757*(t02 + t32));
        a02 = (0.70710678118654757*(t91 - t42));
        s3 = (a91 - a02);
        s4 = (a02 + a91);
        t92 = (t9 + t52);
        t03 = (t01 + t62);
        t13 = (t9 - t52);
        t23 = (t01 - t62);
        t33 = (t31 + s);
        t43 = (t41 + s2);
        t53 = (t31 - s);
        t63 = (t41 - s2);
        t73 = (t11 + t82);
        t83 = (t21 - t72);
        t93 = (t11 - t82);
        t04 = (t21 + t72);
        t14 = (t51 + s3);
        t24 = (t61 - s4);
        t34 = (t51 - s3);
        t44 = (t61 + s4);
        a12 = (a + 32);
        a22 = (a + 33);
        a32 = (a + 544);
        a42 = (a + 545);
        t54 = (*(a12) + *(a32));
        t64 = (*(a22) + *(a42));
        t74 = (*(a12) - *(a32));
        t84 = (*(a22) - *(a42));
        a52 = (a + 288);
        a62 = (a + 289);
        a72 = (a + 800);
        a82 = (a + 801);
        t94 = (*(a52) + *(a72));
        t05 = (*(a62) + *(a82));
        t15 = (*(a52) - *(a72));
        t25 = (*(a62) - *(a82));
        t35 = (t54 + t94);
        t45 = (t64 + t05);
        t55 = (t54 - t94);
        t65 = (t64 - t05);
        t75 = (t74 + t25);
        t85 = (t84 - t15);
        t95 = (t74 - t25);
        t06 = (t84 + t15);
        a92 = (a + 160);
        a03 = (a + 161);
        a13 = (a + 672);
        a23 = (a + 673);
        t16 = (*(a92) + *(a13));
        t26 = (*(a03) + *(a23));
        t36 = (*(a92) - *(a13));
        t46 = (*(a03) - *(a23));
        a33 = (a + 416);
        a43 = (a + 417);
        a53 = (a + 928);
        a63 = (a + 929);
        t56 = (*(a33) + *(a53));
        t66 = (*(a43) + *(a63));
        t76 = (*(a33) - *(a53));
        t86 = (*(a43) - *(a63));
        t96 = (t16 + t56);
        t07 = (t26 + t66);
        t17 = (t16 - t56);
        t27 = (t26 - t66);
        a73 = (0.70710678118654757*(t36 + t86));
        a83 = (0.70710678118654757*(t46 - t76));
        s5 = (a73 + a83);
        s6 = (a83 - a73);
        a93 = (0.70710678118654757*(t46 + t76));
        a04 = (0.70710678118654757*(t36 - t86));
        s7 = (a93 - a04);
        s8 = (a04 + a93);
        t37 = (t35 + t96);
        t47 = (t45 + t07);
        a14 = (0.70710678118654757*(t35 - t96));
        a24 = (0.70710678118654757*(t45 - t07));
        s9 = (a14 + a24);
        s01 = (a24 - a14);
        t57 = (t75 + s5);
        t67 = (t85 + s6);
        t77 = (t75 - s5);
        t87 = (t85 - s6);
        s11 = ((0.98078528040323043*t57) + (0.19509032201612828*t67));
        s21 = ((0.98078528040323043*t67) - (0.19509032201612828*t57));
        s31 = ((0.55557023301960218*t77) + (0.83146961230254524*t87));
        s41 = ((0.55557023301960218*t87) - (0.83146961230254524*t77));
        t97 = (t55 + t27);
        t08 = (t65 - t17);
        t18 = (t55 - t27);
        t28 = (t65 + t17);
        s51 = ((0.92387953251128674*t97) + (0.38268343236508978*t08));
        s61 = ((0.92387953251128674*t08) - (0.38268343236508978*t97));
        s71 = ((0.38268343236508978*t18) + (0.92387953251128674*t28));
        s81 = ((0.38268343236508978*t28) - (0.92387953251128674*t18));
        t38 = (t95 + s7);
        t48 = (t06 - s8);
        t58 = (t95 - s7);
        t68 = (t06 + s8);
        s91 = ((0.83146961230254524*t38) + (0.55557023301960218*t48));
        s02 = ((0.83146961230254524*t48) - (0.55557023301960218*t38));
        s12 = ((0.19509032201612828*t58) + (0.98078528040323043*t68));
        s22 = ((0.19509032201612828*t68) - (0.98078528040323043*t58));
        a34 = (a + 64);
        a44 = (a + 65);
        a54 = (a + 576);
        a64 = (a + 577);
        t78 = (*(a34) + *(a54));
        t88 = (*(a44) + *(a64));
        t98 = (*(a34) - *(a54));
        t09 = (*(a44) - *(a64));
        a74 = (a + 320);
        a84 = (a + 321);
        a94 = (a + 832);
        a05 = (a + 833);
        t19 = (*(a74) + *(a94));
        t29 = (*(a84) + *(a05));
        t39 = (*(a74) - *(a94));
        t49 = (*(a84) - *(a05));
        t59 = (t78 + t19);
        t69 = (t88 + t29);
        t79 = (t78 - t19);
        t89 = (t88 - t29);
        t99 = (t98 + t49);
        t0a = (t09 - t39);
        t1a = (t98 - t49);
        t2a = (t09 + t39);
        a15 = (a + 192);
        a25 = (a + 193);
        a35 = (a + 704);
        a45 = (a + 705);
        t3a = (*(a15) + *(a35));
        t4a = (*(a25) + *(a45));
        t5a = (*(a15) - *(a35));
        t6a = (*(a25) - *(a45));
        a55 = (a + 448);
        a65 = (a + 449);
        a75 = (a + 960);
        a85 = (a + 961);
        t7a = (*(a55) + *(a75));
        t8a = (*(a65) + *(a85));
        t9a = (*(a55) - *(a75));
        t0b = (*(a65) - *(a85));
        t1b = (t3a + t7a);
        t2b = (t4a + t8a);
        t3b = (t3a - t7a);
        t4b = (t4a - t8a);
        a95 = (0.70710678118654757*(t5a + t0b));
        a06 = (0.70710678118654757*(t6a - t9a));
        s32 = (a95 + a06);
        s42 = (a06 - a95);
        a16 = (0.70710678118654757*(t6a + t9a));
        a26 = (0.70710678118654757*(t5a - t0b));
        s52 = (a16 - a26);
        s62 = (a26 + a16);
        t5b = (t59 + t1b);
        t6b = (t69 + t2b);
        t7b = (t59 - t1b);
        t8b = (t69 - t2b);
        t9b = (t99 + s32);
        t0c = (t0a + s42);
        t1c = (t99 - s32);
        t2c = (t0a - s42);
        s72 = ((0.92387953251128674*t9b) + (0.38268343236508978*t0c));
        s82 = ((0.92387953251128674*t0c) - (0.38268343236508978*t9b));
        s92 = ((0.92387953251128674*t2c) - (0.38268343236508978*t1c));
        s03 = ((0.92387953251128674*t1c) + (0.38268343236508978*t2c));
        a36 = (0.70710678118654757*(t79 + t4b));
        a46 = (0.70710678118654757*(t89 - t3b));
        s13 = (a36 + a46);
        s23 = (a46 - a36);
        a56 = (0.70710678118654757*(t89 + t3b));
        a66 = (0.70710678118654757*(t79 - t4b));
        s33 = (a56 - a66);
        s43 = (a66 + a56);
        t3c = (t1a + s52);
        t4c = (t2a - s62);
        t5c = (t1a - s52);
        t6c = (t2a + s62);
        s53 = ((0.38268343236508978*t3c) + (0.92387953251128674*t4c));
        s63 = ((0.38268343236508978*t4c) - (0.92387953251128674*t3c));
        s73 = ((0.38268343236508978*t6c) - (0.92387953251128674*t5c));
        s83 = ((0.38268343236508978*t5c) + (0.92387953251128674*t6c));
        a76 = (a + 96);
        a86 = (a + 97);
        a96 = (a + 608);
        a07 = (a + 609);
        t7c = (*(a76) + *(a96));
        t8c = (*(a86) + *(a07));
        t9c = (*(a76) - *(a96));
        t0d = (*(a86) - *(a07));
        a17 = (a + 352);
        a27 = (a + 353);
        a37 = (a + 864);
        a47 = (a + 865);
        t1d = (*(a17) + *(a37));
        t2d = (*(a27) + *(a47));
        t3d = (*(a17) - *(a37));
        t4d = (*(a27) - *(a47));
        t5d = (t7c + t1d);
        t6d = (t8c + t2d);
        t7d = (t7c - t1d);
        t8d = (t8c - t2d);
        t9d = (t9c + t4d);
        t0e = (t0d - t3d);
        t1e = (t9c - t4d);
        t2e = (t0d + t3d);
        a57 = (a + 224);
        a67 = (a + 225);
        a77 = (a + 736);
        a87 = (a + 737);
        t3e = (*(a57) + *(a77));
        t4e = (*(a67) + *(a87));
        t5e = (*(a57) - *(a77));
        t6e = (*(a67) - *(a87));
        a97 = (a + 480);
        a08 = (a + 481);
        a18 = (a + 992);
        a28 = (a + 993);
        t7e = (*(a97) + *(a18));
        t8e = (*(a08) + *(a28));
        t9e = (*(a97) - *(a18));
        t0f = (*(a08) - *(a28));
        t1f = (t3e + t7e);
        t2f = (t4e + t8e);
        t3f = (t3e - t7e);
        t4f = (t4e - t8e);
        a38 = (0.70710678118654757*(t5e + t0f));
        a48 = (0.70710678118654757*(t6e - t9e));
        s93 = (a38 + a48);
        s04 = (a48 - a38);
        a58 = (0.70710678118654757*(t6e + t9e));
        a68 = (0.70710678118654757*(t5e - t0f));
        s14 = (a58 - a68);
        s24 = (a68 + a58);
        t5f = (t5d + t1f);
        t6f = (t6d + t2f);
        a78 = (0.70710678118654757*(t6d - t2f));
        a88 = (0.70710678118654757*(t5d - t1f));
        s34 = (a78 - a88);
        s44 = (a88 + a78);
        t7f = (t9d + s93);
        t8f = (t0e + s04);
        t9f = (t9d - s93);
        t0g = (t0e - s04);
        s54 = ((0.83146961230254524*t7f) + (0.55557023301960218*t8f));
        s64 = ((0.83146961230254524*t8f) - (0.55557023301960218*t7f));
        s74 = ((0.19509032201612828*t0g) - (0.98078528040323043*t9f));
        s84 = ((0.19509032201612828*t9f) + (0.98078528040323043*t0g));
        t1g = (t7d + t4f);
        t2g = (t8d - t3f);
        t3g = (t7d - t4f);
        t4g = (t8d + t3f);
        s94 = ((0.38268343236508978*t1g) + (0.92387953251128674*t2g));
        s05 = ((0.38268343236508978*t2g) - (0.92387953251128674*t1g));
        s15 = ((0.92387953251128674*t3g) + (0.38268343236508978*t4g));
        s25 = ((0.38268343236508978*t3g) - (0.92387953251128674*t4g));
        t5g = (t1e + s14);
        t6g = (t2e - s24);
        t7g = (t1e - s14);
        t8g = (t2e + s24);
        s35 = ((0.98078528040323043*t6g) - (0.19509032201612828*t5g));
        s45 = ((0.98078528040323043*t5g) + (0.19509032201612828*t6g));
        s55 = ((0.55557023301960218*t7g) + (0.83146961230254524*t8g));
        s65 = ((0.83146961230254524*t7g) - (0.55557023301960218*t8g));
        t9g = (t92 + t5b);
        t0h = (t03 + t6b);
        t1h = (t92 - t5b);
        t2h = (t03 - t6b);
        t3h = (t37 + t5f);
        t4h = (t47 + t6f);
        t5h = (t37 - t5f);
        t6h = (t47 - t6f);
        t7h = (t9g + t3h);
        t8h = (t0h + t4h);
        t9h = (t9g - t3h);
        t0i = (t0h - t4h);
        a98 = (64*i);
        a09 = (D294 + a98);
        a19 = (a09 + 1);
        a29 = (a09 + 2);
        a39 = (a09 + 3);
        a49 = (T + a98);
        *(a49) = ((*(a09)*t7h) - (*(a19)*t8h));
        *((a49 + 1)) = ((*(a19)*t7h) + (*(a09)*t8h));
        *((a49 + 32)) = ((*(a29)*t9h) - (*(a39)*t0i));
        *((a49 + 33)) = ((*(a39)*t9h) + (*(a29)*t0i));
        t1i = (t1h + t6h);
        t2i = (t2h - t5h);
        t3i = (t1h - t6h);
        t4i = (t2h + t5h);
        a59 = (a09 + 4);
        a69 = (a09 + 5);
        a79 = (a09 + 6);
        a89 = (a09 + 7);
        *((a49 + 16)) = ((*(a59)*t1i) - (*(a69)*t2i));
        *((a49 + 17)) = ((*(a69)*t1i) + (*(a59)*t2i));
        *((a49 + 48)) = ((*(a79)*t3i) - (*(a89)*t4i));
        *((a49 + 49)) = ((*(a89)*t3i) + (*(a79)*t4i));
        t5i = (t33 + s72);
        t6i = (t43 + s82);
        t7i = (t33 - s72);
        t8i = (t43 - s82);
        t9i = (s11 + s54);
        t0j = (s21 + s64);
        t1j = (s11 - s54);
        t2j = (s21 - s64);
        t3j = (t5i + t9i);
        t4j = (t6i + t0j);
        t5j = (t5i - t9i);
        t6j = (t6i - t0j);
        a99 = (a09 + 8);
        a0a = (a09 + 9);
        a1a = (a09 + 10);
        a2a = (a09 + 11);
        *((a49 + 2)) = ((*(a99)*t3j) - (*(a0a)*t4j));
        *((a49 + 3)) = ((*(a0a)*t3j) + (*(a99)*t4j));
        *((a49 + 34)) = ((*(a1a)*t5j) - (*(a2a)*t6j));
        *((a49 + 35)) = ((*(a2a)*t5j) + (*(a1a)*t6j));
        t7j = (t7i + t2j);
        t8j = (t8i - t1j);
        t9j = (t7i - t2j);
        t0k = (t8i + t1j);
        a3a = (a09 + 12);
        a4a = (a09 + 13);
        a5a = (a09 + 14);
        a6a = (a09 + 15);
        *((a49 + 18)) = ((*(a3a)*t7j) - (*(a4a)*t8j));
        *((a49 + 19)) = ((*(a4a)*t7j) + (*(a3a)*t8j));
        *((a49 + 50)) = ((*(a5a)*t9j) - (*(a6a)*t0k));
        *((a49 + 51)) = ((*(a6a)*t9j) + (*(a5a)*t0k));
        t1k = (t73 + s13);
        t2k = (t83 + s23);
        t3k = (t73 - s13);
        t4k = (t83 - s23);
        t5k = (s51 + s94);
        t6k = (s61 + s05);
        t7k = (s51 - s94);
        t8k = (s61 - s05);
        t9k = (t1k + t5k);
        t0l = (t2k + t6k);
        t1l = (t1k - t5k);
        t2l = (t2k - t6k);
        a7a = (a09 + 16);
        a8a = (a09 + 17);
        a9a = (a09 + 18);
        a0b = (a09 + 19);
        *((a49 + 4)) = ((*(a7a)*t9k) - (*(a8a)*t0l));
        *((a49 + 5)) = ((*(a8a)*t9k) + (*(a7a)*t0l));
        *((a49 + 36)) = ((*(a9a)*t1l) - (*(a0b)*t2l));
        *((a49 + 37)) = ((*(a0b)*t1l) + (*(a9a)*t2l));
        t3l = (t3k + t8k);
        t4l = (t4k - t7k);
        t5l = (t3k - t8k);
        t6l = (t4k + t7k);
        a1b = (a09 + 20);
        a2b = (a09 + 21);
        a3b = (a09 + 22);
        a4b = (a09 + 23);
        *((a49 + 20)) = ((*(a1b)*t3l) - (*(a2b)*t4l));
        *((a49 + 21)) = ((*(a2b)*t3l) + (*(a1b)*t4l));
        *((a49 + 52)) = ((*(a3b)*t5l) - (*(a4b)*t6l));
        *((a49 + 53)) = ((*(a4b)*t5l) + (*(a3b)*t6l));
        t7l = (t14 + s53);
        t8l = (t24 + s63);
        t9l = (t14 - s53);
        t0m = (t24 - s63);
        t1m = (s91 + s35);
        t2m = (s02 - s45);
        t3m = (s91 - s35);
        t4m = (s02 + s45);
        t5m = (t7l + t1m);
        t6m = (t8l + t2m);
        t7m = (t7l - t1m);
        t8m = (t8l - t2m);
        a5b = (a09 + 24);
        a6b = (a09 + 25);
        a7b = (a09 + 26);
        a8b = (a09 + 27);
        *((a49 + 6)) = ((*(a5b)*t5m) - (*(a6b)*t6m));
        *((a49 + 7)) = ((*(a6b)*t5m) + (*(a5b)*t6m));
        *((a49 + 38)) = ((*(a7b)*t7m) - (*(a8b)*t8m));
        *((a49 + 39)) = ((*(a8b)*t7m) + (*(a7b)*t8m));
        t9m = (t9l + t4m);
        t0n = (t0m - t3m);
        t1n = (t9l - t4m);
        t2n = (t0m + t3m);
        a9b = (a09 + 28);
        a0c = (a09 + 29);
        a1c = (a09 + 30);
        a2c = (a09 + 31);
        *((a49 + 22)) = ((*(a9b)*t9m) - (*(a0c)*t0n));
        *((a49 + 23)) = ((*(a0c)*t9m) + (*(a9b)*t0n));
        *((a49 + 54)) = ((*(a1c)*t1n) - (*(a2c)*t2n));
        *((a49 + 55)) = ((*(a2c)*t1n) + (*(a1c)*t2n));
        t3n = (t13 + t8b);
        t4n = (t23 - t7b);
        t5n = (t13 - t8b);
        t6n = (t23 + t7b);
        t7n = (s9 + s34);
        t8n = (s01 - s44);
        t9n = (s9 - s34);
        t0o = (s01 + s44);
        t1o = (t3n + t7n);
        t2o = (t4n + t8n);
        t3o = (t3n - t7n);
        t4o = (t4n - t8n);
        a3c = (a09 + 32);
        a4c = (a09 + 33);
        a5c = (a09 + 34);
        a6c = (a09 + 35);
        *((a49 + 8)) = ((*(a3c)*t1o) - (*(a4c)*t2o));
        *((a49 + 9)) = ((*(a4c)*t1o) + (*(a3c)*t2o));
        *((a49 + 40)) = ((*(a5c)*t3o) - (*(a6c)*t4o));
        *((a49 + 41)) = ((*(a6c)*t3o) + (*(a5c)*t4o));
        t5o = (t5n + t0o);
        t6o = (t6n - t9n);
        t7o = (t5n - t0o);
        t8o = (t6n + t9n);
        a7c = (a09 + 36);
        a8c = (a09 + 37);
        a9c = (a09 + 38);
        a0d = (a09 + 39);
        *((a49 + 24)) = ((*(a7c)*t5o) - (*(a8c)*t6o));
        *((a49 + 25)) = ((*(a8c)*t5o) + (*(a7c)*t6o));
        *((a49 + 56)) = ((*(a9c)*t7o) - (*(a0d)*t8o));
        *((a49 + 57)) = ((*(a0d)*t7o) + (*(a9c)*t8o));
        t9o = (t53 + s92);
        t0p = (t63 - s03);
        t1p = (t53 - s92);
        t2p = (t63 + s03);
        t3p = (s31 + s74);
        t4p = (s41 - s84);
        t5p = (s31 - s74);
        t6p = (s41 + s84);
        t7p = (t9o + t3p);
        t8p = (t0p + t4p);
        t9p = (t9o - t3p);
        t0q = (t0p - t4p);
        a1d = (a09 + 40);
        a2d = (a09 + 41);
        a3d = (a09 + 42);
        a4d = (a09 + 43);
        *((a49 + 10)) = ((*(a1d)*t7p) - (*(a2d)*t8p));
        *((a49 + 11)) = ((*(a2d)*t7p) + (*(a1d)*t8p));
        *((a49 + 42)) = ((*(a3d)*t9p) - (*(a4d)*t0q));
        *((a49 + 43)) = ((*(a4d)*t9p) + (*(a3d)*t0q));
        t1q = (t1p + t6p);
        t2q = (t2p - t5p);
        t3q = (t1p - t6p);
        t4q = (t2p + t5p);
        a5d = (a09 + 44);
        a6d = (a09 + 45);
        a7d = (a09 + 46);
        a8d = (a09 + 47);
        *((a49 + 26)) = ((*(a5d)*t1q) - (*(a6d)*t2q));
        *((a49 + 27)) = ((*(a6d)*t1q) + (*(a5d)*t2q));
        *((a49 + 58)) = ((*(a7d)*t3q) - (*(a8d)*t4q));
        *((a49 + 59)) = ((*(a8d)*t3q) + (*(a7d)*t4q));
        t5q = (t93 + s33);
        t6q = (t04 - s43);
        t7q = (t93 - s33);
        t8q = (t04 + s43);
        t9q = (s71 - s15);
        t0r = (s81 + s25);
        t1r = (s71 + s15);
        t2r = (s81 - s25);
        t3r = (t5q + t9q);
        t4r = (t6q + t0r);
        t5r = (t5q - t9q);
        t6r = (t6q - t0r);
        a9d = (a09 + 48);
        a0e = (a09 + 49);
        a1e = (a09 + 50);
        a2e = (a09 + 51);
        *((a49 + 12)) = ((*(a9d)*t3r) - (*(a0e)*t4r));
        *((a49 + 13)) = ((*(a0e)*t3r) + (*(a9d)*t4r));
        *((a49 + 44)) = ((*(a1e)*t5r) - (*(a2e)*t6r));
        *((a49 + 45)) = ((*(a2e)*t5r) + (*(a1e)*t6r));
        t7r = (t7q + t2r);
        t8r = (t8q - t1r);
        t9r = (t7q - t2r);
        t0s = (t8q + t1r);
        a3e = (a09 + 52);
        a4e = (a09 + 53);
        a5e = (a09 + 54);
        a6e = (a09 + 55);
        *((a49 + 28)) = ((*(a3e)*t7r) - (*(a4e)*t8r));
        *((a49 + 29)) = ((*(a4e)*t7r) + (*(a3e)*t8r));
        *((a49 + 60)) = ((*(a5e)*t9r) - (*(a6e)*t0s));
        *((a49 + 61)) = ((*(a6e)*t9r) + (*(a5e)*t0s));
        t1s = (t34 + s73);
        t2s = (t44 - s83);
        t3s = (t34 - s73);
        t4s = (t44 + s83);
        t5s = (s12 - s55);
        t6s = (s22 + s65);
        t7s = (s12 + s55);
        t8s = (s22 - s65);
        t9s = (t1s + t5s);
        t0t = (t2s + t6s);
        t1t = (t1s - t5s);
        t2t = (t2s - t6s);
        a7e = (a09 + 56);
        a8e = (a09 + 57);
        a9e = (a09 + 58);
        a0f = (a09 + 59);
        *((a49 + 14)) = ((*(a7e)*t9s) - (*(a8e)*t0t));
        *((a49 + 15)) = ((*(a8e)*t9s) + (*(a7e)*t0t));
        *((a49 + 46)) = ((*(a9e)*t1t) - (*(a0f)*t2t));
        *((a49 + 47)) = ((*(a0f)*t1t) + (*(a9e)*t2t));
        t3t = (t3s + t8s);
        t4t = (t4s - t7s);
        t5t = (t3s - t8s);
        t6t = (t4s + t7s);
        a1f = (a09 + 60);
        a2f = (a09 + 61);
        a3f = (a09 + 62);
        a4f = (a09 + 63);
        *((a49 + 30)) = ((*(a1f)*t3t) - (*(a2f)*t4t));
        *((a49 + 31)) = ((*(a2f)*t3t) + (*(a1f)*t4t));
        *((a49 + 62)) = ((*(a3f)*t5t) - (*(a4f)*t6t));
        *((a49 + 63)) = ((*(a4f)*t5t) + (*(a3f)*t6t));
    }}
    {long i2; for(i2 = 0; i2 <= 31; i2++) {
        a5f = (2*i2);
        a6f = (T + a5f);
        a7f = (a6f + 1);
        a8f = (a6f + 512);
        a9f = (a6f + 513);
        t7t = (*(a6f) + *(a8f));
        t8t = (*(a7f) + *(a9f));
        t9t = (*(a6f) - *(a8f));
        t0u = (*(a7f) - *(a9f));
        a0g = (a6f + 256);
        a1g = (a6f + 257);
        a2g = (a6f + 768);
        a3g = (a6f + 769);
        t1u = (*(a0g) + *(a2g));
        t2u = (*(a1g) + *(a3g));
        t3u = (*(a0g) - *(a2g));
        t4u = (*(a1g) - *(a3g));
        t5u = (t7t + t1u);
        t6u = (t8t + t2u);
        t7u = (t7t - t1u);
        t8u = (t8t - t2u);
        t9u = (t9t + t4u);
        t0v = (t0u - t3u);
        t1v = (t9t - t4u);
        t2v = (t0u + t3u);
        a4g = (a6f + 64);
        a5g = (a6f + 65);
        a6g = (a6f + 576);
        a7g = (a6f + 577);
        t3v = (*(a4g) + *(a6g));
        t4v = (*(a5g) + *(a7g));
        t5v = (*(a4g) - *(a6g));
        t6v = (*(a5g) - *(a7g));
        a8g = (a6f + 320);
        a9g = (a6f + 321);
        a0h = (a6f + 832);
        a1h = (a6f + 833);
        t7v = (*(a8g) + *(a0h));
        t8v = (*(a9g) + *(a1h));
        t9v = (*(a8g) - *(a0h));
        t0w = (*(a9g) - *(a1h));
        t1w = (t3v + t7v);
        t2w = (t4v + t8v);
        a2h = (0.70710678118654757*(t3v - t7v));
        a3h = (0.70710678118654757*(t4v - t8v));
        s75 = (a2h + a3h);
        s85 = (a3h - a2h);
        t3w = (t5v + t0w);
        t4w = (t6v - t9v);
        t5w = (t5v - t0w);
        t6w = (t6v + t9v);
        s95 = ((0.92387953251128674*t3w) + (0.38268343236508978*t4w));
        s06 = ((0.92387953251128674*t4w) - (0.38268343236508978*t3w));
        s16 = ((0.38268343236508978*t5w) + (0.92387953251128674*t6w));
        s26 = ((0.38268343236508978*t6w) - (0.92387953251128674*t5w));
        a4h = (a6f + 128);
        a5h = (a6f + 129);
        a6h = (a6f + 640);
        a7h = (a6f + 641);
        t7w = (*(a4h) + *(a6h));
        t8w = (*(a5h) + *(a7h));
        t9w = (*(a4h) - *(a6h));
        t0x = (*(a5h) - *(a7h));
        a8h = (a6f + 384);
        a9h = (a6f + 385);
        a0i = (a6f + 896);
        a1i = (a6f + 897);
        t1x = (*(a8h) + *(a0i));
        t2x = (*(a9h) + *(a1i));
        t3x = (*(a8h) - *(a0i));
        t4x = (*(a9h) - *(a1i));
        t5x = (t7w + t1x);
        t6x = (t8w + t2x);
        t7x = (t7w - t1x);
        t8x = (t8w - t2x);
        a2i = (0.70710678118654757*(t9w + t4x));
        a3i = (0.70710678118654757*(t0x - t3x));
        s36 = (a2i + a3i);
        s46 = (a3i - a2i);
        a4i = (0.70710678118654757*(t0x + t3x));
        a5i = (0.70710678118654757*(t9w - t4x));
        s56 = (a4i - a5i);
        s66 = (a5i + a4i);
        a6i = (a6f + 192);
        a7i = (a6f + 193);
        a8i = (a6f + 704);
        a9i = (a6f + 705);
        t9x = (*(a6i) + *(a8i));
        t0y = (*(a7i) + *(a9i));
        t1y = (*(a6i) - *(a8i));
        t2y = (*(a7i) - *(a9i));
        a0j = (a6f + 448);
        a1j = (a6f + 449);
        a2j = (a6f + 960);
        a3j = (a6f + 961);
        t3y = (*(a0j) + *(a2j));
        t4y = (*(a1j) + *(a3j));
        t5y = (*(a0j) - *(a2j));
        t6y = (*(a1j) - *(a3j));
        t7y = (t9x + t3y);
        t8y = (t0y + t4y);
        a4j = (0.70710678118654757*(t0y - t4y));
        a5j = (0.70710678118654757*(t9x - t3y));
        s76 = (a4j - a5j);
        s86 = (a5j + a4j);
        t9y = (t1y + t6y);
        t0z = (t2y - t5y);
        t1z = (t1y - t6y);
        t2z = (t2y + t5y);
        s96 = ((0.38268343236508978*t9y) + (0.92387953251128674*t0z));
        s07 = ((0.38268343236508978*t0z) - (0.92387953251128674*t9y));
        s17 = ((0.92387953251128674*t1z) + (0.38268343236508978*t2z));
        s27 = ((0.38268343236508978*t1z) - (0.92387953251128674*t2z));
        t3z = (t5u + t5x);
        t4z = (t6u + t6x);
        t5z = (t5u - t5x);
        t6z = (t6u - t6x);
        t7z = (t1w + t7y);
        t8z = (t2w + t8y);
        t9z = (t1w - t7y);
        t0A = (t2w - t8y);
        a6j = (dst + a5f);
        *(a6j) = (t3z + t7z);
        *((a6j + 1)) = (t4z + t8z);
        *((a6j + 512)) = (t3z - t7z);
        *((a6j + 513)) = (t4z - t8z);
        *((a6j + 256)) = (t5z + t0A);
        *((a6j + 257)) = (t6z - t9z);
        *((a6j + 768)) = (t5z - t0A);
        *((a6j + 769)) = (t6z + t9z);
        t1A = (t9u + s36);
        t2A = (t0v + s46);
        t3A = (t9u - s36);
        t4A = (t0v - s46);
        t5A = (s95 + s96);
        t6A = (s06 + s07);
        t7A = (s95 - s96);
        t8A = (s06 - s07);
        *((a6j + 64)) = (t1A + t5A);
        *((a6j + 65)) = (t2A + t6A);
        *((a6j + 576)) = (t1A - t5A);
        *((a6j + 577)) = (t2A - t6A);
        *((a6j + 320)) = (t3A + t8A);
        *((a6j + 321)) = (t4A - t7A);
        *((a6j + 832)) = (t3A - t8A);
        *((a6j + 833)) = (t4A + t7A);
        t9A = (t7u + t8x);
        t0B = (t8u - t7x);
        t1B = (t7u - t8x);
        t2B = (t8u + t7x);
        t3B = (s75 + s76);
        t4B = (s85 - s86);
        t5B = (s75 - s76);
        t6B = (s85 + s86);
        *((a6j + 128)) = (t9A + t3B);
        *((a6j + 129)) = (t0B + t4B);
        *((a6j + 640)) = (t9A - t3B);
        *((a6j + 641)) = (t0B - t4B);
        *((a6j + 384)) = (t1B + t6B);
        *((a6j + 385)) = (t2B - t5B);
        *((a6j + 896)) = (t1B - t6B);
        *((a6j + 897)) = (t2B + t5B);
        t7B = (t1v + s56);
        t8B = (t2v - s66);
        t9B = (t1v - s56);
        t0C = (t2v + s66);
        t1C = (s16 - s17);
        t2C = (s26 + s27);
        t3C = (s16 + s17);
        t4C = (s26 - s27);
        *((a6j + 192)) = (t7B + t1C);
        *((a6j + 193)) = (t8B + t2C);
        *((a6j + 704)) = (t7B - t1C);
        *((a6j + 705)) = (t8B - t2C);
        *((a6j + 448)) = (t9B + t4C);
        *((a6j + 449)) = (t0C - t3C);
        *((a6j + 960)) = (t9B - t4C);
        *((a6j + 961)) = (t0C + t3C);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_double_1024)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[2048];
     double T2[128];
    double  *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a0c, *a15, *a16, *a17, *a18, *a1a, *a1b, *a1c, *a24, *a25, *a26, *a27, *a28, *a2a, *a2b
            , *a2c, *a34, *a35, *a36, *a37, *a38, *a3a, *a3b, *a3c, *a3d, *a44, *a45, *a46, *a47, *a48, *a4a, *a4b, *a4c, *a54, *a55, *a56, *a57
            , *a58, *a5a, *a5b, *a5c, *a64, *a65, *a66, *a67, *a68, *a69, *a6a, *a6b, *a6c, *a74, *a75, *a76, *a77, *a78, *a79, *a7a, *a7b, *a7c
            , *a84, *a85, *a86, *a87, *a88, *a89, *a8a, *a8b, *a8c, *a94, *a95, *a96, *a97, *a98, *a99, *a9a, *a9b;
    const double  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a59;
    double a03, a04, a0d, a19, a1d, a29, a2d, a39, a49, a71, a72, a81, a82, a92, a93, a9c, s, s01, s02, s11, s12, s2
            , s21, s22, s3, s31, s32, s4, s41, s42, s5, s51, s6, s61, s7, s71, s8, s81, s9, s91, t, t01, t02, t03
            , t04, t05, t06, t07, t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t11, t12, t13, t14, t15, t16
            , t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t2, t21, t22, t23, t24, t25, t26, t27, t28
            , t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a
            , t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d
            , t4e, t4f, t4g, t4h, t4i, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g
            , t5h, t5i, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t7
            , t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t8, t81, t82, t83
            , t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t9, t91, t92, t93, t94, t95, t96
            , t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i;
    {long i; for(i = 0; i <= 63; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 1024);
        a4 = (a + 1025);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 512);
        a6 = (a + 513);
        a7 = (a + 1536);
        a8 = (a + 1537);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 + t8);
        t41 = (t4 - t7);
        t51 = (t3 - t8);
        t61 = (t4 + t7);
        a9 = (a + 128);
        a01 = (a + 129);
        a11 = (a + 1152);
        a21 = (a + 1153);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 640);
        a41 = (a + 641);
        a51 = (a + 1664);
        a61 = (a + 1665);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        a71 = (0.70710678118654757*(t71 - t12));
        a81 = (0.70710678118654757*(t81 - t22));
        s = (a71 + a81);
        s2 = (a81 - a71);
        t72 = (t91 + t42);
        t82 = (t02 - t32);
        t92 = (t91 - t42);
        t03 = (t02 + t32);
        s3 = ((0.92387953251128674*t72) + (0.38268343236508978*t82));
        s4 = ((0.92387953251128674*t82) - (0.38268343236508978*t72));
        s5 = ((0.38268343236508978*t92) + (0.92387953251128674*t03));
        s6 = ((0.38268343236508978*t03) - (0.92387953251128674*t92));
        a91 = (a + 256);
        a02 = (a + 257);
        a12 = (a + 1280);
        a22 = (a + 1281);
        t13 = (*(a91) + *(a12));
        t23 = (*(a02) + *(a22));
        t33 = (*(a91) - *(a12));
        t43 = (*(a02) - *(a22));
        a32 = (a + 768);
        a42 = (a + 769);
        a52 = (a + 1792);
        a62 = (a + 1793);
        t53 = (*(a32) + *(a52));
        t63 = (*(a42) + *(a62));
        t73 = (*(a32) - *(a52));
        t83 = (*(a42) - *(a62));
        t93 = (t13 + t53);
        t04 = (t23 + t63);
        t14 = (t13 - t53);
        t24 = (t23 - t63);
        a72 = (0.70710678118654757*(t33 + t83));
        a82 = (0.70710678118654757*(t43 - t73));
        s7 = (a72 + a82);
        s8 = (a82 - a72);
        a92 = (0.70710678118654757*(t43 + t73));
        a03 = (0.70710678118654757*(t33 - t83));
        s9 = (a92 - a03);
        s01 = (a03 + a92);
        a13 = (a + 384);
        a23 = (a + 385);
        a33 = (a + 1408);
        a43 = (a + 1409);
        t34 = (*(a13) + *(a33));
        t44 = (*(a23) + *(a43));
        t54 = (*(a13) - *(a33));
        t64 = (*(a23) - *(a43));
        a53 = (a + 896);
        a63 = (a + 897);
        a73 = (a + 1920);
        a83 = (a + 1921);
        t74 = (*(a53) + *(a73));
        t84 = (*(a63) + *(a83));
        t94 = (*(a53) - *(a73));
        t05 = (*(a63) - *(a83));
        t15 = (t34 + t74);
        t25 = (t44 + t84);
        a93 = (0.70710678118654757*(t44 - t84));
        a04 = (0.70710678118654757*(t34 - t74));
        s11 = (a93 - a04);
        s21 = (a04 + a93);
        t35 = (t54 + t05);
        t45 = (t64 - t94);
        t55 = (t54 - t05);
        t65 = (t64 + t94);
        s31 = ((0.38268343236508978*t35) + (0.92387953251128674*t45));
        s41 = ((0.38268343236508978*t45) - (0.92387953251128674*t35));
        s51 = ((0.92387953251128674*t55) + (0.38268343236508978*t65));
        s61 = ((0.38268343236508978*t55) - (0.92387953251128674*t65));
        t75 = (t9 + t93);
        t85 = (t01 + t04);
        t95 = (t9 - t93);
        t06 = (t01 - t04);
        t16 = (t52 + t15);
        t26 = (t62 + t25);
        t36 = (t52 - t15);
        t46 = (t62 - t25);
        t56 = (t75 + t16);
        t66 = (t85 + t26);
        t76 = (t75 - t16);
        t86 = (t85 - t26);
        a14 = (32*i);
        a24 = (D295 + a14);
        a34 = (a24 + 1);
        a44 = (a24 + 2);
        a54 = (a24 + 3);
        a64 = (T + a14);
        *(a64) = ((*(a24)*t56) - (*(a34)*t66));
        *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
        *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
        *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
        t96 = (t95 + t46);
        t07 = (t06 - t36);
        t17 = (t95 - t46);
        t27 = (t06 + t36);
        a74 = (a24 + 4);
        a84 = (a24 + 5);
        a94 = (a24 + 6);
        a05 = (a24 + 7);
        *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
        *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
        *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
        *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
        t37 = (t31 + s7);
        t47 = (t41 + s8);
        t57 = (t31 - s7);
        t67 = (t41 - s8);
        t77 = (s3 + s31);
        t87 = (s4 + s41);
        t97 = (s3 - s31);
        t08 = (s4 - s41);
        t18 = (t37 + t77);
        t28 = (t47 + t87);
        t38 = (t37 - t77);
        t48 = (t47 - t87);
        a15 = (a24 + 8);
        a25 = (a24 + 9);
        a35 = (a24 + 10);
        a45 = (a24 + 11);
        *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
        *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
        *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
        *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
        t58 = (t57 + t08);
        t68 = (t67 - t97);
        t78 = (t57 - t08);
        t88 = (t67 + t97);
        a55 = (a24 + 12);
        a65 = (a24 + 13);
        a75 = (a24 + 14);
        a85 = (a24 + 15);
        *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
        *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
        *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
        *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
        t98 = (t11 + t24);
        t09 = (t21 - t14);
        t19 = (t11 - t24);
        t29 = (t21 + t14);
        t39 = (s + s11);
        t49 = (s2 - s21);
        t59 = (s - s11);
        t69 = (s2 + s21);
        t79 = (t98 + t39);
        t89 = (t09 + t49);
        t99 = (t98 - t39);
        t0a = (t09 - t49);
        a95 = (a24 + 16);
        a06 = (a24 + 17);
        a16 = (a24 + 18);
        a26 = (a24 + 19);
        *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
        *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
        *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
        *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
        t1a = (t19 + t69);
        t2a = (t29 - t59);
        t3a = (t19 - t69);
        t4a = (t29 + t59);
        a36 = (a24 + 20);
        a46 = (a24 + 21);
        a56 = (a24 + 22);
        a66 = (a24 + 23);
        *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
        *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
        *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
        *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
        t5a = (t51 + s9);
        t6a = (t61 - s01);
        t7a = (t51 - s9);
        t8a = (t61 + s01);
        t9a = (s5 - s51);
        t0b = (s6 + s61);
        t1b = (s5 + s51);
        t2b = (s6 - s61);
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        a76 = (a24 + 24);
        a86 = (a24 + 25);
        a96 = (a24 + 26);
        a07 = (a24 + 27);
        *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
        *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
        *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
        *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
        t7b = (t7a + t2b);
        t8b = (t8a - t1b);
        t9b = (t7a - t2b);
        t0c = (t8a + t1b);
        a17 = (a24 + 28);
        a27 = (a24 + 29);
        a37 = (a24 + 30);
        a47 = (a24 + 31);
        *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
        *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
        *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
        *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        {long i3; for(i3 = 0; i3 <= 7; i3++) {
            a57 = (T + (2*i2) + (32*i3));
            a67 = (a57 + 1);
            a77 = (a57 + 1024);
            a87 = (a57 + 1025);
            t1c = (*(a57) + *(a77));
            t2c = (*(a67) + *(a87));
            t3c = (*(a57) - *(a77));
            t4c = (*(a67) - *(a87));
            a97 = (a57 + 512);
            a08 = (a57 + 513);
            a18 = (a57 + 1536);
            a28 = (a57 + 1537);
            t5c = (*(a97) + *(a18));
            t6c = (*(a08) + *(a28));
            t7c = (*(a97) - *(a18));
            t8c = (*(a08) - *(a28));
            t9c = (t1c + t5c);
            t0d = (t2c + t6c);
            t1d = (t1c - t5c);
            t2d = (t2c - t6c);
            t3d = (t3c + t8c);
            t4d = (t4c - t7c);
            t5d = (t3c - t8c);
            t6d = (t4c + t7c);
            a38 = (a57 + 256);
            a48 = (a57 + 257);
            a58 = (a57 + 1280);
            a68 = (a57 + 1281);
            t7d = (*(a38) + *(a58));
            t8d = (*(a48) + *(a68));
            t9d = (*(a38) - *(a58));
            t0e = (*(a48) - *(a68));
            a78 = (a57 + 768);
            a88 = (a57 + 769);
            a98 = (a57 + 1792);
            a09 = (a57 + 1793);
            t1e = (*(a78) + *(a98));
            t2e = (*(a88) + *(a09));
            t3e = (*(a78) - *(a98));
            t4e = (*(a88) - *(a09));
            t5e = (t7d + t1e);
            t6e = (t8d + t2e);
            t7e = (t7d - t1e);
            t8e = (t8d - t2e);
            a19 = (0.70710678118654757*(t9d + t4e));
            a29 = (0.70710678118654757*(t0e - t3e));
            s71 = (a19 + a29);
            s81 = (a29 - a19);
            a39 = (0.70710678118654757*(t0e + t3e));
            a49 = (0.70710678118654757*(t9d - t4e));
            s91 = (a39 - a49);
            s02 = (a49 + a39);
            t9e = (t9c + t5e);
            t0f = (t0d + t6e);
            t1f = (t9c - t5e);
            t2f = (t0d - t6e);
            a59 = (16*i3);
            a69 = (D291 + a59);
            a79 = (a69 + 1);
            a89 = (a69 + 2);
            a99 = (a69 + 3);
            a0a = (T2 + a59);
            *(a0a) = ((*(a69)*t9e) - (*(a79)*t0f));
            *((a0a + 1)) = ((*(a79)*t9e) + (*(a69)*t0f));
            *((a0a + 8)) = ((*(a89)*t1f) - (*(a99)*t2f));
            *((a0a + 9)) = ((*(a99)*t1f) + (*(a89)*t2f));
            t3f = (t3d + s71);
            t4f = (t4d + s81);
            t5f = (t3d - s71);
            t6f = (t4d - s81);
            a1a = (a69 + 4);
            a2a = (a69 + 5);
            a3a = (a69 + 6);
            a4a = (a69 + 7);
            *((a0a + 2)) = ((*(a1a)*t3f) - (*(a2a)*t4f));
            *((a0a + 3)) = ((*(a2a)*t3f) + (*(a1a)*t4f));
            *((a0a + 10)) = ((*(a3a)*t5f) - (*(a4a)*t6f));
            *((a0a + 11)) = ((*(a4a)*t5f) + (*(a3a)*t6f));
            t7f = (t1d + t8e);
            t8f = (t2d - t7e);
            t9f = (t1d - t8e);
            t0g = (t2d + t7e);
            a5a = (a69 + 8);
            a6a = (a69 + 9);
            a7a = (a69 + 10);
            a8a = (a69 + 11);
            *((a0a + 4)) = ((*(a5a)*t7f) - (*(a6a)*t8f));
            *((a0a + 5)) = ((*(a6a)*t7f) + (*(a5a)*t8f));
            *((a0a + 12)) = ((*(a7a)*t9f) - (*(a8a)*t0g));
            *((a0a + 13)) = ((*(a8a)*t9f) + (*(a7a)*t0g));
            t1g = (t5d + s91);
            t2g = (t6d - s02);
            t3g = (t5d - s91);
            t4g = (t6d + s02);
            a9a = (a69 + 12);
            a0b = (a69 + 13);
            a1b = (a69 + 14);
            a2b = (a69 + 15);
            *((a0a + 6)) = ((*(a9a)*t1g) - (*(a0b)*t2g));
            *((a0a + 7)) = ((*(a0b)*t1g) + (*(a9a)*t2g));
            *((a0a + 14)) = ((*(a1b)*t3g) - (*(a2b)*t4g));
            *((a0a + 15)) = ((*(a2b)*t3g) + (*(a1b)*t4g));
        }}
        {long i4; for(i4 = 0; i4 <= 7; i4++) {
            a3b = (T2 + (2*i4));
            a4b = (a3b + 1);
            a5b = (a3b + 64);
            a6b = (a3b + 65);
            t5g = (*(a3b) + *(a5b));
            t6g = (*(a4b) + *(a6b));
            t7g = (*(a3b) - *(a5b));
            t8g = (*(a4b) - *(a6b));
            a7b = (a3b + 32);
            a8b = (a3b + 33);
            a9b = (a3b + 96);
            a0c = (a3b + 97);
            t9g = (*(a7b) + *(a9b));
            t0h = (*(a8b) + *(a0c));
            t1h = (*(a7b) - *(a9b));
            t2h = (*(a8b) - *(a0c));
            t3h = (t5g + t9g);
            t4h = (t6g + t0h);
            t5h = (t5g - t9g);
            t6h = (t6g - t0h);
            t7h = (t7g + t2h);
            t8h = (t8g - t1h);
            t9h = (t7g - t2h);
            t0i = (t8g + t1h);
            a1c = (a3b + 16);
            a2c = (a3b + 17);
            a3c = (a3b + 80);
            a4c = (a3b + 81);
            t1i = (*(a1c) + *(a3c));
            t2i = (*(a2c) + *(a4c));
            t3i = (*(a1c) - *(a3c));
            t4i = (*(a2c) - *(a4c));
            a5c = (a3b + 48);
            a6c = (a3b + 49);
            a7c = (a3b + 112);
            a8c = (a3b + 113);
            t5i = (*(a5c) + *(a7c));
            t6i = (*(a6c) + *(a8c));
            t7i = (*(a5c) - *(a7c));
            t8i = (*(a6c) - *(a8c));
            t9i = (t1i + t5i);
            t0j = (t2i + t6i);
            t1j = (t1i - t5i);
            t2j = (t2i - t6i);
            a9c = (0.70710678118654757*(t3i + t8i));
            a0d = (0.70710678118654757*(t4i - t7i));
            s12 = (a9c + a0d);
            s22 = (a0d - a9c);
            a1d = (0.70710678118654757*(t4i + t7i));
            a2d = (0.70710678118654757*(t3i - t8i));
            s32 = (a1d - a2d);
            s42 = (a2d + a1d);
            a3d = (dst + (2*i2) + (32*i4));
            *(a3d) = (t3h + t9i);
            *((a3d + 1)) = (t4h + t0j);
            *((a3d + 1024)) = (t3h - t9i);
            *((a3d + 1025)) = (t4h - t0j);
            *((a3d + 256)) = (t7h + s12);
            *((a3d + 257)) = (t8h + s22);
            *((a3d + 1280)) = (t7h - s12);
            *((a3d + 1281)) = (t8h - s22);
            *((a3d + 512)) = (t5h + t2j);
            *((a3d + 513)) = (t6h - t1j);
            *((a3d + 1536)) = (t5h - t2j);
            *((a3d + 1537)) = (t6h + t1j);
            *((a3d + 768)) = (t9h + s32);
            *((a3d + 769)) = (t0i - s42);
            *((a3d + 1792)) = (t9h - s32);
            *((a3d + 1793)) = (t0i + s42);
        }}
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_double_2048)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[4096];
     double T2[256];
    double  *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0g, *a15, *a16, *a17, *a18, *a19, *a1a, *a1b, *a1c, *a1d, *a1e
            , *a1f, *a1g, *a24, *a25, *a26, *a27, *a28, *a2b, *a2c, *a2d, *a2e, *a2f, *a2g, *a34, *a35, *a36, *a37, *a38, *a3b, *a3c, *a3d, *a3e
            , *a3f, *a3g, *a44, *a45, *a46, *a47, *a48, *a49, *a4c, *a4d, *a4e, *a4f, *a4g, *a54, *a55, *a56, *a58, *a59, *a5c, *a5d, *a5e, *a5f
            , *a64, *a65, *a66, *a67, *a68, *a69, *a6a, *a6b, *a6c, *a6d, *a6e, *a6f, *a74, *a75, *a76, *a77, *a78, *a79, *a7a, *a7b, *a7c, *a7d
            , *a7e, *a7f, *a84, *a85, *a86, *a87, *a88, *a89, *a8a, *a8b, *a8c, *a8d, *a8e, *a8f, *a94, *a95, *a96, *a97, *a98, *a99, *a9a, *a9b
            , *a9c, *a9d, *a9e, *a9f, *a9g;
    const double  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a57;
    double a03, a04, a29, a2a, a39, a3a, a4a, a4b, a5a, a5b, a5g, a6g, a71, a72, a7g, a81, a82, a8g, a92, a93, s, s01
            , s02, s03, s11, s12, s13, s2, s21, s22, s23, s3, s31, s32, s33, s4, s41, s42, s43, s5, s51, s52, s53, s6
            , s61, s62, s63, s7, s71, s72, s8, s81, s82, s9, s91, s92, t, t01, t02, t03, t04, t05, t06, t07, t08, t09
            , t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o, t0p, t0q, t11, t12, t13, t14, t15
            , t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t2
            , t21, t22, t23, t24, t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m
            , t2n, t2o, t2p, t2q, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h
            , t3i, t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c
            , t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t4o, t4p, t4q, t5, t51, t52, t53, t54, t55, t56, t57
            , t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t6, t61, t62
            , t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o
            , t6p, t6q, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j
            , t7k, t7l, t7m, t7n, t7o, t7p, t7q, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e
            , t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p, t8q, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99
            , t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p;
    {long i; for(i = 0; i <= 127; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 2048);
        a4 = (a + 2049);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 1024);
        a6 = (a + 1025);
        a7 = (a + 3072);
        a8 = (a + 3073);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 + t8);
        t41 = (t4 - t7);
        t51 = (t3 - t8);
        t61 = (t4 + t7);
        a9 = (a + 256);
        a01 = (a + 257);
        a11 = (a + 2304);
        a21 = (a + 2305);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 1280);
        a41 = (a + 1281);
        a51 = (a + 3328);
        a61 = (a + 3329);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        a71 = (0.70710678118654757*(t71 - t12));
        a81 = (0.70710678118654757*(t81 - t22));
        s = (a71 + a81);
        s2 = (a81 - a71);
        t72 = (t91 + t42);
        t82 = (t02 - t32);
        t92 = (t91 - t42);
        t03 = (t02 + t32);
        s3 = ((0.92387953251128674*t72) + (0.38268343236508978*t82));
        s4 = ((0.92387953251128674*t82) - (0.38268343236508978*t72));
        s5 = ((0.38268343236508978*t92) + (0.92387953251128674*t03));
        s6 = ((0.38268343236508978*t03) - (0.92387953251128674*t92));
        a91 = (a + 512);
        a02 = (a + 513);
        a12 = (a + 2560);
        a22 = (a + 2561);
        t13 = (*(a91) + *(a12));
        t23 = (*(a02) + *(a22));
        t33 = (*(a91) - *(a12));
        t43 = (*(a02) - *(a22));
        a32 = (a + 1536);
        a42 = (a + 1537);
        a52 = (a + 3584);
        a62 = (a + 3585);
        t53 = (*(a32) + *(a52));
        t63 = (*(a42) + *(a62));
        t73 = (*(a32) - *(a52));
        t83 = (*(a42) - *(a62));
        t93 = (t13 + t53);
        t04 = (t23 + t63);
        t14 = (t13 - t53);
        t24 = (t23 - t63);
        a72 = (0.70710678118654757*(t33 + t83));
        a82 = (0.70710678118654757*(t43 - t73));
        s7 = (a72 + a82);
        s8 = (a82 - a72);
        a92 = (0.70710678118654757*(t43 + t73));
        a03 = (0.70710678118654757*(t33 - t83));
        s9 = (a92 - a03);
        s01 = (a03 + a92);
        a13 = (a + 768);
        a23 = (a + 769);
        a33 = (a + 2816);
        a43 = (a + 2817);
        t34 = (*(a13) + *(a33));
        t44 = (*(a23) + *(a43));
        t54 = (*(a13) - *(a33));
        t64 = (*(a23) - *(a43));
        a53 = (a + 1792);
        a63 = (a + 1793);
        a73 = (a + 3840);
        a83 = (a + 3841);
        t74 = (*(a53) + *(a73));
        t84 = (*(a63) + *(a83));
        t94 = (*(a53) - *(a73));
        t05 = (*(a63) - *(a83));
        t15 = (t34 + t74);
        t25 = (t44 + t84);
        a93 = (0.70710678118654757*(t44 - t84));
        a04 = (0.70710678118654757*(t34 - t74));
        s11 = (a93 - a04);
        s21 = (a04 + a93);
        t35 = (t54 + t05);
        t45 = (t64 - t94);
        t55 = (t54 - t05);
        t65 = (t64 + t94);
        s31 = ((0.38268343236508978*t35) + (0.92387953251128674*t45));
        s41 = ((0.38268343236508978*t45) - (0.92387953251128674*t35));
        s51 = ((0.92387953251128674*t55) + (0.38268343236508978*t65));
        s61 = ((0.38268343236508978*t55) - (0.92387953251128674*t65));
        t75 = (t9 + t93);
        t85 = (t01 + t04);
        t95 = (t9 - t93);
        t06 = (t01 - t04);
        t16 = (t52 + t15);
        t26 = (t62 + t25);
        t36 = (t52 - t15);
        t46 = (t62 - t25);
        t56 = (t75 + t16);
        t66 = (t85 + t26);
        t76 = (t75 - t16);
        t86 = (t85 - t26);
        a14 = (32*i);
        a24 = (D296 + a14);
        a34 = (a24 + 1);
        a44 = (a24 + 2);
        a54 = (a24 + 3);
        a64 = (T + a14);
        *(a64) = ((*(a24)*t56) - (*(a34)*t66));
        *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
        *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
        *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
        t96 = (t95 + t46);
        t07 = (t06 - t36);
        t17 = (t95 - t46);
        t27 = (t06 + t36);
        a74 = (a24 + 4);
        a84 = (a24 + 5);
        a94 = (a24 + 6);
        a05 = (a24 + 7);
        *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
        *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
        *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
        *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
        t37 = (t31 + s7);
        t47 = (t41 + s8);
        t57 = (t31 - s7);
        t67 = (t41 - s8);
        t77 = (s3 + s31);
        t87 = (s4 + s41);
        t97 = (s3 - s31);
        t08 = (s4 - s41);
        t18 = (t37 + t77);
        t28 = (t47 + t87);
        t38 = (t37 - t77);
        t48 = (t47 - t87);
        a15 = (a24 + 8);
        a25 = (a24 + 9);
        a35 = (a24 + 10);
        a45 = (a24 + 11);
        *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
        *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
        *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
        *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
        t58 = (t57 + t08);
        t68 = (t67 - t97);
        t78 = (t57 - t08);
        t88 = (t67 + t97);
        a55 = (a24 + 12);
        a65 = (a24 + 13);
        a75 = (a24 + 14);
        a85 = (a24 + 15);
        *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
        *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
        *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
        *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
        t98 = (t11 + t24);
        t09 = (t21 - t14);
        t19 = (t11 - t24);
        t29 = (t21 + t14);
        t39 = (s + s11);
        t49 = (s2 - s21);
        t59 = (s - s11);
        t69 = (s2 + s21);
        t79 = (t98 + t39);
        t89 = (t09 + t49);
        t99 = (t98 - t39);
        t0a = (t09 - t49);
        a95 = (a24 + 16);
        a06 = (a24 + 17);
        a16 = (a24 + 18);
        a26 = (a24 + 19);
        *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
        *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
        *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
        *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
        t1a = (t19 + t69);
        t2a = (t29 - t59);
        t3a = (t19 - t69);
        t4a = (t29 + t59);
        a36 = (a24 + 20);
        a46 = (a24 + 21);
        a56 = (a24 + 22);
        a66 = (a24 + 23);
        *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
        *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
        *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
        *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
        t5a = (t51 + s9);
        t6a = (t61 - s01);
        t7a = (t51 - s9);
        t8a = (t61 + s01);
        t9a = (s5 - s51);
        t0b = (s6 + s61);
        t1b = (s5 + s51);
        t2b = (s6 - s61);
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        a76 = (a24 + 24);
        a86 = (a24 + 25);
        a96 = (a24 + 26);
        a07 = (a24 + 27);
        *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
        *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
        *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
        *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
        t7b = (t7a + t2b);
        t8b = (t8a - t1b);
        t9b = (t7a - t2b);
        t0c = (t8a + t1b);
        a17 = (a24 + 28);
        a27 = (a24 + 29);
        a37 = (a24 + 30);
        a47 = (a24 + 31);
        *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
        *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
        *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
        *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        {long i3; for(i3 = 0; i3 <= 7; i3++) {
            a57 = (32*i3);
            a67 = (T + (2*i2) + a57);
            a77 = (a67 + 1);
            a87 = (a67 + 2048);
            a97 = (a67 + 2049);
            t1c = (*(a67) + *(a87));
            t2c = (*(a77) + *(a97));
            t3c = (*(a67) - *(a87));
            t4c = (*(a77) - *(a97));
            a08 = (a67 + 1024);
            a18 = (a67 + 1025);
            a28 = (a67 + 3072);
            a38 = (a67 + 3073);
            t5c = (*(a08) + *(a28));
            t6c = (*(a18) + *(a38));
            t7c = (*(a08) - *(a28));
            t8c = (*(a18) - *(a38));
            t9c = (t1c + t5c);
            t0d = (t2c + t6c);
            t1d = (t1c - t5c);
            t2d = (t2c - t6c);
            t3d = (t3c + t8c);
            t4d = (t4c - t7c);
            t5d = (t3c - t8c);
            t6d = (t4c + t7c);
            a48 = (a67 + 256);
            a58 = (a67 + 257);
            a68 = (a67 + 2304);
            a78 = (a67 + 2305);
            t7d = (*(a48) + *(a68));
            t8d = (*(a58) + *(a78));
            t9d = (*(a48) - *(a68));
            t0e = (*(a58) - *(a78));
            a88 = (a67 + 1280);
            a98 = (a67 + 1281);
            a09 = (a67 + 3328);
            a19 = (a67 + 3329);
            t1e = (*(a88) + *(a09));
            t2e = (*(a98) + *(a19));
            t3e = (*(a88) - *(a09));
            t4e = (*(a98) - *(a19));
            t5e = (t7d + t1e);
            t6e = (t8d + t2e);
            a29 = (0.70710678118654757*(t7d - t1e));
            a39 = (0.70710678118654757*(t8d - t2e));
            s71 = (a29 + a39);
            s81 = (a39 - a29);
            t7e = (t9d + t4e);
            t8e = (t0e - t3e);
            t9e = (t9d - t4e);
            t0f = (t0e + t3e);
            s91 = ((0.92387953251128674*t7e) + (0.38268343236508978*t8e));
            s02 = ((0.92387953251128674*t8e) - (0.38268343236508978*t7e));
            s12 = ((0.38268343236508978*t9e) + (0.92387953251128674*t0f));
            s22 = ((0.38268343236508978*t0f) - (0.92387953251128674*t9e));
            a49 = (a67 + 512);
            a59 = (a67 + 513);
            a69 = (a67 + 2560);
            a79 = (a67 + 2561);
            t1f = (*(a49) + *(a69));
            t2f = (*(a59) + *(a79));
            t3f = (*(a49) - *(a69));
            t4f = (*(a59) - *(a79));
            a89 = (a67 + 1536);
            a99 = (a67 + 1537);
            a0a = (a67 + 3584);
            a1a = (a67 + 3585);
            t5f = (*(a89) + *(a0a));
            t6f = (*(a99) + *(a1a));
            t7f = (*(a89) - *(a0a));
            t8f = (*(a99) - *(a1a));
            t9f = (t1f + t5f);
            t0g = (t2f + t6f);
            t1g = (t1f - t5f);
            t2g = (t2f - t6f);
            a2a = (0.70710678118654757*(t3f + t8f));
            a3a = (0.70710678118654757*(t4f - t7f));
            s32 = (a2a + a3a);
            s42 = (a3a - a2a);
            a4a = (0.70710678118654757*(t4f + t7f));
            a5a = (0.70710678118654757*(t3f - t8f));
            s52 = (a4a - a5a);
            s62 = (a5a + a4a);
            a6a = (a67 + 768);
            a7a = (a67 + 769);
            a8a = (a67 + 2816);
            a9a = (a67 + 2817);
            t3g = (*(a6a) + *(a8a));
            t4g = (*(a7a) + *(a9a));
            t5g = (*(a6a) - *(a8a));
            t6g = (*(a7a) - *(a9a));
            a0b = (a67 + 1792);
            a1b = (a67 + 1793);
            a2b = (a67 + 3840);
            a3b = (a67 + 3841);
            t7g = (*(a0b) + *(a2b));
            t8g = (*(a1b) + *(a3b));
            t9g = (*(a0b) - *(a2b));
            t0h = (*(a1b) - *(a3b));
            t1h = (t3g + t7g);
            t2h = (t4g + t8g);
            a4b = (0.70710678118654757*(t4g - t8g));
            a5b = (0.70710678118654757*(t3g - t7g));
            s72 = (a4b - a5b);
            s82 = (a5b + a4b);
            t3h = (t5g + t0h);
            t4h = (t6g - t9g);
            t5h = (t5g - t0h);
            t6h = (t6g + t9g);
            s92 = ((0.38268343236508978*t3h) + (0.92387953251128674*t4h));
            s03 = ((0.38268343236508978*t4h) - (0.92387953251128674*t3h));
            s13 = ((0.92387953251128674*t5h) + (0.38268343236508978*t6h));
            s23 = ((0.38268343236508978*t5h) - (0.92387953251128674*t6h));
            t7h = (t9c + t9f);
            t8h = (t0d + t0g);
            t9h = (t9c - t9f);
            t0i = (t0d - t0g);
            t1i = (t5e + t1h);
            t2i = (t6e + t2h);
            t3i = (t5e - t1h);
            t4i = (t6e - t2h);
            t5i = (t7h + t1i);
            t6i = (t8h + t2i);
            t7i = (t7h - t1i);
            t8i = (t8h - t2i);
            a6b = (D292 + a57);
            a7b = (a6b + 1);
            a8b = (a6b + 2);
            a9b = (a6b + 3);
            a0c = (T2 + a57);
            *(a0c) = ((*(a6b)*t5i) - (*(a7b)*t6i));
            *((a0c + 1)) = ((*(a7b)*t5i) + (*(a6b)*t6i));
            *((a0c + 16)) = ((*(a8b)*t7i) - (*(a9b)*t8i));
            *((a0c + 17)) = ((*(a9b)*t7i) + (*(a8b)*t8i));
            t9i = (t9h + t4i);
            t0j = (t0i - t3i);
            t1j = (t9h - t4i);
            t2j = (t0i + t3i);
            a1c = (a6b + 4);
            a2c = (a6b + 5);
            a3c = (a6b + 6);
            a4c = (a6b + 7);
            *((a0c + 8)) = ((*(a1c)*t9i) - (*(a2c)*t0j));
            *((a0c + 9)) = ((*(a2c)*t9i) + (*(a1c)*t0j));
            *((a0c + 24)) = ((*(a3c)*t1j) - (*(a4c)*t2j));
            *((a0c + 25)) = ((*(a4c)*t1j) + (*(a3c)*t2j));
            t3j = (t3d + s32);
            t4j = (t4d + s42);
            t5j = (t3d - s32);
            t6j = (t4d - s42);
            t7j = (s91 + s92);
            t8j = (s02 + s03);
            t9j = (s91 - s92);
            t0k = (s02 - s03);
            t1k = (t3j + t7j);
            t2k = (t4j + t8j);
            t3k = (t3j - t7j);
            t4k = (t4j - t8j);
            a5c = (a6b + 8);
            a6c = (a6b + 9);
            a7c = (a6b + 10);
            a8c = (a6b + 11);
            *((a0c + 2)) = ((*(a5c)*t1k) - (*(a6c)*t2k));
            *((a0c + 3)) = ((*(a6c)*t1k) + (*(a5c)*t2k));
            *((a0c + 18)) = ((*(a7c)*t3k) - (*(a8c)*t4k));
            *((a0c + 19)) = ((*(a8c)*t3k) + (*(a7c)*t4k));
            t5k = (t5j + t0k);
            t6k = (t6j - t9j);
            t7k = (t5j - t0k);
            t8k = (t6j + t9j);
            a9c = (a6b + 12);
            a0d = (a6b + 13);
            a1d = (a6b + 14);
            a2d = (a6b + 15);
            *((a0c + 10)) = ((*(a9c)*t5k) - (*(a0d)*t6k));
            *((a0c + 11)) = ((*(a0d)*t5k) + (*(a9c)*t6k));
            *((a0c + 26)) = ((*(a1d)*t7k) - (*(a2d)*t8k));
            *((a0c + 27)) = ((*(a2d)*t7k) + (*(a1d)*t8k));
            t9k = (t1d + t2g);
            t0l = (t2d - t1g);
            t1l = (t1d - t2g);
            t2l = (t2d + t1g);
            t3l = (s71 + s72);
            t4l = (s81 - s82);
            t5l = (s71 - s72);
            t6l = (s81 + s82);
            t7l = (t9k + t3l);
            t8l = (t0l + t4l);
            t9l = (t9k - t3l);
            t0m = (t0l - t4l);
            a3d = (a6b + 16);
            a4d = (a6b + 17);
            a5d = (a6b + 18);
            a6d = (a6b + 19);
            *((a0c + 4)) = ((*(a3d)*t7l) - (*(a4d)*t8l));
            *((a0c + 5)) = ((*(a4d)*t7l) + (*(a3d)*t8l));
            *((a0c + 20)) = ((*(a5d)*t9l) - (*(a6d)*t0m));
            *((a0c + 21)) = ((*(a6d)*t9l) + (*(a5d)*t0m));
            t1m = (t1l + t6l);
            t2m = (t2l - t5l);
            t3m = (t1l - t6l);
            t4m = (t2l + t5l);
            a7d = (a6b + 20);
            a8d = (a6b + 21);
            a9d = (a6b + 22);
            a0e = (a6b + 23);
            *((a0c + 12)) = ((*(a7d)*t1m) - (*(a8d)*t2m));
            *((a0c + 13)) = ((*(a8d)*t1m) + (*(a7d)*t2m));
            *((a0c + 28)) = ((*(a9d)*t3m) - (*(a0e)*t4m));
            *((a0c + 29)) = ((*(a0e)*t3m) + (*(a9d)*t4m));
            t5m = (t5d + s52);
            t6m = (t6d - s62);
            t7m = (t5d - s52);
            t8m = (t6d + s62);
            t9m = (s12 - s13);
            t0n = (s22 + s23);
            t1n = (s12 + s13);
            t2n = (s22 - s23);
            t3n = (t5m + t9m);
            t4n = (t6m + t0n);
            t5n = (t5m - t9m);
            t6n = (t6m - t0n);
            a1e = (a6b + 24);
            a2e = (a6b + 25);
            a3e = (a6b + 26);
            a4e = (a6b + 27);
            *((a0c + 6)) = ((*(a1e)*t3n) - (*(a2e)*t4n));
            *((a0c + 7)) = ((*(a2e)*t3n) + (*(a1e)*t4n));
            *((a0c + 22)) = ((*(a3e)*t5n) - (*(a4e)*t6n));
            *((a0c + 23)) = ((*(a4e)*t5n) + (*(a3e)*t6n));
            t7n = (t7m + t2n);
            t8n = (t8m - t1n);
            t9n = (t7m - t2n);
            t0o = (t8m + t1n);
            a5e = (a6b + 28);
            a6e = (a6b + 29);
            a7e = (a6b + 30);
            a8e = (a6b + 31);
            *((a0c + 14)) = ((*(a5e)*t7n) - (*(a6e)*t8n));
            *((a0c + 15)) = ((*(a6e)*t7n) + (*(a5e)*t8n));
            *((a0c + 30)) = ((*(a7e)*t9n) - (*(a8e)*t0o));
            *((a0c + 31)) = ((*(a8e)*t9n) + (*(a7e)*t0o));
        }}
        {long i4; for(i4 = 0; i4 <= 15; i4++) {
            a9e = (T2 + (2*i4));
            a0f = (a9e + 1);
            a1f = (a9e + 128);
            a2f = (a9e + 129);
            t1o = (*(a9e) + *(a1f));
            t2o = (*(a0f) + *(a2f));
            t3o = (*(a9e) - *(a1f));
            t4o = (*(a0f) - *(a2f));
            a3f = (a9e + 64);
            a4f = (a9e + 65);
            a5f = (a9e + 192);
            a6f = (a9e + 193);
            t5o = (*(a3f) + *(a5f));
            t6o = (*(a4f) + *(a6f));
            t7o = (*(a3f) - *(a5f));
            t8o = (*(a4f) - *(a6f));
            t9o = (t1o + t5o);
            t0p = (t2o + t6o);
            t1p = (t1o - t5o);
            t2p = (t2o - t6o);
            t3p = (t3o + t8o);
            t4p = (t4o - t7o);
            t5p = (t3o - t8o);
            t6p = (t4o + t7o);
            a7f = (a9e + 32);
            a8f = (a9e + 33);
            a9f = (a9e + 160);
            a0g = (a9e + 161);
            t7p = (*(a7f) + *(a9f));
            t8p = (*(a8f) + *(a0g));
            t9p = (*(a7f) - *(a9f));
            t0q = (*(a8f) - *(a0g));
            a1g = (a9e + 96);
            a2g = (a9e + 97);
            a3g = (a9e + 224);
            a4g = (a9e + 225);
            t1q = (*(a1g) + *(a3g));
            t2q = (*(a2g) + *(a4g));
            t3q = (*(a1g) - *(a3g));
            t4q = (*(a2g) - *(a4g));
            t5q = (t7p + t1q);
            t6q = (t8p + t2q);
            t7q = (t7p - t1q);
            t8q = (t8p - t2q);
            a5g = (0.70710678118654757*(t9p + t4q));
            a6g = (0.70710678118654757*(t0q - t3q));
            s33 = (a5g + a6g);
            s43 = (a6g - a5g);
            a7g = (0.70710678118654757*(t0q + t3q));
            a8g = (0.70710678118654757*(t9p - t4q));
            s53 = (a7g - a8g);
            s63 = (a8g + a7g);
            a9g = (dst + (2*i2) + (32*i4));
            *(a9g) = (t9o + t5q);
            *((a9g + 1)) = (t0p + t6q);
            *((a9g + 2048)) = (t9o - t5q);
            *((a9g + 2049)) = (t0p - t6q);
            *((a9g + 512)) = (t3p + s33);
            *((a9g + 513)) = (t4p + s43);
            *((a9g + 2560)) = (t3p - s33);
            *((a9g + 2561)) = (t4p - s43);
            *((a9g + 1024)) = (t1p + t8q);
            *((a9g + 1025)) = (t2p - t7q);
            *((a9g + 3072)) = (t1p - t8q);
            *((a9g + 3073)) = (t2p + t7q);
            *((a9g + 1536)) = (t5p + s53);
            *((a9g + 1537)) = (t6p - s63);
            *((a9g + 3584)) = (t5p - s53);
            *((a9g + 3585)) = (t6p + s63);
        }}
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_double_4096)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[8192];
     double T2[1024];
    double  *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0g, *a0h, *a0i, *a0j, *a0k, *a0l, *a0m, *a0o, *a19, *a1a, *a1b, *a1c, *a1d, *a1e, *a1f
            , *a1g, *a1h, *a1i, *a1j, *a1k, *a1l, *a1m, *a1n, *a1o, *a1p, *a29, *a2a, *a2b, *a2c, *a2d, *a2e, *a2f, *a2g, *a2j, *a2k, *a2l, *a2m
            , *a2n, *a2o, *a39, *a3a, *a3b, *a3c, *a3d, *a3e, *a3f, *a3g, *a3j, *a3k, *a3l, *a3m, *a3n, *a3o, *a49, *a4a, *a4b, *a4c, *a4d, *a4e
            , *a4f, *a4g, *a4h, *a4k, *a4l, *a4m, *a4n, *a4o, *a59, *a5a, *a5b, *a5c, *a5d, *a5e, *a5g, *a5h, *a5k, *a5l, *a5m, *a5n, *a5o, *a69
            , *a6a, *a6b, *a6c, *a6d, *a6e, *a6f, *a6g, *a6h, *a6i, *a6k, *a6l, *a6m, *a6n, *a6o, *a79, *a7a, *a7b, *a7c, *a7d, *a7e, *a7f, *a7g
            , *a7h, *a7i, *a7j, *a7k, *a7l, *a7m, *a7n, *a89, *a8a, *a8b, *a8c, *a8d, *a8e, *a8f, *a8g, *a8h, *a8i, *a8j, *a8k, *a8l, *a8m, *a8n
            , *a99, *a9a, *a9b, *a9c, *a9d, *a9e, *a9f, *a9g, *a9h, *a9i, *a9j, *a9k, *a9l, *a9m, *a9n;
    const double  *a, *a01, *a03, *a05, *a07, *a08, *a11, *a12, *a13, *a15, *a17, *a18, *a2, *a21, *a22, *a23, *a25, *a27, *a28, *a3, *a31, *a32
            , *a33, *a34, *a35, *a37, *a4, *a41, *a42, *a43, *a44, *a45, *a47, *a5, *a51, *a52, *a53, *a54, *a55, *a57, *a6, *a61, *a62, *a63
            , *a64, *a65, *a67, *a7, *a72, *a74, *a75, *a76, *a77, *a8, *a82, *a84, *a85, *a86, *a87, *a9, *a92, *a94, *a96, *a97;
    int a0n, a5f, a6j, a98;
    double a02, a04, a06, a0p, a14, a16, a24, a26, a2h, a2i, a36, a38, a3h, a3i, a46, a48, a4i, a4j, a56, a58, a5i, a5j
            , a66, a68, a71, a73, a78, a7o, a81, a83, a88, a8o, a91, a93, a95, a9o, s, s01, s02, s03, s04, s05, s06, s07
            , s11, s12, s13, s14, s15, s16, s17, s2, s21, s22, s23, s24, s25, s26, s27, s3, s31, s32, s33, s34, s35, s36
            , s37, s4, s41, s42, s43, s44, s45, s46, s47, s5, s51, s52, s53, s54, s55, s56, s57, s6, s61, s62, s63, s64
            , s65, s66, s67, s7, s71, s72, s73, s74, s75, s76, s8, s81, s82, s83, s84, s85, s86, s9, s91, s92, s93, s94
            , s95, s96, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0A, t0B, t0C, t0D, t0E, t0F, t0G, t0H, t0I, t0a
            , t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o, t0p, t0q, t0r, t0s, t0t, t0u, t0v, t0w
            , t0x, t0y, t0z, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1A, t1B, t1C, t1D, t1E, t1F, t1G, t1H, t1I, t1a
            , t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t, t1u, t1v, t1w
            , t1x, t1y, t1z, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2A, t2B, t2C, t2D, t2E, t2F, t2G, t2H, t2I
            , t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p, t2q, t2r, t2s, t2t, t2u, t2v
            , t2w, t2x, t2y, t2z, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3A, t3B, t3C, t3D, t3E, t3F, t3G, t3H
            , t3I, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s, t3t, t3u
            , t3v, t3w, t3x, t3y, t3z, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4A, t4B, t4C, t4D, t4E, t4F, t4G
            , t4H, t4I, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t4o, t4p, t4q, t4r, t4s, t4t
            , t4u, t4v, t4w, t4x, t4y, t4z, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5A, t5B, t5C, t5D, t5E, t5F
            , t5G, t5H, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t5r, t5s, t5t
            , t5u, t5v, t5w, t5x, t5y, t5z, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6A, t6B, t6C, t6D, t6E, t6F
            , t6G, t6H, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r, t6s, t6t
            , t6u, t6v, t6w, t6x, t6y, t6z, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7A, t7B, t7C, t7D, t7E, t7F
            , t7G, t7H, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m, t7n, t7o, t7p, t7q, t7r, t7s, t7t
            , t7u, t7v, t7w, t7x, t7y, t7z, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8A, t8B, t8C, t8D, t8E, t8F
            , t8G, t8H, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p, t8q, t8r, t8s, t8t
            , t8u, t8v, t8w, t8x, t8y, t8z, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9A, t9B, t9C, t9D, t9E, t9F
            , t9G, t9H, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p, t9q, t9r, t9s, t9t
            , t9u, t9v, t9w, t9x, t9y, t9z;
    {long i; for(i = 0; i <= 7; i++) {
        {long i2; for(i2 = 0; i2 <= 15; i2++) {
            a = (src + (2*i) + (16*i2));
            a2 = (a + 1);
            a3 = (a + 4096);
            a4 = (a + 4097);
            t = (*(a) + *(a3));
            t2 = (*(a2) + *(a4));
            t3 = (*(a) - *(a3));
            t4 = (*(a2) - *(a4));
            a5 = (a + 2048);
            a6 = (a + 2049);
            a7 = (a + 6144);
            a8 = (a + 6145);
            t5 = (*(a5) + *(a7));
            t6 = (*(a6) + *(a8));
            t7 = (*(a5) - *(a7));
            t8 = (*(a6) - *(a8));
            t9 = (t + t5);
            t01 = (t2 + t6);
            t11 = (t - t5);
            t21 = (t2 - t6);
            t31 = (t3 + t8);
            t41 = (t4 - t7);
            t51 = (t3 - t8);
            t61 = (t4 + t7);
            a9 = (a + 1024);
            a01 = (a + 1025);
            a11 = (a + 5120);
            a21 = (a + 5121);
            t71 = (*(a9) + *(a11));
            t81 = (*(a01) + *(a21));
            t91 = (*(a9) - *(a11));
            t02 = (*(a01) - *(a21));
            a31 = (a + 3072);
            a41 = (a + 3073);
            a51 = (a + 7168);
            a61 = (a + 7169);
            t12 = (*(a31) + *(a51));
            t22 = (*(a41) + *(a61));
            t32 = (*(a31) - *(a51));
            t42 = (*(a41) - *(a61));
            t52 = (t71 + t12);
            t62 = (t81 + t22);
            t72 = (t71 - t12);
            t82 = (t81 - t22);
            a71 = (0.70710678118654757*(t91 + t42));
            a81 = (0.70710678118654757*(t02 - t32));
            s = (a71 + a81);
            s2 = (a81 - a71);
            a91 = (0.70710678118654757*(t02 + t32));
            a02 = (0.70710678118654757*(t91 - t42));
            s3 = (a91 - a02);
            s4 = (a02 + a91);
            t92 = (t9 + t52);
            t03 = (t01 + t62);
            t13 = (t9 - t52);
            t23 = (t01 - t62);
            t33 = (t31 + s);
            t43 = (t41 + s2);
            t53 = (t31 - s);
            t63 = (t41 - s2);
            t73 = (t11 + t82);
            t83 = (t21 - t72);
            t93 = (t11 - t82);
            t04 = (t21 + t72);
            t14 = (t51 + s3);
            t24 = (t61 - s4);
            t34 = (t51 - s3);
            t44 = (t61 + s4);
            a12 = (a + 256);
            a22 = (a + 257);
            a32 = (a + 4352);
            a42 = (a + 4353);
            t54 = (*(a12) + *(a32));
            t64 = (*(a22) + *(a42));
            t74 = (*(a12) - *(a32));
            t84 = (*(a22) - *(a42));
            a52 = (a + 2304);
            a62 = (a + 2305);
            a72 = (a + 6400);
            a82 = (a + 6401);
            t94 = (*(a52) + *(a72));
            t05 = (*(a62) + *(a82));
            t15 = (*(a52) - *(a72));
            t25 = (*(a62) - *(a82));
            t35 = (t54 + t94);
            t45 = (t64 + t05);
            t55 = (t54 - t94);
            t65 = (t64 - t05);
            t75 = (t74 + t25);
            t85 = (t84 - t15);
            t95 = (t74 - t25);
            t06 = (t84 + t15);
            a92 = (a + 1280);
            a03 = (a + 1281);
            a13 = (a + 5376);
            a23 = (a + 5377);
            t16 = (*(a92) + *(a13));
            t26 = (*(a03) + *(a23));
            t36 = (*(a92) - *(a13));
            t46 = (*(a03) - *(a23));
            a33 = (a + 3328);
            a43 = (a + 3329);
            a53 = (a + 7424);
            a63 = (a + 7425);
            t56 = (*(a33) + *(a53));
            t66 = (*(a43) + *(a63));
            t76 = (*(a33) - *(a53));
            t86 = (*(a43) - *(a63));
            t96 = (t16 + t56);
            t07 = (t26 + t66);
            t17 = (t16 - t56);
            t27 = (t26 - t66);
            a73 = (0.70710678118654757*(t36 + t86));
            a83 = (0.70710678118654757*(t46 - t76));
            s5 = (a73 + a83);
            s6 = (a83 - a73);
            a93 = (0.70710678118654757*(t46 + t76));
            a04 = (0.70710678118654757*(t36 - t86));
            s7 = (a93 - a04);
            s8 = (a04 + a93);
            t37 = (t35 + t96);
            t47 = (t45 + t07);
            a14 = (0.70710678118654757*(t35 - t96));
            a24 = (0.70710678118654757*(t45 - t07));
            s9 = (a14 + a24);
            s01 = (a24 - a14);
            t57 = (t75 + s5);
            t67 = (t85 + s6);
            t77 = (t75 - s5);
            t87 = (t85 - s6);
            s11 = ((0.98078528040323043*t57) + (0.19509032201612828*t67));
            s21 = ((0.98078528040323043*t67) - (0.19509032201612828*t57));
            s31 = ((0.55557023301960218*t77) + (0.83146961230254524*t87));
            s41 = ((0.55557023301960218*t87) - (0.83146961230254524*t77));
            t97 = (t55 + t27);
            t08 = (t65 - t17);
            t18 = (t55 - t27);
            t28 = (t65 + t17);
            s51 = ((0.92387953251128674*t97) + (0.38268343236508978*t08));
            s61 = ((0.92387953251128674*t08) - (0.38268343236508978*t97));
            s71 = ((0.38268343236508978*t18) + (0.92387953251128674*t28));
            s81 = ((0.38268343236508978*t28) - (0.92387953251128674*t18));
            t38 = (t95 + s7);
            t48 = (t06 - s8);
            t58 = (t95 - s7);
            t68 = (t06 + s8);
            s91 = ((0.83146961230254524*t38) + (0.55557023301960218*t48));
            s02 = ((0.83146961230254524*t48) - (0.55557023301960218*t38));
            s12 = ((0.19509032201612828*t58) + (0.98078528040323043*t68));
            s22 = ((0.19509032201612828*t68) - (0.98078528040323043*t58));
            a34 = (a + 512);
            a44 = (a + 513);
            a54 = (a + 4608);
            a64 = (a + 4609);
            t78 = (*(a34) + *(a54));
            t88 = (*(a44) + *(a64));
            t98 = (*(a34) - *(a54));
            t09 = (*(a44) - *(a64));
            a74 = (a + 2560);
            a84 = (a + 2561);
            a94 = (a + 6656);
            a05 = (a + 6657);
            t19 = (*(a74) + *(a94));
            t29 = (*(a84) + *(a05));
            t39 = (*(a74) - *(a94));
            t49 = (*(a84) - *(a05));
            t59 = (t78 + t19);
            t69 = (t88 + t29);
            t79 = (t78 - t19);
            t89 = (t88 - t29);
            t99 = (t98 + t49);
            t0a = (t09 - t39);
            t1a = (t98 - t49);
            t2a = (t09 + t39);
            a15 = (a + 1536);
            a25 = (a + 1537);
            a35 = (a + 5632);
            a45 = (a + 5633);
            t3a = (*(a15) + *(a35));
            t4a = (*(a25) + *(a45));
            t5a = (*(a15) - *(a35));
            t6a = (*(a25) - *(a45));
            a55 = (a + 3584);
            a65 = (a + 3585);
            a75 = (a + 7680);
            a85 = (a + 7681);
            t7a = (*(a55) + *(a75));
            t8a = (*(a65) + *(a85));
            t9a = (*(a55) - *(a75));
            t0b = (*(a65) - *(a85));
            t1b = (t3a + t7a);
            t2b = (t4a + t8a);
            t3b = (t3a - t7a);
            t4b = (t4a - t8a);
            a95 = (0.70710678118654757*(t5a + t0b));
            a06 = (0.70710678118654757*(t6a - t9a));
            s32 = (a95 + a06);
            s42 = (a06 - a95);
            a16 = (0.70710678118654757*(t6a + t9a));
            a26 = (0.70710678118654757*(t5a - t0b));
            s52 = (a16 - a26);
            s62 = (a26 + a16);
            t5b = (t59 + t1b);
            t6b = (t69 + t2b);
            t7b = (t59 - t1b);
            t8b = (t69 - t2b);
            t9b = (t99 + s32);
            t0c = (t0a + s42);
            t1c = (t99 - s32);
            t2c = (t0a - s42);
            s72 = ((0.92387953251128674*t9b) + (0.38268343236508978*t0c));
            s82 = ((0.92387953251128674*t0c) - (0.38268343236508978*t9b));
            s92 = ((0.92387953251128674*t2c) - (0.38268343236508978*t1c));
            s03 = ((0.92387953251128674*t1c) + (0.38268343236508978*t2c));
            a36 = (0.70710678118654757*(t79 + t4b));
            a46 = (0.70710678118654757*(t89 - t3b));
            s13 = (a36 + a46);
            s23 = (a46 - a36);
            a56 = (0.70710678118654757*(t89 + t3b));
            a66 = (0.70710678118654757*(t79 - t4b));
            s33 = (a56 - a66);
            s43 = (a66 + a56);
            t3c = (t1a + s52);
            t4c = (t2a - s62);
            t5c = (t1a - s52);
            t6c = (t2a + s62);
            s53 = ((0.38268343236508978*t3c) + (0.92387953251128674*t4c));
            s63 = ((0.38268343236508978*t4c) - (0.92387953251128674*t3c));
            s73 = ((0.38268343236508978*t6c) - (0.92387953251128674*t5c));
            s83 = ((0.38268343236508978*t5c) + (0.92387953251128674*t6c));
            a76 = (a + 768);
            a86 = (a + 769);
            a96 = (a + 4864);
            a07 = (a + 4865);
            t7c = (*(a76) + *(a96));
            t8c = (*(a86) + *(a07));
            t9c = (*(a76) - *(a96));
            t0d = (*(a86) - *(a07));
            a17 = (a + 2816);
            a27 = (a + 2817);
            a37 = (a + 6912);
            a47 = (a + 6913);
            t1d = (*(a17) + *(a37));
            t2d = (*(a27) + *(a47));
            t3d = (*(a17) - *(a37));
            t4d = (*(a27) - *(a47));
            t5d = (t7c + t1d);
            t6d = (t8c + t2d);
            t7d = (t7c - t1d);
            t8d = (t8c - t2d);
            t9d = (t9c + t4d);
            t0e = (t0d - t3d);
            t1e = (t9c - t4d);
            t2e = (t0d + t3d);
            a57 = (a + 1792);
            a67 = (a + 1793);
            a77 = (a + 5888);
            a87 = (a + 5889);
            t3e = (*(a57) + *(a77));
            t4e = (*(a67) + *(a87));
            t5e = (*(a57) - *(a77));
            t6e = (*(a67) - *(a87));
            a97 = (a + 3840);
            a08 = (a + 3841);
            a18 = (a + 7936);
            a28 = (a + 7937);
            t7e = (*(a97) + *(a18));
            t8e = (*(a08) + *(a28));
            t9e = (*(a97) - *(a18));
            t0f = (*(a08) - *(a28));
            t1f = (t3e + t7e);
            t2f = (t4e + t8e);
            t3f = (t3e - t7e);
            t4f = (t4e - t8e);
            a38 = (0.70710678118654757*(t5e + t0f));
            a48 = (0.70710678118654757*(t6e - t9e));
            s93 = (a38 + a48);
            s04 = (a48 - a38);
            a58 = (0.70710678118654757*(t6e + t9e));
            a68 = (0.70710678118654757*(t5e - t0f));
            s14 = (a58 - a68);
            s24 = (a68 + a58);
            t5f = (t5d + t1f);
            t6f = (t6d + t2f);
            a78 = (0.70710678118654757*(t6d - t2f));
            a88 = (0.70710678118654757*(t5d - t1f));
            s34 = (a78 - a88);
            s44 = (a88 + a78);
            t7f = (t9d + s93);
            t8f = (t0e + s04);
            t9f = (t9d - s93);
            t0g = (t0e - s04);
            s54 = ((0.83146961230254524*t7f) + (0.55557023301960218*t8f));
            s64 = ((0.83146961230254524*t8f) - (0.55557023301960218*t7f));
            s74 = ((0.19509032201612828*t0g) - (0.98078528040323043*t9f));
            s84 = ((0.19509032201612828*t9f) + (0.98078528040323043*t0g));
            t1g = (t7d + t4f);
            t2g = (t8d - t3f);
            t3g = (t7d - t4f);
            t4g = (t8d + t3f);
            s94 = ((0.38268343236508978*t1g) + (0.92387953251128674*t2g));
            s05 = ((0.38268343236508978*t2g) - (0.92387953251128674*t1g));
            s15 = ((0.92387953251128674*t3g) + (0.38268343236508978*t4g));
            s25 = ((0.38268343236508978*t3g) - (0.92387953251128674*t4g));
            t5g = (t1e + s14);
            t6g = (t2e - s24);
            t7g = (t1e - s14);
            t8g = (t2e + s24);
            s35 = ((0.98078528040323043*t6g) - (0.19509032201612828*t5g));
            s45 = ((0.98078528040323043*t5g) + (0.19509032201612828*t6g));
            s55 = ((0.55557023301960218*t7g) + (0.83146961230254524*t8g));
            s65 = ((0.83146961230254524*t7g) - (0.55557023301960218*t8g));
            t9g = (t92 + t5b);
            t0h = (t03 + t6b);
            t1h = (t92 - t5b);
            t2h = (t03 - t6b);
            t3h = (t37 + t5f);
            t4h = (t47 + t6f);
            t5h = (t37 - t5f);
            t6h = (t47 - t6f);
            t7h = (t9g + t3h);
            t8h = (t0h + t4h);
            t9h = (t9g - t3h);
            t0i = (t0h - t4h);
            a98 = (64*i2);
            a09 = (D294 + a98);
            a19 = (a09 + 1);
            a29 = (a09 + 2);
            a39 = (a09 + 3);
            a49 = (T2 + a98);
            *(a49) = ((*(a09)*t7h) - (*(a19)*t8h));
            *((a49 + 1)) = ((*(a19)*t7h) + (*(a09)*t8h));
            *((a49 + 32)) = ((*(a29)*t9h) - (*(a39)*t0i));
            *((a49 + 33)) = ((*(a39)*t9h) + (*(a29)*t0i));
            t1i = (t1h + t6h);
            t2i = (t2h - t5h);
            t3i = (t1h - t6h);
            t4i = (t2h + t5h);
            a59 = (a09 + 4);
            a69 = (a09 + 5);
            a79 = (a09 + 6);
            a89 = (a09 + 7);
            *((a49 + 16)) = ((*(a59)*t1i) - (*(a69)*t2i));
            *((a49 + 17)) = ((*(a69)*t1i) + (*(a59)*t2i));
            *((a49 + 48)) = ((*(a79)*t3i) - (*(a89)*t4i));
            *((a49 + 49)) = ((*(a89)*t3i) + (*(a79)*t4i));
            t5i = (t33 + s72);
            t6i = (t43 + s82);
            t7i = (t33 - s72);
            t8i = (t43 - s82);
            t9i = (s11 + s54);
            t0j = (s21 + s64);
            t1j = (s11 - s54);
            t2j = (s21 - s64);
            t3j = (t5i + t9i);
            t4j = (t6i + t0j);
            t5j = (t5i - t9i);
            t6j = (t6i - t0j);
            a99 = (a09 + 8);
            a0a = (a09 + 9);
            a1a = (a09 + 10);
            a2a = (a09 + 11);
            *((a49 + 2)) = ((*(a99)*t3j) - (*(a0a)*t4j));
            *((a49 + 3)) = ((*(a0a)*t3j) + (*(a99)*t4j));
            *((a49 + 34)) = ((*(a1a)*t5j) - (*(a2a)*t6j));
            *((a49 + 35)) = ((*(a2a)*t5j) + (*(a1a)*t6j));
            t7j = (t7i + t2j);
            t8j = (t8i - t1j);
            t9j = (t7i - t2j);
            t0k = (t8i + t1j);
            a3a = (a09 + 12);
            a4a = (a09 + 13);
            a5a = (a09 + 14);
            a6a = (a09 + 15);
            *((a49 + 18)) = ((*(a3a)*t7j) - (*(a4a)*t8j));
            *((a49 + 19)) = ((*(a4a)*t7j) + (*(a3a)*t8j));
            *((a49 + 50)) = ((*(a5a)*t9j) - (*(a6a)*t0k));
            *((a49 + 51)) = ((*(a6a)*t9j) + (*(a5a)*t0k));
            t1k = (t73 + s13);
            t2k = (t83 + s23);
            t3k = (t73 - s13);
            t4k = (t83 - s23);
            t5k = (s51 + s94);
            t6k = (s61 + s05);
            t7k = (s51 - s94);
            t8k = (s61 - s05);
            t9k = (t1k + t5k);
            t0l = (t2k + t6k);
            t1l = (t1k - t5k);
            t2l = (t2k - t6k);
            a7a = (a09 + 16);
            a8a = (a09 + 17);
            a9a = (a09 + 18);
            a0b = (a09 + 19);
            *((a49 + 4)) = ((*(a7a)*t9k) - (*(a8a)*t0l));
            *((a49 + 5)) = ((*(a8a)*t9k) + (*(a7a)*t0l));
            *((a49 + 36)) = ((*(a9a)*t1l) - (*(a0b)*t2l));
            *((a49 + 37)) = ((*(a0b)*t1l) + (*(a9a)*t2l));
            t3l = (t3k + t8k);
            t4l = (t4k - t7k);
            t5l = (t3k - t8k);
            t6l = (t4k + t7k);
            a1b = (a09 + 20);
            a2b = (a09 + 21);
            a3b = (a09 + 22);
            a4b = (a09 + 23);
            *((a49 + 20)) = ((*(a1b)*t3l) - (*(a2b)*t4l));
            *((a49 + 21)) = ((*(a2b)*t3l) + (*(a1b)*t4l));
            *((a49 + 52)) = ((*(a3b)*t5l) - (*(a4b)*t6l));
            *((a49 + 53)) = ((*(a4b)*t5l) + (*(a3b)*t6l));
            t7l = (t14 + s53);
            t8l = (t24 + s63);
            t9l = (t14 - s53);
            t0m = (t24 - s63);
            t1m = (s91 + s35);
            t2m = (s02 - s45);
            t3m = (s91 - s35);
            t4m = (s02 + s45);
            t5m = (t7l + t1m);
            t6m = (t8l + t2m);
            t7m = (t7l - t1m);
            t8m = (t8l - t2m);
            a5b = (a09 + 24);
            a6b = (a09 + 25);
            a7b = (a09 + 26);
            a8b = (a09 + 27);
            *((a49 + 6)) = ((*(a5b)*t5m) - (*(a6b)*t6m));
            *((a49 + 7)) = ((*(a6b)*t5m) + (*(a5b)*t6m));
            *((a49 + 38)) = ((*(a7b)*t7m) - (*(a8b)*t8m));
            *((a49 + 39)) = ((*(a8b)*t7m) + (*(a7b)*t8m));
            t9m = (t9l + t4m);
            t0n = (t0m - t3m);
            t1n = (t9l - t4m);
            t2n = (t0m + t3m);
            a9b = (a09 + 28);
            a0c = (a09 + 29);
            a1c = (a09 + 30);
            a2c = (a09 + 31);
            *((a49 + 22)) = ((*(a9b)*t9m) - (*(a0c)*t0n));
            *((a49 + 23)) = ((*(a0c)*t9m) + (*(a9b)*t0n));
            *((a49 + 54)) = ((*(a1c)*t1n) - (*(a2c)*t2n));
            *((a49 + 55)) = ((*(a2c)*t1n) + (*(a1c)*t2n));
            t3n = (t13 + t8b);
            t4n = (t23 - t7b);
            t5n = (t13 - t8b);
            t6n = (t23 + t7b);
            t7n = (s9 + s34);
            t8n = (s01 - s44);
            t9n = (s9 - s34);
            t0o = (s01 + s44);
            t1o = (t3n + t7n);
            t2o = (t4n + t8n);
            t3o = (t3n - t7n);
            t4o = (t4n - t8n);
            a3c = (a09 + 32);
            a4c = (a09 + 33);
            a5c = (a09 + 34);
            a6c = (a09 + 35);
            *((a49 + 8)) = ((*(a3c)*t1o) - (*(a4c)*t2o));
            *((a49 + 9)) = ((*(a4c)*t1o) + (*(a3c)*t2o));
            *((a49 + 40)) = ((*(a5c)*t3o) - (*(a6c)*t4o));
            *((a49 + 41)) = ((*(a6c)*t3o) + (*(a5c)*t4o));
            t5o = (t5n + t0o);
            t6o = (t6n - t9n);
            t7o = (t5n - t0o);
            t8o = (t6n + t9n);
            a7c = (a09 + 36);
            a8c = (a09 + 37);
            a9c = (a09 + 38);
            a0d = (a09 + 39);
            *((a49 + 24)) = ((*(a7c)*t5o) - (*(a8c)*t6o));
            *((a49 + 25)) = ((*(a8c)*t5o) + (*(a7c)*t6o));
            *((a49 + 56)) = ((*(a9c)*t7o) - (*(a0d)*t8o));
            *((a49 + 57)) = ((*(a0d)*t7o) + (*(a9c)*t8o));
            t9o = (t53 + s92);
            t0p = (t63 - s03);
            t1p = (t53 - s92);
            t2p = (t63 + s03);
            t3p = (s31 + s74);
            t4p = (s41 - s84);
            t5p = (s31 - s74);
            t6p = (s41 + s84);
            t7p = (t9o + t3p);
            t8p = (t0p + t4p);
            t9p = (t9o - t3p);
            t0q = (t0p - t4p);
            a1d = (a09 + 40);
            a2d = (a09 + 41);
            a3d = (a09 + 42);
            a4d = (a09 + 43);
            *((a49 + 10)) = ((*(a1d)*t7p) - (*(a2d)*t8p));
            *((a49 + 11)) = ((*(a2d)*t7p) + (*(a1d)*t8p));
            *((a49 + 42)) = ((*(a3d)*t9p) - (*(a4d)*t0q));
            *((a49 + 43)) = ((*(a4d)*t9p) + (*(a3d)*t0q));
            t1q = (t1p + t6p);
            t2q = (t2p - t5p);
            t3q = (t1p - t6p);
            t4q = (t2p + t5p);
            a5d = (a09 + 44);
            a6d = (a09 + 45);
            a7d = (a09 + 46);
            a8d = (a09 + 47);
            *((a49 + 26)) = ((*(a5d)*t1q) - (*(a6d)*t2q));
            *((a49 + 27)) = ((*(a6d)*t1q) + (*(a5d)*t2q));
            *((a49 + 58)) = ((*(a7d)*t3q) - (*(a8d)*t4q));
            *((a49 + 59)) = ((*(a8d)*t3q) + (*(a7d)*t4q));
            t5q = (t93 + s33);
            t6q = (t04 - s43);
            t7q = (t93 - s33);
            t8q = (t04 + s43);
            t9q = (s71 - s15);
            t0r = (s81 + s25);
            t1r = (s71 + s15);
            t2r = (s81 - s25);
            t3r = (t5q + t9q);
            t4r = (t6q + t0r);
            t5r = (t5q - t9q);
            t6r = (t6q - t0r);
            a9d = (a09 + 48);
            a0e = (a09 + 49);
            a1e = (a09 + 50);
            a2e = (a09 + 51);
            *((a49 + 12)) = ((*(a9d)*t3r) - (*(a0e)*t4r));
            *((a49 + 13)) = ((*(a0e)*t3r) + (*(a9d)*t4r));
            *((a49 + 44)) = ((*(a1e)*t5r) - (*(a2e)*t6r));
            *((a49 + 45)) = ((*(a2e)*t5r) + (*(a1e)*t6r));
            t7r = (t7q + t2r);
            t8r = (t8q - t1r);
            t9r = (t7q - t2r);
            t0s = (t8q + t1r);
            a3e = (a09 + 52);
            a4e = (a09 + 53);
            a5e = (a09 + 54);
            a6e = (a09 + 55);
            *((a49 + 28)) = ((*(a3e)*t7r) - (*(a4e)*t8r));
            *((a49 + 29)) = ((*(a4e)*t7r) + (*(a3e)*t8r));
            *((a49 + 60)) = ((*(a5e)*t9r) - (*(a6e)*t0s));
            *((a49 + 61)) = ((*(a6e)*t9r) + (*(a5e)*t0s));
            t1s = (t34 + s73);
            t2s = (t44 - s83);
            t3s = (t34 - s73);
            t4s = (t44 + s83);
            t5s = (s12 - s55);
            t6s = (s22 + s65);
            t7s = (s12 + s55);
            t8s = (s22 - s65);
            t9s = (t1s + t5s);
            t0t = (t2s + t6s);
            t1t = (t1s - t5s);
            t2t = (t2s - t6s);
            a7e = (a09 + 56);
            a8e = (a09 + 57);
            a9e = (a09 + 58);
            a0f = (a09 + 59);
            *((a49 + 14)) = ((*(a7e)*t9s) - (*(a8e)*t0t));
            *((a49 + 15)) = ((*(a8e)*t9s) + (*(a7e)*t0t));
            *((a49 + 46)) = ((*(a9e)*t1t) - (*(a0f)*t2t));
            *((a49 + 47)) = ((*(a0f)*t1t) + (*(a9e)*t2t));
            t3t = (t3s + t8s);
            t4t = (t4s - t7s);
            t5t = (t3s - t8s);
            t6t = (t4s + t7s);
            a1f = (a09 + 60);
            a2f = (a09 + 61);
            a3f = (a09 + 62);
            a4f = (a09 + 63);
            *((a49 + 30)) = ((*(a1f)*t3t) - (*(a2f)*t4t));
            *((a49 + 31)) = ((*(a2f)*t3t) + (*(a1f)*t4t));
            *((a49 + 62)) = ((*(a3f)*t5t) - (*(a4f)*t6t));
            *((a49 + 63)) = ((*(a4f)*t5t) + (*(a3f)*t6t));
        }}
        {long i3; for(i3 = 0; i3 <= 31; i3++) {
            a5f = (2*i3);
            a6f = (T2 + a5f);
            a7f = (a6f + 1);
            a8f = (a6f + 512);
            a9f = (a6f + 513);
            t7t = (*(a6f) + *(a8f));
            t8t = (*(a7f) + *(a9f));
            t9t = (*(a6f) - *(a8f));
            t0u = (*(a7f) - *(a9f));
            a0g = (a6f + 256);
            a1g = (a6f + 257);
            a2g = (a6f + 768);
            a3g = (a6f + 769);
            t1u = (*(a0g) + *(a2g));
            t2u = (*(a1g) + *(a3g));
            t3u = (*(a0g) - *(a2g));
            t4u = (*(a1g) - *(a3g));
            t5u = (t7t + t1u);
            t6u = (t8t + t2u);
            t7u = (t7t - t1u);
            t8u = (t8t - t2u);
            t9u = (t9t + t4u);
            t0v = (t0u - t3u);
            t1v = (t9t - t4u);
            t2v = (t0u + t3u);
            a4g = (a6f + 64);
            a5g = (a6f + 65);
            a6g = (a6f + 576);
            a7g = (a6f + 577);
            t3v = (*(a4g) + *(a6g));
            t4v = (*(a5g) + *(a7g));
            t5v = (*(a4g) - *(a6g));
            t6v = (*(a5g) - *(a7g));
            a8g = (a6f + 320);
            a9g = (a6f + 321);
            a0h = (a6f + 832);
            a1h = (a6f + 833);
            t7v = (*(a8g) + *(a0h));
            t8v = (*(a9g) + *(a1h));
            t9v = (*(a8g) - *(a0h));
            t0w = (*(a9g) - *(a1h));
            t1w = (t3v + t7v);
            t2w = (t4v + t8v);
            a2h = (0.70710678118654757*(t3v - t7v));
            a3h = (0.70710678118654757*(t4v - t8v));
            s75 = (a2h + a3h);
            s85 = (a3h - a2h);
            t3w = (t5v + t0w);
            t4w = (t6v - t9v);
            t5w = (t5v - t0w);
            t6w = (t6v + t9v);
            s95 = ((0.92387953251128674*t3w) + (0.38268343236508978*t4w));
            s06 = ((0.92387953251128674*t4w) - (0.38268343236508978*t3w));
            s16 = ((0.38268343236508978*t5w) + (0.92387953251128674*t6w));
            s26 = ((0.38268343236508978*t6w) - (0.92387953251128674*t5w));
            a4h = (a6f + 128);
            a5h = (a6f + 129);
            a6h = (a6f + 640);
            a7h = (a6f + 641);
            t7w = (*(a4h) + *(a6h));
            t8w = (*(a5h) + *(a7h));
            t9w = (*(a4h) - *(a6h));
            t0x = (*(a5h) - *(a7h));
            a8h = (a6f + 384);
            a9h = (a6f + 385);
            a0i = (a6f + 896);
            a1i = (a6f + 897);
            t1x = (*(a8h) + *(a0i));
            t2x = (*(a9h) + *(a1i));
            t3x = (*(a8h) - *(a0i));
            t4x = (*(a9h) - *(a1i));
            t5x = (t7w + t1x);
            t6x = (t8w + t2x);
            t7x = (t7w - t1x);
            t8x = (t8w - t2x);
            a2i = (0.70710678118654757*(t9w + t4x));
            a3i = (0.70710678118654757*(t0x - t3x));
            s36 = (a2i + a3i);
            s46 = (a3i - a2i);
            a4i = (0.70710678118654757*(t0x + t3x));
            a5i = (0.70710678118654757*(t9w - t4x));
            s56 = (a4i - a5i);
            s66 = (a5i + a4i);
            a6i = (a6f + 192);
            a7i = (a6f + 193);
            a8i = (a6f + 704);
            a9i = (a6f + 705);
            t9x = (*(a6i) + *(a8i));
            t0y = (*(a7i) + *(a9i));
            t1y = (*(a6i) - *(a8i));
            t2y = (*(a7i) - *(a9i));
            a0j = (a6f + 448);
            a1j = (a6f + 449);
            a2j = (a6f + 960);
            a3j = (a6f + 961);
            t3y = (*(a0j) + *(a2j));
            t4y = (*(a1j) + *(a3j));
            t5y = (*(a0j) - *(a2j));
            t6y = (*(a1j) - *(a3j));
            t7y = (t9x + t3y);
            t8y = (t0y + t4y);
            a4j = (0.70710678118654757*(t0y - t4y));
            a5j = (0.70710678118654757*(t9x - t3y));
            s76 = (a4j - a5j);
            s86 = (a5j + a4j);
            t9y = (t1y + t6y);
            t0z = (t2y - t5y);
            t1z = (t1y - t6y);
            t2z = (t2y + t5y);
            s96 = ((0.38268343236508978*t9y) + (0.92387953251128674*t0z));
            s07 = ((0.38268343236508978*t0z) - (0.92387953251128674*t9y));
            s17 = ((0.92387953251128674*t1z) + (0.38268343236508978*t2z));
            s27 = ((0.38268343236508978*t1z) - (0.92387953251128674*t2z));
            t3z = (t5u + t5x);
            t4z = (t6u + t6x);
            t5z = (t5u - t5x);
            t6z = (t6u - t6x);
            t7z = (t1w + t7y);
            t8z = (t2w + t8y);
            t9z = (t1w - t7y);
            t0A = (t2w - t8y);
            t1A = (t3z + t7z);
            t2A = (t4z + t8z);
            t3A = (t3z - t7z);
            t4A = (t4z - t8z);
            a6j = (1024*i);
            a7j = (D297 + a6j + (32*i3));
            a8j = (a7j + 1);
            a9j = (a7j + 2);
            a0k = (a7j + 3);
            a1k = (T + a6j + a5f);
            *(a1k) = ((*(a7j)*t1A) - (*(a8j)*t2A));
            *((a1k + 1)) = ((*(a8j)*t1A) + (*(a7j)*t2A));
            *((a1k + 512)) = ((*(a9j)*t3A) - (*(a0k)*t4A));
            *((a1k + 513)) = ((*(a0k)*t3A) + (*(a9j)*t4A));
            t5A = (t5z + t0A);
            t6A = (t6z - t9z);
            t7A = (t5z - t0A);
            t8A = (t6z + t9z);
            a2k = (a7j + 4);
            a3k = (a7j + 5);
            a4k = (a7j + 6);
            a5k = (a7j + 7);
            *((a1k + 256)) = ((*(a2k)*t5A) - (*(a3k)*t6A));
            *((a1k + 257)) = ((*(a3k)*t5A) + (*(a2k)*t6A));
            *((a1k + 768)) = ((*(a4k)*t7A) - (*(a5k)*t8A));
            *((a1k + 769)) = ((*(a5k)*t7A) + (*(a4k)*t8A));
            t9A = (t9u + s36);
            t0B = (t0v + s46);
            t1B = (t9u - s36);
            t2B = (t0v - s46);
            t3B = (s95 + s96);
            t4B = (s06 + s07);
            t5B = (s95 - s96);
            t6B = (s06 - s07);
            t7B = (t9A + t3B);
            t8B = (t0B + t4B);
            t9B = (t9A - t3B);
            t0C = (t0B - t4B);
            a6k = (a7j + 8);
            a7k = (a7j + 9);
            a8k = (a7j + 10);
            a9k = (a7j + 11);
            *((a1k + 64)) = ((*(a6k)*t7B) - (*(a7k)*t8B));
            *((a1k + 65)) = ((*(a7k)*t7B) + (*(a6k)*t8B));
            *((a1k + 576)) = ((*(a8k)*t9B) - (*(a9k)*t0C));
            *((a1k + 577)) = ((*(a9k)*t9B) + (*(a8k)*t0C));
            t1C = (t1B + t6B);
            t2C = (t2B - t5B);
            t3C = (t1B - t6B);
            t4C = (t2B + t5B);
            a0l = (a7j + 12);
            a1l = (a7j + 13);
            a2l = (a7j + 14);
            a3l = (a7j + 15);
            *((a1k + 320)) = ((*(a0l)*t1C) - (*(a1l)*t2C));
            *((a1k + 321)) = ((*(a1l)*t1C) + (*(a0l)*t2C));
            *((a1k + 832)) = ((*(a2l)*t3C) - (*(a3l)*t4C));
            *((a1k + 833)) = ((*(a3l)*t3C) + (*(a2l)*t4C));
            t5C = (t7u + t8x);
            t6C = (t8u - t7x);
            t7C = (t7u - t8x);
            t8C = (t8u + t7x);
            t9C = (s75 + s76);
            t0D = (s85 - s86);
            t1D = (s75 - s76);
            t2D = (s85 + s86);
            t3D = (t5C + t9C);
            t4D = (t6C + t0D);
            t5D = (t5C - t9C);
            t6D = (t6C - t0D);
            a4l = (a7j + 16);
            a5l = (a7j + 17);
            a6l = (a7j + 18);
            a7l = (a7j + 19);
            *((a1k + 128)) = ((*(a4l)*t3D) - (*(a5l)*t4D));
            *((a1k + 129)) = ((*(a5l)*t3D) + (*(a4l)*t4D));
            *((a1k + 640)) = ((*(a6l)*t5D) - (*(a7l)*t6D));
            *((a1k + 641)) = ((*(a7l)*t5D) + (*(a6l)*t6D));
            t7D = (t7C + t2D);
            t8D = (t8C - t1D);
            t9D = (t7C - t2D);
            t0E = (t8C + t1D);
            a8l = (a7j + 20);
            a9l = (a7j + 21);
            a0m = (a7j + 22);
            a1m = (a7j + 23);
            *((a1k + 384)) = ((*(a8l)*t7D) - (*(a9l)*t8D));
            *((a1k + 385)) = ((*(a9l)*t7D) + (*(a8l)*t8D));
            *((a1k + 896)) = ((*(a0m)*t9D) - (*(a1m)*t0E));
            *((a1k + 897)) = ((*(a1m)*t9D) + (*(a0m)*t0E));
            t1E = (t1v + s56);
            t2E = (t2v - s66);
            t3E = (t1v - s56);
            t4E = (t2v + s66);
            t5E = (s16 - s17);
            t6E = (s26 + s27);
            t7E = (s16 + s17);
            t8E = (s26 - s27);
            t9E = (t1E + t5E);
            t0F = (t2E + t6E);
            t1F = (t1E - t5E);
            t2F = (t2E - t6E);
            a2m = (a7j + 24);
            a3m = (a7j + 25);
            a4m = (a7j + 26);
            a5m = (a7j + 27);
            *((a1k + 192)) = ((*(a2m)*t9E) - (*(a3m)*t0F));
            *((a1k + 193)) = ((*(a3m)*t9E) + (*(a2m)*t0F));
            *((a1k + 704)) = ((*(a4m)*t1F) - (*(a5m)*t2F));
            *((a1k + 705)) = ((*(a5m)*t1F) + (*(a4m)*t2F));
            t3F = (t3E + t8E);
            t4F = (t4E - t7E);
            t5F = (t3E - t8E);
            t6F = (t4E + t7E);
            a6m = (a7j + 28);
            a7m = (a7j + 29);
            a8m = (a7j + 30);
            a9m = (a7j + 31);
            *((a1k + 448)) = ((*(a6m)*t3F) - (*(a7m)*t4F));
            *((a1k + 449)) = ((*(a7m)*t3F) + (*(a6m)*t4F));
            *((a1k + 960)) = ((*(a8m)*t5F) - (*(a9m)*t6F));
            *((a1k + 961)) = ((*(a9m)*t5F) + (*(a8m)*t6F));
        }}
    }}
    {long i4; for(i4 = 0; i4 <= 511; i4++) {
        a0n = (2*i4);
        a1n = (T + a0n);
        a2n = (a1n + 1);
        a3n = (a1n + 4096);
        a4n = (a1n + 4097);
        t7F = (*(a1n) + *(a3n));
        t8F = (*(a2n) + *(a4n));
        t9F = (*(a1n) - *(a3n));
        t0G = (*(a2n) - *(a4n));
        a5n = (a1n + 2048);
        a6n = (a1n + 2049);
        a7n = (a1n + 6144);
        a8n = (a1n + 6145);
        t1G = (*(a5n) + *(a7n));
        t2G = (*(a6n) + *(a8n));
        t3G = (*(a5n) - *(a7n));
        t4G = (*(a6n) - *(a8n));
        t5G = (t7F + t1G);
        t6G = (t8F + t2G);
        t7G = (t7F - t1G);
        t8G = (t8F - t2G);
        t9G = (t9F + t4G);
        t0H = (t0G - t3G);
        t1H = (t9F - t4G);
        t2H = (t0G + t3G);
        a9n = (a1n + 1024);
        a0o = (a1n + 1025);
        a1o = (a1n + 5120);
        a2o = (a1n + 5121);
        t3H = (*(a9n) + *(a1o));
        t4H = (*(a0o) + *(a2o));
        t5H = (*(a9n) - *(a1o));
        t6H = (*(a0o) - *(a2o));
        a3o = (a1n + 3072);
        a4o = (a1n + 3073);
        a5o = (a1n + 7168);
        a6o = (a1n + 7169);
        t7H = (*(a3o) + *(a5o));
        t8H = (*(a4o) + *(a6o));
        t9H = (*(a3o) - *(a5o));
        t0I = (*(a4o) - *(a6o));
        t1I = (t3H + t7H);
        t2I = (t4H + t8H);
        t3I = (t3H - t7H);
        t4I = (t4H - t8H);
        a7o = (0.70710678118654757*(t5H + t0I));
        a8o = (0.70710678118654757*(t6H - t9H));
        s37 = (a7o + a8o);
        s47 = (a8o - a7o);
        a9o = (0.70710678118654757*(t6H + t9H));
        a0p = (0.70710678118654757*(t5H - t0I));
        s57 = (a9o - a0p);
        s67 = (a0p + a9o);
        a1p = (dst + a0n);
        *(a1p) = (t5G + t1I);
        *((a1p + 1)) = (t6G + t2I);
        *((a1p + 4096)) = (t5G - t1I);
        *((a1p + 4097)) = (t6G - t2I);
        *((a1p + 1024)) = (t9G + s37);
        *((a1p + 1025)) = (t0H + s47);
        *((a1p + 5120)) = (t9G - s37);
        *((a1p + 5121)) = (t0H - s47);
        *((a1p + 2048)) = (t7G + t4I);
        *((a1p + 2049)) = (t8G - t3I);
        *((a1p + 6144)) = (t7G - t4I);
        *((a1p + 6145)) = (t8G + t3I);
        *((a1p + 3072)) = (t1H + s57);
        *((a1p + 3073)) = (t2H - s67);
        *((a1p + 7168)) = (t1H - s57);
        *((a1p + 7169)) = (t2H + s67);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_double_8192)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *) pSrc; 
    double        *dst = (double *) pDst;
    
    
    { double T[16384];
     double T2[2048];
     double T3[128];
    double  *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a0c, *a0e, *a0f, *a0g, *a15, *a16, *a17, *a18, *a1a, *a1b, *a1c, *a1e, *a1g, *a24, *a25
            , *a26, *a27, *a28, *a2a, *a2b, *a2c, *a2e, *a2f, *a2g, *a2h, *a34, *a35, *a36, *a37, *a38, *a3a, *a3b, *a3c, *a3e, *a3f, *a3g, *a44
            , *a45, *a46, *a47, *a48, *a4a, *a4b, *a4c, *a4d, *a4e, *a4f, *a4g, *a54, *a55, *a56, *a57, *a58, *a5a, *a5b, *a5c, *a5d, *a5e, *a5f
            , *a5g, *a64, *a65, *a66, *a67, *a68, *a69, *a6a, *a6b, *a6c, *a6d, *a6e, *a6f, *a6g, *a74, *a75, *a76, *a77, *a78, *a79, *a7a, *a7b
            , *a7c, *a7d, *a7e, *a7f, *a7g, *a84, *a85, *a86, *a87, *a88, *a89, *a8a, *a8b, *a8c, *a8d, *a8e, *a8f, *a94, *a95, *a96, *a97, *a98
            , *a99, *a9a, *a9b, *a9d, *a9e, *a9f;
    const double  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a1f, a3d, a59;
    double a03, a04, a0d, a0h, a19, a1d, a1h, a29, a2d, a39, a49, a71, a72, a81, a82, a8g, a92, a93, a9c, a9g, s, s01
            , s02, s11, s12, s2, s21, s22, s3, s31, s32, s4, s41, s42, s5, s51, s52, s6, s61, s62, s7, s71, s72, s8
            , s81, s82, s9, s91, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h
            , t0i, t0j, t0k, t0l, t0m, t0n, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g
            , t1h, t1i, t1j, t1k, t1l, t1m, t1n, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e
            , t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c
            , t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l, t3m, t3n, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a
            , t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t5, t51, t52, t53, t54, t55, t56, t57, t58
            , t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t6, t61, t62, t63, t64, t65, t66
            , t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t7, t71, t72, t73, t74
            , t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m, t8, t81, t82, t83
            , t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t9, t91, t92
            , t93, t94, t95, t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m;
    {long i; for(i = 0; i <= 7; i++) {
        {long i2; for(i2 = 0; i2 <= 63; i2++) {
            a = (src + (2*i) + (16*i2));
            a2 = (a + 1);
            a3 = (a + 8192);
            a4 = (a + 8193);
            t = (*(a) + *(a3));
            t2 = (*(a2) + *(a4));
            t3 = (*(a) - *(a3));
            t4 = (*(a2) - *(a4));
            a5 = (a + 4096);
            a6 = (a + 4097);
            a7 = (a + 12288);
            a8 = (a + 12289);
            t5 = (*(a5) + *(a7));
            t6 = (*(a6) + *(a8));
            t7 = (*(a5) - *(a7));
            t8 = (*(a6) - *(a8));
            t9 = (t + t5);
            t01 = (t2 + t6);
            t11 = (t - t5);
            t21 = (t2 - t6);
            t31 = (t3 + t8);
            t41 = (t4 - t7);
            t51 = (t3 - t8);
            t61 = (t4 + t7);
            a9 = (a + 1024);
            a01 = (a + 1025);
            a11 = (a + 9216);
            a21 = (a + 9217);
            t71 = (*(a9) + *(a11));
            t81 = (*(a01) + *(a21));
            t91 = (*(a9) - *(a11));
            t02 = (*(a01) - *(a21));
            a31 = (a + 5120);
            a41 = (a + 5121);
            a51 = (a + 13312);
            a61 = (a + 13313);
            t12 = (*(a31) + *(a51));
            t22 = (*(a41) + *(a61));
            t32 = (*(a31) - *(a51));
            t42 = (*(a41) - *(a61));
            t52 = (t71 + t12);
            t62 = (t81 + t22);
            a71 = (0.70710678118654757*(t71 - t12));
            a81 = (0.70710678118654757*(t81 - t22));
            s = (a71 + a81);
            s2 = (a81 - a71);
            t72 = (t91 + t42);
            t82 = (t02 - t32);
            t92 = (t91 - t42);
            t03 = (t02 + t32);
            s3 = ((0.92387953251128674*t72) + (0.38268343236508978*t82));
            s4 = ((0.92387953251128674*t82) - (0.38268343236508978*t72));
            s5 = ((0.38268343236508978*t92) + (0.92387953251128674*t03));
            s6 = ((0.38268343236508978*t03) - (0.92387953251128674*t92));
            a91 = (a + 2048);
            a02 = (a + 2049);
            a12 = (a + 10240);
            a22 = (a + 10241);
            t13 = (*(a91) + *(a12));
            t23 = (*(a02) + *(a22));
            t33 = (*(a91) - *(a12));
            t43 = (*(a02) - *(a22));
            a32 = (a + 6144);
            a42 = (a + 6145);
            a52 = (a + 14336);
            a62 = (a + 14337);
            t53 = (*(a32) + *(a52));
            t63 = (*(a42) + *(a62));
            t73 = (*(a32) - *(a52));
            t83 = (*(a42) - *(a62));
            t93 = (t13 + t53);
            t04 = (t23 + t63);
            t14 = (t13 - t53);
            t24 = (t23 - t63);
            a72 = (0.70710678118654757*(t33 + t83));
            a82 = (0.70710678118654757*(t43 - t73));
            s7 = (a72 + a82);
            s8 = (a82 - a72);
            a92 = (0.70710678118654757*(t43 + t73));
            a03 = (0.70710678118654757*(t33 - t83));
            s9 = (a92 - a03);
            s01 = (a03 + a92);
            a13 = (a + 3072);
            a23 = (a + 3073);
            a33 = (a + 11264);
            a43 = (a + 11265);
            t34 = (*(a13) + *(a33));
            t44 = (*(a23) + *(a43));
            t54 = (*(a13) - *(a33));
            t64 = (*(a23) - *(a43));
            a53 = (a + 7168);
            a63 = (a + 7169);
            a73 = (a + 15360);
            a83 = (a + 15361);
            t74 = (*(a53) + *(a73));
            t84 = (*(a63) + *(a83));
            t94 = (*(a53) - *(a73));
            t05 = (*(a63) - *(a83));
            t15 = (t34 + t74);
            t25 = (t44 + t84);
            a93 = (0.70710678118654757*(t44 - t84));
            a04 = (0.70710678118654757*(t34 - t74));
            s11 = (a93 - a04);
            s21 = (a04 + a93);
            t35 = (t54 + t05);
            t45 = (t64 - t94);
            t55 = (t54 - t05);
            t65 = (t64 + t94);
            s31 = ((0.38268343236508978*t35) + (0.92387953251128674*t45));
            s41 = ((0.38268343236508978*t45) - (0.92387953251128674*t35));
            s51 = ((0.92387953251128674*t55) + (0.38268343236508978*t65));
            s61 = ((0.38268343236508978*t55) - (0.92387953251128674*t65));
            t75 = (t9 + t93);
            t85 = (t01 + t04);
            t95 = (t9 - t93);
            t06 = (t01 - t04);
            t16 = (t52 + t15);
            t26 = (t62 + t25);
            t36 = (t52 - t15);
            t46 = (t62 - t25);
            t56 = (t75 + t16);
            t66 = (t85 + t26);
            t76 = (t75 - t16);
            t86 = (t85 - t26);
            a14 = (32*i2);
            a24 = (D295 + a14);
            a34 = (a24 + 1);
            a44 = (a24 + 2);
            a54 = (a24 + 3);
            a64 = (T2 + a14);
            *(a64) = ((*(a24)*t56) - (*(a34)*t66));
            *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
            *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
            *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
            t96 = (t95 + t46);
            t07 = (t06 - t36);
            t17 = (t95 - t46);
            t27 = (t06 + t36);
            a74 = (a24 + 4);
            a84 = (a24 + 5);
            a94 = (a24 + 6);
            a05 = (a24 + 7);
            *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
            *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
            *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
            *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
            t37 = (t31 + s7);
            t47 = (t41 + s8);
            t57 = (t31 - s7);
            t67 = (t41 - s8);
            t77 = (s3 + s31);
            t87 = (s4 + s41);
            t97 = (s3 - s31);
            t08 = (s4 - s41);
            t18 = (t37 + t77);
            t28 = (t47 + t87);
            t38 = (t37 - t77);
            t48 = (t47 - t87);
            a15 = (a24 + 8);
            a25 = (a24 + 9);
            a35 = (a24 + 10);
            a45 = (a24 + 11);
            *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
            *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
            *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
            *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
            t58 = (t57 + t08);
            t68 = (t67 - t97);
            t78 = (t57 - t08);
            t88 = (t67 + t97);
            a55 = (a24 + 12);
            a65 = (a24 + 13);
            a75 = (a24 + 14);
            a85 = (a24 + 15);
            *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
            *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
            *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
            *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
            t98 = (t11 + t24);
            t09 = (t21 - t14);
            t19 = (t11 - t24);
            t29 = (t21 + t14);
            t39 = (s + s11);
            t49 = (s2 - s21);
            t59 = (s - s11);
            t69 = (s2 + s21);
            t79 = (t98 + t39);
            t89 = (t09 + t49);
            t99 = (t98 - t39);
            t0a = (t09 - t49);
            a95 = (a24 + 16);
            a06 = (a24 + 17);
            a16 = (a24 + 18);
            a26 = (a24 + 19);
            *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
            *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
            *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
            *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
            t1a = (t19 + t69);
            t2a = (t29 - t59);
            t3a = (t19 - t69);
            t4a = (t29 + t59);
            a36 = (a24 + 20);
            a46 = (a24 + 21);
            a56 = (a24 + 22);
            a66 = (a24 + 23);
            *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
            *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
            *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
            *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
            t5a = (t51 + s9);
            t6a = (t61 - s01);
            t7a = (t51 - s9);
            t8a = (t61 + s01);
            t9a = (s5 - s51);
            t0b = (s6 + s61);
            t1b = (s5 + s51);
            t2b = (s6 - s61);
            t3b = (t5a + t9a);
            t4b = (t6a + t0b);
            t5b = (t5a - t9a);
            t6b = (t6a - t0b);
            a76 = (a24 + 24);
            a86 = (a24 + 25);
            a96 = (a24 + 26);
            a07 = (a24 + 27);
            *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
            *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
            *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
            *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
            t7b = (t7a + t2b);
            t8b = (t8a - t1b);
            t9b = (t7a - t2b);
            t0c = (t8a + t1b);
            a17 = (a24 + 28);
            a27 = (a24 + 29);
            a37 = (a24 + 30);
            a47 = (a24 + 31);
            *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
            *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
            *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
            *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
        }}
        {long i3; for(i3 = 0; i3 <= 15; i3++) {
            {long i4; for(i4 = 0; i4 <= 7; i4++) {
                a57 = (T2 + (2*i3) + (32*i4));
                a67 = (a57 + 1);
                a77 = (a57 + 1024);
                a87 = (a57 + 1025);
                t1c = (*(a57) + *(a77));
                t2c = (*(a67) + *(a87));
                t3c = (*(a57) - *(a77));
                t4c = (*(a67) - *(a87));
                a97 = (a57 + 512);
                a08 = (a57 + 513);
                a18 = (a57 + 1536);
                a28 = (a57 + 1537);
                t5c = (*(a97) + *(a18));
                t6c = (*(a08) + *(a28));
                t7c = (*(a97) - *(a18));
                t8c = (*(a08) - *(a28));
                t9c = (t1c + t5c);
                t0d = (t2c + t6c);
                t1d = (t1c - t5c);
                t2d = (t2c - t6c);
                t3d = (t3c + t8c);
                t4d = (t4c - t7c);
                t5d = (t3c - t8c);
                t6d = (t4c + t7c);
                a38 = (a57 + 256);
                a48 = (a57 + 257);
                a58 = (a57 + 1280);
                a68 = (a57 + 1281);
                t7d = (*(a38) + *(a58));
                t8d = (*(a48) + *(a68));
                t9d = (*(a38) - *(a58));
                t0e = (*(a48) - *(a68));
                a78 = (a57 + 768);
                a88 = (a57 + 769);
                a98 = (a57 + 1792);
                a09 = (a57 + 1793);
                t1e = (*(a78) + *(a98));
                t2e = (*(a88) + *(a09));
                t3e = (*(a78) - *(a98));
                t4e = (*(a88) - *(a09));
                t5e = (t7d + t1e);
                t6e = (t8d + t2e);
                t7e = (t7d - t1e);
                t8e = (t8d - t2e);
                a19 = (0.70710678118654757*(t9d + t4e));
                a29 = (0.70710678118654757*(t0e - t3e));
                s71 = (a19 + a29);
                s81 = (a29 - a19);
                a39 = (0.70710678118654757*(t0e + t3e));
                a49 = (0.70710678118654757*(t9d - t4e));
                s91 = (a39 - a49);
                s02 = (a49 + a39);
                t9e = (t9c + t5e);
                t0f = (t0d + t6e);
                t1f = (t9c - t5e);
                t2f = (t0d - t6e);
                a59 = (16*i4);
                a69 = (D291 + a59);
                a79 = (a69 + 1);
                a89 = (a69 + 2);
                a99 = (a69 + 3);
                a0a = (T3 + a59);
                *(a0a) = ((*(a69)*t9e) - (*(a79)*t0f));
                *((a0a + 1)) = ((*(a79)*t9e) + (*(a69)*t0f));
                *((a0a + 8)) = ((*(a89)*t1f) - (*(a99)*t2f));
                *((a0a + 9)) = ((*(a99)*t1f) + (*(a89)*t2f));
                t3f = (t3d + s71);
                t4f = (t4d + s81);
                t5f = (t3d - s71);
                t6f = (t4d - s81);
                a1a = (a69 + 4);
                a2a = (a69 + 5);
                a3a = (a69 + 6);
                a4a = (a69 + 7);
                *((a0a + 2)) = ((*(a1a)*t3f) - (*(a2a)*t4f));
                *((a0a + 3)) = ((*(a2a)*t3f) + (*(a1a)*t4f));
                *((a0a + 10)) = ((*(a3a)*t5f) - (*(a4a)*t6f));
                *((a0a + 11)) = ((*(a4a)*t5f) + (*(a3a)*t6f));
                t7f = (t1d + t8e);
                t8f = (t2d - t7e);
                t9f = (t1d - t8e);
                t0g = (t2d + t7e);
                a5a = (a69 + 8);
                a6a = (a69 + 9);
                a7a = (a69 + 10);
                a8a = (a69 + 11);
                *((a0a + 4)) = ((*(a5a)*t7f) - (*(a6a)*t8f));
                *((a0a + 5)) = ((*(a6a)*t7f) + (*(a5a)*t8f));
                *((a0a + 12)) = ((*(a7a)*t9f) - (*(a8a)*t0g));
                *((a0a + 13)) = ((*(a8a)*t9f) + (*(a7a)*t0g));
                t1g = (t5d + s91);
                t2g = (t6d - s02);
                t3g = (t5d - s91);
                t4g = (t6d + s02);
                a9a = (a69 + 12);
                a0b = (a69 + 13);
                a1b = (a69 + 14);
                a2b = (a69 + 15);
                *((a0a + 6)) = ((*(a9a)*t1g) - (*(a0b)*t2g));
                *((a0a + 7)) = ((*(a0b)*t1g) + (*(a9a)*t2g));
                *((a0a + 14)) = ((*(a1b)*t3g) - (*(a2b)*t4g));
                *((a0a + 15)) = ((*(a2b)*t3g) + (*(a1b)*t4g));
            }}
            {long i5; for(i5 = 0; i5 <= 7; i5++) {
                a3b = (T3 + (2*i5));
                a4b = (a3b + 1);
                a5b = (a3b + 64);
                a6b = (a3b + 65);
                t5g = (*(a3b) + *(a5b));
                t6g = (*(a4b) + *(a6b));
                t7g = (*(a3b) - *(a5b));
                t8g = (*(a4b) - *(a6b));
                a7b = (a3b + 32);
                a8b = (a3b + 33);
                a9b = (a3b + 96);
                a0c = (a3b + 97);
                t9g = (*(a7b) + *(a9b));
                t0h = (*(a8b) + *(a0c));
                t1h = (*(a7b) - *(a9b));
                t2h = (*(a8b) - *(a0c));
                t3h = (t5g + t9g);
                t4h = (t6g + t0h);
                t5h = (t5g - t9g);
                t6h = (t6g - t0h);
                t7h = (t7g + t2h);
                t8h = (t8g - t1h);
                t9h = (t7g - t2h);
                t0i = (t8g + t1h);
                a1c = (a3b + 16);
                a2c = (a3b + 17);
                a3c = (a3b + 80);
                a4c = (a3b + 81);
                t1i = (*(a1c) + *(a3c));
                t2i = (*(a2c) + *(a4c));
                t3i = (*(a1c) - *(a3c));
                t4i = (*(a2c) - *(a4c));
                a5c = (a3b + 48);
                a6c = (a3b + 49);
                a7c = (a3b + 112);
                a8c = (a3b + 113);
                t5i = (*(a5c) + *(a7c));
                t6i = (*(a6c) + *(a8c));
                t7i = (*(a5c) - *(a7c));
                t8i = (*(a6c) - *(a8c));
                t9i = (t1i + t5i);
                t0j = (t2i + t6i);
                t1j = (t1i - t5i);
                t2j = (t2i - t6i);
                a9c = (0.70710678118654757*(t3i + t8i));
                a0d = (0.70710678118654757*(t4i - t7i));
                s12 = (a9c + a0d);
                s22 = (a0d - a9c);
                a1d = (0.70710678118654757*(t4i + t7i));
                a2d = (0.70710678118654757*(t3i - t8i));
                s32 = (a1d - a2d);
                s42 = (a2d + a1d);
                t3j = (t3h + t9i);
                t4j = (t4h + t0j);
                t5j = (t3h - t9i);
                t6j = (t4h - t0j);
                a3d = (2048*i);
                a4d = (D298 + a3d + (128*i3) + (16*i5));
                a5d = (a4d + 1);
                a6d = (a4d + 2);
                a7d = (a4d + 3);
                a8d = (T + a3d + (2*i3) + (32*i5));
                *(a8d) = ((*(a4d)*t3j) - (*(a5d)*t4j));
                *((a8d + 1)) = ((*(a5d)*t3j) + (*(a4d)*t4j));
                *((a8d + 1024)) = ((*(a6d)*t5j) - (*(a7d)*t6j));
                *((a8d + 1025)) = ((*(a7d)*t5j) + (*(a6d)*t6j));
                t7j = (t7h + s12);
                t8j = (t8h + s22);
                t9j = (t7h - s12);
                t0k = (t8h - s22);
                a9d = (a4d + 4);
                a0e = (a4d + 5);
                a1e = (a4d + 6);
                a2e = (a4d + 7);
                *((a8d + 256)) = ((*(a9d)*t7j) - (*(a0e)*t8j));
                *((a8d + 257)) = ((*(a0e)*t7j) + (*(a9d)*t8j));
                *((a8d + 1280)) = ((*(a1e)*t9j) - (*(a2e)*t0k));
                *((a8d + 1281)) = ((*(a2e)*t9j) + (*(a1e)*t0k));
                t1k = (t5h + t2j);
                t2k = (t6h - t1j);
                t3k = (t5h - t2j);
                t4k = (t6h + t1j);
                a3e = (a4d + 8);
                a4e = (a4d + 9);
                a5e = (a4d + 10);
                a6e = (a4d + 11);
                *((a8d + 512)) = ((*(a3e)*t1k) - (*(a4e)*t2k));
                *((a8d + 513)) = ((*(a4e)*t1k) + (*(a3e)*t2k));
                *((a8d + 1536)) = ((*(a5e)*t3k) - (*(a6e)*t4k));
                *((a8d + 1537)) = ((*(a6e)*t3k) + (*(a5e)*t4k));
                t5k = (t9h + s32);
                t6k = (t0i - s42);
                t7k = (t9h - s32);
                t8k = (t0i + s42);
                a7e = (a4d + 12);
                a8e = (a4d + 13);
                a9e = (a4d + 14);
                a0f = (a4d + 15);
                *((a8d + 768)) = ((*(a7e)*t5k) - (*(a8e)*t6k));
                *((a8d + 769)) = ((*(a8e)*t5k) + (*(a7e)*t6k));
                *((a8d + 1792)) = ((*(a9e)*t7k) - (*(a0f)*t8k));
                *((a8d + 1793)) = ((*(a0f)*t7k) + (*(a9e)*t8k));
            }}
        }}
    }}
    {long i6; for(i6 = 0; i6 <= 1023; i6++) {
        a1f = (2*i6);
        a2f = (T + a1f);
        a3f = (a2f + 1);
        a4f = (a2f + 8192);
        a5f = (a2f + 8193);
        t9k = (*(a2f) + *(a4f));
        t0l = (*(a3f) + *(a5f));
        t1l = (*(a2f) - *(a4f));
        t2l = (*(a3f) - *(a5f));
        a6f = (a2f + 4096);
        a7f = (a2f + 4097);
        a8f = (a2f + 12288);
        a9f = (a2f + 12289);
        t3l = (*(a6f) + *(a8f));
        t4l = (*(a7f) + *(a9f));
        t5l = (*(a6f) - *(a8f));
        t6l = (*(a7f) - *(a9f));
        t7l = (t9k + t3l);
        t8l = (t0l + t4l);
        t9l = (t9k - t3l);
        t0m = (t0l - t4l);
        t1m = (t1l + t6l);
        t2m = (t2l - t5l);
        t3m = (t1l - t6l);
        t4m = (t2l + t5l);
        a0g = (a2f + 2048);
        a1g = (a2f + 2049);
        a2g = (a2f + 10240);
        a3g = (a2f + 10241);
        t5m = (*(a0g) + *(a2g));
        t6m = (*(a1g) + *(a3g));
        t7m = (*(a0g) - *(a2g));
        t8m = (*(a1g) - *(a3g));
        a4g = (a2f + 6144);
        a5g = (a2f + 6145);
        a6g = (a2f + 14336);
        a7g = (a2f + 14337);
        t9m = (*(a4g) + *(a6g));
        t0n = (*(a5g) + *(a7g));
        t1n = (*(a4g) - *(a6g));
        t2n = (*(a5g) - *(a7g));
        t3n = (t5m + t9m);
        t4n = (t6m + t0n);
        t5n = (t5m - t9m);
        t6n = (t6m - t0n);
        a8g = (0.70710678118654757*(t7m + t2n));
        a9g = (0.70710678118654757*(t8m - t1n));
        s52 = (a8g + a9g);
        s62 = (a9g - a8g);
        a0h = (0.70710678118654757*(t8m + t1n));
        a1h = (0.70710678118654757*(t7m - t2n));
        s72 = (a0h - a1h);
        s82 = (a1h + a0h);
        a2h = (dst + a1f);
        *(a2h) = (t7l + t3n);
        *((a2h + 1)) = (t8l + t4n);
        *((a2h + 8192)) = (t7l - t3n);
        *((a2h + 8193)) = (t8l - t4n);
        *((a2h + 2048)) = (t1m + s52);
        *((a2h + 2049)) = (t2m + s62);
        *((a2h + 10240)) = (t1m - s52);
        *((a2h + 10241)) = (t2m - s62);
        *((a2h + 4096)) = (t9l + t6n);
        *((a2h + 4097)) = (t0m - t5n);
        *((a2h + 12288)) = (t9l - t6n);
        *((a2h + 12289)) = (t0m + t5n);
        *((a2h + 6144)) = (t3m + s72);
        *((a2h + 6145)) = (t4m - s82);
        *((a2h + 14336)) = (t3m - s72);
        *((a2h + 14337)) = (t4m + s82);
    }}
    }
    
    return SPIRAL_OK;
}

