/*/////////////////////////////////////////////////////////////////////////////
//
//     spiral_fft_float.c
//
//     This library was generated by Spiral 6.0, developed at Carnegie Mellon
//     University, http://www.spiral.net. This code is distributed under the
//     GNU general purpose software license version 2.0.
//
//     Commercial licenses and support are available through SpiralGen, Inc.
//     fft@spiralgen.com
//
*/

#include "spiral_fft.h"
#include "spiral_private.h"

/*************************************************
 * Main dispatch  
 *************************************************/

SPIRAL_API(spiral_status_t, spiral_fft_float)(int n, int sign, const float *pSrc, float *pDst ) {
    if (sign<0) {
        switch(n) {
            case 2: return spiral_fftfwd_float_2(pSrc, pDst );
            case 4: return spiral_fftfwd_float_4(pSrc, pDst );
            case 8: return spiral_fftfwd_float_8(pSrc, pDst );
            case 16: return spiral_fftfwd_float_16(pSrc, pDst );
            case 32: return spiral_fftfwd_float_32(pSrc, pDst );
            case 64: return spiral_fftfwd_float_64(pSrc, pDst );
            case 128: return spiral_fftfwd_float_128(pSrc, pDst );
            case 256: return spiral_fftfwd_float_256(pSrc, pDst );
            case 512: return spiral_fftfwd_float_512(pSrc, pDst );
            case 1024: return spiral_fftfwd_float_1024(pSrc, pDst );
            case 2048: return spiral_fftfwd_float_2048(pSrc, pDst );
            case 4096: return spiral_fftfwd_float_4096(pSrc, pDst );
            case 8192: return spiral_fftfwd_float_8192(pSrc, pDst );
            default: return SPIRAL_SIZE_NOT_SUPPORTED;
        }
    } 
    else {
        switch(n) {
            case 2: return spiral_fftinv_float_2(pSrc, pDst );
            case 4: return spiral_fftinv_float_4(pSrc, pDst );
            case 8: return spiral_fftinv_float_8(pSrc, pDst );
            case 16: return spiral_fftinv_float_16(pSrc, pDst );
            case 32: return spiral_fftinv_float_32(pSrc, pDst );
            case 64: return spiral_fftinv_float_64(pSrc, pDst );
            case 128: return spiral_fftinv_float_128(pSrc, pDst );
            case 256: return spiral_fftinv_float_256(pSrc, pDst );
            case 512: return spiral_fftinv_float_512(pSrc, pDst );
            case 1024: return spiral_fftinv_float_1024(pSrc, pDst );
            case 2048: return spiral_fftinv_float_2048(pSrc, pDst );
            case 4096: return spiral_fftinv_float_4096(pSrc, pDst );
            case 8192: return spiral_fftinv_float_8192(pSrc, pDst );
            default: return SPIRAL_SIZE_NOT_SUPPORTED;
        }
    }
}

/*************************************************
 * Individual transform sizes  
 *************************************************/

SPIRAL_API(spiral_status_t, spiral_fftinv_float_2)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    {const float  *a, *a2, *a3;
    a = (src + 2);
    a2 = (src + 1);
    a3 = (src + 3);
    *(dst) = (*(src) + *(a));
    *((dst + 1)) = (*(a2) + *(a3));
    *((dst + 2)) = (*(src) - *(a));
    *((dst + 3)) = (*(a2) - *(a3));
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_float_4)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    {const float  *a, *a2, *a3, *a4, *a5, *a6, *a7;
    float t, t2, t3, t4, t5, t6, t7, t8;
    a = (src + 4);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 5);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 2);
    a5 = (src + 6);
    t5 = (*(a4) + *(a5));
    a6 = (src + 3);
    a7 = (src + 7);
    t6 = (*(a6) + *(a7));
    t7 = (*(a4) - *(a5));
    t8 = (*(a6) - *(a7));
    *(dst) = (t + t5);
    *((dst + 1)) = (t2 + t6);
    *((dst + 4)) = (t - t5);
    *((dst + 5)) = (t2 - t6);
    *((dst + 2)) = (t3 - t8);
    *((dst + 3)) = (t4 + t7);
    *((dst + 6)) = (t3 + t8);
    *((dst + 7)) = (t4 - t7);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_float_8)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    {const float  *a, *a01, *a11, *a2, *a21, *a3, *a31, *a4, *a41, *a5, *a51, *a6, *a61, *a7, *a71;
    float a8, a81, a9, a91, s, s2, s3, s4, t, t01, t02, t11, t12, t2, t21, t22, t3, t31, t32, t4, t41, t42
            , t5, t51, t52, t6, t61, t62, t7, t71, t72, t8, t81, t82, t9, t91;
    a = (src + 8);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 9);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 2);
    a5 = (src + 10);
    t5 = (*(a4) + *(a5));
    a6 = (src + 3);
    a7 = (src + 11);
    t6 = (*(a6) + *(a7));
    a8 = (0.70710678118654757f*(*(a4) - *(a5)));
    a9 = (0.70710678118654757f*(*(a6) - *(a7)));
    s = (a8 - a9);
    s2 = (a8 + a9);
    a01 = (src + 4);
    a11 = (src + 12);
    t7 = (*(a01) + *(a11));
    a21 = (src + 5);
    a31 = (src + 13);
    t8 = (*(a21) + *(a31));
    t9 = (*(a01) - *(a11));
    t01 = (*(a21) - *(a31));
    a41 = (src + 6);
    a51 = (src + 14);
    t11 = (*(a41) + *(a51));
    a61 = (src + 7);
    a71 = (src + 15);
    t21 = (*(a61) + *(a71));
    a81 = (0.70710678118654757f*(*(a41) - *(a51)));
    a91 = (0.70710678118654757f*(*(a61) - *(a71)));
    s3 = (a81 + a91);
    s4 = (a81 - a91);
    t31 = (t + t7);
    t41 = (t2 + t8);
    t51 = (t - t7);
    t61 = (t2 - t8);
    t71 = (t5 + t11);
    t81 = (t6 + t21);
    t91 = (t5 - t11);
    t02 = (t6 - t21);
    *(dst) = (t31 + t71);
    *((dst + 1)) = (t41 + t81);
    *((dst + 8)) = (t31 - t71);
    *((dst + 9)) = (t41 - t81);
    *((dst + 4)) = (t51 - t02);
    *((dst + 5)) = (t61 + t91);
    *((dst + 12)) = (t51 + t02);
    *((dst + 13)) = (t61 - t91);
    t12 = (t3 - t01);
    t22 = (t4 + t9);
    t32 = (t3 + t01);
    t42 = (t4 - t9);
    t52 = (s - s3);
    t62 = (s2 + s4);
    t72 = (s + s3);
    t82 = (s2 - s4);
    *((dst + 2)) = (t12 + t52);
    *((dst + 3)) = (t22 + t62);
    *((dst + 10)) = (t12 - t52);
    *((dst + 11)) = (t22 - t62);
    *((dst + 6)) = (t32 - t82);
    *((dst + 7)) = (t42 + t72);
    *((dst + 14)) = (t32 + t82);
    *((dst + 15)) = (t42 - t72);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_float_16)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    {const float  *a, *a01, *a02, *a03, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52
            , *a53, *a6, *a63, *a7, *a73, *a8, *a81, *a9, *a91;
    float a61, a62, a71, a72, a82, a83, a92, a93, s, s01, s11, s2, s21, s3, s31, s4, s41, s5, s51, s6, s61, s7
            , s8, s9, t, t01, t02, t03, t04, t05, t06, t07, t08, t11, t12, t13, t14, t15, t16, t17, t18, t2, t21, t22
            , t23, t24, t25, t26, t27, t28, t3, t31, t32, t33, t34, t35, t36, t37, t38, t4, t41, t42, t43, t44, t45, t46
            , t47, t48, t5, t51, t52, t53, t54, t55, t56, t57, t58, t6, t61, t62, t63, t64, t65, t66, t67, t68, t7, t71
            , t72, t73, t74, t75, t76, t77, t78, t8, t81, t82, t83, t84, t85, t86, t87, t88, t9, t91, t92, t93, t94, t95
            , t96, t97;
    a = (src + 16);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 17);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 8);
    a5 = (src + 24);
    t5 = (*(a4) + *(a5));
    a6 = (src + 9);
    a7 = (src + 25);
    t6 = (*(a6) + *(a7));
    t7 = (*(a4) - *(a5));
    t8 = (*(a6) - *(a7));
    t9 = (t + t5);
    t01 = (t2 + t6);
    t11 = (t - t5);
    t21 = (t2 - t6);
    t31 = (t3 - t8);
    t41 = (t4 + t7);
    t51 = (t3 + t8);
    t61 = (t4 - t7);
    a8 = (src + 2);
    a9 = (src + 18);
    t71 = (*(a8) + *(a9));
    a01 = (src + 3);
    a11 = (src + 19);
    t81 = (*(a01) + *(a11));
    t91 = (*(a8) - *(a9));
    t02 = (*(a01) - *(a11));
    a21 = (src + 10);
    a31 = (src + 26);
    t12 = (*(a21) + *(a31));
    a41 = (src + 11);
    a51 = (src + 27);
    t22 = (*(a41) + *(a51));
    t32 = (*(a21) - *(a31));
    t42 = (*(a41) - *(a51));
    t52 = (t71 + t12);
    t62 = (t81 + t22);
    a61 = (0.70710678118654757f*(t71 - t12));
    a71 = (0.70710678118654757f*(t81 - t22));
    s = (a61 - a71);
    s2 = (a61 + a71);
    t72 = (t91 - t42);
    t82 = (t02 + t32);
    t92 = (t91 + t42);
    t03 = (t02 - t32);
    s3 = ((0.92387953251128674f*t72) - (0.38268343236508978f*t82));
    s4 = ((0.38268343236508978f*t72) + (0.92387953251128674f*t82));
    s5 = ((0.38268343236508978f*t92) - (0.92387953251128674f*t03));
    s6 = ((0.92387953251128674f*t92) + (0.38268343236508978f*t03));
    a81 = (src + 4);
    a91 = (src + 20);
    t13 = (*(a81) + *(a91));
    a02 = (src + 5);
    a12 = (src + 21);
    t23 = (*(a02) + *(a12));
    t33 = (*(a81) - *(a91));
    t43 = (*(a02) - *(a12));
    a22 = (src + 12);
    a32 = (src + 28);
    t53 = (*(a22) + *(a32));
    a42 = (src + 13);
    a52 = (src + 29);
    t63 = (*(a42) + *(a52));
    t73 = (*(a22) - *(a32));
    t83 = (*(a42) - *(a52));
    t93 = (t13 + t53);
    t04 = (t23 + t63);
    t14 = (t13 - t53);
    t24 = (t23 - t63);
    a62 = (0.70710678118654757f*(t33 - t83));
    a72 = (0.70710678118654757f*(t43 + t73));
    s7 = (a62 - a72);
    s8 = (a62 + a72);
    a82 = (0.70710678118654757f*(t33 + t83));
    a92 = (0.70710678118654757f*(t43 - t73));
    s9 = (a82 + a92);
    s01 = (a82 - a92);
    a03 = (src + 6);
    a13 = (src + 22);
    t34 = (*(a03) + *(a13));
    a23 = (src + 7);
    a33 = (src + 23);
    t44 = (*(a23) + *(a33));
    t54 = (*(a03) - *(a13));
    t64 = (*(a23) - *(a33));
    a43 = (src + 14);
    a53 = (src + 30);
    t74 = (*(a43) + *(a53));
    a63 = (src + 15);
    a73 = (src + 31);
    t84 = (*(a63) + *(a73));
    t94 = (*(a43) - *(a53));
    t05 = (*(a63) - *(a73));
    t15 = (t34 + t74);
    t25 = (t44 + t84);
    a83 = (0.70710678118654757f*(t34 - t74));
    a93 = (0.70710678118654757f*(t44 - t84));
    s11 = (a83 + a93);
    s21 = (a83 - a93);
    t35 = (t54 - t05);
    t45 = (t64 + t94);
    t55 = (t54 + t05);
    t65 = (t64 - t94);
    s31 = ((0.38268343236508978f*t35) - (0.92387953251128674f*t45));
    s41 = ((0.92387953251128674f*t35) + (0.38268343236508978f*t45));
    s51 = ((0.38268343236508978f*t65) - (0.92387953251128674f*t55));
    s61 = ((0.38268343236508978f*t55) + (0.92387953251128674f*t65));
    t75 = (t9 + t93);
    t85 = (t01 + t04);
    t95 = (t9 - t93);
    t06 = (t01 - t04);
    t16 = (t52 + t15);
    t26 = (t62 + t25);
    t36 = (t52 - t15);
    t46 = (t62 - t25);
    *(dst) = (t75 + t16);
    *((dst + 1)) = (t85 + t26);
    *((dst + 16)) = (t75 - t16);
    *((dst + 17)) = (t85 - t26);
    *((dst + 8)) = (t95 - t46);
    *((dst + 9)) = (t06 + t36);
    *((dst + 24)) = (t95 + t46);
    *((dst + 25)) = (t06 - t36);
    t56 = (t31 + s7);
    t66 = (t41 + s8);
    t76 = (t31 - s7);
    t86 = (t41 - s8);
    t96 = (s3 + s31);
    t07 = (s4 + s41);
    t17 = (s3 - s31);
    t27 = (s4 - s41);
    *((dst + 2)) = (t56 + t96);
    *((dst + 3)) = (t66 + t07);
    *((dst + 18)) = (t56 - t96);
    *((dst + 19)) = (t66 - t07);
    *((dst + 10)) = (t76 - t27);
    *((dst + 11)) = (t86 + t17);
    *((dst + 26)) = (t76 + t27);
    *((dst + 27)) = (t86 - t17);
    t37 = (t11 - t24);
    t47 = (t21 + t14);
    t57 = (t11 + t24);
    t67 = (t21 - t14);
    t77 = (s - s11);
    t87 = (s2 + s21);
    t97 = (s + s11);
    t08 = (s2 - s21);
    *((dst + 4)) = (t37 + t77);
    *((dst + 5)) = (t47 + t87);
    *((dst + 20)) = (t37 - t77);
    *((dst + 21)) = (t47 - t87);
    *((dst + 12)) = (t57 - t08);
    *((dst + 13)) = (t67 + t97);
    *((dst + 28)) = (t57 + t08);
    *((dst + 29)) = (t67 - t97);
    t18 = (t51 - s9);
    t28 = (t61 + s01);
    t38 = (t51 + s9);
    t48 = (t61 - s01);
    t58 = (s5 + s51);
    t68 = (s6 - s61);
    t78 = (s5 - s51);
    t88 = (s6 + s61);
    *((dst + 6)) = (t18 + t58);
    *((dst + 7)) = (t28 + t68);
    *((dst + 22)) = (t18 - t58);
    *((dst + 23)) = (t28 - t68);
    *((dst + 14)) = (t38 - t88);
    *((dst + 15)) = (t48 + t78);
    *((dst + 30)) = (t38 + t88);
    *((dst + 31)) = (t48 - t78);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_float_32)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    {const float  *a, *a01, *a02, *a03, *a04, *a05, *a06, *a07, *a11, *a12, *a13, *a14, *a15, *a16, *a17, *a2, *a21, *a22, *a23, *a25, *a3, *a31
            , *a32, *a33, *a35, *a4, *a41, *a43, *a45, *a46, *a5, *a51, *a53, *a55, *a56, *a6, *a61, *a62, *a63, *a64, *a65, *a66, *a7, *a71
            , *a72, *a73, *a74, *a75, *a76, *a8, *a81, *a82, *a83, *a84, *a85, *a86, *a9, *a91, *a92, *a93, *a94, *a95, *a96;
    float a08, a18, a24, a26, a27, a28, a34, a36, a37, a38, a42, a44, a47, a48, a52, a54, a57, a58, a67, a68, a77, a78
            , a87, a97, s, s01, s02, s03, s04, s05, s11, s12, s13, s14, s15, s2, s21, s22, s23, s24, s25, s3, s31, s32
            , s33, s34, s35, s4, s41, s42, s43, s44, s45, s5, s51, s52, s53, s54, s55, s6, s61, s62, s63, s64, s65, s7
            , s71, s72, s73, s74, s8, s81, s82, s83, s84, s9, s91, s92, s93, s94, t, t01, t02, t03, t04, t05, t06, t07
            , t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t11, t12, t13, t14, t15, t16
            , t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t2, t21, t22, t23, t24
            , t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t3, t31, t32
            , t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l, t3m, t4, t41
            , t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t5
            , t51, t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m
            , t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l
            , t6m, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k
            , t7l, t7m, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j
            , t8k, t8l, t8m, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i
            , t9j, t9k, t9l, t9m;
    a = (src + 32);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 33);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 16);
    a5 = (src + 48);
    t5 = (*(a4) + *(a5));
    a6 = (src + 17);
    a7 = (src + 49);
    t6 = (*(a6) + *(a7));
    t7 = (*(a4) - *(a5));
    t8 = (*(a6) - *(a7));
    t9 = (t + t5);
    t01 = (t2 + t6);
    t11 = (t - t5);
    t21 = (t2 - t6);
    t31 = (t3 - t8);
    t41 = (t4 + t7);
    t51 = (t3 + t8);
    t61 = (t4 - t7);
    a8 = (src + 2);
    a9 = (src + 34);
    t71 = (*(a8) + *(a9));
    a01 = (src + 3);
    a11 = (src + 35);
    t81 = (*(a01) + *(a11));
    t91 = (*(a8) - *(a9));
    t02 = (*(a01) - *(a11));
    a21 = (src + 18);
    a31 = (src + 50);
    t12 = (*(a21) + *(a31));
    a41 = (src + 19);
    a51 = (src + 51);
    t22 = (*(a41) + *(a51));
    t32 = (*(a21) - *(a31));
    t42 = (*(a41) - *(a51));
    t52 = (t71 + t12);
    t62 = (t81 + t22);
    t72 = (t71 - t12);
    t82 = (t81 - t22);
    s = ((0.92387953251128674f*t72) - (0.38268343236508978f*t82));
    s2 = ((0.38268343236508978f*t72) + (0.92387953251128674f*t82));
    t92 = (t91 - t42);
    t03 = (t02 + t32);
    t13 = (t91 + t42);
    t23 = (t02 - t32);
    s3 = ((0.98078528040323043f*t92) - (0.19509032201612828f*t03));
    s4 = ((0.19509032201612828f*t92) + (0.98078528040323043f*t03));
    s5 = ((0.83146961230254524f*t13) - (0.55557023301960218f*t23));
    s6 = ((0.55557023301960218f*t13) + (0.83146961230254524f*t23));
    a61 = (src + 4);
    a71 = (src + 36);
    t33 = (*(a61) + *(a71));
    a81 = (src + 5);
    a91 = (src + 37);
    t43 = (*(a81) + *(a91));
    t53 = (*(a61) - *(a71));
    t63 = (*(a81) - *(a91));
    a02 = (src + 20);
    a12 = (src + 52);
    t73 = (*(a02) + *(a12));
    a22 = (src + 21);
    a32 = (src + 53);
    t83 = (*(a22) + *(a32));
    t93 = (*(a02) - *(a12));
    t04 = (*(a22) - *(a32));
    t14 = (t33 + t73);
    t24 = (t43 + t83);
    a42 = (0.70710678118654757f*(t33 - t73));
    a52 = (0.70710678118654757f*(t43 - t83));
    s7 = (a42 - a52);
    s8 = (a42 + a52);
    t34 = (t53 - t04);
    t44 = (t63 + t93);
    t54 = (t53 + t04);
    t64 = (t63 - t93);
    s9 = ((0.92387953251128674f*t34) - (0.38268343236508978f*t44));
    s01 = ((0.38268343236508978f*t34) + (0.92387953251128674f*t44));
    s11 = ((0.38268343236508978f*t54) - (0.92387953251128674f*t64));
    s21 = ((0.92387953251128674f*t54) + (0.38268343236508978f*t64));
    a62 = (src + 6);
    a72 = (src + 38);
    t74 = (*(a62) + *(a72));
    a82 = (src + 7);
    a92 = (src + 39);
    t84 = (*(a82) + *(a92));
    t94 = (*(a62) - *(a72));
    t05 = (*(a82) - *(a92));
    a03 = (src + 22);
    a13 = (src + 54);
    t15 = (*(a03) + *(a13));
    a23 = (src + 23);
    a33 = (src + 55);
    t25 = (*(a23) + *(a33));
    t35 = (*(a03) - *(a13));
    t45 = (*(a23) - *(a33));
    t55 = (t74 + t15);
    t65 = (t84 + t25);
    t75 = (t74 - t15);
    t85 = (t84 - t25);
    s31 = ((0.38268343236508978f*t75) - (0.92387953251128674f*t85));
    s41 = ((0.92387953251128674f*t75) + (0.38268343236508978f*t85));
    t95 = (t94 - t45);
    t06 = (t05 + t35);
    t16 = (t94 + t45);
    t26 = (t05 - t35);
    s51 = ((0.83146961230254524f*t95) - (0.55557023301960218f*t06));
    s61 = ((0.55557023301960218f*t95) + (0.83146961230254524f*t06));
    s71 = ((0.19509032201612828f*t16) + (0.98078528040323043f*t26));
    s81 = ((0.98078528040323043f*t16) - (0.19509032201612828f*t26));
    a43 = (src + 8);
    a53 = (src + 40);
    t36 = (*(a43) + *(a53));
    a63 = (src + 9);
    a73 = (src + 41);
    t46 = (*(a63) + *(a73));
    t56 = (*(a43) - *(a53));
    t66 = (*(a63) - *(a73));
    a83 = (src + 24);
    a93 = (src + 56);
    t76 = (*(a83) + *(a93));
    a04 = (src + 25);
    a14 = (src + 57);
    t86 = (*(a04) + *(a14));
    t96 = (*(a83) - *(a93));
    t07 = (*(a04) - *(a14));
    t17 = (t36 + t76);
    t27 = (t46 + t86);
    t37 = (t36 - t76);
    t47 = (t46 - t86);
    a24 = (0.70710678118654757f*(t56 - t07));
    a34 = (0.70710678118654757f*(t66 + t96));
    s91 = (a24 - a34);
    s02 = (a24 + a34);
    a44 = (0.70710678118654757f*(t56 + t07));
    a54 = (0.70710678118654757f*(t66 - t96));
    s12 = (a44 + a54);
    s22 = (a44 - a54);
    a64 = (src + 10);
    a74 = (src + 42);
    t57 = (*(a64) + *(a74));
    a84 = (src + 11);
    a94 = (src + 43);
    t67 = (*(a84) + *(a94));
    t77 = (*(a64) - *(a74));
    t87 = (*(a84) - *(a94));
    a05 = (src + 26);
    a15 = (src + 58);
    t97 = (*(a05) + *(a15));
    a25 = (src + 27);
    a35 = (src + 59);
    t08 = (*(a25) + *(a35));
    t18 = (*(a05) - *(a15));
    t28 = (*(a25) - *(a35));
    t38 = (t57 + t97);
    t48 = (t67 + t08);
    t58 = (t57 - t97);
    t68 = (t67 - t08);
    s32 = ((0.38268343236508978f*t58) + (0.92387953251128674f*t68));
    s42 = ((0.92387953251128674f*t58) - (0.38268343236508978f*t68));
    t78 = (t77 - t28);
    t88 = (t87 + t18);
    t98 = (t77 + t28);
    t09 = (t87 - t18);
    s52 = ((0.55557023301960218f*t78) - (0.83146961230254524f*t88));
    s62 = ((0.83146961230254524f*t78) + (0.55557023301960218f*t88));
    s72 = ((0.98078528040323043f*t98) + (0.19509032201612828f*t09));
    s82 = ((0.19509032201612828f*t98) - (0.98078528040323043f*t09));
    a45 = (src + 12);
    a55 = (src + 44);
    t19 = (*(a45) + *(a55));
    a65 = (src + 13);
    a75 = (src + 45);
    t29 = (*(a65) + *(a75));
    t39 = (*(a45) - *(a55));
    t49 = (*(a65) - *(a75));
    a85 = (src + 28);
    a95 = (src + 60);
    t59 = (*(a85) + *(a95));
    a06 = (src + 29);
    a16 = (src + 61);
    t69 = (*(a06) + *(a16));
    t79 = (*(a85) - *(a95));
    t89 = (*(a06) - *(a16));
    t99 = (t19 + t59);
    t0a = (t29 + t69);
    a26 = (0.70710678118654757f*(t19 - t59));
    a36 = (0.70710678118654757f*(t29 - t69));
    s92 = (a26 + a36);
    s03 = (a26 - a36);
    t1a = (t39 - t89);
    t2a = (t49 + t79);
    t3a = (t39 + t89);
    t4a = (t49 - t79);
    s13 = ((0.38268343236508978f*t1a) - (0.92387953251128674f*t2a));
    s23 = ((0.92387953251128674f*t1a) + (0.38268343236508978f*t2a));
    s33 = ((0.38268343236508978f*t4a) - (0.92387953251128674f*t3a));
    s43 = ((0.38268343236508978f*t3a) + (0.92387953251128674f*t4a));
    a46 = (src + 14);
    a56 = (src + 46);
    t5a = (*(a46) + *(a56));
    a66 = (src + 15);
    a76 = (src + 47);
    t6a = (*(a66) + *(a76));
    t7a = (*(a46) - *(a56));
    t8a = (*(a66) - *(a76));
    a86 = (src + 30);
    a96 = (src + 62);
    t9a = (*(a86) + *(a96));
    a07 = (src + 31);
    a17 = (src + 63);
    t0b = (*(a07) + *(a17));
    t1b = (*(a86) - *(a96));
    t2b = (*(a07) - *(a17));
    t3b = (t5a + t9a);
    t4b = (t6a + t0b);
    t5b = (t5a - t9a);
    t6b = (t6a - t0b);
    s53 = ((0.92387953251128674f*t5b) + (0.38268343236508978f*t6b));
    s63 = ((0.38268343236508978f*t5b) - (0.92387953251128674f*t6b));
    t7b = (t7a - t2b);
    t8b = (t8a + t1b);
    t9b = (t7a + t2b);
    t0c = (t8a - t1b);
    s73 = ((0.19509032201612828f*t7b) - (0.98078528040323043f*t8b));
    s83 = ((0.98078528040323043f*t7b) + (0.19509032201612828f*t8b));
    s93 = ((0.83146961230254524f*t0c) - (0.55557023301960218f*t9b));
    s04 = ((0.83146961230254524f*t9b) + (0.55557023301960218f*t0c));
    t1c = (t9 + t17);
    t2c = (t01 + t27);
    t3c = (t9 - t17);
    t4c = (t01 - t27);
    t5c = (t52 + t38);
    t6c = (t62 + t48);
    a27 = (0.70710678118654757f*(t52 - t38));
    a37 = (0.70710678118654757f*(t62 - t48));
    s14 = (a27 - a37);
    s24 = (a27 + a37);
    t7c = (t14 + t99);
    t8c = (t24 + t0a);
    t9c = (t14 - t99);
    t0d = (t24 - t0a);
    t1d = (t55 + t3b);
    t2d = (t65 + t4b);
    a47 = (0.70710678118654757f*(t55 - t3b));
    a57 = (0.70710678118654757f*(t65 - t4b));
    s34 = (a47 + a57);
    s44 = (a47 - a57);
    t3d = (t1c + t7c);
    t4d = (t2c + t8c);
    t5d = (t1c - t7c);
    t6d = (t2c - t8c);
    t7d = (t5c + t1d);
    t8d = (t6c + t2d);
    t9d = (t5c - t1d);
    t0e = (t6c - t2d);
    *(dst) = (t3d + t7d);
    *((dst + 1)) = (t4d + t8d);
    *((dst + 32)) = (t3d - t7d);
    *((dst + 33)) = (t4d - t8d);
    *((dst + 16)) = (t5d - t0e);
    *((dst + 17)) = (t6d + t9d);
    *((dst + 48)) = (t5d + t0e);
    *((dst + 49)) = (t6d - t9d);
    t1e = (t3c - t0d);
    t2e = (t4c + t9c);
    t3e = (t3c + t0d);
    t4e = (t4c - t9c);
    t5e = (s14 - s34);
    t6e = (s24 + s44);
    t7e = (s14 + s34);
    t8e = (s24 - s44);
    *((dst + 8)) = (t1e + t5e);
    *((dst + 9)) = (t2e + t6e);
    *((dst + 40)) = (t1e - t5e);
    *((dst + 41)) = (t2e - t6e);
    *((dst + 24)) = (t3e - t8e);
    *((dst + 25)) = (t4e + t7e);
    *((dst + 56)) = (t3e + t8e);
    *((dst + 57)) = (t4e - t7e);
    t9e = (t31 + s91);
    t0f = (t41 + s02);
    t1f = (t31 - s91);
    t2f = (t41 - s02);
    t3f = (s3 + s52);
    t4f = (s4 + s62);
    a67 = (0.70710678118654757f*(s3 - s52));
    a77 = (0.70710678118654757f*(s4 - s62));
    s54 = (a67 - a77);
    s64 = (a67 + a77);
    t5f = (s9 + s13);
    t6f = (s01 + s23);
    t7f = (s9 - s13);
    t8f = (s01 - s23);
    t9f = (s51 + s73);
    t0g = (s61 + s83);
    a87 = (0.70710678118654757f*(s51 - s73));
    a97 = (0.70710678118654757f*(s61 - s83));
    s74 = (a87 + a97);
    s84 = (a87 - a97);
    t1g = (t9e + t5f);
    t2g = (t0f + t6f);
    t3g = (t9e - t5f);
    t4g = (t0f - t6f);
    t5g = (t3f + t9f);
    t6g = (t4f + t0g);
    t7g = (t3f - t9f);
    t8g = (t4f - t0g);
    *((dst + 2)) = (t1g + t5g);
    *((dst + 3)) = (t2g + t6g);
    *((dst + 34)) = (t1g - t5g);
    *((dst + 35)) = (t2g - t6g);
    *((dst + 18)) = (t3g - t8g);
    *((dst + 19)) = (t4g + t7g);
    *((dst + 50)) = (t3g + t8g);
    *((dst + 51)) = (t4g - t7g);
    t9g = (t1f - t8f);
    t0h = (t2f + t7f);
    t1h = (t1f + t8f);
    t2h = (t2f - t7f);
    t3h = (s54 - s74);
    t4h = (s64 + s84);
    t5h = (s54 + s74);
    t6h = (s64 - s84);
    *((dst + 10)) = (t9g + t3h);
    *((dst + 11)) = (t0h + t4h);
    *((dst + 42)) = (t9g - t3h);
    *((dst + 43)) = (t0h - t4h);
    *((dst + 26)) = (t1h - t6h);
    *((dst + 27)) = (t2h + t5h);
    *((dst + 58)) = (t1h + t6h);
    *((dst + 59)) = (t2h - t5h);
    t7h = (t11 - t47);
    t8h = (t21 + t37);
    t9h = (t11 + t47);
    t0i = (t21 - t37);
    t1i = (s - s32);
    t2i = (s2 + s42);
    a08 = (0.70710678118654757f*(s + s32));
    a18 = (0.70710678118654757f*(s2 - s42));
    s94 = (a08 - a18);
    s05 = (a08 + a18);
    t3i = (s7 - s92);
    t4i = (s8 + s03);
    t5i = (s7 + s92);
    t6i = (s8 - s03);
    t7i = (s31 - s53);
    t8i = (s41 + s63);
    a28 = (0.70710678118654757f*(s31 + s53));
    a38 = (0.70710678118654757f*(s41 - s63));
    s15 = (a28 + a38);
    s25 = (a28 - a38);
    t9i = (t7h + t3i);
    t0j = (t8h + t4i);
    t1j = (t7h - t3i);
    t2j = (t8h - t4i);
    t3j = (t1i + t7i);
    t4j = (t2i + t8i);
    t5j = (t1i - t7i);
    t6j = (t2i - t8i);
    *((dst + 4)) = (t9i + t3j);
    *((dst + 5)) = (t0j + t4j);
    *((dst + 36)) = (t9i - t3j);
    *((dst + 37)) = (t0j - t4j);
    *((dst + 20)) = (t1j - t6j);
    *((dst + 21)) = (t2j + t5j);
    *((dst + 52)) = (t1j + t6j);
    *((dst + 53)) = (t2j - t5j);
    t7j = (t9h - t6i);
    t8j = (t0i + t5i);
    t9j = (t9h + t6i);
    t0k = (t0i - t5i);
    t1k = (s94 - s15);
    t2k = (s05 + s25);
    t3k = (s94 + s15);
    t4k = (s05 - s25);
    *((dst + 12)) = (t7j + t1k);
    *((dst + 13)) = (t8j + t2k);
    *((dst + 44)) = (t7j - t1k);
    *((dst + 45)) = (t8j - t2k);
    *((dst + 28)) = (t9j - t4k);
    *((dst + 29)) = (t0k + t3k);
    *((dst + 60)) = (t9j + t4k);
    *((dst + 61)) = (t0k - t3k);
    t5k = (t51 - s12);
    t6k = (t61 + s22);
    t7k = (t51 + s12);
    t8k = (t61 - s22);
    t9k = (s5 - s72);
    t0l = (s6 + s82);
    a48 = (0.70710678118654757f*(s5 + s72));
    a58 = (0.70710678118654757f*(s6 - s82));
    s35 = (a48 - a58);
    s45 = (a48 + a58);
    t1l = (s11 + s33);
    t2l = (s21 - s43);
    t3l = (s11 - s33);
    t4l = (s21 + s43);
    t5l = (s93 - s71);
    t6l = (s81 - s04);
    a68 = (0.70710678118654757f*(s71 + s93));
    a78 = (0.70710678118654757f*(s81 + s04));
    s55 = (a68 - a78);
    s65 = (a68 + a78);
    t7l = (t5k + t1l);
    t8l = (t6k + t2l);
    t9l = (t5k - t1l);
    t0m = (t6k - t2l);
    t1m = (t9k + t5l);
    t2m = (t0l + t6l);
    t3m = (t9k - t5l);
    t4m = (t0l - t6l);
    *((dst + 6)) = (t7l + t1m);
    *((dst + 7)) = (t8l + t2m);
    *((dst + 38)) = (t7l - t1m);
    *((dst + 39)) = (t8l - t2m);
    *((dst + 22)) = (t9l - t4m);
    *((dst + 23)) = (t0m + t3m);
    *((dst + 54)) = (t9l + t4m);
    *((dst + 55)) = (t0m - t3m);
    t5m = (t7k - t4l);
    t6m = (t8k + t3l);
    t7m = (t7k + t4l);
    t8m = (t8k - t3l);
    t9m = (s35 + s55);
    t0n = (s45 - s65);
    t1n = (s35 - s55);
    t2n = (s45 + s65);
    *((dst + 14)) = (t5m + t9m);
    *((dst + 15)) = (t6m + t0n);
    *((dst + 46)) = (t5m - t9m);
    *((dst + 47)) = (t6m - t0n);
    *((dst + 30)) = (t7m - t2n);
    *((dst + 31)) = (t8m + t1n);
    *((dst + 62)) = (t7m + t2n);
    *((dst + 63)) = (t8m - t1n);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_float_64)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[128];
    float  *a03, *a04, *a05, *a06, *a13, *a14, *a15, *a22, *a23, *a24, *a25, *a32, *a33, *a34, *a35, *a42, *a43, *a44, *a45, *a52, *a53, *a54
            , *a55, *a62, *a63, *a64, *a65, *a72, *a73, *a74, *a75, *a82, *a83, *a92;
    const float  *a, *a11, *a2, *a21, *a3, *a31, *a4, *a41, *a5, *a51, *a6, *a61, *a7, *a71, *a8, *a81;
    int a12, a93;
    float a01, a02, a84, a85, a9, a91, a94, a95, s, s2, s3, s4, s5, s6, s7, s8, t, t01, t02, t03, t04, t05
            , t06, t07, t11, t12, t13, t14, t15, t16, t17, t2, t21, t22, t23, t24, t25, t26, t27, t3, t31, t32, t33, t34
            , t35, t36, t4, t41, t42, t43, t44, t45, t46, t5, t51, t52, t53, t54, t55, t56, t6, t61, t62, t63, t64, t65
            , t66, t7, t71, t72, t73, t74, t75, t76, t8, t81, t82, t83, t84, t85, t86, t9, t91, t92, t93, t94, t95, t96;
    {long i; for(i = 0; i <= 7; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 64);
        a4 = (a + 65);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 16);
        a6 = (a + 17);
        a7 = (a + 80);
        a8 = (a + 81);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        a9 = (0.70710678118654757f*(*(a5) - *(a7)));
        a01 = (0.70710678118654757f*(*(a6) - *(a8)));
        s = (a9 - a01);
        s2 = (a9 + a01);
        a11 = (a + 32);
        a21 = (a + 33);
        a31 = (a + 96);
        a41 = (a + 97);
        t7 = (*(a11) + *(a31));
        t8 = (*(a21) + *(a41));
        t9 = (*(a11) - *(a31));
        t01 = (*(a21) - *(a41));
        a51 = (a + 48);
        a61 = (a + 49);
        a71 = (a + 112);
        a81 = (a + 113);
        t11 = (*(a51) + *(a71));
        t21 = (*(a61) + *(a81));
        a91 = (0.70710678118654757f*(*(a51) - *(a71)));
        a02 = (0.70710678118654757f*(*(a61) - *(a81)));
        s3 = (a91 + a02);
        s4 = (a91 - a02);
        t31 = (t + t7);
        t41 = (t2 + t8);
        t51 = (t - t7);
        t61 = (t2 - t8);
        t71 = (t5 + t11);
        t81 = (t6 + t21);
        t91 = (t5 - t11);
        t02 = (t6 - t21);
        t12 = (t31 + t71);
        t22 = (t41 + t81);
        t32 = (t31 - t71);
        t42 = (t41 - t81);
        a12 = (16*i);
        a22 = (D267 + a12);
        a32 = (a22 + 1);
        a42 = (a22 + 2);
        a52 = (a22 + 3);
        a62 = (T + a12);
        *(a62) = ((*(a22)*t12) - (*(a32)*t22));
        *((a62 + 1)) = ((*(a32)*t12) + (*(a22)*t22));
        *((a62 + 8)) = ((*(a42)*t32) - (*(a52)*t42));
        *((a62 + 9)) = ((*(a52)*t32) + (*(a42)*t42));
        t52 = (t51 - t02);
        t62 = (t61 + t91);
        t72 = (t51 + t02);
        t82 = (t61 - t91);
        a72 = (a22 + 4);
        a82 = (a22 + 5);
        a92 = (a22 + 6);
        a03 = (a22 + 7);
        *((a62 + 4)) = ((*(a72)*t52) - (*(a82)*t62));
        *((a62 + 5)) = ((*(a82)*t52) + (*(a72)*t62));
        *((a62 + 12)) = ((*(a92)*t72) - (*(a03)*t82));
        *((a62 + 13)) = ((*(a03)*t72) + (*(a92)*t82));
        t92 = (t3 - t01);
        t03 = (t4 + t9);
        t13 = (t3 + t01);
        t23 = (t4 - t9);
        t33 = (s - s3);
        t43 = (s2 + s4);
        t53 = (s + s3);
        t63 = (s2 - s4);
        t73 = (t92 + t33);
        t83 = (t03 + t43);
        t93 = (t92 - t33);
        t04 = (t03 - t43);
        a13 = (a22 + 8);
        a23 = (a22 + 9);
        a33 = (a22 + 10);
        a43 = (a22 + 11);
        *((a62 + 2)) = ((*(a13)*t73) - (*(a23)*t83));
        *((a62 + 3)) = ((*(a23)*t73) + (*(a13)*t83));
        *((a62 + 10)) = ((*(a33)*t93) - (*(a43)*t04));
        *((a62 + 11)) = ((*(a43)*t93) + (*(a33)*t04));
        t14 = (t13 - t63);
        t24 = (t23 + t53);
        t34 = (t13 + t63);
        t44 = (t23 - t53);
        a53 = (a22 + 12);
        a63 = (a22 + 13);
        a73 = (a22 + 14);
        a83 = (a22 + 15);
        *((a62 + 6)) = ((*(a53)*t14) - (*(a63)*t24));
        *((a62 + 7)) = ((*(a63)*t14) + (*(a53)*t24));
        *((a62 + 14)) = ((*(a73)*t34) - (*(a83)*t44));
        *((a62 + 15)) = ((*(a83)*t34) + (*(a73)*t44));
    }}
    {long i2; for(i2 = 0; i2 <= 7; i2++) {
        a93 = (2*i2);
        a04 = (T + a93);
        a14 = (a04 + 1);
        a24 = (a04 + 64);
        a34 = (a04 + 65);
        t54 = (*(a04) + *(a24));
        t64 = (*(a14) + *(a34));
        t74 = (*(a04) - *(a24));
        t84 = (*(a14) - *(a34));
        a44 = (a04 + 16);
        a54 = (a04 + 17);
        a64 = (a04 + 80);
        a74 = (a04 + 81);
        t94 = (*(a44) + *(a64));
        t05 = (*(a54) + *(a74));
        a84 = (0.70710678118654757f*(*(a44) - *(a64)));
        a94 = (0.70710678118654757f*(*(a54) - *(a74)));
        s5 = (a84 - a94);
        s6 = (a84 + a94);
        a05 = (a04 + 32);
        a15 = (a04 + 33);
        a25 = (a04 + 96);
        a35 = (a04 + 97);
        t15 = (*(a05) + *(a25));
        t25 = (*(a15) + *(a35));
        t35 = (*(a05) - *(a25));
        t45 = (*(a15) - *(a35));
        a45 = (a04 + 48);
        a55 = (a04 + 49);
        a65 = (a04 + 112);
        a75 = (a04 + 113);
        t55 = (*(a45) + *(a65));
        t65 = (*(a55) + *(a75));
        a85 = (0.70710678118654757f*(*(a45) - *(a65)));
        a95 = (0.70710678118654757f*(*(a55) - *(a75)));
        s7 = (a85 + a95);
        s8 = (a85 - a95);
        t75 = (t54 + t15);
        t85 = (t64 + t25);
        t95 = (t54 - t15);
        t06 = (t64 - t25);
        t16 = (t94 + t55);
        t26 = (t05 + t65);
        t36 = (t94 - t55);
        t46 = (t05 - t65);
        a06 = (dst + a93);
        *(a06) = (t75 + t16);
        *((a06 + 1)) = (t85 + t26);
        *((a06 + 64)) = (t75 - t16);
        *((a06 + 65)) = (t85 - t26);
        *((a06 + 32)) = (t95 - t46);
        *((a06 + 33)) = (t06 + t36);
        *((a06 + 96)) = (t95 + t46);
        *((a06 + 97)) = (t06 - t36);
        t56 = (t74 - t45);
        t66 = (t84 + t35);
        t76 = (t74 + t45);
        t86 = (t84 - t35);
        t96 = (s5 - s7);
        t07 = (s6 + s8);
        t17 = (s5 + s7);
        t27 = (s6 - s8);
        *((a06 + 16)) = (t56 + t96);
        *((a06 + 17)) = (t66 + t07);
        *((a06 + 80)) = (t56 - t96);
        *((a06 + 81)) = (t66 - t07);
        *((a06 + 48)) = (t76 - t27);
        *((a06 + 49)) = (t86 + t17);
        *((a06 + 112)) = (t76 + t27);
        *((a06 + 113)) = (t86 - t17);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_float_128)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[256];
    float  *a05, *a06, *a07, *a08, *a09, *a15, *a16, *a17, *a18, *a19, *a24, *a25, *a26, *a27, *a28, *a29, *a34, *a35, *a36, *a37, *a38, *a39
            , *a44, *a45, *a46, *a47, *a54, *a55, *a56, *a64, *a65, *a66, *a67, *a68, *a69, *a74, *a75, *a76, *a77, *a78, *a84, *a85, *a86, *a87
            , *a88, *a94, *a95, *a96, *a97, *a98;
    const float  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a57;
    float a03, a04, a48, a49, a58, a59, a71, a72, a81, a82, a92, a93, s, s01, s02, s11, s2, s21, s3, s31, s4, s41
            , s5, s51, s6, s61, s7, s71, s8, s81, s9, s91, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b
            , t0c, t0d, t0e, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t2, t21, t22, t23, t24
            , t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b
            , t3c, t3d, t3e, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t5, t51, t52, t53
            , t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a
            , t6b, t6c, t6d, t6e, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t8, t81, t82
            , t83, t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99
            , t9a, t9b, t9c, t9d;
    {long i; for(i = 0; i <= 7; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 128);
        a4 = (a + 129);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 64);
        a6 = (a + 65);
        a7 = (a + 192);
        a8 = (a + 193);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 - t8);
        t41 = (t4 + t7);
        t51 = (t3 + t8);
        t61 = (t4 - t7);
        a9 = (a + 16);
        a01 = (a + 17);
        a11 = (a + 144);
        a21 = (a + 145);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 80);
        a41 = (a + 81);
        a51 = (a + 208);
        a61 = (a + 209);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        a71 = (0.70710678118654757f*(t71 - t12));
        a81 = (0.70710678118654757f*(t81 - t22));
        s = (a71 - a81);
        s2 = (a71 + a81);
        t72 = (t91 - t42);
        t82 = (t02 + t32);
        t92 = (t91 + t42);
        t03 = (t02 - t32);
        s3 = ((0.92387953251128674f*t72) - (0.38268343236508978f*t82));
        s4 = ((0.38268343236508978f*t72) + (0.92387953251128674f*t82));
        s5 = ((0.38268343236508978f*t92) - (0.92387953251128674f*t03));
        s6 = ((0.92387953251128674f*t92) + (0.38268343236508978f*t03));
        a91 = (a + 32);
        a02 = (a + 33);
        a12 = (a + 160);
        a22 = (a + 161);
        t13 = (*(a91) + *(a12));
        t23 = (*(a02) + *(a22));
        t33 = (*(a91) - *(a12));
        t43 = (*(a02) - *(a22));
        a32 = (a + 96);
        a42 = (a + 97);
        a52 = (a + 224);
        a62 = (a + 225);
        t53 = (*(a32) + *(a52));
        t63 = (*(a42) + *(a62));
        t73 = (*(a32) - *(a52));
        t83 = (*(a42) - *(a62));
        t93 = (t13 + t53);
        t04 = (t23 + t63);
        t14 = (t13 - t53);
        t24 = (t23 - t63);
        a72 = (0.70710678118654757f*(t33 - t83));
        a82 = (0.70710678118654757f*(t43 + t73));
        s7 = (a72 - a82);
        s8 = (a72 + a82);
        a92 = (0.70710678118654757f*(t33 + t83));
        a03 = (0.70710678118654757f*(t43 - t73));
        s9 = (a92 + a03);
        s01 = (a92 - a03);
        a13 = (a + 48);
        a23 = (a + 49);
        a33 = (a + 176);
        a43 = (a + 177);
        t34 = (*(a13) + *(a33));
        t44 = (*(a23) + *(a43));
        t54 = (*(a13) - *(a33));
        t64 = (*(a23) - *(a43));
        a53 = (a + 112);
        a63 = (a + 113);
        a73 = (a + 240);
        a83 = (a + 241);
        t74 = (*(a53) + *(a73));
        t84 = (*(a63) + *(a83));
        t94 = (*(a53) - *(a73));
        t05 = (*(a63) - *(a83));
        t15 = (t34 + t74);
        t25 = (t44 + t84);
        a93 = (0.70710678118654757f*(t34 - t74));
        a04 = (0.70710678118654757f*(t44 - t84));
        s11 = (a93 + a04);
        s21 = (a93 - a04);
        t35 = (t54 - t05);
        t45 = (t64 + t94);
        t55 = (t54 + t05);
        t65 = (t64 - t94);
        s31 = ((0.38268343236508978f*t35) - (0.92387953251128674f*t45));
        s41 = ((0.92387953251128674f*t35) + (0.38268343236508978f*t45));
        s51 = ((0.38268343236508978f*t65) - (0.92387953251128674f*t55));
        s61 = ((0.38268343236508978f*t55) + (0.92387953251128674f*t65));
        t75 = (t9 + t93);
        t85 = (t01 + t04);
        t95 = (t9 - t93);
        t06 = (t01 - t04);
        t16 = (t52 + t15);
        t26 = (t62 + t25);
        t36 = (t52 - t15);
        t46 = (t62 - t25);
        t56 = (t75 + t16);
        t66 = (t85 + t26);
        t76 = (t75 - t16);
        t86 = (t85 - t26);
        a14 = (32*i);
        a24 = (D268 + a14);
        a34 = (a24 + 1);
        a44 = (a24 + 2);
        a54 = (a24 + 3);
        a64 = (T + a14);
        *(a64) = ((*(a24)*t56) - (*(a34)*t66));
        *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
        *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
        *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
        t96 = (t95 - t46);
        t07 = (t06 + t36);
        t17 = (t95 + t46);
        t27 = (t06 - t36);
        a74 = (a24 + 4);
        a84 = (a24 + 5);
        a94 = (a24 + 6);
        a05 = (a24 + 7);
        *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
        *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
        *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
        *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
        t37 = (t31 + s7);
        t47 = (t41 + s8);
        t57 = (t31 - s7);
        t67 = (t41 - s8);
        t77 = (s3 + s31);
        t87 = (s4 + s41);
        t97 = (s3 - s31);
        t08 = (s4 - s41);
        t18 = (t37 + t77);
        t28 = (t47 + t87);
        t38 = (t37 - t77);
        t48 = (t47 - t87);
        a15 = (a24 + 8);
        a25 = (a24 + 9);
        a35 = (a24 + 10);
        a45 = (a24 + 11);
        *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
        *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
        *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
        *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
        t58 = (t57 - t08);
        t68 = (t67 + t97);
        t78 = (t57 + t08);
        t88 = (t67 - t97);
        a55 = (a24 + 12);
        a65 = (a24 + 13);
        a75 = (a24 + 14);
        a85 = (a24 + 15);
        *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
        *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
        *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
        *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
        t98 = (t11 - t24);
        t09 = (t21 + t14);
        t19 = (t11 + t24);
        t29 = (t21 - t14);
        t39 = (s - s11);
        t49 = (s2 + s21);
        t59 = (s + s11);
        t69 = (s2 - s21);
        t79 = (t98 + t39);
        t89 = (t09 + t49);
        t99 = (t98 - t39);
        t0a = (t09 - t49);
        a95 = (a24 + 16);
        a06 = (a24 + 17);
        a16 = (a24 + 18);
        a26 = (a24 + 19);
        *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
        *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
        *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
        *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
        t1a = (t19 - t69);
        t2a = (t29 + t59);
        t3a = (t19 + t69);
        t4a = (t29 - t59);
        a36 = (a24 + 20);
        a46 = (a24 + 21);
        a56 = (a24 + 22);
        a66 = (a24 + 23);
        *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
        *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
        *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
        *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
        t5a = (t51 - s9);
        t6a = (t61 + s01);
        t7a = (t51 + s9);
        t8a = (t61 - s01);
        t9a = (s5 + s51);
        t0b = (s6 - s61);
        t1b = (s5 - s51);
        t2b = (s6 + s61);
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        a76 = (a24 + 24);
        a86 = (a24 + 25);
        a96 = (a24 + 26);
        a07 = (a24 + 27);
        *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
        *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
        *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
        *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
        t7b = (t7a - t2b);
        t8b = (t8a + t1b);
        t9b = (t7a + t2b);
        t0c = (t8a - t1b);
        a17 = (a24 + 28);
        a27 = (a24 + 29);
        a37 = (a24 + 30);
        a47 = (a24 + 31);
        *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
        *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
        *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
        *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        a57 = (2*i2);
        a67 = (T + a57);
        a77 = (a67 + 1);
        a87 = (a67 + 128);
        a97 = (a67 + 129);
        t1c = (*(a67) + *(a87));
        t2c = (*(a77) + *(a97));
        t3c = (*(a67) - *(a87));
        t4c = (*(a77) - *(a97));
        a08 = (a67 + 32);
        a18 = (a67 + 33);
        a28 = (a67 + 160);
        a38 = (a67 + 161);
        t5c = (*(a08) + *(a28));
        t6c = (*(a18) + *(a38));
        a48 = (0.70710678118654757f*(*(a08) - *(a28)));
        a58 = (0.70710678118654757f*(*(a18) - *(a38)));
        s71 = (a48 - a58);
        s81 = (a48 + a58);
        a68 = (a67 + 64);
        a78 = (a67 + 65);
        a88 = (a67 + 192);
        a98 = (a67 + 193);
        t7c = (*(a68) + *(a88));
        t8c = (*(a78) + *(a98));
        t9c = (*(a68) - *(a88));
        t0d = (*(a78) - *(a98));
        a09 = (a67 + 96);
        a19 = (a67 + 97);
        a29 = (a67 + 224);
        a39 = (a67 + 225);
        t1d = (*(a09) + *(a29));
        t2d = (*(a19) + *(a39));
        a49 = (0.70710678118654757f*(*(a09) - *(a29)));
        a59 = (0.70710678118654757f*(*(a19) - *(a39)));
        s91 = (a49 + a59);
        s02 = (a49 - a59);
        t3d = (t1c + t7c);
        t4d = (t2c + t8c);
        t5d = (t1c - t7c);
        t6d = (t2c - t8c);
        t7d = (t5c + t1d);
        t8d = (t6c + t2d);
        t9d = (t5c - t1d);
        t0e = (t6c - t2d);
        a69 = (dst + a57);
        *(a69) = (t3d + t7d);
        *((a69 + 1)) = (t4d + t8d);
        *((a69 + 128)) = (t3d - t7d);
        *((a69 + 129)) = (t4d - t8d);
        *((a69 + 64)) = (t5d - t0e);
        *((a69 + 65)) = (t6d + t9d);
        *((a69 + 192)) = (t5d + t0e);
        *((a69 + 193)) = (t6d - t9d);
        t1e = (t3c - t0d);
        t2e = (t4c + t9c);
        t3e = (t3c + t0d);
        t4e = (t4c - t9c);
        t5e = (s71 - s91);
        t6e = (s81 + s02);
        t7e = (s71 + s91);
        t8e = (s81 - s02);
        *((a69 + 32)) = (t1e + t5e);
        *((a69 + 33)) = (t2e + t6e);
        *((a69 + 160)) = (t1e - t5e);
        *((a69 + 161)) = (t2e - t6e);
        *((a69 + 96)) = (t3e - t8e);
        *((a69 + 97)) = (t4e + t7e);
        *((a69 + 224)) = (t3e + t8e);
        *((a69 + 225)) = (t4e - t7e);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_float_256)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[512];
    float  *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a15, *a16, *a17, *a18, *a19, *a1a, *a1b, *a24, *a25, *a26, *a27, *a28, *a2b, *a34, *a35
            , *a36, *a37, *a38, *a3b, *a44, *a45, *a46, *a47, *a48, *a49, *a54, *a55, *a56, *a58, *a59, *a64, *a65, *a66, *a67, *a68, *a69, *a6a
            , *a6b, *a74, *a75, *a76, *a77, *a78, *a79, *a7a, *a84, *a85, *a86, *a87, *a88, *a89, *a8a, *a94, *a95, *a96, *a97, *a98, *a99, *a9a;
    const float  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a57;
    float a03, a04, a29, a2a, a39, a3a, a4a, a4b, a5a, a5b, a71, a72, a81, a82, a92, a93, s, s01, s02, s03, s11, s12
            , s13, s2, s21, s22, s23, s3, s31, s32, s4, s41, s42, s5, s51, s52, s6, s61, s62, s7, s71, s72, s8, s81
            , s82, s9, s91, s92, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h
            , t0i, t0j, t0k, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j
            , t1k, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k
            , t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t4
            , t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t5, t51
            , t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t6, t61, t62
            , t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t7, t71, t72, t73
            , t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t8, t81, t82, t83, t84
            , t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t9, t91, t92, t93, t94, t95
            , t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j;
    {long i; for(i = 0; i <= 15; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 256);
        a4 = (a + 257);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 128);
        a6 = (a + 129);
        a7 = (a + 384);
        a8 = (a + 385);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 - t8);
        t41 = (t4 + t7);
        t51 = (t3 + t8);
        t61 = (t4 - t7);
        a9 = (a + 32);
        a01 = (a + 33);
        a11 = (a + 288);
        a21 = (a + 289);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 160);
        a41 = (a + 161);
        a51 = (a + 416);
        a61 = (a + 417);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        a71 = (0.70710678118654757f*(t71 - t12));
        a81 = (0.70710678118654757f*(t81 - t22));
        s = (a71 - a81);
        s2 = (a71 + a81);
        t72 = (t91 - t42);
        t82 = (t02 + t32);
        t92 = (t91 + t42);
        t03 = (t02 - t32);
        s3 = ((0.92387953251128674f*t72) - (0.38268343236508978f*t82));
        s4 = ((0.38268343236508978f*t72) + (0.92387953251128674f*t82));
        s5 = ((0.38268343236508978f*t92) - (0.92387953251128674f*t03));
        s6 = ((0.92387953251128674f*t92) + (0.38268343236508978f*t03));
        a91 = (a + 64);
        a02 = (a + 65);
        a12 = (a + 320);
        a22 = (a + 321);
        t13 = (*(a91) + *(a12));
        t23 = (*(a02) + *(a22));
        t33 = (*(a91) - *(a12));
        t43 = (*(a02) - *(a22));
        a32 = (a + 192);
        a42 = (a + 193);
        a52 = (a + 448);
        a62 = (a + 449);
        t53 = (*(a32) + *(a52));
        t63 = (*(a42) + *(a62));
        t73 = (*(a32) - *(a52));
        t83 = (*(a42) - *(a62));
        t93 = (t13 + t53);
        t04 = (t23 + t63);
        t14 = (t13 - t53);
        t24 = (t23 - t63);
        a72 = (0.70710678118654757f*(t33 - t83));
        a82 = (0.70710678118654757f*(t43 + t73));
        s7 = (a72 - a82);
        s8 = (a72 + a82);
        a92 = (0.70710678118654757f*(t33 + t83));
        a03 = (0.70710678118654757f*(t43 - t73));
        s9 = (a92 + a03);
        s01 = (a92 - a03);
        a13 = (a + 96);
        a23 = (a + 97);
        a33 = (a + 352);
        a43 = (a + 353);
        t34 = (*(a13) + *(a33));
        t44 = (*(a23) + *(a43));
        t54 = (*(a13) - *(a33));
        t64 = (*(a23) - *(a43));
        a53 = (a + 224);
        a63 = (a + 225);
        a73 = (a + 480);
        a83 = (a + 481);
        t74 = (*(a53) + *(a73));
        t84 = (*(a63) + *(a83));
        t94 = (*(a53) - *(a73));
        t05 = (*(a63) - *(a83));
        t15 = (t34 + t74);
        t25 = (t44 + t84);
        a93 = (0.70710678118654757f*(t34 - t74));
        a04 = (0.70710678118654757f*(t44 - t84));
        s11 = (a93 + a04);
        s21 = (a93 - a04);
        t35 = (t54 - t05);
        t45 = (t64 + t94);
        t55 = (t54 + t05);
        t65 = (t64 - t94);
        s31 = ((0.38268343236508978f*t35) - (0.92387953251128674f*t45));
        s41 = ((0.92387953251128674f*t35) + (0.38268343236508978f*t45));
        s51 = ((0.38268343236508978f*t65) - (0.92387953251128674f*t55));
        s61 = ((0.38268343236508978f*t55) + (0.92387953251128674f*t65));
        t75 = (t9 + t93);
        t85 = (t01 + t04);
        t95 = (t9 - t93);
        t06 = (t01 - t04);
        t16 = (t52 + t15);
        t26 = (t62 + t25);
        t36 = (t52 - t15);
        t46 = (t62 - t25);
        t56 = (t75 + t16);
        t66 = (t85 + t26);
        t76 = (t75 - t16);
        t86 = (t85 - t26);
        a14 = (32*i);
        a24 = (D269 + a14);
        a34 = (a24 + 1);
        a44 = (a24 + 2);
        a54 = (a24 + 3);
        a64 = (T + a14);
        *(a64) = ((*(a24)*t56) - (*(a34)*t66));
        *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
        *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
        *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
        t96 = (t95 - t46);
        t07 = (t06 + t36);
        t17 = (t95 + t46);
        t27 = (t06 - t36);
        a74 = (a24 + 4);
        a84 = (a24 + 5);
        a94 = (a24 + 6);
        a05 = (a24 + 7);
        *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
        *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
        *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
        *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
        t37 = (t31 + s7);
        t47 = (t41 + s8);
        t57 = (t31 - s7);
        t67 = (t41 - s8);
        t77 = (s3 + s31);
        t87 = (s4 + s41);
        t97 = (s3 - s31);
        t08 = (s4 - s41);
        t18 = (t37 + t77);
        t28 = (t47 + t87);
        t38 = (t37 - t77);
        t48 = (t47 - t87);
        a15 = (a24 + 8);
        a25 = (a24 + 9);
        a35 = (a24 + 10);
        a45 = (a24 + 11);
        *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
        *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
        *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
        *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
        t58 = (t57 - t08);
        t68 = (t67 + t97);
        t78 = (t57 + t08);
        t88 = (t67 - t97);
        a55 = (a24 + 12);
        a65 = (a24 + 13);
        a75 = (a24 + 14);
        a85 = (a24 + 15);
        *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
        *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
        *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
        *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
        t98 = (t11 - t24);
        t09 = (t21 + t14);
        t19 = (t11 + t24);
        t29 = (t21 - t14);
        t39 = (s - s11);
        t49 = (s2 + s21);
        t59 = (s + s11);
        t69 = (s2 - s21);
        t79 = (t98 + t39);
        t89 = (t09 + t49);
        t99 = (t98 - t39);
        t0a = (t09 - t49);
        a95 = (a24 + 16);
        a06 = (a24 + 17);
        a16 = (a24 + 18);
        a26 = (a24 + 19);
        *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
        *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
        *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
        *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
        t1a = (t19 - t69);
        t2a = (t29 + t59);
        t3a = (t19 + t69);
        t4a = (t29 - t59);
        a36 = (a24 + 20);
        a46 = (a24 + 21);
        a56 = (a24 + 22);
        a66 = (a24 + 23);
        *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
        *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
        *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
        *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
        t5a = (t51 - s9);
        t6a = (t61 + s01);
        t7a = (t51 + s9);
        t8a = (t61 - s01);
        t9a = (s5 + s51);
        t0b = (s6 - s61);
        t1b = (s5 - s51);
        t2b = (s6 + s61);
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        a76 = (a24 + 24);
        a86 = (a24 + 25);
        a96 = (a24 + 26);
        a07 = (a24 + 27);
        *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
        *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
        *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
        *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
        t7b = (t7a - t2b);
        t8b = (t8a + t1b);
        t9b = (t7a + t2b);
        t0c = (t8a - t1b);
        a17 = (a24 + 28);
        a27 = (a24 + 29);
        a37 = (a24 + 30);
        a47 = (a24 + 31);
        *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
        *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
        *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
        *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        a57 = (2*i2);
        a67 = (T + a57);
        a77 = (a67 + 1);
        a87 = (a67 + 256);
        a97 = (a67 + 257);
        t1c = (*(a67) + *(a87));
        t2c = (*(a77) + *(a97));
        t3c = (*(a67) - *(a87));
        t4c = (*(a77) - *(a97));
        a08 = (a67 + 128);
        a18 = (a67 + 129);
        a28 = (a67 + 384);
        a38 = (a67 + 385);
        t5c = (*(a08) + *(a28));
        t6c = (*(a18) + *(a38));
        t7c = (*(a08) - *(a28));
        t8c = (*(a18) - *(a38));
        t9c = (t1c + t5c);
        t0d = (t2c + t6c);
        t1d = (t1c - t5c);
        t2d = (t2c - t6c);
        t3d = (t3c - t8c);
        t4d = (t4c + t7c);
        t5d = (t3c + t8c);
        t6d = (t4c - t7c);
        a48 = (a67 + 32);
        a58 = (a67 + 33);
        a68 = (a67 + 288);
        a78 = (a67 + 289);
        t7d = (*(a48) + *(a68));
        t8d = (*(a58) + *(a78));
        t9d = (*(a48) - *(a68));
        t0e = (*(a58) - *(a78));
        a88 = (a67 + 160);
        a98 = (a67 + 161);
        a09 = (a67 + 416);
        a19 = (a67 + 417);
        t1e = (*(a88) + *(a09));
        t2e = (*(a98) + *(a19));
        t3e = (*(a88) - *(a09));
        t4e = (*(a98) - *(a19));
        t5e = (t7d + t1e);
        t6e = (t8d + t2e);
        a29 = (0.70710678118654757f*(t7d - t1e));
        a39 = (0.70710678118654757f*(t8d - t2e));
        s71 = (a29 - a39);
        s81 = (a29 + a39);
        t7e = (t9d - t4e);
        t8e = (t0e + t3e);
        t9e = (t9d + t4e);
        t0f = (t0e - t3e);
        s91 = ((0.92387953251128674f*t7e) - (0.38268343236508978f*t8e));
        s02 = ((0.38268343236508978f*t7e) + (0.92387953251128674f*t8e));
        s12 = ((0.38268343236508978f*t9e) - (0.92387953251128674f*t0f));
        s22 = ((0.92387953251128674f*t9e) + (0.38268343236508978f*t0f));
        a49 = (a67 + 64);
        a59 = (a67 + 65);
        a69 = (a67 + 320);
        a79 = (a67 + 321);
        t1f = (*(a49) + *(a69));
        t2f = (*(a59) + *(a79));
        t3f = (*(a49) - *(a69));
        t4f = (*(a59) - *(a79));
        a89 = (a67 + 192);
        a99 = (a67 + 193);
        a0a = (a67 + 448);
        a1a = (a67 + 449);
        t5f = (*(a89) + *(a0a));
        t6f = (*(a99) + *(a1a));
        t7f = (*(a89) - *(a0a));
        t8f = (*(a99) - *(a1a));
        t9f = (t1f + t5f);
        t0g = (t2f + t6f);
        t1g = (t1f - t5f);
        t2g = (t2f - t6f);
        a2a = (0.70710678118654757f*(t3f - t8f));
        a3a = (0.70710678118654757f*(t4f + t7f));
        s32 = (a2a - a3a);
        s42 = (a2a + a3a);
        a4a = (0.70710678118654757f*(t3f + t8f));
        a5a = (0.70710678118654757f*(t4f - t7f));
        s52 = (a4a + a5a);
        s62 = (a4a - a5a);
        a6a = (a67 + 96);
        a7a = (a67 + 97);
        a8a = (a67 + 352);
        a9a = (a67 + 353);
        t3g = (*(a6a) + *(a8a));
        t4g = (*(a7a) + *(a9a));
        t5g = (*(a6a) - *(a8a));
        t6g = (*(a7a) - *(a9a));
        a0b = (a67 + 224);
        a1b = (a67 + 225);
        a2b = (a67 + 480);
        a3b = (a67 + 481);
        t7g = (*(a0b) + *(a2b));
        t8g = (*(a1b) + *(a3b));
        t9g = (*(a0b) - *(a2b));
        t0h = (*(a1b) - *(a3b));
        t1h = (t3g + t7g);
        t2h = (t4g + t8g);
        a4b = (0.70710678118654757f*(t3g - t7g));
        a5b = (0.70710678118654757f*(t4g - t8g));
        s72 = (a4b + a5b);
        s82 = (a4b - a5b);
        t3h = (t5g - t0h);
        t4h = (t6g + t9g);
        t5h = (t5g + t0h);
        t6h = (t6g - t9g);
        s92 = ((0.38268343236508978f*t3h) - (0.92387953251128674f*t4h));
        s03 = ((0.92387953251128674f*t3h) + (0.38268343236508978f*t4h));
        s13 = ((0.38268343236508978f*t6h) - (0.92387953251128674f*t5h));
        s23 = ((0.38268343236508978f*t5h) + (0.92387953251128674f*t6h));
        t7h = (t9c + t9f);
        t8h = (t0d + t0g);
        t9h = (t9c - t9f);
        t0i = (t0d - t0g);
        t1i = (t5e + t1h);
        t2i = (t6e + t2h);
        t3i = (t5e - t1h);
        t4i = (t6e - t2h);
        a6b = (dst + a57);
        *(a6b) = (t7h + t1i);
        *((a6b + 1)) = (t8h + t2i);
        *((a6b + 256)) = (t7h - t1i);
        *((a6b + 257)) = (t8h - t2i);
        *((a6b + 128)) = (t9h - t4i);
        *((a6b + 129)) = (t0i + t3i);
        *((a6b + 384)) = (t9h + t4i);
        *((a6b + 385)) = (t0i - t3i);
        t5i = (t3d + s32);
        t6i = (t4d + s42);
        t7i = (t3d - s32);
        t8i = (t4d - s42);
        t9i = (s91 + s92);
        t0j = (s02 + s03);
        t1j = (s91 - s92);
        t2j = (s02 - s03);
        *((a6b + 32)) = (t5i + t9i);
        *((a6b + 33)) = (t6i + t0j);
        *((a6b + 288)) = (t5i - t9i);
        *((a6b + 289)) = (t6i - t0j);
        *((a6b + 160)) = (t7i - t2j);
        *((a6b + 161)) = (t8i + t1j);
        *((a6b + 416)) = (t7i + t2j);
        *((a6b + 417)) = (t8i - t1j);
        t3j = (t1d - t2g);
        t4j = (t2d + t1g);
        t5j = (t1d + t2g);
        t6j = (t2d - t1g);
        t7j = (s71 - s72);
        t8j = (s81 + s82);
        t9j = (s71 + s72);
        t0k = (s81 - s82);
        *((a6b + 64)) = (t3j + t7j);
        *((a6b + 65)) = (t4j + t8j);
        *((a6b + 320)) = (t3j - t7j);
        *((a6b + 321)) = (t4j - t8j);
        *((a6b + 192)) = (t5j - t0k);
        *((a6b + 193)) = (t6j + t9j);
        *((a6b + 448)) = (t5j + t0k);
        *((a6b + 449)) = (t6j - t9j);
        t1k = (t5d - s52);
        t2k = (t6d + s62);
        t3k = (t5d + s52);
        t4k = (t6d - s62);
        t5k = (s12 + s13);
        t6k = (s22 - s23);
        t7k = (s12 - s13);
        t8k = (s22 + s23);
        *((a6b + 96)) = (t1k + t5k);
        *((a6b + 97)) = (t2k + t6k);
        *((a6b + 352)) = (t1k - t5k);
        *((a6b + 353)) = (t2k - t6k);
        *((a6b + 224)) = (t3k - t8k);
        *((a6b + 225)) = (t4k + t7k);
        *((a6b + 480)) = (t3k + t8k);
        *((a6b + 481)) = (t4k - t7k);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_float_512)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[1024];
    float  *a08, *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0g, *a0h, *a0i, *a0j, *a18, *a19, *a1a, *a1b, *a1c, *a1d, *a1e, *a1f, *a1g, *a1h
            , *a1i, *a1j, *a28, *a29, *a2a, *a2b, *a2c, *a2d, *a2e, *a2f, *a2g, *a2j, *a38, *a39, *a3a, *a3b, *a3c, *a3d, *a3e, *a3f, *a3g, *a3j
            , *a48, *a49, *a4a, *a4b, *a4c, *a4d, *a4e, *a4f, *a4g, *a4h, *a58, *a5a, *a5c, *a5e, *a5g, *a5h, *a68, *a6a, *a6c, *a6e, *a6f, *a6g
            , *a6h, *a6i, *a6j, *a78, *a7a, *a7c, *a7e, *a7f, *a7g, *a7h, *a7i, *a87, *a88, *a8a, *a8c, *a8e, *a8f, *a8g, *a8h, *a8i, *a97, *a98
            , *a99, *a9a, *a9b, *a9c, *a9d, *a9e, *a9f, *a9g, *a9h, *a9i;
    const float  *a, *a01, *a02, *a03, *a04, *a05, *a06, *a07, *a11, *a12, *a13, *a14, *a15, *a16, *a17, *a2, *a21, *a22, *a23, *a24, *a25, *a26
            , *a27, *a3, *a31, *a32, *a33, *a35, *a4, *a41, *a42, *a43, *a45, *a5, *a51, *a53, *a55, *a56, *a6, *a61, *a63, *a65, *a66, *a7
            , *a71, *a72, *a73, *a74, *a75, *a76, *a8, *a81, *a82, *a83, *a84, *a85, *a86, *a9, *a91, *a92, *a93, *a94, *a95, *a96;
    int a5f, a77;
    float a2h, a2i, a34, a36, a37, a3h, a3i, a44, a46, a47, a4i, a4j, a52, a54, a57, a59, a5b, a5d, a5i, a5j, a62, a64
            , a67, a69, a6b, a6d, a79, a7b, a7d, a89, a8b, a8d, s, s01, s02, s03, s04, s05, s06, s07, s11, s12, s13, s14
            , s15, s16, s17, s2, s21, s22, s23, s24, s25, s26, s27, s3, s31, s32, s33, s34, s35, s36, s4, s41, s42, s43
            , s44, s45, s46, s5, s51, s52, s53, s54, s55, s56, s6, s61, s62, s63, s64, s65, s66, s7, s71, s72, s73, s74
            , s75, s76, s8, s81, s82, s83, s84, s85, s86, s9, s91, s92, s93, s94, s95, s96, t, t01, t02, t03, t04, t05
            , t06, t07, t08, t09, t0A, t0B, t0C, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o
            , t0p, t0q, t0r, t0s, t0t, t0u, t0v, t0w, t0x, t0y, t0z, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1A, t1B
            , t1C, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t, t1u
            , t1v, t1w, t1x, t1y, t1z, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2A, t2B, t2C, t2a, t2b, t2c, t2d
            , t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p, t2q, t2r, t2s, t2t, t2u, t2v, t2w, t2x, t2y, t2z
            , t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3A, t3B, t3C, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i
            , t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s, t3t, t3u, t3v, t3w, t3x, t3y, t3z, t4, t41, t42, t43, t44
            , t45, t46, t47, t48, t49, t4A, t4B, t4C, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n
            , t4o, t4p, t4q, t4r, t4s, t4t, t4u, t4v, t4w, t4x, t4y, t4z, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59
            , t5A, t5B, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t5r, t5s, t5t
            , t5u, t5v, t5w, t5x, t5y, t5z, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6A, t6B, t6a, t6b, t6c, t6d
            , t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r, t6s, t6t, t6u, t6v, t6w, t6x, t6y, t6z
            , t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7A, t7B, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j
            , t7k, t7l, t7m, t7n, t7o, t7p, t7q, t7r, t7s, t7t, t7u, t7v, t7w, t7x, t7y, t7z, t8, t81, t82, t83, t84, t85
            , t86, t87, t88, t89, t8A, t8B, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p
            , t8q, t8r, t8s, t8t, t8u, t8v, t8w, t8x, t8y, t8z, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9A, t9B
            , t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p, t9q, t9r, t9s, t9t, t9u, t9v
            , t9w, t9x, t9y, t9z;
    {long i; for(i = 0; i <= 15; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 512);
        a4 = (a + 513);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 256);
        a6 = (a + 257);
        a7 = (a + 768);
        a8 = (a + 769);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 - t8);
        t41 = (t4 + t7);
        t51 = (t3 + t8);
        t61 = (t4 - t7);
        a9 = (a + 32);
        a01 = (a + 33);
        a11 = (a + 544);
        a21 = (a + 545);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 288);
        a41 = (a + 289);
        a51 = (a + 800);
        a61 = (a + 801);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        t72 = (t71 - t12);
        t82 = (t81 - t22);
        s = ((0.92387953251128674f*t72) - (0.38268343236508978f*t82));
        s2 = ((0.38268343236508978f*t72) + (0.92387953251128674f*t82));
        t92 = (t91 - t42);
        t03 = (t02 + t32);
        t13 = (t91 + t42);
        t23 = (t02 - t32);
        s3 = ((0.98078528040323043f*t92) - (0.19509032201612828f*t03));
        s4 = ((0.19509032201612828f*t92) + (0.98078528040323043f*t03));
        s5 = ((0.83146961230254524f*t13) - (0.55557023301960218f*t23));
        s6 = ((0.55557023301960218f*t13) + (0.83146961230254524f*t23));
        a71 = (a + 64);
        a81 = (a + 65);
        a91 = (a + 576);
        a02 = (a + 577);
        t33 = (*(a71) + *(a91));
        t43 = (*(a81) + *(a02));
        t53 = (*(a71) - *(a91));
        t63 = (*(a81) - *(a02));
        a12 = (a + 320);
        a22 = (a + 321);
        a32 = (a + 832);
        a42 = (a + 833);
        t73 = (*(a12) + *(a32));
        t83 = (*(a22) + *(a42));
        t93 = (*(a12) - *(a32));
        t04 = (*(a22) - *(a42));
        t14 = (t33 + t73);
        t24 = (t43 + t83);
        a52 = (0.70710678118654757f*(t33 - t73));
        a62 = (0.70710678118654757f*(t43 - t83));
        s7 = (a52 - a62);
        s8 = (a52 + a62);
        t34 = (t53 - t04);
        t44 = (t63 + t93);
        t54 = (t53 + t04);
        t64 = (t63 - t93);
        s9 = ((0.92387953251128674f*t34) - (0.38268343236508978f*t44));
        s01 = ((0.38268343236508978f*t34) + (0.92387953251128674f*t44));
        s11 = ((0.38268343236508978f*t54) - (0.92387953251128674f*t64));
        s21 = ((0.92387953251128674f*t54) + (0.38268343236508978f*t64));
        a72 = (a + 96);
        a82 = (a + 97);
        a92 = (a + 608);
        a03 = (a + 609);
        t74 = (*(a72) + *(a92));
        t84 = (*(a82) + *(a03));
        t94 = (*(a72) - *(a92));
        t05 = (*(a82) - *(a03));
        a13 = (a + 352);
        a23 = (a + 353);
        a33 = (a + 864);
        a43 = (a + 865);
        t15 = (*(a13) + *(a33));
        t25 = (*(a23) + *(a43));
        t35 = (*(a13) - *(a33));
        t45 = (*(a23) - *(a43));
        t55 = (t74 + t15);
        t65 = (t84 + t25);
        t75 = (t74 - t15);
        t85 = (t84 - t25);
        s31 = ((0.38268343236508978f*t75) - (0.92387953251128674f*t85));
        s41 = ((0.92387953251128674f*t75) + (0.38268343236508978f*t85));
        t95 = (t94 - t45);
        t06 = (t05 + t35);
        t16 = (t94 + t45);
        t26 = (t05 - t35);
        s51 = ((0.83146961230254524f*t95) - (0.55557023301960218f*t06));
        s61 = ((0.55557023301960218f*t95) + (0.83146961230254524f*t06));
        s71 = ((0.19509032201612828f*t16) + (0.98078528040323043f*t26));
        s81 = ((0.98078528040323043f*t16) - (0.19509032201612828f*t26));
        a53 = (a + 128);
        a63 = (a + 129);
        a73 = (a + 640);
        a83 = (a + 641);
        t36 = (*(a53) + *(a73));
        t46 = (*(a63) + *(a83));
        t56 = (*(a53) - *(a73));
        t66 = (*(a63) - *(a83));
        a93 = (a + 384);
        a04 = (a + 385);
        a14 = (a + 896);
        a24 = (a + 897);
        t76 = (*(a93) + *(a14));
        t86 = (*(a04) + *(a24));
        t96 = (*(a93) - *(a14));
        t07 = (*(a04) - *(a24));
        t17 = (t36 + t76);
        t27 = (t46 + t86);
        t37 = (t36 - t76);
        t47 = (t46 - t86);
        a34 = (0.70710678118654757f*(t56 - t07));
        a44 = (0.70710678118654757f*(t66 + t96));
        s91 = (a34 - a44);
        s02 = (a34 + a44);
        a54 = (0.70710678118654757f*(t56 + t07));
        a64 = (0.70710678118654757f*(t66 - t96));
        s12 = (a54 + a64);
        s22 = (a54 - a64);
        a74 = (a + 160);
        a84 = (a + 161);
        a94 = (a + 672);
        a05 = (a + 673);
        t57 = (*(a74) + *(a94));
        t67 = (*(a84) + *(a05));
        t77 = (*(a74) - *(a94));
        t87 = (*(a84) - *(a05));
        a15 = (a + 416);
        a25 = (a + 417);
        a35 = (a + 928);
        a45 = (a + 929);
        t97 = (*(a15) + *(a35));
        t08 = (*(a25) + *(a45));
        t18 = (*(a15) - *(a35));
        t28 = (*(a25) - *(a45));
        t38 = (t57 + t97);
        t48 = (t67 + t08);
        t58 = (t57 - t97);
        t68 = (t67 - t08);
        s32 = ((0.38268343236508978f*t58) + (0.92387953251128674f*t68));
        s42 = ((0.92387953251128674f*t58) - (0.38268343236508978f*t68));
        t78 = (t77 - t28);
        t88 = (t87 + t18);
        t98 = (t77 + t28);
        t09 = (t87 - t18);
        s52 = ((0.55557023301960218f*t78) - (0.83146961230254524f*t88));
        s62 = ((0.83146961230254524f*t78) + (0.55557023301960218f*t88));
        s72 = ((0.98078528040323043f*t98) + (0.19509032201612828f*t09));
        s82 = ((0.19509032201612828f*t98) - (0.98078528040323043f*t09));
        a55 = (a + 192);
        a65 = (a + 193);
        a75 = (a + 704);
        a85 = (a + 705);
        t19 = (*(a55) + *(a75));
        t29 = (*(a65) + *(a85));
        t39 = (*(a55) - *(a75));
        t49 = (*(a65) - *(a85));
        a95 = (a + 448);
        a06 = (a + 449);
        a16 = (a + 960);
        a26 = (a + 961);
        t59 = (*(a95) + *(a16));
        t69 = (*(a06) + *(a26));
        t79 = (*(a95) - *(a16));
        t89 = (*(a06) - *(a26));
        t99 = (t19 + t59);
        t0a = (t29 + t69);
        a36 = (0.70710678118654757f*(t19 - t59));
        a46 = (0.70710678118654757f*(t29 - t69));
        s92 = (a36 + a46);
        s03 = (a36 - a46);
        t1a = (t39 - t89);
        t2a = (t49 + t79);
        t3a = (t39 + t89);
        t4a = (t49 - t79);
        s13 = ((0.38268343236508978f*t1a) - (0.92387953251128674f*t2a));
        s23 = ((0.92387953251128674f*t1a) + (0.38268343236508978f*t2a));
        s33 = ((0.38268343236508978f*t4a) - (0.92387953251128674f*t3a));
        s43 = ((0.38268343236508978f*t3a) + (0.92387953251128674f*t4a));
        a56 = (a + 224);
        a66 = (a + 225);
        a76 = (a + 736);
        a86 = (a + 737);
        t5a = (*(a56) + *(a76));
        t6a = (*(a66) + *(a86));
        t7a = (*(a56) - *(a76));
        t8a = (*(a66) - *(a86));
        a96 = (a + 480);
        a07 = (a + 481);
        a17 = (a + 992);
        a27 = (a + 993);
        t9a = (*(a96) + *(a17));
        t0b = (*(a07) + *(a27));
        t1b = (*(a96) - *(a17));
        t2b = (*(a07) - *(a27));
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        s53 = ((0.92387953251128674f*t5b) + (0.38268343236508978f*t6b));
        s63 = ((0.38268343236508978f*t5b) - (0.92387953251128674f*t6b));
        t7b = (t7a - t2b);
        t8b = (t8a + t1b);
        t9b = (t7a + t2b);
        t0c = (t8a - t1b);
        s73 = ((0.19509032201612828f*t7b) - (0.98078528040323043f*t8b));
        s83 = ((0.98078528040323043f*t7b) + (0.19509032201612828f*t8b));
        s93 = ((0.83146961230254524f*t0c) - (0.55557023301960218f*t9b));
        s04 = ((0.83146961230254524f*t9b) + (0.55557023301960218f*t0c));
        t1c = (t9 + t17);
        t2c = (t01 + t27);
        t3c = (t9 - t17);
        t4c = (t01 - t27);
        t5c = (t52 + t38);
        t6c = (t62 + t48);
        a37 = (0.70710678118654757f*(t52 - t38));
        a47 = (0.70710678118654757f*(t62 - t48));
        s14 = (a37 - a47);
        s24 = (a37 + a47);
        t7c = (t14 + t99);
        t8c = (t24 + t0a);
        t9c = (t14 - t99);
        t0d = (t24 - t0a);
        t1d = (t55 + t3b);
        t2d = (t65 + t4b);
        a57 = (0.70710678118654757f*(t55 - t3b));
        a67 = (0.70710678118654757f*(t65 - t4b));
        s34 = (a57 + a67);
        s44 = (a57 - a67);
        t3d = (t1c + t7c);
        t4d = (t2c + t8c);
        t5d = (t1c - t7c);
        t6d = (t2c - t8c);
        t7d = (t5c + t1d);
        t8d = (t6c + t2d);
        t9d = (t5c - t1d);
        t0e = (t6c - t2d);
        t1e = (t3d + t7d);
        t2e = (t4d + t8d);
        t3e = (t3d - t7d);
        t4e = (t4d - t8d);
        a77 = (64*i);
        a87 = (D270 + a77);
        a97 = (a87 + 1);
        a08 = (a87 + 2);
        a18 = (a87 + 3);
        a28 = (T + a77);
        *(a28) = ((*(a87)*t1e) - (*(a97)*t2e));
        *((a28 + 1)) = ((*(a97)*t1e) + (*(a87)*t2e));
        *((a28 + 32)) = ((*(a08)*t3e) - (*(a18)*t4e));
        *((a28 + 33)) = ((*(a18)*t3e) + (*(a08)*t4e));
        t5e = (t5d - t0e);
        t6e = (t6d + t9d);
        t7e = (t5d + t0e);
        t8e = (t6d - t9d);
        a38 = (a87 + 4);
        a48 = (a87 + 5);
        a58 = (a87 + 6);
        a68 = (a87 + 7);
        *((a28 + 16)) = ((*(a38)*t5e) - (*(a48)*t6e));
        *((a28 + 17)) = ((*(a48)*t5e) + (*(a38)*t6e));
        *((a28 + 48)) = ((*(a58)*t7e) - (*(a68)*t8e));
        *((a28 + 49)) = ((*(a68)*t7e) + (*(a58)*t8e));
        t9e = (t3c - t0d);
        t0f = (t4c + t9c);
        t1f = (t3c + t0d);
        t2f = (t4c - t9c);
        t3f = (s14 - s34);
        t4f = (s24 + s44);
        t5f = (s14 + s34);
        t6f = (s24 - s44);
        t7f = (t9e + t3f);
        t8f = (t0f + t4f);
        t9f = (t9e - t3f);
        t0g = (t0f - t4f);
        a78 = (a87 + 8);
        a88 = (a87 + 9);
        a98 = (a87 + 10);
        a09 = (a87 + 11);
        *((a28 + 8)) = ((*(a78)*t7f) - (*(a88)*t8f));
        *((a28 + 9)) = ((*(a88)*t7f) + (*(a78)*t8f));
        *((a28 + 40)) = ((*(a98)*t9f) - (*(a09)*t0g));
        *((a28 + 41)) = ((*(a09)*t9f) + (*(a98)*t0g));
        t1g = (t1f - t6f);
        t2g = (t2f + t5f);
        t3g = (t1f + t6f);
        t4g = (t2f - t5f);
        a19 = (a87 + 12);
        a29 = (a87 + 13);
        a39 = (a87 + 14);
        a49 = (a87 + 15);
        *((a28 + 24)) = ((*(a19)*t1g) - (*(a29)*t2g));
        *((a28 + 25)) = ((*(a29)*t1g) + (*(a19)*t2g));
        *((a28 + 56)) = ((*(a39)*t3g) - (*(a49)*t4g));
        *((a28 + 57)) = ((*(a49)*t3g) + (*(a39)*t4g));
        t5g = (t31 + s91);
        t6g = (t41 + s02);
        t7g = (t31 - s91);
        t8g = (t41 - s02);
        t9g = (s3 + s52);
        t0h = (s4 + s62);
        a59 = (0.70710678118654757f*(s3 - s52));
        a69 = (0.70710678118654757f*(s4 - s62));
        s54 = (a59 - a69);
        s64 = (a59 + a69);
        t1h = (s9 + s13);
        t2h = (s01 + s23);
        t3h = (s9 - s13);
        t4h = (s01 - s23);
        t5h = (s51 + s73);
        t6h = (s61 + s83);
        a79 = (0.70710678118654757f*(s51 - s73));
        a89 = (0.70710678118654757f*(s61 - s83));
        s74 = (a79 + a89);
        s84 = (a79 - a89);
        t7h = (t5g + t1h);
        t8h = (t6g + t2h);
        t9h = (t5g - t1h);
        t0i = (t6g - t2h);
        t1i = (t9g + t5h);
        t2i = (t0h + t6h);
        t3i = (t9g - t5h);
        t4i = (t0h - t6h);
        t5i = (t7h + t1i);
        t6i = (t8h + t2i);
        t7i = (t7h - t1i);
        t8i = (t8h - t2i);
        a99 = (a87 + 16);
        a0a = (a87 + 17);
        a1a = (a87 + 18);
        a2a = (a87 + 19);
        *((a28 + 2)) = ((*(a99)*t5i) - (*(a0a)*t6i));
        *((a28 + 3)) = ((*(a0a)*t5i) + (*(a99)*t6i));
        *((a28 + 34)) = ((*(a1a)*t7i) - (*(a2a)*t8i));
        *((a28 + 35)) = ((*(a2a)*t7i) + (*(a1a)*t8i));
        t9i = (t9h - t4i);
        t0j = (t0i + t3i);
        t1j = (t9h + t4i);
        t2j = (t0i - t3i);
        a3a = (a87 + 20);
        a4a = (a87 + 21);
        a5a = (a87 + 22);
        a6a = (a87 + 23);
        *((a28 + 18)) = ((*(a3a)*t9i) - (*(a4a)*t0j));
        *((a28 + 19)) = ((*(a4a)*t9i) + (*(a3a)*t0j));
        *((a28 + 50)) = ((*(a5a)*t1j) - (*(a6a)*t2j));
        *((a28 + 51)) = ((*(a6a)*t1j) + (*(a5a)*t2j));
        t3j = (t7g - t4h);
        t4j = (t8g + t3h);
        t5j = (t7g + t4h);
        t6j = (t8g - t3h);
        t7j = (s54 - s74);
        t8j = (s64 + s84);
        t9j = (s54 + s74);
        t0k = (s64 - s84);
        t1k = (t3j + t7j);
        t2k = (t4j + t8j);
        t3k = (t3j - t7j);
        t4k = (t4j - t8j);
        a7a = (a87 + 24);
        a8a = (a87 + 25);
        a9a = (a87 + 26);
        a0b = (a87 + 27);
        *((a28 + 10)) = ((*(a7a)*t1k) - (*(a8a)*t2k));
        *((a28 + 11)) = ((*(a8a)*t1k) + (*(a7a)*t2k));
        *((a28 + 42)) = ((*(a9a)*t3k) - (*(a0b)*t4k));
        *((a28 + 43)) = ((*(a0b)*t3k) + (*(a9a)*t4k));
        t5k = (t5j - t0k);
        t6k = (t6j + t9j);
        t7k = (t5j + t0k);
        t8k = (t6j - t9j);
        a1b = (a87 + 28);
        a2b = (a87 + 29);
        a3b = (a87 + 30);
        a4b = (a87 + 31);
        *((a28 + 26)) = ((*(a1b)*t5k) - (*(a2b)*t6k));
        *((a28 + 27)) = ((*(a2b)*t5k) + (*(a1b)*t6k));
        *((a28 + 58)) = ((*(a3b)*t7k) - (*(a4b)*t8k));
        *((a28 + 59)) = ((*(a4b)*t7k) + (*(a3b)*t8k));
        t9k = (t11 - t47);
        t0l = (t21 + t37);
        t1l = (t11 + t47);
        t2l = (t21 - t37);
        t3l = (s - s32);
        t4l = (s2 + s42);
        a5b = (0.70710678118654757f*(s + s32));
        a6b = (0.70710678118654757f*(s2 - s42));
        s94 = (a5b - a6b);
        s05 = (a5b + a6b);
        t5l = (s7 - s92);
        t6l = (s8 + s03);
        t7l = (s7 + s92);
        t8l = (s8 - s03);
        t9l = (s31 - s53);
        t0m = (s41 + s63);
        a7b = (0.70710678118654757f*(s31 + s53));
        a8b = (0.70710678118654757f*(s41 - s63));
        s15 = (a7b + a8b);
        s25 = (a7b - a8b);
        t1m = (t9k + t5l);
        t2m = (t0l + t6l);
        t3m = (t9k - t5l);
        t4m = (t0l - t6l);
        t5m = (t3l + t9l);
        t6m = (t4l + t0m);
        t7m = (t3l - t9l);
        t8m = (t4l - t0m);
        t9m = (t1m + t5m);
        t0n = (t2m + t6m);
        t1n = (t1m - t5m);
        t2n = (t2m - t6m);
        a9b = (a87 + 32);
        a0c = (a87 + 33);
        a1c = (a87 + 34);
        a2c = (a87 + 35);
        *((a28 + 4)) = ((*(a9b)*t9m) - (*(a0c)*t0n));
        *((a28 + 5)) = ((*(a0c)*t9m) + (*(a9b)*t0n));
        *((a28 + 36)) = ((*(a1c)*t1n) - (*(a2c)*t2n));
        *((a28 + 37)) = ((*(a2c)*t1n) + (*(a1c)*t2n));
        t3n = (t3m - t8m);
        t4n = (t4m + t7m);
        t5n = (t3m + t8m);
        t6n = (t4m - t7m);
        a3c = (a87 + 36);
        a4c = (a87 + 37);
        a5c = (a87 + 38);
        a6c = (a87 + 39);
        *((a28 + 20)) = ((*(a3c)*t3n) - (*(a4c)*t4n));
        *((a28 + 21)) = ((*(a4c)*t3n) + (*(a3c)*t4n));
        *((a28 + 52)) = ((*(a5c)*t5n) - (*(a6c)*t6n));
        *((a28 + 53)) = ((*(a6c)*t5n) + (*(a5c)*t6n));
        t7n = (t1l - t8l);
        t8n = (t2l + t7l);
        t9n = (t1l + t8l);
        t0o = (t2l - t7l);
        t1o = (s94 - s15);
        t2o = (s05 + s25);
        t3o = (s94 + s15);
        t4o = (s05 - s25);
        t5o = (t7n + t1o);
        t6o = (t8n + t2o);
        t7o = (t7n - t1o);
        t8o = (t8n - t2o);
        a7c = (a87 + 40);
        a8c = (a87 + 41);
        a9c = (a87 + 42);
        a0d = (a87 + 43);
        *((a28 + 12)) = ((*(a7c)*t5o) - (*(a8c)*t6o));
        *((a28 + 13)) = ((*(a8c)*t5o) + (*(a7c)*t6o));
        *((a28 + 44)) = ((*(a9c)*t7o) - (*(a0d)*t8o));
        *((a28 + 45)) = ((*(a0d)*t7o) + (*(a9c)*t8o));
        t9o = (t9n - t4o);
        t0p = (t0o + t3o);
        t1p = (t9n + t4o);
        t2p = (t0o - t3o);
        a1d = (a87 + 44);
        a2d = (a87 + 45);
        a3d = (a87 + 46);
        a4d = (a87 + 47);
        *((a28 + 28)) = ((*(a1d)*t9o) - (*(a2d)*t0p));
        *((a28 + 29)) = ((*(a2d)*t9o) + (*(a1d)*t0p));
        *((a28 + 60)) = ((*(a3d)*t1p) - (*(a4d)*t2p));
        *((a28 + 61)) = ((*(a4d)*t1p) + (*(a3d)*t2p));
        t3p = (t51 - s12);
        t4p = (t61 + s22);
        t5p = (t51 + s12);
        t6p = (t61 - s22);
        t7p = (s5 - s72);
        t8p = (s6 + s82);
        a5d = (0.70710678118654757f*(s5 + s72));
        a6d = (0.70710678118654757f*(s6 - s82));
        s35 = (a5d - a6d);
        s45 = (a5d + a6d);
        t9p = (s11 + s33);
        t0q = (s21 - s43);
        t1q = (s11 - s33);
        t2q = (s21 + s43);
        t3q = (s93 - s71);
        t4q = (s81 - s04);
        a7d = (0.70710678118654757f*(s71 + s93));
        a8d = (0.70710678118654757f*(s81 + s04));
        s55 = (a7d - a8d);
        s65 = (a7d + a8d);
        t5q = (t3p + t9p);
        t6q = (t4p + t0q);
        t7q = (t3p - t9p);
        t8q = (t4p - t0q);
        t9q = (t7p + t3q);
        t0r = (t8p + t4q);
        t1r = (t7p - t3q);
        t2r = (t8p - t4q);
        t3r = (t5q + t9q);
        t4r = (t6q + t0r);
        t5r = (t5q - t9q);
        t6r = (t6q - t0r);
        a9d = (a87 + 48);
        a0e = (a87 + 49);
        a1e = (a87 + 50);
        a2e = (a87 + 51);
        *((a28 + 6)) = ((*(a9d)*t3r) - (*(a0e)*t4r));
        *((a28 + 7)) = ((*(a0e)*t3r) + (*(a9d)*t4r));
        *((a28 + 38)) = ((*(a1e)*t5r) - (*(a2e)*t6r));
        *((a28 + 39)) = ((*(a2e)*t5r) + (*(a1e)*t6r));
        t7r = (t7q - t2r);
        t8r = (t8q + t1r);
        t9r = (t7q + t2r);
        t0s = (t8q - t1r);
        a3e = (a87 + 52);
        a4e = (a87 + 53);
        a5e = (a87 + 54);
        a6e = (a87 + 55);
        *((a28 + 22)) = ((*(a3e)*t7r) - (*(a4e)*t8r));
        *((a28 + 23)) = ((*(a4e)*t7r) + (*(a3e)*t8r));
        *((a28 + 54)) = ((*(a5e)*t9r) - (*(a6e)*t0s));
        *((a28 + 55)) = ((*(a6e)*t9r) + (*(a5e)*t0s));
        t1s = (t5p - t2q);
        t2s = (t6p + t1q);
        t3s = (t5p + t2q);
        t4s = (t6p - t1q);
        t5s = (s35 + s55);
        t6s = (s45 - s65);
        t7s = (s35 - s55);
        t8s = (s45 + s65);
        t9s = (t1s + t5s);
        t0t = (t2s + t6s);
        t1t = (t1s - t5s);
        t2t = (t2s - t6s);
        a7e = (a87 + 56);
        a8e = (a87 + 57);
        a9e = (a87 + 58);
        a0f = (a87 + 59);
        *((a28 + 14)) = ((*(a7e)*t9s) - (*(a8e)*t0t));
        *((a28 + 15)) = ((*(a8e)*t9s) + (*(a7e)*t0t));
        *((a28 + 46)) = ((*(a9e)*t1t) - (*(a0f)*t2t));
        *((a28 + 47)) = ((*(a0f)*t1t) + (*(a9e)*t2t));
        t3t = (t3s - t8s);
        t4t = (t4s + t7s);
        t5t = (t3s + t8s);
        t6t = (t4s - t7s);
        a1f = (a87 + 60);
        a2f = (a87 + 61);
        a3f = (a87 + 62);
        a4f = (a87 + 63);
        *((a28 + 30)) = ((*(a1f)*t3t) - (*(a2f)*t4t));
        *((a28 + 31)) = ((*(a2f)*t3t) + (*(a1f)*t4t));
        *((a28 + 62)) = ((*(a3f)*t5t) - (*(a4f)*t6t));
        *((a28 + 63)) = ((*(a4f)*t5t) + (*(a3f)*t6t));
    }}
    {long i2; for(i2 = 0; i2 <= 31; i2++) {
        a5f = (2*i2);
        a6f = (T + a5f);
        a7f = (a6f + 1);
        a8f = (a6f + 512);
        a9f = (a6f + 513);
        t7t = (*(a6f) + *(a8f));
        t8t = (*(a7f) + *(a9f));
        t9t = (*(a6f) - *(a8f));
        t0u = (*(a7f) - *(a9f));
        a0g = (a6f + 256);
        a1g = (a6f + 257);
        a2g = (a6f + 768);
        a3g = (a6f + 769);
        t1u = (*(a0g) + *(a2g));
        t2u = (*(a1g) + *(a3g));
        t3u = (*(a0g) - *(a2g));
        t4u = (*(a1g) - *(a3g));
        t5u = (t7t + t1u);
        t6u = (t8t + t2u);
        t7u = (t7t - t1u);
        t8u = (t8t - t2u);
        t9u = (t9t - t4u);
        t0v = (t0u + t3u);
        t1v = (t9t + t4u);
        t2v = (t0u - t3u);
        a4g = (a6f + 64);
        a5g = (a6f + 65);
        a6g = (a6f + 576);
        a7g = (a6f + 577);
        t3v = (*(a4g) + *(a6g));
        t4v = (*(a5g) + *(a7g));
        t5v = (*(a4g) - *(a6g));
        t6v = (*(a5g) - *(a7g));
        a8g = (a6f + 320);
        a9g = (a6f + 321);
        a0h = (a6f + 832);
        a1h = (a6f + 833);
        t7v = (*(a8g) + *(a0h));
        t8v = (*(a9g) + *(a1h));
        t9v = (*(a8g) - *(a0h));
        t0w = (*(a9g) - *(a1h));
        t1w = (t3v + t7v);
        t2w = (t4v + t8v);
        a2h = (0.70710678118654757f*(t3v - t7v));
        a3h = (0.70710678118654757f*(t4v - t8v));
        s75 = (a2h - a3h);
        s85 = (a2h + a3h);
        t3w = (t5v - t0w);
        t4w = (t6v + t9v);
        t5w = (t5v + t0w);
        t6w = (t6v - t9v);
        s95 = ((0.92387953251128674f*t3w) - (0.38268343236508978f*t4w));
        s06 = ((0.38268343236508978f*t3w) + (0.92387953251128674f*t4w));
        s16 = ((0.38268343236508978f*t5w) - (0.92387953251128674f*t6w));
        s26 = ((0.92387953251128674f*t5w) + (0.38268343236508978f*t6w));
        a4h = (a6f + 128);
        a5h = (a6f + 129);
        a6h = (a6f + 640);
        a7h = (a6f + 641);
        t7w = (*(a4h) + *(a6h));
        t8w = (*(a5h) + *(a7h));
        t9w = (*(a4h) - *(a6h));
        t0x = (*(a5h) - *(a7h));
        a8h = (a6f + 384);
        a9h = (a6f + 385);
        a0i = (a6f + 896);
        a1i = (a6f + 897);
        t1x = (*(a8h) + *(a0i));
        t2x = (*(a9h) + *(a1i));
        t3x = (*(a8h) - *(a0i));
        t4x = (*(a9h) - *(a1i));
        t5x = (t7w + t1x);
        t6x = (t8w + t2x);
        t7x = (t7w - t1x);
        t8x = (t8w - t2x);
        a2i = (0.70710678118654757f*(t9w - t4x));
        a3i = (0.70710678118654757f*(t0x + t3x));
        s36 = (a2i - a3i);
        s46 = (a2i + a3i);
        a4i = (0.70710678118654757f*(t9w + t4x));
        a5i = (0.70710678118654757f*(t0x - t3x));
        s56 = (a4i + a5i);
        s66 = (a4i - a5i);
        a6i = (a6f + 192);
        a7i = (a6f + 193);
        a8i = (a6f + 704);
        a9i = (a6f + 705);
        t9x = (*(a6i) + *(a8i));
        t0y = (*(a7i) + *(a9i));
        t1y = (*(a6i) - *(a8i));
        t2y = (*(a7i) - *(a9i));
        a0j = (a6f + 448);
        a1j = (a6f + 449);
        a2j = (a6f + 960);
        a3j = (a6f + 961);
        t3y = (*(a0j) + *(a2j));
        t4y = (*(a1j) + *(a3j));
        t5y = (*(a0j) - *(a2j));
        t6y = (*(a1j) - *(a3j));
        t7y = (t9x + t3y);
        t8y = (t0y + t4y);
        a4j = (0.70710678118654757f*(t9x - t3y));
        a5j = (0.70710678118654757f*(t0y - t4y));
        s76 = (a4j + a5j);
        s86 = (a4j - a5j);
        t9y = (t1y - t6y);
        t0z = (t2y + t5y);
        t1z = (t1y + t6y);
        t2z = (t2y - t5y);
        s96 = ((0.38268343236508978f*t9y) - (0.92387953251128674f*t0z));
        s07 = ((0.92387953251128674f*t9y) + (0.38268343236508978f*t0z));
        s17 = ((0.38268343236508978f*t2z) - (0.92387953251128674f*t1z));
        s27 = ((0.38268343236508978f*t1z) + (0.92387953251128674f*t2z));
        t3z = (t5u + t5x);
        t4z = (t6u + t6x);
        t5z = (t5u - t5x);
        t6z = (t6u - t6x);
        t7z = (t1w + t7y);
        t8z = (t2w + t8y);
        t9z = (t1w - t7y);
        t0A = (t2w - t8y);
        a6j = (dst + a5f);
        *(a6j) = (t3z + t7z);
        *((a6j + 1)) = (t4z + t8z);
        *((a6j + 512)) = (t3z - t7z);
        *((a6j + 513)) = (t4z - t8z);
        *((a6j + 256)) = (t5z - t0A);
        *((a6j + 257)) = (t6z + t9z);
        *((a6j + 768)) = (t5z + t0A);
        *((a6j + 769)) = (t6z - t9z);
        t1A = (t9u + s36);
        t2A = (t0v + s46);
        t3A = (t9u - s36);
        t4A = (t0v - s46);
        t5A = (s95 + s96);
        t6A = (s06 + s07);
        t7A = (s95 - s96);
        t8A = (s06 - s07);
        *((a6j + 64)) = (t1A + t5A);
        *((a6j + 65)) = (t2A + t6A);
        *((a6j + 576)) = (t1A - t5A);
        *((a6j + 577)) = (t2A - t6A);
        *((a6j + 320)) = (t3A - t8A);
        *((a6j + 321)) = (t4A + t7A);
        *((a6j + 832)) = (t3A + t8A);
        *((a6j + 833)) = (t4A - t7A);
        t9A = (t7u - t8x);
        t0B = (t8u + t7x);
        t1B = (t7u + t8x);
        t2B = (t8u - t7x);
        t3B = (s75 - s76);
        t4B = (s85 + s86);
        t5B = (s75 + s76);
        t6B = (s85 - s86);
        *((a6j + 128)) = (t9A + t3B);
        *((a6j + 129)) = (t0B + t4B);
        *((a6j + 640)) = (t9A - t3B);
        *((a6j + 641)) = (t0B - t4B);
        *((a6j + 384)) = (t1B - t6B);
        *((a6j + 385)) = (t2B + t5B);
        *((a6j + 896)) = (t1B + t6B);
        *((a6j + 897)) = (t2B - t5B);
        t7B = (t1v - s56);
        t8B = (t2v + s66);
        t9B = (t1v + s56);
        t0C = (t2v - s66);
        t1C = (s16 + s17);
        t2C = (s26 - s27);
        t3C = (s16 - s17);
        t4C = (s26 + s27);
        *((a6j + 192)) = (t7B + t1C);
        *((a6j + 193)) = (t8B + t2C);
        *((a6j + 704)) = (t7B - t1C);
        *((a6j + 705)) = (t8B - t2C);
        *((a6j + 448)) = (t9B - t4C);
        *((a6j + 449)) = (t0C + t3C);
        *((a6j + 960)) = (t9B + t4C);
        *((a6j + 961)) = (t0C - t3C);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_float_1024)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[2048];
    float  *a08, *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0g, *a0h, *a0j, *a0l, *a0m, *a18, *a19, *a1a, *a1b, *a1c, *a1d, *a1e, *a1f, *a1g
            , *a1h, *a1j, *a1l, *a1m, *a28, *a29, *a2a, *a2b, *a2c, *a2d, *a2e, *a2f, *a2g, *a2h, *a2i, *a2j, *a2k, *a2l, *a2m, *a2n, *a38, *a39
            , *a3a, *a3b, *a3c, *a3d, *a3e, *a3f, *a3g, *a3h, *a3i, *a3j, *a3k, *a3l, *a3m, *a48, *a49, *a4a, *a4b, *a4c, *a4d, *a4e, *a4f, *a4g
            , *a4h, *a4i, *a4j, *a4k, *a4l, *a4m, *a58, *a5a, *a5c, *a5e, *a5g, *a5h, *a5i, *a5j, *a5k, *a5l, *a5m, *a68, *a6a, *a6c, *a6e, *a6f
            , *a6g, *a6h, *a6i, *a6j, *a6k, *a6l, *a6m, *a78, *a7a, *a7c, *a7e, *a7f, *a7g, *a7h, *a7i, *a7j, *a7k, *a7l, *a7m, *a87, *a88, *a8a
            , *a8c, *a8e, *a8f, *a8g, *a8h, *a8i, *a8k, *a97, *a98, *a99, *a9a, *a9b, *a9c, *a9d, *a9e, *a9f, *a9g, *a9h, *a9i, *a9k;
    const float  *a, *a01, *a02, *a03, *a04, *a05, *a06, *a07, *a11, *a12, *a13, *a14, *a15, *a16, *a17, *a2, *a21, *a22, *a23, *a24, *a25, *a26
            , *a27, *a3, *a31, *a32, *a33, *a35, *a4, *a41, *a42, *a43, *a45, *a5, *a51, *a53, *a55, *a56, *a6, *a61, *a63, *a65, *a66, *a7
            , *a71, *a72, *a73, *a74, *a75, *a76, *a8, *a81, *a82, *a83, *a84, *a85, *a86, *a9, *a91, *a92, *a93, *a94, *a95, *a96;
    int a5f, a77;
    float a0i, a0k, a0n, a0o, a1i, a1k, a1n, a1o, a2o, a34, a36, a37, a3n, a3o, a44, a46, a47, a4n, a4o, a52, a54, a57
            , a59, a5b, a5d, a5n, a62, a64, a67, a69, a6b, a6d, a6n, a79, a7b, a7d, a7n, a89, a8b, a8d, a8j, a8l, a8m, a8n
            , a9j, a9l, a9m, a9n, s, s01, s02, s03, s04, s05, s06, s07, s08, s09, s0a, s0b, s11, s12, s13, s14, s15, s16
            , s17, s18, s19, s1a, s1b, s2, s21, s22, s23, s24, s25, s26, s27, s28, s29, s2a, s2b, s3, s31, s32, s33, s34
            , s35, s36, s37, s38, s39, s3a, s4, s41, s42, s43, s44, s45, s46, s47, s48, s49, s4a, s5, s51, s52, s53, s54
            , s55, s56, s57, s58, s59, s5a, s6, s61, s62, s63, s64, s65, s66, s67, s68, s69, s6a, s7, s71, s72, s73, s74
            , s75, s76, s77, s78, s79, s7a, s8, s81, s82, s83, s84, s85, s86, s87, s88, s89, s8a, s9, s91, s92, s93, s94
            , s95, s96, s97, s98, s99, s9a, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0A, t0B, t0C, t0D, t0E, t0F
            , t0G, t0H, t0I, t0J, t0K, t0L, t0M, t0N, t0O, t0P, t0Q, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k
            , t0l, t0m, t0n, t0o, t0p, t0q, t0r, t0s, t0t, t0u, t0v, t0w, t0x, t0y, t0z, t11, t12, t13, t14, t15, t16, t17
            , t18, t19, t1A, t1B, t1C, t1D, t1E, t1F, t1G, t1H, t1I, t1J, t1K, t1L, t1M, t1N, t1O, t1P, t1Q, t1a, t1b, t1c
            , t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t, t1u, t1v, t1w, t1x, t1y
            , t1z, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2A, t2B, t2C, t2D, t2E, t2F, t2G, t2H, t2I, t2J, t2K
            , t2L, t2M, t2N, t2O, t2P, t2Q, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p
            , t2q, t2r, t2s, t2t, t2u, t2v, t2w, t2x, t2y, t2z, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3A, t3B
            , t3C, t3D, t3E, t3F, t3G, t3H, t3I, t3J, t3K, t3L, t3M, t3N, t3O, t3P, t3Q, t3a, t3b, t3c, t3d, t3e, t3f, t3g
            , t3h, t3i, t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s, t3t, t3u, t3v, t3w, t3x, t3y, t3z, t4, t41, t42
            , t43, t44, t45, t46, t47, t48, t49, t4A, t4B, t4C, t4D, t4E, t4F, t4G, t4H, t4I, t4J, t4K, t4L, t4M, t4N, t4O
            , t4P, t4Q, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t4o, t4p, t4q, t4r, t4s, t4t
            , t4u, t4v, t4w, t4x, t4y, t4z, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5A, t5B, t5C, t5D, t5E, t5F
            , t5G, t5H, t5I, t5J, t5K, t5L, t5M, t5N, t5O, t5P, t5Q, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k
            , t5l, t5m, t5n, t5o, t5p, t5q, t5r, t5s, t5t, t5u, t5v, t5w, t5x, t5y, t5z, t6, t61, t62, t63, t64, t65, t66
            , t67, t68, t69, t6A, t6B, t6C, t6D, t6E, t6F, t6G, t6H, t6I, t6J, t6K, t6L, t6M, t6N, t6O, t6P, t6Q, t6a, t6b
            , t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r, t6s, t6t, t6u, t6v, t6w, t6x
            , t6y, t6z, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7A, t7B, t7C, t7D, t7E, t7F, t7G, t7H, t7I, t7J
            , t7K, t7L, t7M, t7N, t7O, t7P, t7Q, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m, t7n, t7o
            , t7p, t7q, t7r, t7s, t7t, t7u, t7v, t7w, t7x, t7y, t7z, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8A
            , t8B, t8C, t8D, t8E, t8F, t8G, t8H, t8I, t8J, t8K, t8L, t8M, t8N, t8O, t8P, t8Q, t8a, t8b, t8c, t8d, t8e, t8f
            , t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p, t8q, t8r, t8s, t8t, t8u, t8v, t8w, t8x, t8y, t8z, t9, t91
            , t92, t93, t94, t95, t96, t97, t98, t99, t9A, t9B, t9C, t9D, t9E, t9F, t9G, t9H, t9I, t9J, t9K, t9L, t9M, t9N
            , t9O, t9P, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p, t9q, t9r, t9s, t9t
            , t9u, t9v, t9w, t9x, t9y, t9z;
    {long i; for(i = 0; i <= 31; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 1024);
        a4 = (a + 1025);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 512);
        a6 = (a + 513);
        a7 = (a + 1536);
        a8 = (a + 1537);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 - t8);
        t41 = (t4 + t7);
        t51 = (t3 + t8);
        t61 = (t4 - t7);
        a9 = (a + 64);
        a01 = (a + 65);
        a11 = (a + 1088);
        a21 = (a + 1089);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 576);
        a41 = (a + 577);
        a51 = (a + 1600);
        a61 = (a + 1601);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        t72 = (t71 - t12);
        t82 = (t81 - t22);
        s = ((0.92387953251128674f*t72) - (0.38268343236508978f*t82));
        s2 = ((0.38268343236508978f*t72) + (0.92387953251128674f*t82));
        t92 = (t91 - t42);
        t03 = (t02 + t32);
        t13 = (t91 + t42);
        t23 = (t02 - t32);
        s3 = ((0.98078528040323043f*t92) - (0.19509032201612828f*t03));
        s4 = ((0.19509032201612828f*t92) + (0.98078528040323043f*t03));
        s5 = ((0.83146961230254524f*t13) - (0.55557023301960218f*t23));
        s6 = ((0.55557023301960218f*t13) + (0.83146961230254524f*t23));
        a71 = (a + 128);
        a81 = (a + 129);
        a91 = (a + 1152);
        a02 = (a + 1153);
        t33 = (*(a71) + *(a91));
        t43 = (*(a81) + *(a02));
        t53 = (*(a71) - *(a91));
        t63 = (*(a81) - *(a02));
        a12 = (a + 640);
        a22 = (a + 641);
        a32 = (a + 1664);
        a42 = (a + 1665);
        t73 = (*(a12) + *(a32));
        t83 = (*(a22) + *(a42));
        t93 = (*(a12) - *(a32));
        t04 = (*(a22) - *(a42));
        t14 = (t33 + t73);
        t24 = (t43 + t83);
        a52 = (0.70710678118654757f*(t33 - t73));
        a62 = (0.70710678118654757f*(t43 - t83));
        s7 = (a52 - a62);
        s8 = (a52 + a62);
        t34 = (t53 - t04);
        t44 = (t63 + t93);
        t54 = (t53 + t04);
        t64 = (t63 - t93);
        s9 = ((0.92387953251128674f*t34) - (0.38268343236508978f*t44));
        s01 = ((0.38268343236508978f*t34) + (0.92387953251128674f*t44));
        s11 = ((0.38268343236508978f*t54) - (0.92387953251128674f*t64));
        s21 = ((0.92387953251128674f*t54) + (0.38268343236508978f*t64));
        a72 = (a + 192);
        a82 = (a + 193);
        a92 = (a + 1216);
        a03 = (a + 1217);
        t74 = (*(a72) + *(a92));
        t84 = (*(a82) + *(a03));
        t94 = (*(a72) - *(a92));
        t05 = (*(a82) - *(a03));
        a13 = (a + 704);
        a23 = (a + 705);
        a33 = (a + 1728);
        a43 = (a + 1729);
        t15 = (*(a13) + *(a33));
        t25 = (*(a23) + *(a43));
        t35 = (*(a13) - *(a33));
        t45 = (*(a23) - *(a43));
        t55 = (t74 + t15);
        t65 = (t84 + t25);
        t75 = (t74 - t15);
        t85 = (t84 - t25);
        s31 = ((0.38268343236508978f*t75) - (0.92387953251128674f*t85));
        s41 = ((0.92387953251128674f*t75) + (0.38268343236508978f*t85));
        t95 = (t94 - t45);
        t06 = (t05 + t35);
        t16 = (t94 + t45);
        t26 = (t05 - t35);
        s51 = ((0.83146961230254524f*t95) - (0.55557023301960218f*t06));
        s61 = ((0.55557023301960218f*t95) + (0.83146961230254524f*t06));
        s71 = ((0.19509032201612828f*t16) + (0.98078528040323043f*t26));
        s81 = ((0.98078528040323043f*t16) - (0.19509032201612828f*t26));
        a53 = (a + 256);
        a63 = (a + 257);
        a73 = (a + 1280);
        a83 = (a + 1281);
        t36 = (*(a53) + *(a73));
        t46 = (*(a63) + *(a83));
        t56 = (*(a53) - *(a73));
        t66 = (*(a63) - *(a83));
        a93 = (a + 768);
        a04 = (a + 769);
        a14 = (a + 1792);
        a24 = (a + 1793);
        t76 = (*(a93) + *(a14));
        t86 = (*(a04) + *(a24));
        t96 = (*(a93) - *(a14));
        t07 = (*(a04) - *(a24));
        t17 = (t36 + t76);
        t27 = (t46 + t86);
        t37 = (t36 - t76);
        t47 = (t46 - t86);
        a34 = (0.70710678118654757f*(t56 - t07));
        a44 = (0.70710678118654757f*(t66 + t96));
        s91 = (a34 - a44);
        s02 = (a34 + a44);
        a54 = (0.70710678118654757f*(t56 + t07));
        a64 = (0.70710678118654757f*(t66 - t96));
        s12 = (a54 + a64);
        s22 = (a54 - a64);
        a74 = (a + 320);
        a84 = (a + 321);
        a94 = (a + 1344);
        a05 = (a + 1345);
        t57 = (*(a74) + *(a94));
        t67 = (*(a84) + *(a05));
        t77 = (*(a74) - *(a94));
        t87 = (*(a84) - *(a05));
        a15 = (a + 832);
        a25 = (a + 833);
        a35 = (a + 1856);
        a45 = (a + 1857);
        t97 = (*(a15) + *(a35));
        t08 = (*(a25) + *(a45));
        t18 = (*(a15) - *(a35));
        t28 = (*(a25) - *(a45));
        t38 = (t57 + t97);
        t48 = (t67 + t08);
        t58 = (t57 - t97);
        t68 = (t67 - t08);
        s32 = ((0.38268343236508978f*t58) + (0.92387953251128674f*t68));
        s42 = ((0.92387953251128674f*t58) - (0.38268343236508978f*t68));
        t78 = (t77 - t28);
        t88 = (t87 + t18);
        t98 = (t77 + t28);
        t09 = (t87 - t18);
        s52 = ((0.55557023301960218f*t78) - (0.83146961230254524f*t88));
        s62 = ((0.83146961230254524f*t78) + (0.55557023301960218f*t88));
        s72 = ((0.98078528040323043f*t98) + (0.19509032201612828f*t09));
        s82 = ((0.19509032201612828f*t98) - (0.98078528040323043f*t09));
        a55 = (a + 384);
        a65 = (a + 385);
        a75 = (a + 1408);
        a85 = (a + 1409);
        t19 = (*(a55) + *(a75));
        t29 = (*(a65) + *(a85));
        t39 = (*(a55) - *(a75));
        t49 = (*(a65) - *(a85));
        a95 = (a + 896);
        a06 = (a + 897);
        a16 = (a + 1920);
        a26 = (a + 1921);
        t59 = (*(a95) + *(a16));
        t69 = (*(a06) + *(a26));
        t79 = (*(a95) - *(a16));
        t89 = (*(a06) - *(a26));
        t99 = (t19 + t59);
        t0a = (t29 + t69);
        a36 = (0.70710678118654757f*(t19 - t59));
        a46 = (0.70710678118654757f*(t29 - t69));
        s92 = (a36 + a46);
        s03 = (a36 - a46);
        t1a = (t39 - t89);
        t2a = (t49 + t79);
        t3a = (t39 + t89);
        t4a = (t49 - t79);
        s13 = ((0.38268343236508978f*t1a) - (0.92387953251128674f*t2a));
        s23 = ((0.92387953251128674f*t1a) + (0.38268343236508978f*t2a));
        s33 = ((0.38268343236508978f*t4a) - (0.92387953251128674f*t3a));
        s43 = ((0.38268343236508978f*t3a) + (0.92387953251128674f*t4a));
        a56 = (a + 448);
        a66 = (a + 449);
        a76 = (a + 1472);
        a86 = (a + 1473);
        t5a = (*(a56) + *(a76));
        t6a = (*(a66) + *(a86));
        t7a = (*(a56) - *(a76));
        t8a = (*(a66) - *(a86));
        a96 = (a + 960);
        a07 = (a + 961);
        a17 = (a + 1984);
        a27 = (a + 1985);
        t9a = (*(a96) + *(a17));
        t0b = (*(a07) + *(a27));
        t1b = (*(a96) - *(a17));
        t2b = (*(a07) - *(a27));
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        s53 = ((0.92387953251128674f*t5b) + (0.38268343236508978f*t6b));
        s63 = ((0.38268343236508978f*t5b) - (0.92387953251128674f*t6b));
        t7b = (t7a - t2b);
        t8b = (t8a + t1b);
        t9b = (t7a + t2b);
        t0c = (t8a - t1b);
        s73 = ((0.19509032201612828f*t7b) - (0.98078528040323043f*t8b));
        s83 = ((0.98078528040323043f*t7b) + (0.19509032201612828f*t8b));
        s93 = ((0.83146961230254524f*t0c) - (0.55557023301960218f*t9b));
        s04 = ((0.83146961230254524f*t9b) + (0.55557023301960218f*t0c));
        t1c = (t9 + t17);
        t2c = (t01 + t27);
        t3c = (t9 - t17);
        t4c = (t01 - t27);
        t5c = (t52 + t38);
        t6c = (t62 + t48);
        a37 = (0.70710678118654757f*(t52 - t38));
        a47 = (0.70710678118654757f*(t62 - t48));
        s14 = (a37 - a47);
        s24 = (a37 + a47);
        t7c = (t14 + t99);
        t8c = (t24 + t0a);
        t9c = (t14 - t99);
        t0d = (t24 - t0a);
        t1d = (t55 + t3b);
        t2d = (t65 + t4b);
        a57 = (0.70710678118654757f*(t55 - t3b));
        a67 = (0.70710678118654757f*(t65 - t4b));
        s34 = (a57 + a67);
        s44 = (a57 - a67);
        t3d = (t1c + t7c);
        t4d = (t2c + t8c);
        t5d = (t1c - t7c);
        t6d = (t2c - t8c);
        t7d = (t5c + t1d);
        t8d = (t6c + t2d);
        t9d = (t5c - t1d);
        t0e = (t6c - t2d);
        t1e = (t3d + t7d);
        t2e = (t4d + t8d);
        t3e = (t3d - t7d);
        t4e = (t4d - t8d);
        a77 = (64*i);
        a87 = (D271 + a77);
        a97 = (a87 + 1);
        a08 = (a87 + 2);
        a18 = (a87 + 3);
        a28 = (T + a77);
        *(a28) = ((*(a87)*t1e) - (*(a97)*t2e));
        *((a28 + 1)) = ((*(a97)*t1e) + (*(a87)*t2e));
        *((a28 + 32)) = ((*(a08)*t3e) - (*(a18)*t4e));
        *((a28 + 33)) = ((*(a18)*t3e) + (*(a08)*t4e));
        t5e = (t5d - t0e);
        t6e = (t6d + t9d);
        t7e = (t5d + t0e);
        t8e = (t6d - t9d);
        a38 = (a87 + 4);
        a48 = (a87 + 5);
        a58 = (a87 + 6);
        a68 = (a87 + 7);
        *((a28 + 16)) = ((*(a38)*t5e) - (*(a48)*t6e));
        *((a28 + 17)) = ((*(a48)*t5e) + (*(a38)*t6e));
        *((a28 + 48)) = ((*(a58)*t7e) - (*(a68)*t8e));
        *((a28 + 49)) = ((*(a68)*t7e) + (*(a58)*t8e));
        t9e = (t3c - t0d);
        t0f = (t4c + t9c);
        t1f = (t3c + t0d);
        t2f = (t4c - t9c);
        t3f = (s14 - s34);
        t4f = (s24 + s44);
        t5f = (s14 + s34);
        t6f = (s24 - s44);
        t7f = (t9e + t3f);
        t8f = (t0f + t4f);
        t9f = (t9e - t3f);
        t0g = (t0f - t4f);
        a78 = (a87 + 8);
        a88 = (a87 + 9);
        a98 = (a87 + 10);
        a09 = (a87 + 11);
        *((a28 + 8)) = ((*(a78)*t7f) - (*(a88)*t8f));
        *((a28 + 9)) = ((*(a88)*t7f) + (*(a78)*t8f));
        *((a28 + 40)) = ((*(a98)*t9f) - (*(a09)*t0g));
        *((a28 + 41)) = ((*(a09)*t9f) + (*(a98)*t0g));
        t1g = (t1f - t6f);
        t2g = (t2f + t5f);
        t3g = (t1f + t6f);
        t4g = (t2f - t5f);
        a19 = (a87 + 12);
        a29 = (a87 + 13);
        a39 = (a87 + 14);
        a49 = (a87 + 15);
        *((a28 + 24)) = ((*(a19)*t1g) - (*(a29)*t2g));
        *((a28 + 25)) = ((*(a29)*t1g) + (*(a19)*t2g));
        *((a28 + 56)) = ((*(a39)*t3g) - (*(a49)*t4g));
        *((a28 + 57)) = ((*(a49)*t3g) + (*(a39)*t4g));
        t5g = (t31 + s91);
        t6g = (t41 + s02);
        t7g = (t31 - s91);
        t8g = (t41 - s02);
        t9g = (s3 + s52);
        t0h = (s4 + s62);
        a59 = (0.70710678118654757f*(s3 - s52));
        a69 = (0.70710678118654757f*(s4 - s62));
        s54 = (a59 - a69);
        s64 = (a59 + a69);
        t1h = (s9 + s13);
        t2h = (s01 + s23);
        t3h = (s9 - s13);
        t4h = (s01 - s23);
        t5h = (s51 + s73);
        t6h = (s61 + s83);
        a79 = (0.70710678118654757f*(s51 - s73));
        a89 = (0.70710678118654757f*(s61 - s83));
        s74 = (a79 + a89);
        s84 = (a79 - a89);
        t7h = (t5g + t1h);
        t8h = (t6g + t2h);
        t9h = (t5g - t1h);
        t0i = (t6g - t2h);
        t1i = (t9g + t5h);
        t2i = (t0h + t6h);
        t3i = (t9g - t5h);
        t4i = (t0h - t6h);
        t5i = (t7h + t1i);
        t6i = (t8h + t2i);
        t7i = (t7h - t1i);
        t8i = (t8h - t2i);
        a99 = (a87 + 16);
        a0a = (a87 + 17);
        a1a = (a87 + 18);
        a2a = (a87 + 19);
        *((a28 + 2)) = ((*(a99)*t5i) - (*(a0a)*t6i));
        *((a28 + 3)) = ((*(a0a)*t5i) + (*(a99)*t6i));
        *((a28 + 34)) = ((*(a1a)*t7i) - (*(a2a)*t8i));
        *((a28 + 35)) = ((*(a2a)*t7i) + (*(a1a)*t8i));
        t9i = (t9h - t4i);
        t0j = (t0i + t3i);
        t1j = (t9h + t4i);
        t2j = (t0i - t3i);
        a3a = (a87 + 20);
        a4a = (a87 + 21);
        a5a = (a87 + 22);
        a6a = (a87 + 23);
        *((a28 + 18)) = ((*(a3a)*t9i) - (*(a4a)*t0j));
        *((a28 + 19)) = ((*(a4a)*t9i) + (*(a3a)*t0j));
        *((a28 + 50)) = ((*(a5a)*t1j) - (*(a6a)*t2j));
        *((a28 + 51)) = ((*(a6a)*t1j) + (*(a5a)*t2j));
        t3j = (t7g - t4h);
        t4j = (t8g + t3h);
        t5j = (t7g + t4h);
        t6j = (t8g - t3h);
        t7j = (s54 - s74);
        t8j = (s64 + s84);
        t9j = (s54 + s74);
        t0k = (s64 - s84);
        t1k = (t3j + t7j);
        t2k = (t4j + t8j);
        t3k = (t3j - t7j);
        t4k = (t4j - t8j);
        a7a = (a87 + 24);
        a8a = (a87 + 25);
        a9a = (a87 + 26);
        a0b = (a87 + 27);
        *((a28 + 10)) = ((*(a7a)*t1k) - (*(a8a)*t2k));
        *((a28 + 11)) = ((*(a8a)*t1k) + (*(a7a)*t2k));
        *((a28 + 42)) = ((*(a9a)*t3k) - (*(a0b)*t4k));
        *((a28 + 43)) = ((*(a0b)*t3k) + (*(a9a)*t4k));
        t5k = (t5j - t0k);
        t6k = (t6j + t9j);
        t7k = (t5j + t0k);
        t8k = (t6j - t9j);
        a1b = (a87 + 28);
        a2b = (a87 + 29);
        a3b = (a87 + 30);
        a4b = (a87 + 31);
        *((a28 + 26)) = ((*(a1b)*t5k) - (*(a2b)*t6k));
        *((a28 + 27)) = ((*(a2b)*t5k) + (*(a1b)*t6k));
        *((a28 + 58)) = ((*(a3b)*t7k) - (*(a4b)*t8k));
        *((a28 + 59)) = ((*(a4b)*t7k) + (*(a3b)*t8k));
        t9k = (t11 - t47);
        t0l = (t21 + t37);
        t1l = (t11 + t47);
        t2l = (t21 - t37);
        t3l = (s - s32);
        t4l = (s2 + s42);
        a5b = (0.70710678118654757f*(s + s32));
        a6b = (0.70710678118654757f*(s2 - s42));
        s94 = (a5b - a6b);
        s05 = (a5b + a6b);
        t5l = (s7 - s92);
        t6l = (s8 + s03);
        t7l = (s7 + s92);
        t8l = (s8 - s03);
        t9l = (s31 - s53);
        t0m = (s41 + s63);
        a7b = (0.70710678118654757f*(s31 + s53));
        a8b = (0.70710678118654757f*(s41 - s63));
        s15 = (a7b + a8b);
        s25 = (a7b - a8b);
        t1m = (t9k + t5l);
        t2m = (t0l + t6l);
        t3m = (t9k - t5l);
        t4m = (t0l - t6l);
        t5m = (t3l + t9l);
        t6m = (t4l + t0m);
        t7m = (t3l - t9l);
        t8m = (t4l - t0m);
        t9m = (t1m + t5m);
        t0n = (t2m + t6m);
        t1n = (t1m - t5m);
        t2n = (t2m - t6m);
        a9b = (a87 + 32);
        a0c = (a87 + 33);
        a1c = (a87 + 34);
        a2c = (a87 + 35);
        *((a28 + 4)) = ((*(a9b)*t9m) - (*(a0c)*t0n));
        *((a28 + 5)) = ((*(a0c)*t9m) + (*(a9b)*t0n));
        *((a28 + 36)) = ((*(a1c)*t1n) - (*(a2c)*t2n));
        *((a28 + 37)) = ((*(a2c)*t1n) + (*(a1c)*t2n));
        t3n = (t3m - t8m);
        t4n = (t4m + t7m);
        t5n = (t3m + t8m);
        t6n = (t4m - t7m);
        a3c = (a87 + 36);
        a4c = (a87 + 37);
        a5c = (a87 + 38);
        a6c = (a87 + 39);
        *((a28 + 20)) = ((*(a3c)*t3n) - (*(a4c)*t4n));
        *((a28 + 21)) = ((*(a4c)*t3n) + (*(a3c)*t4n));
        *((a28 + 52)) = ((*(a5c)*t5n) - (*(a6c)*t6n));
        *((a28 + 53)) = ((*(a6c)*t5n) + (*(a5c)*t6n));
        t7n = (t1l - t8l);
        t8n = (t2l + t7l);
        t9n = (t1l + t8l);
        t0o = (t2l - t7l);
        t1o = (s94 - s15);
        t2o = (s05 + s25);
        t3o = (s94 + s15);
        t4o = (s05 - s25);
        t5o = (t7n + t1o);
        t6o = (t8n + t2o);
        t7o = (t7n - t1o);
        t8o = (t8n - t2o);
        a7c = (a87 + 40);
        a8c = (a87 + 41);
        a9c = (a87 + 42);
        a0d = (a87 + 43);
        *((a28 + 12)) = ((*(a7c)*t5o) - (*(a8c)*t6o));
        *((a28 + 13)) = ((*(a8c)*t5o) + (*(a7c)*t6o));
        *((a28 + 44)) = ((*(a9c)*t7o) - (*(a0d)*t8o));
        *((a28 + 45)) = ((*(a0d)*t7o) + (*(a9c)*t8o));
        t9o = (t9n - t4o);
        t0p = (t0o + t3o);
        t1p = (t9n + t4o);
        t2p = (t0o - t3o);
        a1d = (a87 + 44);
        a2d = (a87 + 45);
        a3d = (a87 + 46);
        a4d = (a87 + 47);
        *((a28 + 28)) = ((*(a1d)*t9o) - (*(a2d)*t0p));
        *((a28 + 29)) = ((*(a2d)*t9o) + (*(a1d)*t0p));
        *((a28 + 60)) = ((*(a3d)*t1p) - (*(a4d)*t2p));
        *((a28 + 61)) = ((*(a4d)*t1p) + (*(a3d)*t2p));
        t3p = (t51 - s12);
        t4p = (t61 + s22);
        t5p = (t51 + s12);
        t6p = (t61 - s22);
        t7p = (s5 - s72);
        t8p = (s6 + s82);
        a5d = (0.70710678118654757f*(s5 + s72));
        a6d = (0.70710678118654757f*(s6 - s82));
        s35 = (a5d - a6d);
        s45 = (a5d + a6d);
        t9p = (s11 + s33);
        t0q = (s21 - s43);
        t1q = (s11 - s33);
        t2q = (s21 + s43);
        t3q = (s93 - s71);
        t4q = (s81 - s04);
        a7d = (0.70710678118654757f*(s71 + s93));
        a8d = (0.70710678118654757f*(s81 + s04));
        s55 = (a7d - a8d);
        s65 = (a7d + a8d);
        t5q = (t3p + t9p);
        t6q = (t4p + t0q);
        t7q = (t3p - t9p);
        t8q = (t4p - t0q);
        t9q = (t7p + t3q);
        t0r = (t8p + t4q);
        t1r = (t7p - t3q);
        t2r = (t8p - t4q);
        t3r = (t5q + t9q);
        t4r = (t6q + t0r);
        t5r = (t5q - t9q);
        t6r = (t6q - t0r);
        a9d = (a87 + 48);
        a0e = (a87 + 49);
        a1e = (a87 + 50);
        a2e = (a87 + 51);
        *((a28 + 6)) = ((*(a9d)*t3r) - (*(a0e)*t4r));
        *((a28 + 7)) = ((*(a0e)*t3r) + (*(a9d)*t4r));
        *((a28 + 38)) = ((*(a1e)*t5r) - (*(a2e)*t6r));
        *((a28 + 39)) = ((*(a2e)*t5r) + (*(a1e)*t6r));
        t7r = (t7q - t2r);
        t8r = (t8q + t1r);
        t9r = (t7q + t2r);
        t0s = (t8q - t1r);
        a3e = (a87 + 52);
        a4e = (a87 + 53);
        a5e = (a87 + 54);
        a6e = (a87 + 55);
        *((a28 + 22)) = ((*(a3e)*t7r) - (*(a4e)*t8r));
        *((a28 + 23)) = ((*(a4e)*t7r) + (*(a3e)*t8r));
        *((a28 + 54)) = ((*(a5e)*t9r) - (*(a6e)*t0s));
        *((a28 + 55)) = ((*(a6e)*t9r) + (*(a5e)*t0s));
        t1s = (t5p - t2q);
        t2s = (t6p + t1q);
        t3s = (t5p + t2q);
        t4s = (t6p - t1q);
        t5s = (s35 + s55);
        t6s = (s45 - s65);
        t7s = (s35 - s55);
        t8s = (s45 + s65);
        t9s = (t1s + t5s);
        t0t = (t2s + t6s);
        t1t = (t1s - t5s);
        t2t = (t2s - t6s);
        a7e = (a87 + 56);
        a8e = (a87 + 57);
        a9e = (a87 + 58);
        a0f = (a87 + 59);
        *((a28 + 14)) = ((*(a7e)*t9s) - (*(a8e)*t0t));
        *((a28 + 15)) = ((*(a8e)*t9s) + (*(a7e)*t0t));
        *((a28 + 46)) = ((*(a9e)*t1t) - (*(a0f)*t2t));
        *((a28 + 47)) = ((*(a0f)*t1t) + (*(a9e)*t2t));
        t3t = (t3s - t8s);
        t4t = (t4s + t7s);
        t5t = (t3s + t8s);
        t6t = (t4s - t7s);
        a1f = (a87 + 60);
        a2f = (a87 + 61);
        a3f = (a87 + 62);
        a4f = (a87 + 63);
        *((a28 + 30)) = ((*(a1f)*t3t) - (*(a2f)*t4t));
        *((a28 + 31)) = ((*(a2f)*t3t) + (*(a1f)*t4t));
        *((a28 + 62)) = ((*(a3f)*t5t) - (*(a4f)*t6t));
        *((a28 + 63)) = ((*(a4f)*t5t) + (*(a3f)*t6t));
    }}
    {long i2; for(i2 = 0; i2 <= 31; i2++) {
        a5f = (2*i2);
        a6f = (T + a5f);
        a7f = (a6f + 1);
        a8f = (a6f + 1024);
        a9f = (a6f + 1025);
        t7t = (*(a6f) + *(a8f));
        t8t = (*(a7f) + *(a9f));
        t9t = (*(a6f) - *(a8f));
        t0u = (*(a7f) - *(a9f));
        a0g = (a6f + 512);
        a1g = (a6f + 513);
        a2g = (a6f + 1536);
        a3g = (a6f + 1537);
        t1u = (*(a0g) + *(a2g));
        t2u = (*(a1g) + *(a3g));
        t3u = (*(a0g) - *(a2g));
        t4u = (*(a1g) - *(a3g));
        t5u = (t7t + t1u);
        t6u = (t8t + t2u);
        t7u = (t7t - t1u);
        t8u = (t8t - t2u);
        t9u = (t9t - t4u);
        t0v = (t0u + t3u);
        t1v = (t9t + t4u);
        t2v = (t0u - t3u);
        a4g = (a6f + 64);
        a5g = (a6f + 65);
        a6g = (a6f + 1088);
        a7g = (a6f + 1089);
        t3v = (*(a4g) + *(a6g));
        t4v = (*(a5g) + *(a7g));
        t5v = (*(a4g) - *(a6g));
        t6v = (*(a5g) - *(a7g));
        a8g = (a6f + 576);
        a9g = (a6f + 577);
        a0h = (a6f + 1600);
        a1h = (a6f + 1601);
        t7v = (*(a8g) + *(a0h));
        t8v = (*(a9g) + *(a1h));
        t9v = (*(a8g) - *(a0h));
        t0w = (*(a9g) - *(a1h));
        t1w = (t3v + t7v);
        t2w = (t4v + t8v);
        t3w = (t3v - t7v);
        t4w = (t4v - t8v);
        s75 = ((0.92387953251128674f*t3w) - (0.38268343236508978f*t4w));
        s85 = ((0.38268343236508978f*t3w) + (0.92387953251128674f*t4w));
        t5w = (t5v - t0w);
        t6w = (t6v + t9v);
        t7w = (t5v + t0w);
        t8w = (t6v - t9v);
        s95 = ((0.98078528040323043f*t5w) - (0.19509032201612828f*t6w));
        s06 = ((0.19509032201612828f*t5w) + (0.98078528040323043f*t6w));
        s16 = ((0.83146961230254524f*t7w) - (0.55557023301960218f*t8w));
        s26 = ((0.55557023301960218f*t7w) + (0.83146961230254524f*t8w));
        a2h = (a6f + 128);
        a3h = (a6f + 129);
        a4h = (a6f + 1152);
        a5h = (a6f + 1153);
        t9w = (*(a2h) + *(a4h));
        t0x = (*(a3h) + *(a5h));
        t1x = (*(a2h) - *(a4h));
        t2x = (*(a3h) - *(a5h));
        a6h = (a6f + 640);
        a7h = (a6f + 641);
        a8h = (a6f + 1664);
        a9h = (a6f + 1665);
        t3x = (*(a6h) + *(a8h));
        t4x = (*(a7h) + *(a9h));
        t5x = (*(a6h) - *(a8h));
        t6x = (*(a7h) - *(a9h));
        t7x = (t9w + t3x);
        t8x = (t0x + t4x);
        a0i = (0.70710678118654757f*(t9w - t3x));
        a1i = (0.70710678118654757f*(t0x - t4x));
        s36 = (a0i - a1i);
        s46 = (a0i + a1i);
        t9x = (t1x - t6x);
        t0y = (t2x + t5x);
        t1y = (t1x + t6x);
        t2y = (t2x - t5x);
        s56 = ((0.92387953251128674f*t9x) - (0.38268343236508978f*t0y));
        s66 = ((0.38268343236508978f*t9x) + (0.92387953251128674f*t0y));
        s76 = ((0.38268343236508978f*t1y) - (0.92387953251128674f*t2y));
        s86 = ((0.92387953251128674f*t1y) + (0.38268343236508978f*t2y));
        a2i = (a6f + 192);
        a3i = (a6f + 193);
        a4i = (a6f + 1216);
        a5i = (a6f + 1217);
        t3y = (*(a2i) + *(a4i));
        t4y = (*(a3i) + *(a5i));
        t5y = (*(a2i) - *(a4i));
        t6y = (*(a3i) - *(a5i));
        a6i = (a6f + 704);
        a7i = (a6f + 705);
        a8i = (a6f + 1728);
        a9i = (a6f + 1729);
        t7y = (*(a6i) + *(a8i));
        t8y = (*(a7i) + *(a9i));
        t9y = (*(a6i) - *(a8i));
        t0z = (*(a7i) - *(a9i));
        t1z = (t3y + t7y);
        t2z = (t4y + t8y);
        t3z = (t3y - t7y);
        t4z = (t4y - t8y);
        s96 = ((0.38268343236508978f*t3z) - (0.92387953251128674f*t4z));
        s07 = ((0.92387953251128674f*t3z) + (0.38268343236508978f*t4z));
        t5z = (t5y - t0z);
        t6z = (t6y + t9y);
        t7z = (t5y + t0z);
        t8z = (t6y - t9y);
        s17 = ((0.83146961230254524f*t5z) - (0.55557023301960218f*t6z));
        s27 = ((0.55557023301960218f*t5z) + (0.83146961230254524f*t6z));
        s37 = ((0.19509032201612828f*t7z) + (0.98078528040323043f*t8z));
        s47 = ((0.98078528040323043f*t7z) - (0.19509032201612828f*t8z));
        a0j = (a6f + 256);
        a1j = (a6f + 257);
        a2j = (a6f + 1280);
        a3j = (a6f + 1281);
        t9z = (*(a0j) + *(a2j));
        t0A = (*(a1j) + *(a3j));
        t1A = (*(a0j) - *(a2j));
        t2A = (*(a1j) - *(a3j));
        a4j = (a6f + 768);
        a5j = (a6f + 769);
        a6j = (a6f + 1792);
        a7j = (a6f + 1793);
        t3A = (*(a4j) + *(a6j));
        t4A = (*(a5j) + *(a7j));
        t5A = (*(a4j) - *(a6j));
        t6A = (*(a5j) - *(a7j));
        t7A = (t9z + t3A);
        t8A = (t0A + t4A);
        t9A = (t9z - t3A);
        t0B = (t0A - t4A);
        a8j = (0.70710678118654757f*(t1A - t6A));
        a9j = (0.70710678118654757f*(t2A + t5A));
        s57 = (a8j - a9j);
        s67 = (a8j + a9j);
        a0k = (0.70710678118654757f*(t1A + t6A));
        a1k = (0.70710678118654757f*(t2A - t5A));
        s77 = (a0k + a1k);
        s87 = (a0k - a1k);
        a2k = (a6f + 320);
        a3k = (a6f + 321);
        a4k = (a6f + 1344);
        a5k = (a6f + 1345);
        t1B = (*(a2k) + *(a4k));
        t2B = (*(a3k) + *(a5k));
        t3B = (*(a2k) - *(a4k));
        t4B = (*(a3k) - *(a5k));
        a6k = (a6f + 832);
        a7k = (a6f + 833);
        a8k = (a6f + 1856);
        a9k = (a6f + 1857);
        t5B = (*(a6k) + *(a8k));
        t6B = (*(a7k) + *(a9k));
        t7B = (*(a6k) - *(a8k));
        t8B = (*(a7k) - *(a9k));
        t9B = (t1B + t5B);
        t0C = (t2B + t6B);
        t1C = (t1B - t5B);
        t2C = (t2B - t6B);
        s97 = ((0.38268343236508978f*t1C) + (0.92387953251128674f*t2C));
        s08 = ((0.92387953251128674f*t1C) - (0.38268343236508978f*t2C));
        t3C = (t3B - t8B);
        t4C = (t4B + t7B);
        t5C = (t3B + t8B);
        t6C = (t4B - t7B);
        s18 = ((0.55557023301960218f*t3C) - (0.83146961230254524f*t4C));
        s28 = ((0.83146961230254524f*t3C) + (0.55557023301960218f*t4C));
        s38 = ((0.98078528040323043f*t5C) + (0.19509032201612828f*t6C));
        s48 = ((0.19509032201612828f*t5C) - (0.98078528040323043f*t6C));
        a0l = (a6f + 384);
        a1l = (a6f + 385);
        a2l = (a6f + 1408);
        a3l = (a6f + 1409);
        t7C = (*(a0l) + *(a2l));
        t8C = (*(a1l) + *(a3l));
        t9C = (*(a0l) - *(a2l));
        t0D = (*(a1l) - *(a3l));
        a4l = (a6f + 896);
        a5l = (a6f + 897);
        a6l = (a6f + 1920);
        a7l = (a6f + 1921);
        t1D = (*(a4l) + *(a6l));
        t2D = (*(a5l) + *(a7l));
        t3D = (*(a4l) - *(a6l));
        t4D = (*(a5l) - *(a7l));
        t5D = (t7C + t1D);
        t6D = (t8C + t2D);
        a8l = (0.70710678118654757f*(t7C - t1D));
        a9l = (0.70710678118654757f*(t8C - t2D));
        s58 = (a8l + a9l);
        s68 = (a8l - a9l);
        t7D = (t9C - t4D);
        t8D = (t0D + t3D);
        t9D = (t9C + t4D);
        t0E = (t0D - t3D);
        s78 = ((0.38268343236508978f*t7D) - (0.92387953251128674f*t8D));
        s88 = ((0.92387953251128674f*t7D) + (0.38268343236508978f*t8D));
        s98 = ((0.38268343236508978f*t0E) - (0.92387953251128674f*t9D));
        s09 = ((0.38268343236508978f*t9D) + (0.92387953251128674f*t0E));
        a0m = (a6f + 448);
        a1m = (a6f + 449);
        a2m = (a6f + 1472);
        a3m = (a6f + 1473);
        t1E = (*(a0m) + *(a2m));
        t2E = (*(a1m) + *(a3m));
        t3E = (*(a0m) - *(a2m));
        t4E = (*(a1m) - *(a3m));
        a4m = (a6f + 960);
        a5m = (a6f + 961);
        a6m = (a6f + 1984);
        a7m = (a6f + 1985);
        t5E = (*(a4m) + *(a6m));
        t6E = (*(a5m) + *(a7m));
        t7E = (*(a4m) - *(a6m));
        t8E = (*(a5m) - *(a7m));
        t9E = (t1E + t5E);
        t0F = (t2E + t6E);
        t1F = (t1E - t5E);
        t2F = (t2E - t6E);
        s19 = ((0.92387953251128674f*t1F) + (0.38268343236508978f*t2F));
        s29 = ((0.38268343236508978f*t1F) - (0.92387953251128674f*t2F));
        t3F = (t3E - t8E);
        t4F = (t4E + t7E);
        t5F = (t3E + t8E);
        t6F = (t4E - t7E);
        s39 = ((0.19509032201612828f*t3F) - (0.98078528040323043f*t4F));
        s49 = ((0.98078528040323043f*t3F) + (0.19509032201612828f*t4F));
        s59 = ((0.83146961230254524f*t6F) - (0.55557023301960218f*t5F));
        s69 = ((0.83146961230254524f*t5F) + (0.55557023301960218f*t6F));
        t7F = (t5u + t7A);
        t8F = (t6u + t8A);
        t9F = (t5u - t7A);
        t0G = (t6u - t8A);
        t1G = (t1w + t9B);
        t2G = (t2w + t0C);
        a8m = (0.70710678118654757f*(t1w - t9B));
        a9m = (0.70710678118654757f*(t2w - t0C));
        s79 = (a8m - a9m);
        s89 = (a8m + a9m);
        t3G = (t7x + t5D);
        t4G = (t8x + t6D);
        t5G = (t7x - t5D);
        t6G = (t8x - t6D);
        t7G = (t1z + t9E);
        t8G = (t2z + t0F);
        a0n = (0.70710678118654757f*(t1z - t9E));
        a1n = (0.70710678118654757f*(t2z - t0F));
        s99 = (a0n + a1n);
        s0a = (a0n - a1n);
        t9G = (t7F + t3G);
        t0H = (t8F + t4G);
        t1H = (t7F - t3G);
        t2H = (t8F - t4G);
        t3H = (t1G + t7G);
        t4H = (t2G + t8G);
        t5H = (t1G - t7G);
        t6H = (t2G - t8G);
        a2n = (dst + a5f);
        *(a2n) = (t9G + t3H);
        *((a2n + 1)) = (t0H + t4H);
        *((a2n + 1024)) = (t9G - t3H);
        *((a2n + 1025)) = (t0H - t4H);
        *((a2n + 512)) = (t1H - t6H);
        *((a2n + 513)) = (t2H + t5H);
        *((a2n + 1536)) = (t1H + t6H);
        *((a2n + 1537)) = (t2H - t5H);
        t7H = (t9F - t6G);
        t8H = (t0G + t5G);
        t9H = (t9F + t6G);
        t0I = (t0G - t5G);
        t1I = (s79 - s99);
        t2I = (s89 + s0a);
        t3I = (s79 + s99);
        t4I = (s89 - s0a);
        *((a2n + 256)) = (t7H + t1I);
        *((a2n + 257)) = (t8H + t2I);
        *((a2n + 1280)) = (t7H - t1I);
        *((a2n + 1281)) = (t8H - t2I);
        *((a2n + 768)) = (t9H - t4I);
        *((a2n + 769)) = (t0I + t3I);
        *((a2n + 1792)) = (t9H + t4I);
        *((a2n + 1793)) = (t0I - t3I);
        t5I = (t9u + s57);
        t6I = (t0v + s67);
        t7I = (t9u - s57);
        t8I = (t0v - s67);
        t9I = (s95 + s18);
        t0J = (s06 + s28);
        a3n = (0.70710678118654757f*(s95 - s18));
        a4n = (0.70710678118654757f*(s06 - s28));
        s1a = (a3n - a4n);
        s2a = (a3n + a4n);
        t1J = (s56 + s78);
        t2J = (s66 + s88);
        t3J = (s56 - s78);
        t4J = (s66 - s88);
        t5J = (s17 + s39);
        t6J = (s27 + s49);
        a5n = (0.70710678118654757f*(s17 - s39));
        a6n = (0.70710678118654757f*(s27 - s49));
        s3a = (a5n + a6n);
        s4a = (a5n - a6n);
        t7J = (t5I + t1J);
        t8J = (t6I + t2J);
        t9J = (t5I - t1J);
        t0K = (t6I - t2J);
        t1K = (t9I + t5J);
        t2K = (t0J + t6J);
        t3K = (t9I - t5J);
        t4K = (t0J - t6J);
        *((a2n + 64)) = (t7J + t1K);
        *((a2n + 65)) = (t8J + t2K);
        *((a2n + 1088)) = (t7J - t1K);
        *((a2n + 1089)) = (t8J - t2K);
        *((a2n + 576)) = (t9J - t4K);
        *((a2n + 577)) = (t0K + t3K);
        *((a2n + 1600)) = (t9J + t4K);
        *((a2n + 1601)) = (t0K - t3K);
        t5K = (t7I - t4J);
        t6K = (t8I + t3J);
        t7K = (t7I + t4J);
        t8K = (t8I - t3J);
        t9K = (s1a - s3a);
        t0L = (s2a + s4a);
        t1L = (s1a + s3a);
        t2L = (s2a - s4a);
        *((a2n + 320)) = (t5K + t9K);
        *((a2n + 321)) = (t6K + t0L);
        *((a2n + 1344)) = (t5K - t9K);
        *((a2n + 1345)) = (t6K - t0L);
        *((a2n + 832)) = (t7K - t2L);
        *((a2n + 833)) = (t8K + t1L);
        *((a2n + 1856)) = (t7K + t2L);
        *((a2n + 1857)) = (t8K - t1L);
        t3L = (t7u - t0B);
        t4L = (t8u + t9A);
        t5L = (t7u + t0B);
        t6L = (t8u - t9A);
        t7L = (s75 - s97);
        t8L = (s85 + s08);
        a7n = (0.70710678118654757f*(s75 + s97));
        a8n = (0.70710678118654757f*(s85 - s08));
        s5a = (a7n - a8n);
        s6a = (a7n + a8n);
        t9L = (s36 - s58);
        t0M = (s46 + s68);
        t1M = (s36 + s58);
        t2M = (s46 - s68);
        t3M = (s96 - s19);
        t4M = (s07 + s29);
        a9n = (0.70710678118654757f*(s96 + s19));
        a0o = (0.70710678118654757f*(s07 - s29));
        s7a = (a9n + a0o);
        s8a = (a9n - a0o);
        t5M = (t3L + t9L);
        t6M = (t4L + t0M);
        t7M = (t3L - t9L);
        t8M = (t4L - t0M);
        t9M = (t7L + t3M);
        t0N = (t8L + t4M);
        t1N = (t7L - t3M);
        t2N = (t8L - t4M);
        *((a2n + 128)) = (t5M + t9M);
        *((a2n + 129)) = (t6M + t0N);
        *((a2n + 1152)) = (t5M - t9M);
        *((a2n + 1153)) = (t6M - t0N);
        *((a2n + 640)) = (t7M - t2N);
        *((a2n + 641)) = (t8M + t1N);
        *((a2n + 1664)) = (t7M + t2N);
        *((a2n + 1665)) = (t8M - t1N);
        t3N = (t5L - t2M);
        t4N = (t6L + t1M);
        t5N = (t5L + t2M);
        t6N = (t6L - t1M);
        t7N = (s5a - s7a);
        t8N = (s6a + s8a);
        t9N = (s5a + s7a);
        t0O = (s6a - s8a);
        *((a2n + 384)) = (t3N + t7N);
        *((a2n + 385)) = (t4N + t8N);
        *((a2n + 1408)) = (t3N - t7N);
        *((a2n + 1409)) = (t4N - t8N);
        *((a2n + 896)) = (t5N - t0O);
        *((a2n + 897)) = (t6N + t9N);
        *((a2n + 1920)) = (t5N + t0O);
        *((a2n + 1921)) = (t6N - t9N);
        t1O = (t1v - s77);
        t2O = (t2v + s87);
        t3O = (t1v + s77);
        t4O = (t2v - s87);
        t5O = (s16 - s38);
        t6O = (s26 + s48);
        a1o = (0.70710678118654757f*(s16 + s38));
        a2o = (0.70710678118654757f*(s26 - s48));
        s9a = (a1o - a2o);
        s0b = (a1o + a2o);
        t7O = (s76 + s98);
        t8O = (s86 - s09);
        t9O = (s76 - s98);
        t0P = (s86 + s09);
        t1P = (s59 - s37);
        t2P = (s47 - s69);
        a3o = (0.70710678118654757f*(s37 + s59));
        a4o = (0.70710678118654757f*(s47 + s69));
        s1b = (a3o - a4o);
        s2b = (a3o + a4o);
        t3P = (t1O + t7O);
        t4P = (t2O + t8O);
        t5P = (t1O - t7O);
        t6P = (t2O - t8O);
        t7P = (t5O + t1P);
        t8P = (t6O + t2P);
        t9P = (t5O - t1P);
        t0Q = (t6O - t2P);
        *((a2n + 192)) = (t3P + t7P);
        *((a2n + 193)) = (t4P + t8P);
        *((a2n + 1216)) = (t3P - t7P);
        *((a2n + 1217)) = (t4P - t8P);
        *((a2n + 704)) = (t5P - t0Q);
        *((a2n + 705)) = (t6P + t9P);
        *((a2n + 1728)) = (t5P + t0Q);
        *((a2n + 1729)) = (t6P - t9P);
        t1Q = (t3O - t0P);
        t2Q = (t4O + t9O);
        t3Q = (t3O + t0P);
        t4Q = (t4O - t9O);
        t5Q = (s9a + s1b);
        t6Q = (s0b - s2b);
        t7Q = (s9a - s1b);
        t8Q = (s0b + s2b);
        *((a2n + 448)) = (t1Q + t5Q);
        *((a2n + 449)) = (t2Q + t6Q);
        *((a2n + 1472)) = (t1Q - t5Q);
        *((a2n + 1473)) = (t2Q - t6Q);
        *((a2n + 960)) = (t3Q - t8Q);
        *((a2n + 961)) = (t4Q + t7Q);
        *((a2n + 1984)) = (t3Q + t8Q);
        *((a2n + 1985)) = (t4Q - t7Q);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_float_2048)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[4096];
     float T2[256];
    float  *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a15, *a16, *a17, *a18, *a19, *a1a, *a1b, *a1c, *a1f, *a24, *a25
            , *a26, *a27, *a28, *a29, *a2a, *a2b, *a2c, *a2f, *a34, *a35, *a36, *a37, *a38, *a39, *a3a, *a3b, *a3c, *a3d, *a44, *a45, *a46, *a47
            , *a4a, *a4c, *a4d, *a54, *a55, *a56, *a5a, *a5b, *a5c, *a5d, *a5e, *a5f, *a64, *a65, *a66, *a67, *a68, *a6a, *a6b, *a6c, *a6d, *a6e
            , *a74, *a75, *a76, *a77, *a78, *a79, *a7a, *a7b, *a7c, *a7d, *a7e, *a84, *a85, *a86, *a87, *a88, *a89, *a8a, *a8b, *a8c, *a8d, *a8e
            , *a94, *a95, *a96, *a97, *a98, *a99, *a9a, *a9b, *a9c, *a9d, *a9e;
    const float  *a01, *a02, *a11, *a12, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53, *a6, *a61
            , *a62, *a63, *a7, *a71, *a72, *a73, *a8, *a83, *a9, *a93;
    int a, a4b, a57, a69;
    float a03, a04, a13, a14, a1d, a1e, a2d, a2e, a3e, a3f, a48, a49, a4e, a4f, a58, a59, a81, a82, a91, a92, s, s01
            , s02, s03, s11, s12, s13, s2, s21, s22, s23, s3, s31, s32, s33, s4, s41, s42, s43, s5, s51, s52, s53, s6
            , s61, s62, s63, s7, s71, s72, s8, s81, s82, s9, s91, s92, t, t01, t02, t03, t04, t05, t06, t07, t08, t09
            , t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o, t0p, t11, t12, t13, t14, t15, t16
            , t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t2, t21, t22
            , t23, t24, t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o
            , t2p, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k
            , t3l, t3m, t3n, t3o, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h
            , t4i, t4j, t4k, t4l, t4m, t4n, t4o, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e
            , t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a, t6b
            , t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t7, t71, t72, t73, t74, t75, t76, t77, t78
            , t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m, t7n, t7o, t8, t81, t82, t83, t84, t85
            , t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t9, t91, t92
            , t93, t94, t95, t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o;
    {long i; for(i = 0; i <= 15; i++) {
        {long i2; for(i2 = 0; i2 <= 7; i2++) {
            a = (32*i2);
            a2 = (src + (2*i) + a);
            a3 = (a2 + 1);
            a4 = (a2 + 2048);
            a5 = (a2 + 2049);
            t = (*(a2) + *(a4));
            t2 = (*(a3) + *(a5));
            t3 = (*(a2) - *(a4));
            t4 = (*(a3) - *(a5));
            a6 = (a2 + 1024);
            a7 = (a2 + 1025);
            a8 = (a2 + 3072);
            a9 = (a2 + 3073);
            t5 = (*(a6) + *(a8));
            t6 = (*(a7) + *(a9));
            t7 = (*(a6) - *(a8));
            t8 = (*(a7) - *(a9));
            t9 = (t + t5);
            t01 = (t2 + t6);
            t11 = (t - t5);
            t21 = (t2 - t6);
            t31 = (t3 - t8);
            t41 = (t4 + t7);
            t51 = (t3 + t8);
            t61 = (t4 - t7);
            a01 = (a2 + 256);
            a11 = (a2 + 257);
            a21 = (a2 + 2304);
            a31 = (a2 + 2305);
            t71 = (*(a01) + *(a21));
            t81 = (*(a11) + *(a31));
            t91 = (*(a01) - *(a21));
            t02 = (*(a11) - *(a31));
            a41 = (a2 + 1280);
            a51 = (a2 + 1281);
            a61 = (a2 + 3328);
            a71 = (a2 + 3329);
            t12 = (*(a41) + *(a61));
            t22 = (*(a51) + *(a71));
            t32 = (*(a41) - *(a61));
            t42 = (*(a51) - *(a71));
            t52 = (t71 + t12);
            t62 = (t81 + t22);
            a81 = (0.70710678118654757f*(t71 - t12));
            a91 = (0.70710678118654757f*(t81 - t22));
            s = (a81 - a91);
            s2 = (a81 + a91);
            t72 = (t91 - t42);
            t82 = (t02 + t32);
            t92 = (t91 + t42);
            t03 = (t02 - t32);
            s3 = ((0.92387953251128674f*t72) - (0.38268343236508978f*t82));
            s4 = ((0.38268343236508978f*t72) + (0.92387953251128674f*t82));
            s5 = ((0.38268343236508978f*t92) - (0.92387953251128674f*t03));
            s6 = ((0.92387953251128674f*t92) + (0.38268343236508978f*t03));
            a02 = (a2 + 512);
            a12 = (a2 + 513);
            a22 = (a2 + 2560);
            a32 = (a2 + 2561);
            t13 = (*(a02) + *(a22));
            t23 = (*(a12) + *(a32));
            t33 = (*(a02) - *(a22));
            t43 = (*(a12) - *(a32));
            a42 = (a2 + 1536);
            a52 = (a2 + 1537);
            a62 = (a2 + 3584);
            a72 = (a2 + 3585);
            t53 = (*(a42) + *(a62));
            t63 = (*(a52) + *(a72));
            t73 = (*(a42) - *(a62));
            t83 = (*(a52) - *(a72));
            t93 = (t13 + t53);
            t04 = (t23 + t63);
            t14 = (t13 - t53);
            t24 = (t23 - t63);
            a82 = (0.70710678118654757f*(t33 - t83));
            a92 = (0.70710678118654757f*(t43 + t73));
            s7 = (a82 - a92);
            s8 = (a82 + a92);
            a03 = (0.70710678118654757f*(t33 + t83));
            a13 = (0.70710678118654757f*(t43 - t73));
            s9 = (a03 + a13);
            s01 = (a03 - a13);
            a23 = (a2 + 768);
            a33 = (a2 + 769);
            a43 = (a2 + 2816);
            a53 = (a2 + 2817);
            t34 = (*(a23) + *(a43));
            t44 = (*(a33) + *(a53));
            t54 = (*(a23) - *(a43));
            t64 = (*(a33) - *(a53));
            a63 = (a2 + 1792);
            a73 = (a2 + 1793);
            a83 = (a2 + 3840);
            a93 = (a2 + 3841);
            t74 = (*(a63) + *(a83));
            t84 = (*(a73) + *(a93));
            t94 = (*(a63) - *(a83));
            t05 = (*(a73) - *(a93));
            t15 = (t34 + t74);
            t25 = (t44 + t84);
            a04 = (0.70710678118654757f*(t34 - t74));
            a14 = (0.70710678118654757f*(t44 - t84));
            s11 = (a04 + a14);
            s21 = (a04 - a14);
            t35 = (t54 - t05);
            t45 = (t64 + t94);
            t55 = (t54 + t05);
            t65 = (t64 - t94);
            s31 = ((0.38268343236508978f*t35) - (0.92387953251128674f*t45));
            s41 = ((0.92387953251128674f*t35) + (0.38268343236508978f*t45));
            s51 = ((0.38268343236508978f*t65) - (0.92387953251128674f*t55));
            s61 = ((0.38268343236508978f*t55) + (0.92387953251128674f*t65));
            t75 = (t9 + t93);
            t85 = (t01 + t04);
            t95 = (t9 - t93);
            t06 = (t01 - t04);
            t16 = (t52 + t15);
            t26 = (t62 + t25);
            t36 = (t52 - t15);
            t46 = (t62 - t25);
            t56 = (t75 + t16);
            t66 = (t85 + t26);
            t76 = (t75 - t16);
            t86 = (t85 - t26);
            a24 = (D268 + a);
            a34 = (a24 + 1);
            a44 = (a24 + 2);
            a54 = (a24 + 3);
            a64 = (T2 + a);
            *(a64) = ((*(a24)*t56) - (*(a34)*t66));
            *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
            *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
            *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
            t96 = (t95 - t46);
            t07 = (t06 + t36);
            t17 = (t95 + t46);
            t27 = (t06 - t36);
            a74 = (a24 + 4);
            a84 = (a24 + 5);
            a94 = (a24 + 6);
            a05 = (a24 + 7);
            *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
            *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
            *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
            *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
            t37 = (t31 + s7);
            t47 = (t41 + s8);
            t57 = (t31 - s7);
            t67 = (t41 - s8);
            t77 = (s3 + s31);
            t87 = (s4 + s41);
            t97 = (s3 - s31);
            t08 = (s4 - s41);
            t18 = (t37 + t77);
            t28 = (t47 + t87);
            t38 = (t37 - t77);
            t48 = (t47 - t87);
            a15 = (a24 + 8);
            a25 = (a24 + 9);
            a35 = (a24 + 10);
            a45 = (a24 + 11);
            *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
            *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
            *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
            *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
            t58 = (t57 - t08);
            t68 = (t67 + t97);
            t78 = (t57 + t08);
            t88 = (t67 - t97);
            a55 = (a24 + 12);
            a65 = (a24 + 13);
            a75 = (a24 + 14);
            a85 = (a24 + 15);
            *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
            *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
            *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
            *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
            t98 = (t11 - t24);
            t09 = (t21 + t14);
            t19 = (t11 + t24);
            t29 = (t21 - t14);
            t39 = (s - s11);
            t49 = (s2 + s21);
            t59 = (s + s11);
            t69 = (s2 - s21);
            t79 = (t98 + t39);
            t89 = (t09 + t49);
            t99 = (t98 - t39);
            t0a = (t09 - t49);
            a95 = (a24 + 16);
            a06 = (a24 + 17);
            a16 = (a24 + 18);
            a26 = (a24 + 19);
            *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
            *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
            *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
            *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
            t1a = (t19 - t69);
            t2a = (t29 + t59);
            t3a = (t19 + t69);
            t4a = (t29 - t59);
            a36 = (a24 + 20);
            a46 = (a24 + 21);
            a56 = (a24 + 22);
            a66 = (a24 + 23);
            *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
            *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
            *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
            *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
            t5a = (t51 - s9);
            t6a = (t61 + s01);
            t7a = (t51 + s9);
            t8a = (t61 - s01);
            t9a = (s5 + s51);
            t0b = (s6 - s61);
            t1b = (s5 - s51);
            t2b = (s6 + s61);
            t3b = (t5a + t9a);
            t4b = (t6a + t0b);
            t5b = (t5a - t9a);
            t6b = (t6a - t0b);
            a76 = (a24 + 24);
            a86 = (a24 + 25);
            a96 = (a24 + 26);
            a07 = (a24 + 27);
            *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
            *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
            *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
            *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
            t7b = (t7a - t2b);
            t8b = (t8a + t1b);
            t9b = (t7a + t2b);
            t0c = (t8a - t1b);
            a17 = (a24 + 28);
            a27 = (a24 + 29);
            a37 = (a24 + 30);
            a47 = (a24 + 31);
            *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
            *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
            *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
            *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
        }}
        {long i3; for(i3 = 0; i3 <= 15; i3++) {
            a57 = (2*i3);
            a67 = (T2 + a57);
            a77 = (a67 + 1);
            a87 = (a67 + 128);
            a97 = (a67 + 129);
            t1c = (*(a67) + *(a87));
            t2c = (*(a77) + *(a97));
            t3c = (*(a67) - *(a87));
            t4c = (*(a77) - *(a97));
            a08 = (a67 + 32);
            a18 = (a67 + 33);
            a28 = (a67 + 160);
            a38 = (a67 + 161);
            t5c = (*(a08) + *(a28));
            t6c = (*(a18) + *(a38));
            a48 = (0.70710678118654757f*(*(a08) - *(a28)));
            a58 = (0.70710678118654757f*(*(a18) - *(a38)));
            s71 = (a48 - a58);
            s81 = (a48 + a58);
            a68 = (a67 + 64);
            a78 = (a67 + 65);
            a88 = (a67 + 192);
            a98 = (a67 + 193);
            t7c = (*(a68) + *(a88));
            t8c = (*(a78) + *(a98));
            t9c = (*(a68) - *(a88));
            t0d = (*(a78) - *(a98));
            a09 = (a67 + 96);
            a19 = (a67 + 97);
            a29 = (a67 + 224);
            a39 = (a67 + 225);
            t1d = (*(a09) + *(a29));
            t2d = (*(a19) + *(a39));
            a49 = (0.70710678118654757f*(*(a09) - *(a29)));
            a59 = (0.70710678118654757f*(*(a19) - *(a39)));
            s91 = (a49 + a59);
            s02 = (a49 - a59);
            t3d = (t1c + t7c);
            t4d = (t2c + t8c);
            t5d = (t1c - t7c);
            t6d = (t2c - t8c);
            t7d = (t5c + t1d);
            t8d = (t6c + t2d);
            t9d = (t5c - t1d);
            t0e = (t6c - t2d);
            t1e = (t3d + t7d);
            t2e = (t4d + t8d);
            t3e = (t3d - t7d);
            t4e = (t4d - t8d);
            a69 = (256*i);
            a79 = (D272 + a69 + (16*i3));
            a89 = (a79 + 1);
            a99 = (a79 + 2);
            a0a = (a79 + 3);
            a1a = (T + a69 + a57);
            *(a1a) = ((*(a79)*t1e) - (*(a89)*t2e));
            *((a1a + 1)) = ((*(a89)*t1e) + (*(a79)*t2e));
            *((a1a + 128)) = ((*(a99)*t3e) - (*(a0a)*t4e));
            *((a1a + 129)) = ((*(a0a)*t3e) + (*(a99)*t4e));
            t5e = (t5d - t0e);
            t6e = (t6d + t9d);
            t7e = (t5d + t0e);
            t8e = (t6d - t9d);
            a2a = (a79 + 4);
            a3a = (a79 + 5);
            a4a = (a79 + 6);
            a5a = (a79 + 7);
            *((a1a + 64)) = ((*(a2a)*t5e) - (*(a3a)*t6e));
            *((a1a + 65)) = ((*(a3a)*t5e) + (*(a2a)*t6e));
            *((a1a + 192)) = ((*(a4a)*t7e) - (*(a5a)*t8e));
            *((a1a + 193)) = ((*(a5a)*t7e) + (*(a4a)*t8e));
            t9e = (t3c - t0d);
            t0f = (t4c + t9c);
            t1f = (t3c + t0d);
            t2f = (t4c - t9c);
            t3f = (s71 - s91);
            t4f = (s81 + s02);
            t5f = (s71 + s91);
            t6f = (s81 - s02);
            t7f = (t9e + t3f);
            t8f = (t0f + t4f);
            t9f = (t9e - t3f);
            t0g = (t0f - t4f);
            a6a = (a79 + 8);
            a7a = (a79 + 9);
            a8a = (a79 + 10);
            a9a = (a79 + 11);
            *((a1a + 32)) = ((*(a6a)*t7f) - (*(a7a)*t8f));
            *((a1a + 33)) = ((*(a7a)*t7f) + (*(a6a)*t8f));
            *((a1a + 160)) = ((*(a8a)*t9f) - (*(a9a)*t0g));
            *((a1a + 161)) = ((*(a9a)*t9f) + (*(a8a)*t0g));
            t1g = (t1f - t6f);
            t2g = (t2f + t5f);
            t3g = (t1f + t6f);
            t4g = (t2f - t5f);
            a0b = (a79 + 12);
            a1b = (a79 + 13);
            a2b = (a79 + 14);
            a3b = (a79 + 15);
            *((a1a + 96)) = ((*(a0b)*t1g) - (*(a1b)*t2g));
            *((a1a + 97)) = ((*(a1b)*t1g) + (*(a0b)*t2g));
            *((a1a + 224)) = ((*(a2b)*t3g) - (*(a3b)*t4g));
            *((a1a + 225)) = ((*(a3b)*t3g) + (*(a2b)*t4g));
        }}
    }}
    {long i4; for(i4 = 0; i4 <= 127; i4++) {
        a4b = (2*i4);
        a5b = (T + a4b);
        a6b = (a5b + 1);
        a7b = (a5b + 2048);
        a8b = (a5b + 2049);
        t5g = (*(a5b) + *(a7b));
        t6g = (*(a6b) + *(a8b));
        t7g = (*(a5b) - *(a7b));
        t8g = (*(a6b) - *(a8b));
        a9b = (a5b + 1024);
        a0c = (a5b + 1025);
        a1c = (a5b + 3072);
        a2c = (a5b + 3073);
        t9g = (*(a9b) + *(a1c));
        t0h = (*(a0c) + *(a2c));
        t1h = (*(a9b) - *(a1c));
        t2h = (*(a0c) - *(a2c));
        t3h = (t5g + t9g);
        t4h = (t6g + t0h);
        t5h = (t5g - t9g);
        t6h = (t6g - t0h);
        t7h = (t7g - t2h);
        t8h = (t8g + t1h);
        t9h = (t7g + t2h);
        t0i = (t8g - t1h);
        a3c = (a5b + 256);
        a4c = (a5b + 257);
        a5c = (a5b + 2304);
        a6c = (a5b + 2305);
        t1i = (*(a3c) + *(a5c));
        t2i = (*(a4c) + *(a6c));
        t3i = (*(a3c) - *(a5c));
        t4i = (*(a4c) - *(a6c));
        a7c = (a5b + 1280);
        a8c = (a5b + 1281);
        a9c = (a5b + 3328);
        a0d = (a5b + 3329);
        t5i = (*(a7c) + *(a9c));
        t6i = (*(a8c) + *(a0d));
        t7i = (*(a7c) - *(a9c));
        t8i = (*(a8c) - *(a0d));
        t9i = (t1i + t5i);
        t0j = (t2i + t6i);
        a1d = (0.70710678118654757f*(t1i - t5i));
        a2d = (0.70710678118654757f*(t2i - t6i));
        s12 = (a1d - a2d);
        s22 = (a1d + a2d);
        t1j = (t3i - t8i);
        t2j = (t4i + t7i);
        t3j = (t3i + t8i);
        t4j = (t4i - t7i);
        s32 = ((0.92387953251128674f*t1j) - (0.38268343236508978f*t2j));
        s42 = ((0.38268343236508978f*t1j) + (0.92387953251128674f*t2j));
        s52 = ((0.38268343236508978f*t3j) - (0.92387953251128674f*t4j));
        s62 = ((0.92387953251128674f*t3j) + (0.38268343236508978f*t4j));
        a3d = (a5b + 512);
        a4d = (a5b + 513);
        a5d = (a5b + 2560);
        a6d = (a5b + 2561);
        t5j = (*(a3d) + *(a5d));
        t6j = (*(a4d) + *(a6d));
        t7j = (*(a3d) - *(a5d));
        t8j = (*(a4d) - *(a6d));
        a7d = (a5b + 1536);
        a8d = (a5b + 1537);
        a9d = (a5b + 3584);
        a0e = (a5b + 3585);
        t9j = (*(a7d) + *(a9d));
        t0k = (*(a8d) + *(a0e));
        t1k = (*(a7d) - *(a9d));
        t2k = (*(a8d) - *(a0e));
        t3k = (t5j + t9j);
        t4k = (t6j + t0k);
        t5k = (t5j - t9j);
        t6k = (t6j - t0k);
        a1e = (0.70710678118654757f*(t7j - t2k));
        a2e = (0.70710678118654757f*(t8j + t1k));
        s72 = (a1e - a2e);
        s82 = (a1e + a2e);
        a3e = (0.70710678118654757f*(t7j + t2k));
        a4e = (0.70710678118654757f*(t8j - t1k));
        s92 = (a3e + a4e);
        s03 = (a3e - a4e);
        a5e = (a5b + 768);
        a6e = (a5b + 769);
        a7e = (a5b + 2816);
        a8e = (a5b + 2817);
        t7k = (*(a5e) + *(a7e));
        t8k = (*(a6e) + *(a8e));
        t9k = (*(a5e) - *(a7e));
        t0l = (*(a6e) - *(a8e));
        a9e = (a5b + 1792);
        a0f = (a5b + 1793);
        a1f = (a5b + 3840);
        a2f = (a5b + 3841);
        t1l = (*(a9e) + *(a1f));
        t2l = (*(a0f) + *(a2f));
        t3l = (*(a9e) - *(a1f));
        t4l = (*(a0f) - *(a2f));
        t5l = (t7k + t1l);
        t6l = (t8k + t2l);
        a3f = (0.70710678118654757f*(t7k - t1l));
        a4f = (0.70710678118654757f*(t8k - t2l));
        s13 = (a3f + a4f);
        s23 = (a3f - a4f);
        t7l = (t9k - t4l);
        t8l = (t0l + t3l);
        t9l = (t9k + t4l);
        t0m = (t0l - t3l);
        s33 = ((0.38268343236508978f*t7l) - (0.92387953251128674f*t8l));
        s43 = ((0.92387953251128674f*t7l) + (0.38268343236508978f*t8l));
        s53 = ((0.38268343236508978f*t0m) - (0.92387953251128674f*t9l));
        s63 = ((0.38268343236508978f*t9l) + (0.92387953251128674f*t0m));
        t1m = (t3h + t3k);
        t2m = (t4h + t4k);
        t3m = (t3h - t3k);
        t4m = (t4h - t4k);
        t5m = (t9i + t5l);
        t6m = (t0j + t6l);
        t7m = (t9i - t5l);
        t8m = (t0j - t6l);
        a5f = (dst + a4b);
        *(a5f) = (t1m + t5m);
        *((a5f + 1)) = (t2m + t6m);
        *((a5f + 2048)) = (t1m - t5m);
        *((a5f + 2049)) = (t2m - t6m);
        *((a5f + 1024)) = (t3m - t8m);
        *((a5f + 1025)) = (t4m + t7m);
        *((a5f + 3072)) = (t3m + t8m);
        *((a5f + 3073)) = (t4m - t7m);
        t9m = (t7h + s72);
        t0n = (t8h + s82);
        t1n = (t7h - s72);
        t2n = (t8h - s82);
        t3n = (s32 + s33);
        t4n = (s42 + s43);
        t5n = (s32 - s33);
        t6n = (s42 - s43);
        *((a5f + 256)) = (t9m + t3n);
        *((a5f + 257)) = (t0n + t4n);
        *((a5f + 2304)) = (t9m - t3n);
        *((a5f + 2305)) = (t0n - t4n);
        *((a5f + 1280)) = (t1n - t6n);
        *((a5f + 1281)) = (t2n + t5n);
        *((a5f + 3328)) = (t1n + t6n);
        *((a5f + 3329)) = (t2n - t5n);
        t7n = (t5h - t6k);
        t8n = (t6h + t5k);
        t9n = (t5h + t6k);
        t0o = (t6h - t5k);
        t1o = (s12 - s13);
        t2o = (s22 + s23);
        t3o = (s12 + s13);
        t4o = (s22 - s23);
        *((a5f + 512)) = (t7n + t1o);
        *((a5f + 513)) = (t8n + t2o);
        *((a5f + 2560)) = (t7n - t1o);
        *((a5f + 2561)) = (t8n - t2o);
        *((a5f + 1536)) = (t9n - t4o);
        *((a5f + 1537)) = (t0o + t3o);
        *((a5f + 3584)) = (t9n + t4o);
        *((a5f + 3585)) = (t0o - t3o);
        t5o = (t9h - s92);
        t6o = (t0i + s03);
        t7o = (t9h + s92);
        t8o = (t0i - s03);
        t9o = (s52 + s53);
        t0p = (s62 - s63);
        t1p = (s52 - s53);
        t2p = (s62 + s63);
        *((a5f + 768)) = (t5o + t9o);
        *((a5f + 769)) = (t6o + t0p);
        *((a5f + 2816)) = (t5o - t9o);
        *((a5f + 2817)) = (t6o - t0p);
        *((a5f + 1792)) = (t7o - t2p);
        *((a5f + 1793)) = (t8o + t1p);
        *((a5f + 3840)) = (t7o + t2p);
        *((a5f + 3841)) = (t8o - t1p);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_float_4096)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[8192];
     float T2[256];
    float  *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a0c, *a0d, *a0f, *a0h, *a0i, *a15, *a16, *a17, *a18, *a19, *a1a, *a1b, *a1c, *a1d, *a1e
            , *a1f, *a1g, *a1h, *a1i, *a1j, *a24, *a25, *a26, *a27, *a28, *a29, *a2a, *a2b, *a2c, *a2d, *a2e, *a2f, *a2g, *a2h, *a2i, *a34, *a35
            , *a36, *a37, *a38, *a39, *a3a, *a3b, *a3c, *a3d, *a3e, *a3f, *a3g, *a3h, *a3i, *a44, *a45, *a46, *a47, *a4a, *a4c, *a4d, *a4e, *a4f
            , *a4g, *a4h, *a4i, *a54, *a55, *a56, *a5a, *a5b, *a5c, *a5d, *a5e, *a5f, *a5g, *a5h, *a5i, *a64, *a65, *a66, *a67, *a68, *a6a, *a6b
            , *a6c, *a6d, *a6e, *a6f, *a6g, *a6h, *a6i, *a74, *a75, *a76, *a77, *a78, *a79, *a7a, *a7b, *a7c, *a7d, *a7e, *a7g, *a84, *a85, *a86
            , *a87, *a88, *a89, *a8a, *a8b, *a8c, *a8d, *a8e, *a8g, *a94, *a95, *a96, *a97, *a98, *a99, *a9a, *a9b, *a9c, *a9e, *a9g, *a9h;
    const float  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a4b, a57, a69;
    float a03, a04, a0e, a0g, a0j, a0k, a1k, a2j, a2k, a3j, a3k, a48, a49, a4j, a58, a59, a5j, a6j, a71, a72, a7f, a7h
            , a7i, a7j, a81, a82, a8f, a8h, a8i, a8j, a92, a93, a9d, a9f, a9i, a9j, s, s01, s02, s03, s04, s05, s06, s07
            , s11, s12, s13, s14, s15, s16, s17, s2, s21, s22, s23, s24, s25, s26, s27, s3, s31, s32, s33, s34, s35, s36
            , s37, s4, s41, s42, s43, s44, s45, s46, s47, s5, s51, s52, s53, s54, s55, s56, s57, s6, s61, s62, s63, s64
            , s65, s66, s67, s7, s71, s72, s73, s74, s75, s76, s8, s81, s82, s83, s84, s85, s86, s9, s91, s92, s93, s94
            , s95, s96, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0A, t0B, t0C, t0D, t0a, t0b, t0c, t0d, t0e, t0f
            , t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o, t0p, t0q, t0r, t0s, t0t, t0u, t0v, t0w, t0x, t0y, t0z, t11, t12
            , t13, t14, t15, t16, t17, t18, t19, t1A, t1B, t1C, t1D, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k
            , t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t, t1u, t1v, t1w, t1x, t1y, t1z, t2, t21, t22, t23, t24, t25, t26
            , t27, t28, t29, t2A, t2B, t2C, t2D, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o
            , t2p, t2q, t2r, t2s, t2t, t2u, t2v, t2w, t2x, t2y, t2z, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3A
            , t3B, t3C, t3D, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s
            , t3t, t3u, t3v, t3w, t3x, t3y, t3z, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4A, t4B, t4C, t4D, t4a
            , t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t4o, t4p, t4q, t4r, t4s, t4t, t4u, t4v, t4w
            , t4x, t4y, t4z, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5A, t5B, t5C, t5D, t5a, t5b, t5c, t5d, t5e
            , t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t5r, t5s, t5t, t5u, t5v, t5w, t5x, t5y, t5z, t6
            , t61, t62, t63, t64, t65, t66, t67, t68, t69, t6A, t6B, t6C, t6D, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i
            , t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r, t6s, t6t, t6u, t6v, t6w, t6x, t6y, t6z, t7, t71, t72, t73, t74
            , t75, t76, t77, t78, t79, t7A, t7B, t7C, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m, t7n
            , t7o, t7p, t7q, t7r, t7s, t7t, t7u, t7v, t7w, t7x, t7y, t7z, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89
            , t8A, t8B, t8C, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p, t8q, t8r, t8s
            , t8t, t8u, t8v, t8w, t8x, t8y, t8z, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9A, t9B, t9C, t9a, t9b
            , t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p, t9q, t9r, t9s, t9t, t9u, t9v, t9w, t9x
            , t9y, t9z;
    {long i; for(i = 0; i <= 31; i++) {
        {long i2; for(i2 = 0; i2 <= 7; i2++) {
            a = (src + (2*i) + (64*i2));
            a2 = (a + 1);
            a3 = (a + 4096);
            a4 = (a + 4097);
            t = (*(a) + *(a3));
            t2 = (*(a2) + *(a4));
            t3 = (*(a) - *(a3));
            t4 = (*(a2) - *(a4));
            a5 = (a + 2048);
            a6 = (a + 2049);
            a7 = (a + 6144);
            a8 = (a + 6145);
            t5 = (*(a5) + *(a7));
            t6 = (*(a6) + *(a8));
            t7 = (*(a5) - *(a7));
            t8 = (*(a6) - *(a8));
            t9 = (t + t5);
            t01 = (t2 + t6);
            t11 = (t - t5);
            t21 = (t2 - t6);
            t31 = (t3 - t8);
            t41 = (t4 + t7);
            t51 = (t3 + t8);
            t61 = (t4 - t7);
            a9 = (a + 512);
            a01 = (a + 513);
            a11 = (a + 4608);
            a21 = (a + 4609);
            t71 = (*(a9) + *(a11));
            t81 = (*(a01) + *(a21));
            t91 = (*(a9) - *(a11));
            t02 = (*(a01) - *(a21));
            a31 = (a + 2560);
            a41 = (a + 2561);
            a51 = (a + 6656);
            a61 = (a + 6657);
            t12 = (*(a31) + *(a51));
            t22 = (*(a41) + *(a61));
            t32 = (*(a31) - *(a51));
            t42 = (*(a41) - *(a61));
            t52 = (t71 + t12);
            t62 = (t81 + t22);
            a71 = (0.70710678118654757f*(t71 - t12));
            a81 = (0.70710678118654757f*(t81 - t22));
            s = (a71 - a81);
            s2 = (a71 + a81);
            t72 = (t91 - t42);
            t82 = (t02 + t32);
            t92 = (t91 + t42);
            t03 = (t02 - t32);
            s3 = ((0.92387953251128674f*t72) - (0.38268343236508978f*t82));
            s4 = ((0.38268343236508978f*t72) + (0.92387953251128674f*t82));
            s5 = ((0.38268343236508978f*t92) - (0.92387953251128674f*t03));
            s6 = ((0.92387953251128674f*t92) + (0.38268343236508978f*t03));
            a91 = (a + 1024);
            a02 = (a + 1025);
            a12 = (a + 5120);
            a22 = (a + 5121);
            t13 = (*(a91) + *(a12));
            t23 = (*(a02) + *(a22));
            t33 = (*(a91) - *(a12));
            t43 = (*(a02) - *(a22));
            a32 = (a + 3072);
            a42 = (a + 3073);
            a52 = (a + 7168);
            a62 = (a + 7169);
            t53 = (*(a32) + *(a52));
            t63 = (*(a42) + *(a62));
            t73 = (*(a32) - *(a52));
            t83 = (*(a42) - *(a62));
            t93 = (t13 + t53);
            t04 = (t23 + t63);
            t14 = (t13 - t53);
            t24 = (t23 - t63);
            a72 = (0.70710678118654757f*(t33 - t83));
            a82 = (0.70710678118654757f*(t43 + t73));
            s7 = (a72 - a82);
            s8 = (a72 + a82);
            a92 = (0.70710678118654757f*(t33 + t83));
            a03 = (0.70710678118654757f*(t43 - t73));
            s9 = (a92 + a03);
            s01 = (a92 - a03);
            a13 = (a + 1536);
            a23 = (a + 1537);
            a33 = (a + 5632);
            a43 = (a + 5633);
            t34 = (*(a13) + *(a33));
            t44 = (*(a23) + *(a43));
            t54 = (*(a13) - *(a33));
            t64 = (*(a23) - *(a43));
            a53 = (a + 3584);
            a63 = (a + 3585);
            a73 = (a + 7680);
            a83 = (a + 7681);
            t74 = (*(a53) + *(a73));
            t84 = (*(a63) + *(a83));
            t94 = (*(a53) - *(a73));
            t05 = (*(a63) - *(a83));
            t15 = (t34 + t74);
            t25 = (t44 + t84);
            a93 = (0.70710678118654757f*(t34 - t74));
            a04 = (0.70710678118654757f*(t44 - t84));
            s11 = (a93 + a04);
            s21 = (a93 - a04);
            t35 = (t54 - t05);
            t45 = (t64 + t94);
            t55 = (t54 + t05);
            t65 = (t64 - t94);
            s31 = ((0.38268343236508978f*t35) - (0.92387953251128674f*t45));
            s41 = ((0.92387953251128674f*t35) + (0.38268343236508978f*t45));
            s51 = ((0.38268343236508978f*t65) - (0.92387953251128674f*t55));
            s61 = ((0.38268343236508978f*t55) + (0.92387953251128674f*t65));
            t75 = (t9 + t93);
            t85 = (t01 + t04);
            t95 = (t9 - t93);
            t06 = (t01 - t04);
            t16 = (t52 + t15);
            t26 = (t62 + t25);
            t36 = (t52 - t15);
            t46 = (t62 - t25);
            t56 = (t75 + t16);
            t66 = (t85 + t26);
            t76 = (t75 - t16);
            t86 = (t85 - t26);
            a14 = (32*i2);
            a24 = (D268 + a14);
            a34 = (a24 + 1);
            a44 = (a24 + 2);
            a54 = (a24 + 3);
            a64 = (T2 + a14);
            *(a64) = ((*(a24)*t56) - (*(a34)*t66));
            *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
            *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
            *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
            t96 = (t95 - t46);
            t07 = (t06 + t36);
            t17 = (t95 + t46);
            t27 = (t06 - t36);
            a74 = (a24 + 4);
            a84 = (a24 + 5);
            a94 = (a24 + 6);
            a05 = (a24 + 7);
            *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
            *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
            *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
            *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
            t37 = (t31 + s7);
            t47 = (t41 + s8);
            t57 = (t31 - s7);
            t67 = (t41 - s8);
            t77 = (s3 + s31);
            t87 = (s4 + s41);
            t97 = (s3 - s31);
            t08 = (s4 - s41);
            t18 = (t37 + t77);
            t28 = (t47 + t87);
            t38 = (t37 - t77);
            t48 = (t47 - t87);
            a15 = (a24 + 8);
            a25 = (a24 + 9);
            a35 = (a24 + 10);
            a45 = (a24 + 11);
            *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
            *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
            *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
            *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
            t58 = (t57 - t08);
            t68 = (t67 + t97);
            t78 = (t57 + t08);
            t88 = (t67 - t97);
            a55 = (a24 + 12);
            a65 = (a24 + 13);
            a75 = (a24 + 14);
            a85 = (a24 + 15);
            *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
            *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
            *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
            *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
            t98 = (t11 - t24);
            t09 = (t21 + t14);
            t19 = (t11 + t24);
            t29 = (t21 - t14);
            t39 = (s - s11);
            t49 = (s2 + s21);
            t59 = (s + s11);
            t69 = (s2 - s21);
            t79 = (t98 + t39);
            t89 = (t09 + t49);
            t99 = (t98 - t39);
            t0a = (t09 - t49);
            a95 = (a24 + 16);
            a06 = (a24 + 17);
            a16 = (a24 + 18);
            a26 = (a24 + 19);
            *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
            *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
            *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
            *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
            t1a = (t19 - t69);
            t2a = (t29 + t59);
            t3a = (t19 + t69);
            t4a = (t29 - t59);
            a36 = (a24 + 20);
            a46 = (a24 + 21);
            a56 = (a24 + 22);
            a66 = (a24 + 23);
            *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
            *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
            *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
            *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
            t5a = (t51 - s9);
            t6a = (t61 + s01);
            t7a = (t51 + s9);
            t8a = (t61 - s01);
            t9a = (s5 + s51);
            t0b = (s6 - s61);
            t1b = (s5 - s51);
            t2b = (s6 + s61);
            t3b = (t5a + t9a);
            t4b = (t6a + t0b);
            t5b = (t5a - t9a);
            t6b = (t6a - t0b);
            a76 = (a24 + 24);
            a86 = (a24 + 25);
            a96 = (a24 + 26);
            a07 = (a24 + 27);
            *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
            *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
            *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
            *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
            t7b = (t7a - t2b);
            t8b = (t8a + t1b);
            t9b = (t7a + t2b);
            t0c = (t8a - t1b);
            a17 = (a24 + 28);
            a27 = (a24 + 29);
            a37 = (a24 + 30);
            a47 = (a24 + 31);
            *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
            *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
            *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
            *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
        }}
        {long i3; for(i3 = 0; i3 <= 15; i3++) {
            a57 = (2*i3);
            a67 = (T2 + a57);
            a77 = (a67 + 1);
            a87 = (a67 + 128);
            a97 = (a67 + 129);
            t1c = (*(a67) + *(a87));
            t2c = (*(a77) + *(a97));
            t3c = (*(a67) - *(a87));
            t4c = (*(a77) - *(a97));
            a08 = (a67 + 32);
            a18 = (a67 + 33);
            a28 = (a67 + 160);
            a38 = (a67 + 161);
            t5c = (*(a08) + *(a28));
            t6c = (*(a18) + *(a38));
            a48 = (0.70710678118654757f*(*(a08) - *(a28)));
            a58 = (0.70710678118654757f*(*(a18) - *(a38)));
            s71 = (a48 - a58);
            s81 = (a48 + a58);
            a68 = (a67 + 64);
            a78 = (a67 + 65);
            a88 = (a67 + 192);
            a98 = (a67 + 193);
            t7c = (*(a68) + *(a88));
            t8c = (*(a78) + *(a98));
            t9c = (*(a68) - *(a88));
            t0d = (*(a78) - *(a98));
            a09 = (a67 + 96);
            a19 = (a67 + 97);
            a29 = (a67 + 224);
            a39 = (a67 + 225);
            t1d = (*(a09) + *(a29));
            t2d = (*(a19) + *(a39));
            a49 = (0.70710678118654757f*(*(a09) - *(a29)));
            a59 = (0.70710678118654757f*(*(a19) - *(a39)));
            s91 = (a49 + a59);
            s02 = (a49 - a59);
            t3d = (t1c + t7c);
            t4d = (t2c + t8c);
            t5d = (t1c - t7c);
            t6d = (t2c - t8c);
            t7d = (t5c + t1d);
            t8d = (t6c + t2d);
            t9d = (t5c - t1d);
            t0e = (t6c - t2d);
            t1e = (t3d + t7d);
            t2e = (t4d + t8d);
            t3e = (t3d - t7d);
            t4e = (t4d - t8d);
            a69 = (256*i);
            a79 = (D273 + a69 + (16*i3));
            a89 = (a79 + 1);
            a99 = (a79 + 2);
            a0a = (a79 + 3);
            a1a = (T + a69 + a57);
            *(a1a) = ((*(a79)*t1e) - (*(a89)*t2e));
            *((a1a + 1)) = ((*(a89)*t1e) + (*(a79)*t2e));
            *((a1a + 128)) = ((*(a99)*t3e) - (*(a0a)*t4e));
            *((a1a + 129)) = ((*(a0a)*t3e) + (*(a99)*t4e));
            t5e = (t5d - t0e);
            t6e = (t6d + t9d);
            t7e = (t5d + t0e);
            t8e = (t6d - t9d);
            a2a = (a79 + 4);
            a3a = (a79 + 5);
            a4a = (a79 + 6);
            a5a = (a79 + 7);
            *((a1a + 64)) = ((*(a2a)*t5e) - (*(a3a)*t6e));
            *((a1a + 65)) = ((*(a3a)*t5e) + (*(a2a)*t6e));
            *((a1a + 192)) = ((*(a4a)*t7e) - (*(a5a)*t8e));
            *((a1a + 193)) = ((*(a5a)*t7e) + (*(a4a)*t8e));
            t9e = (t3c - t0d);
            t0f = (t4c + t9c);
            t1f = (t3c + t0d);
            t2f = (t4c - t9c);
            t3f = (s71 - s91);
            t4f = (s81 + s02);
            t5f = (s71 + s91);
            t6f = (s81 - s02);
            t7f = (t9e + t3f);
            t8f = (t0f + t4f);
            t9f = (t9e - t3f);
            t0g = (t0f - t4f);
            a6a = (a79 + 8);
            a7a = (a79 + 9);
            a8a = (a79 + 10);
            a9a = (a79 + 11);
            *((a1a + 32)) = ((*(a6a)*t7f) - (*(a7a)*t8f));
            *((a1a + 33)) = ((*(a7a)*t7f) + (*(a6a)*t8f));
            *((a1a + 160)) = ((*(a8a)*t9f) - (*(a9a)*t0g));
            *((a1a + 161)) = ((*(a9a)*t9f) + (*(a8a)*t0g));
            t1g = (t1f - t6f);
            t2g = (t2f + t5f);
            t3g = (t1f + t6f);
            t4g = (t2f - t5f);
            a0b = (a79 + 12);
            a1b = (a79 + 13);
            a2b = (a79 + 14);
            a3b = (a79 + 15);
            *((a1a + 96)) = ((*(a0b)*t1g) - (*(a1b)*t2g));
            *((a1a + 97)) = ((*(a1b)*t1g) + (*(a0b)*t2g));
            *((a1a + 224)) = ((*(a2b)*t3g) - (*(a3b)*t4g));
            *((a1a + 225)) = ((*(a3b)*t3g) + (*(a2b)*t4g));
        }}
    }}
    {long i4; for(i4 = 0; i4 <= 127; i4++) {
        a4b = (2*i4);
        a5b = (T + a4b);
        a6b = (a5b + 1);
        a7b = (a5b + 4096);
        a8b = (a5b + 4097);
        t5g = (*(a5b) + *(a7b));
        t6g = (*(a6b) + *(a8b));
        t7g = (*(a5b) - *(a7b));
        t8g = (*(a6b) - *(a8b));
        a9b = (a5b + 2048);
        a0c = (a5b + 2049);
        a1c = (a5b + 6144);
        a2c = (a5b + 6145);
        t9g = (*(a9b) + *(a1c));
        t0h = (*(a0c) + *(a2c));
        t1h = (*(a9b) - *(a1c));
        t2h = (*(a0c) - *(a2c));
        t3h = (t5g + t9g);
        t4h = (t6g + t0h);
        t5h = (t5g - t9g);
        t6h = (t6g - t0h);
        t7h = (t7g - t2h);
        t8h = (t8g + t1h);
        t9h = (t7g + t2h);
        t0i = (t8g - t1h);
        a3c = (a5b + 256);
        a4c = (a5b + 257);
        a5c = (a5b + 4352);
        a6c = (a5b + 4353);
        t1i = (*(a3c) + *(a5c));
        t2i = (*(a4c) + *(a6c));
        t3i = (*(a3c) - *(a5c));
        t4i = (*(a4c) - *(a6c));
        a7c = (a5b + 2304);
        a8c = (a5b + 2305);
        a9c = (a5b + 6400);
        a0d = (a5b + 6401);
        t5i = (*(a7c) + *(a9c));
        t6i = (*(a8c) + *(a0d));
        t7i = (*(a7c) - *(a9c));
        t8i = (*(a8c) - *(a0d));
        t9i = (t1i + t5i);
        t0j = (t2i + t6i);
        t1j = (t1i - t5i);
        t2j = (t2i - t6i);
        s12 = ((0.92387953251128674f*t1j) - (0.38268343236508978f*t2j));
        s22 = ((0.38268343236508978f*t1j) + (0.92387953251128674f*t2j));
        t3j = (t3i - t8i);
        t4j = (t4i + t7i);
        t5j = (t3i + t8i);
        t6j = (t4i - t7i);
        s32 = ((0.98078528040323043f*t3j) - (0.19509032201612828f*t4j));
        s42 = ((0.19509032201612828f*t3j) + (0.98078528040323043f*t4j));
        s52 = ((0.83146961230254524f*t5j) - (0.55557023301960218f*t6j));
        s62 = ((0.55557023301960218f*t5j) + (0.83146961230254524f*t6j));
        a1d = (a5b + 512);
        a2d = (a5b + 513);
        a3d = (a5b + 4608);
        a4d = (a5b + 4609);
        t7j = (*(a1d) + *(a3d));
        t8j = (*(a2d) + *(a4d));
        t9j = (*(a1d) - *(a3d));
        t0k = (*(a2d) - *(a4d));
        a5d = (a5b + 2560);
        a6d = (a5b + 2561);
        a7d = (a5b + 6656);
        a8d = (a5b + 6657);
        t1k = (*(a5d) + *(a7d));
        t2k = (*(a6d) + *(a8d));
        t3k = (*(a5d) - *(a7d));
        t4k = (*(a6d) - *(a8d));
        t5k = (t7j + t1k);
        t6k = (t8j + t2k);
        a9d = (0.70710678118654757f*(t7j - t1k));
        a0e = (0.70710678118654757f*(t8j - t2k));
        s72 = (a9d - a0e);
        s82 = (a9d + a0e);
        t7k = (t9j - t4k);
        t8k = (t0k + t3k);
        t9k = (t9j + t4k);
        t0l = (t0k - t3k);
        s92 = ((0.92387953251128674f*t7k) - (0.38268343236508978f*t8k));
        s03 = ((0.38268343236508978f*t7k) + (0.92387953251128674f*t8k));
        s13 = ((0.38268343236508978f*t9k) - (0.92387953251128674f*t0l));
        s23 = ((0.92387953251128674f*t9k) + (0.38268343236508978f*t0l));
        a1e = (a5b + 768);
        a2e = (a5b + 769);
        a3e = (a5b + 4864);
        a4e = (a5b + 4865);
        t1l = (*(a1e) + *(a3e));
        t2l = (*(a2e) + *(a4e));
        t3l = (*(a1e) - *(a3e));
        t4l = (*(a2e) - *(a4e));
        a5e = (a5b + 2816);
        a6e = (a5b + 2817);
        a7e = (a5b + 6912);
        a8e = (a5b + 6913);
        t5l = (*(a5e) + *(a7e));
        t6l = (*(a6e) + *(a8e));
        t7l = (*(a5e) - *(a7e));
        t8l = (*(a6e) - *(a8e));
        t9l = (t1l + t5l);
        t0m = (t2l + t6l);
        t1m = (t1l - t5l);
        t2m = (t2l - t6l);
        s33 = ((0.38268343236508978f*t1m) - (0.92387953251128674f*t2m));
        s43 = ((0.92387953251128674f*t1m) + (0.38268343236508978f*t2m));
        t3m = (t3l - t8l);
        t4m = (t4l + t7l);
        t5m = (t3l + t8l);
        t6m = (t4l - t7l);
        s53 = ((0.83146961230254524f*t3m) - (0.55557023301960218f*t4m));
        s63 = ((0.55557023301960218f*t3m) + (0.83146961230254524f*t4m));
        s73 = ((0.19509032201612828f*t5m) + (0.98078528040323043f*t6m));
        s83 = ((0.98078528040323043f*t5m) - (0.19509032201612828f*t6m));
        a9e = (a5b + 1024);
        a0f = (a5b + 1025);
        a1f = (a5b + 5120);
        a2f = (a5b + 5121);
        t7m = (*(a9e) + *(a1f));
        t8m = (*(a0f) + *(a2f));
        t9m = (*(a9e) - *(a1f));
        t0n = (*(a0f) - *(a2f));
        a3f = (a5b + 3072);
        a4f = (a5b + 3073);
        a5f = (a5b + 7168);
        a6f = (a5b + 7169);
        t1n = (*(a3f) + *(a5f));
        t2n = (*(a4f) + *(a6f));
        t3n = (*(a3f) - *(a5f));
        t4n = (*(a4f) - *(a6f));
        t5n = (t7m + t1n);
        t6n = (t8m + t2n);
        t7n = (t7m - t1n);
        t8n = (t8m - t2n);
        a7f = (0.70710678118654757f*(t9m - t4n));
        a8f = (0.70710678118654757f*(t0n + t3n));
        s93 = (a7f - a8f);
        s04 = (a7f + a8f);
        a9f = (0.70710678118654757f*(t9m + t4n));
        a0g = (0.70710678118654757f*(t0n - t3n));
        s14 = (a9f + a0g);
        s24 = (a9f - a0g);
        a1g = (a5b + 1280);
        a2g = (a5b + 1281);
        a3g = (a5b + 5376);
        a4g = (a5b + 5377);
        t9n = (*(a1g) + *(a3g));
        t0o = (*(a2g) + *(a4g));
        t1o = (*(a1g) - *(a3g));
        t2o = (*(a2g) - *(a4g));
        a5g = (a5b + 3328);
        a6g = (a5b + 3329);
        a7g = (a5b + 7424);
        a8g = (a5b + 7425);
        t3o = (*(a5g) + *(a7g));
        t4o = (*(a6g) + *(a8g));
        t5o = (*(a5g) - *(a7g));
        t6o = (*(a6g) - *(a8g));
        t7o = (t9n + t3o);
        t8o = (t0o + t4o);
        t9o = (t9n - t3o);
        t0p = (t0o - t4o);
        s34 = ((0.38268343236508978f*t9o) + (0.92387953251128674f*t0p));
        s44 = ((0.92387953251128674f*t9o) - (0.38268343236508978f*t0p));
        t1p = (t1o - t6o);
        t2p = (t2o + t5o);
        t3p = (t1o + t6o);
        t4p = (t2o - t5o);
        s54 = ((0.55557023301960218f*t1p) - (0.83146961230254524f*t2p));
        s64 = ((0.83146961230254524f*t1p) + (0.55557023301960218f*t2p));
        s74 = ((0.98078528040323043f*t3p) + (0.19509032201612828f*t4p));
        s84 = ((0.19509032201612828f*t3p) - (0.98078528040323043f*t4p));
        a9g = (a5b + 1536);
        a0h = (a5b + 1537);
        a1h = (a5b + 5632);
        a2h = (a5b + 5633);
        t5p = (*(a9g) + *(a1h));
        t6p = (*(a0h) + *(a2h));
        t7p = (*(a9g) - *(a1h));
        t8p = (*(a0h) - *(a2h));
        a3h = (a5b + 3584);
        a4h = (a5b + 3585);
        a5h = (a5b + 7680);
        a6h = (a5b + 7681);
        t9p = (*(a3h) + *(a5h));
        t0q = (*(a4h) + *(a6h));
        t1q = (*(a3h) - *(a5h));
        t2q = (*(a4h) - *(a6h));
        t3q = (t5p + t9p);
        t4q = (t6p + t0q);
        a7h = (0.70710678118654757f*(t5p - t9p));
        a8h = (0.70710678118654757f*(t6p - t0q));
        s94 = (a7h + a8h);
        s05 = (a7h - a8h);
        t5q = (t7p - t2q);
        t6q = (t8p + t1q);
        t7q = (t7p + t2q);
        t8q = (t8p - t1q);
        s15 = ((0.38268343236508978f*t5q) - (0.92387953251128674f*t6q));
        s25 = ((0.92387953251128674f*t5q) + (0.38268343236508978f*t6q));
        s35 = ((0.38268343236508978f*t8q) - (0.92387953251128674f*t7q));
        s45 = ((0.38268343236508978f*t7q) + (0.92387953251128674f*t8q));
        a9h = (a5b + 1792);
        a0i = (a5b + 1793);
        a1i = (a5b + 5888);
        a2i = (a5b + 5889);
        t9q = (*(a9h) + *(a1i));
        t0r = (*(a0i) + *(a2i));
        t1r = (*(a9h) - *(a1i));
        t2r = (*(a0i) - *(a2i));
        a3i = (a5b + 3840);
        a4i = (a5b + 3841);
        a5i = (a5b + 7936);
        a6i = (a5b + 7937);
        t3r = (*(a3i) + *(a5i));
        t4r = (*(a4i) + *(a6i));
        t5r = (*(a3i) - *(a5i));
        t6r = (*(a4i) - *(a6i));
        t7r = (t9q + t3r);
        t8r = (t0r + t4r);
        t9r = (t9q - t3r);
        t0s = (t0r - t4r);
        s55 = ((0.92387953251128674f*t9r) + (0.38268343236508978f*t0s));
        s65 = ((0.38268343236508978f*t9r) - (0.92387953251128674f*t0s));
        t1s = (t1r - t6r);
        t2s = (t2r + t5r);
        t3s = (t1r + t6r);
        t4s = (t2r - t5r);
        s75 = ((0.19509032201612828f*t1s) - (0.98078528040323043f*t2s));
        s85 = ((0.98078528040323043f*t1s) + (0.19509032201612828f*t2s));
        s95 = ((0.83146961230254524f*t4s) - (0.55557023301960218f*t3s));
        s06 = ((0.83146961230254524f*t3s) + (0.55557023301960218f*t4s));
        t5s = (t3h + t5n);
        t6s = (t4h + t6n);
        t7s = (t3h - t5n);
        t8s = (t4h - t6n);
        t9s = (t9i + t7o);
        t0t = (t0j + t8o);
        a7i = (0.70710678118654757f*(t9i - t7o));
        a8i = (0.70710678118654757f*(t0j - t8o));
        s16 = (a7i - a8i);
        s26 = (a7i + a8i);
        t1t = (t5k + t3q);
        t2t = (t6k + t4q);
        t3t = (t5k - t3q);
        t4t = (t6k - t4q);
        t5t = (t9l + t7r);
        t6t = (t0m + t8r);
        a9i = (0.70710678118654757f*(t9l - t7r));
        a0j = (0.70710678118654757f*(t0m - t8r));
        s36 = (a9i + a0j);
        s46 = (a9i - a0j);
        t7t = (t5s + t1t);
        t8t = (t6s + t2t);
        t9t = (t5s - t1t);
        t0u = (t6s - t2t);
        t1u = (t9s + t5t);
        t2u = (t0t + t6t);
        t3u = (t9s - t5t);
        t4u = (t0t - t6t);
        a1j = (dst + a4b);
        *(a1j) = (t7t + t1u);
        *((a1j + 1)) = (t8t + t2u);
        *((a1j + 4096)) = (t7t - t1u);
        *((a1j + 4097)) = (t8t - t2u);
        *((a1j + 2048)) = (t9t - t4u);
        *((a1j + 2049)) = (t0u + t3u);
        *((a1j + 6144)) = (t9t + t4u);
        *((a1j + 6145)) = (t0u - t3u);
        t5u = (t7s - t4t);
        t6u = (t8s + t3t);
        t7u = (t7s + t4t);
        t8u = (t8s - t3t);
        t9u = (s16 - s36);
        t0v = (s26 + s46);
        t1v = (s16 + s36);
        t2v = (s26 - s46);
        *((a1j + 1024)) = (t5u + t9u);
        *((a1j + 1025)) = (t6u + t0v);
        *((a1j + 5120)) = (t5u - t9u);
        *((a1j + 5121)) = (t6u - t0v);
        *((a1j + 3072)) = (t7u - t2v);
        *((a1j + 3073)) = (t8u + t1v);
        *((a1j + 7168)) = (t7u + t2v);
        *((a1j + 7169)) = (t8u - t1v);
        t3v = (t7h + s93);
        t4v = (t8h + s04);
        t5v = (t7h - s93);
        t6v = (t8h - s04);
        t7v = (s32 + s54);
        t8v = (s42 + s64);
        a2j = (0.70710678118654757f*(s32 - s54));
        a3j = (0.70710678118654757f*(s42 - s64));
        s56 = (a2j - a3j);
        s66 = (a2j + a3j);
        t9v = (s92 + s15);
        t0w = (s03 + s25);
        t1w = (s92 - s15);
        t2w = (s03 - s25);
        t3w = (s53 + s75);
        t4w = (s63 + s85);
        a4j = (0.70710678118654757f*(s53 - s75));
        a5j = (0.70710678118654757f*(s63 - s85));
        s76 = (a4j + a5j);
        s86 = (a4j - a5j);
        t5w = (t3v + t9v);
        t6w = (t4v + t0w);
        t7w = (t3v - t9v);
        t8w = (t4v - t0w);
        t9w = (t7v + t3w);
        t0x = (t8v + t4w);
        t1x = (t7v - t3w);
        t2x = (t8v - t4w);
        *((a1j + 256)) = (t5w + t9w);
        *((a1j + 257)) = (t6w + t0x);
        *((a1j + 4352)) = (t5w - t9w);
        *((a1j + 4353)) = (t6w - t0x);
        *((a1j + 2304)) = (t7w - t2x);
        *((a1j + 2305)) = (t8w + t1x);
        *((a1j + 6400)) = (t7w + t2x);
        *((a1j + 6401)) = (t8w - t1x);
        t3x = (t5v - t2w);
        t4x = (t6v + t1w);
        t5x = (t5v + t2w);
        t6x = (t6v - t1w);
        t7x = (s56 - s76);
        t8x = (s66 + s86);
        t9x = (s56 + s76);
        t0y = (s66 - s86);
        *((a1j + 1280)) = (t3x + t7x);
        *((a1j + 1281)) = (t4x + t8x);
        *((a1j + 5376)) = (t3x - t7x);
        *((a1j + 5377)) = (t4x - t8x);
        *((a1j + 3328)) = (t5x - t0y);
        *((a1j + 3329)) = (t6x + t9x);
        *((a1j + 7424)) = (t5x + t0y);
        *((a1j + 7425)) = (t6x - t9x);
        t1y = (t5h - t8n);
        t2y = (t6h + t7n);
        t3y = (t5h + t8n);
        t4y = (t6h - t7n);
        t5y = (s12 - s34);
        t6y = (s22 + s44);
        a6j = (0.70710678118654757f*(s12 + s34));
        a7j = (0.70710678118654757f*(s22 - s44));
        s96 = (a6j - a7j);
        s07 = (a6j + a7j);
        t7y = (s72 - s94);
        t8y = (s82 + s05);
        t9y = (s72 + s94);
        t0z = (s82 - s05);
        t1z = (s33 - s55);
        t2z = (s43 + s65);
        a8j = (0.70710678118654757f*(s33 + s55));
        a9j = (0.70710678118654757f*(s43 - s65));
        s17 = (a8j + a9j);
        s27 = (a8j - a9j);
        t3z = (t1y + t7y);
        t4z = (t2y + t8y);
        t5z = (t1y - t7y);
        t6z = (t2y - t8y);
        t7z = (t5y + t1z);
        t8z = (t6y + t2z);
        t9z = (t5y - t1z);
        t0A = (t6y - t2z);
        *((a1j + 512)) = (t3z + t7z);
        *((a1j + 513)) = (t4z + t8z);
        *((a1j + 4608)) = (t3z - t7z);
        *((a1j + 4609)) = (t4z - t8z);
        *((a1j + 2560)) = (t5z - t0A);
        *((a1j + 2561)) = (t6z + t9z);
        *((a1j + 6656)) = (t5z + t0A);
        *((a1j + 6657)) = (t6z - t9z);
        t1A = (t3y - t0z);
        t2A = (t4y + t9y);
        t3A = (t3y + t0z);
        t4A = (t4y - t9y);
        t5A = (s96 - s17);
        t6A = (s07 + s27);
        t7A = (s96 + s17);
        t8A = (s07 - s27);
        *((a1j + 1536)) = (t1A + t5A);
        *((a1j + 1537)) = (t2A + t6A);
        *((a1j + 5632)) = (t1A - t5A);
        *((a1j + 5633)) = (t2A - t6A);
        *((a1j + 3584)) = (t3A - t8A);
        *((a1j + 3585)) = (t4A + t7A);
        *((a1j + 7680)) = (t3A + t8A);
        *((a1j + 7681)) = (t4A - t7A);
        t9A = (t9h - s14);
        t0B = (t0i + s24);
        t1B = (t9h + s14);
        t2B = (t0i - s24);
        t3B = (s52 - s74);
        t4B = (s62 + s84);
        a0k = (0.70710678118654757f*(s52 + s74));
        a1k = (0.70710678118654757f*(s62 - s84));
        s37 = (a0k - a1k);
        s47 = (a0k + a1k);
        t5B = (s13 + s35);
        t6B = (s23 - s45);
        t7B = (s13 - s35);
        t8B = (s23 + s45);
        t9B = (s95 - s73);
        t0C = (s83 - s06);
        a2k = (0.70710678118654757f*(s73 + s95));
        a3k = (0.70710678118654757f*(s83 + s06));
        s57 = (a2k - a3k);
        s67 = (a2k + a3k);
        t1C = (t9A + t5B);
        t2C = (t0B + t6B);
        t3C = (t9A - t5B);
        t4C = (t0B - t6B);
        t5C = (t3B + t9B);
        t6C = (t4B + t0C);
        t7C = (t3B - t9B);
        t8C = (t4B - t0C);
        *((a1j + 768)) = (t1C + t5C);
        *((a1j + 769)) = (t2C + t6C);
        *((a1j + 4864)) = (t1C - t5C);
        *((a1j + 4865)) = (t2C - t6C);
        *((a1j + 2816)) = (t3C - t8C);
        *((a1j + 2817)) = (t4C + t7C);
        *((a1j + 6912)) = (t3C + t8C);
        *((a1j + 6913)) = (t4C - t7C);
        t9C = (t1B - t8B);
        t0D = (t2B + t7B);
        t1D = (t1B + t8B);
        t2D = (t2B - t7B);
        t3D = (s37 + s57);
        t4D = (s47 - s67);
        t5D = (s37 - s57);
        t6D = (s47 + s67);
        *((a1j + 1792)) = (t9C + t3D);
        *((a1j + 1793)) = (t0D + t4D);
        *((a1j + 5888)) = (t9C - t3D);
        *((a1j + 5889)) = (t0D - t4D);
        *((a1j + 3840)) = (t1D - t6D);
        *((a1j + 3841)) = (t2D + t5D);
        *((a1j + 7936)) = (t1D + t6D);
        *((a1j + 7937)) = (t2D - t5D);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftinv_float_8192)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[16384];
     float T2[2048];
    float  *a08, *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0g, *a0h, *a0j, *a0l, *a0m, *a0o, *a0q, *a0s, *a0u, *a18, *a19, *a1a, *a1b, *a1c
            , *a1d, *a1e, *a1f, *a1g, *a1h, *a1j, *a1l, *a1m, *a1o, *a1q, *a1s, *a1u, *a1v, *a1w, *a1x, *a28, *a29, *a2a, *a2b, *a2c, *a2d, *a2e
            , *a2f, *a2g, *a2h, *a2i, *a2j, *a2k, *a2l, *a2m, *a2o, *a2q, *a2s, *a2u, *a2v, *a2w, *a38, *a39, *a3a, *a3b, *a3c, *a3d, *a3e, *a3f
            , *a3g, *a3h, *a3i, *a3j, *a3k, *a3l, *a3m, *a3n, *a3o, *a3q, *a3s, *a3u, *a3v, *a3w, *a48, *a49, *a4a, *a4b, *a4c, *a4d, *a4e, *a4f
            , *a4g, *a4h, *a4i, *a4j, *a4k, *a4l, *a4m, *a4n, *a4o, *a4p, *a4q, *a4r, *a4s, *a4t, *a4u, *a4v, *a4w, *a58, *a5a, *a5c, *a5e, *a5g
            , *a5h, *a5i, *a5j, *a5k, *a5l, *a5m, *a5n, *a5o, *a5p, *a5q, *a5r, *a5s, *a5t, *a5u, *a5v, *a5w, *a68, *a6a, *a6c, *a6e, *a6f, *a6g
            , *a6h, *a6i, *a6j, *a6k, *a6l, *a6m, *a6n, *a6o, *a6p, *a6q, *a6r, *a6s, *a6t, *a6u, *a6v, *a6w, *a78, *a7a, *a7c, *a7e, *a7f, *a7g
            , *a7h, *a7i, *a7j, *a7k, *a7l, *a7m, *a7n, *a7o, *a7p, *a7q, *a7r, *a7s, *a7t, *a7u, *a7v, *a7w, *a87, *a88, *a8a, *a8c, *a8e, *a8f
            , *a8g, *a8h, *a8i, *a8k, *a8n, *a8o, *a8p, *a8q, *a8r, *a8s, *a8t, *a8u, *a8v, *a8w, *a97, *a98, *a99, *a9a, *a9b, *a9c, *a9d, *a9e
            , *a9f, *a9g, *a9h, *a9i, *a9k, *a9n, *a9o, *a9p, *a9q, *a9r, *a9s, *a9t, *a9u;
    const float  *a, *a01, *a02, *a03, *a04, *a05, *a06, *a07, *a11, *a12, *a13, *a14, *a15, *a16, *a17, *a2, *a21, *a22, *a23, *a24, *a25, *a26
            , *a27, *a3, *a31, *a32, *a33, *a35, *a4, *a41, *a42, *a43, *a45, *a5, *a51, *a53, *a55, *a56, *a6, *a61, *a63, *a65, *a66, *a7
            , *a71, *a72, *a73, *a74, *a75, *a76, *a8, *a81, *a82, *a83, *a84, *a85, *a86, *a9, *a91, *a92, *a93, *a94, *a95, *a96;
    int a0v, a2n, a5f, a77;
    float a0i, a0k, a0n, a0p, a0r, a0t, a0w, a0x, a1i, a1k, a1n, a1p, a1r, a1t, a2p, a2r, a2t, a34, a36, a37, a3p, a3r
            , a3t, a44, a46, a47, a52, a54, a57, a59, a5b, a5d, a62, a64, a67, a69, a6b, a6d, a79, a7b, a7d, a89, a8b, a8d
            , a8j, a8l, a8m, a9j, a9l, a9m, a9v, a9w, s, s01, s02, s03, s04, s05, s06, s07, s08, s09, s0a, s0b, s11, s12
            , s13, s14, s15, s16, s17, s18, s19, s1a, s1b, s2, s21, s22, s23, s24, s25, s26, s27, s28, s29, s2a, s2b, s3
            , s31, s32, s33, s34, s35, s36, s37, s38, s39, s3a, s3b, s4, s41, s42, s43, s44, s45, s46, s47, s48, s49, s4a
            , s4b, s5, s51, s52, s53, s54, s55, s56, s57, s58, s59, s5a, s5b, s6, s61, s62, s63, s64, s65, s66, s67, s68
            , s69, s6a, s6b, s7, s71, s72, s73, s74, s75, s76, s77, s78, s79, s7a, s8, s81, s82, s83, s84, s85, s86, s87
            , s88, s89, s8a, s9, s91, s92, s93, s94, s95, s96, s97, s98, s99, s9a, t, t01, t010, t02, t03, t04, t05, t06
            , t07, t08, t09, t0A, t0B, t0C, t0D, t0E, t0F, t0G, t0H, t0I, t0J, t0K, t0L, t0M, t0N, t0O, t0P, t0Q, t0R, t0S
            , t0T, t0U, t0V, t0W, t0X, t0Y, t0Z, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o
            , t0p, t0q, t0r, t0s, t0t, t0u, t0v, t0w, t0x, t0y, t0z, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1A, t1B
            , t1C, t1D, t1E, t1F, t1G, t1H, t1I, t1J, t1K, t1L, t1M, t1N, t1O, t1P, t1Q, t1R, t1S, t1T, t1U, t1V, t1W, t1X
            , t1Y, t1Z, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t
            , t1u, t1v, t1w, t1x, t1y, t1z, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2A, t2B, t2C, t2D, t2E, t2F
            , t2G, t2H, t2I, t2J, t2K, t2L, t2M, t2N, t2O, t2P, t2Q, t2R, t2S, t2T, t2U, t2V, t2W, t2X, t2Y, t2Z, t2a, t2b
            , t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p, t2q, t2r, t2s, t2t, t2u, t2v, t2w, t2x
            , t2y, t2z, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3A, t3B, t3C, t3D, t3E, t3F, t3G, t3H, t3I, t3J
            , t3K, t3L, t3M, t3N, t3O, t3P, t3Q, t3R, t3S, t3T, t3U, t3V, t3W, t3X, t3Y, t3Z, t3a, t3b, t3c, t3d, t3e, t3f
            , t3g, t3h, t3i, t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s, t3t, t3u, t3v, t3w, t3x, t3y, t3z, t4, t41
            , t42, t43, t44, t45, t46, t47, t48, t49, t4A, t4B, t4C, t4D, t4E, t4F, t4G, t4H, t4I, t4J, t4K, t4L, t4M, t4N
            , t4O, t4P, t4Q, t4R, t4S, t4T, t4U, t4V, t4W, t4X, t4Y, t4Z, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j
            , t4k, t4l, t4m, t4n, t4o, t4p, t4q, t4r, t4s, t4t, t4u, t4v, t4w, t4x, t4y, t4z, t5, t51, t52, t53, t54, t55
            , t56, t57, t58, t59, t5A, t5B, t5C, t5D, t5E, t5F, t5G, t5H, t5I, t5J, t5K, t5L, t5M, t5N, t5O, t5P, t5Q, t5R
            , t5S, t5T, t5U, t5V, t5W, t5X, t5Y, t5Z, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n
            , t5o, t5p, t5q, t5r, t5s, t5t, t5u, t5v, t5w, t5x, t5y, t5z, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69
            , t6A, t6B, t6C, t6D, t6E, t6F, t6G, t6H, t6I, t6J, t6K, t6L, t6M, t6N, t6O, t6P, t6Q, t6R, t6S, t6T, t6U, t6V
            , t6W, t6X, t6Y, t6Z, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r
            , t6s, t6t, t6u, t6v, t6w, t6x, t6y, t6z, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7A, t7B, t7C, t7D
            , t7E, t7F, t7G, t7H, t7I, t7J, t7K, t7L, t7M, t7N, t7O, t7P, t7Q, t7R, t7S, t7T, t7U, t7V, t7W, t7X, t7Y, t7Z
            , t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m, t7n, t7o, t7p, t7q, t7r, t7s, t7t, t7u, t7v
            , t7w, t7x, t7y, t7z, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8A, t8B, t8C, t8D, t8E, t8F, t8G, t8H
            , t8I, t8J, t8K, t8L, t8M, t8N, t8O, t8P, t8Q, t8R, t8S, t8T, t8U, t8V, t8W, t8X, t8Y, t8Z, t8a, t8b, t8c, t8d
            , t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p, t8q, t8r, t8s, t8t, t8u, t8v, t8w, t8x, t8y, t8z
            , t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9A, t9B, t9C, t9D, t9E, t9F, t9G, t9H, t9I, t9J, t9K, t9L
            , t9M, t9N, t9O, t9P, t9Q, t9R, t9S, t9T, t9U, t9V, t9W, t9X, t9Y, t9Z, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h
            , t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p, t9q, t9r, t9s, t9t, t9u, t9v, t9w, t9x, t9y, t9z;
    {long i; for(i = 0; i <= 7; i++) {
        {long i2; for(i2 = 0; i2 <= 31; i2++) {
            a = (src + (2*i) + (16*i2));
            a2 = (a + 1);
            a3 = (a + 8192);
            a4 = (a + 8193);
            t = (*(a) + *(a3));
            t2 = (*(a2) + *(a4));
            t3 = (*(a) - *(a3));
            t4 = (*(a2) - *(a4));
            a5 = (a + 4096);
            a6 = (a + 4097);
            a7 = (a + 12288);
            a8 = (a + 12289);
            t5 = (*(a5) + *(a7));
            t6 = (*(a6) + *(a8));
            t7 = (*(a5) - *(a7));
            t8 = (*(a6) - *(a8));
            t9 = (t + t5);
            t01 = (t2 + t6);
            t11 = (t - t5);
            t21 = (t2 - t6);
            t31 = (t3 - t8);
            t41 = (t4 + t7);
            t51 = (t3 + t8);
            t61 = (t4 - t7);
            a9 = (a + 512);
            a01 = (a + 513);
            a11 = (a + 8704);
            a21 = (a + 8705);
            t71 = (*(a9) + *(a11));
            t81 = (*(a01) + *(a21));
            t91 = (*(a9) - *(a11));
            t02 = (*(a01) - *(a21));
            a31 = (a + 4608);
            a41 = (a + 4609);
            a51 = (a + 12800);
            a61 = (a + 12801);
            t12 = (*(a31) + *(a51));
            t22 = (*(a41) + *(a61));
            t32 = (*(a31) - *(a51));
            t42 = (*(a41) - *(a61));
            t52 = (t71 + t12);
            t62 = (t81 + t22);
            t72 = (t71 - t12);
            t82 = (t81 - t22);
            s = ((0.92387953251128674f*t72) - (0.38268343236508978f*t82));
            s2 = ((0.38268343236508978f*t72) + (0.92387953251128674f*t82));
            t92 = (t91 - t42);
            t03 = (t02 + t32);
            t13 = (t91 + t42);
            t23 = (t02 - t32);
            s3 = ((0.98078528040323043f*t92) - (0.19509032201612828f*t03));
            s4 = ((0.19509032201612828f*t92) + (0.98078528040323043f*t03));
            s5 = ((0.83146961230254524f*t13) - (0.55557023301960218f*t23));
            s6 = ((0.55557023301960218f*t13) + (0.83146961230254524f*t23));
            a71 = (a + 1024);
            a81 = (a + 1025);
            a91 = (a + 9216);
            a02 = (a + 9217);
            t33 = (*(a71) + *(a91));
            t43 = (*(a81) + *(a02));
            t53 = (*(a71) - *(a91));
            t63 = (*(a81) - *(a02));
            a12 = (a + 5120);
            a22 = (a + 5121);
            a32 = (a + 13312);
            a42 = (a + 13313);
            t73 = (*(a12) + *(a32));
            t83 = (*(a22) + *(a42));
            t93 = (*(a12) - *(a32));
            t04 = (*(a22) - *(a42));
            t14 = (t33 + t73);
            t24 = (t43 + t83);
            a52 = (0.70710678118654757f*(t33 - t73));
            a62 = (0.70710678118654757f*(t43 - t83));
            s7 = (a52 - a62);
            s8 = (a52 + a62);
            t34 = (t53 - t04);
            t44 = (t63 + t93);
            t54 = (t53 + t04);
            t64 = (t63 - t93);
            s9 = ((0.92387953251128674f*t34) - (0.38268343236508978f*t44));
            s01 = ((0.38268343236508978f*t34) + (0.92387953251128674f*t44));
            s11 = ((0.38268343236508978f*t54) - (0.92387953251128674f*t64));
            s21 = ((0.92387953251128674f*t54) + (0.38268343236508978f*t64));
            a72 = (a + 1536);
            a82 = (a + 1537);
            a92 = (a + 9728);
            a03 = (a + 9729);
            t74 = (*(a72) + *(a92));
            t84 = (*(a82) + *(a03));
            t94 = (*(a72) - *(a92));
            t05 = (*(a82) - *(a03));
            a13 = (a + 5632);
            a23 = (a + 5633);
            a33 = (a + 13824);
            a43 = (a + 13825);
            t15 = (*(a13) + *(a33));
            t25 = (*(a23) + *(a43));
            t35 = (*(a13) - *(a33));
            t45 = (*(a23) - *(a43));
            t55 = (t74 + t15);
            t65 = (t84 + t25);
            t75 = (t74 - t15);
            t85 = (t84 - t25);
            s31 = ((0.38268343236508978f*t75) - (0.92387953251128674f*t85));
            s41 = ((0.92387953251128674f*t75) + (0.38268343236508978f*t85));
            t95 = (t94 - t45);
            t06 = (t05 + t35);
            t16 = (t94 + t45);
            t26 = (t05 - t35);
            s51 = ((0.83146961230254524f*t95) - (0.55557023301960218f*t06));
            s61 = ((0.55557023301960218f*t95) + (0.83146961230254524f*t06));
            s71 = ((0.19509032201612828f*t16) + (0.98078528040323043f*t26));
            s81 = ((0.98078528040323043f*t16) - (0.19509032201612828f*t26));
            a53 = (a + 2048);
            a63 = (a + 2049);
            a73 = (a + 10240);
            a83 = (a + 10241);
            t36 = (*(a53) + *(a73));
            t46 = (*(a63) + *(a83));
            t56 = (*(a53) - *(a73));
            t66 = (*(a63) - *(a83));
            a93 = (a + 6144);
            a04 = (a + 6145);
            a14 = (a + 14336);
            a24 = (a + 14337);
            t76 = (*(a93) + *(a14));
            t86 = (*(a04) + *(a24));
            t96 = (*(a93) - *(a14));
            t07 = (*(a04) - *(a24));
            t17 = (t36 + t76);
            t27 = (t46 + t86);
            t37 = (t36 - t76);
            t47 = (t46 - t86);
            a34 = (0.70710678118654757f*(t56 - t07));
            a44 = (0.70710678118654757f*(t66 + t96));
            s91 = (a34 - a44);
            s02 = (a34 + a44);
            a54 = (0.70710678118654757f*(t56 + t07));
            a64 = (0.70710678118654757f*(t66 - t96));
            s12 = (a54 + a64);
            s22 = (a54 - a64);
            a74 = (a + 2560);
            a84 = (a + 2561);
            a94 = (a + 10752);
            a05 = (a + 10753);
            t57 = (*(a74) + *(a94));
            t67 = (*(a84) + *(a05));
            t77 = (*(a74) - *(a94));
            t87 = (*(a84) - *(a05));
            a15 = (a + 6656);
            a25 = (a + 6657);
            a35 = (a + 14848);
            a45 = (a + 14849);
            t97 = (*(a15) + *(a35));
            t08 = (*(a25) + *(a45));
            t18 = (*(a15) - *(a35));
            t28 = (*(a25) - *(a45));
            t38 = (t57 + t97);
            t48 = (t67 + t08);
            t58 = (t57 - t97);
            t68 = (t67 - t08);
            s32 = ((0.38268343236508978f*t58) + (0.92387953251128674f*t68));
            s42 = ((0.92387953251128674f*t58) - (0.38268343236508978f*t68));
            t78 = (t77 - t28);
            t88 = (t87 + t18);
            t98 = (t77 + t28);
            t09 = (t87 - t18);
            s52 = ((0.55557023301960218f*t78) - (0.83146961230254524f*t88));
            s62 = ((0.83146961230254524f*t78) + (0.55557023301960218f*t88));
            s72 = ((0.98078528040323043f*t98) + (0.19509032201612828f*t09));
            s82 = ((0.19509032201612828f*t98) - (0.98078528040323043f*t09));
            a55 = (a + 3072);
            a65 = (a + 3073);
            a75 = (a + 11264);
            a85 = (a + 11265);
            t19 = (*(a55) + *(a75));
            t29 = (*(a65) + *(a85));
            t39 = (*(a55) - *(a75));
            t49 = (*(a65) - *(a85));
            a95 = (a + 7168);
            a06 = (a + 7169);
            a16 = (a + 15360);
            a26 = (a + 15361);
            t59 = (*(a95) + *(a16));
            t69 = (*(a06) + *(a26));
            t79 = (*(a95) - *(a16));
            t89 = (*(a06) - *(a26));
            t99 = (t19 + t59);
            t0a = (t29 + t69);
            a36 = (0.70710678118654757f*(t19 - t59));
            a46 = (0.70710678118654757f*(t29 - t69));
            s92 = (a36 + a46);
            s03 = (a36 - a46);
            t1a = (t39 - t89);
            t2a = (t49 + t79);
            t3a = (t39 + t89);
            t4a = (t49 - t79);
            s13 = ((0.38268343236508978f*t1a) - (0.92387953251128674f*t2a));
            s23 = ((0.92387953251128674f*t1a) + (0.38268343236508978f*t2a));
            s33 = ((0.38268343236508978f*t4a) - (0.92387953251128674f*t3a));
            s43 = ((0.38268343236508978f*t3a) + (0.92387953251128674f*t4a));
            a56 = (a + 3584);
            a66 = (a + 3585);
            a76 = (a + 11776);
            a86 = (a + 11777);
            t5a = (*(a56) + *(a76));
            t6a = (*(a66) + *(a86));
            t7a = (*(a56) - *(a76));
            t8a = (*(a66) - *(a86));
            a96 = (a + 7680);
            a07 = (a + 7681);
            a17 = (a + 15872);
            a27 = (a + 15873);
            t9a = (*(a96) + *(a17));
            t0b = (*(a07) + *(a27));
            t1b = (*(a96) - *(a17));
            t2b = (*(a07) - *(a27));
            t3b = (t5a + t9a);
            t4b = (t6a + t0b);
            t5b = (t5a - t9a);
            t6b = (t6a - t0b);
            s53 = ((0.92387953251128674f*t5b) + (0.38268343236508978f*t6b));
            s63 = ((0.38268343236508978f*t5b) - (0.92387953251128674f*t6b));
            t7b = (t7a - t2b);
            t8b = (t8a + t1b);
            t9b = (t7a + t2b);
            t0c = (t8a - t1b);
            s73 = ((0.19509032201612828f*t7b) - (0.98078528040323043f*t8b));
            s83 = ((0.98078528040323043f*t7b) + (0.19509032201612828f*t8b));
            s93 = ((0.83146961230254524f*t0c) - (0.55557023301960218f*t9b));
            s04 = ((0.83146961230254524f*t9b) + (0.55557023301960218f*t0c));
            t1c = (t9 + t17);
            t2c = (t01 + t27);
            t3c = (t9 - t17);
            t4c = (t01 - t27);
            t5c = (t52 + t38);
            t6c = (t62 + t48);
            a37 = (0.70710678118654757f*(t52 - t38));
            a47 = (0.70710678118654757f*(t62 - t48));
            s14 = (a37 - a47);
            s24 = (a37 + a47);
            t7c = (t14 + t99);
            t8c = (t24 + t0a);
            t9c = (t14 - t99);
            t0d = (t24 - t0a);
            t1d = (t55 + t3b);
            t2d = (t65 + t4b);
            a57 = (0.70710678118654757f*(t55 - t3b));
            a67 = (0.70710678118654757f*(t65 - t4b));
            s34 = (a57 + a67);
            s44 = (a57 - a67);
            t3d = (t1c + t7c);
            t4d = (t2c + t8c);
            t5d = (t1c - t7c);
            t6d = (t2c - t8c);
            t7d = (t5c + t1d);
            t8d = (t6c + t2d);
            t9d = (t5c - t1d);
            t0e = (t6c - t2d);
            t1e = (t3d + t7d);
            t2e = (t4d + t8d);
            t3e = (t3d - t7d);
            t4e = (t4d - t8d);
            a77 = (64*i2);
            a87 = (D271 + a77);
            a97 = (a87 + 1);
            a08 = (a87 + 2);
            a18 = (a87 + 3);
            a28 = (T2 + a77);
            *(a28) = ((*(a87)*t1e) - (*(a97)*t2e));
            *((a28 + 1)) = ((*(a97)*t1e) + (*(a87)*t2e));
            *((a28 + 32)) = ((*(a08)*t3e) - (*(a18)*t4e));
            *((a28 + 33)) = ((*(a18)*t3e) + (*(a08)*t4e));
            t5e = (t5d - t0e);
            t6e = (t6d + t9d);
            t7e = (t5d + t0e);
            t8e = (t6d - t9d);
            a38 = (a87 + 4);
            a48 = (a87 + 5);
            a58 = (a87 + 6);
            a68 = (a87 + 7);
            *((a28 + 16)) = ((*(a38)*t5e) - (*(a48)*t6e));
            *((a28 + 17)) = ((*(a48)*t5e) + (*(a38)*t6e));
            *((a28 + 48)) = ((*(a58)*t7e) - (*(a68)*t8e));
            *((a28 + 49)) = ((*(a68)*t7e) + (*(a58)*t8e));
            t9e = (t3c - t0d);
            t0f = (t4c + t9c);
            t1f = (t3c + t0d);
            t2f = (t4c - t9c);
            t3f = (s14 - s34);
            t4f = (s24 + s44);
            t5f = (s14 + s34);
            t6f = (s24 - s44);
            t7f = (t9e + t3f);
            t8f = (t0f + t4f);
            t9f = (t9e - t3f);
            t0g = (t0f - t4f);
            a78 = (a87 + 8);
            a88 = (a87 + 9);
            a98 = (a87 + 10);
            a09 = (a87 + 11);
            *((a28 + 8)) = ((*(a78)*t7f) - (*(a88)*t8f));
            *((a28 + 9)) = ((*(a88)*t7f) + (*(a78)*t8f));
            *((a28 + 40)) = ((*(a98)*t9f) - (*(a09)*t0g));
            *((a28 + 41)) = ((*(a09)*t9f) + (*(a98)*t0g));
            t1g = (t1f - t6f);
            t2g = (t2f + t5f);
            t3g = (t1f + t6f);
            t4g = (t2f - t5f);
            a19 = (a87 + 12);
            a29 = (a87 + 13);
            a39 = (a87 + 14);
            a49 = (a87 + 15);
            *((a28 + 24)) = ((*(a19)*t1g) - (*(a29)*t2g));
            *((a28 + 25)) = ((*(a29)*t1g) + (*(a19)*t2g));
            *((a28 + 56)) = ((*(a39)*t3g) - (*(a49)*t4g));
            *((a28 + 57)) = ((*(a49)*t3g) + (*(a39)*t4g));
            t5g = (t31 + s91);
            t6g = (t41 + s02);
            t7g = (t31 - s91);
            t8g = (t41 - s02);
            t9g = (s3 + s52);
            t0h = (s4 + s62);
            a59 = (0.70710678118654757f*(s3 - s52));
            a69 = (0.70710678118654757f*(s4 - s62));
            s54 = (a59 - a69);
            s64 = (a59 + a69);
            t1h = (s9 + s13);
            t2h = (s01 + s23);
            t3h = (s9 - s13);
            t4h = (s01 - s23);
            t5h = (s51 + s73);
            t6h = (s61 + s83);
            a79 = (0.70710678118654757f*(s51 - s73));
            a89 = (0.70710678118654757f*(s61 - s83));
            s74 = (a79 + a89);
            s84 = (a79 - a89);
            t7h = (t5g + t1h);
            t8h = (t6g + t2h);
            t9h = (t5g - t1h);
            t0i = (t6g - t2h);
            t1i = (t9g + t5h);
            t2i = (t0h + t6h);
            t3i = (t9g - t5h);
            t4i = (t0h - t6h);
            t5i = (t7h + t1i);
            t6i = (t8h + t2i);
            t7i = (t7h - t1i);
            t8i = (t8h - t2i);
            a99 = (a87 + 16);
            a0a = (a87 + 17);
            a1a = (a87 + 18);
            a2a = (a87 + 19);
            *((a28 + 2)) = ((*(a99)*t5i) - (*(a0a)*t6i));
            *((a28 + 3)) = ((*(a0a)*t5i) + (*(a99)*t6i));
            *((a28 + 34)) = ((*(a1a)*t7i) - (*(a2a)*t8i));
            *((a28 + 35)) = ((*(a2a)*t7i) + (*(a1a)*t8i));
            t9i = (t9h - t4i);
            t0j = (t0i + t3i);
            t1j = (t9h + t4i);
            t2j = (t0i - t3i);
            a3a = (a87 + 20);
            a4a = (a87 + 21);
            a5a = (a87 + 22);
            a6a = (a87 + 23);
            *((a28 + 18)) = ((*(a3a)*t9i) - (*(a4a)*t0j));
            *((a28 + 19)) = ((*(a4a)*t9i) + (*(a3a)*t0j));
            *((a28 + 50)) = ((*(a5a)*t1j) - (*(a6a)*t2j));
            *((a28 + 51)) = ((*(a6a)*t1j) + (*(a5a)*t2j));
            t3j = (t7g - t4h);
            t4j = (t8g + t3h);
            t5j = (t7g + t4h);
            t6j = (t8g - t3h);
            t7j = (s54 - s74);
            t8j = (s64 + s84);
            t9j = (s54 + s74);
            t0k = (s64 - s84);
            t1k = (t3j + t7j);
            t2k = (t4j + t8j);
            t3k = (t3j - t7j);
            t4k = (t4j - t8j);
            a7a = (a87 + 24);
            a8a = (a87 + 25);
            a9a = (a87 + 26);
            a0b = (a87 + 27);
            *((a28 + 10)) = ((*(a7a)*t1k) - (*(a8a)*t2k));
            *((a28 + 11)) = ((*(a8a)*t1k) + (*(a7a)*t2k));
            *((a28 + 42)) = ((*(a9a)*t3k) - (*(a0b)*t4k));
            *((a28 + 43)) = ((*(a0b)*t3k) + (*(a9a)*t4k));
            t5k = (t5j - t0k);
            t6k = (t6j + t9j);
            t7k = (t5j + t0k);
            t8k = (t6j - t9j);
            a1b = (a87 + 28);
            a2b = (a87 + 29);
            a3b = (a87 + 30);
            a4b = (a87 + 31);
            *((a28 + 26)) = ((*(a1b)*t5k) - (*(a2b)*t6k));
            *((a28 + 27)) = ((*(a2b)*t5k) + (*(a1b)*t6k));
            *((a28 + 58)) = ((*(a3b)*t7k) - (*(a4b)*t8k));
            *((a28 + 59)) = ((*(a4b)*t7k) + (*(a3b)*t8k));
            t9k = (t11 - t47);
            t0l = (t21 + t37);
            t1l = (t11 + t47);
            t2l = (t21 - t37);
            t3l = (s - s32);
            t4l = (s2 + s42);
            a5b = (0.70710678118654757f*(s + s32));
            a6b = (0.70710678118654757f*(s2 - s42));
            s94 = (a5b - a6b);
            s05 = (a5b + a6b);
            t5l = (s7 - s92);
            t6l = (s8 + s03);
            t7l = (s7 + s92);
            t8l = (s8 - s03);
            t9l = (s31 - s53);
            t0m = (s41 + s63);
            a7b = (0.70710678118654757f*(s31 + s53));
            a8b = (0.70710678118654757f*(s41 - s63));
            s15 = (a7b + a8b);
            s25 = (a7b - a8b);
            t1m = (t9k + t5l);
            t2m = (t0l + t6l);
            t3m = (t9k - t5l);
            t4m = (t0l - t6l);
            t5m = (t3l + t9l);
            t6m = (t4l + t0m);
            t7m = (t3l - t9l);
            t8m = (t4l - t0m);
            t9m = (t1m + t5m);
            t0n = (t2m + t6m);
            t1n = (t1m - t5m);
            t2n = (t2m - t6m);
            a9b = (a87 + 32);
            a0c = (a87 + 33);
            a1c = (a87 + 34);
            a2c = (a87 + 35);
            *((a28 + 4)) = ((*(a9b)*t9m) - (*(a0c)*t0n));
            *((a28 + 5)) = ((*(a0c)*t9m) + (*(a9b)*t0n));
            *((a28 + 36)) = ((*(a1c)*t1n) - (*(a2c)*t2n));
            *((a28 + 37)) = ((*(a2c)*t1n) + (*(a1c)*t2n));
            t3n = (t3m - t8m);
            t4n = (t4m + t7m);
            t5n = (t3m + t8m);
            t6n = (t4m - t7m);
            a3c = (a87 + 36);
            a4c = (a87 + 37);
            a5c = (a87 + 38);
            a6c = (a87 + 39);
            *((a28 + 20)) = ((*(a3c)*t3n) - (*(a4c)*t4n));
            *((a28 + 21)) = ((*(a4c)*t3n) + (*(a3c)*t4n));
            *((a28 + 52)) = ((*(a5c)*t5n) - (*(a6c)*t6n));
            *((a28 + 53)) = ((*(a6c)*t5n) + (*(a5c)*t6n));
            t7n = (t1l - t8l);
            t8n = (t2l + t7l);
            t9n = (t1l + t8l);
            t0o = (t2l - t7l);
            t1o = (s94 - s15);
            t2o = (s05 + s25);
            t3o = (s94 + s15);
            t4o = (s05 - s25);
            t5o = (t7n + t1o);
            t6o = (t8n + t2o);
            t7o = (t7n - t1o);
            t8o = (t8n - t2o);
            a7c = (a87 + 40);
            a8c = (a87 + 41);
            a9c = (a87 + 42);
            a0d = (a87 + 43);
            *((a28 + 12)) = ((*(a7c)*t5o) - (*(a8c)*t6o));
            *((a28 + 13)) = ((*(a8c)*t5o) + (*(a7c)*t6o));
            *((a28 + 44)) = ((*(a9c)*t7o) - (*(a0d)*t8o));
            *((a28 + 45)) = ((*(a0d)*t7o) + (*(a9c)*t8o));
            t9o = (t9n - t4o);
            t0p = (t0o + t3o);
            t1p = (t9n + t4o);
            t2p = (t0o - t3o);
            a1d = (a87 + 44);
            a2d = (a87 + 45);
            a3d = (a87 + 46);
            a4d = (a87 + 47);
            *((a28 + 28)) = ((*(a1d)*t9o) - (*(a2d)*t0p));
            *((a28 + 29)) = ((*(a2d)*t9o) + (*(a1d)*t0p));
            *((a28 + 60)) = ((*(a3d)*t1p) - (*(a4d)*t2p));
            *((a28 + 61)) = ((*(a4d)*t1p) + (*(a3d)*t2p));
            t3p = (t51 - s12);
            t4p = (t61 + s22);
            t5p = (t51 + s12);
            t6p = (t61 - s22);
            t7p = (s5 - s72);
            t8p = (s6 + s82);
            a5d = (0.70710678118654757f*(s5 + s72));
            a6d = (0.70710678118654757f*(s6 - s82));
            s35 = (a5d - a6d);
            s45 = (a5d + a6d);
            t9p = (s11 + s33);
            t0q = (s21 - s43);
            t1q = (s11 - s33);
            t2q = (s21 + s43);
            t3q = (s93 - s71);
            t4q = (s81 - s04);
            a7d = (0.70710678118654757f*(s71 + s93));
            a8d = (0.70710678118654757f*(s81 + s04));
            s55 = (a7d - a8d);
            s65 = (a7d + a8d);
            t5q = (t3p + t9p);
            t6q = (t4p + t0q);
            t7q = (t3p - t9p);
            t8q = (t4p - t0q);
            t9q = (t7p + t3q);
            t0r = (t8p + t4q);
            t1r = (t7p - t3q);
            t2r = (t8p - t4q);
            t3r = (t5q + t9q);
            t4r = (t6q + t0r);
            t5r = (t5q - t9q);
            t6r = (t6q - t0r);
            a9d = (a87 + 48);
            a0e = (a87 + 49);
            a1e = (a87 + 50);
            a2e = (a87 + 51);
            *((a28 + 6)) = ((*(a9d)*t3r) - (*(a0e)*t4r));
            *((a28 + 7)) = ((*(a0e)*t3r) + (*(a9d)*t4r));
            *((a28 + 38)) = ((*(a1e)*t5r) - (*(a2e)*t6r));
            *((a28 + 39)) = ((*(a2e)*t5r) + (*(a1e)*t6r));
            t7r = (t7q - t2r);
            t8r = (t8q + t1r);
            t9r = (t7q + t2r);
            t0s = (t8q - t1r);
            a3e = (a87 + 52);
            a4e = (a87 + 53);
            a5e = (a87 + 54);
            a6e = (a87 + 55);
            *((a28 + 22)) = ((*(a3e)*t7r) - (*(a4e)*t8r));
            *((a28 + 23)) = ((*(a4e)*t7r) + (*(a3e)*t8r));
            *((a28 + 54)) = ((*(a5e)*t9r) - (*(a6e)*t0s));
            *((a28 + 55)) = ((*(a6e)*t9r) + (*(a5e)*t0s));
            t1s = (t5p - t2q);
            t2s = (t6p + t1q);
            t3s = (t5p + t2q);
            t4s = (t6p - t1q);
            t5s = (s35 + s55);
            t6s = (s45 - s65);
            t7s = (s35 - s55);
            t8s = (s45 + s65);
            t9s = (t1s + t5s);
            t0t = (t2s + t6s);
            t1t = (t1s - t5s);
            t2t = (t2s - t6s);
            a7e = (a87 + 56);
            a8e = (a87 + 57);
            a9e = (a87 + 58);
            a0f = (a87 + 59);
            *((a28 + 14)) = ((*(a7e)*t9s) - (*(a8e)*t0t));
            *((a28 + 15)) = ((*(a8e)*t9s) + (*(a7e)*t0t));
            *((a28 + 46)) = ((*(a9e)*t1t) - (*(a0f)*t2t));
            *((a28 + 47)) = ((*(a0f)*t1t) + (*(a9e)*t2t));
            t3t = (t3s - t8s);
            t4t = (t4s + t7s);
            t5t = (t3s + t8s);
            t6t = (t4s - t7s);
            a1f = (a87 + 60);
            a2f = (a87 + 61);
            a3f = (a87 + 62);
            a4f = (a87 + 63);
            *((a28 + 30)) = ((*(a1f)*t3t) - (*(a2f)*t4t));
            *((a28 + 31)) = ((*(a2f)*t3t) + (*(a1f)*t4t));
            *((a28 + 62)) = ((*(a3f)*t5t) - (*(a4f)*t6t));
            *((a28 + 63)) = ((*(a4f)*t5t) + (*(a3f)*t6t));
        }}
        {long i3; for(i3 = 0; i3 <= 31; i3++) {
            a5f = (2*i3);
            a6f = (T2 + a5f);
            a7f = (a6f + 1);
            a8f = (a6f + 1024);
            a9f = (a6f + 1025);
            t7t = (*(a6f) + *(a8f));
            t8t = (*(a7f) + *(a9f));
            t9t = (*(a6f) - *(a8f));
            t0u = (*(a7f) - *(a9f));
            a0g = (a6f + 512);
            a1g = (a6f + 513);
            a2g = (a6f + 1536);
            a3g = (a6f + 1537);
            t1u = (*(a0g) + *(a2g));
            t2u = (*(a1g) + *(a3g));
            t3u = (*(a0g) - *(a2g));
            t4u = (*(a1g) - *(a3g));
            t5u = (t7t + t1u);
            t6u = (t8t + t2u);
            t7u = (t7t - t1u);
            t8u = (t8t - t2u);
            t9u = (t9t - t4u);
            t0v = (t0u + t3u);
            t1v = (t9t + t4u);
            t2v = (t0u - t3u);
            a4g = (a6f + 64);
            a5g = (a6f + 65);
            a6g = (a6f + 1088);
            a7g = (a6f + 1089);
            t3v = (*(a4g) + *(a6g));
            t4v = (*(a5g) + *(a7g));
            t5v = (*(a4g) - *(a6g));
            t6v = (*(a5g) - *(a7g));
            a8g = (a6f + 576);
            a9g = (a6f + 577);
            a0h = (a6f + 1600);
            a1h = (a6f + 1601);
            t7v = (*(a8g) + *(a0h));
            t8v = (*(a9g) + *(a1h));
            t9v = (*(a8g) - *(a0h));
            t0w = (*(a9g) - *(a1h));
            t1w = (t3v + t7v);
            t2w = (t4v + t8v);
            t3w = (t3v - t7v);
            t4w = (t4v - t8v);
            s75 = ((0.92387953251128674f*t3w) - (0.38268343236508978f*t4w));
            s85 = ((0.38268343236508978f*t3w) + (0.92387953251128674f*t4w));
            t5w = (t5v - t0w);
            t6w = (t6v + t9v);
            t7w = (t5v + t0w);
            t8w = (t6v - t9v);
            s95 = ((0.98078528040323043f*t5w) - (0.19509032201612828f*t6w));
            s06 = ((0.19509032201612828f*t5w) + (0.98078528040323043f*t6w));
            s16 = ((0.83146961230254524f*t7w) - (0.55557023301960218f*t8w));
            s26 = ((0.55557023301960218f*t7w) + (0.83146961230254524f*t8w));
            a2h = (a6f + 128);
            a3h = (a6f + 129);
            a4h = (a6f + 1152);
            a5h = (a6f + 1153);
            t9w = (*(a2h) + *(a4h));
            t0x = (*(a3h) + *(a5h));
            t1x = (*(a2h) - *(a4h));
            t2x = (*(a3h) - *(a5h));
            a6h = (a6f + 640);
            a7h = (a6f + 641);
            a8h = (a6f + 1664);
            a9h = (a6f + 1665);
            t3x = (*(a6h) + *(a8h));
            t4x = (*(a7h) + *(a9h));
            t5x = (*(a6h) - *(a8h));
            t6x = (*(a7h) - *(a9h));
            t7x = (t9w + t3x);
            t8x = (t0x + t4x);
            a0i = (0.70710678118654757f*(t9w - t3x));
            a1i = (0.70710678118654757f*(t0x - t4x));
            s36 = (a0i - a1i);
            s46 = (a0i + a1i);
            t9x = (t1x - t6x);
            t0y = (t2x + t5x);
            t1y = (t1x + t6x);
            t2y = (t2x - t5x);
            s56 = ((0.92387953251128674f*t9x) - (0.38268343236508978f*t0y));
            s66 = ((0.38268343236508978f*t9x) + (0.92387953251128674f*t0y));
            s76 = ((0.38268343236508978f*t1y) - (0.92387953251128674f*t2y));
            s86 = ((0.92387953251128674f*t1y) + (0.38268343236508978f*t2y));
            a2i = (a6f + 192);
            a3i = (a6f + 193);
            a4i = (a6f + 1216);
            a5i = (a6f + 1217);
            t3y = (*(a2i) + *(a4i));
            t4y = (*(a3i) + *(a5i));
            t5y = (*(a2i) - *(a4i));
            t6y = (*(a3i) - *(a5i));
            a6i = (a6f + 704);
            a7i = (a6f + 705);
            a8i = (a6f + 1728);
            a9i = (a6f + 1729);
            t7y = (*(a6i) + *(a8i));
            t8y = (*(a7i) + *(a9i));
            t9y = (*(a6i) - *(a8i));
            t0z = (*(a7i) - *(a9i));
            t1z = (t3y + t7y);
            t2z = (t4y + t8y);
            t3z = (t3y - t7y);
            t4z = (t4y - t8y);
            s96 = ((0.38268343236508978f*t3z) - (0.92387953251128674f*t4z));
            s07 = ((0.92387953251128674f*t3z) + (0.38268343236508978f*t4z));
            t5z = (t5y - t0z);
            t6z = (t6y + t9y);
            t7z = (t5y + t0z);
            t8z = (t6y - t9y);
            s17 = ((0.83146961230254524f*t5z) - (0.55557023301960218f*t6z));
            s27 = ((0.55557023301960218f*t5z) + (0.83146961230254524f*t6z));
            s37 = ((0.19509032201612828f*t7z) + (0.98078528040323043f*t8z));
            s47 = ((0.98078528040323043f*t7z) - (0.19509032201612828f*t8z));
            a0j = (a6f + 256);
            a1j = (a6f + 257);
            a2j = (a6f + 1280);
            a3j = (a6f + 1281);
            t9z = (*(a0j) + *(a2j));
            t0A = (*(a1j) + *(a3j));
            t1A = (*(a0j) - *(a2j));
            t2A = (*(a1j) - *(a3j));
            a4j = (a6f + 768);
            a5j = (a6f + 769);
            a6j = (a6f + 1792);
            a7j = (a6f + 1793);
            t3A = (*(a4j) + *(a6j));
            t4A = (*(a5j) + *(a7j));
            t5A = (*(a4j) - *(a6j));
            t6A = (*(a5j) - *(a7j));
            t7A = (t9z + t3A);
            t8A = (t0A + t4A);
            t9A = (t9z - t3A);
            t0B = (t0A - t4A);
            a8j = (0.70710678118654757f*(t1A - t6A));
            a9j = (0.70710678118654757f*(t2A + t5A));
            s57 = (a8j - a9j);
            s67 = (a8j + a9j);
            a0k = (0.70710678118654757f*(t1A + t6A));
            a1k = (0.70710678118654757f*(t2A - t5A));
            s77 = (a0k + a1k);
            s87 = (a0k - a1k);
            a2k = (a6f + 320);
            a3k = (a6f + 321);
            a4k = (a6f + 1344);
            a5k = (a6f + 1345);
            t1B = (*(a2k) + *(a4k));
            t2B = (*(a3k) + *(a5k));
            t3B = (*(a2k) - *(a4k));
            t4B = (*(a3k) - *(a5k));
            a6k = (a6f + 832);
            a7k = (a6f + 833);
            a8k = (a6f + 1856);
            a9k = (a6f + 1857);
            t5B = (*(a6k) + *(a8k));
            t6B = (*(a7k) + *(a9k));
            t7B = (*(a6k) - *(a8k));
            t8B = (*(a7k) - *(a9k));
            t9B = (t1B + t5B);
            t0C = (t2B + t6B);
            t1C = (t1B - t5B);
            t2C = (t2B - t6B);
            s97 = ((0.38268343236508978f*t1C) + (0.92387953251128674f*t2C));
            s08 = ((0.92387953251128674f*t1C) - (0.38268343236508978f*t2C));
            t3C = (t3B - t8B);
            t4C = (t4B + t7B);
            t5C = (t3B + t8B);
            t6C = (t4B - t7B);
            s18 = ((0.55557023301960218f*t3C) - (0.83146961230254524f*t4C));
            s28 = ((0.83146961230254524f*t3C) + (0.55557023301960218f*t4C));
            s38 = ((0.98078528040323043f*t5C) + (0.19509032201612828f*t6C));
            s48 = ((0.19509032201612828f*t5C) - (0.98078528040323043f*t6C));
            a0l = (a6f + 384);
            a1l = (a6f + 385);
            a2l = (a6f + 1408);
            a3l = (a6f + 1409);
            t7C = (*(a0l) + *(a2l));
            t8C = (*(a1l) + *(a3l));
            t9C = (*(a0l) - *(a2l));
            t0D = (*(a1l) - *(a3l));
            a4l = (a6f + 896);
            a5l = (a6f + 897);
            a6l = (a6f + 1920);
            a7l = (a6f + 1921);
            t1D = (*(a4l) + *(a6l));
            t2D = (*(a5l) + *(a7l));
            t3D = (*(a4l) - *(a6l));
            t4D = (*(a5l) - *(a7l));
            t5D = (t7C + t1D);
            t6D = (t8C + t2D);
            a8l = (0.70710678118654757f*(t7C - t1D));
            a9l = (0.70710678118654757f*(t8C - t2D));
            s58 = (a8l + a9l);
            s68 = (a8l - a9l);
            t7D = (t9C - t4D);
            t8D = (t0D + t3D);
            t9D = (t9C + t4D);
            t0E = (t0D - t3D);
            s78 = ((0.38268343236508978f*t7D) - (0.92387953251128674f*t8D));
            s88 = ((0.92387953251128674f*t7D) + (0.38268343236508978f*t8D));
            s98 = ((0.38268343236508978f*t0E) - (0.92387953251128674f*t9D));
            s09 = ((0.38268343236508978f*t9D) + (0.92387953251128674f*t0E));
            a0m = (a6f + 448);
            a1m = (a6f + 449);
            a2m = (a6f + 1472);
            a3m = (a6f + 1473);
            t1E = (*(a0m) + *(a2m));
            t2E = (*(a1m) + *(a3m));
            t3E = (*(a0m) - *(a2m));
            t4E = (*(a1m) - *(a3m));
            a4m = (a6f + 960);
            a5m = (a6f + 961);
            a6m = (a6f + 1984);
            a7m = (a6f + 1985);
            t5E = (*(a4m) + *(a6m));
            t6E = (*(a5m) + *(a7m));
            t7E = (*(a4m) - *(a6m));
            t8E = (*(a5m) - *(a7m));
            t9E = (t1E + t5E);
            t0F = (t2E + t6E);
            t1F = (t1E - t5E);
            t2F = (t2E - t6E);
            s19 = ((0.92387953251128674f*t1F) + (0.38268343236508978f*t2F));
            s29 = ((0.38268343236508978f*t1F) - (0.92387953251128674f*t2F));
            t3F = (t3E - t8E);
            t4F = (t4E + t7E);
            t5F = (t3E + t8E);
            t6F = (t4E - t7E);
            s39 = ((0.19509032201612828f*t3F) - (0.98078528040323043f*t4F));
            s49 = ((0.98078528040323043f*t3F) + (0.19509032201612828f*t4F));
            s59 = ((0.83146961230254524f*t6F) - (0.55557023301960218f*t5F));
            s69 = ((0.83146961230254524f*t5F) + (0.55557023301960218f*t6F));
            t7F = (t5u + t7A);
            t8F = (t6u + t8A);
            t9F = (t5u - t7A);
            t0G = (t6u - t8A);
            t1G = (t1w + t9B);
            t2G = (t2w + t0C);
            a8m = (0.70710678118654757f*(t1w - t9B));
            a9m = (0.70710678118654757f*(t2w - t0C));
            s79 = (a8m - a9m);
            s89 = (a8m + a9m);
            t3G = (t7x + t5D);
            t4G = (t8x + t6D);
            t5G = (t7x - t5D);
            t6G = (t8x - t6D);
            t7G = (t1z + t9E);
            t8G = (t2z + t0F);
            a0n = (0.70710678118654757f*(t1z - t9E));
            a1n = (0.70710678118654757f*(t2z - t0F));
            s99 = (a0n + a1n);
            s0a = (a0n - a1n);
            t9G = (t7F + t3G);
            t0H = (t8F + t4G);
            t1H = (t7F - t3G);
            t2H = (t8F - t4G);
            t3H = (t1G + t7G);
            t4H = (t2G + t8G);
            t5H = (t1G - t7G);
            t6H = (t2G - t8G);
            t7H = (t9G + t3H);
            t8H = (t0H + t4H);
            t9H = (t9G - t3H);
            t0I = (t0H - t4H);
            a2n = (2048*i);
            a3n = (D274 + a2n + (64*i3));
            a4n = (a3n + 1);
            a5n = (a3n + 2);
            a6n = (a3n + 3);
            a7n = (T + a2n + a5f);
            *(a7n) = ((*(a3n)*t7H) - (*(a4n)*t8H));
            *((a7n + 1)) = ((*(a4n)*t7H) + (*(a3n)*t8H));
            *((a7n + 1024)) = ((*(a5n)*t9H) - (*(a6n)*t0I));
            *((a7n + 1025)) = ((*(a6n)*t9H) + (*(a5n)*t0I));
            t1I = (t1H - t6H);
            t2I = (t2H + t5H);
            t3I = (t1H + t6H);
            t4I = (t2H - t5H);
            a8n = (a3n + 4);
            a9n = (a3n + 5);
            a0o = (a3n + 6);
            a1o = (a3n + 7);
            *((a7n + 512)) = ((*(a8n)*t1I) - (*(a9n)*t2I));
            *((a7n + 513)) = ((*(a9n)*t1I) + (*(a8n)*t2I));
            *((a7n + 1536)) = ((*(a0o)*t3I) - (*(a1o)*t4I));
            *((a7n + 1537)) = ((*(a1o)*t3I) + (*(a0o)*t4I));
            t5I = (t9F - t6G);
            t6I = (t0G + t5G);
            t7I = (t9F + t6G);
            t8I = (t0G - t5G);
            t9I = (s79 - s99);
            t0J = (s89 + s0a);
            t1J = (s79 + s99);
            t2J = (s89 - s0a);
            t3J = (t5I + t9I);
            t4J = (t6I + t0J);
            t5J = (t5I - t9I);
            t6J = (t6I - t0J);
            a2o = (a3n + 8);
            a3o = (a3n + 9);
            a4o = (a3n + 10);
            a5o = (a3n + 11);
            *((a7n + 256)) = ((*(a2o)*t3J) - (*(a3o)*t4J));
            *((a7n + 257)) = ((*(a3o)*t3J) + (*(a2o)*t4J));
            *((a7n + 1280)) = ((*(a4o)*t5J) - (*(a5o)*t6J));
            *((a7n + 1281)) = ((*(a5o)*t5J) + (*(a4o)*t6J));
            t7J = (t7I - t2J);
            t8J = (t8I + t1J);
            t9J = (t7I + t2J);
            t0K = (t8I - t1J);
            a6o = (a3n + 12);
            a7o = (a3n + 13);
            a8o = (a3n + 14);
            a9o = (a3n + 15);
            *((a7n + 768)) = ((*(a6o)*t7J) - (*(a7o)*t8J));
            *((a7n + 769)) = ((*(a7o)*t7J) + (*(a6o)*t8J));
            *((a7n + 1792)) = ((*(a8o)*t9J) - (*(a9o)*t0K));
            *((a7n + 1793)) = ((*(a9o)*t9J) + (*(a8o)*t0K));
            t1K = (t9u + s57);
            t2K = (t0v + s67);
            t3K = (t9u - s57);
            t4K = (t0v - s67);
            t5K = (s95 + s18);
            t6K = (s06 + s28);
            a0p = (0.70710678118654757f*(s95 - s18));
            a1p = (0.70710678118654757f*(s06 - s28));
            s1a = (a0p - a1p);
            s2a = (a0p + a1p);
            t7K = (s56 + s78);
            t8K = (s66 + s88);
            t9K = (s56 - s78);
            t0L = (s66 - s88);
            t1L = (s17 + s39);
            t2L = (s27 + s49);
            a2p = (0.70710678118654757f*(s17 - s39));
            a3p = (0.70710678118654757f*(s27 - s49));
            s3a = (a2p + a3p);
            s4a = (a2p - a3p);
            t3L = (t1K + t7K);
            t4L = (t2K + t8K);
            t5L = (t1K - t7K);
            t6L = (t2K - t8K);
            t7L = (t5K + t1L);
            t8L = (t6K + t2L);
            t9L = (t5K - t1L);
            t0M = (t6K - t2L);
            t1M = (t3L + t7L);
            t2M = (t4L + t8L);
            t3M = (t3L - t7L);
            t4M = (t4L - t8L);
            a4p = (a3n + 16);
            a5p = (a3n + 17);
            a6p = (a3n + 18);
            a7p = (a3n + 19);
            *((a7n + 64)) = ((*(a4p)*t1M) - (*(a5p)*t2M));
            *((a7n + 65)) = ((*(a5p)*t1M) + (*(a4p)*t2M));
            *((a7n + 1088)) = ((*(a6p)*t3M) - (*(a7p)*t4M));
            *((a7n + 1089)) = ((*(a7p)*t3M) + (*(a6p)*t4M));
            t5M = (t5L - t0M);
            t6M = (t6L + t9L);
            t7M = (t5L + t0M);
            t8M = (t6L - t9L);
            a8p = (a3n + 20);
            a9p = (a3n + 21);
            a0q = (a3n + 22);
            a1q = (a3n + 23);
            *((a7n + 576)) = ((*(a8p)*t5M) - (*(a9p)*t6M));
            *((a7n + 577)) = ((*(a9p)*t5M) + (*(a8p)*t6M));
            *((a7n + 1600)) = ((*(a0q)*t7M) - (*(a1q)*t8M));
            *((a7n + 1601)) = ((*(a1q)*t7M) + (*(a0q)*t8M));
            t9M = (t3K - t0L);
            t0N = (t4K + t9K);
            t1N = (t3K + t0L);
            t2N = (t4K - t9K);
            t3N = (s1a - s3a);
            t4N = (s2a + s4a);
            t5N = (s1a + s3a);
            t6N = (s2a - s4a);
            t7N = (t9M + t3N);
            t8N = (t0N + t4N);
            t9N = (t9M - t3N);
            t0O = (t0N - t4N);
            a2q = (a3n + 24);
            a3q = (a3n + 25);
            a4q = (a3n + 26);
            a5q = (a3n + 27);
            *((a7n + 320)) = ((*(a2q)*t7N) - (*(a3q)*t8N));
            *((a7n + 321)) = ((*(a3q)*t7N) + (*(a2q)*t8N));
            *((a7n + 1344)) = ((*(a4q)*t9N) - (*(a5q)*t0O));
            *((a7n + 1345)) = ((*(a5q)*t9N) + (*(a4q)*t0O));
            t1O = (t1N - t6N);
            t2O = (t2N + t5N);
            t3O = (t1N + t6N);
            t4O = (t2N - t5N);
            a6q = (a3n + 28);
            a7q = (a3n + 29);
            a8q = (a3n + 30);
            a9q = (a3n + 31);
            *((a7n + 832)) = ((*(a6q)*t1O) - (*(a7q)*t2O));
            *((a7n + 833)) = ((*(a7q)*t1O) + (*(a6q)*t2O));
            *((a7n + 1856)) = ((*(a8q)*t3O) - (*(a9q)*t4O));
            *((a7n + 1857)) = ((*(a9q)*t3O) + (*(a8q)*t4O));
            t5O = (t7u - t0B);
            t6O = (t8u + t9A);
            t7O = (t7u + t0B);
            t8O = (t8u - t9A);
            t9O = (s75 - s97);
            t0P = (s85 + s08);
            a0r = (0.70710678118654757f*(s75 + s97));
            a1r = (0.70710678118654757f*(s85 - s08));
            s5a = (a0r - a1r);
            s6a = (a0r + a1r);
            t1P = (s36 - s58);
            t2P = (s46 + s68);
            t3P = (s36 + s58);
            t4P = (s46 - s68);
            t5P = (s96 - s19);
            t6P = (s07 + s29);
            a2r = (0.70710678118654757f*(s96 + s19));
            a3r = (0.70710678118654757f*(s07 - s29));
            s7a = (a2r + a3r);
            s8a = (a2r - a3r);
            t7P = (t5O + t1P);
            t8P = (t6O + t2P);
            t9P = (t5O - t1P);
            t0Q = (t6O - t2P);
            t1Q = (t9O + t5P);
            t2Q = (t0P + t6P);
            t3Q = (t9O - t5P);
            t4Q = (t0P - t6P);
            t5Q = (t7P + t1Q);
            t6Q = (t8P + t2Q);
            t7Q = (t7P - t1Q);
            t8Q = (t8P - t2Q);
            a4r = (a3n + 32);
            a5r = (a3n + 33);
            a6r = (a3n + 34);
            a7r = (a3n + 35);
            *((a7n + 128)) = ((*(a4r)*t5Q) - (*(a5r)*t6Q));
            *((a7n + 129)) = ((*(a5r)*t5Q) + (*(a4r)*t6Q));
            *((a7n + 1152)) = ((*(a6r)*t7Q) - (*(a7r)*t8Q));
            *((a7n + 1153)) = ((*(a7r)*t7Q) + (*(a6r)*t8Q));
            t9Q = (t9P - t4Q);
            t0R = (t0Q + t3Q);
            t1R = (t9P + t4Q);
            t2R = (t0Q - t3Q);
            a8r = (a3n + 36);
            a9r = (a3n + 37);
            a0s = (a3n + 38);
            a1s = (a3n + 39);
            *((a7n + 640)) = ((*(a8r)*t9Q) - (*(a9r)*t0R));
            *((a7n + 641)) = ((*(a9r)*t9Q) + (*(a8r)*t0R));
            *((a7n + 1664)) = ((*(a0s)*t1R) - (*(a1s)*t2R));
            *((a7n + 1665)) = ((*(a1s)*t1R) + (*(a0s)*t2R));
            t3R = (t7O - t4P);
            t4R = (t8O + t3P);
            t5R = (t7O + t4P);
            t6R = (t8O - t3P);
            t7R = (s5a - s7a);
            t8R = (s6a + s8a);
            t9R = (s5a + s7a);
            t0S = (s6a - s8a);
            t1S = (t3R + t7R);
            t2S = (t4R + t8R);
            t3S = (t3R - t7R);
            t4S = (t4R - t8R);
            a2s = (a3n + 40);
            a3s = (a3n + 41);
            a4s = (a3n + 42);
            a5s = (a3n + 43);
            *((a7n + 384)) = ((*(a2s)*t1S) - (*(a3s)*t2S));
            *((a7n + 385)) = ((*(a3s)*t1S) + (*(a2s)*t2S));
            *((a7n + 1408)) = ((*(a4s)*t3S) - (*(a5s)*t4S));
            *((a7n + 1409)) = ((*(a5s)*t3S) + (*(a4s)*t4S));
            t5S = (t5R - t0S);
            t6S = (t6R + t9R);
            t7S = (t5R + t0S);
            t8S = (t6R - t9R);
            a6s = (a3n + 44);
            a7s = (a3n + 45);
            a8s = (a3n + 46);
            a9s = (a3n + 47);
            *((a7n + 896)) = ((*(a6s)*t5S) - (*(a7s)*t6S));
            *((a7n + 897)) = ((*(a7s)*t5S) + (*(a6s)*t6S));
            *((a7n + 1920)) = ((*(a8s)*t7S) - (*(a9s)*t8S));
            *((a7n + 1921)) = ((*(a9s)*t7S) + (*(a8s)*t8S));
            t9S = (t1v - s77);
            t0T = (t2v + s87);
            t1T = (t1v + s77);
            t2T = (t2v - s87);
            t3T = (s16 - s38);
            t4T = (s26 + s48);
            a0t = (0.70710678118654757f*(s16 + s38));
            a1t = (0.70710678118654757f*(s26 - s48));
            s9a = (a0t - a1t);
            s0b = (a0t + a1t);
            t5T = (s76 + s98);
            t6T = (s86 - s09);
            t7T = (s76 - s98);
            t8T = (s86 + s09);
            t9T = (s59 - s37);
            t0U = (s47 - s69);
            a2t = (0.70710678118654757f*(s37 + s59));
            a3t = (0.70710678118654757f*(s47 + s69));
            s1b = (a2t - a3t);
            s2b = (a2t + a3t);
            t1U = (t9S + t5T);
            t2U = (t0T + t6T);
            t3U = (t9S - t5T);
            t4U = (t0T - t6T);
            t5U = (t3T + t9T);
            t6U = (t4T + t0U);
            t7U = (t3T - t9T);
            t8U = (t4T - t0U);
            t9U = (t1U + t5U);
            t0V = (t2U + t6U);
            t1V = (t1U - t5U);
            t2V = (t2U - t6U);
            a4t = (a3n + 48);
            a5t = (a3n + 49);
            a6t = (a3n + 50);
            a7t = (a3n + 51);
            *((a7n + 192)) = ((*(a4t)*t9U) - (*(a5t)*t0V));
            *((a7n + 193)) = ((*(a5t)*t9U) + (*(a4t)*t0V));
            *((a7n + 1216)) = ((*(a6t)*t1V) - (*(a7t)*t2V));
            *((a7n + 1217)) = ((*(a7t)*t1V) + (*(a6t)*t2V));
            t3V = (t3U - t8U);
            t4V = (t4U + t7U);
            t5V = (t3U + t8U);
            t6V = (t4U - t7U);
            a8t = (a3n + 52);
            a9t = (a3n + 53);
            a0u = (a3n + 54);
            a1u = (a3n + 55);
            *((a7n + 704)) = ((*(a8t)*t3V) - (*(a9t)*t4V));
            *((a7n + 705)) = ((*(a9t)*t3V) + (*(a8t)*t4V));
            *((a7n + 1728)) = ((*(a0u)*t5V) - (*(a1u)*t6V));
            *((a7n + 1729)) = ((*(a1u)*t5V) + (*(a0u)*t6V));
            t7V = (t1T - t8T);
            t8V = (t2T + t7T);
            t9V = (t1T + t8T);
            t0W = (t2T - t7T);
            t1W = (s9a + s1b);
            t2W = (s0b - s2b);
            t3W = (s9a - s1b);
            t4W = (s0b + s2b);
            t5W = (t7V + t1W);
            t6W = (t8V + t2W);
            t7W = (t7V - t1W);
            t8W = (t8V - t2W);
            a2u = (a3n + 56);
            a3u = (a3n + 57);
            a4u = (a3n + 58);
            a5u = (a3n + 59);
            *((a7n + 448)) = ((*(a2u)*t5W) - (*(a3u)*t6W));
            *((a7n + 449)) = ((*(a3u)*t5W) + (*(a2u)*t6W));
            *((a7n + 1472)) = ((*(a4u)*t7W) - (*(a5u)*t8W));
            *((a7n + 1473)) = ((*(a5u)*t7W) + (*(a4u)*t8W));
            t9W = (t9V - t4W);
            t0X = (t0W + t3W);
            t1X = (t9V + t4W);
            t2X = (t0W - t3W);
            a6u = (a3n + 60);
            a7u = (a3n + 61);
            a8u = (a3n + 62);
            a9u = (a3n + 63);
            *((a7n + 960)) = ((*(a6u)*t9W) - (*(a7u)*t0X));
            *((a7n + 961)) = ((*(a7u)*t9W) + (*(a6u)*t0X));
            *((a7n + 1984)) = ((*(a8u)*t1X) - (*(a9u)*t2X));
            *((a7n + 1985)) = ((*(a9u)*t1X) + (*(a8u)*t2X));
        }}
    }}
    {long i4; for(i4 = 0; i4 <= 1023; i4++) {
        a0v = (2*i4);
        a1v = (T + a0v);
        a2v = (a1v + 1);
        a3v = (a1v + 8192);
        a4v = (a1v + 8193);
        t3X = (*(a1v) + *(a3v));
        t4X = (*(a2v) + *(a4v));
        t5X = (*(a1v) - *(a3v));
        t6X = (*(a2v) - *(a4v));
        a5v = (a1v + 2048);
        a6v = (a1v + 2049);
        a7v = (a1v + 10240);
        a8v = (a1v + 10241);
        t7X = (*(a5v) + *(a7v));
        t8X = (*(a6v) + *(a8v));
        a9v = (0.70710678118654757f*(*(a5v) - *(a7v)));
        a0w = (0.70710678118654757f*(*(a6v) - *(a8v)));
        s3b = (a9v - a0w);
        s4b = (a9v + a0w);
        a1w = (a1v + 4096);
        a2w = (a1v + 4097);
        a3w = (a1v + 12288);
        a4w = (a1v + 12289);
        t9X = (*(a1w) + *(a3w));
        t0Y = (*(a2w) + *(a4w));
        t1Y = (*(a1w) - *(a3w));
        t2Y = (*(a2w) - *(a4w));
        a5w = (a1v + 6144);
        a6w = (a1v + 6145);
        a7w = (a1v + 14336);
        a8w = (a1v + 14337);
        t3Y = (*(a5w) + *(a7w));
        t4Y = (*(a6w) + *(a8w));
        a9w = (0.70710678118654757f*(*(a5w) - *(a7w)));
        a0x = (0.70710678118654757f*(*(a6w) - *(a8w)));
        s5b = (a9w + a0x);
        s6b = (a9w - a0x);
        t5Y = (t3X + t9X);
        t6Y = (t4X + t0Y);
        t7Y = (t3X - t9X);
        t8Y = (t4X - t0Y);
        t9Y = (t7X + t3Y);
        t0Z = (t8X + t4Y);
        t1Z = (t7X - t3Y);
        t2Z = (t8X - t4Y);
        a1x = (dst + a0v);
        *(a1x) = (t5Y + t9Y);
        *((a1x + 1)) = (t6Y + t0Z);
        *((a1x + 8192)) = (t5Y - t9Y);
        *((a1x + 8193)) = (t6Y - t0Z);
        *((a1x + 4096)) = (t7Y - t2Z);
        *((a1x + 4097)) = (t8Y + t1Z);
        *((a1x + 12288)) = (t7Y + t2Z);
        *((a1x + 12289)) = (t8Y - t1Z);
        t3Z = (t5X - t2Y);
        t4Z = (t6X + t1Y);
        t5Z = (t5X + t2Y);
        t6Z = (t6X - t1Y);
        t7Z = (s3b - s5b);
        t8Z = (s4b + s6b);
        t9Z = (s3b + s5b);
        t010 = (s4b - s6b);
        *((a1x + 2048)) = (t3Z + t7Z);
        *((a1x + 2049)) = (t4Z + t8Z);
        *((a1x + 10240)) = (t3Z - t7Z);
        *((a1x + 10241)) = (t4Z - t8Z);
        *((a1x + 6144)) = (t5Z - t010);
        *((a1x + 6145)) = (t6Z + t9Z);
        *((a1x + 14336)) = (t5Z + t010);
        *((a1x + 14337)) = (t6Z - t9Z);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_float_2)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    {const float  *a, *a2, *a3;
    a = (src + 2);
    a2 = (src + 1);
    a3 = (src + 3);
    *(dst) = (*(src) + *(a));
    *((dst + 1)) = (*(a2) + *(a3));
    *((dst + 2)) = (*(src) - *(a));
    *((dst + 3)) = (*(a2) - *(a3));
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_float_4)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    {const float  *a, *a2, *a3, *a4, *a5, *a6, *a7;
    float t, t2, t3, t4, t5, t6, t7, t8;
    a = (src + 4);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 5);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 2);
    a5 = (src + 6);
    t5 = (*(a4) + *(a5));
    a6 = (src + 3);
    a7 = (src + 7);
    t6 = (*(a6) + *(a7));
    t7 = (*(a4) - *(a5));
    t8 = (*(a6) - *(a7));
    *(dst) = (t + t5);
    *((dst + 1)) = (t2 + t6);
    *((dst + 4)) = (t - t5);
    *((dst + 5)) = (t2 - t6);
    *((dst + 2)) = (t3 + t8);
    *((dst + 3)) = (t4 - t7);
    *((dst + 6)) = (t3 - t8);
    *((dst + 7)) = (t4 + t7);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_float_8)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    {const float  *a, *a01, *a11, *a2, *a21, *a3, *a31, *a4, *a41, *a5, *a51, *a6, *a61, *a7, *a71;
    float a8, a81, a9, a91, s, s2, s3, s4, t, t01, t02, t11, t12, t2, t21, t22, t3, t31, t32, t4, t41, t42
            , t5, t51, t52, t6, t61, t62, t7, t71, t72, t8, t81, t82, t9, t91;
    a = (src + 8);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 9);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 2);
    a5 = (src + 10);
    t5 = (*(a4) + *(a5));
    a6 = (src + 3);
    a7 = (src + 11);
    t6 = (*(a6) + *(a7));
    a8 = (0.70710678118654757f*(*(a4) - *(a5)));
    a9 = (0.70710678118654757f*(*(a6) - *(a7)));
    s = (a8 + a9);
    s2 = (a9 - a8);
    a01 = (src + 4);
    a11 = (src + 12);
    t7 = (*(a01) + *(a11));
    a21 = (src + 5);
    a31 = (src + 13);
    t8 = (*(a21) + *(a31));
    t9 = (*(a01) - *(a11));
    t01 = (*(a21) - *(a31));
    a41 = (src + 6);
    a51 = (src + 14);
    t11 = (*(a41) + *(a51));
    a61 = (src + 7);
    a71 = (src + 15);
    t21 = (*(a61) + *(a71));
    a81 = (0.70710678118654757f*(*(a61) - *(a71)));
    a91 = (0.70710678118654757f*(*(a41) - *(a51)));
    s3 = (a81 - a91);
    s4 = (a91 + a81);
    t31 = (t + t7);
    t41 = (t2 + t8);
    t51 = (t - t7);
    t61 = (t2 - t8);
    t71 = (t5 + t11);
    t81 = (t6 + t21);
    t91 = (t5 - t11);
    t02 = (t6 - t21);
    *(dst) = (t31 + t71);
    *((dst + 1)) = (t41 + t81);
    *((dst + 8)) = (t31 - t71);
    *((dst + 9)) = (t41 - t81);
    *((dst + 4)) = (t51 + t02);
    *((dst + 5)) = (t61 - t91);
    *((dst + 12)) = (t51 - t02);
    *((dst + 13)) = (t61 + t91);
    t12 = (t3 + t01);
    t22 = (t4 - t9);
    t32 = (t3 - t01);
    t42 = (t4 + t9);
    t52 = (s + s3);
    t62 = (s2 - s4);
    t72 = (s - s3);
    t82 = (s2 + s4);
    *((dst + 2)) = (t12 + t52);
    *((dst + 3)) = (t22 + t62);
    *((dst + 10)) = (t12 - t52);
    *((dst + 11)) = (t22 - t62);
    *((dst + 6)) = (t32 + t82);
    *((dst + 7)) = (t42 - t72);
    *((dst + 14)) = (t32 - t82);
    *((dst + 15)) = (t42 + t72);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_float_16)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    {const float  *a, *a01, *a02, *a03, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52
            , *a53, *a6, *a63, *a7, *a73, *a8, *a81, *a9, *a91;
    float a61, a62, a71, a72, a82, a83, a92, a93, s, s01, s11, s2, s21, s3, s31, s4, s41, s5, s51, s6, s61, s7
            , s8, s9, t, t01, t02, t03, t04, t05, t06, t07, t08, t11, t12, t13, t14, t15, t16, t17, t18, t2, t21, t22
            , t23, t24, t25, t26, t27, t28, t3, t31, t32, t33, t34, t35, t36, t37, t38, t4, t41, t42, t43, t44, t45, t46
            , t47, t48, t5, t51, t52, t53, t54, t55, t56, t57, t58, t6, t61, t62, t63, t64, t65, t66, t67, t68, t7, t71
            , t72, t73, t74, t75, t76, t77, t78, t8, t81, t82, t83, t84, t85, t86, t87, t88, t9, t91, t92, t93, t94, t95
            , t96, t97;
    a = (src + 16);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 17);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 8);
    a5 = (src + 24);
    t5 = (*(a4) + *(a5));
    a6 = (src + 9);
    a7 = (src + 25);
    t6 = (*(a6) + *(a7));
    t7 = (*(a4) - *(a5));
    t8 = (*(a6) - *(a7));
    t9 = (t + t5);
    t01 = (t2 + t6);
    t11 = (t - t5);
    t21 = (t2 - t6);
    t31 = (t3 + t8);
    t41 = (t4 - t7);
    t51 = (t3 - t8);
    t61 = (t4 + t7);
    a8 = (src + 2);
    a9 = (src + 18);
    t71 = (*(a8) + *(a9));
    a01 = (src + 3);
    a11 = (src + 19);
    t81 = (*(a01) + *(a11));
    t91 = (*(a8) - *(a9));
    t02 = (*(a01) - *(a11));
    a21 = (src + 10);
    a31 = (src + 26);
    t12 = (*(a21) + *(a31));
    a41 = (src + 11);
    a51 = (src + 27);
    t22 = (*(a41) + *(a51));
    t32 = (*(a21) - *(a31));
    t42 = (*(a41) - *(a51));
    t52 = (t71 + t12);
    t62 = (t81 + t22);
    a61 = (0.70710678118654757f*(t71 - t12));
    a71 = (0.70710678118654757f*(t81 - t22));
    s = (a61 + a71);
    s2 = (a71 - a61);
    t72 = (t91 + t42);
    t82 = (t02 - t32);
    t92 = (t91 - t42);
    t03 = (t02 + t32);
    s3 = ((0.92387953251128674f*t72) + (0.38268343236508978f*t82));
    s4 = ((0.92387953251128674f*t82) - (0.38268343236508978f*t72));
    s5 = ((0.38268343236508978f*t92) + (0.92387953251128674f*t03));
    s6 = ((0.38268343236508978f*t03) - (0.92387953251128674f*t92));
    a81 = (src + 4);
    a91 = (src + 20);
    t13 = (*(a81) + *(a91));
    a02 = (src + 5);
    a12 = (src + 21);
    t23 = (*(a02) + *(a12));
    t33 = (*(a81) - *(a91));
    t43 = (*(a02) - *(a12));
    a22 = (src + 12);
    a32 = (src + 28);
    t53 = (*(a22) + *(a32));
    a42 = (src + 13);
    a52 = (src + 29);
    t63 = (*(a42) + *(a52));
    t73 = (*(a22) - *(a32));
    t83 = (*(a42) - *(a52));
    t93 = (t13 + t53);
    t04 = (t23 + t63);
    t14 = (t13 - t53);
    t24 = (t23 - t63);
    a62 = (0.70710678118654757f*(t33 + t83));
    a72 = (0.70710678118654757f*(t43 - t73));
    s7 = (a62 + a72);
    s8 = (a72 - a62);
    a82 = (0.70710678118654757f*(t43 + t73));
    a92 = (0.70710678118654757f*(t33 - t83));
    s9 = (a82 - a92);
    s01 = (a92 + a82);
    a03 = (src + 6);
    a13 = (src + 22);
    t34 = (*(a03) + *(a13));
    a23 = (src + 7);
    a33 = (src + 23);
    t44 = (*(a23) + *(a33));
    t54 = (*(a03) - *(a13));
    t64 = (*(a23) - *(a33));
    a43 = (src + 14);
    a53 = (src + 30);
    t74 = (*(a43) + *(a53));
    a63 = (src + 15);
    a73 = (src + 31);
    t84 = (*(a63) + *(a73));
    t94 = (*(a43) - *(a53));
    t05 = (*(a63) - *(a73));
    t15 = (t34 + t74);
    t25 = (t44 + t84);
    a83 = (0.70710678118654757f*(t44 - t84));
    a93 = (0.70710678118654757f*(t34 - t74));
    s11 = (a83 - a93);
    s21 = (a93 + a83);
    t35 = (t54 + t05);
    t45 = (t64 - t94);
    t55 = (t54 - t05);
    t65 = (t64 + t94);
    s31 = ((0.38268343236508978f*t35) + (0.92387953251128674f*t45));
    s41 = ((0.38268343236508978f*t45) - (0.92387953251128674f*t35));
    s51 = ((0.92387953251128674f*t55) + (0.38268343236508978f*t65));
    s61 = ((0.38268343236508978f*t55) - (0.92387953251128674f*t65));
    t75 = (t9 + t93);
    t85 = (t01 + t04);
    t95 = (t9 - t93);
    t06 = (t01 - t04);
    t16 = (t52 + t15);
    t26 = (t62 + t25);
    t36 = (t52 - t15);
    t46 = (t62 - t25);
    *(dst) = (t75 + t16);
    *((dst + 1)) = (t85 + t26);
    *((dst + 16)) = (t75 - t16);
    *((dst + 17)) = (t85 - t26);
    *((dst + 8)) = (t95 + t46);
    *((dst + 9)) = (t06 - t36);
    *((dst + 24)) = (t95 - t46);
    *((dst + 25)) = (t06 + t36);
    t56 = (t31 + s7);
    t66 = (t41 + s8);
    t76 = (t31 - s7);
    t86 = (t41 - s8);
    t96 = (s3 + s31);
    t07 = (s4 + s41);
    t17 = (s3 - s31);
    t27 = (s4 - s41);
    *((dst + 2)) = (t56 + t96);
    *((dst + 3)) = (t66 + t07);
    *((dst + 18)) = (t56 - t96);
    *((dst + 19)) = (t66 - t07);
    *((dst + 10)) = (t76 + t27);
    *((dst + 11)) = (t86 - t17);
    *((dst + 26)) = (t76 - t27);
    *((dst + 27)) = (t86 + t17);
    t37 = (t11 + t24);
    t47 = (t21 - t14);
    t57 = (t11 - t24);
    t67 = (t21 + t14);
    t77 = (s + s11);
    t87 = (s2 - s21);
    t97 = (s - s11);
    t08 = (s2 + s21);
    *((dst + 4)) = (t37 + t77);
    *((dst + 5)) = (t47 + t87);
    *((dst + 20)) = (t37 - t77);
    *((dst + 21)) = (t47 - t87);
    *((dst + 12)) = (t57 + t08);
    *((dst + 13)) = (t67 - t97);
    *((dst + 28)) = (t57 - t08);
    *((dst + 29)) = (t67 + t97);
    t18 = (t51 + s9);
    t28 = (t61 - s01);
    t38 = (t51 - s9);
    t48 = (t61 + s01);
    t58 = (s5 - s51);
    t68 = (s6 + s61);
    t78 = (s5 + s51);
    t88 = (s6 - s61);
    *((dst + 6)) = (t18 + t58);
    *((dst + 7)) = (t28 + t68);
    *((dst + 22)) = (t18 - t58);
    *((dst + 23)) = (t28 - t68);
    *((dst + 14)) = (t38 + t88);
    *((dst + 15)) = (t48 - t78);
    *((dst + 30)) = (t38 - t88);
    *((dst + 31)) = (t48 + t78);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_float_32)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    {const float  *a, *a01, *a02, *a03, *a04, *a05, *a06, *a07, *a11, *a12, *a13, *a14, *a15, *a16, *a17, *a2, *a21, *a22, *a23, *a25, *a3, *a31
            , *a32, *a33, *a35, *a4, *a41, *a43, *a45, *a46, *a5, *a51, *a53, *a55, *a56, *a6, *a61, *a62, *a63, *a64, *a65, *a66, *a7, *a71
            , *a72, *a73, *a74, *a75, *a76, *a8, *a81, *a82, *a83, *a84, *a85, *a86, *a9, *a91, *a92, *a93, *a94, *a95, *a96;
    float a08, a18, a24, a26, a27, a28, a34, a36, a37, a38, a42, a44, a47, a48, a52, a54, a57, a58, a67, a68, a77, a78
            , a87, a97, s, s01, s02, s03, s04, s05, s11, s12, s13, s14, s15, s2, s21, s22, s23, s24, s25, s3, s31, s32
            , s33, s34, s35, s4, s41, s42, s43, s44, s45, s5, s51, s52, s53, s54, s55, s6, s61, s62, s63, s64, s65, s7
            , s71, s72, s73, s74, s8, s81, s82, s83, s84, s9, s91, s92, s93, s94, t, t01, t02, t03, t04, t05, t06, t07
            , t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t11, t12, t13, t14, t15, t16
            , t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t2, t21, t22, t23, t24
            , t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t3, t31, t32
            , t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l, t3m, t4, t41
            , t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t5
            , t51, t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m
            , t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l
            , t6m, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k
            , t7l, t7m, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j
            , t8k, t8l, t8m, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i
            , t9j, t9k, t9l, t9m;
    a = (src + 32);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 33);
    t2 = (*(a2) + *(a3));
    t3 = (*(src) - *(a));
    t4 = (*(a2) - *(a3));
    a4 = (src + 16);
    a5 = (src + 48);
    t5 = (*(a4) + *(a5));
    a6 = (src + 17);
    a7 = (src + 49);
    t6 = (*(a6) + *(a7));
    t7 = (*(a4) - *(a5));
    t8 = (*(a6) - *(a7));
    t9 = (t + t5);
    t01 = (t2 + t6);
    t11 = (t - t5);
    t21 = (t2 - t6);
    t31 = (t3 + t8);
    t41 = (t4 - t7);
    t51 = (t3 - t8);
    t61 = (t4 + t7);
    a8 = (src + 2);
    a9 = (src + 34);
    t71 = (*(a8) + *(a9));
    a01 = (src + 3);
    a11 = (src + 35);
    t81 = (*(a01) + *(a11));
    t91 = (*(a8) - *(a9));
    t02 = (*(a01) - *(a11));
    a21 = (src + 18);
    a31 = (src + 50);
    t12 = (*(a21) + *(a31));
    a41 = (src + 19);
    a51 = (src + 51);
    t22 = (*(a41) + *(a51));
    t32 = (*(a21) - *(a31));
    t42 = (*(a41) - *(a51));
    t52 = (t71 + t12);
    t62 = (t81 + t22);
    t72 = (t71 - t12);
    t82 = (t81 - t22);
    s = ((0.92387953251128674f*t72) + (0.38268343236508978f*t82));
    s2 = ((0.92387953251128674f*t82) - (0.38268343236508978f*t72));
    t92 = (t91 + t42);
    t03 = (t02 - t32);
    t13 = (t91 - t42);
    t23 = (t02 + t32);
    s3 = ((0.98078528040323043f*t92) + (0.19509032201612828f*t03));
    s4 = ((0.98078528040323043f*t03) - (0.19509032201612828f*t92));
    s5 = ((0.83146961230254524f*t13) + (0.55557023301960218f*t23));
    s6 = ((0.83146961230254524f*t23) - (0.55557023301960218f*t13));
    a61 = (src + 4);
    a71 = (src + 36);
    t33 = (*(a61) + *(a71));
    a81 = (src + 5);
    a91 = (src + 37);
    t43 = (*(a81) + *(a91));
    t53 = (*(a61) - *(a71));
    t63 = (*(a81) - *(a91));
    a02 = (src + 20);
    a12 = (src + 52);
    t73 = (*(a02) + *(a12));
    a22 = (src + 21);
    a32 = (src + 53);
    t83 = (*(a22) + *(a32));
    t93 = (*(a02) - *(a12));
    t04 = (*(a22) - *(a32));
    t14 = (t33 + t73);
    t24 = (t43 + t83);
    a42 = (0.70710678118654757f*(t33 - t73));
    a52 = (0.70710678118654757f*(t43 - t83));
    s7 = (a42 + a52);
    s8 = (a52 - a42);
    t34 = (t53 + t04);
    t44 = (t63 - t93);
    t54 = (t53 - t04);
    t64 = (t63 + t93);
    s9 = ((0.92387953251128674f*t34) + (0.38268343236508978f*t44));
    s01 = ((0.92387953251128674f*t44) - (0.38268343236508978f*t34));
    s11 = ((0.38268343236508978f*t54) + (0.92387953251128674f*t64));
    s21 = ((0.38268343236508978f*t64) - (0.92387953251128674f*t54));
    a62 = (src + 6);
    a72 = (src + 38);
    t74 = (*(a62) + *(a72));
    a82 = (src + 7);
    a92 = (src + 39);
    t84 = (*(a82) + *(a92));
    t94 = (*(a62) - *(a72));
    t05 = (*(a82) - *(a92));
    a03 = (src + 22);
    a13 = (src + 54);
    t15 = (*(a03) + *(a13));
    a23 = (src + 23);
    a33 = (src + 55);
    t25 = (*(a23) + *(a33));
    t35 = (*(a03) - *(a13));
    t45 = (*(a23) - *(a33));
    t55 = (t74 + t15);
    t65 = (t84 + t25);
    t75 = (t74 - t15);
    t85 = (t84 - t25);
    s31 = ((0.38268343236508978f*t75) + (0.92387953251128674f*t85));
    s41 = ((0.38268343236508978f*t85) - (0.92387953251128674f*t75));
    t95 = (t94 + t45);
    t06 = (t05 - t35);
    t16 = (t94 - t45);
    t26 = (t05 + t35);
    s51 = ((0.83146961230254524f*t95) + (0.55557023301960218f*t06));
    s61 = ((0.83146961230254524f*t06) - (0.55557023301960218f*t95));
    s71 = ((0.98078528040323043f*t26) - (0.19509032201612828f*t16));
    s81 = ((0.98078528040323043f*t16) + (0.19509032201612828f*t26));
    a43 = (src + 8);
    a53 = (src + 40);
    t36 = (*(a43) + *(a53));
    a63 = (src + 9);
    a73 = (src + 41);
    t46 = (*(a63) + *(a73));
    t56 = (*(a43) - *(a53));
    t66 = (*(a63) - *(a73));
    a83 = (src + 24);
    a93 = (src + 56);
    t76 = (*(a83) + *(a93));
    a04 = (src + 25);
    a14 = (src + 57);
    t86 = (*(a04) + *(a14));
    t96 = (*(a83) - *(a93));
    t07 = (*(a04) - *(a14));
    t17 = (t36 + t76);
    t27 = (t46 + t86);
    t37 = (t36 - t76);
    t47 = (t46 - t86);
    a24 = (0.70710678118654757f*(t56 + t07));
    a34 = (0.70710678118654757f*(t66 - t96));
    s91 = (a24 + a34);
    s02 = (a34 - a24);
    a44 = (0.70710678118654757f*(t66 + t96));
    a54 = (0.70710678118654757f*(t56 - t07));
    s12 = (a44 - a54);
    s22 = (a54 + a44);
    a64 = (src + 10);
    a74 = (src + 42);
    t57 = (*(a64) + *(a74));
    a84 = (src + 11);
    a94 = (src + 43);
    t67 = (*(a84) + *(a94));
    t77 = (*(a64) - *(a74));
    t87 = (*(a84) - *(a94));
    a05 = (src + 26);
    a15 = (src + 58);
    t97 = (*(a05) + *(a15));
    a25 = (src + 27);
    a35 = (src + 59);
    t08 = (*(a25) + *(a35));
    t18 = (*(a05) - *(a15));
    t28 = (*(a25) - *(a35));
    t38 = (t57 + t97);
    t48 = (t67 + t08);
    t58 = (t57 - t97);
    t68 = (t67 - t08);
    s32 = ((0.92387953251128674f*t68) - (0.38268343236508978f*t58));
    s42 = ((0.92387953251128674f*t58) + (0.38268343236508978f*t68));
    t78 = (t77 + t28);
    t88 = (t87 - t18);
    t98 = (t77 - t28);
    t09 = (t87 + t18);
    s52 = ((0.55557023301960218f*t78) + (0.83146961230254524f*t88));
    s62 = ((0.55557023301960218f*t88) - (0.83146961230254524f*t78));
    s72 = ((0.19509032201612828f*t09) - (0.98078528040323043f*t98));
    s82 = ((0.19509032201612828f*t98) + (0.98078528040323043f*t09));
    a45 = (src + 12);
    a55 = (src + 44);
    t19 = (*(a45) + *(a55));
    a65 = (src + 13);
    a75 = (src + 45);
    t29 = (*(a65) + *(a75));
    t39 = (*(a45) - *(a55));
    t49 = (*(a65) - *(a75));
    a85 = (src + 28);
    a95 = (src + 60);
    t59 = (*(a85) + *(a95));
    a06 = (src + 29);
    a16 = (src + 61);
    t69 = (*(a06) + *(a16));
    t79 = (*(a85) - *(a95));
    t89 = (*(a06) - *(a16));
    t99 = (t19 + t59);
    t0a = (t29 + t69);
    a26 = (0.70710678118654757f*(t29 - t69));
    a36 = (0.70710678118654757f*(t19 - t59));
    s92 = (a26 - a36);
    s03 = (a36 + a26);
    t1a = (t39 + t89);
    t2a = (t49 - t79);
    t3a = (t39 - t89);
    t4a = (t49 + t79);
    s13 = ((0.38268343236508978f*t1a) + (0.92387953251128674f*t2a));
    s23 = ((0.38268343236508978f*t2a) - (0.92387953251128674f*t1a));
    s33 = ((0.92387953251128674f*t3a) + (0.38268343236508978f*t4a));
    s43 = ((0.38268343236508978f*t3a) - (0.92387953251128674f*t4a));
    a46 = (src + 14);
    a56 = (src + 46);
    t5a = (*(a46) + *(a56));
    a66 = (src + 15);
    a76 = (src + 47);
    t6a = (*(a66) + *(a76));
    t7a = (*(a46) - *(a56));
    t8a = (*(a66) - *(a76));
    a86 = (src + 30);
    a96 = (src + 62);
    t9a = (*(a86) + *(a96));
    a07 = (src + 31);
    a17 = (src + 63);
    t0b = (*(a07) + *(a17));
    t1b = (*(a86) - *(a96));
    t2b = (*(a07) - *(a17));
    t3b = (t5a + t9a);
    t4b = (t6a + t0b);
    t5b = (t5a - t9a);
    t6b = (t6a - t0b);
    s53 = ((0.38268343236508978f*t6b) - (0.92387953251128674f*t5b));
    s63 = ((0.38268343236508978f*t5b) + (0.92387953251128674f*t6b));
    t7b = (t7a + t2b);
    t8b = (t8a - t1b);
    t9b = (t7a - t2b);
    t0c = (t8a + t1b);
    s73 = ((0.19509032201612828f*t7b) + (0.98078528040323043f*t8b));
    s83 = ((0.19509032201612828f*t8b) - (0.98078528040323043f*t7b));
    s93 = ((0.55557023301960218f*t9b) + (0.83146961230254524f*t0c));
    s04 = ((0.83146961230254524f*t9b) - (0.55557023301960218f*t0c));
    t1c = (t9 + t17);
    t2c = (t01 + t27);
    t3c = (t9 - t17);
    t4c = (t01 - t27);
    t5c = (t52 + t38);
    t6c = (t62 + t48);
    a27 = (0.70710678118654757f*(t52 - t38));
    a37 = (0.70710678118654757f*(t62 - t48));
    s14 = (a27 + a37);
    s24 = (a37 - a27);
    t7c = (t14 + t99);
    t8c = (t24 + t0a);
    t9c = (t14 - t99);
    t0d = (t24 - t0a);
    t1d = (t55 + t3b);
    t2d = (t65 + t4b);
    a47 = (0.70710678118654757f*(t65 - t4b));
    a57 = (0.70710678118654757f*(t55 - t3b));
    s34 = (a47 - a57);
    s44 = (a57 + a47);
    t3d = (t1c + t7c);
    t4d = (t2c + t8c);
    t5d = (t1c - t7c);
    t6d = (t2c - t8c);
    t7d = (t5c + t1d);
    t8d = (t6c + t2d);
    t9d = (t5c - t1d);
    t0e = (t6c - t2d);
    *(dst) = (t3d + t7d);
    *((dst + 1)) = (t4d + t8d);
    *((dst + 32)) = (t3d - t7d);
    *((dst + 33)) = (t4d - t8d);
    *((dst + 16)) = (t5d + t0e);
    *((dst + 17)) = (t6d - t9d);
    *((dst + 48)) = (t5d - t0e);
    *((dst + 49)) = (t6d + t9d);
    t1e = (t3c + t0d);
    t2e = (t4c - t9c);
    t3e = (t3c - t0d);
    t4e = (t4c + t9c);
    t5e = (s14 + s34);
    t6e = (s24 - s44);
    t7e = (s14 - s34);
    t8e = (s24 + s44);
    *((dst + 8)) = (t1e + t5e);
    *((dst + 9)) = (t2e + t6e);
    *((dst + 40)) = (t1e - t5e);
    *((dst + 41)) = (t2e - t6e);
    *((dst + 24)) = (t3e + t8e);
    *((dst + 25)) = (t4e - t7e);
    *((dst + 56)) = (t3e - t8e);
    *((dst + 57)) = (t4e + t7e);
    t9e = (t31 + s91);
    t0f = (t41 + s02);
    t1f = (t31 - s91);
    t2f = (t41 - s02);
    t3f = (s3 + s52);
    t4f = (s4 + s62);
    a67 = (0.70710678118654757f*(s3 - s52));
    a77 = (0.70710678118654757f*(s4 - s62));
    s54 = (a67 + a77);
    s64 = (a77 - a67);
    t5f = (s9 + s13);
    t6f = (s01 + s23);
    t7f = (s9 - s13);
    t8f = (s01 - s23);
    t9f = (s51 + s73);
    t0g = (s61 + s83);
    a87 = (0.70710678118654757f*(s61 - s83));
    a97 = (0.70710678118654757f*(s51 - s73));
    s74 = (a87 - a97);
    s84 = (a97 + a87);
    t1g = (t9e + t5f);
    t2g = (t0f + t6f);
    t3g = (t9e - t5f);
    t4g = (t0f - t6f);
    t5g = (t3f + t9f);
    t6g = (t4f + t0g);
    t7g = (t3f - t9f);
    t8g = (t4f - t0g);
    *((dst + 2)) = (t1g + t5g);
    *((dst + 3)) = (t2g + t6g);
    *((dst + 34)) = (t1g - t5g);
    *((dst + 35)) = (t2g - t6g);
    *((dst + 18)) = (t3g + t8g);
    *((dst + 19)) = (t4g - t7g);
    *((dst + 50)) = (t3g - t8g);
    *((dst + 51)) = (t4g + t7g);
    t9g = (t1f + t8f);
    t0h = (t2f - t7f);
    t1h = (t1f - t8f);
    t2h = (t2f + t7f);
    t3h = (s54 + s74);
    t4h = (s64 - s84);
    t5h = (s54 - s74);
    t6h = (s64 + s84);
    *((dst + 10)) = (t9g + t3h);
    *((dst + 11)) = (t0h + t4h);
    *((dst + 42)) = (t9g - t3h);
    *((dst + 43)) = (t0h - t4h);
    *((dst + 26)) = (t1h + t6h);
    *((dst + 27)) = (t2h - t5h);
    *((dst + 58)) = (t1h - t6h);
    *((dst + 59)) = (t2h + t5h);
    t7h = (t11 + t47);
    t8h = (t21 - t37);
    t9h = (t11 - t47);
    t0i = (t21 + t37);
    t1i = (s + s32);
    t2i = (s2 - s42);
    a08 = (0.70710678118654757f*(s - s32));
    a18 = (0.70710678118654757f*(s2 + s42));
    s94 = (a08 + a18);
    s05 = (a18 - a08);
    t3i = (s7 + s92);
    t4i = (s8 - s03);
    t5i = (s7 - s92);
    t6i = (s8 + s03);
    t7i = (s31 + s53);
    t8i = (s41 - s63);
    a28 = (0.70710678118654757f*(s41 + s63));
    a38 = (0.70710678118654757f*(s31 - s53));
    s15 = (a28 - a38);
    s25 = (a38 + a28);
    t9i = (t7h + t3i);
    t0j = (t8h + t4i);
    t1j = (t7h - t3i);
    t2j = (t8h - t4i);
    t3j = (t1i + t7i);
    t4j = (t2i + t8i);
    t5j = (t1i - t7i);
    t6j = (t2i - t8i);
    *((dst + 4)) = (t9i + t3j);
    *((dst + 5)) = (t0j + t4j);
    *((dst + 36)) = (t9i - t3j);
    *((dst + 37)) = (t0j - t4j);
    *((dst + 20)) = (t1j + t6j);
    *((dst + 21)) = (t2j - t5j);
    *((dst + 52)) = (t1j - t6j);
    *((dst + 53)) = (t2j + t5j);
    t7j = (t9h + t6i);
    t8j = (t0i - t5i);
    t9j = (t9h - t6i);
    t0k = (t0i + t5i);
    t1k = (s94 + s15);
    t2k = (s05 - s25);
    t3k = (s94 - s15);
    t4k = (s05 + s25);
    *((dst + 12)) = (t7j + t1k);
    *((dst + 13)) = (t8j + t2k);
    *((dst + 44)) = (t7j - t1k);
    *((dst + 45)) = (t8j - t2k);
    *((dst + 28)) = (t9j + t4k);
    *((dst + 29)) = (t0k - t3k);
    *((dst + 60)) = (t9j - t4k);
    *((dst + 61)) = (t0k + t3k);
    t5k = (t51 + s12);
    t6k = (t61 - s22);
    t7k = (t51 - s12);
    t8k = (t61 + s22);
    t9k = (s5 + s72);
    t0l = (s6 - s82);
    a48 = (0.70710678118654757f*(s5 - s72));
    a58 = (0.70710678118654757f*(s6 + s82));
    s35 = (a48 + a58);
    s45 = (a58 - a48);
    t1l = (s11 - s33);
    t2l = (s21 + s43);
    t3l = (s11 + s33);
    t4l = (s21 - s43);
    t5l = (s71 - s93);
    t6l = (s04 - s81);
    a68 = (0.70710678118654757f*(s71 + s93));
    a78 = (0.70710678118654757f*(s81 + s04));
    s55 = (a68 + a78);
    s65 = (a78 - a68);
    t7l = (t5k + t1l);
    t8l = (t6k + t2l);
    t9l = (t5k - t1l);
    t0m = (t6k - t2l);
    t1m = (t9k + t5l);
    t2m = (t0l + t6l);
    t3m = (t9k - t5l);
    t4m = (t0l - t6l);
    *((dst + 6)) = (t7l + t1m);
    *((dst + 7)) = (t8l + t2m);
    *((dst + 38)) = (t7l - t1m);
    *((dst + 39)) = (t8l - t2m);
    *((dst + 22)) = (t9l + t4m);
    *((dst + 23)) = (t0m - t3m);
    *((dst + 54)) = (t9l - t4m);
    *((dst + 55)) = (t0m + t3m);
    t5m = (t7k + t4l);
    t6m = (t8k - t3l);
    t7m = (t7k - t4l);
    t8m = (t8k + t3l);
    t9m = (s35 - s55);
    t0n = (s45 + s65);
    t1n = (s35 + s55);
    t2n = (s45 - s65);
    *((dst + 14)) = (t5m + t9m);
    *((dst + 15)) = (t6m + t0n);
    *((dst + 46)) = (t5m - t9m);
    *((dst + 47)) = (t6m - t0n);
    *((dst + 30)) = (t7m + t2n);
    *((dst + 31)) = (t8m - t1n);
    *((dst + 62)) = (t7m - t2n);
    *((dst + 63)) = (t8m + t1n);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_float_64)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[128];
    float  *a03, *a04, *a05, *a06, *a13, *a14, *a15, *a22, *a23, *a24, *a25, *a32, *a33, *a34, *a35, *a42, *a43, *a44, *a45, *a52, *a53, *a54
            , *a55, *a62, *a63, *a64, *a65, *a72, *a73, *a74, *a75, *a82, *a83, *a92;
    const float  *a, *a11, *a2, *a21, *a3, *a31, *a4, *a41, *a5, *a51, *a6, *a61, *a7, *a71, *a8, *a81;
    int a12, a93;
    float a01, a02, a84, a85, a9, a91, a94, a95, s, s2, s3, s4, s5, s6, s7, s8, t, t01, t02, t03, t04, t05
            , t06, t07, t11, t12, t13, t14, t15, t16, t17, t2, t21, t22, t23, t24, t25, t26, t27, t3, t31, t32, t33, t34
            , t35, t36, t4, t41, t42, t43, t44, t45, t46, t5, t51, t52, t53, t54, t55, t56, t6, t61, t62, t63, t64, t65
            , t66, t7, t71, t72, t73, t74, t75, t76, t8, t81, t82, t83, t84, t85, t86, t9, t91, t92, t93, t94, t95, t96;
    {long i; for(i = 0; i <= 7; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 64);
        a4 = (a + 65);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 16);
        a6 = (a + 17);
        a7 = (a + 80);
        a8 = (a + 81);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        a9 = (0.70710678118654757f*(*(a5) - *(a7)));
        a01 = (0.70710678118654757f*(*(a6) - *(a8)));
        s = (a9 + a01);
        s2 = (a01 - a9);
        a11 = (a + 32);
        a21 = (a + 33);
        a31 = (a + 96);
        a41 = (a + 97);
        t7 = (*(a11) + *(a31));
        t8 = (*(a21) + *(a41));
        t9 = (*(a11) - *(a31));
        t01 = (*(a21) - *(a41));
        a51 = (a + 48);
        a61 = (a + 49);
        a71 = (a + 112);
        a81 = (a + 113);
        t11 = (*(a51) + *(a71));
        t21 = (*(a61) + *(a81));
        a91 = (0.70710678118654757f*(*(a61) - *(a81)));
        a02 = (0.70710678118654757f*(*(a51) - *(a71)));
        s3 = (a91 - a02);
        s4 = (a02 + a91);
        t31 = (t + t7);
        t41 = (t2 + t8);
        t51 = (t - t7);
        t61 = (t2 - t8);
        t71 = (t5 + t11);
        t81 = (t6 + t21);
        t91 = (t5 - t11);
        t02 = (t6 - t21);
        t12 = (t31 + t71);
        t22 = (t41 + t81);
        t32 = (t31 - t71);
        t42 = (t41 - t81);
        a12 = (16*i);
        a22 = (D275 + a12);
        a32 = (a22 + 1);
        a42 = (a22 + 2);
        a52 = (a22 + 3);
        a62 = (T + a12);
        *(a62) = ((*(a22)*t12) - (*(a32)*t22));
        *((a62 + 1)) = ((*(a32)*t12) + (*(a22)*t22));
        *((a62 + 8)) = ((*(a42)*t32) - (*(a52)*t42));
        *((a62 + 9)) = ((*(a52)*t32) + (*(a42)*t42));
        t52 = (t51 + t02);
        t62 = (t61 - t91);
        t72 = (t51 - t02);
        t82 = (t61 + t91);
        a72 = (a22 + 4);
        a82 = (a22 + 5);
        a92 = (a22 + 6);
        a03 = (a22 + 7);
        *((a62 + 4)) = ((*(a72)*t52) - (*(a82)*t62));
        *((a62 + 5)) = ((*(a82)*t52) + (*(a72)*t62));
        *((a62 + 12)) = ((*(a92)*t72) - (*(a03)*t82));
        *((a62 + 13)) = ((*(a03)*t72) + (*(a92)*t82));
        t92 = (t3 + t01);
        t03 = (t4 - t9);
        t13 = (t3 - t01);
        t23 = (t4 + t9);
        t33 = (s + s3);
        t43 = (s2 - s4);
        t53 = (s - s3);
        t63 = (s2 + s4);
        t73 = (t92 + t33);
        t83 = (t03 + t43);
        t93 = (t92 - t33);
        t04 = (t03 - t43);
        a13 = (a22 + 8);
        a23 = (a22 + 9);
        a33 = (a22 + 10);
        a43 = (a22 + 11);
        *((a62 + 2)) = ((*(a13)*t73) - (*(a23)*t83));
        *((a62 + 3)) = ((*(a23)*t73) + (*(a13)*t83));
        *((a62 + 10)) = ((*(a33)*t93) - (*(a43)*t04));
        *((a62 + 11)) = ((*(a43)*t93) + (*(a33)*t04));
        t14 = (t13 + t63);
        t24 = (t23 - t53);
        t34 = (t13 - t63);
        t44 = (t23 + t53);
        a53 = (a22 + 12);
        a63 = (a22 + 13);
        a73 = (a22 + 14);
        a83 = (a22 + 15);
        *((a62 + 6)) = ((*(a53)*t14) - (*(a63)*t24));
        *((a62 + 7)) = ((*(a63)*t14) + (*(a53)*t24));
        *((a62 + 14)) = ((*(a73)*t34) - (*(a83)*t44));
        *((a62 + 15)) = ((*(a83)*t34) + (*(a73)*t44));
    }}
    {long i2; for(i2 = 0; i2 <= 7; i2++) {
        a93 = (2*i2);
        a04 = (T + a93);
        a14 = (a04 + 1);
        a24 = (a04 + 64);
        a34 = (a04 + 65);
        t54 = (*(a04) + *(a24));
        t64 = (*(a14) + *(a34));
        t74 = (*(a04) - *(a24));
        t84 = (*(a14) - *(a34));
        a44 = (a04 + 16);
        a54 = (a04 + 17);
        a64 = (a04 + 80);
        a74 = (a04 + 81);
        t94 = (*(a44) + *(a64));
        t05 = (*(a54) + *(a74));
        a84 = (0.70710678118654757f*(*(a44) - *(a64)));
        a94 = (0.70710678118654757f*(*(a54) - *(a74)));
        s5 = (a84 + a94);
        s6 = (a94 - a84);
        a05 = (a04 + 32);
        a15 = (a04 + 33);
        a25 = (a04 + 96);
        a35 = (a04 + 97);
        t15 = (*(a05) + *(a25));
        t25 = (*(a15) + *(a35));
        t35 = (*(a05) - *(a25));
        t45 = (*(a15) - *(a35));
        a45 = (a04 + 48);
        a55 = (a04 + 49);
        a65 = (a04 + 112);
        a75 = (a04 + 113);
        t55 = (*(a45) + *(a65));
        t65 = (*(a55) + *(a75));
        a85 = (0.70710678118654757f*(*(a55) - *(a75)));
        a95 = (0.70710678118654757f*(*(a45) - *(a65)));
        s7 = (a85 - a95);
        s8 = (a95 + a85);
        t75 = (t54 + t15);
        t85 = (t64 + t25);
        t95 = (t54 - t15);
        t06 = (t64 - t25);
        t16 = (t94 + t55);
        t26 = (t05 + t65);
        t36 = (t94 - t55);
        t46 = (t05 - t65);
        a06 = (dst + a93);
        *(a06) = (t75 + t16);
        *((a06 + 1)) = (t85 + t26);
        *((a06 + 64)) = (t75 - t16);
        *((a06 + 65)) = (t85 - t26);
        *((a06 + 32)) = (t95 + t46);
        *((a06 + 33)) = (t06 - t36);
        *((a06 + 96)) = (t95 - t46);
        *((a06 + 97)) = (t06 + t36);
        t56 = (t74 + t45);
        t66 = (t84 - t35);
        t76 = (t74 - t45);
        t86 = (t84 + t35);
        t96 = (s5 + s7);
        t07 = (s6 - s8);
        t17 = (s5 - s7);
        t27 = (s6 + s8);
        *((a06 + 16)) = (t56 + t96);
        *((a06 + 17)) = (t66 + t07);
        *((a06 + 80)) = (t56 - t96);
        *((a06 + 81)) = (t66 - t07);
        *((a06 + 48)) = (t76 + t27);
        *((a06 + 49)) = (t86 - t17);
        *((a06 + 112)) = (t76 - t27);
        *((a06 + 113)) = (t86 + t17);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_float_128)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[256];
    float  *a05, *a06, *a07, *a08, *a09, *a15, *a16, *a17, *a18, *a19, *a24, *a25, *a26, *a27, *a28, *a29, *a34, *a35, *a36, *a37, *a38, *a39
            , *a44, *a45, *a46, *a47, *a54, *a55, *a56, *a64, *a65, *a66, *a67, *a68, *a69, *a74, *a75, *a76, *a77, *a78, *a84, *a85, *a86, *a87
            , *a88, *a94, *a95, *a96, *a97, *a98;
    const float  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a57;
    float a03, a04, a48, a49, a58, a59, a71, a72, a81, a82, a92, a93, s, s01, s02, s11, s2, s21, s3, s31, s4, s41
            , s5, s51, s6, s61, s7, s71, s8, s81, s9, s91, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b
            , t0c, t0d, t0e, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t2, t21, t22, t23, t24
            , t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b
            , t3c, t3d, t3e, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t5, t51, t52, t53
            , t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a
            , t6b, t6c, t6d, t6e, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t8, t81, t82
            , t83, t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99
            , t9a, t9b, t9c, t9d;
    {long i; for(i = 0; i <= 7; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 128);
        a4 = (a + 129);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 64);
        a6 = (a + 65);
        a7 = (a + 192);
        a8 = (a + 193);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 + t8);
        t41 = (t4 - t7);
        t51 = (t3 - t8);
        t61 = (t4 + t7);
        a9 = (a + 16);
        a01 = (a + 17);
        a11 = (a + 144);
        a21 = (a + 145);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 80);
        a41 = (a + 81);
        a51 = (a + 208);
        a61 = (a + 209);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        a71 = (0.70710678118654757f*(t71 - t12));
        a81 = (0.70710678118654757f*(t81 - t22));
        s = (a71 + a81);
        s2 = (a81 - a71);
        t72 = (t91 + t42);
        t82 = (t02 - t32);
        t92 = (t91 - t42);
        t03 = (t02 + t32);
        s3 = ((0.92387953251128674f*t72) + (0.38268343236508978f*t82));
        s4 = ((0.92387953251128674f*t82) - (0.38268343236508978f*t72));
        s5 = ((0.38268343236508978f*t92) + (0.92387953251128674f*t03));
        s6 = ((0.38268343236508978f*t03) - (0.92387953251128674f*t92));
        a91 = (a + 32);
        a02 = (a + 33);
        a12 = (a + 160);
        a22 = (a + 161);
        t13 = (*(a91) + *(a12));
        t23 = (*(a02) + *(a22));
        t33 = (*(a91) - *(a12));
        t43 = (*(a02) - *(a22));
        a32 = (a + 96);
        a42 = (a + 97);
        a52 = (a + 224);
        a62 = (a + 225);
        t53 = (*(a32) + *(a52));
        t63 = (*(a42) + *(a62));
        t73 = (*(a32) - *(a52));
        t83 = (*(a42) - *(a62));
        t93 = (t13 + t53);
        t04 = (t23 + t63);
        t14 = (t13 - t53);
        t24 = (t23 - t63);
        a72 = (0.70710678118654757f*(t33 + t83));
        a82 = (0.70710678118654757f*(t43 - t73));
        s7 = (a72 + a82);
        s8 = (a82 - a72);
        a92 = (0.70710678118654757f*(t43 + t73));
        a03 = (0.70710678118654757f*(t33 - t83));
        s9 = (a92 - a03);
        s01 = (a03 + a92);
        a13 = (a + 48);
        a23 = (a + 49);
        a33 = (a + 176);
        a43 = (a + 177);
        t34 = (*(a13) + *(a33));
        t44 = (*(a23) + *(a43));
        t54 = (*(a13) - *(a33));
        t64 = (*(a23) - *(a43));
        a53 = (a + 112);
        a63 = (a + 113);
        a73 = (a + 240);
        a83 = (a + 241);
        t74 = (*(a53) + *(a73));
        t84 = (*(a63) + *(a83));
        t94 = (*(a53) - *(a73));
        t05 = (*(a63) - *(a83));
        t15 = (t34 + t74);
        t25 = (t44 + t84);
        a93 = (0.70710678118654757f*(t44 - t84));
        a04 = (0.70710678118654757f*(t34 - t74));
        s11 = (a93 - a04);
        s21 = (a04 + a93);
        t35 = (t54 + t05);
        t45 = (t64 - t94);
        t55 = (t54 - t05);
        t65 = (t64 + t94);
        s31 = ((0.38268343236508978f*t35) + (0.92387953251128674f*t45));
        s41 = ((0.38268343236508978f*t45) - (0.92387953251128674f*t35));
        s51 = ((0.92387953251128674f*t55) + (0.38268343236508978f*t65));
        s61 = ((0.38268343236508978f*t55) - (0.92387953251128674f*t65));
        t75 = (t9 + t93);
        t85 = (t01 + t04);
        t95 = (t9 - t93);
        t06 = (t01 - t04);
        t16 = (t52 + t15);
        t26 = (t62 + t25);
        t36 = (t52 - t15);
        t46 = (t62 - t25);
        t56 = (t75 + t16);
        t66 = (t85 + t26);
        t76 = (t75 - t16);
        t86 = (t85 - t26);
        a14 = (32*i);
        a24 = (D276 + a14);
        a34 = (a24 + 1);
        a44 = (a24 + 2);
        a54 = (a24 + 3);
        a64 = (T + a14);
        *(a64) = ((*(a24)*t56) - (*(a34)*t66));
        *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
        *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
        *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
        t96 = (t95 + t46);
        t07 = (t06 - t36);
        t17 = (t95 - t46);
        t27 = (t06 + t36);
        a74 = (a24 + 4);
        a84 = (a24 + 5);
        a94 = (a24 + 6);
        a05 = (a24 + 7);
        *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
        *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
        *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
        *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
        t37 = (t31 + s7);
        t47 = (t41 + s8);
        t57 = (t31 - s7);
        t67 = (t41 - s8);
        t77 = (s3 + s31);
        t87 = (s4 + s41);
        t97 = (s3 - s31);
        t08 = (s4 - s41);
        t18 = (t37 + t77);
        t28 = (t47 + t87);
        t38 = (t37 - t77);
        t48 = (t47 - t87);
        a15 = (a24 + 8);
        a25 = (a24 + 9);
        a35 = (a24 + 10);
        a45 = (a24 + 11);
        *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
        *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
        *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
        *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
        t58 = (t57 + t08);
        t68 = (t67 - t97);
        t78 = (t57 - t08);
        t88 = (t67 + t97);
        a55 = (a24 + 12);
        a65 = (a24 + 13);
        a75 = (a24 + 14);
        a85 = (a24 + 15);
        *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
        *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
        *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
        *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
        t98 = (t11 + t24);
        t09 = (t21 - t14);
        t19 = (t11 - t24);
        t29 = (t21 + t14);
        t39 = (s + s11);
        t49 = (s2 - s21);
        t59 = (s - s11);
        t69 = (s2 + s21);
        t79 = (t98 + t39);
        t89 = (t09 + t49);
        t99 = (t98 - t39);
        t0a = (t09 - t49);
        a95 = (a24 + 16);
        a06 = (a24 + 17);
        a16 = (a24 + 18);
        a26 = (a24 + 19);
        *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
        *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
        *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
        *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
        t1a = (t19 + t69);
        t2a = (t29 - t59);
        t3a = (t19 - t69);
        t4a = (t29 + t59);
        a36 = (a24 + 20);
        a46 = (a24 + 21);
        a56 = (a24 + 22);
        a66 = (a24 + 23);
        *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
        *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
        *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
        *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
        t5a = (t51 + s9);
        t6a = (t61 - s01);
        t7a = (t51 - s9);
        t8a = (t61 + s01);
        t9a = (s5 - s51);
        t0b = (s6 + s61);
        t1b = (s5 + s51);
        t2b = (s6 - s61);
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        a76 = (a24 + 24);
        a86 = (a24 + 25);
        a96 = (a24 + 26);
        a07 = (a24 + 27);
        *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
        *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
        *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
        *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
        t7b = (t7a + t2b);
        t8b = (t8a - t1b);
        t9b = (t7a - t2b);
        t0c = (t8a + t1b);
        a17 = (a24 + 28);
        a27 = (a24 + 29);
        a37 = (a24 + 30);
        a47 = (a24 + 31);
        *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
        *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
        *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
        *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        a57 = (2*i2);
        a67 = (T + a57);
        a77 = (a67 + 1);
        a87 = (a67 + 128);
        a97 = (a67 + 129);
        t1c = (*(a67) + *(a87));
        t2c = (*(a77) + *(a97));
        t3c = (*(a67) - *(a87));
        t4c = (*(a77) - *(a97));
        a08 = (a67 + 32);
        a18 = (a67 + 33);
        a28 = (a67 + 160);
        a38 = (a67 + 161);
        t5c = (*(a08) + *(a28));
        t6c = (*(a18) + *(a38));
        a48 = (0.70710678118654757f*(*(a08) - *(a28)));
        a58 = (0.70710678118654757f*(*(a18) - *(a38)));
        s71 = (a48 + a58);
        s81 = (a58 - a48);
        a68 = (a67 + 64);
        a78 = (a67 + 65);
        a88 = (a67 + 192);
        a98 = (a67 + 193);
        t7c = (*(a68) + *(a88));
        t8c = (*(a78) + *(a98));
        t9c = (*(a68) - *(a88));
        t0d = (*(a78) - *(a98));
        a09 = (a67 + 96);
        a19 = (a67 + 97);
        a29 = (a67 + 224);
        a39 = (a67 + 225);
        t1d = (*(a09) + *(a29));
        t2d = (*(a19) + *(a39));
        a49 = (0.70710678118654757f*(*(a19) - *(a39)));
        a59 = (0.70710678118654757f*(*(a09) - *(a29)));
        s91 = (a49 - a59);
        s02 = (a59 + a49);
        t3d = (t1c + t7c);
        t4d = (t2c + t8c);
        t5d = (t1c - t7c);
        t6d = (t2c - t8c);
        t7d = (t5c + t1d);
        t8d = (t6c + t2d);
        t9d = (t5c - t1d);
        t0e = (t6c - t2d);
        a69 = (dst + a57);
        *(a69) = (t3d + t7d);
        *((a69 + 1)) = (t4d + t8d);
        *((a69 + 128)) = (t3d - t7d);
        *((a69 + 129)) = (t4d - t8d);
        *((a69 + 64)) = (t5d + t0e);
        *((a69 + 65)) = (t6d - t9d);
        *((a69 + 192)) = (t5d - t0e);
        *((a69 + 193)) = (t6d + t9d);
        t1e = (t3c + t0d);
        t2e = (t4c - t9c);
        t3e = (t3c - t0d);
        t4e = (t4c + t9c);
        t5e = (s71 + s91);
        t6e = (s81 - s02);
        t7e = (s71 - s91);
        t8e = (s81 + s02);
        *((a69 + 32)) = (t1e + t5e);
        *((a69 + 33)) = (t2e + t6e);
        *((a69 + 160)) = (t1e - t5e);
        *((a69 + 161)) = (t2e - t6e);
        *((a69 + 96)) = (t3e + t8e);
        *((a69 + 97)) = (t4e - t7e);
        *((a69 + 224)) = (t3e - t8e);
        *((a69 + 225)) = (t4e + t7e);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_float_256)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[512];
    float  *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a15, *a16, *a17, *a18, *a19, *a1a, *a1b, *a24, *a25, *a26, *a27, *a28, *a2b, *a34, *a35
            , *a36, *a37, *a38, *a3b, *a44, *a45, *a46, *a47, *a48, *a49, *a54, *a55, *a56, *a58, *a59, *a64, *a65, *a66, *a67, *a68, *a69, *a6a
            , *a6b, *a74, *a75, *a76, *a77, *a78, *a79, *a7a, *a84, *a85, *a86, *a87, *a88, *a89, *a8a, *a94, *a95, *a96, *a97, *a98, *a99, *a9a;
    const float  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a57;
    float a03, a04, a29, a2a, a39, a3a, a4a, a4b, a5a, a5b, a71, a72, a81, a82, a92, a93, s, s01, s02, s03, s11, s12
            , s13, s2, s21, s22, s23, s3, s31, s32, s4, s41, s42, s5, s51, s52, s6, s61, s62, s7, s71, s72, s8, s81
            , s82, s9, s91, s92, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h
            , t0i, t0j, t0k, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j
            , t1k, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k
            , t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t4
            , t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t5, t51
            , t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t6, t61, t62
            , t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t7, t71, t72, t73
            , t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t8, t81, t82, t83, t84
            , t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t9, t91, t92, t93, t94, t95
            , t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j;
    {long i; for(i = 0; i <= 15; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 256);
        a4 = (a + 257);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 128);
        a6 = (a + 129);
        a7 = (a + 384);
        a8 = (a + 385);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 + t8);
        t41 = (t4 - t7);
        t51 = (t3 - t8);
        t61 = (t4 + t7);
        a9 = (a + 32);
        a01 = (a + 33);
        a11 = (a + 288);
        a21 = (a + 289);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 160);
        a41 = (a + 161);
        a51 = (a + 416);
        a61 = (a + 417);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        a71 = (0.70710678118654757f*(t71 - t12));
        a81 = (0.70710678118654757f*(t81 - t22));
        s = (a71 + a81);
        s2 = (a81 - a71);
        t72 = (t91 + t42);
        t82 = (t02 - t32);
        t92 = (t91 - t42);
        t03 = (t02 + t32);
        s3 = ((0.92387953251128674f*t72) + (0.38268343236508978f*t82));
        s4 = ((0.92387953251128674f*t82) - (0.38268343236508978f*t72));
        s5 = ((0.38268343236508978f*t92) + (0.92387953251128674f*t03));
        s6 = ((0.38268343236508978f*t03) - (0.92387953251128674f*t92));
        a91 = (a + 64);
        a02 = (a + 65);
        a12 = (a + 320);
        a22 = (a + 321);
        t13 = (*(a91) + *(a12));
        t23 = (*(a02) + *(a22));
        t33 = (*(a91) - *(a12));
        t43 = (*(a02) - *(a22));
        a32 = (a + 192);
        a42 = (a + 193);
        a52 = (a + 448);
        a62 = (a + 449);
        t53 = (*(a32) + *(a52));
        t63 = (*(a42) + *(a62));
        t73 = (*(a32) - *(a52));
        t83 = (*(a42) - *(a62));
        t93 = (t13 + t53);
        t04 = (t23 + t63);
        t14 = (t13 - t53);
        t24 = (t23 - t63);
        a72 = (0.70710678118654757f*(t33 + t83));
        a82 = (0.70710678118654757f*(t43 - t73));
        s7 = (a72 + a82);
        s8 = (a82 - a72);
        a92 = (0.70710678118654757f*(t43 + t73));
        a03 = (0.70710678118654757f*(t33 - t83));
        s9 = (a92 - a03);
        s01 = (a03 + a92);
        a13 = (a + 96);
        a23 = (a + 97);
        a33 = (a + 352);
        a43 = (a + 353);
        t34 = (*(a13) + *(a33));
        t44 = (*(a23) + *(a43));
        t54 = (*(a13) - *(a33));
        t64 = (*(a23) - *(a43));
        a53 = (a + 224);
        a63 = (a + 225);
        a73 = (a + 480);
        a83 = (a + 481);
        t74 = (*(a53) + *(a73));
        t84 = (*(a63) + *(a83));
        t94 = (*(a53) - *(a73));
        t05 = (*(a63) - *(a83));
        t15 = (t34 + t74);
        t25 = (t44 + t84);
        a93 = (0.70710678118654757f*(t44 - t84));
        a04 = (0.70710678118654757f*(t34 - t74));
        s11 = (a93 - a04);
        s21 = (a04 + a93);
        t35 = (t54 + t05);
        t45 = (t64 - t94);
        t55 = (t54 - t05);
        t65 = (t64 + t94);
        s31 = ((0.38268343236508978f*t35) + (0.92387953251128674f*t45));
        s41 = ((0.38268343236508978f*t45) - (0.92387953251128674f*t35));
        s51 = ((0.92387953251128674f*t55) + (0.38268343236508978f*t65));
        s61 = ((0.38268343236508978f*t55) - (0.92387953251128674f*t65));
        t75 = (t9 + t93);
        t85 = (t01 + t04);
        t95 = (t9 - t93);
        t06 = (t01 - t04);
        t16 = (t52 + t15);
        t26 = (t62 + t25);
        t36 = (t52 - t15);
        t46 = (t62 - t25);
        t56 = (t75 + t16);
        t66 = (t85 + t26);
        t76 = (t75 - t16);
        t86 = (t85 - t26);
        a14 = (32*i);
        a24 = (D277 + a14);
        a34 = (a24 + 1);
        a44 = (a24 + 2);
        a54 = (a24 + 3);
        a64 = (T + a14);
        *(a64) = ((*(a24)*t56) - (*(a34)*t66));
        *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
        *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
        *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
        t96 = (t95 + t46);
        t07 = (t06 - t36);
        t17 = (t95 - t46);
        t27 = (t06 + t36);
        a74 = (a24 + 4);
        a84 = (a24 + 5);
        a94 = (a24 + 6);
        a05 = (a24 + 7);
        *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
        *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
        *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
        *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
        t37 = (t31 + s7);
        t47 = (t41 + s8);
        t57 = (t31 - s7);
        t67 = (t41 - s8);
        t77 = (s3 + s31);
        t87 = (s4 + s41);
        t97 = (s3 - s31);
        t08 = (s4 - s41);
        t18 = (t37 + t77);
        t28 = (t47 + t87);
        t38 = (t37 - t77);
        t48 = (t47 - t87);
        a15 = (a24 + 8);
        a25 = (a24 + 9);
        a35 = (a24 + 10);
        a45 = (a24 + 11);
        *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
        *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
        *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
        *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
        t58 = (t57 + t08);
        t68 = (t67 - t97);
        t78 = (t57 - t08);
        t88 = (t67 + t97);
        a55 = (a24 + 12);
        a65 = (a24 + 13);
        a75 = (a24 + 14);
        a85 = (a24 + 15);
        *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
        *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
        *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
        *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
        t98 = (t11 + t24);
        t09 = (t21 - t14);
        t19 = (t11 - t24);
        t29 = (t21 + t14);
        t39 = (s + s11);
        t49 = (s2 - s21);
        t59 = (s - s11);
        t69 = (s2 + s21);
        t79 = (t98 + t39);
        t89 = (t09 + t49);
        t99 = (t98 - t39);
        t0a = (t09 - t49);
        a95 = (a24 + 16);
        a06 = (a24 + 17);
        a16 = (a24 + 18);
        a26 = (a24 + 19);
        *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
        *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
        *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
        *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
        t1a = (t19 + t69);
        t2a = (t29 - t59);
        t3a = (t19 - t69);
        t4a = (t29 + t59);
        a36 = (a24 + 20);
        a46 = (a24 + 21);
        a56 = (a24 + 22);
        a66 = (a24 + 23);
        *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
        *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
        *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
        *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
        t5a = (t51 + s9);
        t6a = (t61 - s01);
        t7a = (t51 - s9);
        t8a = (t61 + s01);
        t9a = (s5 - s51);
        t0b = (s6 + s61);
        t1b = (s5 + s51);
        t2b = (s6 - s61);
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        a76 = (a24 + 24);
        a86 = (a24 + 25);
        a96 = (a24 + 26);
        a07 = (a24 + 27);
        *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
        *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
        *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
        *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
        t7b = (t7a + t2b);
        t8b = (t8a - t1b);
        t9b = (t7a - t2b);
        t0c = (t8a + t1b);
        a17 = (a24 + 28);
        a27 = (a24 + 29);
        a37 = (a24 + 30);
        a47 = (a24 + 31);
        *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
        *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
        *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
        *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        a57 = (2*i2);
        a67 = (T + a57);
        a77 = (a67 + 1);
        a87 = (a67 + 256);
        a97 = (a67 + 257);
        t1c = (*(a67) + *(a87));
        t2c = (*(a77) + *(a97));
        t3c = (*(a67) - *(a87));
        t4c = (*(a77) - *(a97));
        a08 = (a67 + 128);
        a18 = (a67 + 129);
        a28 = (a67 + 384);
        a38 = (a67 + 385);
        t5c = (*(a08) + *(a28));
        t6c = (*(a18) + *(a38));
        t7c = (*(a08) - *(a28));
        t8c = (*(a18) - *(a38));
        t9c = (t1c + t5c);
        t0d = (t2c + t6c);
        t1d = (t1c - t5c);
        t2d = (t2c - t6c);
        t3d = (t3c + t8c);
        t4d = (t4c - t7c);
        t5d = (t3c - t8c);
        t6d = (t4c + t7c);
        a48 = (a67 + 32);
        a58 = (a67 + 33);
        a68 = (a67 + 288);
        a78 = (a67 + 289);
        t7d = (*(a48) + *(a68));
        t8d = (*(a58) + *(a78));
        t9d = (*(a48) - *(a68));
        t0e = (*(a58) - *(a78));
        a88 = (a67 + 160);
        a98 = (a67 + 161);
        a09 = (a67 + 416);
        a19 = (a67 + 417);
        t1e = (*(a88) + *(a09));
        t2e = (*(a98) + *(a19));
        t3e = (*(a88) - *(a09));
        t4e = (*(a98) - *(a19));
        t5e = (t7d + t1e);
        t6e = (t8d + t2e);
        a29 = (0.70710678118654757f*(t7d - t1e));
        a39 = (0.70710678118654757f*(t8d - t2e));
        s71 = (a29 + a39);
        s81 = (a39 - a29);
        t7e = (t9d + t4e);
        t8e = (t0e - t3e);
        t9e = (t9d - t4e);
        t0f = (t0e + t3e);
        s91 = ((0.92387953251128674f*t7e) + (0.38268343236508978f*t8e));
        s02 = ((0.92387953251128674f*t8e) - (0.38268343236508978f*t7e));
        s12 = ((0.38268343236508978f*t9e) + (0.92387953251128674f*t0f));
        s22 = ((0.38268343236508978f*t0f) - (0.92387953251128674f*t9e));
        a49 = (a67 + 64);
        a59 = (a67 + 65);
        a69 = (a67 + 320);
        a79 = (a67 + 321);
        t1f = (*(a49) + *(a69));
        t2f = (*(a59) + *(a79));
        t3f = (*(a49) - *(a69));
        t4f = (*(a59) - *(a79));
        a89 = (a67 + 192);
        a99 = (a67 + 193);
        a0a = (a67 + 448);
        a1a = (a67 + 449);
        t5f = (*(a89) + *(a0a));
        t6f = (*(a99) + *(a1a));
        t7f = (*(a89) - *(a0a));
        t8f = (*(a99) - *(a1a));
        t9f = (t1f + t5f);
        t0g = (t2f + t6f);
        t1g = (t1f - t5f);
        t2g = (t2f - t6f);
        a2a = (0.70710678118654757f*(t3f + t8f));
        a3a = (0.70710678118654757f*(t4f - t7f));
        s32 = (a2a + a3a);
        s42 = (a3a - a2a);
        a4a = (0.70710678118654757f*(t4f + t7f));
        a5a = (0.70710678118654757f*(t3f - t8f));
        s52 = (a4a - a5a);
        s62 = (a5a + a4a);
        a6a = (a67 + 96);
        a7a = (a67 + 97);
        a8a = (a67 + 352);
        a9a = (a67 + 353);
        t3g = (*(a6a) + *(a8a));
        t4g = (*(a7a) + *(a9a));
        t5g = (*(a6a) - *(a8a));
        t6g = (*(a7a) - *(a9a));
        a0b = (a67 + 224);
        a1b = (a67 + 225);
        a2b = (a67 + 480);
        a3b = (a67 + 481);
        t7g = (*(a0b) + *(a2b));
        t8g = (*(a1b) + *(a3b));
        t9g = (*(a0b) - *(a2b));
        t0h = (*(a1b) - *(a3b));
        t1h = (t3g + t7g);
        t2h = (t4g + t8g);
        a4b = (0.70710678118654757f*(t4g - t8g));
        a5b = (0.70710678118654757f*(t3g - t7g));
        s72 = (a4b - a5b);
        s82 = (a5b + a4b);
        t3h = (t5g + t0h);
        t4h = (t6g - t9g);
        t5h = (t5g - t0h);
        t6h = (t6g + t9g);
        s92 = ((0.38268343236508978f*t3h) + (0.92387953251128674f*t4h));
        s03 = ((0.38268343236508978f*t4h) - (0.92387953251128674f*t3h));
        s13 = ((0.92387953251128674f*t5h) + (0.38268343236508978f*t6h));
        s23 = ((0.38268343236508978f*t5h) - (0.92387953251128674f*t6h));
        t7h = (t9c + t9f);
        t8h = (t0d + t0g);
        t9h = (t9c - t9f);
        t0i = (t0d - t0g);
        t1i = (t5e + t1h);
        t2i = (t6e + t2h);
        t3i = (t5e - t1h);
        t4i = (t6e - t2h);
        a6b = (dst + a57);
        *(a6b) = (t7h + t1i);
        *((a6b + 1)) = (t8h + t2i);
        *((a6b + 256)) = (t7h - t1i);
        *((a6b + 257)) = (t8h - t2i);
        *((a6b + 128)) = (t9h + t4i);
        *((a6b + 129)) = (t0i - t3i);
        *((a6b + 384)) = (t9h - t4i);
        *((a6b + 385)) = (t0i + t3i);
        t5i = (t3d + s32);
        t6i = (t4d + s42);
        t7i = (t3d - s32);
        t8i = (t4d - s42);
        t9i = (s91 + s92);
        t0j = (s02 + s03);
        t1j = (s91 - s92);
        t2j = (s02 - s03);
        *((a6b + 32)) = (t5i + t9i);
        *((a6b + 33)) = (t6i + t0j);
        *((a6b + 288)) = (t5i - t9i);
        *((a6b + 289)) = (t6i - t0j);
        *((a6b + 160)) = (t7i + t2j);
        *((a6b + 161)) = (t8i - t1j);
        *((a6b + 416)) = (t7i - t2j);
        *((a6b + 417)) = (t8i + t1j);
        t3j = (t1d + t2g);
        t4j = (t2d - t1g);
        t5j = (t1d - t2g);
        t6j = (t2d + t1g);
        t7j = (s71 + s72);
        t8j = (s81 - s82);
        t9j = (s71 - s72);
        t0k = (s81 + s82);
        *((a6b + 64)) = (t3j + t7j);
        *((a6b + 65)) = (t4j + t8j);
        *((a6b + 320)) = (t3j - t7j);
        *((a6b + 321)) = (t4j - t8j);
        *((a6b + 192)) = (t5j + t0k);
        *((a6b + 193)) = (t6j - t9j);
        *((a6b + 448)) = (t5j - t0k);
        *((a6b + 449)) = (t6j + t9j);
        t1k = (t5d + s52);
        t2k = (t6d - s62);
        t3k = (t5d - s52);
        t4k = (t6d + s62);
        t5k = (s12 - s13);
        t6k = (s22 + s23);
        t7k = (s12 + s13);
        t8k = (s22 - s23);
        *((a6b + 96)) = (t1k + t5k);
        *((a6b + 97)) = (t2k + t6k);
        *((a6b + 352)) = (t1k - t5k);
        *((a6b + 353)) = (t2k - t6k);
        *((a6b + 224)) = (t3k + t8k);
        *((a6b + 225)) = (t4k - t7k);
        *((a6b + 480)) = (t3k - t8k);
        *((a6b + 481)) = (t4k + t7k);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_float_512)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[1024];
    float  *a08, *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0g, *a0h, *a0i, *a0j, *a18, *a19, *a1a, *a1b, *a1c, *a1d, *a1e, *a1f, *a1g, *a1h
            , *a1i, *a1j, *a28, *a29, *a2a, *a2b, *a2c, *a2d, *a2e, *a2f, *a2g, *a2j, *a38, *a39, *a3a, *a3b, *a3c, *a3d, *a3e, *a3f, *a3g, *a3j
            , *a48, *a49, *a4a, *a4b, *a4c, *a4d, *a4e, *a4f, *a4g, *a4h, *a58, *a5a, *a5c, *a5e, *a5g, *a5h, *a68, *a6a, *a6c, *a6e, *a6f, *a6g
            , *a6h, *a6i, *a6j, *a78, *a7a, *a7c, *a7e, *a7f, *a7g, *a7h, *a7i, *a87, *a88, *a8a, *a8c, *a8e, *a8f, *a8g, *a8h, *a8i, *a97, *a98
            , *a99, *a9a, *a9b, *a9c, *a9d, *a9e, *a9f, *a9g, *a9h, *a9i;
    const float  *a, *a01, *a02, *a03, *a04, *a05, *a06, *a07, *a11, *a12, *a13, *a14, *a15, *a16, *a17, *a2, *a21, *a22, *a23, *a24, *a25, *a26
            , *a27, *a3, *a31, *a32, *a33, *a35, *a4, *a41, *a42, *a43, *a45, *a5, *a51, *a53, *a55, *a56, *a6, *a61, *a63, *a65, *a66, *a7
            , *a71, *a72, *a73, *a74, *a75, *a76, *a8, *a81, *a82, *a83, *a84, *a85, *a86, *a9, *a91, *a92, *a93, *a94, *a95, *a96;
    int a5f, a77;
    float a2h, a2i, a34, a36, a37, a3h, a3i, a44, a46, a47, a4i, a4j, a52, a54, a57, a59, a5b, a5d, a5i, a5j, a62, a64
            , a67, a69, a6b, a6d, a79, a7b, a7d, a89, a8b, a8d, s, s01, s02, s03, s04, s05, s06, s07, s11, s12, s13, s14
            , s15, s16, s17, s2, s21, s22, s23, s24, s25, s26, s27, s3, s31, s32, s33, s34, s35, s36, s4, s41, s42, s43
            , s44, s45, s46, s5, s51, s52, s53, s54, s55, s56, s6, s61, s62, s63, s64, s65, s66, s7, s71, s72, s73, s74
            , s75, s76, s8, s81, s82, s83, s84, s85, s86, s9, s91, s92, s93, s94, s95, s96, t, t01, t02, t03, t04, t05
            , t06, t07, t08, t09, t0A, t0B, t0C, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o
            , t0p, t0q, t0r, t0s, t0t, t0u, t0v, t0w, t0x, t0y, t0z, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1A, t1B
            , t1C, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t, t1u
            , t1v, t1w, t1x, t1y, t1z, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2A, t2B, t2C, t2a, t2b, t2c, t2d
            , t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p, t2q, t2r, t2s, t2t, t2u, t2v, t2w, t2x, t2y, t2z
            , t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3A, t3B, t3C, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i
            , t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s, t3t, t3u, t3v, t3w, t3x, t3y, t3z, t4, t41, t42, t43, t44
            , t45, t46, t47, t48, t49, t4A, t4B, t4C, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n
            , t4o, t4p, t4q, t4r, t4s, t4t, t4u, t4v, t4w, t4x, t4y, t4z, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59
            , t5A, t5B, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t5r, t5s, t5t
            , t5u, t5v, t5w, t5x, t5y, t5z, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6A, t6B, t6a, t6b, t6c, t6d
            , t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r, t6s, t6t, t6u, t6v, t6w, t6x, t6y, t6z
            , t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7A, t7B, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j
            , t7k, t7l, t7m, t7n, t7o, t7p, t7q, t7r, t7s, t7t, t7u, t7v, t7w, t7x, t7y, t7z, t8, t81, t82, t83, t84, t85
            , t86, t87, t88, t89, t8A, t8B, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p
            , t8q, t8r, t8s, t8t, t8u, t8v, t8w, t8x, t8y, t8z, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9A, t9B
            , t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p, t9q, t9r, t9s, t9t, t9u, t9v
            , t9w, t9x, t9y, t9z;
    {long i; for(i = 0; i <= 15; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 512);
        a4 = (a + 513);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 256);
        a6 = (a + 257);
        a7 = (a + 768);
        a8 = (a + 769);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 + t8);
        t41 = (t4 - t7);
        t51 = (t3 - t8);
        t61 = (t4 + t7);
        a9 = (a + 32);
        a01 = (a + 33);
        a11 = (a + 544);
        a21 = (a + 545);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 288);
        a41 = (a + 289);
        a51 = (a + 800);
        a61 = (a + 801);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        t72 = (t71 - t12);
        t82 = (t81 - t22);
        s = ((0.92387953251128674f*t72) + (0.38268343236508978f*t82));
        s2 = ((0.92387953251128674f*t82) - (0.38268343236508978f*t72));
        t92 = (t91 + t42);
        t03 = (t02 - t32);
        t13 = (t91 - t42);
        t23 = (t02 + t32);
        s3 = ((0.98078528040323043f*t92) + (0.19509032201612828f*t03));
        s4 = ((0.98078528040323043f*t03) - (0.19509032201612828f*t92));
        s5 = ((0.83146961230254524f*t13) + (0.55557023301960218f*t23));
        s6 = ((0.83146961230254524f*t23) - (0.55557023301960218f*t13));
        a71 = (a + 64);
        a81 = (a + 65);
        a91 = (a + 576);
        a02 = (a + 577);
        t33 = (*(a71) + *(a91));
        t43 = (*(a81) + *(a02));
        t53 = (*(a71) - *(a91));
        t63 = (*(a81) - *(a02));
        a12 = (a + 320);
        a22 = (a + 321);
        a32 = (a + 832);
        a42 = (a + 833);
        t73 = (*(a12) + *(a32));
        t83 = (*(a22) + *(a42));
        t93 = (*(a12) - *(a32));
        t04 = (*(a22) - *(a42));
        t14 = (t33 + t73);
        t24 = (t43 + t83);
        a52 = (0.70710678118654757f*(t33 - t73));
        a62 = (0.70710678118654757f*(t43 - t83));
        s7 = (a52 + a62);
        s8 = (a62 - a52);
        t34 = (t53 + t04);
        t44 = (t63 - t93);
        t54 = (t53 - t04);
        t64 = (t63 + t93);
        s9 = ((0.92387953251128674f*t34) + (0.38268343236508978f*t44));
        s01 = ((0.92387953251128674f*t44) - (0.38268343236508978f*t34));
        s11 = ((0.38268343236508978f*t54) + (0.92387953251128674f*t64));
        s21 = ((0.38268343236508978f*t64) - (0.92387953251128674f*t54));
        a72 = (a + 96);
        a82 = (a + 97);
        a92 = (a + 608);
        a03 = (a + 609);
        t74 = (*(a72) + *(a92));
        t84 = (*(a82) + *(a03));
        t94 = (*(a72) - *(a92));
        t05 = (*(a82) - *(a03));
        a13 = (a + 352);
        a23 = (a + 353);
        a33 = (a + 864);
        a43 = (a + 865);
        t15 = (*(a13) + *(a33));
        t25 = (*(a23) + *(a43));
        t35 = (*(a13) - *(a33));
        t45 = (*(a23) - *(a43));
        t55 = (t74 + t15);
        t65 = (t84 + t25);
        t75 = (t74 - t15);
        t85 = (t84 - t25);
        s31 = ((0.38268343236508978f*t75) + (0.92387953251128674f*t85));
        s41 = ((0.38268343236508978f*t85) - (0.92387953251128674f*t75));
        t95 = (t94 + t45);
        t06 = (t05 - t35);
        t16 = (t94 - t45);
        t26 = (t05 + t35);
        s51 = ((0.83146961230254524f*t95) + (0.55557023301960218f*t06));
        s61 = ((0.83146961230254524f*t06) - (0.55557023301960218f*t95));
        s71 = ((0.98078528040323043f*t26) - (0.19509032201612828f*t16));
        s81 = ((0.98078528040323043f*t16) + (0.19509032201612828f*t26));
        a53 = (a + 128);
        a63 = (a + 129);
        a73 = (a + 640);
        a83 = (a + 641);
        t36 = (*(a53) + *(a73));
        t46 = (*(a63) + *(a83));
        t56 = (*(a53) - *(a73));
        t66 = (*(a63) - *(a83));
        a93 = (a + 384);
        a04 = (a + 385);
        a14 = (a + 896);
        a24 = (a + 897);
        t76 = (*(a93) + *(a14));
        t86 = (*(a04) + *(a24));
        t96 = (*(a93) - *(a14));
        t07 = (*(a04) - *(a24));
        t17 = (t36 + t76);
        t27 = (t46 + t86);
        t37 = (t36 - t76);
        t47 = (t46 - t86);
        a34 = (0.70710678118654757f*(t56 + t07));
        a44 = (0.70710678118654757f*(t66 - t96));
        s91 = (a34 + a44);
        s02 = (a44 - a34);
        a54 = (0.70710678118654757f*(t66 + t96));
        a64 = (0.70710678118654757f*(t56 - t07));
        s12 = (a54 - a64);
        s22 = (a64 + a54);
        a74 = (a + 160);
        a84 = (a + 161);
        a94 = (a + 672);
        a05 = (a + 673);
        t57 = (*(a74) + *(a94));
        t67 = (*(a84) + *(a05));
        t77 = (*(a74) - *(a94));
        t87 = (*(a84) - *(a05));
        a15 = (a + 416);
        a25 = (a + 417);
        a35 = (a + 928);
        a45 = (a + 929);
        t97 = (*(a15) + *(a35));
        t08 = (*(a25) + *(a45));
        t18 = (*(a15) - *(a35));
        t28 = (*(a25) - *(a45));
        t38 = (t57 + t97);
        t48 = (t67 + t08);
        t58 = (t57 - t97);
        t68 = (t67 - t08);
        s32 = ((0.92387953251128674f*t68) - (0.38268343236508978f*t58));
        s42 = ((0.92387953251128674f*t58) + (0.38268343236508978f*t68));
        t78 = (t77 + t28);
        t88 = (t87 - t18);
        t98 = (t77 - t28);
        t09 = (t87 + t18);
        s52 = ((0.55557023301960218f*t78) + (0.83146961230254524f*t88));
        s62 = ((0.55557023301960218f*t88) - (0.83146961230254524f*t78));
        s72 = ((0.19509032201612828f*t09) - (0.98078528040323043f*t98));
        s82 = ((0.19509032201612828f*t98) + (0.98078528040323043f*t09));
        a55 = (a + 192);
        a65 = (a + 193);
        a75 = (a + 704);
        a85 = (a + 705);
        t19 = (*(a55) + *(a75));
        t29 = (*(a65) + *(a85));
        t39 = (*(a55) - *(a75));
        t49 = (*(a65) - *(a85));
        a95 = (a + 448);
        a06 = (a + 449);
        a16 = (a + 960);
        a26 = (a + 961);
        t59 = (*(a95) + *(a16));
        t69 = (*(a06) + *(a26));
        t79 = (*(a95) - *(a16));
        t89 = (*(a06) - *(a26));
        t99 = (t19 + t59);
        t0a = (t29 + t69);
        a36 = (0.70710678118654757f*(t29 - t69));
        a46 = (0.70710678118654757f*(t19 - t59));
        s92 = (a36 - a46);
        s03 = (a46 + a36);
        t1a = (t39 + t89);
        t2a = (t49 - t79);
        t3a = (t39 - t89);
        t4a = (t49 + t79);
        s13 = ((0.38268343236508978f*t1a) + (0.92387953251128674f*t2a));
        s23 = ((0.38268343236508978f*t2a) - (0.92387953251128674f*t1a));
        s33 = ((0.92387953251128674f*t3a) + (0.38268343236508978f*t4a));
        s43 = ((0.38268343236508978f*t3a) - (0.92387953251128674f*t4a));
        a56 = (a + 224);
        a66 = (a + 225);
        a76 = (a + 736);
        a86 = (a + 737);
        t5a = (*(a56) + *(a76));
        t6a = (*(a66) + *(a86));
        t7a = (*(a56) - *(a76));
        t8a = (*(a66) - *(a86));
        a96 = (a + 480);
        a07 = (a + 481);
        a17 = (a + 992);
        a27 = (a + 993);
        t9a = (*(a96) + *(a17));
        t0b = (*(a07) + *(a27));
        t1b = (*(a96) - *(a17));
        t2b = (*(a07) - *(a27));
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        s53 = ((0.38268343236508978f*t6b) - (0.92387953251128674f*t5b));
        s63 = ((0.38268343236508978f*t5b) + (0.92387953251128674f*t6b));
        t7b = (t7a + t2b);
        t8b = (t8a - t1b);
        t9b = (t7a - t2b);
        t0c = (t8a + t1b);
        s73 = ((0.19509032201612828f*t7b) + (0.98078528040323043f*t8b));
        s83 = ((0.19509032201612828f*t8b) - (0.98078528040323043f*t7b));
        s93 = ((0.55557023301960218f*t9b) + (0.83146961230254524f*t0c));
        s04 = ((0.83146961230254524f*t9b) - (0.55557023301960218f*t0c));
        t1c = (t9 + t17);
        t2c = (t01 + t27);
        t3c = (t9 - t17);
        t4c = (t01 - t27);
        t5c = (t52 + t38);
        t6c = (t62 + t48);
        a37 = (0.70710678118654757f*(t52 - t38));
        a47 = (0.70710678118654757f*(t62 - t48));
        s14 = (a37 + a47);
        s24 = (a47 - a37);
        t7c = (t14 + t99);
        t8c = (t24 + t0a);
        t9c = (t14 - t99);
        t0d = (t24 - t0a);
        t1d = (t55 + t3b);
        t2d = (t65 + t4b);
        a57 = (0.70710678118654757f*(t65 - t4b));
        a67 = (0.70710678118654757f*(t55 - t3b));
        s34 = (a57 - a67);
        s44 = (a67 + a57);
        t3d = (t1c + t7c);
        t4d = (t2c + t8c);
        t5d = (t1c - t7c);
        t6d = (t2c - t8c);
        t7d = (t5c + t1d);
        t8d = (t6c + t2d);
        t9d = (t5c - t1d);
        t0e = (t6c - t2d);
        t1e = (t3d + t7d);
        t2e = (t4d + t8d);
        t3e = (t3d - t7d);
        t4e = (t4d - t8d);
        a77 = (64*i);
        a87 = (D278 + a77);
        a97 = (a87 + 1);
        a08 = (a87 + 2);
        a18 = (a87 + 3);
        a28 = (T + a77);
        *(a28) = ((*(a87)*t1e) - (*(a97)*t2e));
        *((a28 + 1)) = ((*(a97)*t1e) + (*(a87)*t2e));
        *((a28 + 32)) = ((*(a08)*t3e) - (*(a18)*t4e));
        *((a28 + 33)) = ((*(a18)*t3e) + (*(a08)*t4e));
        t5e = (t5d + t0e);
        t6e = (t6d - t9d);
        t7e = (t5d - t0e);
        t8e = (t6d + t9d);
        a38 = (a87 + 4);
        a48 = (a87 + 5);
        a58 = (a87 + 6);
        a68 = (a87 + 7);
        *((a28 + 16)) = ((*(a38)*t5e) - (*(a48)*t6e));
        *((a28 + 17)) = ((*(a48)*t5e) + (*(a38)*t6e));
        *((a28 + 48)) = ((*(a58)*t7e) - (*(a68)*t8e));
        *((a28 + 49)) = ((*(a68)*t7e) + (*(a58)*t8e));
        t9e = (t3c + t0d);
        t0f = (t4c - t9c);
        t1f = (t3c - t0d);
        t2f = (t4c + t9c);
        t3f = (s14 + s34);
        t4f = (s24 - s44);
        t5f = (s14 - s34);
        t6f = (s24 + s44);
        t7f = (t9e + t3f);
        t8f = (t0f + t4f);
        t9f = (t9e - t3f);
        t0g = (t0f - t4f);
        a78 = (a87 + 8);
        a88 = (a87 + 9);
        a98 = (a87 + 10);
        a09 = (a87 + 11);
        *((a28 + 8)) = ((*(a78)*t7f) - (*(a88)*t8f));
        *((a28 + 9)) = ((*(a88)*t7f) + (*(a78)*t8f));
        *((a28 + 40)) = ((*(a98)*t9f) - (*(a09)*t0g));
        *((a28 + 41)) = ((*(a09)*t9f) + (*(a98)*t0g));
        t1g = (t1f + t6f);
        t2g = (t2f - t5f);
        t3g = (t1f - t6f);
        t4g = (t2f + t5f);
        a19 = (a87 + 12);
        a29 = (a87 + 13);
        a39 = (a87 + 14);
        a49 = (a87 + 15);
        *((a28 + 24)) = ((*(a19)*t1g) - (*(a29)*t2g));
        *((a28 + 25)) = ((*(a29)*t1g) + (*(a19)*t2g));
        *((a28 + 56)) = ((*(a39)*t3g) - (*(a49)*t4g));
        *((a28 + 57)) = ((*(a49)*t3g) + (*(a39)*t4g));
        t5g = (t31 + s91);
        t6g = (t41 + s02);
        t7g = (t31 - s91);
        t8g = (t41 - s02);
        t9g = (s3 + s52);
        t0h = (s4 + s62);
        a59 = (0.70710678118654757f*(s3 - s52));
        a69 = (0.70710678118654757f*(s4 - s62));
        s54 = (a59 + a69);
        s64 = (a69 - a59);
        t1h = (s9 + s13);
        t2h = (s01 + s23);
        t3h = (s9 - s13);
        t4h = (s01 - s23);
        t5h = (s51 + s73);
        t6h = (s61 + s83);
        a79 = (0.70710678118654757f*(s61 - s83));
        a89 = (0.70710678118654757f*(s51 - s73));
        s74 = (a79 - a89);
        s84 = (a89 + a79);
        t7h = (t5g + t1h);
        t8h = (t6g + t2h);
        t9h = (t5g - t1h);
        t0i = (t6g - t2h);
        t1i = (t9g + t5h);
        t2i = (t0h + t6h);
        t3i = (t9g - t5h);
        t4i = (t0h - t6h);
        t5i = (t7h + t1i);
        t6i = (t8h + t2i);
        t7i = (t7h - t1i);
        t8i = (t8h - t2i);
        a99 = (a87 + 16);
        a0a = (a87 + 17);
        a1a = (a87 + 18);
        a2a = (a87 + 19);
        *((a28 + 2)) = ((*(a99)*t5i) - (*(a0a)*t6i));
        *((a28 + 3)) = ((*(a0a)*t5i) + (*(a99)*t6i));
        *((a28 + 34)) = ((*(a1a)*t7i) - (*(a2a)*t8i));
        *((a28 + 35)) = ((*(a2a)*t7i) + (*(a1a)*t8i));
        t9i = (t9h + t4i);
        t0j = (t0i - t3i);
        t1j = (t9h - t4i);
        t2j = (t0i + t3i);
        a3a = (a87 + 20);
        a4a = (a87 + 21);
        a5a = (a87 + 22);
        a6a = (a87 + 23);
        *((a28 + 18)) = ((*(a3a)*t9i) - (*(a4a)*t0j));
        *((a28 + 19)) = ((*(a4a)*t9i) + (*(a3a)*t0j));
        *((a28 + 50)) = ((*(a5a)*t1j) - (*(a6a)*t2j));
        *((a28 + 51)) = ((*(a6a)*t1j) + (*(a5a)*t2j));
        t3j = (t7g + t4h);
        t4j = (t8g - t3h);
        t5j = (t7g - t4h);
        t6j = (t8g + t3h);
        t7j = (s54 + s74);
        t8j = (s64 - s84);
        t9j = (s54 - s74);
        t0k = (s64 + s84);
        t1k = (t3j + t7j);
        t2k = (t4j + t8j);
        t3k = (t3j - t7j);
        t4k = (t4j - t8j);
        a7a = (a87 + 24);
        a8a = (a87 + 25);
        a9a = (a87 + 26);
        a0b = (a87 + 27);
        *((a28 + 10)) = ((*(a7a)*t1k) - (*(a8a)*t2k));
        *((a28 + 11)) = ((*(a8a)*t1k) + (*(a7a)*t2k));
        *((a28 + 42)) = ((*(a9a)*t3k) - (*(a0b)*t4k));
        *((a28 + 43)) = ((*(a0b)*t3k) + (*(a9a)*t4k));
        t5k = (t5j + t0k);
        t6k = (t6j - t9j);
        t7k = (t5j - t0k);
        t8k = (t6j + t9j);
        a1b = (a87 + 28);
        a2b = (a87 + 29);
        a3b = (a87 + 30);
        a4b = (a87 + 31);
        *((a28 + 26)) = ((*(a1b)*t5k) - (*(a2b)*t6k));
        *((a28 + 27)) = ((*(a2b)*t5k) + (*(a1b)*t6k));
        *((a28 + 58)) = ((*(a3b)*t7k) - (*(a4b)*t8k));
        *((a28 + 59)) = ((*(a4b)*t7k) + (*(a3b)*t8k));
        t9k = (t11 + t47);
        t0l = (t21 - t37);
        t1l = (t11 - t47);
        t2l = (t21 + t37);
        t3l = (s + s32);
        t4l = (s2 - s42);
        a5b = (0.70710678118654757f*(s - s32));
        a6b = (0.70710678118654757f*(s2 + s42));
        s94 = (a5b + a6b);
        s05 = (a6b - a5b);
        t5l = (s7 + s92);
        t6l = (s8 - s03);
        t7l = (s7 - s92);
        t8l = (s8 + s03);
        t9l = (s31 + s53);
        t0m = (s41 - s63);
        a7b = (0.70710678118654757f*(s41 + s63));
        a8b = (0.70710678118654757f*(s31 - s53));
        s15 = (a7b - a8b);
        s25 = (a8b + a7b);
        t1m = (t9k + t5l);
        t2m = (t0l + t6l);
        t3m = (t9k - t5l);
        t4m = (t0l - t6l);
        t5m = (t3l + t9l);
        t6m = (t4l + t0m);
        t7m = (t3l - t9l);
        t8m = (t4l - t0m);
        t9m = (t1m + t5m);
        t0n = (t2m + t6m);
        t1n = (t1m - t5m);
        t2n = (t2m - t6m);
        a9b = (a87 + 32);
        a0c = (a87 + 33);
        a1c = (a87 + 34);
        a2c = (a87 + 35);
        *((a28 + 4)) = ((*(a9b)*t9m) - (*(a0c)*t0n));
        *((a28 + 5)) = ((*(a0c)*t9m) + (*(a9b)*t0n));
        *((a28 + 36)) = ((*(a1c)*t1n) - (*(a2c)*t2n));
        *((a28 + 37)) = ((*(a2c)*t1n) + (*(a1c)*t2n));
        t3n = (t3m + t8m);
        t4n = (t4m - t7m);
        t5n = (t3m - t8m);
        t6n = (t4m + t7m);
        a3c = (a87 + 36);
        a4c = (a87 + 37);
        a5c = (a87 + 38);
        a6c = (a87 + 39);
        *((a28 + 20)) = ((*(a3c)*t3n) - (*(a4c)*t4n));
        *((a28 + 21)) = ((*(a4c)*t3n) + (*(a3c)*t4n));
        *((a28 + 52)) = ((*(a5c)*t5n) - (*(a6c)*t6n));
        *((a28 + 53)) = ((*(a6c)*t5n) + (*(a5c)*t6n));
        t7n = (t1l + t8l);
        t8n = (t2l - t7l);
        t9n = (t1l - t8l);
        t0o = (t2l + t7l);
        t1o = (s94 + s15);
        t2o = (s05 - s25);
        t3o = (s94 - s15);
        t4o = (s05 + s25);
        t5o = (t7n + t1o);
        t6o = (t8n + t2o);
        t7o = (t7n - t1o);
        t8o = (t8n - t2o);
        a7c = (a87 + 40);
        a8c = (a87 + 41);
        a9c = (a87 + 42);
        a0d = (a87 + 43);
        *((a28 + 12)) = ((*(a7c)*t5o) - (*(a8c)*t6o));
        *((a28 + 13)) = ((*(a8c)*t5o) + (*(a7c)*t6o));
        *((a28 + 44)) = ((*(a9c)*t7o) - (*(a0d)*t8o));
        *((a28 + 45)) = ((*(a0d)*t7o) + (*(a9c)*t8o));
        t9o = (t9n + t4o);
        t0p = (t0o - t3o);
        t1p = (t9n - t4o);
        t2p = (t0o + t3o);
        a1d = (a87 + 44);
        a2d = (a87 + 45);
        a3d = (a87 + 46);
        a4d = (a87 + 47);
        *((a28 + 28)) = ((*(a1d)*t9o) - (*(a2d)*t0p));
        *((a28 + 29)) = ((*(a2d)*t9o) + (*(a1d)*t0p));
        *((a28 + 60)) = ((*(a3d)*t1p) - (*(a4d)*t2p));
        *((a28 + 61)) = ((*(a4d)*t1p) + (*(a3d)*t2p));
        t3p = (t51 + s12);
        t4p = (t61 - s22);
        t5p = (t51 - s12);
        t6p = (t61 + s22);
        t7p = (s5 + s72);
        t8p = (s6 - s82);
        a5d = (0.70710678118654757f*(s5 - s72));
        a6d = (0.70710678118654757f*(s6 + s82));
        s35 = (a5d + a6d);
        s45 = (a6d - a5d);
        t9p = (s11 - s33);
        t0q = (s21 + s43);
        t1q = (s11 + s33);
        t2q = (s21 - s43);
        t3q = (s71 - s93);
        t4q = (s04 - s81);
        a7d = (0.70710678118654757f*(s71 + s93));
        a8d = (0.70710678118654757f*(s81 + s04));
        s55 = (a7d + a8d);
        s65 = (a8d - a7d);
        t5q = (t3p + t9p);
        t6q = (t4p + t0q);
        t7q = (t3p - t9p);
        t8q = (t4p - t0q);
        t9q = (t7p + t3q);
        t0r = (t8p + t4q);
        t1r = (t7p - t3q);
        t2r = (t8p - t4q);
        t3r = (t5q + t9q);
        t4r = (t6q + t0r);
        t5r = (t5q - t9q);
        t6r = (t6q - t0r);
        a9d = (a87 + 48);
        a0e = (a87 + 49);
        a1e = (a87 + 50);
        a2e = (a87 + 51);
        *((a28 + 6)) = ((*(a9d)*t3r) - (*(a0e)*t4r));
        *((a28 + 7)) = ((*(a0e)*t3r) + (*(a9d)*t4r));
        *((a28 + 38)) = ((*(a1e)*t5r) - (*(a2e)*t6r));
        *((a28 + 39)) = ((*(a2e)*t5r) + (*(a1e)*t6r));
        t7r = (t7q + t2r);
        t8r = (t8q - t1r);
        t9r = (t7q - t2r);
        t0s = (t8q + t1r);
        a3e = (a87 + 52);
        a4e = (a87 + 53);
        a5e = (a87 + 54);
        a6e = (a87 + 55);
        *((a28 + 22)) = ((*(a3e)*t7r) - (*(a4e)*t8r));
        *((a28 + 23)) = ((*(a4e)*t7r) + (*(a3e)*t8r));
        *((a28 + 54)) = ((*(a5e)*t9r) - (*(a6e)*t0s));
        *((a28 + 55)) = ((*(a6e)*t9r) + (*(a5e)*t0s));
        t1s = (t5p + t2q);
        t2s = (t6p - t1q);
        t3s = (t5p - t2q);
        t4s = (t6p + t1q);
        t5s = (s35 - s55);
        t6s = (s45 + s65);
        t7s = (s35 + s55);
        t8s = (s45 - s65);
        t9s = (t1s + t5s);
        t0t = (t2s + t6s);
        t1t = (t1s - t5s);
        t2t = (t2s - t6s);
        a7e = (a87 + 56);
        a8e = (a87 + 57);
        a9e = (a87 + 58);
        a0f = (a87 + 59);
        *((a28 + 14)) = ((*(a7e)*t9s) - (*(a8e)*t0t));
        *((a28 + 15)) = ((*(a8e)*t9s) + (*(a7e)*t0t));
        *((a28 + 46)) = ((*(a9e)*t1t) - (*(a0f)*t2t));
        *((a28 + 47)) = ((*(a0f)*t1t) + (*(a9e)*t2t));
        t3t = (t3s + t8s);
        t4t = (t4s - t7s);
        t5t = (t3s - t8s);
        t6t = (t4s + t7s);
        a1f = (a87 + 60);
        a2f = (a87 + 61);
        a3f = (a87 + 62);
        a4f = (a87 + 63);
        *((a28 + 30)) = ((*(a1f)*t3t) - (*(a2f)*t4t));
        *((a28 + 31)) = ((*(a2f)*t3t) + (*(a1f)*t4t));
        *((a28 + 62)) = ((*(a3f)*t5t) - (*(a4f)*t6t));
        *((a28 + 63)) = ((*(a4f)*t5t) + (*(a3f)*t6t));
    }}
    {long i2; for(i2 = 0; i2 <= 31; i2++) {
        a5f = (2*i2);
        a6f = (T + a5f);
        a7f = (a6f + 1);
        a8f = (a6f + 512);
        a9f = (a6f + 513);
        t7t = (*(a6f) + *(a8f));
        t8t = (*(a7f) + *(a9f));
        t9t = (*(a6f) - *(a8f));
        t0u = (*(a7f) - *(a9f));
        a0g = (a6f + 256);
        a1g = (a6f + 257);
        a2g = (a6f + 768);
        a3g = (a6f + 769);
        t1u = (*(a0g) + *(a2g));
        t2u = (*(a1g) + *(a3g));
        t3u = (*(a0g) - *(a2g));
        t4u = (*(a1g) - *(a3g));
        t5u = (t7t + t1u);
        t6u = (t8t + t2u);
        t7u = (t7t - t1u);
        t8u = (t8t - t2u);
        t9u = (t9t + t4u);
        t0v = (t0u - t3u);
        t1v = (t9t - t4u);
        t2v = (t0u + t3u);
        a4g = (a6f + 64);
        a5g = (a6f + 65);
        a6g = (a6f + 576);
        a7g = (a6f + 577);
        t3v = (*(a4g) + *(a6g));
        t4v = (*(a5g) + *(a7g));
        t5v = (*(a4g) - *(a6g));
        t6v = (*(a5g) - *(a7g));
        a8g = (a6f + 320);
        a9g = (a6f + 321);
        a0h = (a6f + 832);
        a1h = (a6f + 833);
        t7v = (*(a8g) + *(a0h));
        t8v = (*(a9g) + *(a1h));
        t9v = (*(a8g) - *(a0h));
        t0w = (*(a9g) - *(a1h));
        t1w = (t3v + t7v);
        t2w = (t4v + t8v);
        a2h = (0.70710678118654757f*(t3v - t7v));
        a3h = (0.70710678118654757f*(t4v - t8v));
        s75 = (a2h + a3h);
        s85 = (a3h - a2h);
        t3w = (t5v + t0w);
        t4w = (t6v - t9v);
        t5w = (t5v - t0w);
        t6w = (t6v + t9v);
        s95 = ((0.92387953251128674f*t3w) + (0.38268343236508978f*t4w));
        s06 = ((0.92387953251128674f*t4w) - (0.38268343236508978f*t3w));
        s16 = ((0.38268343236508978f*t5w) + (0.92387953251128674f*t6w));
        s26 = ((0.38268343236508978f*t6w) - (0.92387953251128674f*t5w));
        a4h = (a6f + 128);
        a5h = (a6f + 129);
        a6h = (a6f + 640);
        a7h = (a6f + 641);
        t7w = (*(a4h) + *(a6h));
        t8w = (*(a5h) + *(a7h));
        t9w = (*(a4h) - *(a6h));
        t0x = (*(a5h) - *(a7h));
        a8h = (a6f + 384);
        a9h = (a6f + 385);
        a0i = (a6f + 896);
        a1i = (a6f + 897);
        t1x = (*(a8h) + *(a0i));
        t2x = (*(a9h) + *(a1i));
        t3x = (*(a8h) - *(a0i));
        t4x = (*(a9h) - *(a1i));
        t5x = (t7w + t1x);
        t6x = (t8w + t2x);
        t7x = (t7w - t1x);
        t8x = (t8w - t2x);
        a2i = (0.70710678118654757f*(t9w + t4x));
        a3i = (0.70710678118654757f*(t0x - t3x));
        s36 = (a2i + a3i);
        s46 = (a3i - a2i);
        a4i = (0.70710678118654757f*(t0x + t3x));
        a5i = (0.70710678118654757f*(t9w - t4x));
        s56 = (a4i - a5i);
        s66 = (a5i + a4i);
        a6i = (a6f + 192);
        a7i = (a6f + 193);
        a8i = (a6f + 704);
        a9i = (a6f + 705);
        t9x = (*(a6i) + *(a8i));
        t0y = (*(a7i) + *(a9i));
        t1y = (*(a6i) - *(a8i));
        t2y = (*(a7i) - *(a9i));
        a0j = (a6f + 448);
        a1j = (a6f + 449);
        a2j = (a6f + 960);
        a3j = (a6f + 961);
        t3y = (*(a0j) + *(a2j));
        t4y = (*(a1j) + *(a3j));
        t5y = (*(a0j) - *(a2j));
        t6y = (*(a1j) - *(a3j));
        t7y = (t9x + t3y);
        t8y = (t0y + t4y);
        a4j = (0.70710678118654757f*(t0y - t4y));
        a5j = (0.70710678118654757f*(t9x - t3y));
        s76 = (a4j - a5j);
        s86 = (a5j + a4j);
        t9y = (t1y + t6y);
        t0z = (t2y - t5y);
        t1z = (t1y - t6y);
        t2z = (t2y + t5y);
        s96 = ((0.38268343236508978f*t9y) + (0.92387953251128674f*t0z));
        s07 = ((0.38268343236508978f*t0z) - (0.92387953251128674f*t9y));
        s17 = ((0.92387953251128674f*t1z) + (0.38268343236508978f*t2z));
        s27 = ((0.38268343236508978f*t1z) - (0.92387953251128674f*t2z));
        t3z = (t5u + t5x);
        t4z = (t6u + t6x);
        t5z = (t5u - t5x);
        t6z = (t6u - t6x);
        t7z = (t1w + t7y);
        t8z = (t2w + t8y);
        t9z = (t1w - t7y);
        t0A = (t2w - t8y);
        a6j = (dst + a5f);
        *(a6j) = (t3z + t7z);
        *((a6j + 1)) = (t4z + t8z);
        *((a6j + 512)) = (t3z - t7z);
        *((a6j + 513)) = (t4z - t8z);
        *((a6j + 256)) = (t5z + t0A);
        *((a6j + 257)) = (t6z - t9z);
        *((a6j + 768)) = (t5z - t0A);
        *((a6j + 769)) = (t6z + t9z);
        t1A = (t9u + s36);
        t2A = (t0v + s46);
        t3A = (t9u - s36);
        t4A = (t0v - s46);
        t5A = (s95 + s96);
        t6A = (s06 + s07);
        t7A = (s95 - s96);
        t8A = (s06 - s07);
        *((a6j + 64)) = (t1A + t5A);
        *((a6j + 65)) = (t2A + t6A);
        *((a6j + 576)) = (t1A - t5A);
        *((a6j + 577)) = (t2A - t6A);
        *((a6j + 320)) = (t3A + t8A);
        *((a6j + 321)) = (t4A - t7A);
        *((a6j + 832)) = (t3A - t8A);
        *((a6j + 833)) = (t4A + t7A);
        t9A = (t7u + t8x);
        t0B = (t8u - t7x);
        t1B = (t7u - t8x);
        t2B = (t8u + t7x);
        t3B = (s75 + s76);
        t4B = (s85 - s86);
        t5B = (s75 - s76);
        t6B = (s85 + s86);
        *((a6j + 128)) = (t9A + t3B);
        *((a6j + 129)) = (t0B + t4B);
        *((a6j + 640)) = (t9A - t3B);
        *((a6j + 641)) = (t0B - t4B);
        *((a6j + 384)) = (t1B + t6B);
        *((a6j + 385)) = (t2B - t5B);
        *((a6j + 896)) = (t1B - t6B);
        *((a6j + 897)) = (t2B + t5B);
        t7B = (t1v + s56);
        t8B = (t2v - s66);
        t9B = (t1v - s56);
        t0C = (t2v + s66);
        t1C = (s16 - s17);
        t2C = (s26 + s27);
        t3C = (s16 + s17);
        t4C = (s26 - s27);
        *((a6j + 192)) = (t7B + t1C);
        *((a6j + 193)) = (t8B + t2C);
        *((a6j + 704)) = (t7B - t1C);
        *((a6j + 705)) = (t8B - t2C);
        *((a6j + 448)) = (t9B + t4C);
        *((a6j + 449)) = (t0C - t3C);
        *((a6j + 960)) = (t9B - t4C);
        *((a6j + 961)) = (t0C + t3C);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_float_1024)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[2048];
    float  *a08, *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0g, *a0h, *a0j, *a0l, *a0m, *a18, *a19, *a1a, *a1b, *a1c, *a1d, *a1e, *a1f, *a1g
            , *a1h, *a1j, *a1l, *a1m, *a28, *a29, *a2a, *a2b, *a2c, *a2d, *a2e, *a2f, *a2g, *a2h, *a2i, *a2j, *a2k, *a2l, *a2m, *a2n, *a38, *a39
            , *a3a, *a3b, *a3c, *a3d, *a3e, *a3f, *a3g, *a3h, *a3i, *a3j, *a3k, *a3l, *a3m, *a48, *a49, *a4a, *a4b, *a4c, *a4d, *a4e, *a4f, *a4g
            , *a4h, *a4i, *a4j, *a4k, *a4l, *a4m, *a58, *a5a, *a5c, *a5e, *a5g, *a5h, *a5i, *a5j, *a5k, *a5l, *a5m, *a68, *a6a, *a6c, *a6e, *a6f
            , *a6g, *a6h, *a6i, *a6j, *a6k, *a6l, *a6m, *a78, *a7a, *a7c, *a7e, *a7f, *a7g, *a7h, *a7i, *a7j, *a7k, *a7l, *a7m, *a87, *a88, *a8a
            , *a8c, *a8e, *a8f, *a8g, *a8h, *a8i, *a8k, *a97, *a98, *a99, *a9a, *a9b, *a9c, *a9d, *a9e, *a9f, *a9g, *a9h, *a9i, *a9k;
    const float  *a, *a01, *a02, *a03, *a04, *a05, *a06, *a07, *a11, *a12, *a13, *a14, *a15, *a16, *a17, *a2, *a21, *a22, *a23, *a24, *a25, *a26
            , *a27, *a3, *a31, *a32, *a33, *a35, *a4, *a41, *a42, *a43, *a45, *a5, *a51, *a53, *a55, *a56, *a6, *a61, *a63, *a65, *a66, *a7
            , *a71, *a72, *a73, *a74, *a75, *a76, *a8, *a81, *a82, *a83, *a84, *a85, *a86, *a9, *a91, *a92, *a93, *a94, *a95, *a96;
    int a5f, a77;
    float a0i, a0k, a0n, a0o, a1i, a1k, a1n, a1o, a2o, a34, a36, a37, a3n, a3o, a44, a46, a47, a4n, a4o, a52, a54, a57
            , a59, a5b, a5d, a5n, a62, a64, a67, a69, a6b, a6d, a6n, a79, a7b, a7d, a7n, a89, a8b, a8d, a8j, a8l, a8m, a8n
            , a9j, a9l, a9m, a9n, s, s01, s02, s03, s04, s05, s06, s07, s08, s09, s0a, s0b, s11, s12, s13, s14, s15, s16
            , s17, s18, s19, s1a, s1b, s2, s21, s22, s23, s24, s25, s26, s27, s28, s29, s2a, s2b, s3, s31, s32, s33, s34
            , s35, s36, s37, s38, s39, s3a, s4, s41, s42, s43, s44, s45, s46, s47, s48, s49, s4a, s5, s51, s52, s53, s54
            , s55, s56, s57, s58, s59, s5a, s6, s61, s62, s63, s64, s65, s66, s67, s68, s69, s6a, s7, s71, s72, s73, s74
            , s75, s76, s77, s78, s79, s7a, s8, s81, s82, s83, s84, s85, s86, s87, s88, s89, s8a, s9, s91, s92, s93, s94
            , s95, s96, s97, s98, s99, s9a, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0A, t0B, t0C, t0D, t0E, t0F
            , t0G, t0H, t0I, t0J, t0K, t0L, t0M, t0N, t0O, t0P, t0Q, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k
            , t0l, t0m, t0n, t0o, t0p, t0q, t0r, t0s, t0t, t0u, t0v, t0w, t0x, t0y, t0z, t11, t12, t13, t14, t15, t16, t17
            , t18, t19, t1A, t1B, t1C, t1D, t1E, t1F, t1G, t1H, t1I, t1J, t1K, t1L, t1M, t1N, t1O, t1P, t1Q, t1a, t1b, t1c
            , t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t, t1u, t1v, t1w, t1x, t1y
            , t1z, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2A, t2B, t2C, t2D, t2E, t2F, t2G, t2H, t2I, t2J, t2K
            , t2L, t2M, t2N, t2O, t2P, t2Q, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p
            , t2q, t2r, t2s, t2t, t2u, t2v, t2w, t2x, t2y, t2z, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3A, t3B
            , t3C, t3D, t3E, t3F, t3G, t3H, t3I, t3J, t3K, t3L, t3M, t3N, t3O, t3P, t3Q, t3a, t3b, t3c, t3d, t3e, t3f, t3g
            , t3h, t3i, t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s, t3t, t3u, t3v, t3w, t3x, t3y, t3z, t4, t41, t42
            , t43, t44, t45, t46, t47, t48, t49, t4A, t4B, t4C, t4D, t4E, t4F, t4G, t4H, t4I, t4J, t4K, t4L, t4M, t4N, t4O
            , t4P, t4Q, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t4o, t4p, t4q, t4r, t4s, t4t
            , t4u, t4v, t4w, t4x, t4y, t4z, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5A, t5B, t5C, t5D, t5E, t5F
            , t5G, t5H, t5I, t5J, t5K, t5L, t5M, t5N, t5O, t5P, t5Q, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k
            , t5l, t5m, t5n, t5o, t5p, t5q, t5r, t5s, t5t, t5u, t5v, t5w, t5x, t5y, t5z, t6, t61, t62, t63, t64, t65, t66
            , t67, t68, t69, t6A, t6B, t6C, t6D, t6E, t6F, t6G, t6H, t6I, t6J, t6K, t6L, t6M, t6N, t6O, t6P, t6Q, t6a, t6b
            , t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r, t6s, t6t, t6u, t6v, t6w, t6x
            , t6y, t6z, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7A, t7B, t7C, t7D, t7E, t7F, t7G, t7H, t7I, t7J
            , t7K, t7L, t7M, t7N, t7O, t7P, t7Q, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m, t7n, t7o
            , t7p, t7q, t7r, t7s, t7t, t7u, t7v, t7w, t7x, t7y, t7z, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8A
            , t8B, t8C, t8D, t8E, t8F, t8G, t8H, t8I, t8J, t8K, t8L, t8M, t8N, t8O, t8P, t8Q, t8a, t8b, t8c, t8d, t8e, t8f
            , t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p, t8q, t8r, t8s, t8t, t8u, t8v, t8w, t8x, t8y, t8z, t9, t91
            , t92, t93, t94, t95, t96, t97, t98, t99, t9A, t9B, t9C, t9D, t9E, t9F, t9G, t9H, t9I, t9J, t9K, t9L, t9M, t9N
            , t9O, t9P, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p, t9q, t9r, t9s, t9t
            , t9u, t9v, t9w, t9x, t9y, t9z;
    {long i; for(i = 0; i <= 31; i++) {
        a = (src + (2*i));
        a2 = (a + 1);
        a3 = (a + 1024);
        a4 = (a + 1025);
        t = (*(a) + *(a3));
        t2 = (*(a2) + *(a4));
        t3 = (*(a) - *(a3));
        t4 = (*(a2) - *(a4));
        a5 = (a + 512);
        a6 = (a + 513);
        a7 = (a + 1536);
        a8 = (a + 1537);
        t5 = (*(a5) + *(a7));
        t6 = (*(a6) + *(a8));
        t7 = (*(a5) - *(a7));
        t8 = (*(a6) - *(a8));
        t9 = (t + t5);
        t01 = (t2 + t6);
        t11 = (t - t5);
        t21 = (t2 - t6);
        t31 = (t3 + t8);
        t41 = (t4 - t7);
        t51 = (t3 - t8);
        t61 = (t4 + t7);
        a9 = (a + 64);
        a01 = (a + 65);
        a11 = (a + 1088);
        a21 = (a + 1089);
        t71 = (*(a9) + *(a11));
        t81 = (*(a01) + *(a21));
        t91 = (*(a9) - *(a11));
        t02 = (*(a01) - *(a21));
        a31 = (a + 576);
        a41 = (a + 577);
        a51 = (a + 1600);
        a61 = (a + 1601);
        t12 = (*(a31) + *(a51));
        t22 = (*(a41) + *(a61));
        t32 = (*(a31) - *(a51));
        t42 = (*(a41) - *(a61));
        t52 = (t71 + t12);
        t62 = (t81 + t22);
        t72 = (t71 - t12);
        t82 = (t81 - t22);
        s = ((0.92387953251128674f*t72) + (0.38268343236508978f*t82));
        s2 = ((0.92387953251128674f*t82) - (0.38268343236508978f*t72));
        t92 = (t91 + t42);
        t03 = (t02 - t32);
        t13 = (t91 - t42);
        t23 = (t02 + t32);
        s3 = ((0.98078528040323043f*t92) + (0.19509032201612828f*t03));
        s4 = ((0.98078528040323043f*t03) - (0.19509032201612828f*t92));
        s5 = ((0.83146961230254524f*t13) + (0.55557023301960218f*t23));
        s6 = ((0.83146961230254524f*t23) - (0.55557023301960218f*t13));
        a71 = (a + 128);
        a81 = (a + 129);
        a91 = (a + 1152);
        a02 = (a + 1153);
        t33 = (*(a71) + *(a91));
        t43 = (*(a81) + *(a02));
        t53 = (*(a71) - *(a91));
        t63 = (*(a81) - *(a02));
        a12 = (a + 640);
        a22 = (a + 641);
        a32 = (a + 1664);
        a42 = (a + 1665);
        t73 = (*(a12) + *(a32));
        t83 = (*(a22) + *(a42));
        t93 = (*(a12) - *(a32));
        t04 = (*(a22) - *(a42));
        t14 = (t33 + t73);
        t24 = (t43 + t83);
        a52 = (0.70710678118654757f*(t33 - t73));
        a62 = (0.70710678118654757f*(t43 - t83));
        s7 = (a52 + a62);
        s8 = (a62 - a52);
        t34 = (t53 + t04);
        t44 = (t63 - t93);
        t54 = (t53 - t04);
        t64 = (t63 + t93);
        s9 = ((0.92387953251128674f*t34) + (0.38268343236508978f*t44));
        s01 = ((0.92387953251128674f*t44) - (0.38268343236508978f*t34));
        s11 = ((0.38268343236508978f*t54) + (0.92387953251128674f*t64));
        s21 = ((0.38268343236508978f*t64) - (0.92387953251128674f*t54));
        a72 = (a + 192);
        a82 = (a + 193);
        a92 = (a + 1216);
        a03 = (a + 1217);
        t74 = (*(a72) + *(a92));
        t84 = (*(a82) + *(a03));
        t94 = (*(a72) - *(a92));
        t05 = (*(a82) - *(a03));
        a13 = (a + 704);
        a23 = (a + 705);
        a33 = (a + 1728);
        a43 = (a + 1729);
        t15 = (*(a13) + *(a33));
        t25 = (*(a23) + *(a43));
        t35 = (*(a13) - *(a33));
        t45 = (*(a23) - *(a43));
        t55 = (t74 + t15);
        t65 = (t84 + t25);
        t75 = (t74 - t15);
        t85 = (t84 - t25);
        s31 = ((0.38268343236508978f*t75) + (0.92387953251128674f*t85));
        s41 = ((0.38268343236508978f*t85) - (0.92387953251128674f*t75));
        t95 = (t94 + t45);
        t06 = (t05 - t35);
        t16 = (t94 - t45);
        t26 = (t05 + t35);
        s51 = ((0.83146961230254524f*t95) + (0.55557023301960218f*t06));
        s61 = ((0.83146961230254524f*t06) - (0.55557023301960218f*t95));
        s71 = ((0.98078528040323043f*t26) - (0.19509032201612828f*t16));
        s81 = ((0.98078528040323043f*t16) + (0.19509032201612828f*t26));
        a53 = (a + 256);
        a63 = (a + 257);
        a73 = (a + 1280);
        a83 = (a + 1281);
        t36 = (*(a53) + *(a73));
        t46 = (*(a63) + *(a83));
        t56 = (*(a53) - *(a73));
        t66 = (*(a63) - *(a83));
        a93 = (a + 768);
        a04 = (a + 769);
        a14 = (a + 1792);
        a24 = (a + 1793);
        t76 = (*(a93) + *(a14));
        t86 = (*(a04) + *(a24));
        t96 = (*(a93) - *(a14));
        t07 = (*(a04) - *(a24));
        t17 = (t36 + t76);
        t27 = (t46 + t86);
        t37 = (t36 - t76);
        t47 = (t46 - t86);
        a34 = (0.70710678118654757f*(t56 + t07));
        a44 = (0.70710678118654757f*(t66 - t96));
        s91 = (a34 + a44);
        s02 = (a44 - a34);
        a54 = (0.70710678118654757f*(t66 + t96));
        a64 = (0.70710678118654757f*(t56 - t07));
        s12 = (a54 - a64);
        s22 = (a64 + a54);
        a74 = (a + 320);
        a84 = (a + 321);
        a94 = (a + 1344);
        a05 = (a + 1345);
        t57 = (*(a74) + *(a94));
        t67 = (*(a84) + *(a05));
        t77 = (*(a74) - *(a94));
        t87 = (*(a84) - *(a05));
        a15 = (a + 832);
        a25 = (a + 833);
        a35 = (a + 1856);
        a45 = (a + 1857);
        t97 = (*(a15) + *(a35));
        t08 = (*(a25) + *(a45));
        t18 = (*(a15) - *(a35));
        t28 = (*(a25) - *(a45));
        t38 = (t57 + t97);
        t48 = (t67 + t08);
        t58 = (t57 - t97);
        t68 = (t67 - t08);
        s32 = ((0.92387953251128674f*t68) - (0.38268343236508978f*t58));
        s42 = ((0.92387953251128674f*t58) + (0.38268343236508978f*t68));
        t78 = (t77 + t28);
        t88 = (t87 - t18);
        t98 = (t77 - t28);
        t09 = (t87 + t18);
        s52 = ((0.55557023301960218f*t78) + (0.83146961230254524f*t88));
        s62 = ((0.55557023301960218f*t88) - (0.83146961230254524f*t78));
        s72 = ((0.19509032201612828f*t09) - (0.98078528040323043f*t98));
        s82 = ((0.19509032201612828f*t98) + (0.98078528040323043f*t09));
        a55 = (a + 384);
        a65 = (a + 385);
        a75 = (a + 1408);
        a85 = (a + 1409);
        t19 = (*(a55) + *(a75));
        t29 = (*(a65) + *(a85));
        t39 = (*(a55) - *(a75));
        t49 = (*(a65) - *(a85));
        a95 = (a + 896);
        a06 = (a + 897);
        a16 = (a + 1920);
        a26 = (a + 1921);
        t59 = (*(a95) + *(a16));
        t69 = (*(a06) + *(a26));
        t79 = (*(a95) - *(a16));
        t89 = (*(a06) - *(a26));
        t99 = (t19 + t59);
        t0a = (t29 + t69);
        a36 = (0.70710678118654757f*(t29 - t69));
        a46 = (0.70710678118654757f*(t19 - t59));
        s92 = (a36 - a46);
        s03 = (a46 + a36);
        t1a = (t39 + t89);
        t2a = (t49 - t79);
        t3a = (t39 - t89);
        t4a = (t49 + t79);
        s13 = ((0.38268343236508978f*t1a) + (0.92387953251128674f*t2a));
        s23 = ((0.38268343236508978f*t2a) - (0.92387953251128674f*t1a));
        s33 = ((0.92387953251128674f*t3a) + (0.38268343236508978f*t4a));
        s43 = ((0.38268343236508978f*t3a) - (0.92387953251128674f*t4a));
        a56 = (a + 448);
        a66 = (a + 449);
        a76 = (a + 1472);
        a86 = (a + 1473);
        t5a = (*(a56) + *(a76));
        t6a = (*(a66) + *(a86));
        t7a = (*(a56) - *(a76));
        t8a = (*(a66) - *(a86));
        a96 = (a + 960);
        a07 = (a + 961);
        a17 = (a + 1984);
        a27 = (a + 1985);
        t9a = (*(a96) + *(a17));
        t0b = (*(a07) + *(a27));
        t1b = (*(a96) - *(a17));
        t2b = (*(a07) - *(a27));
        t3b = (t5a + t9a);
        t4b = (t6a + t0b);
        t5b = (t5a - t9a);
        t6b = (t6a - t0b);
        s53 = ((0.38268343236508978f*t6b) - (0.92387953251128674f*t5b));
        s63 = ((0.38268343236508978f*t5b) + (0.92387953251128674f*t6b));
        t7b = (t7a + t2b);
        t8b = (t8a - t1b);
        t9b = (t7a - t2b);
        t0c = (t8a + t1b);
        s73 = ((0.19509032201612828f*t7b) + (0.98078528040323043f*t8b));
        s83 = ((0.19509032201612828f*t8b) - (0.98078528040323043f*t7b));
        s93 = ((0.55557023301960218f*t9b) + (0.83146961230254524f*t0c));
        s04 = ((0.83146961230254524f*t9b) - (0.55557023301960218f*t0c));
        t1c = (t9 + t17);
        t2c = (t01 + t27);
        t3c = (t9 - t17);
        t4c = (t01 - t27);
        t5c = (t52 + t38);
        t6c = (t62 + t48);
        a37 = (0.70710678118654757f*(t52 - t38));
        a47 = (0.70710678118654757f*(t62 - t48));
        s14 = (a37 + a47);
        s24 = (a47 - a37);
        t7c = (t14 + t99);
        t8c = (t24 + t0a);
        t9c = (t14 - t99);
        t0d = (t24 - t0a);
        t1d = (t55 + t3b);
        t2d = (t65 + t4b);
        a57 = (0.70710678118654757f*(t65 - t4b));
        a67 = (0.70710678118654757f*(t55 - t3b));
        s34 = (a57 - a67);
        s44 = (a67 + a57);
        t3d = (t1c + t7c);
        t4d = (t2c + t8c);
        t5d = (t1c - t7c);
        t6d = (t2c - t8c);
        t7d = (t5c + t1d);
        t8d = (t6c + t2d);
        t9d = (t5c - t1d);
        t0e = (t6c - t2d);
        t1e = (t3d + t7d);
        t2e = (t4d + t8d);
        t3e = (t3d - t7d);
        t4e = (t4d - t8d);
        a77 = (64*i);
        a87 = (D279 + a77);
        a97 = (a87 + 1);
        a08 = (a87 + 2);
        a18 = (a87 + 3);
        a28 = (T + a77);
        *(a28) = ((*(a87)*t1e) - (*(a97)*t2e));
        *((a28 + 1)) = ((*(a97)*t1e) + (*(a87)*t2e));
        *((a28 + 32)) = ((*(a08)*t3e) - (*(a18)*t4e));
        *((a28 + 33)) = ((*(a18)*t3e) + (*(a08)*t4e));
        t5e = (t5d + t0e);
        t6e = (t6d - t9d);
        t7e = (t5d - t0e);
        t8e = (t6d + t9d);
        a38 = (a87 + 4);
        a48 = (a87 + 5);
        a58 = (a87 + 6);
        a68 = (a87 + 7);
        *((a28 + 16)) = ((*(a38)*t5e) - (*(a48)*t6e));
        *((a28 + 17)) = ((*(a48)*t5e) + (*(a38)*t6e));
        *((a28 + 48)) = ((*(a58)*t7e) - (*(a68)*t8e));
        *((a28 + 49)) = ((*(a68)*t7e) + (*(a58)*t8e));
        t9e = (t3c + t0d);
        t0f = (t4c - t9c);
        t1f = (t3c - t0d);
        t2f = (t4c + t9c);
        t3f = (s14 + s34);
        t4f = (s24 - s44);
        t5f = (s14 - s34);
        t6f = (s24 + s44);
        t7f = (t9e + t3f);
        t8f = (t0f + t4f);
        t9f = (t9e - t3f);
        t0g = (t0f - t4f);
        a78 = (a87 + 8);
        a88 = (a87 + 9);
        a98 = (a87 + 10);
        a09 = (a87 + 11);
        *((a28 + 8)) = ((*(a78)*t7f) - (*(a88)*t8f));
        *((a28 + 9)) = ((*(a88)*t7f) + (*(a78)*t8f));
        *((a28 + 40)) = ((*(a98)*t9f) - (*(a09)*t0g));
        *((a28 + 41)) = ((*(a09)*t9f) + (*(a98)*t0g));
        t1g = (t1f + t6f);
        t2g = (t2f - t5f);
        t3g = (t1f - t6f);
        t4g = (t2f + t5f);
        a19 = (a87 + 12);
        a29 = (a87 + 13);
        a39 = (a87 + 14);
        a49 = (a87 + 15);
        *((a28 + 24)) = ((*(a19)*t1g) - (*(a29)*t2g));
        *((a28 + 25)) = ((*(a29)*t1g) + (*(a19)*t2g));
        *((a28 + 56)) = ((*(a39)*t3g) - (*(a49)*t4g));
        *((a28 + 57)) = ((*(a49)*t3g) + (*(a39)*t4g));
        t5g = (t31 + s91);
        t6g = (t41 + s02);
        t7g = (t31 - s91);
        t8g = (t41 - s02);
        t9g = (s3 + s52);
        t0h = (s4 + s62);
        a59 = (0.70710678118654757f*(s3 - s52));
        a69 = (0.70710678118654757f*(s4 - s62));
        s54 = (a59 + a69);
        s64 = (a69 - a59);
        t1h = (s9 + s13);
        t2h = (s01 + s23);
        t3h = (s9 - s13);
        t4h = (s01 - s23);
        t5h = (s51 + s73);
        t6h = (s61 + s83);
        a79 = (0.70710678118654757f*(s61 - s83));
        a89 = (0.70710678118654757f*(s51 - s73));
        s74 = (a79 - a89);
        s84 = (a89 + a79);
        t7h = (t5g + t1h);
        t8h = (t6g + t2h);
        t9h = (t5g - t1h);
        t0i = (t6g - t2h);
        t1i = (t9g + t5h);
        t2i = (t0h + t6h);
        t3i = (t9g - t5h);
        t4i = (t0h - t6h);
        t5i = (t7h + t1i);
        t6i = (t8h + t2i);
        t7i = (t7h - t1i);
        t8i = (t8h - t2i);
        a99 = (a87 + 16);
        a0a = (a87 + 17);
        a1a = (a87 + 18);
        a2a = (a87 + 19);
        *((a28 + 2)) = ((*(a99)*t5i) - (*(a0a)*t6i));
        *((a28 + 3)) = ((*(a0a)*t5i) + (*(a99)*t6i));
        *((a28 + 34)) = ((*(a1a)*t7i) - (*(a2a)*t8i));
        *((a28 + 35)) = ((*(a2a)*t7i) + (*(a1a)*t8i));
        t9i = (t9h + t4i);
        t0j = (t0i - t3i);
        t1j = (t9h - t4i);
        t2j = (t0i + t3i);
        a3a = (a87 + 20);
        a4a = (a87 + 21);
        a5a = (a87 + 22);
        a6a = (a87 + 23);
        *((a28 + 18)) = ((*(a3a)*t9i) - (*(a4a)*t0j));
        *((a28 + 19)) = ((*(a4a)*t9i) + (*(a3a)*t0j));
        *((a28 + 50)) = ((*(a5a)*t1j) - (*(a6a)*t2j));
        *((a28 + 51)) = ((*(a6a)*t1j) + (*(a5a)*t2j));
        t3j = (t7g + t4h);
        t4j = (t8g - t3h);
        t5j = (t7g - t4h);
        t6j = (t8g + t3h);
        t7j = (s54 + s74);
        t8j = (s64 - s84);
        t9j = (s54 - s74);
        t0k = (s64 + s84);
        t1k = (t3j + t7j);
        t2k = (t4j + t8j);
        t3k = (t3j - t7j);
        t4k = (t4j - t8j);
        a7a = (a87 + 24);
        a8a = (a87 + 25);
        a9a = (a87 + 26);
        a0b = (a87 + 27);
        *((a28 + 10)) = ((*(a7a)*t1k) - (*(a8a)*t2k));
        *((a28 + 11)) = ((*(a8a)*t1k) + (*(a7a)*t2k));
        *((a28 + 42)) = ((*(a9a)*t3k) - (*(a0b)*t4k));
        *((a28 + 43)) = ((*(a0b)*t3k) + (*(a9a)*t4k));
        t5k = (t5j + t0k);
        t6k = (t6j - t9j);
        t7k = (t5j - t0k);
        t8k = (t6j + t9j);
        a1b = (a87 + 28);
        a2b = (a87 + 29);
        a3b = (a87 + 30);
        a4b = (a87 + 31);
        *((a28 + 26)) = ((*(a1b)*t5k) - (*(a2b)*t6k));
        *((a28 + 27)) = ((*(a2b)*t5k) + (*(a1b)*t6k));
        *((a28 + 58)) = ((*(a3b)*t7k) - (*(a4b)*t8k));
        *((a28 + 59)) = ((*(a4b)*t7k) + (*(a3b)*t8k));
        t9k = (t11 + t47);
        t0l = (t21 - t37);
        t1l = (t11 - t47);
        t2l = (t21 + t37);
        t3l = (s + s32);
        t4l = (s2 - s42);
        a5b = (0.70710678118654757f*(s - s32));
        a6b = (0.70710678118654757f*(s2 + s42));
        s94 = (a5b + a6b);
        s05 = (a6b - a5b);
        t5l = (s7 + s92);
        t6l = (s8 - s03);
        t7l = (s7 - s92);
        t8l = (s8 + s03);
        t9l = (s31 + s53);
        t0m = (s41 - s63);
        a7b = (0.70710678118654757f*(s41 + s63));
        a8b = (0.70710678118654757f*(s31 - s53));
        s15 = (a7b - a8b);
        s25 = (a8b + a7b);
        t1m = (t9k + t5l);
        t2m = (t0l + t6l);
        t3m = (t9k - t5l);
        t4m = (t0l - t6l);
        t5m = (t3l + t9l);
        t6m = (t4l + t0m);
        t7m = (t3l - t9l);
        t8m = (t4l - t0m);
        t9m = (t1m + t5m);
        t0n = (t2m + t6m);
        t1n = (t1m - t5m);
        t2n = (t2m - t6m);
        a9b = (a87 + 32);
        a0c = (a87 + 33);
        a1c = (a87 + 34);
        a2c = (a87 + 35);
        *((a28 + 4)) = ((*(a9b)*t9m) - (*(a0c)*t0n));
        *((a28 + 5)) = ((*(a0c)*t9m) + (*(a9b)*t0n));
        *((a28 + 36)) = ((*(a1c)*t1n) - (*(a2c)*t2n));
        *((a28 + 37)) = ((*(a2c)*t1n) + (*(a1c)*t2n));
        t3n = (t3m + t8m);
        t4n = (t4m - t7m);
        t5n = (t3m - t8m);
        t6n = (t4m + t7m);
        a3c = (a87 + 36);
        a4c = (a87 + 37);
        a5c = (a87 + 38);
        a6c = (a87 + 39);
        *((a28 + 20)) = ((*(a3c)*t3n) - (*(a4c)*t4n));
        *((a28 + 21)) = ((*(a4c)*t3n) + (*(a3c)*t4n));
        *((a28 + 52)) = ((*(a5c)*t5n) - (*(a6c)*t6n));
        *((a28 + 53)) = ((*(a6c)*t5n) + (*(a5c)*t6n));
        t7n = (t1l + t8l);
        t8n = (t2l - t7l);
        t9n = (t1l - t8l);
        t0o = (t2l + t7l);
        t1o = (s94 + s15);
        t2o = (s05 - s25);
        t3o = (s94 - s15);
        t4o = (s05 + s25);
        t5o = (t7n + t1o);
        t6o = (t8n + t2o);
        t7o = (t7n - t1o);
        t8o = (t8n - t2o);
        a7c = (a87 + 40);
        a8c = (a87 + 41);
        a9c = (a87 + 42);
        a0d = (a87 + 43);
        *((a28 + 12)) = ((*(a7c)*t5o) - (*(a8c)*t6o));
        *((a28 + 13)) = ((*(a8c)*t5o) + (*(a7c)*t6o));
        *((a28 + 44)) = ((*(a9c)*t7o) - (*(a0d)*t8o));
        *((a28 + 45)) = ((*(a0d)*t7o) + (*(a9c)*t8o));
        t9o = (t9n + t4o);
        t0p = (t0o - t3o);
        t1p = (t9n - t4o);
        t2p = (t0o + t3o);
        a1d = (a87 + 44);
        a2d = (a87 + 45);
        a3d = (a87 + 46);
        a4d = (a87 + 47);
        *((a28 + 28)) = ((*(a1d)*t9o) - (*(a2d)*t0p));
        *((a28 + 29)) = ((*(a2d)*t9o) + (*(a1d)*t0p));
        *((a28 + 60)) = ((*(a3d)*t1p) - (*(a4d)*t2p));
        *((a28 + 61)) = ((*(a4d)*t1p) + (*(a3d)*t2p));
        t3p = (t51 + s12);
        t4p = (t61 - s22);
        t5p = (t51 - s12);
        t6p = (t61 + s22);
        t7p = (s5 + s72);
        t8p = (s6 - s82);
        a5d = (0.70710678118654757f*(s5 - s72));
        a6d = (0.70710678118654757f*(s6 + s82));
        s35 = (a5d + a6d);
        s45 = (a6d - a5d);
        t9p = (s11 - s33);
        t0q = (s21 + s43);
        t1q = (s11 + s33);
        t2q = (s21 - s43);
        t3q = (s71 - s93);
        t4q = (s04 - s81);
        a7d = (0.70710678118654757f*(s71 + s93));
        a8d = (0.70710678118654757f*(s81 + s04));
        s55 = (a7d + a8d);
        s65 = (a8d - a7d);
        t5q = (t3p + t9p);
        t6q = (t4p + t0q);
        t7q = (t3p - t9p);
        t8q = (t4p - t0q);
        t9q = (t7p + t3q);
        t0r = (t8p + t4q);
        t1r = (t7p - t3q);
        t2r = (t8p - t4q);
        t3r = (t5q + t9q);
        t4r = (t6q + t0r);
        t5r = (t5q - t9q);
        t6r = (t6q - t0r);
        a9d = (a87 + 48);
        a0e = (a87 + 49);
        a1e = (a87 + 50);
        a2e = (a87 + 51);
        *((a28 + 6)) = ((*(a9d)*t3r) - (*(a0e)*t4r));
        *((a28 + 7)) = ((*(a0e)*t3r) + (*(a9d)*t4r));
        *((a28 + 38)) = ((*(a1e)*t5r) - (*(a2e)*t6r));
        *((a28 + 39)) = ((*(a2e)*t5r) + (*(a1e)*t6r));
        t7r = (t7q + t2r);
        t8r = (t8q - t1r);
        t9r = (t7q - t2r);
        t0s = (t8q + t1r);
        a3e = (a87 + 52);
        a4e = (a87 + 53);
        a5e = (a87 + 54);
        a6e = (a87 + 55);
        *((a28 + 22)) = ((*(a3e)*t7r) - (*(a4e)*t8r));
        *((a28 + 23)) = ((*(a4e)*t7r) + (*(a3e)*t8r));
        *((a28 + 54)) = ((*(a5e)*t9r) - (*(a6e)*t0s));
        *((a28 + 55)) = ((*(a6e)*t9r) + (*(a5e)*t0s));
        t1s = (t5p + t2q);
        t2s = (t6p - t1q);
        t3s = (t5p - t2q);
        t4s = (t6p + t1q);
        t5s = (s35 - s55);
        t6s = (s45 + s65);
        t7s = (s35 + s55);
        t8s = (s45 - s65);
        t9s = (t1s + t5s);
        t0t = (t2s + t6s);
        t1t = (t1s - t5s);
        t2t = (t2s - t6s);
        a7e = (a87 + 56);
        a8e = (a87 + 57);
        a9e = (a87 + 58);
        a0f = (a87 + 59);
        *((a28 + 14)) = ((*(a7e)*t9s) - (*(a8e)*t0t));
        *((a28 + 15)) = ((*(a8e)*t9s) + (*(a7e)*t0t));
        *((a28 + 46)) = ((*(a9e)*t1t) - (*(a0f)*t2t));
        *((a28 + 47)) = ((*(a0f)*t1t) + (*(a9e)*t2t));
        t3t = (t3s + t8s);
        t4t = (t4s - t7s);
        t5t = (t3s - t8s);
        t6t = (t4s + t7s);
        a1f = (a87 + 60);
        a2f = (a87 + 61);
        a3f = (a87 + 62);
        a4f = (a87 + 63);
        *((a28 + 30)) = ((*(a1f)*t3t) - (*(a2f)*t4t));
        *((a28 + 31)) = ((*(a2f)*t3t) + (*(a1f)*t4t));
        *((a28 + 62)) = ((*(a3f)*t5t) - (*(a4f)*t6t));
        *((a28 + 63)) = ((*(a4f)*t5t) + (*(a3f)*t6t));
    }}
    {long i2; for(i2 = 0; i2 <= 31; i2++) {
        a5f = (2*i2);
        a6f = (T + a5f);
        a7f = (a6f + 1);
        a8f = (a6f + 1024);
        a9f = (a6f + 1025);
        t7t = (*(a6f) + *(a8f));
        t8t = (*(a7f) + *(a9f));
        t9t = (*(a6f) - *(a8f));
        t0u = (*(a7f) - *(a9f));
        a0g = (a6f + 512);
        a1g = (a6f + 513);
        a2g = (a6f + 1536);
        a3g = (a6f + 1537);
        t1u = (*(a0g) + *(a2g));
        t2u = (*(a1g) + *(a3g));
        t3u = (*(a0g) - *(a2g));
        t4u = (*(a1g) - *(a3g));
        t5u = (t7t + t1u);
        t6u = (t8t + t2u);
        t7u = (t7t - t1u);
        t8u = (t8t - t2u);
        t9u = (t9t + t4u);
        t0v = (t0u - t3u);
        t1v = (t9t - t4u);
        t2v = (t0u + t3u);
        a4g = (a6f + 64);
        a5g = (a6f + 65);
        a6g = (a6f + 1088);
        a7g = (a6f + 1089);
        t3v = (*(a4g) + *(a6g));
        t4v = (*(a5g) + *(a7g));
        t5v = (*(a4g) - *(a6g));
        t6v = (*(a5g) - *(a7g));
        a8g = (a6f + 576);
        a9g = (a6f + 577);
        a0h = (a6f + 1600);
        a1h = (a6f + 1601);
        t7v = (*(a8g) + *(a0h));
        t8v = (*(a9g) + *(a1h));
        t9v = (*(a8g) - *(a0h));
        t0w = (*(a9g) - *(a1h));
        t1w = (t3v + t7v);
        t2w = (t4v + t8v);
        t3w = (t3v - t7v);
        t4w = (t4v - t8v);
        s75 = ((0.92387953251128674f*t3w) + (0.38268343236508978f*t4w));
        s85 = ((0.92387953251128674f*t4w) - (0.38268343236508978f*t3w));
        t5w = (t5v + t0w);
        t6w = (t6v - t9v);
        t7w = (t5v - t0w);
        t8w = (t6v + t9v);
        s95 = ((0.98078528040323043f*t5w) + (0.19509032201612828f*t6w));
        s06 = ((0.98078528040323043f*t6w) - (0.19509032201612828f*t5w));
        s16 = ((0.83146961230254524f*t7w) + (0.55557023301960218f*t8w));
        s26 = ((0.83146961230254524f*t8w) - (0.55557023301960218f*t7w));
        a2h = (a6f + 128);
        a3h = (a6f + 129);
        a4h = (a6f + 1152);
        a5h = (a6f + 1153);
        t9w = (*(a2h) + *(a4h));
        t0x = (*(a3h) + *(a5h));
        t1x = (*(a2h) - *(a4h));
        t2x = (*(a3h) - *(a5h));
        a6h = (a6f + 640);
        a7h = (a6f + 641);
        a8h = (a6f + 1664);
        a9h = (a6f + 1665);
        t3x = (*(a6h) + *(a8h));
        t4x = (*(a7h) + *(a9h));
        t5x = (*(a6h) - *(a8h));
        t6x = (*(a7h) - *(a9h));
        t7x = (t9w + t3x);
        t8x = (t0x + t4x);
        a0i = (0.70710678118654757f*(t9w - t3x));
        a1i = (0.70710678118654757f*(t0x - t4x));
        s36 = (a0i + a1i);
        s46 = (a1i - a0i);
        t9x = (t1x + t6x);
        t0y = (t2x - t5x);
        t1y = (t1x - t6x);
        t2y = (t2x + t5x);
        s56 = ((0.92387953251128674f*t9x) + (0.38268343236508978f*t0y));
        s66 = ((0.92387953251128674f*t0y) - (0.38268343236508978f*t9x));
        s76 = ((0.38268343236508978f*t1y) + (0.92387953251128674f*t2y));
        s86 = ((0.38268343236508978f*t2y) - (0.92387953251128674f*t1y));
        a2i = (a6f + 192);
        a3i = (a6f + 193);
        a4i = (a6f + 1216);
        a5i = (a6f + 1217);
        t3y = (*(a2i) + *(a4i));
        t4y = (*(a3i) + *(a5i));
        t5y = (*(a2i) - *(a4i));
        t6y = (*(a3i) - *(a5i));
        a6i = (a6f + 704);
        a7i = (a6f + 705);
        a8i = (a6f + 1728);
        a9i = (a6f + 1729);
        t7y = (*(a6i) + *(a8i));
        t8y = (*(a7i) + *(a9i));
        t9y = (*(a6i) - *(a8i));
        t0z = (*(a7i) - *(a9i));
        t1z = (t3y + t7y);
        t2z = (t4y + t8y);
        t3z = (t3y - t7y);
        t4z = (t4y - t8y);
        s96 = ((0.38268343236508978f*t3z) + (0.92387953251128674f*t4z));
        s07 = ((0.38268343236508978f*t4z) - (0.92387953251128674f*t3z));
        t5z = (t5y + t0z);
        t6z = (t6y - t9y);
        t7z = (t5y - t0z);
        t8z = (t6y + t9y);
        s17 = ((0.83146961230254524f*t5z) + (0.55557023301960218f*t6z));
        s27 = ((0.83146961230254524f*t6z) - (0.55557023301960218f*t5z));
        s37 = ((0.98078528040323043f*t8z) - (0.19509032201612828f*t7z));
        s47 = ((0.98078528040323043f*t7z) + (0.19509032201612828f*t8z));
        a0j = (a6f + 256);
        a1j = (a6f + 257);
        a2j = (a6f + 1280);
        a3j = (a6f + 1281);
        t9z = (*(a0j) + *(a2j));
        t0A = (*(a1j) + *(a3j));
        t1A = (*(a0j) - *(a2j));
        t2A = (*(a1j) - *(a3j));
        a4j = (a6f + 768);
        a5j = (a6f + 769);
        a6j = (a6f + 1792);
        a7j = (a6f + 1793);
        t3A = (*(a4j) + *(a6j));
        t4A = (*(a5j) + *(a7j));
        t5A = (*(a4j) - *(a6j));
        t6A = (*(a5j) - *(a7j));
        t7A = (t9z + t3A);
        t8A = (t0A + t4A);
        t9A = (t9z - t3A);
        t0B = (t0A - t4A);
        a8j = (0.70710678118654757f*(t1A + t6A));
        a9j = (0.70710678118654757f*(t2A - t5A));
        s57 = (a8j + a9j);
        s67 = (a9j - a8j);
        a0k = (0.70710678118654757f*(t2A + t5A));
        a1k = (0.70710678118654757f*(t1A - t6A));
        s77 = (a0k - a1k);
        s87 = (a1k + a0k);
        a2k = (a6f + 320);
        a3k = (a6f + 321);
        a4k = (a6f + 1344);
        a5k = (a6f + 1345);
        t1B = (*(a2k) + *(a4k));
        t2B = (*(a3k) + *(a5k));
        t3B = (*(a2k) - *(a4k));
        t4B = (*(a3k) - *(a5k));
        a6k = (a6f + 832);
        a7k = (a6f + 833);
        a8k = (a6f + 1856);
        a9k = (a6f + 1857);
        t5B = (*(a6k) + *(a8k));
        t6B = (*(a7k) + *(a9k));
        t7B = (*(a6k) - *(a8k));
        t8B = (*(a7k) - *(a9k));
        t9B = (t1B + t5B);
        t0C = (t2B + t6B);
        t1C = (t1B - t5B);
        t2C = (t2B - t6B);
        s97 = ((0.92387953251128674f*t2C) - (0.38268343236508978f*t1C));
        s08 = ((0.92387953251128674f*t1C) + (0.38268343236508978f*t2C));
        t3C = (t3B + t8B);
        t4C = (t4B - t7B);
        t5C = (t3B - t8B);
        t6C = (t4B + t7B);
        s18 = ((0.55557023301960218f*t3C) + (0.83146961230254524f*t4C));
        s28 = ((0.55557023301960218f*t4C) - (0.83146961230254524f*t3C));
        s38 = ((0.19509032201612828f*t6C) - (0.98078528040323043f*t5C));
        s48 = ((0.19509032201612828f*t5C) + (0.98078528040323043f*t6C));
        a0l = (a6f + 384);
        a1l = (a6f + 385);
        a2l = (a6f + 1408);
        a3l = (a6f + 1409);
        t7C = (*(a0l) + *(a2l));
        t8C = (*(a1l) + *(a3l));
        t9C = (*(a0l) - *(a2l));
        t0D = (*(a1l) - *(a3l));
        a4l = (a6f + 896);
        a5l = (a6f + 897);
        a6l = (a6f + 1920);
        a7l = (a6f + 1921);
        t1D = (*(a4l) + *(a6l));
        t2D = (*(a5l) + *(a7l));
        t3D = (*(a4l) - *(a6l));
        t4D = (*(a5l) - *(a7l));
        t5D = (t7C + t1D);
        t6D = (t8C + t2D);
        a8l = (0.70710678118654757f*(t8C - t2D));
        a9l = (0.70710678118654757f*(t7C - t1D));
        s58 = (a8l - a9l);
        s68 = (a9l + a8l);
        t7D = (t9C + t4D);
        t8D = (t0D - t3D);
        t9D = (t9C - t4D);
        t0E = (t0D + t3D);
        s78 = ((0.38268343236508978f*t7D) + (0.92387953251128674f*t8D));
        s88 = ((0.38268343236508978f*t8D) - (0.92387953251128674f*t7D));
        s98 = ((0.92387953251128674f*t9D) + (0.38268343236508978f*t0E));
        s09 = ((0.38268343236508978f*t9D) - (0.92387953251128674f*t0E));
        a0m = (a6f + 448);
        a1m = (a6f + 449);
        a2m = (a6f + 1472);
        a3m = (a6f + 1473);
        t1E = (*(a0m) + *(a2m));
        t2E = (*(a1m) + *(a3m));
        t3E = (*(a0m) - *(a2m));
        t4E = (*(a1m) - *(a3m));
        a4m = (a6f + 960);
        a5m = (a6f + 961);
        a6m = (a6f + 1984);
        a7m = (a6f + 1985);
        t5E = (*(a4m) + *(a6m));
        t6E = (*(a5m) + *(a7m));
        t7E = (*(a4m) - *(a6m));
        t8E = (*(a5m) - *(a7m));
        t9E = (t1E + t5E);
        t0F = (t2E + t6E);
        t1F = (t1E - t5E);
        t2F = (t2E - t6E);
        s19 = ((0.38268343236508978f*t2F) - (0.92387953251128674f*t1F));
        s29 = ((0.38268343236508978f*t1F) + (0.92387953251128674f*t2F));
        t3F = (t3E + t8E);
        t4F = (t4E - t7E);
        t5F = (t3E - t8E);
        t6F = (t4E + t7E);
        s39 = ((0.19509032201612828f*t3F) + (0.98078528040323043f*t4F));
        s49 = ((0.19509032201612828f*t4F) - (0.98078528040323043f*t3F));
        s59 = ((0.55557023301960218f*t5F) + (0.83146961230254524f*t6F));
        s69 = ((0.83146961230254524f*t5F) - (0.55557023301960218f*t6F));
        t7F = (t5u + t7A);
        t8F = (t6u + t8A);
        t9F = (t5u - t7A);
        t0G = (t6u - t8A);
        t1G = (t1w + t9B);
        t2G = (t2w + t0C);
        a8m = (0.70710678118654757f*(t1w - t9B));
        a9m = (0.70710678118654757f*(t2w - t0C));
        s79 = (a8m + a9m);
        s89 = (a9m - a8m);
        t3G = (t7x + t5D);
        t4G = (t8x + t6D);
        t5G = (t7x - t5D);
        t6G = (t8x - t6D);
        t7G = (t1z + t9E);
        t8G = (t2z + t0F);
        a0n = (0.70710678118654757f*(t2z - t0F));
        a1n = (0.70710678118654757f*(t1z - t9E));
        s99 = (a0n - a1n);
        s0a = (a1n + a0n);
        t9G = (t7F + t3G);
        t0H = (t8F + t4G);
        t1H = (t7F - t3G);
        t2H = (t8F - t4G);
        t3H = (t1G + t7G);
        t4H = (t2G + t8G);
        t5H = (t1G - t7G);
        t6H = (t2G - t8G);
        a2n = (dst + a5f);
        *(a2n) = (t9G + t3H);
        *((a2n + 1)) = (t0H + t4H);
        *((a2n + 1024)) = (t9G - t3H);
        *((a2n + 1025)) = (t0H - t4H);
        *((a2n + 512)) = (t1H + t6H);
        *((a2n + 513)) = (t2H - t5H);
        *((a2n + 1536)) = (t1H - t6H);
        *((a2n + 1537)) = (t2H + t5H);
        t7H = (t9F + t6G);
        t8H = (t0G - t5G);
        t9H = (t9F - t6G);
        t0I = (t0G + t5G);
        t1I = (s79 + s99);
        t2I = (s89 - s0a);
        t3I = (s79 - s99);
        t4I = (s89 + s0a);
        *((a2n + 256)) = (t7H + t1I);
        *((a2n + 257)) = (t8H + t2I);
        *((a2n + 1280)) = (t7H - t1I);
        *((a2n + 1281)) = (t8H - t2I);
        *((a2n + 768)) = (t9H + t4I);
        *((a2n + 769)) = (t0I - t3I);
        *((a2n + 1792)) = (t9H - t4I);
        *((a2n + 1793)) = (t0I + t3I);
        t5I = (t9u + s57);
        t6I = (t0v + s67);
        t7I = (t9u - s57);
        t8I = (t0v - s67);
        t9I = (s95 + s18);
        t0J = (s06 + s28);
        a3n = (0.70710678118654757f*(s95 - s18));
        a4n = (0.70710678118654757f*(s06 - s28));
        s1a = (a3n + a4n);
        s2a = (a4n - a3n);
        t1J = (s56 + s78);
        t2J = (s66 + s88);
        t3J = (s56 - s78);
        t4J = (s66 - s88);
        t5J = (s17 + s39);
        t6J = (s27 + s49);
        a5n = (0.70710678118654757f*(s27 - s49));
        a6n = (0.70710678118654757f*(s17 - s39));
        s3a = (a5n - a6n);
        s4a = (a6n + a5n);
        t7J = (t5I + t1J);
        t8J = (t6I + t2J);
        t9J = (t5I - t1J);
        t0K = (t6I - t2J);
        t1K = (t9I + t5J);
        t2K = (t0J + t6J);
        t3K = (t9I - t5J);
        t4K = (t0J - t6J);
        *((a2n + 64)) = (t7J + t1K);
        *((a2n + 65)) = (t8J + t2K);
        *((a2n + 1088)) = (t7J - t1K);
        *((a2n + 1089)) = (t8J - t2K);
        *((a2n + 576)) = (t9J + t4K);
        *((a2n + 577)) = (t0K - t3K);
        *((a2n + 1600)) = (t9J - t4K);
        *((a2n + 1601)) = (t0K + t3K);
        t5K = (t7I + t4J);
        t6K = (t8I - t3J);
        t7K = (t7I - t4J);
        t8K = (t8I + t3J);
        t9K = (s1a + s3a);
        t0L = (s2a - s4a);
        t1L = (s1a - s3a);
        t2L = (s2a + s4a);
        *((a2n + 320)) = (t5K + t9K);
        *((a2n + 321)) = (t6K + t0L);
        *((a2n + 1344)) = (t5K - t9K);
        *((a2n + 1345)) = (t6K - t0L);
        *((a2n + 832)) = (t7K + t2L);
        *((a2n + 833)) = (t8K - t1L);
        *((a2n + 1856)) = (t7K - t2L);
        *((a2n + 1857)) = (t8K + t1L);
        t3L = (t7u + t0B);
        t4L = (t8u - t9A);
        t5L = (t7u - t0B);
        t6L = (t8u + t9A);
        t7L = (s75 + s97);
        t8L = (s85 - s08);
        a7n = (0.70710678118654757f*(s75 - s97));
        a8n = (0.70710678118654757f*(s85 + s08));
        s5a = (a7n + a8n);
        s6a = (a8n - a7n);
        t9L = (s36 + s58);
        t0M = (s46 - s68);
        t1M = (s36 - s58);
        t2M = (s46 + s68);
        t3M = (s96 + s19);
        t4M = (s07 - s29);
        a9n = (0.70710678118654757f*(s07 + s29));
        a0o = (0.70710678118654757f*(s96 - s19));
        s7a = (a9n - a0o);
        s8a = (a0o + a9n);
        t5M = (t3L + t9L);
        t6M = (t4L + t0M);
        t7M = (t3L - t9L);
        t8M = (t4L - t0M);
        t9M = (t7L + t3M);
        t0N = (t8L + t4M);
        t1N = (t7L - t3M);
        t2N = (t8L - t4M);
        *((a2n + 128)) = (t5M + t9M);
        *((a2n + 129)) = (t6M + t0N);
        *((a2n + 1152)) = (t5M - t9M);
        *((a2n + 1153)) = (t6M - t0N);
        *((a2n + 640)) = (t7M + t2N);
        *((a2n + 641)) = (t8M - t1N);
        *((a2n + 1664)) = (t7M - t2N);
        *((a2n + 1665)) = (t8M + t1N);
        t3N = (t5L + t2M);
        t4N = (t6L - t1M);
        t5N = (t5L - t2M);
        t6N = (t6L + t1M);
        t7N = (s5a + s7a);
        t8N = (s6a - s8a);
        t9N = (s5a - s7a);
        t0O = (s6a + s8a);
        *((a2n + 384)) = (t3N + t7N);
        *((a2n + 385)) = (t4N + t8N);
        *((a2n + 1408)) = (t3N - t7N);
        *((a2n + 1409)) = (t4N - t8N);
        *((a2n + 896)) = (t5N + t0O);
        *((a2n + 897)) = (t6N - t9N);
        *((a2n + 1920)) = (t5N - t0O);
        *((a2n + 1921)) = (t6N + t9N);
        t1O = (t1v + s77);
        t2O = (t2v - s87);
        t3O = (t1v - s77);
        t4O = (t2v + s87);
        t5O = (s16 + s38);
        t6O = (s26 - s48);
        a1o = (0.70710678118654757f*(s16 - s38));
        a2o = (0.70710678118654757f*(s26 + s48));
        s9a = (a1o + a2o);
        s0b = (a2o - a1o);
        t7O = (s76 - s98);
        t8O = (s86 + s09);
        t9O = (s76 + s98);
        t0P = (s86 - s09);
        t1P = (s37 - s59);
        t2P = (s69 - s47);
        a3o = (0.70710678118654757f*(s37 + s59));
        a4o = (0.70710678118654757f*(s47 + s69));
        s1b = (a3o + a4o);
        s2b = (a4o - a3o);
        t3P = (t1O + t7O);
        t4P = (t2O + t8O);
        t5P = (t1O - t7O);
        t6P = (t2O - t8O);
        t7P = (t5O + t1P);
        t8P = (t6O + t2P);
        t9P = (t5O - t1P);
        t0Q = (t6O - t2P);
        *((a2n + 192)) = (t3P + t7P);
        *((a2n + 193)) = (t4P + t8P);
        *((a2n + 1216)) = (t3P - t7P);
        *((a2n + 1217)) = (t4P - t8P);
        *((a2n + 704)) = (t5P + t0Q);
        *((a2n + 705)) = (t6P - t9P);
        *((a2n + 1728)) = (t5P - t0Q);
        *((a2n + 1729)) = (t6P + t9P);
        t1Q = (t3O + t0P);
        t2Q = (t4O - t9O);
        t3Q = (t3O - t0P);
        t4Q = (t4O + t9O);
        t5Q = (s9a - s1b);
        t6Q = (s0b + s2b);
        t7Q = (s9a + s1b);
        t8Q = (s0b - s2b);
        *((a2n + 448)) = (t1Q + t5Q);
        *((a2n + 449)) = (t2Q + t6Q);
        *((a2n + 1472)) = (t1Q - t5Q);
        *((a2n + 1473)) = (t2Q - t6Q);
        *((a2n + 960)) = (t3Q + t8Q);
        *((a2n + 961)) = (t4Q - t7Q);
        *((a2n + 1984)) = (t3Q - t8Q);
        *((a2n + 1985)) = (t4Q + t7Q);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_float_2048)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[4096];
     float T2[256];
    float  *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a15, *a16, *a17, *a18, *a19, *a1a, *a1b, *a1c, *a1f, *a24, *a25
            , *a26, *a27, *a28, *a29, *a2a, *a2b, *a2c, *a2f, *a34, *a35, *a36, *a37, *a38, *a39, *a3a, *a3b, *a3c, *a3d, *a44, *a45, *a46, *a47
            , *a4a, *a4c, *a4d, *a54, *a55, *a56, *a5a, *a5b, *a5c, *a5d, *a5e, *a5f, *a64, *a65, *a66, *a67, *a68, *a6a, *a6b, *a6c, *a6d, *a6e
            , *a74, *a75, *a76, *a77, *a78, *a79, *a7a, *a7b, *a7c, *a7d, *a7e, *a84, *a85, *a86, *a87, *a88, *a89, *a8a, *a8b, *a8c, *a8d, *a8e
            , *a94, *a95, *a96, *a97, *a98, *a99, *a9a, *a9b, *a9c, *a9d, *a9e;
    const float  *a01, *a02, *a11, *a12, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53, *a6, *a61
            , *a62, *a63, *a7, *a71, *a72, *a73, *a8, *a83, *a9, *a93;
    int a, a4b, a57, a69;
    float a03, a04, a13, a14, a1d, a1e, a2d, a2e, a3e, a3f, a48, a49, a4e, a4f, a58, a59, a81, a82, a91, a92, s, s01
            , s02, s03, s11, s12, s13, s2, s21, s22, s23, s3, s31, s32, s33, s4, s41, s42, s43, s5, s51, s52, s53, s6
            , s61, s62, s63, s7, s71, s72, s8, s81, s82, s9, s91, s92, t, t01, t02, t03, t04, t05, t06, t07, t08, t09
            , t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o, t0p, t11, t12, t13, t14, t15, t16
            , t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t2, t21, t22
            , t23, t24, t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o
            , t2p, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k
            , t3l, t3m, t3n, t3o, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h
            , t4i, t4j, t4k, t4l, t4m, t4n, t4o, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e
            , t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a, t6b
            , t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t7, t71, t72, t73, t74, t75, t76, t77, t78
            , t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m, t7n, t7o, t8, t81, t82, t83, t84, t85
            , t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t9, t91, t92
            , t93, t94, t95, t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o;
    {long i; for(i = 0; i <= 15; i++) {
        {long i2; for(i2 = 0; i2 <= 7; i2++) {
            a = (32*i2);
            a2 = (src + (2*i) + a);
            a3 = (a2 + 1);
            a4 = (a2 + 2048);
            a5 = (a2 + 2049);
            t = (*(a2) + *(a4));
            t2 = (*(a3) + *(a5));
            t3 = (*(a2) - *(a4));
            t4 = (*(a3) - *(a5));
            a6 = (a2 + 1024);
            a7 = (a2 + 1025);
            a8 = (a2 + 3072);
            a9 = (a2 + 3073);
            t5 = (*(a6) + *(a8));
            t6 = (*(a7) + *(a9));
            t7 = (*(a6) - *(a8));
            t8 = (*(a7) - *(a9));
            t9 = (t + t5);
            t01 = (t2 + t6);
            t11 = (t - t5);
            t21 = (t2 - t6);
            t31 = (t3 + t8);
            t41 = (t4 - t7);
            t51 = (t3 - t8);
            t61 = (t4 + t7);
            a01 = (a2 + 256);
            a11 = (a2 + 257);
            a21 = (a2 + 2304);
            a31 = (a2 + 2305);
            t71 = (*(a01) + *(a21));
            t81 = (*(a11) + *(a31));
            t91 = (*(a01) - *(a21));
            t02 = (*(a11) - *(a31));
            a41 = (a2 + 1280);
            a51 = (a2 + 1281);
            a61 = (a2 + 3328);
            a71 = (a2 + 3329);
            t12 = (*(a41) + *(a61));
            t22 = (*(a51) + *(a71));
            t32 = (*(a41) - *(a61));
            t42 = (*(a51) - *(a71));
            t52 = (t71 + t12);
            t62 = (t81 + t22);
            a81 = (0.70710678118654757f*(t71 - t12));
            a91 = (0.70710678118654757f*(t81 - t22));
            s = (a81 + a91);
            s2 = (a91 - a81);
            t72 = (t91 + t42);
            t82 = (t02 - t32);
            t92 = (t91 - t42);
            t03 = (t02 + t32);
            s3 = ((0.92387953251128674f*t72) + (0.38268343236508978f*t82));
            s4 = ((0.92387953251128674f*t82) - (0.38268343236508978f*t72));
            s5 = ((0.38268343236508978f*t92) + (0.92387953251128674f*t03));
            s6 = ((0.38268343236508978f*t03) - (0.92387953251128674f*t92));
            a02 = (a2 + 512);
            a12 = (a2 + 513);
            a22 = (a2 + 2560);
            a32 = (a2 + 2561);
            t13 = (*(a02) + *(a22));
            t23 = (*(a12) + *(a32));
            t33 = (*(a02) - *(a22));
            t43 = (*(a12) - *(a32));
            a42 = (a2 + 1536);
            a52 = (a2 + 1537);
            a62 = (a2 + 3584);
            a72 = (a2 + 3585);
            t53 = (*(a42) + *(a62));
            t63 = (*(a52) + *(a72));
            t73 = (*(a42) - *(a62));
            t83 = (*(a52) - *(a72));
            t93 = (t13 + t53);
            t04 = (t23 + t63);
            t14 = (t13 - t53);
            t24 = (t23 - t63);
            a82 = (0.70710678118654757f*(t33 + t83));
            a92 = (0.70710678118654757f*(t43 - t73));
            s7 = (a82 + a92);
            s8 = (a92 - a82);
            a03 = (0.70710678118654757f*(t43 + t73));
            a13 = (0.70710678118654757f*(t33 - t83));
            s9 = (a03 - a13);
            s01 = (a13 + a03);
            a23 = (a2 + 768);
            a33 = (a2 + 769);
            a43 = (a2 + 2816);
            a53 = (a2 + 2817);
            t34 = (*(a23) + *(a43));
            t44 = (*(a33) + *(a53));
            t54 = (*(a23) - *(a43));
            t64 = (*(a33) - *(a53));
            a63 = (a2 + 1792);
            a73 = (a2 + 1793);
            a83 = (a2 + 3840);
            a93 = (a2 + 3841);
            t74 = (*(a63) + *(a83));
            t84 = (*(a73) + *(a93));
            t94 = (*(a63) - *(a83));
            t05 = (*(a73) - *(a93));
            t15 = (t34 + t74);
            t25 = (t44 + t84);
            a04 = (0.70710678118654757f*(t44 - t84));
            a14 = (0.70710678118654757f*(t34 - t74));
            s11 = (a04 - a14);
            s21 = (a14 + a04);
            t35 = (t54 + t05);
            t45 = (t64 - t94);
            t55 = (t54 - t05);
            t65 = (t64 + t94);
            s31 = ((0.38268343236508978f*t35) + (0.92387953251128674f*t45));
            s41 = ((0.38268343236508978f*t45) - (0.92387953251128674f*t35));
            s51 = ((0.92387953251128674f*t55) + (0.38268343236508978f*t65));
            s61 = ((0.38268343236508978f*t55) - (0.92387953251128674f*t65));
            t75 = (t9 + t93);
            t85 = (t01 + t04);
            t95 = (t9 - t93);
            t06 = (t01 - t04);
            t16 = (t52 + t15);
            t26 = (t62 + t25);
            t36 = (t52 - t15);
            t46 = (t62 - t25);
            t56 = (t75 + t16);
            t66 = (t85 + t26);
            t76 = (t75 - t16);
            t86 = (t85 - t26);
            a24 = (D276 + a);
            a34 = (a24 + 1);
            a44 = (a24 + 2);
            a54 = (a24 + 3);
            a64 = (T2 + a);
            *(a64) = ((*(a24)*t56) - (*(a34)*t66));
            *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
            *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
            *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
            t96 = (t95 + t46);
            t07 = (t06 - t36);
            t17 = (t95 - t46);
            t27 = (t06 + t36);
            a74 = (a24 + 4);
            a84 = (a24 + 5);
            a94 = (a24 + 6);
            a05 = (a24 + 7);
            *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
            *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
            *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
            *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
            t37 = (t31 + s7);
            t47 = (t41 + s8);
            t57 = (t31 - s7);
            t67 = (t41 - s8);
            t77 = (s3 + s31);
            t87 = (s4 + s41);
            t97 = (s3 - s31);
            t08 = (s4 - s41);
            t18 = (t37 + t77);
            t28 = (t47 + t87);
            t38 = (t37 - t77);
            t48 = (t47 - t87);
            a15 = (a24 + 8);
            a25 = (a24 + 9);
            a35 = (a24 + 10);
            a45 = (a24 + 11);
            *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
            *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
            *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
            *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
            t58 = (t57 + t08);
            t68 = (t67 - t97);
            t78 = (t57 - t08);
            t88 = (t67 + t97);
            a55 = (a24 + 12);
            a65 = (a24 + 13);
            a75 = (a24 + 14);
            a85 = (a24 + 15);
            *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
            *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
            *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
            *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
            t98 = (t11 + t24);
            t09 = (t21 - t14);
            t19 = (t11 - t24);
            t29 = (t21 + t14);
            t39 = (s + s11);
            t49 = (s2 - s21);
            t59 = (s - s11);
            t69 = (s2 + s21);
            t79 = (t98 + t39);
            t89 = (t09 + t49);
            t99 = (t98 - t39);
            t0a = (t09 - t49);
            a95 = (a24 + 16);
            a06 = (a24 + 17);
            a16 = (a24 + 18);
            a26 = (a24 + 19);
            *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
            *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
            *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
            *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
            t1a = (t19 + t69);
            t2a = (t29 - t59);
            t3a = (t19 - t69);
            t4a = (t29 + t59);
            a36 = (a24 + 20);
            a46 = (a24 + 21);
            a56 = (a24 + 22);
            a66 = (a24 + 23);
            *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
            *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
            *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
            *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
            t5a = (t51 + s9);
            t6a = (t61 - s01);
            t7a = (t51 - s9);
            t8a = (t61 + s01);
            t9a = (s5 - s51);
            t0b = (s6 + s61);
            t1b = (s5 + s51);
            t2b = (s6 - s61);
            t3b = (t5a + t9a);
            t4b = (t6a + t0b);
            t5b = (t5a - t9a);
            t6b = (t6a - t0b);
            a76 = (a24 + 24);
            a86 = (a24 + 25);
            a96 = (a24 + 26);
            a07 = (a24 + 27);
            *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
            *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
            *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
            *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
            t7b = (t7a + t2b);
            t8b = (t8a - t1b);
            t9b = (t7a - t2b);
            t0c = (t8a + t1b);
            a17 = (a24 + 28);
            a27 = (a24 + 29);
            a37 = (a24 + 30);
            a47 = (a24 + 31);
            *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
            *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
            *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
            *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
        }}
        {long i3; for(i3 = 0; i3 <= 15; i3++) {
            a57 = (2*i3);
            a67 = (T2 + a57);
            a77 = (a67 + 1);
            a87 = (a67 + 128);
            a97 = (a67 + 129);
            t1c = (*(a67) + *(a87));
            t2c = (*(a77) + *(a97));
            t3c = (*(a67) - *(a87));
            t4c = (*(a77) - *(a97));
            a08 = (a67 + 32);
            a18 = (a67 + 33);
            a28 = (a67 + 160);
            a38 = (a67 + 161);
            t5c = (*(a08) + *(a28));
            t6c = (*(a18) + *(a38));
            a48 = (0.70710678118654757f*(*(a08) - *(a28)));
            a58 = (0.70710678118654757f*(*(a18) - *(a38)));
            s71 = (a48 + a58);
            s81 = (a58 - a48);
            a68 = (a67 + 64);
            a78 = (a67 + 65);
            a88 = (a67 + 192);
            a98 = (a67 + 193);
            t7c = (*(a68) + *(a88));
            t8c = (*(a78) + *(a98));
            t9c = (*(a68) - *(a88));
            t0d = (*(a78) - *(a98));
            a09 = (a67 + 96);
            a19 = (a67 + 97);
            a29 = (a67 + 224);
            a39 = (a67 + 225);
            t1d = (*(a09) + *(a29));
            t2d = (*(a19) + *(a39));
            a49 = (0.70710678118654757f*(*(a19) - *(a39)));
            a59 = (0.70710678118654757f*(*(a09) - *(a29)));
            s91 = (a49 - a59);
            s02 = (a59 + a49);
            t3d = (t1c + t7c);
            t4d = (t2c + t8c);
            t5d = (t1c - t7c);
            t6d = (t2c - t8c);
            t7d = (t5c + t1d);
            t8d = (t6c + t2d);
            t9d = (t5c - t1d);
            t0e = (t6c - t2d);
            t1e = (t3d + t7d);
            t2e = (t4d + t8d);
            t3e = (t3d - t7d);
            t4e = (t4d - t8d);
            a69 = (256*i);
            a79 = (D280 + a69 + (16*i3));
            a89 = (a79 + 1);
            a99 = (a79 + 2);
            a0a = (a79 + 3);
            a1a = (T + a69 + a57);
            *(a1a) = ((*(a79)*t1e) - (*(a89)*t2e));
            *((a1a + 1)) = ((*(a89)*t1e) + (*(a79)*t2e));
            *((a1a + 128)) = ((*(a99)*t3e) - (*(a0a)*t4e));
            *((a1a + 129)) = ((*(a0a)*t3e) + (*(a99)*t4e));
            t5e = (t5d + t0e);
            t6e = (t6d - t9d);
            t7e = (t5d - t0e);
            t8e = (t6d + t9d);
            a2a = (a79 + 4);
            a3a = (a79 + 5);
            a4a = (a79 + 6);
            a5a = (a79 + 7);
            *((a1a + 64)) = ((*(a2a)*t5e) - (*(a3a)*t6e));
            *((a1a + 65)) = ((*(a3a)*t5e) + (*(a2a)*t6e));
            *((a1a + 192)) = ((*(a4a)*t7e) - (*(a5a)*t8e));
            *((a1a + 193)) = ((*(a5a)*t7e) + (*(a4a)*t8e));
            t9e = (t3c + t0d);
            t0f = (t4c - t9c);
            t1f = (t3c - t0d);
            t2f = (t4c + t9c);
            t3f = (s71 + s91);
            t4f = (s81 - s02);
            t5f = (s71 - s91);
            t6f = (s81 + s02);
            t7f = (t9e + t3f);
            t8f = (t0f + t4f);
            t9f = (t9e - t3f);
            t0g = (t0f - t4f);
            a6a = (a79 + 8);
            a7a = (a79 + 9);
            a8a = (a79 + 10);
            a9a = (a79 + 11);
            *((a1a + 32)) = ((*(a6a)*t7f) - (*(a7a)*t8f));
            *((a1a + 33)) = ((*(a7a)*t7f) + (*(a6a)*t8f));
            *((a1a + 160)) = ((*(a8a)*t9f) - (*(a9a)*t0g));
            *((a1a + 161)) = ((*(a9a)*t9f) + (*(a8a)*t0g));
            t1g = (t1f + t6f);
            t2g = (t2f - t5f);
            t3g = (t1f - t6f);
            t4g = (t2f + t5f);
            a0b = (a79 + 12);
            a1b = (a79 + 13);
            a2b = (a79 + 14);
            a3b = (a79 + 15);
            *((a1a + 96)) = ((*(a0b)*t1g) - (*(a1b)*t2g));
            *((a1a + 97)) = ((*(a1b)*t1g) + (*(a0b)*t2g));
            *((a1a + 224)) = ((*(a2b)*t3g) - (*(a3b)*t4g));
            *((a1a + 225)) = ((*(a3b)*t3g) + (*(a2b)*t4g));
        }}
    }}
    {long i4; for(i4 = 0; i4 <= 127; i4++) {
        a4b = (2*i4);
        a5b = (T + a4b);
        a6b = (a5b + 1);
        a7b = (a5b + 2048);
        a8b = (a5b + 2049);
        t5g = (*(a5b) + *(a7b));
        t6g = (*(a6b) + *(a8b));
        t7g = (*(a5b) - *(a7b));
        t8g = (*(a6b) - *(a8b));
        a9b = (a5b + 1024);
        a0c = (a5b + 1025);
        a1c = (a5b + 3072);
        a2c = (a5b + 3073);
        t9g = (*(a9b) + *(a1c));
        t0h = (*(a0c) + *(a2c));
        t1h = (*(a9b) - *(a1c));
        t2h = (*(a0c) - *(a2c));
        t3h = (t5g + t9g);
        t4h = (t6g + t0h);
        t5h = (t5g - t9g);
        t6h = (t6g - t0h);
        t7h = (t7g + t2h);
        t8h = (t8g - t1h);
        t9h = (t7g - t2h);
        t0i = (t8g + t1h);
        a3c = (a5b + 256);
        a4c = (a5b + 257);
        a5c = (a5b + 2304);
        a6c = (a5b + 2305);
        t1i = (*(a3c) + *(a5c));
        t2i = (*(a4c) + *(a6c));
        t3i = (*(a3c) - *(a5c));
        t4i = (*(a4c) - *(a6c));
        a7c = (a5b + 1280);
        a8c = (a5b + 1281);
        a9c = (a5b + 3328);
        a0d = (a5b + 3329);
        t5i = (*(a7c) + *(a9c));
        t6i = (*(a8c) + *(a0d));
        t7i = (*(a7c) - *(a9c));
        t8i = (*(a8c) - *(a0d));
        t9i = (t1i + t5i);
        t0j = (t2i + t6i);
        a1d = (0.70710678118654757f*(t1i - t5i));
        a2d = (0.70710678118654757f*(t2i - t6i));
        s12 = (a1d + a2d);
        s22 = (a2d - a1d);
        t1j = (t3i + t8i);
        t2j = (t4i - t7i);
        t3j = (t3i - t8i);
        t4j = (t4i + t7i);
        s32 = ((0.92387953251128674f*t1j) + (0.38268343236508978f*t2j));
        s42 = ((0.92387953251128674f*t2j) - (0.38268343236508978f*t1j));
        s52 = ((0.38268343236508978f*t3j) + (0.92387953251128674f*t4j));
        s62 = ((0.38268343236508978f*t4j) - (0.92387953251128674f*t3j));
        a3d = (a5b + 512);
        a4d = (a5b + 513);
        a5d = (a5b + 2560);
        a6d = (a5b + 2561);
        t5j = (*(a3d) + *(a5d));
        t6j = (*(a4d) + *(a6d));
        t7j = (*(a3d) - *(a5d));
        t8j = (*(a4d) - *(a6d));
        a7d = (a5b + 1536);
        a8d = (a5b + 1537);
        a9d = (a5b + 3584);
        a0e = (a5b + 3585);
        t9j = (*(a7d) + *(a9d));
        t0k = (*(a8d) + *(a0e));
        t1k = (*(a7d) - *(a9d));
        t2k = (*(a8d) - *(a0e));
        t3k = (t5j + t9j);
        t4k = (t6j + t0k);
        t5k = (t5j - t9j);
        t6k = (t6j - t0k);
        a1e = (0.70710678118654757f*(t7j + t2k));
        a2e = (0.70710678118654757f*(t8j - t1k));
        s72 = (a1e + a2e);
        s82 = (a2e - a1e);
        a3e = (0.70710678118654757f*(t8j + t1k));
        a4e = (0.70710678118654757f*(t7j - t2k));
        s92 = (a3e - a4e);
        s03 = (a4e + a3e);
        a5e = (a5b + 768);
        a6e = (a5b + 769);
        a7e = (a5b + 2816);
        a8e = (a5b + 2817);
        t7k = (*(a5e) + *(a7e));
        t8k = (*(a6e) + *(a8e));
        t9k = (*(a5e) - *(a7e));
        t0l = (*(a6e) - *(a8e));
        a9e = (a5b + 1792);
        a0f = (a5b + 1793);
        a1f = (a5b + 3840);
        a2f = (a5b + 3841);
        t1l = (*(a9e) + *(a1f));
        t2l = (*(a0f) + *(a2f));
        t3l = (*(a9e) - *(a1f));
        t4l = (*(a0f) - *(a2f));
        t5l = (t7k + t1l);
        t6l = (t8k + t2l);
        a3f = (0.70710678118654757f*(t8k - t2l));
        a4f = (0.70710678118654757f*(t7k - t1l));
        s13 = (a3f - a4f);
        s23 = (a4f + a3f);
        t7l = (t9k + t4l);
        t8l = (t0l - t3l);
        t9l = (t9k - t4l);
        t0m = (t0l + t3l);
        s33 = ((0.38268343236508978f*t7l) + (0.92387953251128674f*t8l));
        s43 = ((0.38268343236508978f*t8l) - (0.92387953251128674f*t7l));
        s53 = ((0.92387953251128674f*t9l) + (0.38268343236508978f*t0m));
        s63 = ((0.38268343236508978f*t9l) - (0.92387953251128674f*t0m));
        t1m = (t3h + t3k);
        t2m = (t4h + t4k);
        t3m = (t3h - t3k);
        t4m = (t4h - t4k);
        t5m = (t9i + t5l);
        t6m = (t0j + t6l);
        t7m = (t9i - t5l);
        t8m = (t0j - t6l);
        a5f = (dst + a4b);
        *(a5f) = (t1m + t5m);
        *((a5f + 1)) = (t2m + t6m);
        *((a5f + 2048)) = (t1m - t5m);
        *((a5f + 2049)) = (t2m - t6m);
        *((a5f + 1024)) = (t3m + t8m);
        *((a5f + 1025)) = (t4m - t7m);
        *((a5f + 3072)) = (t3m - t8m);
        *((a5f + 3073)) = (t4m + t7m);
        t9m = (t7h + s72);
        t0n = (t8h + s82);
        t1n = (t7h - s72);
        t2n = (t8h - s82);
        t3n = (s32 + s33);
        t4n = (s42 + s43);
        t5n = (s32 - s33);
        t6n = (s42 - s43);
        *((a5f + 256)) = (t9m + t3n);
        *((a5f + 257)) = (t0n + t4n);
        *((a5f + 2304)) = (t9m - t3n);
        *((a5f + 2305)) = (t0n - t4n);
        *((a5f + 1280)) = (t1n + t6n);
        *((a5f + 1281)) = (t2n - t5n);
        *((a5f + 3328)) = (t1n - t6n);
        *((a5f + 3329)) = (t2n + t5n);
        t7n = (t5h + t6k);
        t8n = (t6h - t5k);
        t9n = (t5h - t6k);
        t0o = (t6h + t5k);
        t1o = (s12 + s13);
        t2o = (s22 - s23);
        t3o = (s12 - s13);
        t4o = (s22 + s23);
        *((a5f + 512)) = (t7n + t1o);
        *((a5f + 513)) = (t8n + t2o);
        *((a5f + 2560)) = (t7n - t1o);
        *((a5f + 2561)) = (t8n - t2o);
        *((a5f + 1536)) = (t9n + t4o);
        *((a5f + 1537)) = (t0o - t3o);
        *((a5f + 3584)) = (t9n - t4o);
        *((a5f + 3585)) = (t0o + t3o);
        t5o = (t9h + s92);
        t6o = (t0i - s03);
        t7o = (t9h - s92);
        t8o = (t0i + s03);
        t9o = (s52 - s53);
        t0p = (s62 + s63);
        t1p = (s52 + s53);
        t2p = (s62 - s63);
        *((a5f + 768)) = (t5o + t9o);
        *((a5f + 769)) = (t6o + t0p);
        *((a5f + 2816)) = (t5o - t9o);
        *((a5f + 2817)) = (t6o - t0p);
        *((a5f + 1792)) = (t7o + t2p);
        *((a5f + 1793)) = (t8o - t1p);
        *((a5f + 3840)) = (t7o - t2p);
        *((a5f + 3841)) = (t8o + t1p);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_float_4096)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[8192];
     float T2[256];
    float  *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a0c, *a0d, *a0f, *a0h, *a0i, *a15, *a16, *a17, *a18, *a19, *a1a, *a1b, *a1c, *a1d, *a1e
            , *a1f, *a1g, *a1h, *a1i, *a1j, *a24, *a25, *a26, *a27, *a28, *a29, *a2a, *a2b, *a2c, *a2d, *a2e, *a2f, *a2g, *a2h, *a2i, *a34, *a35
            , *a36, *a37, *a38, *a39, *a3a, *a3b, *a3c, *a3d, *a3e, *a3f, *a3g, *a3h, *a3i, *a44, *a45, *a46, *a47, *a4a, *a4c, *a4d, *a4e, *a4f
            , *a4g, *a4h, *a4i, *a54, *a55, *a56, *a5a, *a5b, *a5c, *a5d, *a5e, *a5f, *a5g, *a5h, *a5i, *a64, *a65, *a66, *a67, *a68, *a6a, *a6b
            , *a6c, *a6d, *a6e, *a6f, *a6g, *a6h, *a6i, *a74, *a75, *a76, *a77, *a78, *a79, *a7a, *a7b, *a7c, *a7d, *a7e, *a7g, *a84, *a85, *a86
            , *a87, *a88, *a89, *a8a, *a8b, *a8c, *a8d, *a8e, *a8g, *a94, *a95, *a96, *a97, *a98, *a99, *a9a, *a9b, *a9c, *a9e, *a9g, *a9h;
    const float  *a, *a01, *a02, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53
            , *a6, *a61, *a62, *a63, *a7, *a73, *a8, *a83, *a9, *a91;
    int a14, a4b, a57, a69;
    float a03, a04, a0e, a0g, a0j, a0k, a1k, a2j, a2k, a3j, a3k, a48, a49, a4j, a58, a59, a5j, a6j, a71, a72, a7f, a7h
            , a7i, a7j, a81, a82, a8f, a8h, a8i, a8j, a92, a93, a9d, a9f, a9i, a9j, s, s01, s02, s03, s04, s05, s06, s07
            , s11, s12, s13, s14, s15, s16, s17, s2, s21, s22, s23, s24, s25, s26, s27, s3, s31, s32, s33, s34, s35, s36
            , s37, s4, s41, s42, s43, s44, s45, s46, s47, s5, s51, s52, s53, s54, s55, s56, s57, s6, s61, s62, s63, s64
            , s65, s66, s67, s7, s71, s72, s73, s74, s75, s76, s8, s81, s82, s83, s84, s85, s86, s9, s91, s92, s93, s94
            , s95, s96, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0A, t0B, t0C, t0D, t0a, t0b, t0c, t0d, t0e, t0f
            , t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o, t0p, t0q, t0r, t0s, t0t, t0u, t0v, t0w, t0x, t0y, t0z, t11, t12
            , t13, t14, t15, t16, t17, t18, t19, t1A, t1B, t1C, t1D, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k
            , t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t, t1u, t1v, t1w, t1x, t1y, t1z, t2, t21, t22, t23, t24, t25, t26
            , t27, t28, t29, t2A, t2B, t2C, t2D, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o
            , t2p, t2q, t2r, t2s, t2t, t2u, t2v, t2w, t2x, t2y, t2z, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3A
            , t3B, t3C, t3D, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s
            , t3t, t3u, t3v, t3w, t3x, t3y, t3z, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4A, t4B, t4C, t4D, t4a
            , t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t4o, t4p, t4q, t4r, t4s, t4t, t4u, t4v, t4w
            , t4x, t4y, t4z, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5A, t5B, t5C, t5D, t5a, t5b, t5c, t5d, t5e
            , t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t5r, t5s, t5t, t5u, t5v, t5w, t5x, t5y, t5z, t6
            , t61, t62, t63, t64, t65, t66, t67, t68, t69, t6A, t6B, t6C, t6D, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i
            , t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r, t6s, t6t, t6u, t6v, t6w, t6x, t6y, t6z, t7, t71, t72, t73, t74
            , t75, t76, t77, t78, t79, t7A, t7B, t7C, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m, t7n
            , t7o, t7p, t7q, t7r, t7s, t7t, t7u, t7v, t7w, t7x, t7y, t7z, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89
            , t8A, t8B, t8C, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p, t8q, t8r, t8s
            , t8t, t8u, t8v, t8w, t8x, t8y, t8z, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9A, t9B, t9C, t9a, t9b
            , t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p, t9q, t9r, t9s, t9t, t9u, t9v, t9w, t9x
            , t9y, t9z;
    {long i; for(i = 0; i <= 31; i++) {
        {long i2; for(i2 = 0; i2 <= 7; i2++) {
            a = (src + (2*i) + (64*i2));
            a2 = (a + 1);
            a3 = (a + 4096);
            a4 = (a + 4097);
            t = (*(a) + *(a3));
            t2 = (*(a2) + *(a4));
            t3 = (*(a) - *(a3));
            t4 = (*(a2) - *(a4));
            a5 = (a + 2048);
            a6 = (a + 2049);
            a7 = (a + 6144);
            a8 = (a + 6145);
            t5 = (*(a5) + *(a7));
            t6 = (*(a6) + *(a8));
            t7 = (*(a5) - *(a7));
            t8 = (*(a6) - *(a8));
            t9 = (t + t5);
            t01 = (t2 + t6);
            t11 = (t - t5);
            t21 = (t2 - t6);
            t31 = (t3 + t8);
            t41 = (t4 - t7);
            t51 = (t3 - t8);
            t61 = (t4 + t7);
            a9 = (a + 512);
            a01 = (a + 513);
            a11 = (a + 4608);
            a21 = (a + 4609);
            t71 = (*(a9) + *(a11));
            t81 = (*(a01) + *(a21));
            t91 = (*(a9) - *(a11));
            t02 = (*(a01) - *(a21));
            a31 = (a + 2560);
            a41 = (a + 2561);
            a51 = (a + 6656);
            a61 = (a + 6657);
            t12 = (*(a31) + *(a51));
            t22 = (*(a41) + *(a61));
            t32 = (*(a31) - *(a51));
            t42 = (*(a41) - *(a61));
            t52 = (t71 + t12);
            t62 = (t81 + t22);
            a71 = (0.70710678118654757f*(t71 - t12));
            a81 = (0.70710678118654757f*(t81 - t22));
            s = (a71 + a81);
            s2 = (a81 - a71);
            t72 = (t91 + t42);
            t82 = (t02 - t32);
            t92 = (t91 - t42);
            t03 = (t02 + t32);
            s3 = ((0.92387953251128674f*t72) + (0.38268343236508978f*t82));
            s4 = ((0.92387953251128674f*t82) - (0.38268343236508978f*t72));
            s5 = ((0.38268343236508978f*t92) + (0.92387953251128674f*t03));
            s6 = ((0.38268343236508978f*t03) - (0.92387953251128674f*t92));
            a91 = (a + 1024);
            a02 = (a + 1025);
            a12 = (a + 5120);
            a22 = (a + 5121);
            t13 = (*(a91) + *(a12));
            t23 = (*(a02) + *(a22));
            t33 = (*(a91) - *(a12));
            t43 = (*(a02) - *(a22));
            a32 = (a + 3072);
            a42 = (a + 3073);
            a52 = (a + 7168);
            a62 = (a + 7169);
            t53 = (*(a32) + *(a52));
            t63 = (*(a42) + *(a62));
            t73 = (*(a32) - *(a52));
            t83 = (*(a42) - *(a62));
            t93 = (t13 + t53);
            t04 = (t23 + t63);
            t14 = (t13 - t53);
            t24 = (t23 - t63);
            a72 = (0.70710678118654757f*(t33 + t83));
            a82 = (0.70710678118654757f*(t43 - t73));
            s7 = (a72 + a82);
            s8 = (a82 - a72);
            a92 = (0.70710678118654757f*(t43 + t73));
            a03 = (0.70710678118654757f*(t33 - t83));
            s9 = (a92 - a03);
            s01 = (a03 + a92);
            a13 = (a + 1536);
            a23 = (a + 1537);
            a33 = (a + 5632);
            a43 = (a + 5633);
            t34 = (*(a13) + *(a33));
            t44 = (*(a23) + *(a43));
            t54 = (*(a13) - *(a33));
            t64 = (*(a23) - *(a43));
            a53 = (a + 3584);
            a63 = (a + 3585);
            a73 = (a + 7680);
            a83 = (a + 7681);
            t74 = (*(a53) + *(a73));
            t84 = (*(a63) + *(a83));
            t94 = (*(a53) - *(a73));
            t05 = (*(a63) - *(a83));
            t15 = (t34 + t74);
            t25 = (t44 + t84);
            a93 = (0.70710678118654757f*(t44 - t84));
            a04 = (0.70710678118654757f*(t34 - t74));
            s11 = (a93 - a04);
            s21 = (a04 + a93);
            t35 = (t54 + t05);
            t45 = (t64 - t94);
            t55 = (t54 - t05);
            t65 = (t64 + t94);
            s31 = ((0.38268343236508978f*t35) + (0.92387953251128674f*t45));
            s41 = ((0.38268343236508978f*t45) - (0.92387953251128674f*t35));
            s51 = ((0.92387953251128674f*t55) + (0.38268343236508978f*t65));
            s61 = ((0.38268343236508978f*t55) - (0.92387953251128674f*t65));
            t75 = (t9 + t93);
            t85 = (t01 + t04);
            t95 = (t9 - t93);
            t06 = (t01 - t04);
            t16 = (t52 + t15);
            t26 = (t62 + t25);
            t36 = (t52 - t15);
            t46 = (t62 - t25);
            t56 = (t75 + t16);
            t66 = (t85 + t26);
            t76 = (t75 - t16);
            t86 = (t85 - t26);
            a14 = (32*i2);
            a24 = (D276 + a14);
            a34 = (a24 + 1);
            a44 = (a24 + 2);
            a54 = (a24 + 3);
            a64 = (T2 + a14);
            *(a64) = ((*(a24)*t56) - (*(a34)*t66));
            *((a64 + 1)) = ((*(a34)*t56) + (*(a24)*t66));
            *((a64 + 16)) = ((*(a44)*t76) - (*(a54)*t86));
            *((a64 + 17)) = ((*(a54)*t76) + (*(a44)*t86));
            t96 = (t95 + t46);
            t07 = (t06 - t36);
            t17 = (t95 - t46);
            t27 = (t06 + t36);
            a74 = (a24 + 4);
            a84 = (a24 + 5);
            a94 = (a24 + 6);
            a05 = (a24 + 7);
            *((a64 + 8)) = ((*(a74)*t96) - (*(a84)*t07));
            *((a64 + 9)) = ((*(a84)*t96) + (*(a74)*t07));
            *((a64 + 24)) = ((*(a94)*t17) - (*(a05)*t27));
            *((a64 + 25)) = ((*(a05)*t17) + (*(a94)*t27));
            t37 = (t31 + s7);
            t47 = (t41 + s8);
            t57 = (t31 - s7);
            t67 = (t41 - s8);
            t77 = (s3 + s31);
            t87 = (s4 + s41);
            t97 = (s3 - s31);
            t08 = (s4 - s41);
            t18 = (t37 + t77);
            t28 = (t47 + t87);
            t38 = (t37 - t77);
            t48 = (t47 - t87);
            a15 = (a24 + 8);
            a25 = (a24 + 9);
            a35 = (a24 + 10);
            a45 = (a24 + 11);
            *((a64 + 2)) = ((*(a15)*t18) - (*(a25)*t28));
            *((a64 + 3)) = ((*(a25)*t18) + (*(a15)*t28));
            *((a64 + 18)) = ((*(a35)*t38) - (*(a45)*t48));
            *((a64 + 19)) = ((*(a45)*t38) + (*(a35)*t48));
            t58 = (t57 + t08);
            t68 = (t67 - t97);
            t78 = (t57 - t08);
            t88 = (t67 + t97);
            a55 = (a24 + 12);
            a65 = (a24 + 13);
            a75 = (a24 + 14);
            a85 = (a24 + 15);
            *((a64 + 10)) = ((*(a55)*t58) - (*(a65)*t68));
            *((a64 + 11)) = ((*(a65)*t58) + (*(a55)*t68));
            *((a64 + 26)) = ((*(a75)*t78) - (*(a85)*t88));
            *((a64 + 27)) = ((*(a85)*t78) + (*(a75)*t88));
            t98 = (t11 + t24);
            t09 = (t21 - t14);
            t19 = (t11 - t24);
            t29 = (t21 + t14);
            t39 = (s + s11);
            t49 = (s2 - s21);
            t59 = (s - s11);
            t69 = (s2 + s21);
            t79 = (t98 + t39);
            t89 = (t09 + t49);
            t99 = (t98 - t39);
            t0a = (t09 - t49);
            a95 = (a24 + 16);
            a06 = (a24 + 17);
            a16 = (a24 + 18);
            a26 = (a24 + 19);
            *((a64 + 4)) = ((*(a95)*t79) - (*(a06)*t89));
            *((a64 + 5)) = ((*(a06)*t79) + (*(a95)*t89));
            *((a64 + 20)) = ((*(a16)*t99) - (*(a26)*t0a));
            *((a64 + 21)) = ((*(a26)*t99) + (*(a16)*t0a));
            t1a = (t19 + t69);
            t2a = (t29 - t59);
            t3a = (t19 - t69);
            t4a = (t29 + t59);
            a36 = (a24 + 20);
            a46 = (a24 + 21);
            a56 = (a24 + 22);
            a66 = (a24 + 23);
            *((a64 + 12)) = ((*(a36)*t1a) - (*(a46)*t2a));
            *((a64 + 13)) = ((*(a46)*t1a) + (*(a36)*t2a));
            *((a64 + 28)) = ((*(a56)*t3a) - (*(a66)*t4a));
            *((a64 + 29)) = ((*(a66)*t3a) + (*(a56)*t4a));
            t5a = (t51 + s9);
            t6a = (t61 - s01);
            t7a = (t51 - s9);
            t8a = (t61 + s01);
            t9a = (s5 - s51);
            t0b = (s6 + s61);
            t1b = (s5 + s51);
            t2b = (s6 - s61);
            t3b = (t5a + t9a);
            t4b = (t6a + t0b);
            t5b = (t5a - t9a);
            t6b = (t6a - t0b);
            a76 = (a24 + 24);
            a86 = (a24 + 25);
            a96 = (a24 + 26);
            a07 = (a24 + 27);
            *((a64 + 6)) = ((*(a76)*t3b) - (*(a86)*t4b));
            *((a64 + 7)) = ((*(a86)*t3b) + (*(a76)*t4b));
            *((a64 + 22)) = ((*(a96)*t5b) - (*(a07)*t6b));
            *((a64 + 23)) = ((*(a07)*t5b) + (*(a96)*t6b));
            t7b = (t7a + t2b);
            t8b = (t8a - t1b);
            t9b = (t7a - t2b);
            t0c = (t8a + t1b);
            a17 = (a24 + 28);
            a27 = (a24 + 29);
            a37 = (a24 + 30);
            a47 = (a24 + 31);
            *((a64 + 14)) = ((*(a17)*t7b) - (*(a27)*t8b));
            *((a64 + 15)) = ((*(a27)*t7b) + (*(a17)*t8b));
            *((a64 + 30)) = ((*(a37)*t9b) - (*(a47)*t0c));
            *((a64 + 31)) = ((*(a47)*t9b) + (*(a37)*t0c));
        }}
        {long i3; for(i3 = 0; i3 <= 15; i3++) {
            a57 = (2*i3);
            a67 = (T2 + a57);
            a77 = (a67 + 1);
            a87 = (a67 + 128);
            a97 = (a67 + 129);
            t1c = (*(a67) + *(a87));
            t2c = (*(a77) + *(a97));
            t3c = (*(a67) - *(a87));
            t4c = (*(a77) - *(a97));
            a08 = (a67 + 32);
            a18 = (a67 + 33);
            a28 = (a67 + 160);
            a38 = (a67 + 161);
            t5c = (*(a08) + *(a28));
            t6c = (*(a18) + *(a38));
            a48 = (0.70710678118654757f*(*(a08) - *(a28)));
            a58 = (0.70710678118654757f*(*(a18) - *(a38)));
            s71 = (a48 + a58);
            s81 = (a58 - a48);
            a68 = (a67 + 64);
            a78 = (a67 + 65);
            a88 = (a67 + 192);
            a98 = (a67 + 193);
            t7c = (*(a68) + *(a88));
            t8c = (*(a78) + *(a98));
            t9c = (*(a68) - *(a88));
            t0d = (*(a78) - *(a98));
            a09 = (a67 + 96);
            a19 = (a67 + 97);
            a29 = (a67 + 224);
            a39 = (a67 + 225);
            t1d = (*(a09) + *(a29));
            t2d = (*(a19) + *(a39));
            a49 = (0.70710678118654757f*(*(a19) - *(a39)));
            a59 = (0.70710678118654757f*(*(a09) - *(a29)));
            s91 = (a49 - a59);
            s02 = (a59 + a49);
            t3d = (t1c + t7c);
            t4d = (t2c + t8c);
            t5d = (t1c - t7c);
            t6d = (t2c - t8c);
            t7d = (t5c + t1d);
            t8d = (t6c + t2d);
            t9d = (t5c - t1d);
            t0e = (t6c - t2d);
            t1e = (t3d + t7d);
            t2e = (t4d + t8d);
            t3e = (t3d - t7d);
            t4e = (t4d - t8d);
            a69 = (256*i);
            a79 = (D281 + a69 + (16*i3));
            a89 = (a79 + 1);
            a99 = (a79 + 2);
            a0a = (a79 + 3);
            a1a = (T + a69 + a57);
            *(a1a) = ((*(a79)*t1e) - (*(a89)*t2e));
            *((a1a + 1)) = ((*(a89)*t1e) + (*(a79)*t2e));
            *((a1a + 128)) = ((*(a99)*t3e) - (*(a0a)*t4e));
            *((a1a + 129)) = ((*(a0a)*t3e) + (*(a99)*t4e));
            t5e = (t5d + t0e);
            t6e = (t6d - t9d);
            t7e = (t5d - t0e);
            t8e = (t6d + t9d);
            a2a = (a79 + 4);
            a3a = (a79 + 5);
            a4a = (a79 + 6);
            a5a = (a79 + 7);
            *((a1a + 64)) = ((*(a2a)*t5e) - (*(a3a)*t6e));
            *((a1a + 65)) = ((*(a3a)*t5e) + (*(a2a)*t6e));
            *((a1a + 192)) = ((*(a4a)*t7e) - (*(a5a)*t8e));
            *((a1a + 193)) = ((*(a5a)*t7e) + (*(a4a)*t8e));
            t9e = (t3c + t0d);
            t0f = (t4c - t9c);
            t1f = (t3c - t0d);
            t2f = (t4c + t9c);
            t3f = (s71 + s91);
            t4f = (s81 - s02);
            t5f = (s71 - s91);
            t6f = (s81 + s02);
            t7f = (t9e + t3f);
            t8f = (t0f + t4f);
            t9f = (t9e - t3f);
            t0g = (t0f - t4f);
            a6a = (a79 + 8);
            a7a = (a79 + 9);
            a8a = (a79 + 10);
            a9a = (a79 + 11);
            *((a1a + 32)) = ((*(a6a)*t7f) - (*(a7a)*t8f));
            *((a1a + 33)) = ((*(a7a)*t7f) + (*(a6a)*t8f));
            *((a1a + 160)) = ((*(a8a)*t9f) - (*(a9a)*t0g));
            *((a1a + 161)) = ((*(a9a)*t9f) + (*(a8a)*t0g));
            t1g = (t1f + t6f);
            t2g = (t2f - t5f);
            t3g = (t1f - t6f);
            t4g = (t2f + t5f);
            a0b = (a79 + 12);
            a1b = (a79 + 13);
            a2b = (a79 + 14);
            a3b = (a79 + 15);
            *((a1a + 96)) = ((*(a0b)*t1g) - (*(a1b)*t2g));
            *((a1a + 97)) = ((*(a1b)*t1g) + (*(a0b)*t2g));
            *((a1a + 224)) = ((*(a2b)*t3g) - (*(a3b)*t4g));
            *((a1a + 225)) = ((*(a3b)*t3g) + (*(a2b)*t4g));
        }}
    }}
    {long i4; for(i4 = 0; i4 <= 127; i4++) {
        a4b = (2*i4);
        a5b = (T + a4b);
        a6b = (a5b + 1);
        a7b = (a5b + 4096);
        a8b = (a5b + 4097);
        t5g = (*(a5b) + *(a7b));
        t6g = (*(a6b) + *(a8b));
        t7g = (*(a5b) - *(a7b));
        t8g = (*(a6b) - *(a8b));
        a9b = (a5b + 2048);
        a0c = (a5b + 2049);
        a1c = (a5b + 6144);
        a2c = (a5b + 6145);
        t9g = (*(a9b) + *(a1c));
        t0h = (*(a0c) + *(a2c));
        t1h = (*(a9b) - *(a1c));
        t2h = (*(a0c) - *(a2c));
        t3h = (t5g + t9g);
        t4h = (t6g + t0h);
        t5h = (t5g - t9g);
        t6h = (t6g - t0h);
        t7h = (t7g + t2h);
        t8h = (t8g - t1h);
        t9h = (t7g - t2h);
        t0i = (t8g + t1h);
        a3c = (a5b + 256);
        a4c = (a5b + 257);
        a5c = (a5b + 4352);
        a6c = (a5b + 4353);
        t1i = (*(a3c) + *(a5c));
        t2i = (*(a4c) + *(a6c));
        t3i = (*(a3c) - *(a5c));
        t4i = (*(a4c) - *(a6c));
        a7c = (a5b + 2304);
        a8c = (a5b + 2305);
        a9c = (a5b + 6400);
        a0d = (a5b + 6401);
        t5i = (*(a7c) + *(a9c));
        t6i = (*(a8c) + *(a0d));
        t7i = (*(a7c) - *(a9c));
        t8i = (*(a8c) - *(a0d));
        t9i = (t1i + t5i);
        t0j = (t2i + t6i);
        t1j = (t1i - t5i);
        t2j = (t2i - t6i);
        s12 = ((0.92387953251128674f*t1j) + (0.38268343236508978f*t2j));
        s22 = ((0.92387953251128674f*t2j) - (0.38268343236508978f*t1j));
        t3j = (t3i + t8i);
        t4j = (t4i - t7i);
        t5j = (t3i - t8i);
        t6j = (t4i + t7i);
        s32 = ((0.98078528040323043f*t3j) + (0.19509032201612828f*t4j));
        s42 = ((0.98078528040323043f*t4j) - (0.19509032201612828f*t3j));
        s52 = ((0.83146961230254524f*t5j) + (0.55557023301960218f*t6j));
        s62 = ((0.83146961230254524f*t6j) - (0.55557023301960218f*t5j));
        a1d = (a5b + 512);
        a2d = (a5b + 513);
        a3d = (a5b + 4608);
        a4d = (a5b + 4609);
        t7j = (*(a1d) + *(a3d));
        t8j = (*(a2d) + *(a4d));
        t9j = (*(a1d) - *(a3d));
        t0k = (*(a2d) - *(a4d));
        a5d = (a5b + 2560);
        a6d = (a5b + 2561);
        a7d = (a5b + 6656);
        a8d = (a5b + 6657);
        t1k = (*(a5d) + *(a7d));
        t2k = (*(a6d) + *(a8d));
        t3k = (*(a5d) - *(a7d));
        t4k = (*(a6d) - *(a8d));
        t5k = (t7j + t1k);
        t6k = (t8j + t2k);
        a9d = (0.70710678118654757f*(t7j - t1k));
        a0e = (0.70710678118654757f*(t8j - t2k));
        s72 = (a9d + a0e);
        s82 = (a0e - a9d);
        t7k = (t9j + t4k);
        t8k = (t0k - t3k);
        t9k = (t9j - t4k);
        t0l = (t0k + t3k);
        s92 = ((0.92387953251128674f*t7k) + (0.38268343236508978f*t8k));
        s03 = ((0.92387953251128674f*t8k) - (0.38268343236508978f*t7k));
        s13 = ((0.38268343236508978f*t9k) + (0.92387953251128674f*t0l));
        s23 = ((0.38268343236508978f*t0l) - (0.92387953251128674f*t9k));
        a1e = (a5b + 768);
        a2e = (a5b + 769);
        a3e = (a5b + 4864);
        a4e = (a5b + 4865);
        t1l = (*(a1e) + *(a3e));
        t2l = (*(a2e) + *(a4e));
        t3l = (*(a1e) - *(a3e));
        t4l = (*(a2e) - *(a4e));
        a5e = (a5b + 2816);
        a6e = (a5b + 2817);
        a7e = (a5b + 6912);
        a8e = (a5b + 6913);
        t5l = (*(a5e) + *(a7e));
        t6l = (*(a6e) + *(a8e));
        t7l = (*(a5e) - *(a7e));
        t8l = (*(a6e) - *(a8e));
        t9l = (t1l + t5l);
        t0m = (t2l + t6l);
        t1m = (t1l - t5l);
        t2m = (t2l - t6l);
        s33 = ((0.38268343236508978f*t1m) + (0.92387953251128674f*t2m));
        s43 = ((0.38268343236508978f*t2m) - (0.92387953251128674f*t1m));
        t3m = (t3l + t8l);
        t4m = (t4l - t7l);
        t5m = (t3l - t8l);
        t6m = (t4l + t7l);
        s53 = ((0.83146961230254524f*t3m) + (0.55557023301960218f*t4m));
        s63 = ((0.83146961230254524f*t4m) - (0.55557023301960218f*t3m));
        s73 = ((0.98078528040323043f*t6m) - (0.19509032201612828f*t5m));
        s83 = ((0.98078528040323043f*t5m) + (0.19509032201612828f*t6m));
        a9e = (a5b + 1024);
        a0f = (a5b + 1025);
        a1f = (a5b + 5120);
        a2f = (a5b + 5121);
        t7m = (*(a9e) + *(a1f));
        t8m = (*(a0f) + *(a2f));
        t9m = (*(a9e) - *(a1f));
        t0n = (*(a0f) - *(a2f));
        a3f = (a5b + 3072);
        a4f = (a5b + 3073);
        a5f = (a5b + 7168);
        a6f = (a5b + 7169);
        t1n = (*(a3f) + *(a5f));
        t2n = (*(a4f) + *(a6f));
        t3n = (*(a3f) - *(a5f));
        t4n = (*(a4f) - *(a6f));
        t5n = (t7m + t1n);
        t6n = (t8m + t2n);
        t7n = (t7m - t1n);
        t8n = (t8m - t2n);
        a7f = (0.70710678118654757f*(t9m + t4n));
        a8f = (0.70710678118654757f*(t0n - t3n));
        s93 = (a7f + a8f);
        s04 = (a8f - a7f);
        a9f = (0.70710678118654757f*(t0n + t3n));
        a0g = (0.70710678118654757f*(t9m - t4n));
        s14 = (a9f - a0g);
        s24 = (a0g + a9f);
        a1g = (a5b + 1280);
        a2g = (a5b + 1281);
        a3g = (a5b + 5376);
        a4g = (a5b + 5377);
        t9n = (*(a1g) + *(a3g));
        t0o = (*(a2g) + *(a4g));
        t1o = (*(a1g) - *(a3g));
        t2o = (*(a2g) - *(a4g));
        a5g = (a5b + 3328);
        a6g = (a5b + 3329);
        a7g = (a5b + 7424);
        a8g = (a5b + 7425);
        t3o = (*(a5g) + *(a7g));
        t4o = (*(a6g) + *(a8g));
        t5o = (*(a5g) - *(a7g));
        t6o = (*(a6g) - *(a8g));
        t7o = (t9n + t3o);
        t8o = (t0o + t4o);
        t9o = (t9n - t3o);
        t0p = (t0o - t4o);
        s34 = ((0.92387953251128674f*t0p) - (0.38268343236508978f*t9o));
        s44 = ((0.92387953251128674f*t9o) + (0.38268343236508978f*t0p));
        t1p = (t1o + t6o);
        t2p = (t2o - t5o);
        t3p = (t1o - t6o);
        t4p = (t2o + t5o);
        s54 = ((0.55557023301960218f*t1p) + (0.83146961230254524f*t2p));
        s64 = ((0.55557023301960218f*t2p) - (0.83146961230254524f*t1p));
        s74 = ((0.19509032201612828f*t4p) - (0.98078528040323043f*t3p));
        s84 = ((0.19509032201612828f*t3p) + (0.98078528040323043f*t4p));
        a9g = (a5b + 1536);
        a0h = (a5b + 1537);
        a1h = (a5b + 5632);
        a2h = (a5b + 5633);
        t5p = (*(a9g) + *(a1h));
        t6p = (*(a0h) + *(a2h));
        t7p = (*(a9g) - *(a1h));
        t8p = (*(a0h) - *(a2h));
        a3h = (a5b + 3584);
        a4h = (a5b + 3585);
        a5h = (a5b + 7680);
        a6h = (a5b + 7681);
        t9p = (*(a3h) + *(a5h));
        t0q = (*(a4h) + *(a6h));
        t1q = (*(a3h) - *(a5h));
        t2q = (*(a4h) - *(a6h));
        t3q = (t5p + t9p);
        t4q = (t6p + t0q);
        a7h = (0.70710678118654757f*(t6p - t0q));
        a8h = (0.70710678118654757f*(t5p - t9p));
        s94 = (a7h - a8h);
        s05 = (a8h + a7h);
        t5q = (t7p + t2q);
        t6q = (t8p - t1q);
        t7q = (t7p - t2q);
        t8q = (t8p + t1q);
        s15 = ((0.38268343236508978f*t5q) + (0.92387953251128674f*t6q));
        s25 = ((0.38268343236508978f*t6q) - (0.92387953251128674f*t5q));
        s35 = ((0.92387953251128674f*t7q) + (0.38268343236508978f*t8q));
        s45 = ((0.38268343236508978f*t7q) - (0.92387953251128674f*t8q));
        a9h = (a5b + 1792);
        a0i = (a5b + 1793);
        a1i = (a5b + 5888);
        a2i = (a5b + 5889);
        t9q = (*(a9h) + *(a1i));
        t0r = (*(a0i) + *(a2i));
        t1r = (*(a9h) - *(a1i));
        t2r = (*(a0i) - *(a2i));
        a3i = (a5b + 3840);
        a4i = (a5b + 3841);
        a5i = (a5b + 7936);
        a6i = (a5b + 7937);
        t3r = (*(a3i) + *(a5i));
        t4r = (*(a4i) + *(a6i));
        t5r = (*(a3i) - *(a5i));
        t6r = (*(a4i) - *(a6i));
        t7r = (t9q + t3r);
        t8r = (t0r + t4r);
        t9r = (t9q - t3r);
        t0s = (t0r - t4r);
        s55 = ((0.38268343236508978f*t0s) - (0.92387953251128674f*t9r));
        s65 = ((0.38268343236508978f*t9r) + (0.92387953251128674f*t0s));
        t1s = (t1r + t6r);
        t2s = (t2r - t5r);
        t3s = (t1r - t6r);
        t4s = (t2r + t5r);
        s75 = ((0.19509032201612828f*t1s) + (0.98078528040323043f*t2s));
        s85 = ((0.19509032201612828f*t2s) - (0.98078528040323043f*t1s));
        s95 = ((0.55557023301960218f*t3s) + (0.83146961230254524f*t4s));
        s06 = ((0.83146961230254524f*t3s) - (0.55557023301960218f*t4s));
        t5s = (t3h + t5n);
        t6s = (t4h + t6n);
        t7s = (t3h - t5n);
        t8s = (t4h - t6n);
        t9s = (t9i + t7o);
        t0t = (t0j + t8o);
        a7i = (0.70710678118654757f*(t9i - t7o));
        a8i = (0.70710678118654757f*(t0j - t8o));
        s16 = (a7i + a8i);
        s26 = (a8i - a7i);
        t1t = (t5k + t3q);
        t2t = (t6k + t4q);
        t3t = (t5k - t3q);
        t4t = (t6k - t4q);
        t5t = (t9l + t7r);
        t6t = (t0m + t8r);
        a9i = (0.70710678118654757f*(t0m - t8r));
        a0j = (0.70710678118654757f*(t9l - t7r));
        s36 = (a9i - a0j);
        s46 = (a0j + a9i);
        t7t = (t5s + t1t);
        t8t = (t6s + t2t);
        t9t = (t5s - t1t);
        t0u = (t6s - t2t);
        t1u = (t9s + t5t);
        t2u = (t0t + t6t);
        t3u = (t9s - t5t);
        t4u = (t0t - t6t);
        a1j = (dst + a4b);
        *(a1j) = (t7t + t1u);
        *((a1j + 1)) = (t8t + t2u);
        *((a1j + 4096)) = (t7t - t1u);
        *((a1j + 4097)) = (t8t - t2u);
        *((a1j + 2048)) = (t9t + t4u);
        *((a1j + 2049)) = (t0u - t3u);
        *((a1j + 6144)) = (t9t - t4u);
        *((a1j + 6145)) = (t0u + t3u);
        t5u = (t7s + t4t);
        t6u = (t8s - t3t);
        t7u = (t7s - t4t);
        t8u = (t8s + t3t);
        t9u = (s16 + s36);
        t0v = (s26 - s46);
        t1v = (s16 - s36);
        t2v = (s26 + s46);
        *((a1j + 1024)) = (t5u + t9u);
        *((a1j + 1025)) = (t6u + t0v);
        *((a1j + 5120)) = (t5u - t9u);
        *((a1j + 5121)) = (t6u - t0v);
        *((a1j + 3072)) = (t7u + t2v);
        *((a1j + 3073)) = (t8u - t1v);
        *((a1j + 7168)) = (t7u - t2v);
        *((a1j + 7169)) = (t8u + t1v);
        t3v = (t7h + s93);
        t4v = (t8h + s04);
        t5v = (t7h - s93);
        t6v = (t8h - s04);
        t7v = (s32 + s54);
        t8v = (s42 + s64);
        a2j = (0.70710678118654757f*(s32 - s54));
        a3j = (0.70710678118654757f*(s42 - s64));
        s56 = (a2j + a3j);
        s66 = (a3j - a2j);
        t9v = (s92 + s15);
        t0w = (s03 + s25);
        t1w = (s92 - s15);
        t2w = (s03 - s25);
        t3w = (s53 + s75);
        t4w = (s63 + s85);
        a4j = (0.70710678118654757f*(s63 - s85));
        a5j = (0.70710678118654757f*(s53 - s75));
        s76 = (a4j - a5j);
        s86 = (a5j + a4j);
        t5w = (t3v + t9v);
        t6w = (t4v + t0w);
        t7w = (t3v - t9v);
        t8w = (t4v - t0w);
        t9w = (t7v + t3w);
        t0x = (t8v + t4w);
        t1x = (t7v - t3w);
        t2x = (t8v - t4w);
        *((a1j + 256)) = (t5w + t9w);
        *((a1j + 257)) = (t6w + t0x);
        *((a1j + 4352)) = (t5w - t9w);
        *((a1j + 4353)) = (t6w - t0x);
        *((a1j + 2304)) = (t7w + t2x);
        *((a1j + 2305)) = (t8w - t1x);
        *((a1j + 6400)) = (t7w - t2x);
        *((a1j + 6401)) = (t8w + t1x);
        t3x = (t5v + t2w);
        t4x = (t6v - t1w);
        t5x = (t5v - t2w);
        t6x = (t6v + t1w);
        t7x = (s56 + s76);
        t8x = (s66 - s86);
        t9x = (s56 - s76);
        t0y = (s66 + s86);
        *((a1j + 1280)) = (t3x + t7x);
        *((a1j + 1281)) = (t4x + t8x);
        *((a1j + 5376)) = (t3x - t7x);
        *((a1j + 5377)) = (t4x - t8x);
        *((a1j + 3328)) = (t5x + t0y);
        *((a1j + 3329)) = (t6x - t9x);
        *((a1j + 7424)) = (t5x - t0y);
        *((a1j + 7425)) = (t6x + t9x);
        t1y = (t5h + t8n);
        t2y = (t6h - t7n);
        t3y = (t5h - t8n);
        t4y = (t6h + t7n);
        t5y = (s12 + s34);
        t6y = (s22 - s44);
        a6j = (0.70710678118654757f*(s12 - s34));
        a7j = (0.70710678118654757f*(s22 + s44));
        s96 = (a6j + a7j);
        s07 = (a7j - a6j);
        t7y = (s72 + s94);
        t8y = (s82 - s05);
        t9y = (s72 - s94);
        t0z = (s82 + s05);
        t1z = (s33 + s55);
        t2z = (s43 - s65);
        a8j = (0.70710678118654757f*(s43 + s65));
        a9j = (0.70710678118654757f*(s33 - s55));
        s17 = (a8j - a9j);
        s27 = (a9j + a8j);
        t3z = (t1y + t7y);
        t4z = (t2y + t8y);
        t5z = (t1y - t7y);
        t6z = (t2y - t8y);
        t7z = (t5y + t1z);
        t8z = (t6y + t2z);
        t9z = (t5y - t1z);
        t0A = (t6y - t2z);
        *((a1j + 512)) = (t3z + t7z);
        *((a1j + 513)) = (t4z + t8z);
        *((a1j + 4608)) = (t3z - t7z);
        *((a1j + 4609)) = (t4z - t8z);
        *((a1j + 2560)) = (t5z + t0A);
        *((a1j + 2561)) = (t6z - t9z);
        *((a1j + 6656)) = (t5z - t0A);
        *((a1j + 6657)) = (t6z + t9z);
        t1A = (t3y + t0z);
        t2A = (t4y - t9y);
        t3A = (t3y - t0z);
        t4A = (t4y + t9y);
        t5A = (s96 + s17);
        t6A = (s07 - s27);
        t7A = (s96 - s17);
        t8A = (s07 + s27);
        *((a1j + 1536)) = (t1A + t5A);
        *((a1j + 1537)) = (t2A + t6A);
        *((a1j + 5632)) = (t1A - t5A);
        *((a1j + 5633)) = (t2A - t6A);
        *((a1j + 3584)) = (t3A + t8A);
        *((a1j + 3585)) = (t4A - t7A);
        *((a1j + 7680)) = (t3A - t8A);
        *((a1j + 7681)) = (t4A + t7A);
        t9A = (t9h + s14);
        t0B = (t0i - s24);
        t1B = (t9h - s14);
        t2B = (t0i + s24);
        t3B = (s52 + s74);
        t4B = (s62 - s84);
        a0k = (0.70710678118654757f*(s52 - s74));
        a1k = (0.70710678118654757f*(s62 + s84));
        s37 = (a0k + a1k);
        s47 = (a1k - a0k);
        t5B = (s13 - s35);
        t6B = (s23 + s45);
        t7B = (s13 + s35);
        t8B = (s23 - s45);
        t9B = (s73 - s95);
        t0C = (s06 - s83);
        a2k = (0.70710678118654757f*(s73 + s95));
        a3k = (0.70710678118654757f*(s83 + s06));
        s57 = (a2k + a3k);
        s67 = (a3k - a2k);
        t1C = (t9A + t5B);
        t2C = (t0B + t6B);
        t3C = (t9A - t5B);
        t4C = (t0B - t6B);
        t5C = (t3B + t9B);
        t6C = (t4B + t0C);
        t7C = (t3B - t9B);
        t8C = (t4B - t0C);
        *((a1j + 768)) = (t1C + t5C);
        *((a1j + 769)) = (t2C + t6C);
        *((a1j + 4864)) = (t1C - t5C);
        *((a1j + 4865)) = (t2C - t6C);
        *((a1j + 2816)) = (t3C + t8C);
        *((a1j + 2817)) = (t4C - t7C);
        *((a1j + 6912)) = (t3C - t8C);
        *((a1j + 6913)) = (t4C + t7C);
        t9C = (t1B + t8B);
        t0D = (t2B - t7B);
        t1D = (t1B - t8B);
        t2D = (t2B + t7B);
        t3D = (s37 - s57);
        t4D = (s47 + s67);
        t5D = (s37 + s57);
        t6D = (s47 - s67);
        *((a1j + 1792)) = (t9C + t3D);
        *((a1j + 1793)) = (t0D + t4D);
        *((a1j + 5888)) = (t9C - t3D);
        *((a1j + 5889)) = (t0D - t4D);
        *((a1j + 3840)) = (t1D + t6D);
        *((a1j + 3841)) = (t2D - t5D);
        *((a1j + 7936)) = (t1D - t6D);
        *((a1j + 7937)) = (t2D + t5D);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_fftfwd_float_8192)(const float *pSrc, float *pDst ) {
    const float  *src = (const float *) pSrc; 
    float        *dst = (float *) pDst;
    
    
    { float T[16384];
     float T2[2048];
    float  *a08, *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0g, *a0h, *a0j, *a0l, *a0m, *a0o, *a0q, *a0s, *a0u, *a18, *a19, *a1a, *a1b, *a1c
            , *a1d, *a1e, *a1f, *a1g, *a1h, *a1j, *a1l, *a1m, *a1o, *a1q, *a1s, *a1u, *a1v, *a1w, *a1x, *a28, *a29, *a2a, *a2b, *a2c, *a2d, *a2e
            , *a2f, *a2g, *a2h, *a2i, *a2j, *a2k, *a2l, *a2m, *a2o, *a2q, *a2s, *a2u, *a2v, *a2w, *a38, *a39, *a3a, *a3b, *a3c, *a3d, *a3e, *a3f
            , *a3g, *a3h, *a3i, *a3j, *a3k, *a3l, *a3m, *a3n, *a3o, *a3q, *a3s, *a3u, *a3v, *a3w, *a48, *a49, *a4a, *a4b, *a4c, *a4d, *a4e, *a4f
            , *a4g, *a4h, *a4i, *a4j, *a4k, *a4l, *a4m, *a4n, *a4o, *a4p, *a4q, *a4r, *a4s, *a4t, *a4u, *a4v, *a4w, *a58, *a5a, *a5c, *a5e, *a5g
            , *a5h, *a5i, *a5j, *a5k, *a5l, *a5m, *a5n, *a5o, *a5p, *a5q, *a5r, *a5s, *a5t, *a5u, *a5v, *a5w, *a68, *a6a, *a6c, *a6e, *a6f, *a6g
            , *a6h, *a6i, *a6j, *a6k, *a6l, *a6m, *a6n, *a6o, *a6p, *a6q, *a6r, *a6s, *a6t, *a6u, *a6v, *a6w, *a78, *a7a, *a7c, *a7e, *a7f, *a7g
            , *a7h, *a7i, *a7j, *a7k, *a7l, *a7m, *a7n, *a7o, *a7p, *a7q, *a7r, *a7s, *a7t, *a7u, *a7v, *a7w, *a87, *a88, *a8a, *a8c, *a8e, *a8f
            , *a8g, *a8h, *a8i, *a8k, *a8n, *a8o, *a8p, *a8q, *a8r, *a8s, *a8t, *a8u, *a8v, *a8w, *a97, *a98, *a99, *a9a, *a9b, *a9c, *a9d, *a9e
            , *a9f, *a9g, *a9h, *a9i, *a9k, *a9n, *a9o, *a9p, *a9q, *a9r, *a9s, *a9t, *a9u;
    const float  *a, *a01, *a02, *a03, *a04, *a05, *a06, *a07, *a11, *a12, *a13, *a14, *a15, *a16, *a17, *a2, *a21, *a22, *a23, *a24, *a25, *a26
            , *a27, *a3, *a31, *a32, *a33, *a35, *a4, *a41, *a42, *a43, *a45, *a5, *a51, *a53, *a55, *a56, *a6, *a61, *a63, *a65, *a66, *a7
            , *a71, *a72, *a73, *a74, *a75, *a76, *a8, *a81, *a82, *a83, *a84, *a85, *a86, *a9, *a91, *a92, *a93, *a94, *a95, *a96;
    int a0v, a2n, a5f, a77;
    float a0i, a0k, a0n, a0p, a0r, a0t, a0w, a0x, a1i, a1k, a1n, a1p, a1r, a1t, a2p, a2r, a2t, a34, a36, a37, a3p, a3r
            , a3t, a44, a46, a47, a52, a54, a57, a59, a5b, a5d, a62, a64, a67, a69, a6b, a6d, a79, a7b, a7d, a89, a8b, a8d
            , a8j, a8l, a8m, a9j, a9l, a9m, a9v, a9w, s, s01, s02, s03, s04, s05, s06, s07, s08, s09, s0a, s0b, s11, s12
            , s13, s14, s15, s16, s17, s18, s19, s1a, s1b, s2, s21, s22, s23, s24, s25, s26, s27, s28, s29, s2a, s2b, s3
            , s31, s32, s33, s34, s35, s36, s37, s38, s39, s3a, s3b, s4, s41, s42, s43, s44, s45, s46, s47, s48, s49, s4a
            , s4b, s5, s51, s52, s53, s54, s55, s56, s57, s58, s59, s5a, s5b, s6, s61, s62, s63, s64, s65, s66, s67, s68
            , s69, s6a, s6b, s7, s71, s72, s73, s74, s75, s76, s77, s78, s79, s7a, s8, s81, s82, s83, s84, s85, s86, s87
            , s88, s89, s8a, s9, s91, s92, s93, s94, s95, s96, s97, s98, s99, s9a, t, t01, t010, t02, t03, t04, t05, t06
            , t07, t08, t09, t0A, t0B, t0C, t0D, t0E, t0F, t0G, t0H, t0I, t0J, t0K, t0L, t0M, t0N, t0O, t0P, t0Q, t0R, t0S
            , t0T, t0U, t0V, t0W, t0X, t0Y, t0Z, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o
            , t0p, t0q, t0r, t0s, t0t, t0u, t0v, t0w, t0x, t0y, t0z, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1A, t1B
            , t1C, t1D, t1E, t1F, t1G, t1H, t1I, t1J, t1K, t1L, t1M, t1N, t1O, t1P, t1Q, t1R, t1S, t1T, t1U, t1V, t1W, t1X
            , t1Y, t1Z, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t
            , t1u, t1v, t1w, t1x, t1y, t1z, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2A, t2B, t2C, t2D, t2E, t2F
            , t2G, t2H, t2I, t2J, t2K, t2L, t2M, t2N, t2O, t2P, t2Q, t2R, t2S, t2T, t2U, t2V, t2W, t2X, t2Y, t2Z, t2a, t2b
            , t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p, t2q, t2r, t2s, t2t, t2u, t2v, t2w, t2x
            , t2y, t2z, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3A, t3B, t3C, t3D, t3E, t3F, t3G, t3H, t3I, t3J
            , t3K, t3L, t3M, t3N, t3O, t3P, t3Q, t3R, t3S, t3T, t3U, t3V, t3W, t3X, t3Y, t3Z, t3a, t3b, t3c, t3d, t3e, t3f
            , t3g, t3h, t3i, t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s, t3t, t3u, t3v, t3w, t3x, t3y, t3z, t4, t41
            , t42, t43, t44, t45, t46, t47, t48, t49, t4A, t4B, t4C, t4D, t4E, t4F, t4G, t4H, t4I, t4J, t4K, t4L, t4M, t4N
            , t4O, t4P, t4Q, t4R, t4S, t4T, t4U, t4V, t4W, t4X, t4Y, t4Z, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j
            , t4k, t4l, t4m, t4n, t4o, t4p, t4q, t4r, t4s, t4t, t4u, t4v, t4w, t4x, t4y, t4z, t5, t51, t52, t53, t54, t55
            , t56, t57, t58, t59, t5A, t5B, t5C, t5D, t5E, t5F, t5G, t5H, t5I, t5J, t5K, t5L, t5M, t5N, t5O, t5P, t5Q, t5R
            , t5S, t5T, t5U, t5V, t5W, t5X, t5Y, t5Z, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n
            , t5o, t5p, t5q, t5r, t5s, t5t, t5u, t5v, t5w, t5x, t5y, t5z, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69
            , t6A, t6B, t6C, t6D, t6E, t6F, t6G, t6H, t6I, t6J, t6K, t6L, t6M, t6N, t6O, t6P, t6Q, t6R, t6S, t6T, t6U, t6V
            , t6W, t6X, t6Y, t6Z, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r
            , t6s, t6t, t6u, t6v, t6w, t6x, t6y, t6z, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7A, t7B, t7C, t7D
            , t7E, t7F, t7G, t7H, t7I, t7J, t7K, t7L, t7M, t7N, t7O, t7P, t7Q, t7R, t7S, t7T, t7U, t7V, t7W, t7X, t7Y, t7Z
            , t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m, t7n, t7o, t7p, t7q, t7r, t7s, t7t, t7u, t7v
            , t7w, t7x, t7y, t7z, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8A, t8B, t8C, t8D, t8E, t8F, t8G, t8H
            , t8I, t8J, t8K, t8L, t8M, t8N, t8O, t8P, t8Q, t8R, t8S, t8T, t8U, t8V, t8W, t8X, t8Y, t8Z, t8a, t8b, t8c, t8d
            , t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p, t8q, t8r, t8s, t8t, t8u, t8v, t8w, t8x, t8y, t8z
            , t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9A, t9B, t9C, t9D, t9E, t9F, t9G, t9H, t9I, t9J, t9K, t9L
            , t9M, t9N, t9O, t9P, t9Q, t9R, t9S, t9T, t9U, t9V, t9W, t9X, t9Y, t9Z, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h
            , t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p, t9q, t9r, t9s, t9t, t9u, t9v, t9w, t9x, t9y, t9z;
    {long i; for(i = 0; i <= 7; i++) {
        {long i2; for(i2 = 0; i2 <= 31; i2++) {
            a = (src + (2*i) + (16*i2));
            a2 = (a + 1);
            a3 = (a + 8192);
            a4 = (a + 8193);
            t = (*(a) + *(a3));
            t2 = (*(a2) + *(a4));
            t3 = (*(a) - *(a3));
            t4 = (*(a2) - *(a4));
            a5 = (a + 4096);
            a6 = (a + 4097);
            a7 = (a + 12288);
            a8 = (a + 12289);
            t5 = (*(a5) + *(a7));
            t6 = (*(a6) + *(a8));
            t7 = (*(a5) - *(a7));
            t8 = (*(a6) - *(a8));
            t9 = (t + t5);
            t01 = (t2 + t6);
            t11 = (t - t5);
            t21 = (t2 - t6);
            t31 = (t3 + t8);
            t41 = (t4 - t7);
            t51 = (t3 - t8);
            t61 = (t4 + t7);
            a9 = (a + 512);
            a01 = (a + 513);
            a11 = (a + 8704);
            a21 = (a + 8705);
            t71 = (*(a9) + *(a11));
            t81 = (*(a01) + *(a21));
            t91 = (*(a9) - *(a11));
            t02 = (*(a01) - *(a21));
            a31 = (a + 4608);
            a41 = (a + 4609);
            a51 = (a + 12800);
            a61 = (a + 12801);
            t12 = (*(a31) + *(a51));
            t22 = (*(a41) + *(a61));
            t32 = (*(a31) - *(a51));
            t42 = (*(a41) - *(a61));
            t52 = (t71 + t12);
            t62 = (t81 + t22);
            t72 = (t71 - t12);
            t82 = (t81 - t22);
            s = ((0.92387953251128674f*t72) + (0.38268343236508978f*t82));
            s2 = ((0.92387953251128674f*t82) - (0.38268343236508978f*t72));
            t92 = (t91 + t42);
            t03 = (t02 - t32);
            t13 = (t91 - t42);
            t23 = (t02 + t32);
            s3 = ((0.98078528040323043f*t92) + (0.19509032201612828f*t03));
            s4 = ((0.98078528040323043f*t03) - (0.19509032201612828f*t92));
            s5 = ((0.83146961230254524f*t13) + (0.55557023301960218f*t23));
            s6 = ((0.83146961230254524f*t23) - (0.55557023301960218f*t13));
            a71 = (a + 1024);
            a81 = (a + 1025);
            a91 = (a + 9216);
            a02 = (a + 9217);
            t33 = (*(a71) + *(a91));
            t43 = (*(a81) + *(a02));
            t53 = (*(a71) - *(a91));
            t63 = (*(a81) - *(a02));
            a12 = (a + 5120);
            a22 = (a + 5121);
            a32 = (a + 13312);
            a42 = (a + 13313);
            t73 = (*(a12) + *(a32));
            t83 = (*(a22) + *(a42));
            t93 = (*(a12) - *(a32));
            t04 = (*(a22) - *(a42));
            t14 = (t33 + t73);
            t24 = (t43 + t83);
            a52 = (0.70710678118654757f*(t33 - t73));
            a62 = (0.70710678118654757f*(t43 - t83));
            s7 = (a52 + a62);
            s8 = (a62 - a52);
            t34 = (t53 + t04);
            t44 = (t63 - t93);
            t54 = (t53 - t04);
            t64 = (t63 + t93);
            s9 = ((0.92387953251128674f*t34) + (0.38268343236508978f*t44));
            s01 = ((0.92387953251128674f*t44) - (0.38268343236508978f*t34));
            s11 = ((0.38268343236508978f*t54) + (0.92387953251128674f*t64));
            s21 = ((0.38268343236508978f*t64) - (0.92387953251128674f*t54));
            a72 = (a + 1536);
            a82 = (a + 1537);
            a92 = (a + 9728);
            a03 = (a + 9729);
            t74 = (*(a72) + *(a92));
            t84 = (*(a82) + *(a03));
            t94 = (*(a72) - *(a92));
            t05 = (*(a82) - *(a03));
            a13 = (a + 5632);
            a23 = (a + 5633);
            a33 = (a + 13824);
            a43 = (a + 13825);
            t15 = (*(a13) + *(a33));
            t25 = (*(a23) + *(a43));
            t35 = (*(a13) - *(a33));
            t45 = (*(a23) - *(a43));
            t55 = (t74 + t15);
            t65 = (t84 + t25);
            t75 = (t74 - t15);
            t85 = (t84 - t25);
            s31 = ((0.38268343236508978f*t75) + (0.92387953251128674f*t85));
            s41 = ((0.38268343236508978f*t85) - (0.92387953251128674f*t75));
            t95 = (t94 + t45);
            t06 = (t05 - t35);
            t16 = (t94 - t45);
            t26 = (t05 + t35);
            s51 = ((0.83146961230254524f*t95) + (0.55557023301960218f*t06));
            s61 = ((0.83146961230254524f*t06) - (0.55557023301960218f*t95));
            s71 = ((0.98078528040323043f*t26) - (0.19509032201612828f*t16));
            s81 = ((0.98078528040323043f*t16) + (0.19509032201612828f*t26));
            a53 = (a + 2048);
            a63 = (a + 2049);
            a73 = (a + 10240);
            a83 = (a + 10241);
            t36 = (*(a53) + *(a73));
            t46 = (*(a63) + *(a83));
            t56 = (*(a53) - *(a73));
            t66 = (*(a63) - *(a83));
            a93 = (a + 6144);
            a04 = (a + 6145);
            a14 = (a + 14336);
            a24 = (a + 14337);
            t76 = (*(a93) + *(a14));
            t86 = (*(a04) + *(a24));
            t96 = (*(a93) - *(a14));
            t07 = (*(a04) - *(a24));
            t17 = (t36 + t76);
            t27 = (t46 + t86);
            t37 = (t36 - t76);
            t47 = (t46 - t86);
            a34 = (0.70710678118654757f*(t56 + t07));
            a44 = (0.70710678118654757f*(t66 - t96));
            s91 = (a34 + a44);
            s02 = (a44 - a34);
            a54 = (0.70710678118654757f*(t66 + t96));
            a64 = (0.70710678118654757f*(t56 - t07));
            s12 = (a54 - a64);
            s22 = (a64 + a54);
            a74 = (a + 2560);
            a84 = (a + 2561);
            a94 = (a + 10752);
            a05 = (a + 10753);
            t57 = (*(a74) + *(a94));
            t67 = (*(a84) + *(a05));
            t77 = (*(a74) - *(a94));
            t87 = (*(a84) - *(a05));
            a15 = (a + 6656);
            a25 = (a + 6657);
            a35 = (a + 14848);
            a45 = (a + 14849);
            t97 = (*(a15) + *(a35));
            t08 = (*(a25) + *(a45));
            t18 = (*(a15) - *(a35));
            t28 = (*(a25) - *(a45));
            t38 = (t57 + t97);
            t48 = (t67 + t08);
            t58 = (t57 - t97);
            t68 = (t67 - t08);
            s32 = ((0.92387953251128674f*t68) - (0.38268343236508978f*t58));
            s42 = ((0.92387953251128674f*t58) + (0.38268343236508978f*t68));
            t78 = (t77 + t28);
            t88 = (t87 - t18);
            t98 = (t77 - t28);
            t09 = (t87 + t18);
            s52 = ((0.55557023301960218f*t78) + (0.83146961230254524f*t88));
            s62 = ((0.55557023301960218f*t88) - (0.83146961230254524f*t78));
            s72 = ((0.19509032201612828f*t09) - (0.98078528040323043f*t98));
            s82 = ((0.19509032201612828f*t98) + (0.98078528040323043f*t09));
            a55 = (a + 3072);
            a65 = (a + 3073);
            a75 = (a + 11264);
            a85 = (a + 11265);
            t19 = (*(a55) + *(a75));
            t29 = (*(a65) + *(a85));
            t39 = (*(a55) - *(a75));
            t49 = (*(a65) - *(a85));
            a95 = (a + 7168);
            a06 = (a + 7169);
            a16 = (a + 15360);
            a26 = (a + 15361);
            t59 = (*(a95) + *(a16));
            t69 = (*(a06) + *(a26));
            t79 = (*(a95) - *(a16));
            t89 = (*(a06) - *(a26));
            t99 = (t19 + t59);
            t0a = (t29 + t69);
            a36 = (0.70710678118654757f*(t29 - t69));
            a46 = (0.70710678118654757f*(t19 - t59));
            s92 = (a36 - a46);
            s03 = (a46 + a36);
            t1a = (t39 + t89);
            t2a = (t49 - t79);
            t3a = (t39 - t89);
            t4a = (t49 + t79);
            s13 = ((0.38268343236508978f*t1a) + (0.92387953251128674f*t2a));
            s23 = ((0.38268343236508978f*t2a) - (0.92387953251128674f*t1a));
            s33 = ((0.92387953251128674f*t3a) + (0.38268343236508978f*t4a));
            s43 = ((0.38268343236508978f*t3a) - (0.92387953251128674f*t4a));
            a56 = (a + 3584);
            a66 = (a + 3585);
            a76 = (a + 11776);
            a86 = (a + 11777);
            t5a = (*(a56) + *(a76));
            t6a = (*(a66) + *(a86));
            t7a = (*(a56) - *(a76));
            t8a = (*(a66) - *(a86));
            a96 = (a + 7680);
            a07 = (a + 7681);
            a17 = (a + 15872);
            a27 = (a + 15873);
            t9a = (*(a96) + *(a17));
            t0b = (*(a07) + *(a27));
            t1b = (*(a96) - *(a17));
            t2b = (*(a07) - *(a27));
            t3b = (t5a + t9a);
            t4b = (t6a + t0b);
            t5b = (t5a - t9a);
            t6b = (t6a - t0b);
            s53 = ((0.38268343236508978f*t6b) - (0.92387953251128674f*t5b));
            s63 = ((0.38268343236508978f*t5b) + (0.92387953251128674f*t6b));
            t7b = (t7a + t2b);
            t8b = (t8a - t1b);
            t9b = (t7a - t2b);
            t0c = (t8a + t1b);
            s73 = ((0.19509032201612828f*t7b) + (0.98078528040323043f*t8b));
            s83 = ((0.19509032201612828f*t8b) - (0.98078528040323043f*t7b));
            s93 = ((0.55557023301960218f*t9b) + (0.83146961230254524f*t0c));
            s04 = ((0.83146961230254524f*t9b) - (0.55557023301960218f*t0c));
            t1c = (t9 + t17);
            t2c = (t01 + t27);
            t3c = (t9 - t17);
            t4c = (t01 - t27);
            t5c = (t52 + t38);
            t6c = (t62 + t48);
            a37 = (0.70710678118654757f*(t52 - t38));
            a47 = (0.70710678118654757f*(t62 - t48));
            s14 = (a37 + a47);
            s24 = (a47 - a37);
            t7c = (t14 + t99);
            t8c = (t24 + t0a);
            t9c = (t14 - t99);
            t0d = (t24 - t0a);
            t1d = (t55 + t3b);
            t2d = (t65 + t4b);
            a57 = (0.70710678118654757f*(t65 - t4b));
            a67 = (0.70710678118654757f*(t55 - t3b));
            s34 = (a57 - a67);
            s44 = (a67 + a57);
            t3d = (t1c + t7c);
            t4d = (t2c + t8c);
            t5d = (t1c - t7c);
            t6d = (t2c - t8c);
            t7d = (t5c + t1d);
            t8d = (t6c + t2d);
            t9d = (t5c - t1d);
            t0e = (t6c - t2d);
            t1e = (t3d + t7d);
            t2e = (t4d + t8d);
            t3e = (t3d - t7d);
            t4e = (t4d - t8d);
            a77 = (64*i2);
            a87 = (D279 + a77);
            a97 = (a87 + 1);
            a08 = (a87 + 2);
            a18 = (a87 + 3);
            a28 = (T2 + a77);
            *(a28) = ((*(a87)*t1e) - (*(a97)*t2e));
            *((a28 + 1)) = ((*(a97)*t1e) + (*(a87)*t2e));
            *((a28 + 32)) = ((*(a08)*t3e) - (*(a18)*t4e));
            *((a28 + 33)) = ((*(a18)*t3e) + (*(a08)*t4e));
            t5e = (t5d + t0e);
            t6e = (t6d - t9d);
            t7e = (t5d - t0e);
            t8e = (t6d + t9d);
            a38 = (a87 + 4);
            a48 = (a87 + 5);
            a58 = (a87 + 6);
            a68 = (a87 + 7);
            *((a28 + 16)) = ((*(a38)*t5e) - (*(a48)*t6e));
            *((a28 + 17)) = ((*(a48)*t5e) + (*(a38)*t6e));
            *((a28 + 48)) = ((*(a58)*t7e) - (*(a68)*t8e));
            *((a28 + 49)) = ((*(a68)*t7e) + (*(a58)*t8e));
            t9e = (t3c + t0d);
            t0f = (t4c - t9c);
            t1f = (t3c - t0d);
            t2f = (t4c + t9c);
            t3f = (s14 + s34);
            t4f = (s24 - s44);
            t5f = (s14 - s34);
            t6f = (s24 + s44);
            t7f = (t9e + t3f);
            t8f = (t0f + t4f);
            t9f = (t9e - t3f);
            t0g = (t0f - t4f);
            a78 = (a87 + 8);
            a88 = (a87 + 9);
            a98 = (a87 + 10);
            a09 = (a87 + 11);
            *((a28 + 8)) = ((*(a78)*t7f) - (*(a88)*t8f));
            *((a28 + 9)) = ((*(a88)*t7f) + (*(a78)*t8f));
            *((a28 + 40)) = ((*(a98)*t9f) - (*(a09)*t0g));
            *((a28 + 41)) = ((*(a09)*t9f) + (*(a98)*t0g));
            t1g = (t1f + t6f);
            t2g = (t2f - t5f);
            t3g = (t1f - t6f);
            t4g = (t2f + t5f);
            a19 = (a87 + 12);
            a29 = (a87 + 13);
            a39 = (a87 + 14);
            a49 = (a87 + 15);
            *((a28 + 24)) = ((*(a19)*t1g) - (*(a29)*t2g));
            *((a28 + 25)) = ((*(a29)*t1g) + (*(a19)*t2g));
            *((a28 + 56)) = ((*(a39)*t3g) - (*(a49)*t4g));
            *((a28 + 57)) = ((*(a49)*t3g) + (*(a39)*t4g));
            t5g = (t31 + s91);
            t6g = (t41 + s02);
            t7g = (t31 - s91);
            t8g = (t41 - s02);
            t9g = (s3 + s52);
            t0h = (s4 + s62);
            a59 = (0.70710678118654757f*(s3 - s52));
            a69 = (0.70710678118654757f*(s4 - s62));
            s54 = (a59 + a69);
            s64 = (a69 - a59);
            t1h = (s9 + s13);
            t2h = (s01 + s23);
            t3h = (s9 - s13);
            t4h = (s01 - s23);
            t5h = (s51 + s73);
            t6h = (s61 + s83);
            a79 = (0.70710678118654757f*(s61 - s83));
            a89 = (0.70710678118654757f*(s51 - s73));
            s74 = (a79 - a89);
            s84 = (a89 + a79);
            t7h = (t5g + t1h);
            t8h = (t6g + t2h);
            t9h = (t5g - t1h);
            t0i = (t6g - t2h);
            t1i = (t9g + t5h);
            t2i = (t0h + t6h);
            t3i = (t9g - t5h);
            t4i = (t0h - t6h);
            t5i = (t7h + t1i);
            t6i = (t8h + t2i);
            t7i = (t7h - t1i);
            t8i = (t8h - t2i);
            a99 = (a87 + 16);
            a0a = (a87 + 17);
            a1a = (a87 + 18);
            a2a = (a87 + 19);
            *((a28 + 2)) = ((*(a99)*t5i) - (*(a0a)*t6i));
            *((a28 + 3)) = ((*(a0a)*t5i) + (*(a99)*t6i));
            *((a28 + 34)) = ((*(a1a)*t7i) - (*(a2a)*t8i));
            *((a28 + 35)) = ((*(a2a)*t7i) + (*(a1a)*t8i));
            t9i = (t9h + t4i);
            t0j = (t0i - t3i);
            t1j = (t9h - t4i);
            t2j = (t0i + t3i);
            a3a = (a87 + 20);
            a4a = (a87 + 21);
            a5a = (a87 + 22);
            a6a = (a87 + 23);
            *((a28 + 18)) = ((*(a3a)*t9i) - (*(a4a)*t0j));
            *((a28 + 19)) = ((*(a4a)*t9i) + (*(a3a)*t0j));
            *((a28 + 50)) = ((*(a5a)*t1j) - (*(a6a)*t2j));
            *((a28 + 51)) = ((*(a6a)*t1j) + (*(a5a)*t2j));
            t3j = (t7g + t4h);
            t4j = (t8g - t3h);
            t5j = (t7g - t4h);
            t6j = (t8g + t3h);
            t7j = (s54 + s74);
            t8j = (s64 - s84);
            t9j = (s54 - s74);
            t0k = (s64 + s84);
            t1k = (t3j + t7j);
            t2k = (t4j + t8j);
            t3k = (t3j - t7j);
            t4k = (t4j - t8j);
            a7a = (a87 + 24);
            a8a = (a87 + 25);
            a9a = (a87 + 26);
            a0b = (a87 + 27);
            *((a28 + 10)) = ((*(a7a)*t1k) - (*(a8a)*t2k));
            *((a28 + 11)) = ((*(a8a)*t1k) + (*(a7a)*t2k));
            *((a28 + 42)) = ((*(a9a)*t3k) - (*(a0b)*t4k));
            *((a28 + 43)) = ((*(a0b)*t3k) + (*(a9a)*t4k));
            t5k = (t5j + t0k);
            t6k = (t6j - t9j);
            t7k = (t5j - t0k);
            t8k = (t6j + t9j);
            a1b = (a87 + 28);
            a2b = (a87 + 29);
            a3b = (a87 + 30);
            a4b = (a87 + 31);
            *((a28 + 26)) = ((*(a1b)*t5k) - (*(a2b)*t6k));
            *((a28 + 27)) = ((*(a2b)*t5k) + (*(a1b)*t6k));
            *((a28 + 58)) = ((*(a3b)*t7k) - (*(a4b)*t8k));
            *((a28 + 59)) = ((*(a4b)*t7k) + (*(a3b)*t8k));
            t9k = (t11 + t47);
            t0l = (t21 - t37);
            t1l = (t11 - t47);
            t2l = (t21 + t37);
            t3l = (s + s32);
            t4l = (s2 - s42);
            a5b = (0.70710678118654757f*(s - s32));
            a6b = (0.70710678118654757f*(s2 + s42));
            s94 = (a5b + a6b);
            s05 = (a6b - a5b);
            t5l = (s7 + s92);
            t6l = (s8 - s03);
            t7l = (s7 - s92);
            t8l = (s8 + s03);
            t9l = (s31 + s53);
            t0m = (s41 - s63);
            a7b = (0.70710678118654757f*(s41 + s63));
            a8b = (0.70710678118654757f*(s31 - s53));
            s15 = (a7b - a8b);
            s25 = (a8b + a7b);
            t1m = (t9k + t5l);
            t2m = (t0l + t6l);
            t3m = (t9k - t5l);
            t4m = (t0l - t6l);
            t5m = (t3l + t9l);
            t6m = (t4l + t0m);
            t7m = (t3l - t9l);
            t8m = (t4l - t0m);
            t9m = (t1m + t5m);
            t0n = (t2m + t6m);
            t1n = (t1m - t5m);
            t2n = (t2m - t6m);
            a9b = (a87 + 32);
            a0c = (a87 + 33);
            a1c = (a87 + 34);
            a2c = (a87 + 35);
            *((a28 + 4)) = ((*(a9b)*t9m) - (*(a0c)*t0n));
            *((a28 + 5)) = ((*(a0c)*t9m) + (*(a9b)*t0n));
            *((a28 + 36)) = ((*(a1c)*t1n) - (*(a2c)*t2n));
            *((a28 + 37)) = ((*(a2c)*t1n) + (*(a1c)*t2n));
            t3n = (t3m + t8m);
            t4n = (t4m - t7m);
            t5n = (t3m - t8m);
            t6n = (t4m + t7m);
            a3c = (a87 + 36);
            a4c = (a87 + 37);
            a5c = (a87 + 38);
            a6c = (a87 + 39);
            *((a28 + 20)) = ((*(a3c)*t3n) - (*(a4c)*t4n));
            *((a28 + 21)) = ((*(a4c)*t3n) + (*(a3c)*t4n));
            *((a28 + 52)) = ((*(a5c)*t5n) - (*(a6c)*t6n));
            *((a28 + 53)) = ((*(a6c)*t5n) + (*(a5c)*t6n));
            t7n = (t1l + t8l);
            t8n = (t2l - t7l);
            t9n = (t1l - t8l);
            t0o = (t2l + t7l);
            t1o = (s94 + s15);
            t2o = (s05 - s25);
            t3o = (s94 - s15);
            t4o = (s05 + s25);
            t5o = (t7n + t1o);
            t6o = (t8n + t2o);
            t7o = (t7n - t1o);
            t8o = (t8n - t2o);
            a7c = (a87 + 40);
            a8c = (a87 + 41);
            a9c = (a87 + 42);
            a0d = (a87 + 43);
            *((a28 + 12)) = ((*(a7c)*t5o) - (*(a8c)*t6o));
            *((a28 + 13)) = ((*(a8c)*t5o) + (*(a7c)*t6o));
            *((a28 + 44)) = ((*(a9c)*t7o) - (*(a0d)*t8o));
            *((a28 + 45)) = ((*(a0d)*t7o) + (*(a9c)*t8o));
            t9o = (t9n + t4o);
            t0p = (t0o - t3o);
            t1p = (t9n - t4o);
            t2p = (t0o + t3o);
            a1d = (a87 + 44);
            a2d = (a87 + 45);
            a3d = (a87 + 46);
            a4d = (a87 + 47);
            *((a28 + 28)) = ((*(a1d)*t9o) - (*(a2d)*t0p));
            *((a28 + 29)) = ((*(a2d)*t9o) + (*(a1d)*t0p));
            *((a28 + 60)) = ((*(a3d)*t1p) - (*(a4d)*t2p));
            *((a28 + 61)) = ((*(a4d)*t1p) + (*(a3d)*t2p));
            t3p = (t51 + s12);
            t4p = (t61 - s22);
            t5p = (t51 - s12);
            t6p = (t61 + s22);
            t7p = (s5 + s72);
            t8p = (s6 - s82);
            a5d = (0.70710678118654757f*(s5 - s72));
            a6d = (0.70710678118654757f*(s6 + s82));
            s35 = (a5d + a6d);
            s45 = (a6d - a5d);
            t9p = (s11 - s33);
            t0q = (s21 + s43);
            t1q = (s11 + s33);
            t2q = (s21 - s43);
            t3q = (s71 - s93);
            t4q = (s04 - s81);
            a7d = (0.70710678118654757f*(s71 + s93));
            a8d = (0.70710678118654757f*(s81 + s04));
            s55 = (a7d + a8d);
            s65 = (a8d - a7d);
            t5q = (t3p + t9p);
            t6q = (t4p + t0q);
            t7q = (t3p - t9p);
            t8q = (t4p - t0q);
            t9q = (t7p + t3q);
            t0r = (t8p + t4q);
            t1r = (t7p - t3q);
            t2r = (t8p - t4q);
            t3r = (t5q + t9q);
            t4r = (t6q + t0r);
            t5r = (t5q - t9q);
            t6r = (t6q - t0r);
            a9d = (a87 + 48);
            a0e = (a87 + 49);
            a1e = (a87 + 50);
            a2e = (a87 + 51);
            *((a28 + 6)) = ((*(a9d)*t3r) - (*(a0e)*t4r));
            *((a28 + 7)) = ((*(a0e)*t3r) + (*(a9d)*t4r));
            *((a28 + 38)) = ((*(a1e)*t5r) - (*(a2e)*t6r));
            *((a28 + 39)) = ((*(a2e)*t5r) + (*(a1e)*t6r));
            t7r = (t7q + t2r);
            t8r = (t8q - t1r);
            t9r = (t7q - t2r);
            t0s = (t8q + t1r);
            a3e = (a87 + 52);
            a4e = (a87 + 53);
            a5e = (a87 + 54);
            a6e = (a87 + 55);
            *((a28 + 22)) = ((*(a3e)*t7r) - (*(a4e)*t8r));
            *((a28 + 23)) = ((*(a4e)*t7r) + (*(a3e)*t8r));
            *((a28 + 54)) = ((*(a5e)*t9r) - (*(a6e)*t0s));
            *((a28 + 55)) = ((*(a6e)*t9r) + (*(a5e)*t0s));
            t1s = (t5p + t2q);
            t2s = (t6p - t1q);
            t3s = (t5p - t2q);
            t4s = (t6p + t1q);
            t5s = (s35 - s55);
            t6s = (s45 + s65);
            t7s = (s35 + s55);
            t8s = (s45 - s65);
            t9s = (t1s + t5s);
            t0t = (t2s + t6s);
            t1t = (t1s - t5s);
            t2t = (t2s - t6s);
            a7e = (a87 + 56);
            a8e = (a87 + 57);
            a9e = (a87 + 58);
            a0f = (a87 + 59);
            *((a28 + 14)) = ((*(a7e)*t9s) - (*(a8e)*t0t));
            *((a28 + 15)) = ((*(a8e)*t9s) + (*(a7e)*t0t));
            *((a28 + 46)) = ((*(a9e)*t1t) - (*(a0f)*t2t));
            *((a28 + 47)) = ((*(a0f)*t1t) + (*(a9e)*t2t));
            t3t = (t3s + t8s);
            t4t = (t4s - t7s);
            t5t = (t3s - t8s);
            t6t = (t4s + t7s);
            a1f = (a87 + 60);
            a2f = (a87 + 61);
            a3f = (a87 + 62);
            a4f = (a87 + 63);
            *((a28 + 30)) = ((*(a1f)*t3t) - (*(a2f)*t4t));
            *((a28 + 31)) = ((*(a2f)*t3t) + (*(a1f)*t4t));
            *((a28 + 62)) = ((*(a3f)*t5t) - (*(a4f)*t6t));
            *((a28 + 63)) = ((*(a4f)*t5t) + (*(a3f)*t6t));
        }}
        {long i3; for(i3 = 0; i3 <= 31; i3++) {
            a5f = (2*i3);
            a6f = (T2 + a5f);
            a7f = (a6f + 1);
            a8f = (a6f + 1024);
            a9f = (a6f + 1025);
            t7t = (*(a6f) + *(a8f));
            t8t = (*(a7f) + *(a9f));
            t9t = (*(a6f) - *(a8f));
            t0u = (*(a7f) - *(a9f));
            a0g = (a6f + 512);
            a1g = (a6f + 513);
            a2g = (a6f + 1536);
            a3g = (a6f + 1537);
            t1u = (*(a0g) + *(a2g));
            t2u = (*(a1g) + *(a3g));
            t3u = (*(a0g) - *(a2g));
            t4u = (*(a1g) - *(a3g));
            t5u = (t7t + t1u);
            t6u = (t8t + t2u);
            t7u = (t7t - t1u);
            t8u = (t8t - t2u);
            t9u = (t9t + t4u);
            t0v = (t0u - t3u);
            t1v = (t9t - t4u);
            t2v = (t0u + t3u);
            a4g = (a6f + 64);
            a5g = (a6f + 65);
            a6g = (a6f + 1088);
            a7g = (a6f + 1089);
            t3v = (*(a4g) + *(a6g));
            t4v = (*(a5g) + *(a7g));
            t5v = (*(a4g) - *(a6g));
            t6v = (*(a5g) - *(a7g));
            a8g = (a6f + 576);
            a9g = (a6f + 577);
            a0h = (a6f + 1600);
            a1h = (a6f + 1601);
            t7v = (*(a8g) + *(a0h));
            t8v = (*(a9g) + *(a1h));
            t9v = (*(a8g) - *(a0h));
            t0w = (*(a9g) - *(a1h));
            t1w = (t3v + t7v);
            t2w = (t4v + t8v);
            t3w = (t3v - t7v);
            t4w = (t4v - t8v);
            s75 = ((0.92387953251128674f*t3w) + (0.38268343236508978f*t4w));
            s85 = ((0.92387953251128674f*t4w) - (0.38268343236508978f*t3w));
            t5w = (t5v + t0w);
            t6w = (t6v - t9v);
            t7w = (t5v - t0w);
            t8w = (t6v + t9v);
            s95 = ((0.98078528040323043f*t5w) + (0.19509032201612828f*t6w));
            s06 = ((0.98078528040323043f*t6w) - (0.19509032201612828f*t5w));
            s16 = ((0.83146961230254524f*t7w) + (0.55557023301960218f*t8w));
            s26 = ((0.83146961230254524f*t8w) - (0.55557023301960218f*t7w));
            a2h = (a6f + 128);
            a3h = (a6f + 129);
            a4h = (a6f + 1152);
            a5h = (a6f + 1153);
            t9w = (*(a2h) + *(a4h));
            t0x = (*(a3h) + *(a5h));
            t1x = (*(a2h) - *(a4h));
            t2x = (*(a3h) - *(a5h));
            a6h = (a6f + 640);
            a7h = (a6f + 641);
            a8h = (a6f + 1664);
            a9h = (a6f + 1665);
            t3x = (*(a6h) + *(a8h));
            t4x = (*(a7h) + *(a9h));
            t5x = (*(a6h) - *(a8h));
            t6x = (*(a7h) - *(a9h));
            t7x = (t9w + t3x);
            t8x = (t0x + t4x);
            a0i = (0.70710678118654757f*(t9w - t3x));
            a1i = (0.70710678118654757f*(t0x - t4x));
            s36 = (a0i + a1i);
            s46 = (a1i - a0i);
            t9x = (t1x + t6x);
            t0y = (t2x - t5x);
            t1y = (t1x - t6x);
            t2y = (t2x + t5x);
            s56 = ((0.92387953251128674f*t9x) + (0.38268343236508978f*t0y));
            s66 = ((0.92387953251128674f*t0y) - (0.38268343236508978f*t9x));
            s76 = ((0.38268343236508978f*t1y) + (0.92387953251128674f*t2y));
            s86 = ((0.38268343236508978f*t2y) - (0.92387953251128674f*t1y));
            a2i = (a6f + 192);
            a3i = (a6f + 193);
            a4i = (a6f + 1216);
            a5i = (a6f + 1217);
            t3y = (*(a2i) + *(a4i));
            t4y = (*(a3i) + *(a5i));
            t5y = (*(a2i) - *(a4i));
            t6y = (*(a3i) - *(a5i));
            a6i = (a6f + 704);
            a7i = (a6f + 705);
            a8i = (a6f + 1728);
            a9i = (a6f + 1729);
            t7y = (*(a6i) + *(a8i));
            t8y = (*(a7i) + *(a9i));
            t9y = (*(a6i) - *(a8i));
            t0z = (*(a7i) - *(a9i));
            t1z = (t3y + t7y);
            t2z = (t4y + t8y);
            t3z = (t3y - t7y);
            t4z = (t4y - t8y);
            s96 = ((0.38268343236508978f*t3z) + (0.92387953251128674f*t4z));
            s07 = ((0.38268343236508978f*t4z) - (0.92387953251128674f*t3z));
            t5z = (t5y + t0z);
            t6z = (t6y - t9y);
            t7z = (t5y - t0z);
            t8z = (t6y + t9y);
            s17 = ((0.83146961230254524f*t5z) + (0.55557023301960218f*t6z));
            s27 = ((0.83146961230254524f*t6z) - (0.55557023301960218f*t5z));
            s37 = ((0.98078528040323043f*t8z) - (0.19509032201612828f*t7z));
            s47 = ((0.98078528040323043f*t7z) + (0.19509032201612828f*t8z));
            a0j = (a6f + 256);
            a1j = (a6f + 257);
            a2j = (a6f + 1280);
            a3j = (a6f + 1281);
            t9z = (*(a0j) + *(a2j));
            t0A = (*(a1j) + *(a3j));
            t1A = (*(a0j) - *(a2j));
            t2A = (*(a1j) - *(a3j));
            a4j = (a6f + 768);
            a5j = (a6f + 769);
            a6j = (a6f + 1792);
            a7j = (a6f + 1793);
            t3A = (*(a4j) + *(a6j));
            t4A = (*(a5j) + *(a7j));
            t5A = (*(a4j) - *(a6j));
            t6A = (*(a5j) - *(a7j));
            t7A = (t9z + t3A);
            t8A = (t0A + t4A);
            t9A = (t9z - t3A);
            t0B = (t0A - t4A);
            a8j = (0.70710678118654757f*(t1A + t6A));
            a9j = (0.70710678118654757f*(t2A - t5A));
            s57 = (a8j + a9j);
            s67 = (a9j - a8j);
            a0k = (0.70710678118654757f*(t2A + t5A));
            a1k = (0.70710678118654757f*(t1A - t6A));
            s77 = (a0k - a1k);
            s87 = (a1k + a0k);
            a2k = (a6f + 320);
            a3k = (a6f + 321);
            a4k = (a6f + 1344);
            a5k = (a6f + 1345);
            t1B = (*(a2k) + *(a4k));
            t2B = (*(a3k) + *(a5k));
            t3B = (*(a2k) - *(a4k));
            t4B = (*(a3k) - *(a5k));
            a6k = (a6f + 832);
            a7k = (a6f + 833);
            a8k = (a6f + 1856);
            a9k = (a6f + 1857);
            t5B = (*(a6k) + *(a8k));
            t6B = (*(a7k) + *(a9k));
            t7B = (*(a6k) - *(a8k));
            t8B = (*(a7k) - *(a9k));
            t9B = (t1B + t5B);
            t0C = (t2B + t6B);
            t1C = (t1B - t5B);
            t2C = (t2B - t6B);
            s97 = ((0.92387953251128674f*t2C) - (0.38268343236508978f*t1C));
            s08 = ((0.92387953251128674f*t1C) + (0.38268343236508978f*t2C));
            t3C = (t3B + t8B);
            t4C = (t4B - t7B);
            t5C = (t3B - t8B);
            t6C = (t4B + t7B);
            s18 = ((0.55557023301960218f*t3C) + (0.83146961230254524f*t4C));
            s28 = ((0.55557023301960218f*t4C) - (0.83146961230254524f*t3C));
            s38 = ((0.19509032201612828f*t6C) - (0.98078528040323043f*t5C));
            s48 = ((0.19509032201612828f*t5C) + (0.98078528040323043f*t6C));
            a0l = (a6f + 384);
            a1l = (a6f + 385);
            a2l = (a6f + 1408);
            a3l = (a6f + 1409);
            t7C = (*(a0l) + *(a2l));
            t8C = (*(a1l) + *(a3l));
            t9C = (*(a0l) - *(a2l));
            t0D = (*(a1l) - *(a3l));
            a4l = (a6f + 896);
            a5l = (a6f + 897);
            a6l = (a6f + 1920);
            a7l = (a6f + 1921);
            t1D = (*(a4l) + *(a6l));
            t2D = (*(a5l) + *(a7l));
            t3D = (*(a4l) - *(a6l));
            t4D = (*(a5l) - *(a7l));
            t5D = (t7C + t1D);
            t6D = (t8C + t2D);
            a8l = (0.70710678118654757f*(t8C - t2D));
            a9l = (0.70710678118654757f*(t7C - t1D));
            s58 = (a8l - a9l);
            s68 = (a9l + a8l);
            t7D = (t9C + t4D);
            t8D = (t0D - t3D);
            t9D = (t9C - t4D);
            t0E = (t0D + t3D);
            s78 = ((0.38268343236508978f*t7D) + (0.92387953251128674f*t8D));
            s88 = ((0.38268343236508978f*t8D) - (0.92387953251128674f*t7D));
            s98 = ((0.92387953251128674f*t9D) + (0.38268343236508978f*t0E));
            s09 = ((0.38268343236508978f*t9D) - (0.92387953251128674f*t0E));
            a0m = (a6f + 448);
            a1m = (a6f + 449);
            a2m = (a6f + 1472);
            a3m = (a6f + 1473);
            t1E = (*(a0m) + *(a2m));
            t2E = (*(a1m) + *(a3m));
            t3E = (*(a0m) - *(a2m));
            t4E = (*(a1m) - *(a3m));
            a4m = (a6f + 960);
            a5m = (a6f + 961);
            a6m = (a6f + 1984);
            a7m = (a6f + 1985);
            t5E = (*(a4m) + *(a6m));
            t6E = (*(a5m) + *(a7m));
            t7E = (*(a4m) - *(a6m));
            t8E = (*(a5m) - *(a7m));
            t9E = (t1E + t5E);
            t0F = (t2E + t6E);
            t1F = (t1E - t5E);
            t2F = (t2E - t6E);
            s19 = ((0.38268343236508978f*t2F) - (0.92387953251128674f*t1F));
            s29 = ((0.38268343236508978f*t1F) + (0.92387953251128674f*t2F));
            t3F = (t3E + t8E);
            t4F = (t4E - t7E);
            t5F = (t3E - t8E);
            t6F = (t4E + t7E);
            s39 = ((0.19509032201612828f*t3F) + (0.98078528040323043f*t4F));
            s49 = ((0.19509032201612828f*t4F) - (0.98078528040323043f*t3F));
            s59 = ((0.55557023301960218f*t5F) + (0.83146961230254524f*t6F));
            s69 = ((0.83146961230254524f*t5F) - (0.55557023301960218f*t6F));
            t7F = (t5u + t7A);
            t8F = (t6u + t8A);
            t9F = (t5u - t7A);
            t0G = (t6u - t8A);
            t1G = (t1w + t9B);
            t2G = (t2w + t0C);
            a8m = (0.70710678118654757f*(t1w - t9B));
            a9m = (0.70710678118654757f*(t2w - t0C));
            s79 = (a8m + a9m);
            s89 = (a9m - a8m);
            t3G = (t7x + t5D);
            t4G = (t8x + t6D);
            t5G = (t7x - t5D);
            t6G = (t8x - t6D);
            t7G = (t1z + t9E);
            t8G = (t2z + t0F);
            a0n = (0.70710678118654757f*(t2z - t0F));
            a1n = (0.70710678118654757f*(t1z - t9E));
            s99 = (a0n - a1n);
            s0a = (a1n + a0n);
            t9G = (t7F + t3G);
            t0H = (t8F + t4G);
            t1H = (t7F - t3G);
            t2H = (t8F - t4G);
            t3H = (t1G + t7G);
            t4H = (t2G + t8G);
            t5H = (t1G - t7G);
            t6H = (t2G - t8G);
            t7H = (t9G + t3H);
            t8H = (t0H + t4H);
            t9H = (t9G - t3H);
            t0I = (t0H - t4H);
            a2n = (2048*i);
            a3n = (D282 + a2n + (64*i3));
            a4n = (a3n + 1);
            a5n = (a3n + 2);
            a6n = (a3n + 3);
            a7n = (T + a2n + a5f);
            *(a7n) = ((*(a3n)*t7H) - (*(a4n)*t8H));
            *((a7n + 1)) = ((*(a4n)*t7H) + (*(a3n)*t8H));
            *((a7n + 1024)) = ((*(a5n)*t9H) - (*(a6n)*t0I));
            *((a7n + 1025)) = ((*(a6n)*t9H) + (*(a5n)*t0I));
            t1I = (t1H + t6H);
            t2I = (t2H - t5H);
            t3I = (t1H - t6H);
            t4I = (t2H + t5H);
            a8n = (a3n + 4);
            a9n = (a3n + 5);
            a0o = (a3n + 6);
            a1o = (a3n + 7);
            *((a7n + 512)) = ((*(a8n)*t1I) - (*(a9n)*t2I));
            *((a7n + 513)) = ((*(a9n)*t1I) + (*(a8n)*t2I));
            *((a7n + 1536)) = ((*(a0o)*t3I) - (*(a1o)*t4I));
            *((a7n + 1537)) = ((*(a1o)*t3I) + (*(a0o)*t4I));
            t5I = (t9F + t6G);
            t6I = (t0G - t5G);
            t7I = (t9F - t6G);
            t8I = (t0G + t5G);
            t9I = (s79 + s99);
            t0J = (s89 - s0a);
            t1J = (s79 - s99);
            t2J = (s89 + s0a);
            t3J = (t5I + t9I);
            t4J = (t6I + t0J);
            t5J = (t5I - t9I);
            t6J = (t6I - t0J);
            a2o = (a3n + 8);
            a3o = (a3n + 9);
            a4o = (a3n + 10);
            a5o = (a3n + 11);
            *((a7n + 256)) = ((*(a2o)*t3J) - (*(a3o)*t4J));
            *((a7n + 257)) = ((*(a3o)*t3J) + (*(a2o)*t4J));
            *((a7n + 1280)) = ((*(a4o)*t5J) - (*(a5o)*t6J));
            *((a7n + 1281)) = ((*(a5o)*t5J) + (*(a4o)*t6J));
            t7J = (t7I + t2J);
            t8J = (t8I - t1J);
            t9J = (t7I - t2J);
            t0K = (t8I + t1J);
            a6o = (a3n + 12);
            a7o = (a3n + 13);
            a8o = (a3n + 14);
            a9o = (a3n + 15);
            *((a7n + 768)) = ((*(a6o)*t7J) - (*(a7o)*t8J));
            *((a7n + 769)) = ((*(a7o)*t7J) + (*(a6o)*t8J));
            *((a7n + 1792)) = ((*(a8o)*t9J) - (*(a9o)*t0K));
            *((a7n + 1793)) = ((*(a9o)*t9J) + (*(a8o)*t0K));
            t1K = (t9u + s57);
            t2K = (t0v + s67);
            t3K = (t9u - s57);
            t4K = (t0v - s67);
            t5K = (s95 + s18);
            t6K = (s06 + s28);
            a0p = (0.70710678118654757f*(s95 - s18));
            a1p = (0.70710678118654757f*(s06 - s28));
            s1a = (a0p + a1p);
            s2a = (a1p - a0p);
            t7K = (s56 + s78);
            t8K = (s66 + s88);
            t9K = (s56 - s78);
            t0L = (s66 - s88);
            t1L = (s17 + s39);
            t2L = (s27 + s49);
            a2p = (0.70710678118654757f*(s27 - s49));
            a3p = (0.70710678118654757f*(s17 - s39));
            s3a = (a2p - a3p);
            s4a = (a3p + a2p);
            t3L = (t1K + t7K);
            t4L = (t2K + t8K);
            t5L = (t1K - t7K);
            t6L = (t2K - t8K);
            t7L = (t5K + t1L);
            t8L = (t6K + t2L);
            t9L = (t5K - t1L);
            t0M = (t6K - t2L);
            t1M = (t3L + t7L);
            t2M = (t4L + t8L);
            t3M = (t3L - t7L);
            t4M = (t4L - t8L);
            a4p = (a3n + 16);
            a5p = (a3n + 17);
            a6p = (a3n + 18);
            a7p = (a3n + 19);
            *((a7n + 64)) = ((*(a4p)*t1M) - (*(a5p)*t2M));
            *((a7n + 65)) = ((*(a5p)*t1M) + (*(a4p)*t2M));
            *((a7n + 1088)) = ((*(a6p)*t3M) - (*(a7p)*t4M));
            *((a7n + 1089)) = ((*(a7p)*t3M) + (*(a6p)*t4M));
            t5M = (t5L + t0M);
            t6M = (t6L - t9L);
            t7M = (t5L - t0M);
            t8M = (t6L + t9L);
            a8p = (a3n + 20);
            a9p = (a3n + 21);
            a0q = (a3n + 22);
            a1q = (a3n + 23);
            *((a7n + 576)) = ((*(a8p)*t5M) - (*(a9p)*t6M));
            *((a7n + 577)) = ((*(a9p)*t5M) + (*(a8p)*t6M));
            *((a7n + 1600)) = ((*(a0q)*t7M) - (*(a1q)*t8M));
            *((a7n + 1601)) = ((*(a1q)*t7M) + (*(a0q)*t8M));
            t9M = (t3K + t0L);
            t0N = (t4K - t9K);
            t1N = (t3K - t0L);
            t2N = (t4K + t9K);
            t3N = (s1a + s3a);
            t4N = (s2a - s4a);
            t5N = (s1a - s3a);
            t6N = (s2a + s4a);
            t7N = (t9M + t3N);
            t8N = (t0N + t4N);
            t9N = (t9M - t3N);
            t0O = (t0N - t4N);
            a2q = (a3n + 24);
            a3q = (a3n + 25);
            a4q = (a3n + 26);
            a5q = (a3n + 27);
            *((a7n + 320)) = ((*(a2q)*t7N) - (*(a3q)*t8N));
            *((a7n + 321)) = ((*(a3q)*t7N) + (*(a2q)*t8N));
            *((a7n + 1344)) = ((*(a4q)*t9N) - (*(a5q)*t0O));
            *((a7n + 1345)) = ((*(a5q)*t9N) + (*(a4q)*t0O));
            t1O = (t1N + t6N);
            t2O = (t2N - t5N);
            t3O = (t1N - t6N);
            t4O = (t2N + t5N);
            a6q = (a3n + 28);
            a7q = (a3n + 29);
            a8q = (a3n + 30);
            a9q = (a3n + 31);
            *((a7n + 832)) = ((*(a6q)*t1O) - (*(a7q)*t2O));
            *((a7n + 833)) = ((*(a7q)*t1O) + (*(a6q)*t2O));
            *((a7n + 1856)) = ((*(a8q)*t3O) - (*(a9q)*t4O));
            *((a7n + 1857)) = ((*(a9q)*t3O) + (*(a8q)*t4O));
            t5O = (t7u + t0B);
            t6O = (t8u - t9A);
            t7O = (t7u - t0B);
            t8O = (t8u + t9A);
            t9O = (s75 + s97);
            t0P = (s85 - s08);
            a0r = (0.70710678118654757f*(s75 - s97));
            a1r = (0.70710678118654757f*(s85 + s08));
            s5a = (a0r + a1r);
            s6a = (a1r - a0r);
            t1P = (s36 + s58);
            t2P = (s46 - s68);
            t3P = (s36 - s58);
            t4P = (s46 + s68);
            t5P = (s96 + s19);
            t6P = (s07 - s29);
            a2r = (0.70710678118654757f*(s07 + s29));
            a3r = (0.70710678118654757f*(s96 - s19));
            s7a = (a2r - a3r);
            s8a = (a3r + a2r);
            t7P = (t5O + t1P);
            t8P = (t6O + t2P);
            t9P = (t5O - t1P);
            t0Q = (t6O - t2P);
            t1Q = (t9O + t5P);
            t2Q = (t0P + t6P);
            t3Q = (t9O - t5P);
            t4Q = (t0P - t6P);
            t5Q = (t7P + t1Q);
            t6Q = (t8P + t2Q);
            t7Q = (t7P - t1Q);
            t8Q = (t8P - t2Q);
            a4r = (a3n + 32);
            a5r = (a3n + 33);
            a6r = (a3n + 34);
            a7r = (a3n + 35);
            *((a7n + 128)) = ((*(a4r)*t5Q) - (*(a5r)*t6Q));
            *((a7n + 129)) = ((*(a5r)*t5Q) + (*(a4r)*t6Q));
            *((a7n + 1152)) = ((*(a6r)*t7Q) - (*(a7r)*t8Q));
            *((a7n + 1153)) = ((*(a7r)*t7Q) + (*(a6r)*t8Q));
            t9Q = (t9P + t4Q);
            t0R = (t0Q - t3Q);
            t1R = (t9P - t4Q);
            t2R = (t0Q + t3Q);
            a8r = (a3n + 36);
            a9r = (a3n + 37);
            a0s = (a3n + 38);
            a1s = (a3n + 39);
            *((a7n + 640)) = ((*(a8r)*t9Q) - (*(a9r)*t0R));
            *((a7n + 641)) = ((*(a9r)*t9Q) + (*(a8r)*t0R));
            *((a7n + 1664)) = ((*(a0s)*t1R) - (*(a1s)*t2R));
            *((a7n + 1665)) = ((*(a1s)*t1R) + (*(a0s)*t2R));
            t3R = (t7O + t4P);
            t4R = (t8O - t3P);
            t5R = (t7O - t4P);
            t6R = (t8O + t3P);
            t7R = (s5a + s7a);
            t8R = (s6a - s8a);
            t9R = (s5a - s7a);
            t0S = (s6a + s8a);
            t1S = (t3R + t7R);
            t2S = (t4R + t8R);
            t3S = (t3R - t7R);
            t4S = (t4R - t8R);
            a2s = (a3n + 40);
            a3s = (a3n + 41);
            a4s = (a3n + 42);
            a5s = (a3n + 43);
            *((a7n + 384)) = ((*(a2s)*t1S) - (*(a3s)*t2S));
            *((a7n + 385)) = ((*(a3s)*t1S) + (*(a2s)*t2S));
            *((a7n + 1408)) = ((*(a4s)*t3S) - (*(a5s)*t4S));
            *((a7n + 1409)) = ((*(a5s)*t3S) + (*(a4s)*t4S));
            t5S = (t5R + t0S);
            t6S = (t6R - t9R);
            t7S = (t5R - t0S);
            t8S = (t6R + t9R);
            a6s = (a3n + 44);
            a7s = (a3n + 45);
            a8s = (a3n + 46);
            a9s = (a3n + 47);
            *((a7n + 896)) = ((*(a6s)*t5S) - (*(a7s)*t6S));
            *((a7n + 897)) = ((*(a7s)*t5S) + (*(a6s)*t6S));
            *((a7n + 1920)) = ((*(a8s)*t7S) - (*(a9s)*t8S));
            *((a7n + 1921)) = ((*(a9s)*t7S) + (*(a8s)*t8S));
            t9S = (t1v + s77);
            t0T = (t2v - s87);
            t1T = (t1v - s77);
            t2T = (t2v + s87);
            t3T = (s16 + s38);
            t4T = (s26 - s48);
            a0t = (0.70710678118654757f*(s16 - s38));
            a1t = (0.70710678118654757f*(s26 + s48));
            s9a = (a0t + a1t);
            s0b = (a1t - a0t);
            t5T = (s76 - s98);
            t6T = (s86 + s09);
            t7T = (s76 + s98);
            t8T = (s86 - s09);
            t9T = (s37 - s59);
            t0U = (s69 - s47);
            a2t = (0.70710678118654757f*(s37 + s59));
            a3t = (0.70710678118654757f*(s47 + s69));
            s1b = (a2t + a3t);
            s2b = (a3t - a2t);
            t1U = (t9S + t5T);
            t2U = (t0T + t6T);
            t3U = (t9S - t5T);
            t4U = (t0T - t6T);
            t5U = (t3T + t9T);
            t6U = (t4T + t0U);
            t7U = (t3T - t9T);
            t8U = (t4T - t0U);
            t9U = (t1U + t5U);
            t0V = (t2U + t6U);
            t1V = (t1U - t5U);
            t2V = (t2U - t6U);
            a4t = (a3n + 48);
            a5t = (a3n + 49);
            a6t = (a3n + 50);
            a7t = (a3n + 51);
            *((a7n + 192)) = ((*(a4t)*t9U) - (*(a5t)*t0V));
            *((a7n + 193)) = ((*(a5t)*t9U) + (*(a4t)*t0V));
            *((a7n + 1216)) = ((*(a6t)*t1V) - (*(a7t)*t2V));
            *((a7n + 1217)) = ((*(a7t)*t1V) + (*(a6t)*t2V));
            t3V = (t3U + t8U);
            t4V = (t4U - t7U);
            t5V = (t3U - t8U);
            t6V = (t4U + t7U);
            a8t = (a3n + 52);
            a9t = (a3n + 53);
            a0u = (a3n + 54);
            a1u = (a3n + 55);
            *((a7n + 704)) = ((*(a8t)*t3V) - (*(a9t)*t4V));
            *((a7n + 705)) = ((*(a9t)*t3V) + (*(a8t)*t4V));
            *((a7n + 1728)) = ((*(a0u)*t5V) - (*(a1u)*t6V));
            *((a7n + 1729)) = ((*(a1u)*t5V) + (*(a0u)*t6V));
            t7V = (t1T + t8T);
            t8V = (t2T - t7T);
            t9V = (t1T - t8T);
            t0W = (t2T + t7T);
            t1W = (s9a - s1b);
            t2W = (s0b + s2b);
            t3W = (s9a + s1b);
            t4W = (s0b - s2b);
            t5W = (t7V + t1W);
            t6W = (t8V + t2W);
            t7W = (t7V - t1W);
            t8W = (t8V - t2W);
            a2u = (a3n + 56);
            a3u = (a3n + 57);
            a4u = (a3n + 58);
            a5u = (a3n + 59);
            *((a7n + 448)) = ((*(a2u)*t5W) - (*(a3u)*t6W));
            *((a7n + 449)) = ((*(a3u)*t5W) + (*(a2u)*t6W));
            *((a7n + 1472)) = ((*(a4u)*t7W) - (*(a5u)*t8W));
            *((a7n + 1473)) = ((*(a5u)*t7W) + (*(a4u)*t8W));
            t9W = (t9V + t4W);
            t0X = (t0W - t3W);
            t1X = (t9V - t4W);
            t2X = (t0W + t3W);
            a6u = (a3n + 60);
            a7u = (a3n + 61);
            a8u = (a3n + 62);
            a9u = (a3n + 63);
            *((a7n + 960)) = ((*(a6u)*t9W) - (*(a7u)*t0X));
            *((a7n + 961)) = ((*(a7u)*t9W) + (*(a6u)*t0X));
            *((a7n + 1984)) = ((*(a8u)*t1X) - (*(a9u)*t2X));
            *((a7n + 1985)) = ((*(a9u)*t1X) + (*(a8u)*t2X));
        }}
    }}
    {long i4; for(i4 = 0; i4 <= 1023; i4++) {
        a0v = (2*i4);
        a1v = (T + a0v);
        a2v = (a1v + 1);
        a3v = (a1v + 8192);
        a4v = (a1v + 8193);
        t3X = (*(a1v) + *(a3v));
        t4X = (*(a2v) + *(a4v));
        t5X = (*(a1v) - *(a3v));
        t6X = (*(a2v) - *(a4v));
        a5v = (a1v + 2048);
        a6v = (a1v + 2049);
        a7v = (a1v + 10240);
        a8v = (a1v + 10241);
        t7X = (*(a5v) + *(a7v));
        t8X = (*(a6v) + *(a8v));
        a9v = (0.70710678118654757f*(*(a5v) - *(a7v)));
        a0w = (0.70710678118654757f*(*(a6v) - *(a8v)));
        s3b = (a9v + a0w);
        s4b = (a0w - a9v);
        a1w = (a1v + 4096);
        a2w = (a1v + 4097);
        a3w = (a1v + 12288);
        a4w = (a1v + 12289);
        t9X = (*(a1w) + *(a3w));
        t0Y = (*(a2w) + *(a4w));
        t1Y = (*(a1w) - *(a3w));
        t2Y = (*(a2w) - *(a4w));
        a5w = (a1v + 6144);
        a6w = (a1v + 6145);
        a7w = (a1v + 14336);
        a8w = (a1v + 14337);
        t3Y = (*(a5w) + *(a7w));
        t4Y = (*(a6w) + *(a8w));
        a9w = (0.70710678118654757f*(*(a6w) - *(a8w)));
        a0x = (0.70710678118654757f*(*(a5w) - *(a7w)));
        s5b = (a9w - a0x);
        s6b = (a0x + a9w);
        t5Y = (t3X + t9X);
        t6Y = (t4X + t0Y);
        t7Y = (t3X - t9X);
        t8Y = (t4X - t0Y);
        t9Y = (t7X + t3Y);
        t0Z = (t8X + t4Y);
        t1Z = (t7X - t3Y);
        t2Z = (t8X - t4Y);
        a1x = (dst + a0v);
        *(a1x) = (t5Y + t9Y);
        *((a1x + 1)) = (t6Y + t0Z);
        *((a1x + 8192)) = (t5Y - t9Y);
        *((a1x + 8193)) = (t6Y - t0Z);
        *((a1x + 4096)) = (t7Y + t2Z);
        *((a1x + 4097)) = (t8Y - t1Z);
        *((a1x + 12288)) = (t7Y - t2Z);
        *((a1x + 12289)) = (t8Y + t1Z);
        t3Z = (t5X + t2Y);
        t4Z = (t6X - t1Y);
        t5Z = (t5X - t2Y);
        t6Z = (t6X + t1Y);
        t7Z = (s3b + s5b);
        t8Z = (s4b - s6b);
        t9Z = (s3b - s5b);
        t010 = (s4b + s6b);
        *((a1x + 2048)) = (t3Z + t7Z);
        *((a1x + 2049)) = (t4Z + t8Z);
        *((a1x + 10240)) = (t3Z - t7Z);
        *((a1x + 10241)) = (t4Z - t8Z);
        *((a1x + 6144)) = (t5Z + t010);
        *((a1x + 6145)) = (t6Z - t9Z);
        *((a1x + 14336)) = (t5Z - t010);
        *((a1x + 14337)) = (t6Z + t9Z);
    }}
    }
    
    return SPIRAL_OK;
}

